#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4672
#define LARGE_STATE_COUNT 1300
#define SYMBOL_COUNT 403
#define ALIAS_COUNT 6
#define TOKEN_COUNT 170
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 47
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 292

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_as = 5,
  anon_sym_LBRACE = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_type = 9,
  anon_sym_typeof = 10,
  anon_sym_import = 11,
  anon_sym_from = 12,
  anon_sym_var = 13,
  anon_sym_let = 14,
  anon_sym_const = 15,
  anon_sym_BANG = 16,
  anon_sym_else = 17,
  anon_sym_if = 18,
  anon_sym_switch = 19,
  anon_sym_for = 20,
  anon_sym_LPAREN = 21,
  anon_sym_RPAREN = 22,
  anon_sym_await = 23,
  anon_sym_in = 24,
  anon_sym_of = 25,
  anon_sym_while = 26,
  anon_sym_do = 27,
  anon_sym_try = 28,
  anon_sym_with = 29,
  anon_sym_break = 30,
  anon_sym_continue = 31,
  anon_sym_debugger = 32,
  anon_sym_return = 33,
  anon_sym_throw = 34,
  anon_sym_SEMI = 35,
  anon_sym_COLON = 36,
  anon_sym_case = 37,
  anon_sym_default = 38,
  anon_sym_catch = 39,
  anon_sym_finally = 40,
  anon_sym_yield = 41,
  anon_sym_EQ = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  sym__glimmer_template_content = 45,
  anon_sym_LTtemplate_GT = 46,
  anon_sym_LT_SLASHtemplate_GT = 47,
  anon_sym_LT = 48,
  anon_sym_GT = 49,
  anon_sym_SLASH = 50,
  anon_sym_DOT = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_QMARK_DOT = 56,
  anon_sym_new = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_GT_GT_GT_EQ = 67,
  anon_sym_LT_LT_EQ = 68,
  anon_sym_STAR_STAR_EQ = 69,
  anon_sym_AMP_AMP_EQ = 70,
  anon_sym_PIPE_PIPE_EQ = 71,
  anon_sym_QMARK_QMARK_EQ = 72,
  anon_sym_DOT_DOT_DOT = 73,
  anon_sym_AMP_AMP = 74,
  anon_sym_PIPE_PIPE = 75,
  anon_sym_GT_GT = 76,
  anon_sym_GT_GT_GT = 77,
  anon_sym_LT_LT = 78,
  anon_sym_AMP = 79,
  anon_sym_CARET = 80,
  anon_sym_PIPE = 81,
  anon_sym_PLUS = 82,
  anon_sym_DASH = 83,
  anon_sym_PERCENT = 84,
  anon_sym_STAR_STAR = 85,
  anon_sym_LT_EQ = 86,
  anon_sym_EQ_EQ = 87,
  anon_sym_EQ_EQ_EQ = 88,
  anon_sym_BANG_EQ = 89,
  anon_sym_BANG_EQ_EQ = 90,
  anon_sym_GT_EQ = 91,
  anon_sym_QMARK_QMARK = 92,
  anon_sym_instanceof = 93,
  anon_sym_TILDE = 94,
  anon_sym_void = 95,
  anon_sym_delete = 96,
  anon_sym_PLUS_PLUS = 97,
  anon_sym_DASH_DASH = 98,
  anon_sym_DQUOTE = 99,
  anon_sym_SQUOTE = 100,
  sym_unescaped_double_string_fragment = 101,
  sym_unescaped_single_string_fragment = 102,
  sym_escape_sequence = 103,
  sym_comment = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_DOLLAR_LBRACE = 106,
  anon_sym_SLASH2 = 107,
  sym_regex_pattern = 108,
  sym_regex_flags = 109,
  sym_number = 110,
  sym_private_property_identifier = 111,
  anon_sym_target = 112,
  sym_this = 113,
  sym_super = 114,
  sym_true = 115,
  sym_false = 116,
  sym_null = 117,
  sym_undefined = 118,
  anon_sym_AT = 119,
  anon_sym_static = 120,
  anon_sym_readonly = 121,
  anon_sym_get = 122,
  anon_sym_set = 123,
  anon_sym_QMARK = 124,
  anon_sym_declare = 125,
  anon_sym_namespace = 126,
  anon_sym_public = 127,
  anon_sym_private = 128,
  anon_sym_protected = 129,
  anon_sym_override = 130,
  anon_sym_module = 131,
  anon_sym_any = 132,
  anon_sym_number = 133,
  anon_sym_boolean = 134,
  anon_sym_string = 135,
  anon_sym_symbol = 136,
  anon_sym_abstract = 137,
  anon_sym_satisfies = 138,
  anon_sym_require = 139,
  anon_sym_extends = 140,
  anon_sym_implements = 141,
  anon_sym_global = 142,
  anon_sym_interface = 143,
  anon_sym_enum = 144,
  anon_sym_DASH_QMARK_COLON = 145,
  anon_sym_QMARK_COLON = 146,
  anon_sym_asserts = 147,
  anon_sym_infer = 148,
  anon_sym_is = 149,
  anon_sym_keyof = 150,
  anon_sym_unknown = 151,
  anon_sym_never = 152,
  anon_sym_object = 153,
  anon_sym_LBRACE_PIPE = 154,
  anon_sym_PIPE_RBRACE = 155,
  anon_sym_component = 156,
  anon_sym_POUND = 157,
  anon_sym_instance = 158,
  anon_sym_constructor = 159,
  anon_sym_BQUOTE_BQUOTE_BQUOTE = 160,
  anon_sym_prop = 161,
  anon_sym_id = 162,
  anon_sym_event = 163,
  anon_sym_fn = 164,
  anon_sym_on = 165,
  sym__automatic_semicolon = 166,
  sym__template_chars = 167,
  sym__ternary_qmark = 168,
  sym__function_signature_automatic_semicolon = 169,
  sym_program = 170,
  sym_export_statement = 171,
  sym_declaration = 172,
  sym_import = 173,
  sym_import_statement = 174,
  sym_expression_statement = 175,
  sym_variable_declaration = 176,
  sym_lexical_declaration = 177,
  sym_variable_declarator = 178,
  sym_statement_block = 179,
  sym_else_clause = 180,
  sym_if_statement = 181,
  sym_switch_statement = 182,
  sym_for_statement = 183,
  sym_for_in_statement = 184,
  sym__for_header = 185,
  sym_while_statement = 186,
  sym_do_statement = 187,
  sym_try_statement = 188,
  sym_with_statement = 189,
  sym_break_statement = 190,
  sym_continue_statement = 191,
  sym_debugger_statement = 192,
  sym_return_statement = 193,
  sym_throw_statement = 194,
  sym_empty_statement = 195,
  sym_labeled_statement = 196,
  sym_switch_body = 197,
  sym_switch_case = 198,
  sym_switch_default = 199,
  sym_catch_clause = 200,
  sym_finally_clause = 201,
  sym_parenthesized_expression = 202,
  sym_expression = 203,
  sym_primary_expression = 204,
  sym_yield_expression = 205,
  sym_object = 206,
  sym_object_pattern = 207,
  sym_assignment_pattern = 208,
  sym_object_assignment_pattern = 209,
  sym_array = 210,
  sym_array_pattern = 211,
  sym_glimmer_template = 212,
  sym_glimmer_opening_tag = 213,
  sym_glimmer_closing_tag = 214,
  sym_nested_identifier = 215,
  sym_class = 216,
  sym_class_declaration = 217,
  sym_class_heritage = 218,
  sym_function = 219,
  sym_function_declaration = 220,
  sym_generator_function = 221,
  sym_generator_function_declaration = 222,
  sym_arrow_function = 223,
  sym__call_signature = 224,
  sym__formal_parameter = 225,
  sym_optional_chain = 226,
  sym_call_expression = 227,
  sym_new_expression = 228,
  sym_await_expression = 229,
  sym_member_expression = 230,
  sym_subscript_expression = 231,
  sym_assignment_expression = 232,
  sym__augmented_assignment_lhs = 233,
  sym_augmented_assignment_expression = 234,
  sym__initializer = 235,
  sym__destructuring_pattern = 236,
  sym_spread_element = 237,
  sym_ternary_expression = 238,
  sym_binary_expression = 239,
  sym_unary_expression = 240,
  sym_update_expression = 241,
  sym_sequence_expression = 242,
  sym_string = 243,
  sym_template_string = 244,
  sym_template_substitution = 245,
  sym_regex = 246,
  sym_meta_property = 247,
  sym_arguments = 248,
  sym_decorator = 249,
  sym_decorator_member_expression = 250,
  sym_decorator_call_expression = 251,
  sym_class_body = 252,
  sym_formal_parameters = 253,
  sym_class_static_block = 254,
  sym_pattern = 255,
  sym_rest_pattern = 256,
  sym_method_definition = 257,
  sym_pair = 258,
  sym_pair_pattern = 259,
  sym__property_name = 260,
  sym_computed_property_name = 261,
  sym_public_field_definition = 262,
  sym_non_null_expression = 263,
  sym_method_signature = 264,
  sym_abstract_method_signature = 265,
  sym_function_signature = 266,
  sym_type_assertion = 267,
  sym_as_expression = 268,
  sym_satisfies_expression = 269,
  sym_extends_clause = 270,
  sym_implements_clause = 271,
  sym_ambient_declaration = 272,
  sym_abstract_class_declaration = 273,
  sym_module = 274,
  sym_internal_module = 275,
  sym__module = 276,
  sym_import_alias = 277,
  sym_nested_type_identifier = 278,
  sym_interface_declaration = 279,
  sym_extends_type_clause = 280,
  sym_enum_declaration = 281,
  sym_enum_body = 282,
  sym_enum_assignment = 283,
  sym_type_alias_declaration = 284,
  sym_accessibility_modifier = 285,
  sym_override_modifier = 286,
  sym_required_parameter = 287,
  sym_optional_parameter = 288,
  sym__parameter_name = 289,
  sym_omitting_type_annotation = 290,
  sym_opting_type_annotation = 291,
  sym_type_annotation = 292,
  sym_asserts = 293,
  sym__type = 294,
  sym_tuple_parameter = 295,
  sym_optional_tuple_parameter = 296,
  sym_optional_type = 297,
  sym_rest_type = 298,
  sym__tuple_type_member = 299,
  sym_constructor_type = 300,
  sym__primary_type = 301,
  sym_template_type = 302,
  sym_template_literal_type = 303,
  sym_infer_type = 304,
  sym_conditional_type = 305,
  sym_generic_type = 306,
  sym_type_predicate = 307,
  sym_type_predicate_annotation = 308,
  sym__type_query_member_expression = 309,
  sym__type_query_subscript_expression = 310,
  sym__type_query_call_expression = 311,
  sym_type_query = 312,
  sym_index_type_query = 313,
  sym_lookup_type = 314,
  sym_mapped_type_clause = 315,
  sym_literal_type = 316,
  sym__number = 317,
  sym_existential_type = 318,
  sym_flow_maybe_type = 319,
  sym_parenthesized_type = 320,
  sym_predefined_type = 321,
  sym_type_arguments = 322,
  sym_object_type = 323,
  sym_call_signature = 324,
  sym_property_signature = 325,
  sym_type_parameters = 326,
  sym_type_parameter = 327,
  sym_default_type = 328,
  sym_constraint = 329,
  sym_construct_signature = 330,
  sym_index_signature = 331,
  sym_array_type = 332,
  sym_tuple_type = 333,
  sym_readonly_type = 334,
  sym_union_type = 335,
  sym_intersection_type = 336,
  sym_function_type = 337,
  sym_property_assignment_expression = 338,
  sym_import_path = 339,
  sym_import_path_segment = 340,
  sym_import_as = 341,
  sym_js_import_statement = 342,
  sym_component = 343,
  sym_component_declaration = 344,
  sym_component_heritage = 345,
  sym_component_identifier = 346,
  sym_component_instance = 347,
  sym_component_instance_statement = 348,
  sym_new_component_expression = 349,
  sym_new_tagged_component_expression = 350,
  sym_new_tripple_tagged_component_expression = 351,
  sym_component_body = 352,
  sym_new_component_body = 353,
  sym_constructor_definition = 354,
  sym_tagged_type_string = 355,
  sym_tripple_tagged_type_string = 356,
  sym_formal_type_parameters = 357,
  sym_required_type_parameter = 358,
  sym_optional_type_parameter = 359,
  sym_formal_type_parameter = 360,
  sym_property_declaration_name = 361,
  sym_type_narrow = 362,
  sym_property_declaration = 363,
  sym_property_expression_initializer = 364,
  sym_static_property_declaration = 365,
  sym_identifier_property_assignment = 366,
  sym_property_assignment = 367,
  sym_event_declaration = 368,
  sym_typed_function_return_type = 369,
  sym_property_accessor_declaration = 370,
  sym_typed_method_declaration = 371,
  sym_listener_declaration = 372,
  aux_sym_program_repeat1 = 373,
  aux_sym_variable_declaration_repeat1 = 374,
  aux_sym_statement_block_repeat1 = 375,
  aux_sym_switch_body_repeat1 = 376,
  aux_sym_object_repeat1 = 377,
  aux_sym_object_pattern_repeat1 = 378,
  aux_sym_array_repeat1 = 379,
  aux_sym_array_pattern_repeat1 = 380,
  aux_sym_glimmer_template_repeat1 = 381,
  aux_sym_class_repeat1 = 382,
  aux_sym_string_repeat1 = 383,
  aux_sym_string_repeat2 = 384,
  aux_sym_template_string_repeat1 = 385,
  aux_sym_class_body_repeat1 = 386,
  aux_sym_formal_parameters_repeat1 = 387,
  aux_sym_extends_clause_repeat1 = 388,
  aux_sym_implements_clause_repeat1 = 389,
  aux_sym_extends_type_clause_repeat1 = 390,
  aux_sym_enum_body_repeat1 = 391,
  aux_sym_template_literal_type_repeat1 = 392,
  aux_sym_object_type_repeat1 = 393,
  aux_sym_type_parameters_repeat1 = 394,
  aux_sym_tuple_type_repeat1 = 395,
  aux_sym_import_path_repeat1 = 396,
  aux_sym_import_path_segment_repeat1 = 397,
  aux_sym_js_import_statement_repeat1 = 398,
  aux_sym_component_heritage_repeat1 = 399,
  aux_sym_component_body_repeat1 = 400,
  aux_sym_new_component_body_repeat1 = 401,
  aux_sym_formal_type_parameters_repeat1 = 402,
  alias_sym_property_identifier = 403,
  alias_sym_shorthand_property_identifier = 404,
  alias_sym_shorthand_property_identifier_pattern = 405,
  alias_sym_statement_identifier = 406,
  alias_sym_this_type = 407,
  alias_sym_type_identifier = 408,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_as] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_namespace] = "namespace",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_component] = "component",
  [anon_sym_POUND] = "#",
  [anon_sym_instance] = "instance",
  [anon_sym_constructor] = "constructor",
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = "```",
  [anon_sym_prop] = "prop",
  [anon_sym_id] = "id",
  [anon_sym_event] = "event",
  [anon_sym_fn] = "fn",
  [anon_sym_on] = "on",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_property_assignment_expression] = "property_assignment_expression",
  [sym_import_path] = "import_path",
  [sym_import_path_segment] = "import_path_segment",
  [sym_import_as] = "import_as",
  [sym_js_import_statement] = "js_import_statement",
  [sym_component] = "component",
  [sym_component_declaration] = "component_declaration",
  [sym_component_heritage] = "component_heritage",
  [sym_component_identifier] = "component_identifier",
  [sym_component_instance] = "component_instance",
  [sym_component_instance_statement] = "component_instance_statement",
  [sym_new_component_expression] = "new_component_expression",
  [sym_new_tagged_component_expression] = "new_tagged_component_expression",
  [sym_new_tripple_tagged_component_expression] = "new_tripple_tagged_component_expression",
  [sym_component_body] = "component_body",
  [sym_new_component_body] = "new_component_body",
  [sym_constructor_definition] = "constructor_definition",
  [sym_tagged_type_string] = "tagged_type_string",
  [sym_tripple_tagged_type_string] = "tripple_tagged_type_string",
  [sym_formal_type_parameters] = "formal_type_parameters",
  [sym_required_type_parameter] = "required_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_formal_type_parameter] = "formal_type_parameter",
  [sym_property_declaration_name] = "property_declaration_name",
  [sym_type_narrow] = "type_narrow",
  [sym_property_declaration] = "property_declaration",
  [sym_property_expression_initializer] = "property_expression_initializer",
  [sym_static_property_declaration] = "static_property_declaration",
  [sym_identifier_property_assignment] = "identifier_property_assignment",
  [sym_property_assignment] = "property_assignment",
  [sym_event_declaration] = "event_declaration",
  [sym_typed_function_return_type] = "typed_function_return_type",
  [sym_property_accessor_declaration] = "property_accessor_declaration",
  [sym_typed_method_declaration] = "typed_method_declaration",
  [sym_listener_declaration] = "listener_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_statement_block_repeat1] = "statement_block_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_class_repeat1] = "class_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_import_path_repeat1] = "import_path_repeat1",
  [aux_sym_import_path_segment_repeat1] = "import_path_segment_repeat1",
  [aux_sym_js_import_statement_repeat1] = "js_import_statement_repeat1",
  [aux_sym_component_heritage_repeat1] = "component_heritage_repeat1",
  [aux_sym_component_body_repeat1] = "component_body_repeat1",
  [aux_sym_new_component_body_repeat1] = "new_component_body_repeat1",
  [aux_sym_formal_type_parameters_repeat1] = "formal_type_parameters_repeat1",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_component] = anon_sym_component,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [anon_sym_prop] = anon_sym_prop,
  [anon_sym_id] = anon_sym_id,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_on] = anon_sym_on,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_property_assignment_expression] = sym_property_assignment_expression,
  [sym_import_path] = sym_import_path,
  [sym_import_path_segment] = sym_import_path_segment,
  [sym_import_as] = sym_import_as,
  [sym_js_import_statement] = sym_js_import_statement,
  [sym_component] = sym_component,
  [sym_component_declaration] = sym_component_declaration,
  [sym_component_heritage] = sym_component_heritage,
  [sym_component_identifier] = sym_component_identifier,
  [sym_component_instance] = sym_component_instance,
  [sym_component_instance_statement] = sym_component_instance_statement,
  [sym_new_component_expression] = sym_new_component_expression,
  [sym_new_tagged_component_expression] = sym_new_tagged_component_expression,
  [sym_new_tripple_tagged_component_expression] = sym_new_tripple_tagged_component_expression,
  [sym_component_body] = sym_component_body,
  [sym_new_component_body] = sym_new_component_body,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_tagged_type_string] = sym_tagged_type_string,
  [sym_tripple_tagged_type_string] = sym_tripple_tagged_type_string,
  [sym_formal_type_parameters] = sym_formal_type_parameters,
  [sym_required_type_parameter] = sym_required_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_formal_type_parameter] = sym_formal_type_parameter,
  [sym_property_declaration_name] = sym_property_declaration_name,
  [sym_type_narrow] = sym_type_narrow,
  [sym_property_declaration] = sym_property_declaration,
  [sym_property_expression_initializer] = sym_property_expression_initializer,
  [sym_static_property_declaration] = sym_static_property_declaration,
  [sym_identifier_property_assignment] = sym_identifier_property_assignment,
  [sym_property_assignment] = sym_property_assignment,
  [sym_event_declaration] = sym_event_declaration,
  [sym_typed_function_return_type] = sym_typed_function_return_type,
  [sym_property_accessor_declaration] = sym_property_accessor_declaration,
  [sym_typed_method_declaration] = sym_typed_method_declaration,
  [sym_listener_declaration] = sym_listener_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_statement_block_repeat1] = aux_sym_statement_block_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_class_repeat1] = aux_sym_class_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_import_path_repeat1] = aux_sym_import_path_repeat1,
  [aux_sym_import_path_segment_repeat1] = aux_sym_import_path_segment_repeat1,
  [aux_sym_js_import_statement_repeat1] = aux_sym_js_import_statement_repeat1,
  [aux_sym_component_heritage_repeat1] = aux_sym_component_heritage_repeat1,
  [aux_sym_component_body_repeat1] = aux_sym_component_body_repeat1,
  [aux_sym_new_component_body_repeat1] = aux_sym_new_component_body_repeat1,
  [aux_sym_formal_type_parameters_repeat1] = aux_sym_formal_type_parameters_repeat1,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_component] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_id] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_import_as] = {
    .visible = true,
    .named = true,
  },
  [sym_js_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_component] = {
    .visible = true,
    .named = true,
  },
  [sym_component_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_component_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_component_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_component_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_component_instance_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_new_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_tagged_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_tripple_tagged_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_component_body] = {
    .visible = true,
    .named = true,
  },
  [sym_new_component_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_tagged_type_string] = {
    .visible = true,
    .named = true,
  },
  [sym_tripple_tagged_type_string] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_required_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_narrow] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_expression_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_static_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_property_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_property_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_function_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_listener_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_segment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_js_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_heritage_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_new_component_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_assignment = 5,
  field_binding_assignemnt = 6,
  field_body = 7,
  field_close_tag = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_constructor = 12,
  field_content = 13,
  field_decorator = 14,
  field_finalizer = 15,
  field_flags = 16,
  field_function = 17,
  field_handler = 18,
  field_increment = 19,
  field_index = 20,
  field_index_type = 21,
  field_initializer = 22,
  field_key = 23,
  field_kind = 24,
  field_label = 25,
  field_left = 26,
  field_member = 27,
  field_module = 28,
  field_name = 29,
  field_object = 30,
  field_open_tag = 31,
  field_operator = 32,
  field_optional_chain = 33,
  field_parameter = 34,
  field_parameters = 35,
  field_pattern = 36,
  field_property = 37,
  field_relative = 38,
  field_return = 39,
  field_return_type = 40,
  field_right = 41,
  field_sign = 42,
  field_source = 43,
  field_type = 44,
  field_type_arguments = 45,
  field_type_parameters = 46,
  field_value = 47,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assignment] = "assignment",
  [field_binding_assignemnt] = "binding_assignemnt",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_relative] = "relative",
  [field_return] = "return",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 1},
  [8] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 2},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 3},
  [19] = {.index = 24, .length = 1},
  [21] = {.index = 25, .length = 2},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 9, .length = 1},
  [25] = {.index = 30, .length = 1},
  [26] = {.index = 31, .length = 1},
  [27] = {.index = 32, .length = 2},
  [28] = {.index = 34, .length = 2},
  [29] = {.index = 36, .length = 2},
  [30] = {.index = 38, .length = 2},
  [31] = {.index = 40, .length = 3},
  [32] = {.index = 43, .length = 2},
  [33] = {.index = 45, .length = 2},
  [34] = {.index = 47, .length = 2},
  [35] = {.index = 49, .length = 2},
  [37] = {.index = 51, .length = 1},
  [38] = {.index = 49, .length = 2},
  [39] = {.index = 52, .length = 2},
  [40] = {.index = 54, .length = 1},
  [41] = {.index = 55, .length = 2},
  [42] = {.index = 57, .length = 2},
  [43] = {.index = 59, .length = 2},
  [44] = {.index = 61, .length = 3},
  [45] = {.index = 64, .length = 1},
  [46] = {.index = 65, .length = 2},
  [47] = {.index = 67, .length = 2},
  [51] = {.index = 69, .length = 1},
  [52] = {.index = 70, .length = 3},
  [53] = {.index = 73, .length = 3},
  [54] = {.index = 76, .length = 2},
  [55] = {.index = 78, .length = 2},
  [56] = {.index = 80, .length = 2},
  [57] = {.index = 7, .length = 2},
  [58] = {.index = 82, .length = 1},
  [59] = {.index = 83, .length = 1},
  [60] = {.index = 84, .length = 2},
  [61] = {.index = 86, .length = 4},
  [62] = {.index = 90, .length = 2},
  [63] = {.index = 92, .length = 2},
  [64] = {.index = 65, .length = 2},
  [65] = {.index = 67, .length = 2},
  [66] = {.index = 94, .length = 3},
  [67] = {.index = 12, .length = 2},
  [68] = {.index = 97, .length = 3},
  [69] = {.index = 97, .length = 3},
  [70] = {.index = 100, .length = 3},
  [71] = {.index = 103, .length = 3},
  [72] = {.index = 106, .length = 4},
  [73] = {.index = 110, .length = 3},
  [74] = {.index = 113, .length = 2},
  [75] = {.index = 115, .length = 1},
  [76] = {.index = 116, .length = 4},
  [77] = {.index = 120, .length = 2},
  [78] = {.index = 122, .length = 4},
  [79] = {.index = 126, .length = 4},
  [80] = {.index = 130, .length = 2},
  [81] = {.index = 132, .length = 2},
  [82] = {.index = 134, .length = 2},
  [83] = {.index = 136, .length = 1},
  [84] = {.index = 137, .length = 2},
  [85] = {.index = 139, .length = 2},
  [86] = {.index = 141, .length = 2},
  [87] = {.index = 143, .length = 2},
  [88] = {.index = 145, .length = 3},
  [89] = {.index = 148, .length = 1},
  [90] = {.index = 65, .length = 2},
  [91] = {.index = 149, .length = 2},
  [92] = {.index = 151, .length = 5},
  [93] = {.index = 156, .length = 1},
  [94] = {.index = 157, .length = 1},
  [95] = {.index = 158, .length = 3},
  [96] = {.index = 161, .length = 3},
  [97] = {.index = 164, .length = 4},
  [98] = {.index = 168, .length = 2},
  [99] = {.index = 170, .length = 3},
  [100] = {.index = 173, .length = 2},
  [101] = {.index = 175, .length = 2},
  [102] = {.index = 17, .length = 2},
  [103] = {.index = 177, .length = 3},
  [104] = {.index = 180, .length = 2},
  [105] = {.index = 182, .length = 3},
  [106] = {.index = 185, .length = 2},
  [107] = {.index = 187, .length = 2},
  [108] = {.index = 189, .length = 4},
  [109] = {.index = 187, .length = 2},
  [110] = {.index = 193, .length = 4},
  [111] = {.index = 197, .length = 5},
  [112] = {.index = 202, .length = 3},
  [113] = {.index = 205, .length = 1},
  [114] = {.index = 206, .length = 2},
  [115] = {.index = 21, .length = 3},
  [116] = {.index = 208, .length = 2},
  [117] = {.index = 210, .length = 3},
  [118] = {.index = 213, .length = 4},
  [119] = {.index = 217, .length = 2},
  [120] = {.index = 219, .length = 2},
  [121] = {.index = 221, .length = 2},
  [122] = {.index = 223, .length = 1},
  [123] = {.index = 224, .length = 4},
  [124] = {.index = 228, .length = 2},
  [125] = {.index = 230, .length = 4},
  [126] = {.index = 230, .length = 4},
  [127] = {.index = 234, .length = 4},
  [128] = {.index = 234, .length = 4},
  [129] = {.index = 238, .length = 4},
  [130] = {.index = 238, .length = 4},
  [131] = {.index = 242, .length = 2},
  [132] = {.index = 244, .length = 3},
  [133] = {.index = 247, .length = 3},
  [134] = {.index = 250, .length = 3},
  [135] = {.index = 253, .length = 3},
  [136] = {.index = 256, .length = 2},
  [137] = {.index = 258, .length = 5},
  [138] = {.index = 263, .length = 1},
  [139] = {.index = 264, .length = 4},
  [140] = {.index = 268, .length = 2},
  [141] = {.index = 270, .length = 2},
  [142] = {.index = 272, .length = 2},
  [143] = {.index = 274, .length = 3},
  [144] = {.index = 277, .length = 3},
  [145] = {.index = 280, .length = 4},
  [146] = {.index = 284, .length = 4},
  [147] = {.index = 288, .length = 4},
  [148] = {.index = 292, .length = 5},
  [149] = {.index = 297, .length = 3},
  [150] = {.index = 300, .length = 3},
  [151] = {.index = 228, .length = 2},
  [152] = {.index = 61, .length = 3},
  [153] = {.index = 303, .length = 4},
  [154] = {.index = 307, .length = 3},
  [155] = {.index = 310, .length = 2},
  [156] = {.index = 312, .length = 4},
  [157] = {.index = 228, .length = 2},
  [158] = {.index = 316, .length = 1},
  [159] = {.index = 317, .length = 4},
  [160] = {.index = 321, .length = 3},
  [161] = {.index = 324, .length = 2},
  [162] = {.index = 326, .length = 2},
  [163] = {.index = 328, .length = 1},
  [164] = {.index = 329, .length = 2},
  [165] = {.index = 331, .length = 2},
  [166] = {.index = 333, .length = 4},
  [167] = {.index = 337, .length = 4},
  [168] = {.index = 341, .length = 4},
  [169] = {.index = 345, .length = 3},
  [170] = {.index = 348, .length = 3},
  [171] = {.index = 351, .length = 2},
  [172] = {.index = 353, .length = 2},
  [173] = {.index = 355, .length = 2},
  [174] = {.index = 357, .length = 4},
  [175] = {.index = 361, .length = 2},
  [176] = {.index = 363, .length = 1},
  [177] = {.index = 364, .length = 2},
  [178] = {.index = 366, .length = 2},
  [179] = {.index = 368, .length = 6},
  [180] = {.index = 374, .length = 2},
  [181] = {.index = 376, .length = 2},
  [182] = {.index = 378, .length = 2},
  [183] = {.index = 380, .length = 2},
  [184] = {.index = 382, .length = 1},
  [185] = {.index = 383, .length = 2},
  [186] = {.index = 385, .length = 5},
  [187] = {.index = 390, .length = 2},
  [188] = {.index = 392, .length = 2},
  [189] = {.index = 394, .length = 2},
  [190] = {.index = 396, .length = 3},
  [191] = {.index = 399, .length = 3},
  [192] = {.index = 402, .length = 5},
  [193] = {.index = 407, .length = 4},
  [194] = {.index = 411, .length = 4},
  [195] = {.index = 415, .length = 4},
  [196] = {.index = 419, .length = 2},
  [197] = {.index = 421, .length = 2},
  [198] = {.index = 423, .length = 1},
  [199] = {.index = 424, .length = 3},
  [200] = {.index = 427, .length = 1},
  [201] = {.index = 428, .length = 2},
  [202] = {.index = 430, .length = 4},
  [203] = {.index = 434, .length = 4},
  [204] = {.index = 438, .length = 4},
  [205] = {.index = 442, .length = 4},
  [206] = {.index = 446, .length = 3},
  [207] = {.index = 449, .length = 3},
  [208] = {.index = 452, .length = 3},
  [209] = {.index = 455, .length = 3},
  [210] = {.index = 458, .length = 3},
  [211] = {.index = 461, .length = 3},
  [212] = {.index = 464, .length = 2},
  [213] = {.index = 466, .length = 3},
  [214] = {.index = 469, .length = 6},
  [215] = {.index = 475, .length = 3},
  [216] = {.index = 464, .length = 2},
  [217] = {.index = 478, .length = 1},
  [218] = {.index = 478, .length = 1},
  [219] = {.index = 479, .length = 5},
  [220] = {.index = 484, .length = 2},
  [221] = {.index = 486, .length = 3},
  [222] = {.index = 489, .length = 3},
  [223] = {.index = 492, .length = 2},
  [224] = {.index = 494, .length = 3},
  [225] = {.index = 497, .length = 3},
  [226] = {.index = 494, .length = 3},
  [227] = {.index = 500, .length = 2},
  [228] = {.index = 502, .length = 4},
  [229] = {.index = 506, .length = 4},
  [230] = {.index = 510, .length = 2},
  [231] = {.index = 512, .length = 2},
  [232] = {.index = 514, .length = 4},
  [233] = {.index = 518, .length = 4},
  [234] = {.index = 522, .length = 2},
  [235] = {.index = 524, .length = 2},
  [236] = {.index = 526, .length = 2},
  [237] = {.index = 528, .length = 3},
  [238] = {.index = 531, .length = 2},
  [239] = {.index = 531, .length = 2},
  [240] = {.index = 533, .length = 3},
  [241] = {.index = 536, .length = 5},
  [242] = {.index = 541, .length = 5},
  [243] = {.index = 546, .length = 3},
  [244] = {.index = 549, .length = 2},
  [245] = {.index = 551, .length = 3},
  [246] = {.index = 554, .length = 2},
  [247] = {.index = 556, .length = 1},
  [248] = {.index = 557, .length = 4},
  [249] = {.index = 561, .length = 4},
  [250] = {.index = 565, .length = 3},
  [251] = {.index = 565, .length = 3},
  [252] = {.index = 568, .length = 2},
  [253] = {.index = 570, .length = 3},
  [254] = {.index = 573, .length = 3},
  [255] = {.index = 573, .length = 3},
  [256] = {.index = 576, .length = 3},
  [257] = {.index = 579, .length = 3},
  [258] = {.index = 582, .length = 2},
  [259] = {.index = 584, .length = 2},
  [260] = {.index = 586, .length = 2},
  [261] = {.index = 588, .length = 1},
  [262] = {.index = 589, .length = 3},
  [263] = {.index = 592, .length = 4},
  [264] = {.index = 596, .length = 5},
  [265] = {.index = 601, .length = 5},
  [266] = {.index = 606, .length = 3},
  [267] = {.index = 609, .length = 2},
  [268] = {.index = 611, .length = 3},
  [269] = {.index = 614, .length = 2},
  [270] = {.index = 616, .length = 2},
  [271] = {.index = 618, .length = 4},
  [272] = {.index = 618, .length = 4},
  [273] = {.index = 622, .length = 4},
  [274] = {.index = 626, .length = 4},
  [275] = {.index = 630, .length = 2},
  [276] = {.index = 632, .length = 4},
  [277] = {.index = 636, .length = 4},
  [278] = {.index = 640, .length = 2},
  [280] = {.index = 642, .length = 4},
  [281] = {.index = 646, .length = 5},
  [282] = {.index = 651, .length = 5},
  [283] = {.index = 656, .length = 3},
  [284] = {.index = 659, .length = 2},
  [285] = {.index = 661, .length = 2},
  [286] = {.index = 663, .length = 3},
  [287] = {.index = 666, .length = 4},
  [288] = {.index = 670, .length = 5},
  [289] = {.index = 675, .length = 3},
  [290] = {.index = 678, .length = 5},
  [291] = {.index = 683, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_relative, 0},
  [2] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [4] =
    {field_source, 2},
  [5] =
    {field_arguments, 1},
    {field_function, 0},
  [7] =
    {field_body, 2},
    {field_name, 1},
  [9] =
    {field_name, 0},
  [10] =
    {field_source, 3},
  [11] =
    {field_parameters, 0},
  [12] =
    {field_object, 0},
    {field_property, 2},
  [14] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [16] =
    {field_member, 0},
  [17] =
    {field_body, 3},
    {field_name, 1},
  [19] =
    {field_arguments, 2},
    {field_name, 0},
  [21] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [24] =
    {field_source, 4},
  [25] =
    {field_argument, 1},
    {field_operator, 0},
  [27] =
    {field_pattern, 0},
  [28] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [30] =
    {field_body, 1},
  [31] =
    {field_constructor, 1},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [36] =
    {field_parameters, 0},
    {field_return_type, 1},
  [38] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [40] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [43] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [45] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [47] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [49] =
    {field_name, 0},
    {field_type_arguments, 1},
  [51] =
    {field_name, 1},
  [52] =
    {field_name, 1},
    {field_type, 0},
  [54] =
    {field_member, 1, .inherited = true},
  [55] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [57] =
    {field_body, 4},
    {field_name, 1},
  [59] =
    {field_arguments, 3},
    {field_name, 0},
  [61] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [64] =
    {field_source, 5},
  [65] =
    {field_left, 0},
    {field_right, 2},
  [67] =
    {field_body, 2},
    {field_parameter, 0},
  [69] =
    {field_pattern, 1},
  [70] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [73] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [76] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [78] =
    {field_name, 0},
    {field_value, 1},
  [80] =
    {field_constraint, 1},
    {field_name, 0},
  [82] =
    {field_value, 1},
  [83] =
    {field_body, 2},
  [84] =
    {field_body, 2},
    {field_type_parameters, 1},
  [86] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [90] =
    {field_arguments, 2},
    {field_constructor, 1},
  [92] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [94] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [97] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [100] =
    {field_arguments, 2},
    {field_function, 0},
    {field_optional_chain, 1},
  [103] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [106] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [110] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [113] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [115] =
    {field_parameters, 1},
  [116] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [120] =
    {field_name, 0},
    {field_type, 1},
  [122] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [126] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [130] =
    {field_binding_assignemnt, 1},
    {field_name, 0},
  [132] =
    {field_assignment, 1},
    {field_name, 0},
  [134] =
    {field_module, 0},
    {field_name, 2},
  [136] =
    {field_name, 2},
  [137] =
    {field_name, 2},
    {field_type, 1},
  [139] =
    {field_body, 2},
    {field_parameters, 1},
  [141] =
    {field_name, 1},
    {field_parameters, 2},
  [143] =
    {field_parameters, 0},
    {field_return_type, 2},
  [145] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [148] =
    {field_source, 6},
  [149] =
    {field_key, 0},
    {field_value, 2},
  [151] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [156] =
    {field_type, 2},
  [157] =
    {field_pattern, 2},
  [158] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [161] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [164] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [168] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [170] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [173] =
    {field_flags, 3},
    {field_pattern, 1},
  [175] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [177] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [180] =
    {field_type_arguments, 2},
    {field_value, 1},
  [182] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [185] =
    {field_body, 3},
    {field_type_parameters, 1},
  [187] =
    {field_body, 3},
    {field_parameter, 1},
  [189] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [193] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [197] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [202] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [205] =
    {field_body, 3},
  [206] =
    {field_index, 2},
    {field_object, 0},
  [208] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [210] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [213] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [217] =
    {field_parameters, 1},
    {field_type, 2},
  [219] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [221] =
    {field_name, 1},
    {field_type, 2},
  [223] =
    {field_parameters, 2},
  [224] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [228] =
    {field_name, 0},
    {field_type, 2},
  [230] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [234] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [238] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [242] =
    {field_parameters, 1},
    {field_type, 3},
  [244] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [247] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [250] =
    {field_binding_assignemnt, 2},
    {field_name, 1},
    {field_type, 0},
  [253] =
    {field_assignment, 2},
    {field_name, 1},
    {field_type, 0},
  [256] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [258] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [263] =
    {field_pattern, 3},
  [264] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [268] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [270] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [272] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [274] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [277] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [280] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [284] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [288] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [292] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [297] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [300] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [303] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [307] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [310] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
  [312] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [316] =
    {field_type, 3},
  [317] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [321] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [324] =
    {field_name, 2},
    {field_type, 3},
  [326] =
    {field_name, 1},
    {field_type, 3},
  [328] =
    {field_name, 3},
  [329] =
    {field_parameters, 2},
    {field_type, 3},
  [331] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [333] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [337] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [341] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [345] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [348] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [351] =
    {field_parameters, 2},
    {field_type, 4},
  [353] =
    {field_binding_assignemnt, 3},
    {field_name, 1},
  [355] =
    {field_assignment, 3},
    {field_name, 1},
  [357] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_return, 3},
  [361] =
    {field_body, 2},
    {field_label, 0},
  [363] =
    {field_kind, 0},
  [364] =
    {field_condition, 1},
    {field_consequence, 2},
  [366] =
    {field_body, 2},
    {field_value, 1},
  [368] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [374] =
    {field_body, 2},
    {field_condition, 1},
  [376] =
    {field_body, 1},
    {field_handler, 2},
  [378] =
    {field_body, 1},
    {field_finalizer, 2},
  [380] =
    {field_body, 2},
    {field_object, 1},
  [382] =
    {field_label, 1},
  [383] =
    {field_body, 1},
    {field_name, 0},
  [385] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [390] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [392] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [394] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [396] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [399] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [402] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [407] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [411] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [415] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [419] =
    {field_name, 2},
    {field_type, 4},
  [421] =
    {field_name, 3},
    {field_type, 4},
  [423] =
    {field_type, 4},
  [424] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [427] =
    {field_name, 4},
  [428] =
    {field_index, 3},
    {field_object, 0},
  [430] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [434] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [438] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [442] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_return, 4},
  [446] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [449] =
    {field_body, 5},
    {field_name, 1},
    {field_return, 4},
  [452] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [455] =
    {field_binding_assignemnt, 4},
    {field_name, 1},
    {field_type, 3},
  [458] =
    {field_assignment, 4},
    {field_name, 1},
    {field_type, 3},
  [461] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
  [464] =
    {field_body, 3},
    {field_name, 2},
  [466] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [469] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [475] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [478] =
    {field_type, 1},
  [479] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [484] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [486] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [489] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [492] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [494] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [497] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [500] =
    {field_sign, 0},
    {field_type, 5},
  [502] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [506] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [510] =
    {field_name, 3},
    {field_type, 5},
  [512] =
    {field_name, 4},
    {field_type, 5},
  [514] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
    {field_return, 5},
  [518] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [522] =
    {field_name, 1},
    {field_value, 3},
  [524] =
    {field_body, 1},
    {field_condition, 3},
  [526] =
    {field_body, 4},
    {field_name, 2},
  [528] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [531] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [533] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [536] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [541] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [546] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [549] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [551] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [554] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [556] =
    {field_name, 5},
  [557] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [561] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [565] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [568] =
    {field_name, 4},
    {field_type, 6},
  [570] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [573] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [576] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [579] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [582] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [584] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [586] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [588] =
    {field_name, 2, .inherited = true},
  [589] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [592] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [596] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [601] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [606] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [609] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [611] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [614] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [616] =
    {field_name, 5},
    {field_type, 6},
  [618] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [622] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [626] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [630] =
    {field_body, 3},
    {field_value, 1},
  [632] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [636] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [640] =
    {field_body, 4},
    {field_parameter, 2},
  [642] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [646] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [651] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [656] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [659] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [661] =
    {field_name, 5},
    {field_type, 7},
  [663] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [666] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [670] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [675] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [678] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [683] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [9] = {
    [0] = sym_identifier,
  },
  [11] = {
    [2] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_this_type,
  },
  [20] = {
    [0] = alias_sym_property_identifier,
  },
  [24] = {
    [0] = alias_sym_type_identifier,
  },
  [35] = {
    [0] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [46] = {
    [0] = sym_identifier,
  },
  [47] = {
    [0] = sym_identifier,
  },
  [48] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [49] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [50] = {
    [1] = sym_identifier,
  },
  [55] = {
    [0] = alias_sym_type_identifier,
  },
  [56] = {
    [0] = alias_sym_type_identifier,
  },
  [57] = {
    [1] = alias_sym_type_identifier,
  },
  [68] = {
    [2] = alias_sym_property_identifier,
  },
  [82] = {
    [2] = alias_sym_type_identifier,
  },
  [90] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [99] = {
    [0] = alias_sym_type_identifier,
  },
  [102] = {
    [1] = alias_sym_type_identifier,
  },
  [103] = {
    [1] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = sym_identifier,
  },
  [115] = {
    [2] = alias_sym_type_identifier,
  },
  [125] = {
    [2] = alias_sym_property_identifier,
  },
  [127] = {
    [2] = alias_sym_property_identifier,
  },
  [129] = {
    [2] = alias_sym_property_identifier,
  },
  [144] = {
    [1] = alias_sym_type_identifier,
  },
  [151] = {
    [0] = sym_identifier,
  },
  [152] = {
    [2] = alias_sym_type_identifier,
  },
  [153] = {
    [2] = alias_sym_type_identifier,
  },
  [157] = {
    [0] = alias_sym_type_identifier,
  },
  [175] = {
    [0] = alias_sym_statement_identifier,
  },
  [184] = {
    [1] = alias_sym_statement_identifier,
  },
  [193] = {
    [2] = alias_sym_type_identifier,
  },
  [216] = {
    [2] = alias_sym_type_identifier,
  },
  [217] = {
    [1] = alias_sym_type_identifier,
  },
  [224] = {
    [1] = sym_identifier,
  },
  [225] = {
    [0] = alias_sym_type_identifier,
  },
  [234] = {
    [1] = alias_sym_type_identifier,
  },
  [236] = {
    [2] = alias_sym_type_identifier,
  },
  [237] = {
    [2] = alias_sym_type_identifier,
  },
  [238] = {
    [1] = alias_sym_type_identifier,
  },
  [240] = {
    [3] = alias_sym_type_identifier,
  },
  [250] = {
    [2] = sym_identifier,
  },
  [253] = {
    [1] = alias_sym_type_identifier,
  },
  [254] = {
    [1] = sym_identifier,
  },
  [257] = {
    [2] = alias_sym_type_identifier,
  },
  [262] = {
    [3] = alias_sym_type_identifier,
  },
  [263] = {
    [3] = alias_sym_type_identifier,
  },
  [271] = {
    [3] = sym_identifier,
  },
  [279] = {
    [3] = alias_sym_property_identifier,
  },
  [280] = {
    [3] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 15,
  [17] = 17,
  [18] = 17,
  [19] = 17,
  [20] = 15,
  [21] = 17,
  [22] = 17,
  [23] = 15,
  [24] = 17,
  [25] = 17,
  [26] = 17,
  [27] = 15,
  [28] = 15,
  [29] = 15,
  [30] = 17,
  [31] = 15,
  [32] = 17,
  [33] = 15,
  [34] = 15,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 39,
  [42] = 42,
  [43] = 40,
  [44] = 38,
  [45] = 37,
  [46] = 35,
  [47] = 36,
  [48] = 42,
  [49] = 49,
  [50] = 50,
  [51] = 50,
  [52] = 52,
  [53] = 52,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 54,
  [62] = 62,
  [63] = 62,
  [64] = 62,
  [65] = 62,
  [66] = 62,
  [67] = 62,
  [68] = 62,
  [69] = 69,
  [70] = 69,
  [71] = 71,
  [72] = 71,
  [73] = 71,
  [74] = 71,
  [75] = 71,
  [76] = 71,
  [77] = 77,
  [78] = 77,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 77,
  [85] = 77,
  [86] = 77,
  [87] = 77,
  [88] = 77,
  [89] = 89,
  [90] = 89,
  [91] = 91,
  [92] = 89,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 95,
  [98] = 95,
  [99] = 94,
  [100] = 100,
  [101] = 93,
  [102] = 94,
  [103] = 93,
  [104] = 96,
  [105] = 96,
  [106] = 100,
  [107] = 107,
  [108] = 107,
  [109] = 109,
  [110] = 110,
  [111] = 110,
  [112] = 107,
  [113] = 107,
  [114] = 107,
  [115] = 107,
  [116] = 107,
  [117] = 117,
  [118] = 107,
  [119] = 119,
  [120] = 120,
  [121] = 119,
  [122] = 122,
  [123] = 122,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 125,
  [128] = 128,
  [129] = 129,
  [130] = 129,
  [131] = 131,
  [132] = 129,
  [133] = 129,
  [134] = 129,
  [135] = 135,
  [136] = 129,
  [137] = 129,
  [138] = 138,
  [139] = 129,
  [140] = 129,
  [141] = 131,
  [142] = 119,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 131,
  [148] = 131,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 168,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 179,
  [184] = 179,
  [185] = 185,
  [186] = 186,
  [187] = 179,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 190,
  [196] = 192,
  [197] = 197,
  [198] = 198,
  [199] = 191,
  [200] = 194,
  [201] = 193,
  [202] = 202,
  [203] = 198,
  [204] = 189,
  [205] = 202,
  [206] = 197,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 207,
  [212] = 208,
  [213] = 207,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 215,
  [219] = 219,
  [220] = 220,
  [221] = 208,
  [222] = 222,
  [223] = 209,
  [224] = 224,
  [225] = 215,
  [226] = 226,
  [227] = 227,
  [228] = 215,
  [229] = 229,
  [230] = 222,
  [231] = 209,
  [232] = 207,
  [233] = 214,
  [234] = 214,
  [235] = 215,
  [236] = 227,
  [237] = 237,
  [238] = 238,
  [239] = 215,
  [240] = 207,
  [241] = 214,
  [242] = 238,
  [243] = 209,
  [244] = 209,
  [245] = 222,
  [246] = 246,
  [247] = 222,
  [248] = 222,
  [249] = 229,
  [250] = 217,
  [251] = 215,
  [252] = 219,
  [253] = 208,
  [254] = 215,
  [255] = 255,
  [256] = 256,
  [257] = 217,
  [258] = 258,
  [259] = 220,
  [260] = 260,
  [261] = 238,
  [262] = 226,
  [263] = 256,
  [264] = 214,
  [265] = 265,
  [266] = 208,
  [267] = 258,
  [268] = 214,
  [269] = 269,
  [270] = 207,
  [271] = 209,
  [272] = 222,
  [273] = 258,
  [274] = 222,
  [275] = 275,
  [276] = 217,
  [277] = 209,
  [278] = 278,
  [279] = 237,
  [280] = 214,
  [281] = 208,
  [282] = 226,
  [283] = 207,
  [284] = 284,
  [285] = 217,
  [286] = 217,
  [287] = 208,
  [288] = 215,
  [289] = 217,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 292,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 306,
  [313] = 307,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 290,
  [319] = 316,
  [320] = 309,
  [321] = 321,
  [322] = 293,
  [323] = 293,
  [324] = 296,
  [325] = 316,
  [326] = 297,
  [327] = 298,
  [328] = 299,
  [329] = 315,
  [330] = 293,
  [331] = 331,
  [332] = 292,
  [333] = 295,
  [334] = 290,
  [335] = 300,
  [336] = 336,
  [337] = 301,
  [338] = 296,
  [339] = 297,
  [340] = 340,
  [341] = 298,
  [342] = 310,
  [343] = 336,
  [344] = 344,
  [345] = 316,
  [346] = 305,
  [347] = 299,
  [348] = 300,
  [349] = 316,
  [350] = 304,
  [351] = 292,
  [352] = 290,
  [353] = 301,
  [354] = 296,
  [355] = 302,
  [356] = 303,
  [357] = 304,
  [358] = 305,
  [359] = 302,
  [360] = 360,
  [361] = 303,
  [362] = 336,
  [363] = 315,
  [364] = 297,
  [365] = 302,
  [366] = 310,
  [367] = 298,
  [368] = 311,
  [369] = 303,
  [370] = 301,
  [371] = 371,
  [372] = 299,
  [373] = 300,
  [374] = 300,
  [375] = 299,
  [376] = 301,
  [377] = 321,
  [378] = 302,
  [379] = 321,
  [380] = 380,
  [381] = 303,
  [382] = 298,
  [383] = 309,
  [384] = 297,
  [385] = 296,
  [386] = 295,
  [387] = 387,
  [388] = 304,
  [389] = 306,
  [390] = 304,
  [391] = 290,
  [392] = 292,
  [393] = 331,
  [394] = 307,
  [395] = 293,
  [396] = 315,
  [397] = 317,
  [398] = 398,
  [399] = 305,
  [400] = 293,
  [401] = 315,
  [402] = 292,
  [403] = 290,
  [404] = 296,
  [405] = 297,
  [406] = 307,
  [407] = 298,
  [408] = 305,
  [409] = 310,
  [410] = 380,
  [411] = 299,
  [412] = 331,
  [413] = 300,
  [414] = 301,
  [415] = 302,
  [416] = 310,
  [417] = 331,
  [418] = 307,
  [419] = 307,
  [420] = 321,
  [421] = 295,
  [422] = 303,
  [423] = 316,
  [424] = 309,
  [425] = 425,
  [426] = 304,
  [427] = 427,
  [428] = 306,
  [429] = 331,
  [430] = 295,
  [431] = 311,
  [432] = 307,
  [433] = 306,
  [434] = 336,
  [435] = 309,
  [436] = 321,
  [437] = 310,
  [438] = 309,
  [439] = 306,
  [440] = 305,
  [441] = 304,
  [442] = 305,
  [443] = 321,
  [444] = 303,
  [445] = 302,
  [446] = 301,
  [447] = 306,
  [448] = 295,
  [449] = 331,
  [450] = 300,
  [451] = 311,
  [452] = 299,
  [453] = 315,
  [454] = 310,
  [455] = 298,
  [456] = 293,
  [457] = 297,
  [458] = 295,
  [459] = 331,
  [460] = 316,
  [461] = 292,
  [462] = 462,
  [463] = 296,
  [464] = 290,
  [465] = 321,
  [466] = 315,
  [467] = 309,
  [468] = 468,
  [469] = 468,
  [470] = 468,
  [471] = 468,
  [472] = 472,
  [473] = 472,
  [474] = 472,
  [475] = 475,
  [476] = 475,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 479,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 477,
  [486] = 486,
  [487] = 477,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 488,
  [493] = 493,
  [494] = 494,
  [495] = 494,
  [496] = 493,
  [497] = 493,
  [498] = 475,
  [499] = 494,
  [500] = 494,
  [501] = 475,
  [502] = 494,
  [503] = 493,
  [504] = 504,
  [505] = 493,
  [506] = 506,
  [507] = 506,
  [508] = 479,
  [509] = 506,
  [510] = 510,
  [511] = 511,
  [512] = 511,
  [513] = 510,
  [514] = 511,
  [515] = 510,
  [516] = 516,
  [517] = 516,
  [518] = 518,
  [519] = 518,
  [520] = 516,
  [521] = 518,
  [522] = 522,
  [523] = 523,
  [524] = 523,
  [525] = 522,
  [526] = 526,
  [527] = 522,
  [528] = 523,
  [529] = 529,
  [530] = 522,
  [531] = 523,
  [532] = 532,
  [533] = 533,
  [534] = 533,
  [535] = 131,
  [536] = 532,
  [537] = 131,
  [538] = 131,
  [539] = 539,
  [540] = 131,
  [541] = 541,
  [542] = 131,
  [543] = 543,
  [544] = 541,
  [545] = 545,
  [546] = 131,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 170,
  [551] = 162,
  [552] = 552,
  [553] = 553,
  [554] = 131,
  [555] = 555,
  [556] = 556,
  [557] = 174,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 154,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 533,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 155,
  [587] = 157,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 174,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 155,
  [628] = 628,
  [629] = 629,
  [630] = 131,
  [631] = 157,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 543,
  [636] = 170,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 135,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 164,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 131,
  [656] = 175,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 135,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 164,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 174,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 170,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 175,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 734,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 813,
  [850] = 850,
  [851] = 746,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 811,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 786,
  [873] = 873,
  [874] = 874,
  [875] = 874,
  [876] = 876,
  [877] = 877,
  [878] = 830,
  [879] = 879,
  [880] = 880,
  [881] = 841,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 164,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 154,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 155,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 157,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 162,
  [966] = 966,
  [967] = 967,
  [968] = 175,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 634,
  [979] = 596,
  [980] = 633,
  [981] = 660,
  [982] = 616,
  [983] = 605,
  [984] = 622,
  [985] = 607,
  [986] = 641,
  [987] = 626,
  [988] = 623,
  [989] = 608,
  [990] = 601,
  [991] = 604,
  [992] = 609,
  [993] = 629,
  [994] = 621,
  [995] = 652,
  [996] = 599,
  [997] = 615,
  [998] = 642,
  [999] = 628,
  [1000] = 603,
  [1001] = 611,
  [1002] = 643,
  [1003] = 602,
  [1004] = 690,
  [1005] = 1005,
  [1006] = 1005,
  [1007] = 1005,
  [1008] = 1005,
  [1009] = 1005,
  [1010] = 1005,
  [1011] = 841,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 486,
  [1015] = 1015,
  [1016] = 1012,
  [1017] = 1017,
  [1018] = 1012,
  [1019] = 1012,
  [1020] = 1020,
  [1021] = 1015,
  [1022] = 478,
  [1023] = 1023,
  [1024] = 1012,
  [1025] = 1015,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1015,
  [1029] = 1029,
  [1030] = 1015,
  [1031] = 1015,
  [1032] = 1012,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1038,
  [1041] = 1038,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1044,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1045,
  [1051] = 1051,
  [1052] = 1048,
  [1053] = 1049,
  [1054] = 1049,
  [1055] = 1048,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1042,
  [1059] = 739,
  [1060] = 1049,
  [1061] = 772,
  [1062] = 1049,
  [1063] = 1056,
  [1064] = 1056,
  [1065] = 873,
  [1066] = 1042,
  [1067] = 1057,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1071,
  [1074] = 1068,
  [1075] = 1069,
  [1076] = 1070,
  [1077] = 1071,
  [1078] = 1071,
  [1079] = 1072,
  [1080] = 1072,
  [1081] = 1070,
  [1082] = 1068,
  [1083] = 1071,
  [1084] = 1069,
  [1085] = 1085,
  [1086] = 1085,
  [1087] = 1068,
  [1088] = 1088,
  [1089] = 1070,
  [1090] = 1070,
  [1091] = 1068,
  [1092] = 1072,
  [1093] = 1072,
  [1094] = 1069,
  [1095] = 1071,
  [1096] = 1045,
  [1097] = 1070,
  [1098] = 1069,
  [1099] = 1069,
  [1100] = 1071,
  [1101] = 1070,
  [1102] = 1068,
  [1103] = 1068,
  [1104] = 1072,
  [1105] = 1069,
  [1106] = 468,
  [1107] = 1070,
  [1108] = 1068,
  [1109] = 1068,
  [1110] = 1070,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1113,
  [1120] = 1120,
  [1121] = 1117,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1114,
  [1131] = 1125,
  [1132] = 1132,
  [1133] = 1112,
  [1134] = 1124,
  [1135] = 1135,
  [1136] = 1117,
  [1137] = 1127,
  [1138] = 1129,
  [1139] = 1139,
  [1140] = 468,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1129,
  [1144] = 1127,
  [1145] = 1125,
  [1146] = 1126,
  [1147] = 1113,
  [1148] = 1128,
  [1149] = 1112,
  [1150] = 1122,
  [1151] = 1142,
  [1152] = 1141,
  [1153] = 1142,
  [1154] = 1115,
  [1155] = 1120,
  [1156] = 1141,
  [1157] = 1125,
  [1158] = 1115,
  [1159] = 1124,
  [1160] = 468,
  [1161] = 1117,
  [1162] = 1124,
  [1163] = 1045,
  [1164] = 1164,
  [1165] = 1127,
  [1166] = 1126,
  [1167] = 1139,
  [1168] = 1114,
  [1169] = 1111,
  [1170] = 1170,
  [1171] = 1126,
  [1172] = 1123,
  [1173] = 1139,
  [1174] = 1132,
  [1175] = 1126,
  [1176] = 1112,
  [1177] = 1126,
  [1178] = 1139,
  [1179] = 1117,
  [1180] = 1132,
  [1181] = 1132,
  [1182] = 1124,
  [1183] = 1115,
  [1184] = 1184,
  [1185] = 1129,
  [1186] = 1139,
  [1187] = 1128,
  [1188] = 1112,
  [1189] = 1142,
  [1190] = 1190,
  [1191] = 1141,
  [1192] = 1129,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1123,
  [1196] = 1114,
  [1197] = 1123,
  [1198] = 1139,
  [1199] = 1139,
  [1200] = 1123,
  [1201] = 1117,
  [1202] = 1120,
  [1203] = 1123,
  [1204] = 1132,
  [1205] = 1124,
  [1206] = 1112,
  [1207] = 1114,
  [1208] = 1126,
  [1209] = 1124,
  [1210] = 1117,
  [1211] = 1139,
  [1212] = 1115,
  [1213] = 1213,
  [1214] = 1184,
  [1215] = 468,
  [1216] = 1123,
  [1217] = 1115,
  [1218] = 1125,
  [1219] = 468,
  [1220] = 1220,
  [1221] = 1127,
  [1222] = 1222,
  [1223] = 1123,
  [1224] = 1129,
  [1225] = 1123,
  [1226] = 1190,
  [1227] = 1115,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1114,
  [1231] = 1184,
  [1232] = 1139,
  [1233] = 1122,
  [1234] = 1113,
  [1235] = 1132,
  [1236] = 1142,
  [1237] = 1112,
  [1238] = 1122,
  [1239] = 1113,
  [1240] = 1113,
  [1241] = 1141,
  [1242] = 1132,
  [1243] = 1124,
  [1244] = 1114,
  [1245] = 1117,
  [1246] = 1184,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1122,
  [1251] = 1132,
  [1252] = 1184,
  [1253] = 1122,
  [1254] = 1141,
  [1255] = 1142,
  [1256] = 1135,
  [1257] = 1112,
  [1258] = 1127,
  [1259] = 1115,
  [1260] = 1260,
  [1261] = 1113,
  [1262] = 1135,
  [1263] = 1125,
  [1264] = 1125,
  [1265] = 1122,
  [1266] = 1184,
  [1267] = 1115,
  [1268] = 1112,
  [1269] = 1213,
  [1270] = 1127,
  [1271] = 1129,
  [1272] = 1141,
  [1273] = 1132,
  [1274] = 1125,
  [1275] = 1117,
  [1276] = 1124,
  [1277] = 1141,
  [1278] = 1142,
  [1279] = 1129,
  [1280] = 1127,
  [1281] = 1127,
  [1282] = 1122,
  [1283] = 1113,
  [1284] = 1125,
  [1285] = 1114,
  [1286] = 1142,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1126,
  [1291] = 1114,
  [1292] = 1292,
  [1293] = 1142,
  [1294] = 1184,
  [1295] = 1141,
  [1296] = 1129,
  [1297] = 1113,
  [1298] = 1122,
  [1299] = 1126,
  [1300] = 1300,
  [1301] = 1051,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1057,
  [1305] = 1305,
  [1306] = 1305,
  [1307] = 1305,
  [1308] = 1305,
  [1309] = 1305,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1305,
  [1313] = 1303,
  [1314] = 1305,
  [1315] = 468,
  [1316] = 1305,
  [1317] = 468,
  [1318] = 1302,
  [1319] = 1319,
  [1320] = 1319,
  [1321] = 468,
  [1322] = 468,
  [1323] = 1260,
  [1324] = 1324,
  [1325] = 1324,
  [1326] = 1319,
  [1327] = 1324,
  [1328] = 484,
  [1329] = 491,
  [1330] = 1330,
  [1331] = 1330,
  [1332] = 1330,
  [1333] = 482,
  [1334] = 489,
  [1335] = 490,
  [1336] = 483,
  [1337] = 480,
  [1338] = 479,
  [1339] = 478,
  [1340] = 486,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1342,
  [1346] = 1344,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1348,
  [1350] = 1341,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 475,
  [1354] = 1352,
  [1355] = 1347,
  [1356] = 1341,
  [1357] = 1357,
  [1358] = 1343,
  [1359] = 486,
  [1360] = 480,
  [1361] = 1361,
  [1362] = 475,
  [1363] = 1363,
  [1364] = 475,
  [1365] = 483,
  [1366] = 484,
  [1367] = 489,
  [1368] = 482,
  [1369] = 475,
  [1370] = 478,
  [1371] = 1341,
  [1372] = 490,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1363,
  [1376] = 479,
  [1377] = 1377,
  [1378] = 475,
  [1379] = 1374,
  [1380] = 491,
  [1381] = 1381,
  [1382] = 1357,
  [1383] = 475,
  [1384] = 1384,
  [1385] = 1351,
  [1386] = 1386,
  [1387] = 479,
  [1388] = 475,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 479,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 174,
  [1395] = 479,
  [1396] = 170,
  [1397] = 1397,
  [1398] = 791,
  [1399] = 839,
  [1400] = 1400,
  [1401] = 1342,
  [1402] = 793,
  [1403] = 977,
  [1404] = 975,
  [1405] = 912,
  [1406] = 155,
  [1407] = 157,
  [1408] = 475,
  [1409] = 1377,
  [1410] = 475,
  [1411] = 1348,
  [1412] = 916,
  [1413] = 1392,
  [1414] = 479,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1418,
  [1421] = 861,
  [1422] = 742,
  [1423] = 1418,
  [1424] = 1424,
  [1425] = 1418,
  [1426] = 1418,
  [1427] = 1418,
  [1428] = 1418,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 896,
  [1433] = 937,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 915,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 839,
  [1443] = 898,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 905,
  [1451] = 1451,
  [1452] = 901,
  [1453] = 791,
  [1454] = 1454,
  [1455] = 903,
  [1456] = 908,
  [1457] = 793,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1416,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1471,
  [1474] = 1472,
  [1475] = 1472,
  [1476] = 1476,
  [1477] = 1471,
  [1478] = 1469,
  [1479] = 1469,
  [1480] = 1471,
  [1481] = 1471,
  [1482] = 1469,
  [1483] = 1469,
  [1484] = 1471,
  [1485] = 1472,
  [1486] = 1469,
  [1487] = 1472,
  [1488] = 1471,
  [1489] = 1472,
  [1490] = 1472,
  [1491] = 1469,
  [1492] = 1492,
  [1493] = 1492,
  [1494] = 1492,
  [1495] = 1492,
  [1496] = 1492,
  [1497] = 581,
  [1498] = 1492,
  [1499] = 575,
  [1500] = 1492,
  [1501] = 1492,
  [1502] = 1419,
  [1503] = 1503,
  [1504] = 135,
  [1505] = 606,
  [1506] = 598,
  [1507] = 1503,
  [1508] = 1503,
  [1509] = 1503,
  [1510] = 597,
  [1511] = 617,
  [1512] = 811,
  [1513] = 1503,
  [1514] = 659,
  [1515] = 661,
  [1516] = 1503,
  [1517] = 594,
  [1518] = 632,
  [1519] = 658,
  [1520] = 734,
  [1521] = 1503,
  [1522] = 657,
  [1523] = 649,
  [1524] = 1524,
  [1525] = 614,
  [1526] = 1526,
  [1527] = 889,
  [1528] = 746,
  [1529] = 762,
  [1530] = 763,
  [1531] = 764,
  [1532] = 861,
  [1533] = 765,
  [1534] = 767,
  [1535] = 758,
  [1536] = 170,
  [1537] = 772,
  [1538] = 793,
  [1539] = 866,
  [1540] = 786,
  [1541] = 800,
  [1542] = 816,
  [1543] = 822,
  [1544] = 831,
  [1545] = 833,
  [1546] = 776,
  [1547] = 835,
  [1548] = 836,
  [1549] = 837,
  [1550] = 663,
  [1551] = 840,
  [1552] = 842,
  [1553] = 843,
  [1554] = 844,
  [1555] = 845,
  [1556] = 847,
  [1557] = 813,
  [1558] = 859,
  [1559] = 860,
  [1560] = 871,
  [1561] = 873,
  [1562] = 754,
  [1563] = 841,
  [1564] = 749,
  [1565] = 856,
  [1566] = 718,
  [1567] = 677,
  [1568] = 874,
  [1569] = 685,
  [1570] = 880,
  [1571] = 748,
  [1572] = 688,
  [1573] = 886,
  [1574] = 747,
  [1575] = 891,
  [1576] = 894,
  [1577] = 760,
  [1578] = 839,
  [1579] = 702,
  [1580] = 1580,
  [1581] = 681,
  [1582] = 703,
  [1583] = 174,
  [1584] = 709,
  [1585] = 742,
  [1586] = 895,
  [1587] = 893,
  [1588] = 734,
  [1589] = 892,
  [1590] = 707,
  [1591] = 811,
  [1592] = 710,
  [1593] = 834,
  [1594] = 883,
  [1595] = 751,
  [1596] = 1596,
  [1597] = 730,
  [1598] = 863,
  [1599] = 850,
  [1600] = 753,
  [1601] = 791,
  [1602] = 780,
  [1603] = 711,
  [1604] = 712,
  [1605] = 830,
  [1606] = 829,
  [1607] = 826,
  [1608] = 825,
  [1609] = 823,
  [1610] = 820,
  [1611] = 819,
  [1612] = 817,
  [1613] = 812,
  [1614] = 807,
  [1615] = 799,
  [1616] = 777,
  [1617] = 716,
  [1618] = 879,
  [1619] = 771,
  [1620] = 827,
  [1621] = 884,
  [1622] = 818,
  [1623] = 828,
  [1624] = 719,
  [1625] = 717,
  [1626] = 756,
  [1627] = 669,
  [1628] = 832,
  [1629] = 739,
  [1630] = 938,
  [1631] = 952,
  [1632] = 951,
  [1633] = 949,
  [1634] = 1634,
  [1635] = 948,
  [1636] = 956,
  [1637] = 912,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1634,
  [1641] = 175,
  [1642] = 162,
  [1643] = 957,
  [1644] = 916,
  [1645] = 581,
  [1646] = 940,
  [1647] = 945,
  [1648] = 960,
  [1649] = 906,
  [1650] = 961,
  [1651] = 971,
  [1652] = 972,
  [1653] = 974,
  [1654] = 909,
  [1655] = 962,
  [1656] = 914,
  [1657] = 902,
  [1658] = 898,
  [1659] = 901,
  [1660] = 903,
  [1661] = 1639,
  [1662] = 908,
  [1663] = 907,
  [1664] = 917,
  [1665] = 963,
  [1666] = 921,
  [1667] = 929,
  [1668] = 935,
  [1669] = 946,
  [1670] = 950,
  [1671] = 967,
  [1672] = 1672,
  [1673] = 1639,
  [1674] = 154,
  [1675] = 910,
  [1676] = 973,
  [1677] = 1672,
  [1678] = 164,
  [1679] = 1679,
  [1680] = 976,
  [1681] = 904,
  [1682] = 919,
  [1683] = 970,
  [1684] = 920,
  [1685] = 926,
  [1686] = 918,
  [1687] = 977,
  [1688] = 1672,
  [1689] = 927,
  [1690] = 925,
  [1691] = 897,
  [1692] = 941,
  [1693] = 947,
  [1694] = 959,
  [1695] = 932,
  [1696] = 928,
  [1697] = 896,
  [1698] = 937,
  [1699] = 913,
  [1700] = 924,
  [1701] = 923,
  [1702] = 899,
  [1703] = 930,
  [1704] = 1639,
  [1705] = 931,
  [1706] = 969,
  [1707] = 975,
  [1708] = 575,
  [1709] = 934,
  [1710] = 915,
  [1711] = 1672,
  [1712] = 1672,
  [1713] = 905,
  [1714] = 936,
  [1715] = 942,
  [1716] = 1672,
  [1717] = 943,
  [1718] = 944,
  [1719] = 157,
  [1720] = 1639,
  [1721] = 958,
  [1722] = 954,
  [1723] = 955,
  [1724] = 900,
  [1725] = 966,
  [1726] = 953,
  [1727] = 964,
  [1728] = 1639,
  [1729] = 155,
  [1730] = 730,
  [1731] = 652,
  [1732] = 730,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 607,
  [1736] = 709,
  [1737] = 174,
  [1738] = 1734,
  [1739] = 170,
  [1740] = 629,
  [1741] = 628,
  [1742] = 1742,
  [1743] = 623,
  [1744] = 157,
  [1745] = 1745,
  [1746] = 155,
  [1747] = 1747,
  [1748] = 1734,
  [1749] = 1749,
  [1750] = 681,
  [1751] = 649,
  [1752] = 658,
  [1753] = 709,
  [1754] = 681,
  [1755] = 632,
  [1756] = 594,
  [1757] = 175,
  [1758] = 1734,
  [1759] = 164,
  [1760] = 596,
  [1761] = 599,
  [1762] = 601,
  [1763] = 602,
  [1764] = 603,
  [1765] = 162,
  [1766] = 659,
  [1767] = 657,
  [1768] = 604,
  [1769] = 605,
  [1770] = 608,
  [1771] = 609,
  [1772] = 611,
  [1773] = 615,
  [1774] = 616,
  [1775] = 622,
  [1776] = 626,
  [1777] = 633,
  [1778] = 634,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 641,
  [1782] = 154,
  [1783] = 642,
  [1784] = 643,
  [1785] = 606,
  [1786] = 598,
  [1787] = 1742,
  [1788] = 617,
  [1789] = 597,
  [1790] = 661,
  [1791] = 614,
  [1792] = 834,
  [1793] = 135,
  [1794] = 892,
  [1795] = 893,
  [1796] = 895,
  [1797] = 894,
  [1798] = 891,
  [1799] = 889,
  [1800] = 886,
  [1801] = 880,
  [1802] = 874,
  [1803] = 1803,
  [1804] = 642,
  [1805] = 873,
  [1806] = 871,
  [1807] = 860,
  [1808] = 859,
  [1809] = 643,
  [1810] = 847,
  [1811] = 845,
  [1812] = 844,
  [1813] = 843,
  [1814] = 842,
  [1815] = 840,
  [1816] = 663,
  [1817] = 837,
  [1818] = 836,
  [1819] = 835,
  [1820] = 776,
  [1821] = 833,
  [1822] = 1803,
  [1823] = 831,
  [1824] = 822,
  [1825] = 816,
  [1826] = 800,
  [1827] = 786,
  [1828] = 772,
  [1829] = 767,
  [1830] = 765,
  [1831] = 764,
  [1832] = 763,
  [1833] = 1803,
  [1834] = 762,
  [1835] = 760,
  [1836] = 756,
  [1837] = 754,
  [1838] = 1838,
  [1839] = 749,
  [1840] = 748,
  [1841] = 747,
  [1842] = 746,
  [1843] = 739,
  [1844] = 1844,
  [1845] = 730,
  [1846] = 718,
  [1847] = 716,
  [1848] = 712,
  [1849] = 711,
  [1850] = 710,
  [1851] = 707,
  [1852] = 703,
  [1853] = 702,
  [1854] = 688,
  [1855] = 685,
  [1856] = 652,
  [1857] = 677,
  [1858] = 758,
  [1859] = 883,
  [1860] = 866,
  [1861] = 863,
  [1862] = 813,
  [1863] = 709,
  [1864] = 742,
  [1865] = 751,
  [1866] = 753,
  [1867] = 780,
  [1868] = 850,
  [1869] = 827,
  [1870] = 828,
  [1871] = 830,
  [1872] = 832,
  [1873] = 841,
  [1874] = 861,
  [1875] = 1875,
  [1876] = 1780,
  [1877] = 607,
  [1878] = 829,
  [1879] = 826,
  [1880] = 628,
  [1881] = 623,
  [1882] = 629,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 596,
  [1886] = 599,
  [1887] = 791,
  [1888] = 601,
  [1889] = 602,
  [1890] = 603,
  [1891] = 604,
  [1892] = 605,
  [1893] = 608,
  [1894] = 609,
  [1895] = 611,
  [1896] = 615,
  [1897] = 616,
  [1898] = 622,
  [1899] = 626,
  [1900] = 633,
  [1901] = 634,
  [1902] = 641,
  [1903] = 642,
  [1904] = 643,
  [1905] = 825,
  [1906] = 823,
  [1907] = 820,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 819,
  [1911] = 793,
  [1912] = 817,
  [1913] = 812,
  [1914] = 807,
  [1915] = 799,
  [1916] = 777,
  [1917] = 771,
  [1918] = 641,
  [1919] = 634,
  [1920] = 633,
  [1921] = 626,
  [1922] = 681,
  [1923] = 623,
  [1924] = 669,
  [1925] = 622,
  [1926] = 616,
  [1927] = 615,
  [1928] = 717,
  [1929] = 839,
  [1930] = 690,
  [1931] = 1803,
  [1932] = 719,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1747,
  [1936] = 1749,
  [1937] = 818,
  [1938] = 1749,
  [1939] = 1939,
  [1940] = 611,
  [1941] = 1941,
  [1942] = 1747,
  [1943] = 884,
  [1944] = 1944,
  [1945] = 879,
  [1946] = 609,
  [1947] = 608,
  [1948] = 605,
  [1949] = 604,
  [1950] = 603,
  [1951] = 652,
  [1952] = 602,
  [1953] = 601,
  [1954] = 599,
  [1955] = 1939,
  [1956] = 856,
  [1957] = 1941,
  [1958] = 596,
  [1959] = 629,
  [1960] = 607,
  [1961] = 1747,
  [1962] = 1941,
  [1963] = 628,
  [1964] = 1939,
  [1965] = 1749,
  [1966] = 1803,
  [1967] = 1967,
  [1968] = 135,
  [1969] = 1941,
  [1970] = 1939,
  [1971] = 1971,
  [1972] = 1780,
  [1973] = 1875,
  [1974] = 1974,
  [1975] = 1884,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 603,
  [1979] = 841,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 604,
  [1983] = 1983,
  [1984] = 602,
  [1985] = 1985,
  [1986] = 1985,
  [1987] = 1985,
  [1988] = 1980,
  [1989] = 730,
  [1990] = 608,
  [1991] = 709,
  [1992] = 681,
  [1993] = 609,
  [1994] = 611,
  [1995] = 599,
  [1996] = 1747,
  [1997] = 1749,
  [1998] = 615,
  [1999] = 616,
  [2000] = 690,
  [2001] = 622,
  [2002] = 626,
  [2003] = 2003,
  [2004] = 1983,
  [2005] = 633,
  [2006] = 634,
  [2007] = 2007,
  [2008] = 596,
  [2009] = 1985,
  [2010] = 2010,
  [2011] = 1908,
  [2012] = 641,
  [2013] = 1981,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 1981,
  [2017] = 629,
  [2018] = 623,
  [2019] = 1985,
  [2020] = 690,
  [2021] = 605,
  [2022] = 642,
  [2023] = 1985,
  [2024] = 628,
  [2025] = 643,
  [2026] = 607,
  [2027] = 2027,
  [2028] = 1908,
  [2029] = 652,
  [2030] = 1933,
  [2031] = 905,
  [2032] = 915,
  [2033] = 153,
  [2034] = 150,
  [2035] = 1747,
  [2036] = 1749,
  [2037] = 898,
  [2038] = 901,
  [2039] = 903,
  [2040] = 908,
  [2041] = 2041,
  [2042] = 1985,
  [2043] = 912,
  [2044] = 916,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 1745,
  [2048] = 2048,
  [2049] = 169,
  [2050] = 896,
  [2051] = 937,
  [2052] = 975,
  [2053] = 977,
  [2054] = 2054,
  [2055] = 145,
  [2056] = 953,
  [2057] = 925,
  [2058] = 924,
  [2059] = 923,
  [2060] = 948,
  [2061] = 159,
  [2062] = 949,
  [2063] = 951,
  [2064] = 952,
  [2065] = 956,
  [2066] = 957,
  [2067] = 960,
  [2068] = 961,
  [2069] = 962,
  [2070] = 963,
  [2071] = 964,
  [2072] = 966,
  [2073] = 955,
  [2074] = 954,
  [2075] = 1985,
  [2076] = 944,
  [2077] = 943,
  [2078] = 144,
  [2079] = 942,
  [2080] = 938,
  [2081] = 936,
  [2082] = 934,
  [2083] = 969,
  [2084] = 931,
  [2085] = 930,
  [2086] = 928,
  [2087] = 1985,
  [2088] = 927,
  [2089] = 926,
  [2090] = 920,
  [2091] = 919,
  [2092] = 918,
  [2093] = 910,
  [2094] = 909,
  [2095] = 906,
  [2096] = 904,
  [2097] = 151,
  [2098] = 167,
  [2099] = 940,
  [2100] = 945,
  [2101] = 971,
  [2102] = 972,
  [2103] = 974,
  [2104] = 1980,
  [2105] = 156,
  [2106] = 1934,
  [2107] = 914,
  [2108] = 902,
  [2109] = 1884,
  [2110] = 907,
  [2111] = 2111,
  [2112] = 917,
  [2113] = 921,
  [2114] = 929,
  [2115] = 935,
  [2116] = 946,
  [2117] = 950,
  [2118] = 967,
  [2119] = 973,
  [2120] = 976,
  [2121] = 176,
  [2122] = 970,
  [2123] = 1780,
  [2124] = 149,
  [2125] = 2125,
  [2126] = 897,
  [2127] = 1980,
  [2128] = 941,
  [2129] = 947,
  [2130] = 959,
  [2131] = 2131,
  [2132] = 146,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 166,
  [2137] = 2111,
  [2138] = 932,
  [2139] = 178,
  [2140] = 913,
  [2141] = 899,
  [2142] = 177,
  [2143] = 2143,
  [2144] = 1933,
  [2145] = 2145,
  [2146] = 958,
  [2147] = 2147,
  [2148] = 841,
  [2149] = 900,
  [2150] = 601,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 161,
  [2154] = 158,
  [2155] = 152,
  [2156] = 163,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 1934,
  [2161] = 1908,
  [2162] = 2162,
  [2163] = 1838,
  [2164] = 1884,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 690,
  [2168] = 2166,
  [2169] = 2169,
  [2170] = 2162,
  [2171] = 2171,
  [2172] = 1733,
  [2173] = 1838,
  [2174] = 1934,
  [2175] = 841,
  [2176] = 2176,
  [2177] = 2166,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 1749,
  [2186] = 1747,
  [2187] = 2166,
  [2188] = 2166,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2181,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 730,
  [2195] = 2166,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2166,
  [2200] = 2193,
  [2201] = 2197,
  [2202] = 2166,
  [2203] = 2014,
  [2204] = 2181,
  [2205] = 2169,
  [2206] = 2206,
  [2207] = 2169,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 608,
  [2211] = 2211,
  [2212] = 643,
  [2213] = 2213,
  [2214] = 709,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 642,
  [2224] = 2218,
  [2225] = 1838,
  [2226] = 641,
  [2227] = 2218,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2217,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2232,
  [2235] = 2235,
  [2236] = 634,
  [2237] = 633,
  [2238] = 2238,
  [2239] = 2218,
  [2240] = 2240,
  [2241] = 626,
  [2242] = 622,
  [2243] = 2213,
  [2244] = 2221,
  [2245] = 1742,
  [2246] = 2217,
  [2247] = 2218,
  [2248] = 616,
  [2249] = 2221,
  [2250] = 2213,
  [2251] = 2222,
  [2252] = 615,
  [2253] = 2253,
  [2254] = 611,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 609,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 1638,
  [2262] = 1933,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 605,
  [2266] = 607,
  [2267] = 681,
  [2268] = 604,
  [2269] = 2222,
  [2270] = 1884,
  [2271] = 2271,
  [2272] = 2222,
  [2273] = 2222,
  [2274] = 652,
  [2275] = 2275,
  [2276] = 2217,
  [2277] = 2277,
  [2278] = 1838,
  [2279] = 2217,
  [2280] = 603,
  [2281] = 2222,
  [2282] = 628,
  [2283] = 2283,
  [2284] = 602,
  [2285] = 2285,
  [2286] = 601,
  [2287] = 2287,
  [2288] = 1908,
  [2289] = 2289,
  [2290] = 2209,
  [2291] = 623,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2218,
  [2295] = 2229,
  [2296] = 2213,
  [2297] = 2215,
  [2298] = 2221,
  [2299] = 2299,
  [2300] = 629,
  [2301] = 2301,
  [2302] = 2217,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 599,
  [2306] = 730,
  [2307] = 2218,
  [2308] = 596,
  [2309] = 2217,
  [2310] = 2218,
  [2311] = 2311,
  [2312] = 2217,
  [2313] = 2313,
  [2314] = 2222,
  [2315] = 2257,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2319,
  [2325] = 2325,
  [2326] = 2323,
  [2327] = 2327,
  [2328] = 2319,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2319,
  [2332] = 2015,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2319,
  [2339] = 2339,
  [2340] = 2336,
  [2341] = 681,
  [2342] = 2342,
  [2343] = 2319,
  [2344] = 841,
  [2345] = 2337,
  [2346] = 709,
  [2347] = 2347,
  [2348] = 2319,
  [2349] = 2349,
  [2350] = 690,
  [2351] = 2325,
  [2352] = 2342,
  [2353] = 2353,
  [2354] = 2342,
  [2355] = 730,
  [2356] = 2319,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2213,
  [2367] = 2221,
  [2368] = 2213,
  [2369] = 2221,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2213,
  [2373] = 2221,
  [2374] = 2221,
  [2375] = 2213,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2213,
  [2379] = 2221,
  [2380] = 2213,
  [2381] = 2381,
  [2382] = 2213,
  [2383] = 2376,
  [2384] = 2213,
  [2385] = 2221,
  [2386] = 2221,
  [2387] = 2387,
  [2388] = 2221,
  [2389] = 2389,
  [2390] = 157,
  [2391] = 155,
  [2392] = 2392,
  [2393] = 1373,
  [2394] = 2362,
  [2395] = 2360,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 1386,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 170,
  [2419] = 174,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 174,
  [2435] = 2435,
  [2436] = 2325,
  [2437] = 2433,
  [2438] = 2323,
  [2439] = 2439,
  [2440] = 2336,
  [2441] = 2327,
  [2442] = 2442,
  [2443] = 2323,
  [2444] = 2353,
  [2445] = 2445,
  [2446] = 2320,
  [2447] = 2336,
  [2448] = 2325,
  [2449] = 2330,
  [2450] = 2450,
  [2451] = 2337,
  [2452] = 2452,
  [2453] = 170,
  [2454] = 2337,
  [2455] = 157,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 155,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 791,
  [2463] = 2463,
  [2464] = 1384,
  [2465] = 1389,
  [2466] = 839,
  [2467] = 793,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2479,
  [2480] = 2333,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2491,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2494,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2503,
  [2513] = 2502,
  [2514] = 2498,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2507,
  [2520] = 2501,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 734,
  [2524] = 793,
  [2525] = 839,
  [2526] = 791,
  [2527] = 811,
  [2528] = 2528,
  [2529] = 669,
  [2530] = 617,
  [2531] = 597,
  [2532] = 661,
  [2533] = 817,
  [2534] = 807,
  [2535] = 844,
  [2536] = 843,
  [2537] = 842,
  [2538] = 840,
  [2539] = 891,
  [2540] = 663,
  [2541] = 837,
  [2542] = 836,
  [2543] = 880,
  [2544] = 835,
  [2545] = 776,
  [2546] = 833,
  [2547] = 831,
  [2548] = 822,
  [2549] = 883,
  [2550] = 816,
  [2551] = 800,
  [2552] = 834,
  [2553] = 892,
  [2554] = 893,
  [2555] = 799,
  [2556] = 886,
  [2557] = 895,
  [2558] = 889,
  [2559] = 812,
  [2560] = 894,
  [2561] = 819,
  [2562] = 2562,
  [2563] = 820,
  [2564] = 823,
  [2565] = 825,
  [2566] = 826,
  [2567] = 829,
  [2568] = 2562,
  [2569] = 786,
  [2570] = 830,
  [2571] = 749,
  [2572] = 758,
  [2573] = 2573,
  [2574] = 748,
  [2575] = 606,
  [2576] = 813,
  [2577] = 874,
  [2578] = 746,
  [2579] = 747,
  [2580] = 2573,
  [2581] = 767,
  [2582] = 598,
  [2583] = 811,
  [2584] = 707,
  [2585] = 734,
  [2586] = 718,
  [2587] = 669,
  [2588] = 754,
  [2589] = 871,
  [2590] = 617,
  [2591] = 2591,
  [2592] = 777,
  [2593] = 2591,
  [2594] = 597,
  [2595] = 866,
  [2596] = 863,
  [2597] = 2591,
  [2598] = 859,
  [2599] = 764,
  [2600] = 716,
  [2601] = 850,
  [2602] = 763,
  [2603] = 847,
  [2604] = 575,
  [2605] = 712,
  [2606] = 756,
  [2607] = 828,
  [2608] = 685,
  [2609] = 703,
  [2610] = 760,
  [2611] = 2591,
  [2612] = 711,
  [2613] = 2591,
  [2614] = 702,
  [2615] = 677,
  [2616] = 2591,
  [2617] = 832,
  [2618] = 751,
  [2619] = 753,
  [2620] = 780,
  [2621] = 845,
  [2622] = 2591,
  [2623] = 661,
  [2624] = 827,
  [2625] = 825,
  [2626] = 883,
  [2627] = 575,
  [2628] = 2628,
  [2629] = 575,
  [2630] = 2630,
  [2631] = 2631,
  [2632] = 2632,
  [2633] = 2630,
  [2634] = 2634,
  [2635] = 2635,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2638,
  [2639] = 575,
  [2640] = 800,
  [2641] = 816,
  [2642] = 822,
  [2643] = 831,
  [2644] = 833,
  [2645] = 776,
  [2646] = 835,
  [2647] = 836,
  [2648] = 837,
  [2649] = 663,
  [2650] = 840,
  [2651] = 842,
  [2652] = 843,
  [2653] = 844,
  [2654] = 2630,
  [2655] = 2655,
  [2656] = 2628,
  [2657] = 2634,
  [2658] = 2636,
  [2659] = 2659,
  [2660] = 2628,
  [2661] = 2628,
  [2662] = 2630,
  [2663] = 2636,
  [2664] = 2634,
  [2665] = 2628,
  [2666] = 2634,
  [2667] = 2630,
  [2668] = 2636,
  [2669] = 2669,
  [2670] = 2636,
  [2671] = 880,
  [2672] = 886,
  [2673] = 889,
  [2674] = 891,
  [2675] = 894,
  [2676] = 895,
  [2677] = 893,
  [2678] = 892,
  [2679] = 834,
  [2680] = 2634,
  [2681] = 614,
  [2682] = 799,
  [2683] = 2634,
  [2684] = 2630,
  [2685] = 2636,
  [2686] = 2628,
  [2687] = 829,
  [2688] = 826,
  [2689] = 807,
  [2690] = 823,
  [2691] = 820,
  [2692] = 819,
  [2693] = 817,
  [2694] = 812,
  [2695] = 2695,
  [2696] = 2696,
  [2697] = 748,
  [2698] = 2698,
  [2699] = 598,
  [2700] = 749,
  [2701] = 547,
  [2702] = 747,
  [2703] = 758,
  [2704] = 2704,
  [2705] = 617,
  [2706] = 558,
  [2707] = 614,
  [2708] = 614,
  [2709] = 661,
  [2710] = 597,
  [2711] = 793,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2713,
  [2716] = 2713,
  [2717] = 2698,
  [2718] = 2718,
  [2719] = 575,
  [2720] = 560,
  [2721] = 2698,
  [2722] = 839,
  [2723] = 2723,
  [2724] = 791,
  [2725] = 2725,
  [2726] = 2698,
  [2727] = 2727,
  [2728] = 614,
  [2729] = 2729,
  [2730] = 2713,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2698,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 837,
  [2739] = 2739,
  [2740] = 844,
  [2741] = 606,
  [2742] = 823,
  [2743] = 891,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 843,
  [2747] = 886,
  [2748] = 826,
  [2749] = 829,
  [2750] = 889,
  [2751] = 669,
  [2752] = 529,
  [2753] = 842,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 836,
  [2757] = 825,
  [2758] = 840,
  [2759] = 663,
  [2760] = 835,
  [2761] = 659,
  [2762] = 2762,
  [2763] = 2763,
  [2764] = 820,
  [2765] = 819,
  [2766] = 2766,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 657,
  [2770] = 817,
  [2771] = 893,
  [2772] = 895,
  [2773] = 894,
  [2774] = 776,
  [2775] = 880,
  [2776] = 883,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 833,
  [2780] = 2780,
  [2781] = 614,
  [2782] = 831,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 822,
  [2786] = 2737,
  [2787] = 669,
  [2788] = 2737,
  [2789] = 2789,
  [2790] = 2737,
  [2791] = 2791,
  [2792] = 816,
  [2793] = 800,
  [2794] = 799,
  [2795] = 2795,
  [2796] = 807,
  [2797] = 812,
  [2798] = 834,
  [2799] = 892,
  [2800] = 712,
  [2801] = 791,
  [2802] = 2802,
  [2803] = 716,
  [2804] = 711,
  [2805] = 718,
  [2806] = 839,
  [2807] = 771,
  [2808] = 765,
  [2809] = 762,
  [2810] = 598,
  [2811] = 739,
  [2812] = 707,
  [2813] = 793,
  [2814] = 703,
  [2815] = 659,
  [2816] = 702,
  [2817] = 657,
  [2818] = 758,
  [2819] = 685,
  [2820] = 746,
  [2821] = 747,
  [2822] = 659,
  [2823] = 657,
  [2824] = 748,
  [2825] = 749,
  [2826] = 813,
  [2827] = 754,
  [2828] = 756,
  [2829] = 760,
  [2830] = 677,
  [2831] = 763,
  [2832] = 764,
  [2833] = 767,
  [2834] = 860,
  [2835] = 772,
  [2836] = 2836,
  [2837] = 717,
  [2838] = 719,
  [2839] = 751,
  [2840] = 2840,
  [2841] = 786,
  [2842] = 845,
  [2843] = 847,
  [2844] = 859,
  [2845] = 871,
  [2846] = 753,
  [2847] = 780,
  [2848] = 873,
  [2849] = 827,
  [2850] = 828,
  [2851] = 832,
  [2852] = 874,
  [2853] = 669,
  [2854] = 866,
  [2855] = 2855,
  [2856] = 863,
  [2857] = 657,
  [2858] = 710,
  [2859] = 850,
  [2860] = 659,
  [2861] = 688,
  [2862] = 830,
  [2863] = 777,
  [2864] = 2836,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 771,
  [2868] = 2868,
  [2869] = 710,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 710,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 591,
  [2876] = 2876,
  [2877] = 762,
  [2878] = 765,
  [2879] = 2879,
  [2880] = 549,
  [2881] = 575,
  [2882] = 688,
  [2883] = 657,
  [2884] = 659,
  [2885] = 606,
  [2886] = 2871,
  [2887] = 2887,
  [2888] = 717,
  [2889] = 771,
  [2890] = 2890,
  [2891] = 566,
  [2892] = 688,
  [2893] = 2865,
  [2894] = 719,
  [2895] = 2879,
  [2896] = 860,
  [2897] = 563,
  [2898] = 2871,
  [2899] = 717,
  [2900] = 688,
  [2901] = 719,
  [2902] = 710,
  [2903] = 860,
  [2904] = 2865,
  [2905] = 860,
  [2906] = 719,
  [2907] = 762,
  [2908] = 771,
  [2909] = 717,
  [2910] = 2868,
  [2911] = 765,
  [2912] = 555,
  [2913] = 556,
  [2914] = 762,
  [2915] = 2915,
  [2916] = 765,
  [2917] = 2917,
  [2918] = 739,
  [2919] = 830,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 850,
  [2924] = 863,
  [2925] = 2925,
  [2926] = 2737,
  [2927] = 866,
  [2928] = 2928,
  [2929] = 2737,
  [2930] = 614,
  [2931] = 585,
  [2932] = 874,
  [2933] = 873,
  [2934] = 873,
  [2935] = 871,
  [2936] = 860,
  [2937] = 859,
  [2938] = 847,
  [2939] = 845,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2942,
  [2943] = 2943,
  [2944] = 786,
  [2945] = 2945,
  [2946] = 2737,
  [2947] = 2737,
  [2948] = 2922,
  [2949] = 772,
  [2950] = 767,
  [2951] = 765,
  [2952] = 2737,
  [2953] = 764,
  [2954] = 2920,
  [2955] = 763,
  [2956] = 762,
  [2957] = 2870,
  [2958] = 2958,
  [2959] = 832,
  [2960] = 760,
  [2961] = 2887,
  [2962] = 756,
  [2963] = 754,
  [2964] = 2920,
  [2965] = 2965,
  [2966] = 2966,
  [2967] = 777,
  [2968] = 2968,
  [2969] = 746,
  [2970] = 2970,
  [2971] = 2870,
  [2972] = 2972,
  [2973] = 2945,
  [2974] = 2887,
  [2975] = 718,
  [2976] = 716,
  [2977] = 712,
  [2978] = 2978,
  [2979] = 2737,
  [2980] = 717,
  [2981] = 2981,
  [2982] = 711,
  [2983] = 710,
  [2984] = 707,
  [2985] = 703,
  [2986] = 702,
  [2987] = 688,
  [2988] = 685,
  [2989] = 827,
  [2990] = 771,
  [2991] = 677,
  [2992] = 2992,
  [2993] = 2993,
  [2994] = 811,
  [2995] = 2995,
  [2996] = 2943,
  [2997] = 2992,
  [2998] = 2940,
  [2999] = 739,
  [3000] = 3000,
  [3001] = 813,
  [3002] = 588,
  [3003] = 2940,
  [3004] = 734,
  [3005] = 751,
  [3006] = 753,
  [3007] = 2737,
  [3008] = 2945,
  [3009] = 2737,
  [3010] = 780,
  [3011] = 2970,
  [3012] = 772,
  [3013] = 3013,
  [3014] = 828,
  [3015] = 719,
  [3016] = 3016,
  [3017] = 3017,
  [3018] = 2992,
  [3019] = 3019,
  [3020] = 3016,
  [3021] = 3016,
  [3022] = 598,
  [3023] = 3023,
  [3024] = 3016,
  [3025] = 3025,
  [3026] = 3016,
  [3027] = 3027,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 2992,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 1373,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3036,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 2840,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 2978,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 659,
  [3066] = 657,
  [3067] = 861,
  [3068] = 3068,
  [3069] = 3030,
  [3070] = 3049,
  [3071] = 2874,
  [3072] = 3072,
  [3073] = 3049,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 3077,
  [3078] = 2966,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 3088,
  [3089] = 3089,
  [3090] = 3090,
  [3091] = 3085,
  [3092] = 2941,
  [3093] = 2992,
  [3094] = 3046,
  [3095] = 3084,
  [3096] = 3096,
  [3097] = 2942,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3077,
  [3101] = 3101,
  [3102] = 3068,
  [3103] = 3103,
  [3104] = 3068,
  [3105] = 3105,
  [3106] = 3085,
  [3107] = 3107,
  [3108] = 3108,
  [3109] = 3086,
  [3110] = 3103,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3115,
  [3116] = 3030,
  [3117] = 3088,
  [3118] = 3118,
  [3119] = 3107,
  [3120] = 3083,
  [3121] = 3121,
  [3122] = 2855,
  [3123] = 3123,
  [3124] = 3124,
  [3125] = 3103,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3035,
  [3129] = 3052,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3074,
  [3134] = 646,
  [3135] = 742,
  [3136] = 3136,
  [3137] = 2917,
  [3138] = 3036,
  [3139] = 3139,
  [3140] = 3140,
  [3141] = 3141,
  [3142] = 3142,
  [3143] = 3083,
  [3144] = 3052,
  [3145] = 3145,
  [3146] = 3146,
  [3147] = 3147,
  [3148] = 3108,
  [3149] = 3028,
  [3150] = 3130,
  [3151] = 3127,
  [3152] = 3152,
  [3153] = 3153,
  [3154] = 3154,
  [3155] = 3155,
  [3156] = 3156,
  [3157] = 762,
  [3158] = 765,
  [3159] = 3041,
  [3160] = 3160,
  [3161] = 3161,
  [3162] = 3162,
  [3163] = 3163,
  [3164] = 3164,
  [3165] = 3165,
  [3166] = 3166,
  [3167] = 3167,
  [3168] = 3168,
  [3169] = 3115,
  [3170] = 3131,
  [3171] = 3154,
  [3172] = 3032,
  [3173] = 3098,
  [3174] = 3174,
  [3175] = 3175,
  [3176] = 3176,
  [3177] = 3146,
  [3178] = 3156,
  [3179] = 3179,
  [3180] = 3180,
  [3181] = 3176,
  [3182] = 3182,
  [3183] = 3099,
  [3184] = 3176,
  [3185] = 3160,
  [3186] = 3186,
  [3187] = 3187,
  [3188] = 3188,
  [3189] = 3189,
  [3190] = 3190,
  [3191] = 3191,
  [3192] = 3114,
  [3193] = 539,
  [3194] = 3194,
  [3195] = 3176,
  [3196] = 3196,
  [3197] = 3179,
  [3198] = 3188,
  [3199] = 3199,
  [3200] = 3200,
  [3201] = 3201,
  [3202] = 3202,
  [3203] = 3175,
  [3204] = 3204,
  [3205] = 3205,
  [3206] = 3189,
  [3207] = 3207,
  [3208] = 3194,
  [3209] = 3160,
  [3210] = 3210,
  [3211] = 3211,
  [3212] = 3113,
  [3213] = 3160,
  [3214] = 3214,
  [3215] = 3199,
  [3216] = 3089,
  [3217] = 3200,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 3220,
  [3221] = 3176,
  [3222] = 3222,
  [3223] = 3105,
  [3224] = 3156,
  [3225] = 3225,
  [3226] = 3147,
  [3227] = 3196,
  [3228] = 3051,
  [3229] = 3161,
  [3230] = 3230,
  [3231] = 3231,
  [3232] = 1386,
  [3233] = 3211,
  [3234] = 3146,
  [3235] = 3126,
  [3236] = 3210,
  [3237] = 3231,
  [3238] = 3190,
  [3239] = 3160,
  [3240] = 3152,
  [3241] = 3241,
  [3242] = 3242,
  [3243] = 3147,
  [3244] = 3205,
  [3245] = 860,
  [3246] = 3147,
  [3247] = 3219,
  [3248] = 3161,
  [3249] = 3199,
  [3250] = 3154,
  [3251] = 3218,
  [3252] = 3252,
  [3253] = 3199,
  [3254] = 3156,
  [3255] = 3072,
  [3256] = 3242,
  [3257] = 3257,
  [3258] = 3124,
  [3259] = 3160,
  [3260] = 3202,
  [3261] = 3123,
  [3262] = 3211,
  [3263] = 3027,
  [3264] = 3231,
  [3265] = 3265,
  [3266] = 717,
  [3267] = 719,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3050,
  [3271] = 3271,
  [3272] = 3199,
  [3273] = 3273,
  [3274] = 688,
  [3275] = 3275,
  [3276] = 3082,
  [3277] = 3214,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 710,
  [3281] = 3160,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3207,
  [3286] = 3196,
  [3287] = 3189,
  [3288] = 3202,
  [3289] = 3167,
  [3290] = 3079,
  [3291] = 771,
  [3292] = 3199,
  [3293] = 3218,
  [3294] = 3156,
  [3295] = 3295,
  [3296] = 3296,
  [3297] = 3147,
  [3298] = 3147,
  [3299] = 3154,
  [3300] = 3156,
  [3301] = 3156,
  [3302] = 3199,
  [3303] = 3303,
  [3304] = 1361,
  [3305] = 3186,
  [3306] = 3162,
  [3307] = 3307,
  [3308] = 3167,
  [3309] = 3087,
  [3310] = 3043,
  [3311] = 3311,
  [3312] = 3176,
  [3313] = 3045,
  [3314] = 3314,
  [3315] = 3202,
  [3316] = 3316,
  [3317] = 3154,
  [3318] = 3154,
  [3319] = 3162,
  [3320] = 3320,
  [3321] = 3189,
  [3322] = 3132,
  [3323] = 3176,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3196,
  [3327] = 3154,
  [3328] = 3231,
  [3329] = 3329,
  [3330] = 3211,
  [3331] = 3295,
  [3332] = 3332,
  [3333] = 3127,
  [3334] = 3334,
  [3335] = 3207,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3337,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 3344,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3357,
  [3358] = 3358,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3337,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3370,
  [3371] = 3344,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3386,
  [3387] = 3387,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 3393,
  [3394] = 3394,
  [3395] = 3395,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 3399,
  [3400] = 2887,
  [3401] = 3344,
  [3402] = 3393,
  [3403] = 3403,
  [3404] = 3337,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 2870,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 3411,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3337,
  [3416] = 3416,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 3435,
  [3436] = 3434,
  [3437] = 3437,
  [3438] = 3438,
  [3439] = 3420,
  [3440] = 3440,
  [3441] = 3441,
  [3442] = 3442,
  [3443] = 3433,
  [3444] = 3399,
  [3445] = 3445,
  [3446] = 3337,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3410,
  [3450] = 3336,
  [3451] = 3096,
  [3452] = 3452,
  [3453] = 3378,
  [3454] = 3347,
  [3455] = 2870,
  [3456] = 3346,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3376,
  [3460] = 3438,
  [3461] = 3461,
  [3462] = 3461,
  [3463] = 3372,
  [3464] = 3390,
  [3465] = 3389,
  [3466] = 3368,
  [3467] = 3341,
  [3468] = 3391,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 3472,
  [3473] = 3472,
  [3474] = 3345,
  [3475] = 3475,
  [3476] = 3339,
  [3477] = 3477,
  [3478] = 3344,
  [3479] = 3479,
  [3480] = 3393,
  [3481] = 3343,
  [3482] = 3482,
  [3483] = 3399,
  [3484] = 3484,
  [3485] = 3485,
  [3486] = 3383,
  [3487] = 3487,
  [3488] = 3488,
  [3489] = 3489,
  [3490] = 3344,
  [3491] = 3491,
  [3492] = 3492,
  [3493] = 2887,
  [3494] = 3407,
  [3495] = 3495,
  [3496] = 669,
  [3497] = 3497,
  [3498] = 3498,
  [3499] = 3499,
  [3500] = 3357,
  [3501] = 3484,
  [3502] = 3414,
  [3503] = 3503,
  [3504] = 3031,
  [3505] = 3505,
  [3506] = 3506,
  [3507] = 3332,
  [3508] = 3508,
  [3509] = 3279,
  [3510] = 3278,
  [3511] = 3225,
  [3512] = 3418,
  [3513] = 3378,
  [3514] = 3112,
  [3515] = 3380,
  [3516] = 3379,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 773,
  [3524] = 570,
  [3525] = 3433,
  [3526] = 3526,
  [3527] = 3418,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3365,
  [3532] = 3414,
  [3533] = 3503,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3537,
  [3538] = 3505,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 569,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3553,
  [3554] = 3554,
  [3555] = 3551,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 3558,
  [3559] = 3559,
  [3560] = 3553,
  [3561] = 3552,
  [3562] = 3562,
  [3563] = 3548,
  [3564] = 3550,
  [3565] = 3548,
  [3566] = 3547,
  [3567] = 3567,
  [3568] = 3568,
  [3569] = 3550,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3570,
  [3574] = 3548,
  [3575] = 3575,
  [3576] = 3576,
  [3577] = 3553,
  [3578] = 3554,
  [3579] = 3550,
  [3580] = 3553,
  [3581] = 3559,
  [3582] = 3552,
  [3583] = 3552,
  [3584] = 3584,
  [3585] = 3547,
  [3586] = 3586,
  [3587] = 3548,
  [3588] = 3588,
  [3589] = 3589,
  [3590] = 3568,
  [3591] = 3550,
  [3592] = 3567,
  [3593] = 3554,
  [3594] = 3584,
  [3595] = 3595,
  [3596] = 3554,
  [3597] = 3551,
  [3598] = 3598,
  [3599] = 3599,
  [3600] = 3551,
  [3601] = 3551,
  [3602] = 3602,
  [3603] = 3567,
  [3604] = 3604,
  [3605] = 3547,
  [3606] = 3606,
  [3607] = 3607,
  [3608] = 3552,
  [3609] = 3553,
  [3610] = 3610,
  [3611] = 3551,
  [3612] = 3550,
  [3613] = 3613,
  [3614] = 3554,
  [3615] = 3615,
  [3616] = 3559,
  [3617] = 3548,
  [3618] = 3554,
  [3619] = 3551,
  [3620] = 3549,
  [3621] = 3570,
  [3622] = 3622,
  [3623] = 3623,
  [3624] = 3624,
  [3625] = 3625,
  [3626] = 3610,
  [3627] = 3559,
  [3628] = 3570,
  [3629] = 3567,
  [3630] = 3630,
  [3631] = 3553,
  [3632] = 3632,
  [3633] = 3633,
  [3634] = 3634,
  [3635] = 3635,
  [3636] = 3550,
  [3637] = 3630,
  [3638] = 3572,
  [3639] = 3548,
  [3640] = 3550,
  [3641] = 3567,
  [3642] = 3559,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3548,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3610,
  [3650] = 3551,
  [3651] = 3570,
  [3652] = 3652,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3568,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3548,
  [3659] = 3552,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3662,
  [3663] = 3663,
  [3664] = 3550,
  [3665] = 3551,
  [3666] = 3567,
  [3667] = 3584,
  [3668] = 3554,
  [3669] = 3547,
  [3670] = 3552,
  [3671] = 3553,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3554,
  [3675] = 3643,
  [3676] = 3676,
  [3677] = 3677,
  [3678] = 3678,
  [3679] = 3663,
  [3680] = 3606,
  [3681] = 640,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3684,
  [3685] = 3685,
  [3686] = 3686,
  [3687] = 3687,
  [3688] = 3688,
  [3689] = 3570,
  [3690] = 3556,
  [3691] = 3691,
  [3692] = 3549,
  [3693] = 3547,
  [3694] = 3572,
  [3695] = 3554,
  [3696] = 3567,
  [3697] = 3547,
  [3698] = 3559,
  [3699] = 3699,
  [3700] = 3700,
  [3701] = 3663,
  [3702] = 3702,
  [3703] = 707,
  [3704] = 3704,
  [3705] = 3705,
  [3706] = 653,
  [3707] = 3707,
  [3708] = 3708,
  [3709] = 3709,
  [3710] = 3710,
  [3711] = 3711,
  [3712] = 3712,
  [3713] = 3713,
  [3714] = 3714,
  [3715] = 3715,
  [3716] = 3716,
  [3717] = 3717,
  [3718] = 3718,
  [3719] = 3719,
  [3720] = 3720,
  [3721] = 3721,
  [3722] = 3722,
  [3723] = 3723,
  [3724] = 3724,
  [3725] = 3032,
  [3726] = 3726,
  [3727] = 3727,
  [3728] = 3728,
  [3729] = 3729,
  [3730] = 3730,
  [3731] = 3731,
  [3732] = 3732,
  [3733] = 3733,
  [3734] = 3734,
  [3735] = 3735,
  [3736] = 3704,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3740,
  [3741] = 3741,
  [3742] = 3028,
  [3743] = 3743,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3746,
  [3747] = 3747,
  [3748] = 3727,
  [3749] = 3749,
  [3750] = 3724,
  [3751] = 3747,
  [3752] = 3731,
  [3753] = 3705,
  [3754] = 3712,
  [3755] = 3746,
  [3756] = 3718,
  [3757] = 3722,
  [3758] = 3758,
  [3759] = 3728,
  [3760] = 3760,
  [3761] = 3729,
  [3762] = 3762,
  [3763] = 3740,
  [3764] = 3764,
  [3765] = 3727,
  [3766] = 3766,
  [3767] = 3767,
  [3768] = 3768,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 3771,
  [3772] = 3772,
  [3773] = 3739,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3776,
  [3777] = 3777,
  [3778] = 3542,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3781,
  [3782] = 3738,
  [3783] = 3783,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 3716,
  [3787] = 3787,
  [3788] = 3733,
  [3789] = 3789,
  [3790] = 3732,
  [3791] = 3730,
  [3792] = 3727,
  [3793] = 3041,
  [3794] = 3794,
  [3795] = 3795,
  [3796] = 3704,
  [3797] = 3797,
  [3798] = 3798,
  [3799] = 3722,
  [3800] = 3708,
  [3801] = 3718,
  [3802] = 3802,
  [3803] = 3803,
  [3804] = 3795,
  [3805] = 3805,
  [3806] = 3787,
  [3807] = 3807,
  [3808] = 3808,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3802,
  [3812] = 3727,
  [3813] = 3813,
  [3814] = 3814,
  [3815] = 3815,
  [3816] = 3816,
  [3817] = 3766,
  [3818] = 3818,
  [3819] = 3819,
  [3820] = 3717,
  [3821] = 3821,
  [3822] = 3822,
  [3823] = 3457,
  [3824] = 3824,
  [3825] = 3717,
  [3826] = 3826,
  [3827] = 3709,
  [3828] = 3828,
  [3829] = 3716,
  [3830] = 3722,
  [3831] = 3718,
  [3832] = 3727,
  [3833] = 3716,
  [3834] = 3808,
  [3835] = 3835,
  [3836] = 3836,
  [3837] = 718,
  [3838] = 3777,
  [3839] = 3714,
  [3840] = 3721,
  [3841] = 3835,
  [3842] = 3722,
  [3843] = 3718,
  [3844] = 3717,
  [3845] = 3716,
  [3846] = 3846,
  [3847] = 646,
  [3848] = 3716,
  [3849] = 3787,
  [3850] = 3716,
  [3851] = 3721,
  [3852] = 3704,
  [3853] = 3853,
  [3854] = 3805,
  [3855] = 3723,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3735,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3861,
  [3862] = 3862,
  [3863] = 3718,
  [3864] = 3722,
  [3865] = 3865,
  [3866] = 3866,
  [3867] = 3743,
  [3868] = 3868,
  [3869] = 3396,
  [3870] = 3722,
  [3871] = 3718,
  [3872] = 3727,
  [3873] = 3873,
  [3874] = 3874,
  [3875] = 3875,
  [3876] = 3876,
  [3877] = 3733,
  [3878] = 3822,
  [3879] = 3738,
  [3880] = 3740,
  [3881] = 3724,
  [3882] = 3747,
  [3883] = 3760,
  [3884] = 3884,
  [3885] = 3828,
  [3886] = 3716,
  [3887] = 3808,
  [3888] = 3888,
  [3889] = 3889,
  [3890] = 3836,
  [3891] = 3853,
  [3892] = 3892,
  [3893] = 3727,
  [3894] = 3704,
  [3895] = 3749,
  [3896] = 3896,
  [3897] = 3897,
  [3898] = 3898,
  [3899] = 3899,
  [3900] = 3805,
  [3901] = 3901,
  [3902] = 3722,
  [3903] = 3903,
  [3904] = 3787,
  [3905] = 3905,
  [3906] = 3906,
  [3907] = 3907,
  [3908] = 3846,
  [3909] = 3909,
  [3910] = 3910,
  [3911] = 3718,
  [3912] = 3717,
  [3913] = 3723,
  [3914] = 3914,
  [3915] = 3717,
  [3916] = 3735,
  [3917] = 3712,
  [3918] = 3787,
  [3919] = 3919,
  [3920] = 3920,
  [3921] = 3921,
  [3922] = 3824,
  [3923] = 3743,
  [3924] = 3868,
  [3925] = 3707,
  [3926] = 3787,
  [3927] = 3798,
  [3928] = 3797,
  [3929] = 3910,
  [3930] = 3787,
  [3931] = 3704,
  [3932] = 3932,
  [3933] = 3933,
  [3934] = 3713,
  [3935] = 3826,
  [3936] = 3727,
  [3937] = 3795,
  [3938] = 3718,
  [3939] = 3722,
  [3940] = 3798,
  [3941] = 3941,
  [3942] = 3716,
  [3943] = 3943,
  [3944] = 3944,
  [3945] = 3797,
  [3946] = 3946,
  [3947] = 170,
  [3948] = 3045,
  [3949] = 174,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3952,
  [3953] = 3953,
  [3954] = 3954,
  [3955] = 3955,
  [3956] = 3956,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3961,
  [3962] = 3962,
  [3963] = 3963,
  [3964] = 3964,
  [3965] = 3965,
  [3966] = 2429,
  [3967] = 3967,
  [3968] = 3968,
  [3969] = 3969,
  [3970] = 3970,
  [3971] = 2428,
  [3972] = 3972,
  [3973] = 3973,
  [3974] = 3958,
  [3975] = 3960,
  [3976] = 3976,
  [3977] = 3977,
  [3978] = 3978,
  [3979] = 3970,
  [3980] = 3980,
  [3981] = 3981,
  [3982] = 3982,
  [3983] = 3983,
  [3984] = 3977,
  [3985] = 3985,
  [3986] = 3986,
  [3987] = 3987,
  [3988] = 3988,
  [3989] = 3989,
  [3990] = 3990,
  [3991] = 3991,
  [3992] = 3952,
  [3993] = 3993,
  [3994] = 3994,
  [3995] = 3995,
  [3996] = 3996,
  [3997] = 3976,
  [3998] = 3998,
  [3999] = 3980,
  [4000] = 4000,
  [4001] = 3981,
  [4002] = 4002,
  [4003] = 3982,
  [4004] = 4004,
  [4005] = 4005,
  [4006] = 3982,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 3981,
  [4010] = 3980,
  [4011] = 3976,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4000,
  [4015] = 4015,
  [4016] = 3978,
  [4017] = 3989,
  [4018] = 4018,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 4026,
  [4027] = 4027,
  [4028] = 4028,
  [4029] = 4029,
  [4030] = 4013,
  [4031] = 3959,
  [4032] = 3988,
  [4033] = 3987,
  [4034] = 4000,
  [4035] = 4035,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 3225,
  [4040] = 3977,
  [4041] = 3977,
  [4042] = 4042,
  [4043] = 4043,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 1462,
  [4047] = 3973,
  [4048] = 3960,
  [4049] = 4049,
  [4050] = 1460,
  [4051] = 4051,
  [4052] = 4052,
  [4053] = 4053,
  [4054] = 4054,
  [4055] = 4037,
  [4056] = 4056,
  [4057] = 4057,
  [4058] = 4058,
  [4059] = 4059,
  [4060] = 4060,
  [4061] = 4061,
  [4062] = 4062,
  [4063] = 4063,
  [4064] = 4018,
  [4065] = 3989,
  [4066] = 4066,
  [4067] = 4067,
  [4068] = 4068,
  [4069] = 4000,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 486,
  [4075] = 478,
  [4076] = 4076,
  [4077] = 4077,
  [4078] = 4078,
  [4079] = 2413,
  [4080] = 2403,
  [4081] = 3957,
  [4082] = 2397,
  [4083] = 3958,
  [4084] = 4060,
  [4085] = 2422,
  [4086] = 3960,
  [4087] = 2425,
  [4088] = 3989,
  [4089] = 2412,
  [4090] = 2400,
  [4091] = 4038,
  [4092] = 4036,
  [4093] = 4035,
  [4094] = 2414,
  [4095] = 4095,
  [4096] = 4096,
  [4097] = 3676,
  [4098] = 3958,
  [4099] = 3960,
  [4100] = 4100,
  [4101] = 3983,
  [4102] = 3989,
  [4103] = 2416,
  [4104] = 4104,
  [4105] = 4105,
  [4106] = 2417,
  [4107] = 3982,
  [4108] = 3981,
  [4109] = 3980,
  [4110] = 3976,
  [4111] = 3958,
  [4112] = 4007,
  [4113] = 4113,
  [4114] = 4061,
  [4115] = 4066,
  [4116] = 4116,
  [4117] = 3989,
  [4118] = 3960,
  [4119] = 4119,
  [4120] = 4068,
  [4121] = 4121,
  [4122] = 2410,
  [4123] = 3989,
  [4124] = 4029,
  [4125] = 4125,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 4128,
  [4129] = 4129,
  [4130] = 4130,
  [4131] = 4131,
  [4132] = 3958,
  [4133] = 4000,
  [4134] = 2421,
  [4135] = 4135,
  [4136] = 2407,
  [4137] = 2424,
  [4138] = 4138,
  [4139] = 3960,
  [4140] = 4140,
  [4141] = 3989,
  [4142] = 4142,
  [4143] = 3972,
  [4144] = 4144,
  [4145] = 2420,
  [4146] = 4146,
  [4147] = 4147,
  [4148] = 4028,
  [4149] = 3977,
  [4150] = 3953,
  [4151] = 3954,
  [4152] = 4152,
  [4153] = 4042,
  [4154] = 3960,
  [4155] = 4155,
  [4156] = 2423,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 3955,
  [4160] = 4160,
  [4161] = 3956,
  [4162] = 4162,
  [4163] = 4163,
  [4164] = 4036,
  [4165] = 4165,
  [4166] = 3961,
  [4167] = 3962,
  [4168] = 4168,
  [4169] = 3278,
  [4170] = 3279,
  [4171] = 4171,
  [4172] = 3968,
  [4173] = 2396,
  [4174] = 1454,
  [4175] = 4013,
  [4176] = 3969,
  [4177] = 4177,
  [4178] = 3958,
  [4179] = 4179,
  [4180] = 4180,
  [4181] = 3959,
  [4182] = 3976,
  [4183] = 3980,
  [4184] = 4184,
  [4185] = 4185,
  [4186] = 3981,
  [4187] = 4096,
  [4188] = 4188,
  [4189] = 3982,
  [4190] = 3988,
  [4191] = 3987,
  [4192] = 4192,
  [4193] = 4192,
  [4194] = 4194,
  [4195] = 3958,
  [4196] = 4196,
  [4197] = 3977,
  [4198] = 4198,
  [4199] = 4199,
  [4200] = 4200,
  [4201] = 4201,
  [4202] = 4202,
  [4203] = 4028,
  [4204] = 3960,
  [4205] = 4205,
  [4206] = 4206,
  [4207] = 3958,
  [4208] = 1446,
  [4209] = 3953,
  [4210] = 4210,
  [4211] = 4038,
  [4212] = 4072,
  [4213] = 4035,
  [4214] = 4027,
  [4215] = 3127,
  [4216] = 4025,
  [4217] = 3954,
  [4218] = 4024,
  [4219] = 4023,
  [4220] = 3955,
  [4221] = 3332,
  [4222] = 3127,
  [4223] = 4057,
  [4224] = 4171,
  [4225] = 3956,
  [4226] = 4019,
  [4227] = 4227,
  [4228] = 4008,
  [4229] = 3961,
  [4230] = 4004,
  [4231] = 4142,
  [4232] = 3962,
  [4233] = 4002,
  [4234] = 3990,
  [4235] = 4235,
  [4236] = 4236,
  [4237] = 3991,
  [4238] = 3998,
  [4239] = 4199,
  [4240] = 3994,
  [4241] = 2409,
  [4242] = 4242,
  [4243] = 4071,
  [4244] = 3993,
  [4245] = 4027,
  [4246] = 4025,
  [4247] = 4024,
  [4248] = 4248,
  [4249] = 4249,
  [4250] = 4023,
  [4251] = 4251,
  [4252] = 3968,
  [4253] = 4019,
  [4254] = 4254,
  [4255] = 4008,
  [4256] = 4004,
  [4257] = 4002,
  [4258] = 3998,
  [4259] = 4259,
  [4260] = 4260,
  [4261] = 4259,
  [4262] = 4194,
  [4263] = 4188,
  [4264] = 4116,
  [4265] = 4265,
  [4266] = 4266,
  [4267] = 4267,
  [4268] = 4268,
  [4269] = 4269,
  [4270] = 3989,
  [4271] = 2408,
  [4272] = 4272,
  [4273] = 4273,
  [4274] = 3982,
  [4275] = 2411,
  [4276] = 4276,
  [4277] = 3981,
  [4278] = 4278,
  [4279] = 3980,
  [4280] = 4073,
  [4281] = 3976,
  [4282] = 4282,
  [4283] = 3969,
  [4284] = 4284,
  [4285] = 4285,
  [4286] = 4286,
  [4287] = 4287,
  [4288] = 4288,
  [4289] = 4289,
  [4290] = 4286,
  [4291] = 4291,
  [4292] = 4292,
  [4293] = 4293,
  [4294] = 4294,
  [4295] = 4295,
  [4296] = 4286,
  [4297] = 4297,
  [4298] = 4298,
  [4299] = 4299,
  [4300] = 4300,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4304,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4307,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 4310,
  [4311] = 4311,
  [4312] = 4312,
  [4313] = 4313,
  [4314] = 4314,
  [4315] = 4298,
  [4316] = 4300,
  [4317] = 4294,
  [4318] = 4318,
  [4319] = 4319,
  [4320] = 4320,
  [4321] = 4321,
  [4322] = 4297,
  [4323] = 4323,
  [4324] = 4324,
  [4325] = 4325,
  [4326] = 4326,
  [4327] = 4327,
  [4328] = 4328,
  [4329] = 4291,
  [4330] = 4287,
  [4331] = 4291,
  [4332] = 4286,
  [4333] = 4333,
  [4334] = 4292,
  [4335] = 4288,
  [4336] = 4302,
  [4337] = 4337,
  [4338] = 4303,
  [4339] = 4305,
  [4340] = 4340,
  [4341] = 4306,
  [4342] = 4307,
  [4343] = 4308,
  [4344] = 4309,
  [4345] = 4345,
  [4346] = 4310,
  [4347] = 4311,
  [4348] = 4312,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 4351,
  [4352] = 4352,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4355,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4358,
  [4359] = 4294,
  [4360] = 4360,
  [4361] = 4361,
  [4362] = 4362,
  [4363] = 4363,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4368,
  [4369] = 4304,
  [4370] = 4314,
  [4371] = 4371,
  [4372] = 4372,
  [4373] = 4373,
  [4374] = 4291,
  [4375] = 4375,
  [4376] = 4361,
  [4377] = 4356,
  [4378] = 4371,
  [4379] = 4355,
  [4380] = 4380,
  [4381] = 4381,
  [4382] = 4382,
  [4383] = 4289,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4366,
  [4387] = 4387,
  [4388] = 4301,
  [4389] = 4365,
  [4390] = 4364,
  [4391] = 4391,
  [4392] = 4337,
  [4393] = 4292,
  [4394] = 4363,
  [4395] = 4362,
  [4396] = 4287,
  [4397] = 4397,
  [4398] = 4398,
  [4399] = 4289,
  [4400] = 4400,
  [4401] = 4401,
  [4402] = 4402,
  [4403] = 4301,
  [4404] = 4301,
  [4405] = 4291,
  [4406] = 4406,
  [4407] = 4328,
  [4408] = 4408,
  [4409] = 4286,
  [4410] = 4410,
  [4411] = 4289,
  [4412] = 4297,
  [4413] = 4413,
  [4414] = 4289,
  [4415] = 4328,
  [4416] = 4362,
  [4417] = 4417,
  [4418] = 4301,
  [4419] = 4419,
  [4420] = 4302,
  [4421] = 953,
  [4422] = 4303,
  [4423] = 4287,
  [4424] = 4305,
  [4425] = 4306,
  [4426] = 4307,
  [4427] = 4308,
  [4428] = 4289,
  [4429] = 4287,
  [4430] = 4309,
  [4431] = 4301,
  [4432] = 4310,
  [4433] = 4311,
  [4434] = 4312,
  [4435] = 4294,
  [4436] = 4318,
  [4437] = 4301,
  [4438] = 4301,
  [4439] = 4319,
  [4440] = 4440,
  [4441] = 4320,
  [4442] = 4323,
  [4443] = 4443,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 4325,
  [4447] = 4327,
  [4448] = 4333,
  [4449] = 4349,
  [4450] = 4350,
  [4451] = 4362,
  [4452] = 4318,
  [4453] = 4363,
  [4454] = 4353,
  [4455] = 4319,
  [4456] = 4320,
  [4457] = 4457,
  [4458] = 4291,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4323,
  [4462] = 4366,
  [4463] = 4325,
  [4464] = 4351,
  [4465] = 4327,
  [4466] = 4287,
  [4467] = 4361,
  [4468] = 4356,
  [4469] = 4355,
  [4470] = 4292,
  [4471] = 4471,
  [4472] = 4333,
  [4473] = 4349,
  [4474] = 4350,
  [4475] = 4351,
  [4476] = 4476,
  [4477] = 4368,
  [4478] = 4366,
  [4479] = 4297,
  [4480] = 4287,
  [4481] = 4481,
  [4482] = 4364,
  [4483] = 4483,
  [4484] = 4410,
  [4485] = 4300,
  [4486] = 4294,
  [4487] = 4368,
  [4488] = 4402,
  [4489] = 4365,
  [4490] = 4292,
  [4491] = 4366,
  [4492] = 4492,
  [4493] = 4294,
  [4494] = 4305,
  [4495] = 4351,
  [4496] = 4350,
  [4497] = 4349,
  [4498] = 4345,
  [4499] = 4333,
  [4500] = 4500,
  [4501] = 4337,
  [4502] = 4371,
  [4503] = 4327,
  [4504] = 4325,
  [4505] = 4368,
  [4506] = 4323,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4320,
  [4510] = 4319,
  [4511] = 4318,
  [4512] = 4337,
  [4513] = 4363,
  [4514] = 4292,
  [4515] = 4351,
  [4516] = 4350,
  [4517] = 4349,
  [4518] = 4333,
  [4519] = 4327,
  [4520] = 4364,
  [4521] = 4352,
  [4522] = 4325,
  [4523] = 4365,
  [4524] = 4355,
  [4525] = 4356,
  [4526] = 4361,
  [4527] = 4527,
  [4528] = 4366,
  [4529] = 4323,
  [4530] = 4368,
  [4531] = 4320,
  [4532] = 4301,
  [4533] = 4294,
  [4534] = 4312,
  [4535] = 4311,
  [4536] = 4310,
  [4537] = 4309,
  [4538] = 4308,
  [4539] = 4371,
  [4540] = 4307,
  [4541] = 4306,
  [4542] = 4319,
  [4543] = 4303,
  [4544] = 4544,
  [4545] = 4302,
  [4546] = 4546,
  [4547] = 4318,
  [4548] = 4294,
  [4549] = 4291,
  [4550] = 4406,
  [4551] = 4312,
  [4552] = 4311,
  [4553] = 4300,
  [4554] = 4310,
  [4555] = 4309,
  [4556] = 4298,
  [4557] = 4308,
  [4558] = 4307,
  [4559] = 4306,
  [4560] = 4371,
  [4561] = 4366,
  [4562] = 4562,
  [4563] = 4563,
  [4564] = 4564,
  [4565] = 4305,
  [4566] = 4303,
  [4567] = 4365,
  [4568] = 4460,
  [4569] = 4569,
  [4570] = 4368,
  [4571] = 4302,
  [4572] = 4328,
  [4573] = 4300,
  [4574] = 4364,
  [4575] = 4362,
  [4576] = 4297,
  [4577] = 4363,
  [4578] = 4361,
  [4579] = 4356,
  [4580] = 4355,
  [4581] = 4581,
  [4582] = 4286,
  [4583] = 4286,
  [4584] = 4297,
  [4585] = 4302,
  [4586] = 4303,
  [4587] = 4361,
  [4588] = 4363,
  [4589] = 4362,
  [4590] = 4356,
  [4591] = 4362,
  [4592] = 4289,
  [4593] = 4363,
  [4594] = 4305,
  [4595] = 4355,
  [4596] = 4306,
  [4597] = 4307,
  [4598] = 4460,
  [4599] = 4308,
  [4600] = 4366,
  [4601] = 4352,
  [4602] = 4309,
  [4603] = 4291,
  [4604] = 4361,
  [4605] = 4356,
  [4606] = 4355,
  [4607] = 4292,
  [4608] = 4310,
  [4609] = 4413,
  [4610] = 4287,
  [4611] = 4402,
  [4612] = 4612,
  [4613] = 4286,
  [4614] = 4297,
  [4615] = 4297,
  [4616] = 4294,
  [4617] = 4286,
  [4618] = 4311,
  [4619] = 4619,
  [4620] = 4620,
  [4621] = 4460,
  [4622] = 4337,
  [4623] = 4410,
  [4624] = 4292,
  [4625] = 4625,
  [4626] = 4460,
  [4627] = 4292,
  [4628] = 4460,
  [4629] = 4312,
  [4630] = 4460,
  [4631] = 4337,
  [4632] = 4632,
  [4633] = 4287,
  [4634] = 4634,
  [4635] = 4635,
  [4636] = 4368,
  [4637] = 4297,
  [4638] = 4459,
  [4639] = 4291,
  [4640] = 4640,
  [4641] = 4641,
  [4642] = 4642,
  [4643] = 4366,
  [4644] = 4634,
  [4645] = 4365,
  [4646] = 4417,
  [4647] = 4364,
  [4648] = 4304,
  [4649] = 4419,
  [4650] = 4440,
  [4651] = 4651,
  [4652] = 4328,
  [4653] = 4351,
  [4654] = 4350,
  [4655] = 4349,
  [4656] = 4333,
  [4657] = 4657,
  [4658] = 4327,
  [4659] = 4373,
  [4660] = 4325,
  [4661] = 4632,
  [4662] = 4323,
  [4663] = 4320,
  [4664] = 4460,
  [4665] = 4665,
  [4666] = 4319,
  [4667] = 4385,
  [4668] = 4460,
  [4669] = 4318,
  [4670] = 4670,
  [4671] = 4671,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym__glimmer_template_content_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(256);
      if (lookahead == '$') ADVANCE(243);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(190);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(229);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(95)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(244);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '/') ADVANCE(126);
      if (lookahead == '<') ADVANCE(128);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(127);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(30)
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(94);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(230);
      if (lookahead != 0) ADVANCE(231);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(4)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(244);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(135);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(28);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(244);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(135);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || ':' < lookahead) &&
          lookahead != ']') ADVANCE(244);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(28);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(244);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(28);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(12)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(182);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(13)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(58);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(244);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(16)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(244);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '/') ADVANCE(209);
      if (lookahead == '\\') ADVANCE(59);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(212);
      if (lookahead != 0) ADVANCE(213);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(18)
      if (lookahead != 0 &&
          lookahead > '"' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '?') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '?') ADVANCE(32);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(39);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 22:
      if (lookahead == '$') ADVANCE(60);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '`') ADVANCE(39);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '\\') ADVANCE(59);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0) ADVANCE(219);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(201);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(162);
      END_STATE();
    case 30:
      if (lookahead == '/') ADVANCE(24);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(30)
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(251);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(252);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(129);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(130);
      END_STATE();
    case 36:
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 37:
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == '\\') ADVANCE(58);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 39:
      if (lookahead == '`') ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == '`') ADVANCE(257);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(49);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(51);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(52);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(48);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(223);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(64);
      if (lookahead == 'x') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(223);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 60:
      if (lookahead == '{') ADVANCE(228);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 62:
      if (lookahead == '{') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 63:
      if (lookahead == '{') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 64:
      if (lookahead == '{') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '}') ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '}') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      if (lookahead == '}') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 70:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(236);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(237);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(239);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(220);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(238);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(221);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 93:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 94:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(231);
      END_STATE();
    case 95:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(256);
      if (lookahead == '$') ADVANCE(243);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(190);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(95)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(244);
      END_STATE();
    case 96:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(14);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(96)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ']') ADVANCE(244);
      END_STATE();
    case 97:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(97)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 98:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(98)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(244);
      END_STATE();
    case 99:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(99)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || '+' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 100:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(229);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(101)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 101:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(101)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 102:
      if (eof) ADVANCE(104);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(102)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(244);
      END_STATE();
    case 103:
      if (eof) ADVANCE(104);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(248);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(103)
      if (lookahead != 0 &&
          lookahead > '"' &&
          (lookahead < '%' || '9' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(194);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(193);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(253);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(198);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(196);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(126);
      if (lookahead == '<') ADVANCE(128);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(125);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(55);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(195);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(195);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(200);
      if (lookahead == '>') ADVANCE(167);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(200);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(163);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '|') ADVANCE(166);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '|') ADVANCE(166);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(165);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(165);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      if (lookahead == '=') ADVANCE(148);
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(211);
      if (lookahead == '/') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(210);
      if (lookahead == '/') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(209);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(215);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(57);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(244);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(220);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(222);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '`') ADVANCE(40);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(30)
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(94);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(230);
      if (lookahead != 0) ADVANCE(231);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(231);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(57);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(244);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '0') ADVANCE(239);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(71);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(78);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'n') ADVANCE(233);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == '_') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(70);
      if (lookahead == 'n') ADVANCE(233);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(78);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(238);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(239);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (lookahead == '_') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '{') ADVANCE(228);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(244);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(57);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(58);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(202);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(201);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(105);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BQUOTE_BQUOTE_BQUOTE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'v') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(36);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 'u') ADVANCE(42);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 8:
      if (lookahead == 'd') ADVANCE(45);
      if (lookahead == 'f') ADVANCE(46);
      if (lookahead == 'm') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(48);
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'e') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(56);
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == 'n') ADVANCE(58);
      if (lookahead == 'v') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(63);
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 't') ADVANCE(65);
      if (lookahead == 'u') ADVANCE(66);
      if (lookahead == 'w') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'h') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(73);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(80);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 'y') ADVANCE(82);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(86);
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(89);
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(91);
      if (lookahead == 'c') ADVANCE(92);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 37:
      if (lookahead == 'l') ADVANCE(100);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(106);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_id);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(108);
      if (lookahead == 's') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 50:
      if (lookahead == 'y') ADVANCE(111);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(113);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 54:
      if (lookahead == 'v') ADVANCE(115);
      if (lookahead == 'w') ADVANCE(116);
      END_STATE();
    case 55:
      if (lookahead == 'l') ADVANCE(117);
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 56:
      if (lookahead == 'j') ADVANCE(119);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(121);
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(124);
      if (lookahead == 'q') ADVANCE(125);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(129);
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 66:
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 68:
      if (lookahead == 'm') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(137);
      if (lookahead == 'y') ADVANCE(138);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(139);
      END_STATE();
    case 73:
      if (lookahead == 'd') ADVANCE(140);
      if (lookahead == 'k') ADVANCE(141);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(142);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(144);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(149);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(150);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(154);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(155);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 92:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(164);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 98:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 100:
      if (lookahead == 's') ADVANCE(168);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(169);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 103:
      if (lookahead == 'm') ADVANCE(170);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(172);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(173);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(178);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(179);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(182);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(183);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 121:
      if (lookahead == 'v') ADVANCE(186);
      END_STATE();
    case 122:
      if (lookahead == 'p') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(191);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(193);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 133:
      if (lookahead == 'b') ADVANCE(198);
      END_STATE();
    case 134:
      if (lookahead == 'g') ADVANCE(199);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(200);
      END_STATE();
    case 136:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 143:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 145:
      if (lookahead == 'h') ADVANCE(208);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(209);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 149:
      if (lookahead == 'c') ADVANCE(212);
      END_STATE();
    case 150:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 152:
      if (lookahead == 'k') ADVANCE(215);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 154:
      if (lookahead == 'h') ADVANCE(216);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 156:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 159:
      if (lookahead == 'g') ADVANCE(221);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 161:
      if (lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 167:
      if (lookahead == 'n') ADVANCE(227);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(229);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(231);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(236);
      END_STATE();
    case 178:
      if (lookahead == 'f') ADVANCE(237);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 180:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(240);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 184:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_prop);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(246);
      END_STATE();
    case 190:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 191:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 193:
      if (lookahead == 's') ADVANCE(250);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(251);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 196:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 197:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(255);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 201:
      if (lookahead == 'w') ADVANCE(257);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(258);
      END_STATE();
    case 204:
      if (lookahead == 'f') ADVANCE(259);
      END_STATE();
    case 205:
      if (lookahead == 'o') ADVANCE(260);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(262);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(263);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 214:
      if (lookahead == 'a') ADVANCE(265);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'r') ADVANCE(267);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 221:
      if (lookahead == 'g') ADVANCE(269);
      END_STATE();
    case 222:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 223:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 227:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 231:
      if (lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 232:
      if (lookahead == 'm') ADVANCE(278);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 236:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 239:
      if (lookahead == 'p') ADVANCE(283);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 243:
      if (lookahead == 'i') ADVANCE(286);
      END_STATE();
    case 244:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 245:
      if (lookahead == 'c') ADVANCE(288);
      END_STATE();
    case 246:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 250:
      if (lookahead == 'f') ADVANCE(293);
      END_STATE();
    case 251:
      if (lookahead == 'c') ADVANCE(294);
      END_STATE();
    case 252:
      if (lookahead == 'g') ADVANCE(295);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 254:
      if (lookahead == 'h') ADVANCE(296);
      END_STATE();
    case 255:
      if (lookahead == 'l') ADVANCE(297);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(298);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 258:
      if (lookahead == 'f') ADVANCE(299);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(300);
      END_STATE();
    case 260:
      if (lookahead == 'w') ADVANCE(301);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(302);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(303);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 266:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 267:
      if (lookahead == 'u') ADVANCE(306);
      END_STATE();
    case 268:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(310);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 274:
      if (lookahead == 's') ADVANCE(311);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(312);
      END_STATE();
    case 276:
      if (lookahead == 'o') ADVANCE(313);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(316);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 283:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(318);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 290:
      if (lookahead == 'l') ADVANCE(321);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(323);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 300:
      if (lookahead == 'n') ADVANCE(324);
      END_STATE();
    case 301:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 302:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(327);
      END_STATE();
    case 306:
      if (lookahead == 'c') ADVANCE(328);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(329);
      END_STATE();
    case 308:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(332);
      END_STATE();
    case 315:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 316:
      if (lookahead == 'c') ADVANCE(334);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 321:
      if (lookahead == 'y') ADVANCE(338);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(339);
      END_STATE();
    case 324:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(341);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(343);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_instance);
      if (lookahead == 'o') ADVANCE(344);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(346);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 337:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 339:
      if (lookahead == 's') ADVANCE(348);
      END_STATE();
    case 340:
      if (lookahead == 'd') ADVANCE(349);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_component);
      END_STATE();
    case 342:
      if (lookahead == 'o') ADVANCE(350);
      END_STATE();
    case 343:
      if (lookahead == 's') ADVANCE(351);
      END_STATE();
    case 344:
      if (lookahead == 'f') ADVANCE(352);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 350:
      if (lookahead == 'r') ADVANCE(353);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 96},
  [2] = {.lex_state = 96, .external_lex_state = 2},
  [3] = {.lex_state = 96, .external_lex_state = 2},
  [4] = {.lex_state = 98},
  [5] = {.lex_state = 98},
  [6] = {.lex_state = 98},
  [7] = {.lex_state = 98},
  [8] = {.lex_state = 98},
  [9] = {.lex_state = 98},
  [10] = {.lex_state = 98},
  [11] = {.lex_state = 98},
  [12] = {.lex_state = 98},
  [13] = {.lex_state = 98},
  [14] = {.lex_state = 98},
  [15] = {.lex_state = 98},
  [16] = {.lex_state = 98},
  [17] = {.lex_state = 98},
  [18] = {.lex_state = 98},
  [19] = {.lex_state = 98},
  [20] = {.lex_state = 98},
  [21] = {.lex_state = 98},
  [22] = {.lex_state = 98},
  [23] = {.lex_state = 98},
  [24] = {.lex_state = 98},
  [25] = {.lex_state = 98},
  [26] = {.lex_state = 98},
  [27] = {.lex_state = 98},
  [28] = {.lex_state = 98},
  [29] = {.lex_state = 98},
  [30] = {.lex_state = 98},
  [31] = {.lex_state = 98},
  [32] = {.lex_state = 98},
  [33] = {.lex_state = 98},
  [34] = {.lex_state = 98},
  [35] = {.lex_state = 98},
  [36] = {.lex_state = 98},
  [37] = {.lex_state = 98},
  [38] = {.lex_state = 98},
  [39] = {.lex_state = 98},
  [40] = {.lex_state = 98},
  [41] = {.lex_state = 98},
  [42] = {.lex_state = 98},
  [43] = {.lex_state = 98},
  [44] = {.lex_state = 98},
  [45] = {.lex_state = 98},
  [46] = {.lex_state = 98},
  [47] = {.lex_state = 98},
  [48] = {.lex_state = 98},
  [49] = {.lex_state = 98},
  [50] = {.lex_state = 98},
  [51] = {.lex_state = 98},
  [52] = {.lex_state = 98},
  [53] = {.lex_state = 98},
  [54] = {.lex_state = 4, .external_lex_state = 2},
  [55] = {.lex_state = 4, .external_lex_state = 2},
  [56] = {.lex_state = 4, .external_lex_state = 2},
  [57] = {.lex_state = 4, .external_lex_state = 2},
  [58] = {.lex_state = 4, .external_lex_state = 2},
  [59] = {.lex_state = 4, .external_lex_state = 2},
  [60] = {.lex_state = 4, .external_lex_state = 2},
  [61] = {.lex_state = 4, .external_lex_state = 2},
  [62] = {.lex_state = 15},
  [63] = {.lex_state = 15},
  [64] = {.lex_state = 15},
  [65] = {.lex_state = 15},
  [66] = {.lex_state = 15},
  [67] = {.lex_state = 15},
  [68] = {.lex_state = 15},
  [69] = {.lex_state = 15},
  [70] = {.lex_state = 15},
  [71] = {.lex_state = 15},
  [72] = {.lex_state = 15},
  [73] = {.lex_state = 15},
  [74] = {.lex_state = 15},
  [75] = {.lex_state = 15},
  [76] = {.lex_state = 15},
  [77] = {.lex_state = 7, .external_lex_state = 2},
  [78] = {.lex_state = 7, .external_lex_state = 2},
  [79] = {.lex_state = 15},
  [80] = {.lex_state = 15},
  [81] = {.lex_state = 15},
  [82] = {.lex_state = 15},
  [83] = {.lex_state = 15},
  [84] = {.lex_state = 6, .external_lex_state = 2},
  [85] = {.lex_state = 6, .external_lex_state = 3},
  [86] = {.lex_state = 6, .external_lex_state = 3},
  [87] = {.lex_state = 6, .external_lex_state = 2},
  [88] = {.lex_state = 6, .external_lex_state = 2},
  [89] = {.lex_state = 98},
  [90] = {.lex_state = 98},
  [91] = {.lex_state = 3, .external_lex_state = 2},
  [92] = {.lex_state = 98},
  [93] = {.lex_state = 3, .external_lex_state = 2},
  [94] = {.lex_state = 98},
  [95] = {.lex_state = 98},
  [96] = {.lex_state = 98},
  [97] = {.lex_state = 98},
  [98] = {.lex_state = 98},
  [99] = {.lex_state = 98},
  [100] = {.lex_state = 3, .external_lex_state = 2},
  [101] = {.lex_state = 3, .external_lex_state = 2},
  [102] = {.lex_state = 98},
  [103] = {.lex_state = 3, .external_lex_state = 2},
  [104] = {.lex_state = 98},
  [105] = {.lex_state = 98},
  [106] = {.lex_state = 3, .external_lex_state = 2},
  [107] = {.lex_state = 98},
  [108] = {.lex_state = 98},
  [109] = {.lex_state = 98},
  [110] = {.lex_state = 98},
  [111] = {.lex_state = 98},
  [112] = {.lex_state = 98},
  [113] = {.lex_state = 98},
  [114] = {.lex_state = 98},
  [115] = {.lex_state = 98},
  [116] = {.lex_state = 98},
  [117] = {.lex_state = 98},
  [118] = {.lex_state = 98},
  [119] = {.lex_state = 98},
  [120] = {.lex_state = 98},
  [121] = {.lex_state = 98, .external_lex_state = 4},
  [122] = {.lex_state = 98},
  [123] = {.lex_state = 98},
  [124] = {.lex_state = 98},
  [125] = {.lex_state = 98},
  [126] = {.lex_state = 98},
  [127] = {.lex_state = 98},
  [128] = {.lex_state = 98},
  [129] = {.lex_state = 98},
  [130] = {.lex_state = 98},
  [131] = {.lex_state = 3, .external_lex_state = 2},
  [132] = {.lex_state = 98},
  [133] = {.lex_state = 98},
  [134] = {.lex_state = 98},
  [135] = {.lex_state = 6, .external_lex_state = 3},
  [136] = {.lex_state = 98},
  [137] = {.lex_state = 98},
  [138] = {.lex_state = 98},
  [139] = {.lex_state = 98},
  [140] = {.lex_state = 98},
  [141] = {.lex_state = 3, .external_lex_state = 2},
  [142] = {.lex_state = 98},
  [143] = {.lex_state = 98},
  [144] = {.lex_state = 6, .external_lex_state = 3},
  [145] = {.lex_state = 6, .external_lex_state = 3},
  [146] = {.lex_state = 6, .external_lex_state = 3},
  [147] = {.lex_state = 3, .external_lex_state = 2},
  [148] = {.lex_state = 3, .external_lex_state = 2},
  [149] = {.lex_state = 6, .external_lex_state = 3},
  [150] = {.lex_state = 6, .external_lex_state = 3},
  [151] = {.lex_state = 6, .external_lex_state = 3},
  [152] = {.lex_state = 6, .external_lex_state = 3},
  [153] = {.lex_state = 6, .external_lex_state = 3},
  [154] = {.lex_state = 6, .external_lex_state = 3},
  [155] = {.lex_state = 6, .external_lex_state = 3},
  [156] = {.lex_state = 6, .external_lex_state = 3},
  [157] = {.lex_state = 6, .external_lex_state = 3},
  [158] = {.lex_state = 6, .external_lex_state = 3},
  [159] = {.lex_state = 6, .external_lex_state = 3},
  [160] = {.lex_state = 98},
  [161] = {.lex_state = 6, .external_lex_state = 3},
  [162] = {.lex_state = 6, .external_lex_state = 3},
  [163] = {.lex_state = 6, .external_lex_state = 3},
  [164] = {.lex_state = 6, .external_lex_state = 3},
  [165] = {.lex_state = 98},
  [166] = {.lex_state = 6, .external_lex_state = 3},
  [167] = {.lex_state = 6, .external_lex_state = 3},
  [168] = {.lex_state = 98},
  [169] = {.lex_state = 6, .external_lex_state = 3},
  [170] = {.lex_state = 6, .external_lex_state = 3},
  [171] = {.lex_state = 98},
  [172] = {.lex_state = 98},
  [173] = {.lex_state = 98},
  [174] = {.lex_state = 6, .external_lex_state = 3},
  [175] = {.lex_state = 6, .external_lex_state = 3},
  [176] = {.lex_state = 6, .external_lex_state = 3},
  [177] = {.lex_state = 6, .external_lex_state = 3},
  [178] = {.lex_state = 6, .external_lex_state = 3},
  [179] = {.lex_state = 98},
  [180] = {.lex_state = 98},
  [181] = {.lex_state = 98},
  [182] = {.lex_state = 98},
  [183] = {.lex_state = 98},
  [184] = {.lex_state = 98},
  [185] = {.lex_state = 98},
  [186] = {.lex_state = 98},
  [187] = {.lex_state = 98},
  [188] = {.lex_state = 98, .external_lex_state = 4},
  [189] = {.lex_state = 98},
  [190] = {.lex_state = 98},
  [191] = {.lex_state = 98},
  [192] = {.lex_state = 98},
  [193] = {.lex_state = 98},
  [194] = {.lex_state = 98},
  [195] = {.lex_state = 98},
  [196] = {.lex_state = 98},
  [197] = {.lex_state = 98},
  [198] = {.lex_state = 98},
  [199] = {.lex_state = 98},
  [200] = {.lex_state = 98},
  [201] = {.lex_state = 98},
  [202] = {.lex_state = 98},
  [203] = {.lex_state = 98},
  [204] = {.lex_state = 98},
  [205] = {.lex_state = 98},
  [206] = {.lex_state = 98},
  [207] = {.lex_state = 98},
  [208] = {.lex_state = 98},
  [209] = {.lex_state = 98},
  [210] = {.lex_state = 98},
  [211] = {.lex_state = 98},
  [212] = {.lex_state = 98},
  [213] = {.lex_state = 98},
  [214] = {.lex_state = 98},
  [215] = {.lex_state = 16},
  [216] = {.lex_state = 98},
  [217] = {.lex_state = 98},
  [218] = {.lex_state = 16},
  [219] = {.lex_state = 4, .external_lex_state = 2},
  [220] = {.lex_state = 4, .external_lex_state = 2},
  [221] = {.lex_state = 98},
  [222] = {.lex_state = 98},
  [223] = {.lex_state = 98},
  [224] = {.lex_state = 98},
  [225] = {.lex_state = 16},
  [226] = {.lex_state = 98},
  [227] = {.lex_state = 98},
  [228] = {.lex_state = 16},
  [229] = {.lex_state = 98},
  [230] = {.lex_state = 98},
  [231] = {.lex_state = 98},
  [232] = {.lex_state = 98},
  [233] = {.lex_state = 98},
  [234] = {.lex_state = 98},
  [235] = {.lex_state = 16},
  [236] = {.lex_state = 98},
  [237] = {.lex_state = 98},
  [238] = {.lex_state = 16},
  [239] = {.lex_state = 16},
  [240] = {.lex_state = 98},
  [241] = {.lex_state = 98},
  [242] = {.lex_state = 16},
  [243] = {.lex_state = 98},
  [244] = {.lex_state = 98},
  [245] = {.lex_state = 98},
  [246] = {.lex_state = 98},
  [247] = {.lex_state = 98},
  [248] = {.lex_state = 98},
  [249] = {.lex_state = 98},
  [250] = {.lex_state = 98},
  [251] = {.lex_state = 16},
  [252] = {.lex_state = 4, .external_lex_state = 2},
  [253] = {.lex_state = 98},
  [254] = {.lex_state = 16},
  [255] = {.lex_state = 98},
  [256] = {.lex_state = 98},
  [257] = {.lex_state = 98},
  [258] = {.lex_state = 98},
  [259] = {.lex_state = 4, .external_lex_state = 2},
  [260] = {.lex_state = 98},
  [261] = {.lex_state = 16},
  [262] = {.lex_state = 98},
  [263] = {.lex_state = 98},
  [264] = {.lex_state = 98},
  [265] = {.lex_state = 98},
  [266] = {.lex_state = 98},
  [267] = {.lex_state = 98},
  [268] = {.lex_state = 98},
  [269] = {.lex_state = 98},
  [270] = {.lex_state = 98},
  [271] = {.lex_state = 98},
  [272] = {.lex_state = 98},
  [273] = {.lex_state = 98},
  [274] = {.lex_state = 98},
  [275] = {.lex_state = 98},
  [276] = {.lex_state = 98},
  [277] = {.lex_state = 98},
  [278] = {.lex_state = 98},
  [279] = {.lex_state = 98},
  [280] = {.lex_state = 98},
  [281] = {.lex_state = 98},
  [282] = {.lex_state = 98},
  [283] = {.lex_state = 98},
  [284] = {.lex_state = 98},
  [285] = {.lex_state = 98},
  [286] = {.lex_state = 98},
  [287] = {.lex_state = 98},
  [288] = {.lex_state = 16},
  [289] = {.lex_state = 98},
  [290] = {.lex_state = 98},
  [291] = {.lex_state = 98},
  [292] = {.lex_state = 98},
  [293] = {.lex_state = 98},
  [294] = {.lex_state = 98},
  [295] = {.lex_state = 98},
  [296] = {.lex_state = 98},
  [297] = {.lex_state = 98},
  [298] = {.lex_state = 98},
  [299] = {.lex_state = 98},
  [300] = {.lex_state = 98},
  [301] = {.lex_state = 98},
  [302] = {.lex_state = 98},
  [303] = {.lex_state = 98},
  [304] = {.lex_state = 98},
  [305] = {.lex_state = 98},
  [306] = {.lex_state = 98},
  [307] = {.lex_state = 98},
  [308] = {.lex_state = 98},
  [309] = {.lex_state = 98},
  [310] = {.lex_state = 98},
  [311] = {.lex_state = 98},
  [312] = {.lex_state = 98},
  [313] = {.lex_state = 98},
  [314] = {.lex_state = 98},
  [315] = {.lex_state = 98},
  [316] = {.lex_state = 98},
  [317] = {.lex_state = 98},
  [318] = {.lex_state = 98},
  [319] = {.lex_state = 98},
  [320] = {.lex_state = 98},
  [321] = {.lex_state = 98},
  [322] = {.lex_state = 98},
  [323] = {.lex_state = 98},
  [324] = {.lex_state = 98},
  [325] = {.lex_state = 98},
  [326] = {.lex_state = 98},
  [327] = {.lex_state = 98},
  [328] = {.lex_state = 98},
  [329] = {.lex_state = 98},
  [330] = {.lex_state = 98},
  [331] = {.lex_state = 98},
  [332] = {.lex_state = 98},
  [333] = {.lex_state = 98},
  [334] = {.lex_state = 98},
  [335] = {.lex_state = 98},
  [336] = {.lex_state = 98},
  [337] = {.lex_state = 98},
  [338] = {.lex_state = 98},
  [339] = {.lex_state = 98},
  [340] = {.lex_state = 98},
  [341] = {.lex_state = 98},
  [342] = {.lex_state = 98},
  [343] = {.lex_state = 98},
  [344] = {.lex_state = 98},
  [345] = {.lex_state = 98},
  [346] = {.lex_state = 98},
  [347] = {.lex_state = 98},
  [348] = {.lex_state = 98},
  [349] = {.lex_state = 98},
  [350] = {.lex_state = 98},
  [351] = {.lex_state = 98},
  [352] = {.lex_state = 98},
  [353] = {.lex_state = 98},
  [354] = {.lex_state = 98},
  [355] = {.lex_state = 98},
  [356] = {.lex_state = 98},
  [357] = {.lex_state = 98},
  [358] = {.lex_state = 98},
  [359] = {.lex_state = 98},
  [360] = {.lex_state = 98},
  [361] = {.lex_state = 98},
  [362] = {.lex_state = 98},
  [363] = {.lex_state = 98},
  [364] = {.lex_state = 98},
  [365] = {.lex_state = 98},
  [366] = {.lex_state = 98},
  [367] = {.lex_state = 98},
  [368] = {.lex_state = 98},
  [369] = {.lex_state = 98},
  [370] = {.lex_state = 98},
  [371] = {.lex_state = 98},
  [372] = {.lex_state = 98},
  [373] = {.lex_state = 98},
  [374] = {.lex_state = 98},
  [375] = {.lex_state = 98},
  [376] = {.lex_state = 98},
  [377] = {.lex_state = 98},
  [378] = {.lex_state = 98},
  [379] = {.lex_state = 98},
  [380] = {.lex_state = 98},
  [381] = {.lex_state = 98},
  [382] = {.lex_state = 98},
  [383] = {.lex_state = 98},
  [384] = {.lex_state = 98},
  [385] = {.lex_state = 98},
  [386] = {.lex_state = 98},
  [387] = {.lex_state = 98},
  [388] = {.lex_state = 98},
  [389] = {.lex_state = 98},
  [390] = {.lex_state = 98},
  [391] = {.lex_state = 98},
  [392] = {.lex_state = 98},
  [393] = {.lex_state = 98},
  [394] = {.lex_state = 98},
  [395] = {.lex_state = 98},
  [396] = {.lex_state = 98},
  [397] = {.lex_state = 98},
  [398] = {.lex_state = 98},
  [399] = {.lex_state = 98},
  [400] = {.lex_state = 98},
  [401] = {.lex_state = 98},
  [402] = {.lex_state = 98},
  [403] = {.lex_state = 98},
  [404] = {.lex_state = 98},
  [405] = {.lex_state = 98},
  [406] = {.lex_state = 98},
  [407] = {.lex_state = 98},
  [408] = {.lex_state = 98},
  [409] = {.lex_state = 98},
  [410] = {.lex_state = 98},
  [411] = {.lex_state = 98},
  [412] = {.lex_state = 98},
  [413] = {.lex_state = 98},
  [414] = {.lex_state = 98},
  [415] = {.lex_state = 98},
  [416] = {.lex_state = 98},
  [417] = {.lex_state = 98},
  [418] = {.lex_state = 98},
  [419] = {.lex_state = 98},
  [420] = {.lex_state = 98},
  [421] = {.lex_state = 98},
  [422] = {.lex_state = 98},
  [423] = {.lex_state = 98},
  [424] = {.lex_state = 98},
  [425] = {.lex_state = 98},
  [426] = {.lex_state = 98},
  [427] = {.lex_state = 98},
  [428] = {.lex_state = 98},
  [429] = {.lex_state = 98},
  [430] = {.lex_state = 98},
  [431] = {.lex_state = 98},
  [432] = {.lex_state = 98},
  [433] = {.lex_state = 98},
  [434] = {.lex_state = 98},
  [435] = {.lex_state = 98},
  [436] = {.lex_state = 98},
  [437] = {.lex_state = 98},
  [438] = {.lex_state = 98},
  [439] = {.lex_state = 98},
  [440] = {.lex_state = 98},
  [441] = {.lex_state = 98},
  [442] = {.lex_state = 98},
  [443] = {.lex_state = 98},
  [444] = {.lex_state = 98},
  [445] = {.lex_state = 98},
  [446] = {.lex_state = 98},
  [447] = {.lex_state = 98},
  [448] = {.lex_state = 98},
  [449] = {.lex_state = 98},
  [450] = {.lex_state = 98},
  [451] = {.lex_state = 98},
  [452] = {.lex_state = 98},
  [453] = {.lex_state = 98},
  [454] = {.lex_state = 98},
  [455] = {.lex_state = 98},
  [456] = {.lex_state = 98},
  [457] = {.lex_state = 98},
  [458] = {.lex_state = 98},
  [459] = {.lex_state = 98},
  [460] = {.lex_state = 98},
  [461] = {.lex_state = 98},
  [462] = {.lex_state = 98},
  [463] = {.lex_state = 98},
  [464] = {.lex_state = 98},
  [465] = {.lex_state = 98},
  [466] = {.lex_state = 98},
  [467] = {.lex_state = 98},
  [468] = {.lex_state = 5, .external_lex_state = 2},
  [469] = {.lex_state = 5, .external_lex_state = 2},
  [470] = {.lex_state = 5, .external_lex_state = 2},
  [471] = {.lex_state = 5, .external_lex_state = 2},
  [472] = {.lex_state = 97, .external_lex_state = 3},
  [473] = {.lex_state = 97, .external_lex_state = 3},
  [474] = {.lex_state = 97, .external_lex_state = 3},
  [475] = {.lex_state = 3, .external_lex_state = 2},
  [476] = {.lex_state = 3, .external_lex_state = 2},
  [477] = {.lex_state = 3, .external_lex_state = 3},
  [478] = {.lex_state = 3, .external_lex_state = 2},
  [479] = {.lex_state = 3, .external_lex_state = 2},
  [480] = {.lex_state = 3, .external_lex_state = 2},
  [481] = {.lex_state = 3, .external_lex_state = 2},
  [482] = {.lex_state = 3, .external_lex_state = 2},
  [483] = {.lex_state = 3, .external_lex_state = 2},
  [484] = {.lex_state = 3, .external_lex_state = 2},
  [485] = {.lex_state = 3, .external_lex_state = 3},
  [486] = {.lex_state = 3, .external_lex_state = 2},
  [487] = {.lex_state = 3, .external_lex_state = 3},
  [488] = {.lex_state = 97, .external_lex_state = 3},
  [489] = {.lex_state = 3, .external_lex_state = 2},
  [490] = {.lex_state = 3, .external_lex_state = 2},
  [491] = {.lex_state = 3, .external_lex_state = 2},
  [492] = {.lex_state = 97, .external_lex_state = 3},
  [493] = {.lex_state = 100},
  [494] = {.lex_state = 100},
  [495] = {.lex_state = 100},
  [496] = {.lex_state = 100},
  [497] = {.lex_state = 100},
  [498] = {.lex_state = 3, .external_lex_state = 2},
  [499] = {.lex_state = 100},
  [500] = {.lex_state = 100},
  [501] = {.lex_state = 3, .external_lex_state = 2},
  [502] = {.lex_state = 100},
  [503] = {.lex_state = 100},
  [504] = {.lex_state = 100},
  [505] = {.lex_state = 100},
  [506] = {.lex_state = 3, .external_lex_state = 3},
  [507] = {.lex_state = 3, .external_lex_state = 3},
  [508] = {.lex_state = 3, .external_lex_state = 2},
  [509] = {.lex_state = 3, .external_lex_state = 3},
  [510] = {.lex_state = 3, .external_lex_state = 3},
  [511] = {.lex_state = 3, .external_lex_state = 3},
  [512] = {.lex_state = 3, .external_lex_state = 3},
  [513] = {.lex_state = 3, .external_lex_state = 3},
  [514] = {.lex_state = 3, .external_lex_state = 3},
  [515] = {.lex_state = 3, .external_lex_state = 3},
  [516] = {.lex_state = 3, .external_lex_state = 3},
  [517] = {.lex_state = 3, .external_lex_state = 3},
  [518] = {.lex_state = 3, .external_lex_state = 3},
  [519] = {.lex_state = 3, .external_lex_state = 3},
  [520] = {.lex_state = 3, .external_lex_state = 3},
  [521] = {.lex_state = 3, .external_lex_state = 3},
  [522] = {.lex_state = 100},
  [523] = {.lex_state = 100},
  [524] = {.lex_state = 100},
  [525] = {.lex_state = 100},
  [526] = {.lex_state = 100},
  [527] = {.lex_state = 100},
  [528] = {.lex_state = 100},
  [529] = {.lex_state = 16},
  [530] = {.lex_state = 100},
  [531] = {.lex_state = 100},
  [532] = {.lex_state = 97, .external_lex_state = 2},
  [533] = {.lex_state = 97, .external_lex_state = 2},
  [534] = {.lex_state = 97, .external_lex_state = 2},
  [535] = {.lex_state = 97, .external_lex_state = 2},
  [536] = {.lex_state = 97, .external_lex_state = 2},
  [537] = {.lex_state = 97, .external_lex_state = 3},
  [538] = {.lex_state = 97, .external_lex_state = 3},
  [539] = {.lex_state = 98},
  [540] = {.lex_state = 97, .external_lex_state = 3},
  [541] = {.lex_state = 97, .external_lex_state = 3},
  [542] = {.lex_state = 97, .external_lex_state = 3},
  [543] = {.lex_state = 97, .external_lex_state = 3},
  [544] = {.lex_state = 97, .external_lex_state = 3},
  [545] = {.lex_state = 98, .external_lex_state = 4},
  [546] = {.lex_state = 97, .external_lex_state = 2},
  [547] = {.lex_state = 16},
  [548] = {.lex_state = 98, .external_lex_state = 4},
  [549] = {.lex_state = 16},
  [550] = {.lex_state = 98, .external_lex_state = 4},
  [551] = {.lex_state = 98, .external_lex_state = 4},
  [552] = {.lex_state = 98, .external_lex_state = 4},
  [553] = {.lex_state = 97, .external_lex_state = 2},
  [554] = {.lex_state = 97, .external_lex_state = 2},
  [555] = {.lex_state = 16},
  [556] = {.lex_state = 16},
  [557] = {.lex_state = 98, .external_lex_state = 4},
  [558] = {.lex_state = 16},
  [559] = {.lex_state = 98, .external_lex_state = 4},
  [560] = {.lex_state = 16},
  [561] = {.lex_state = 98, .external_lex_state = 4},
  [562] = {.lex_state = 98, .external_lex_state = 4},
  [563] = {.lex_state = 16},
  [564] = {.lex_state = 98, .external_lex_state = 4},
  [565] = {.lex_state = 98, .external_lex_state = 4},
  [566] = {.lex_state = 16},
  [567] = {.lex_state = 98},
  [568] = {.lex_state = 97, .external_lex_state = 2},
  [569] = {.lex_state = 98},
  [570] = {.lex_state = 16},
  [571] = {.lex_state = 98},
  [572] = {.lex_state = 98},
  [573] = {.lex_state = 98},
  [574] = {.lex_state = 98},
  [575] = {.lex_state = 10, .external_lex_state = 2},
  [576] = {.lex_state = 98},
  [577] = {.lex_state = 98},
  [578] = {.lex_state = 98},
  [579] = {.lex_state = 98},
  [580] = {.lex_state = 98},
  [581] = {.lex_state = 10, .external_lex_state = 2},
  [582] = {.lex_state = 97, .external_lex_state = 2},
  [583] = {.lex_state = 98},
  [584] = {.lex_state = 97, .external_lex_state = 2},
  [585] = {.lex_state = 16},
  [586] = {.lex_state = 98},
  [587] = {.lex_state = 98},
  [588] = {.lex_state = 98},
  [589] = {.lex_state = 98},
  [590] = {.lex_state = 98},
  [591] = {.lex_state = 98},
  [592] = {.lex_state = 98},
  [593] = {.lex_state = 98, .external_lex_state = 4},
  [594] = {.lex_state = 10, .external_lex_state = 2},
  [595] = {.lex_state = 98, .external_lex_state = 4},
  [596] = {.lex_state = 10, .external_lex_state = 2},
  [597] = {.lex_state = 10, .external_lex_state = 2},
  [598] = {.lex_state = 10, .external_lex_state = 2},
  [599] = {.lex_state = 10, .external_lex_state = 2},
  [600] = {.lex_state = 98},
  [601] = {.lex_state = 10, .external_lex_state = 2},
  [602] = {.lex_state = 10, .external_lex_state = 2},
  [603] = {.lex_state = 10, .external_lex_state = 2},
  [604] = {.lex_state = 10, .external_lex_state = 2},
  [605] = {.lex_state = 10, .external_lex_state = 2},
  [606] = {.lex_state = 10, .external_lex_state = 2},
  [607] = {.lex_state = 10, .external_lex_state = 2},
  [608] = {.lex_state = 10, .external_lex_state = 2},
  [609] = {.lex_state = 10, .external_lex_state = 2},
  [610] = {.lex_state = 98, .external_lex_state = 4},
  [611] = {.lex_state = 10, .external_lex_state = 2},
  [612] = {.lex_state = 98, .external_lex_state = 4},
  [613] = {.lex_state = 98, .external_lex_state = 4},
  [614] = {.lex_state = 10, .external_lex_state = 2},
  [615] = {.lex_state = 10, .external_lex_state = 2},
  [616] = {.lex_state = 10, .external_lex_state = 2},
  [617] = {.lex_state = 10, .external_lex_state = 2},
  [618] = {.lex_state = 98, .external_lex_state = 4},
  [619] = {.lex_state = 98, .external_lex_state = 4},
  [620] = {.lex_state = 98, .external_lex_state = 4},
  [621] = {.lex_state = 10, .external_lex_state = 2},
  [622] = {.lex_state = 10, .external_lex_state = 2},
  [623] = {.lex_state = 10, .external_lex_state = 2},
  [624] = {.lex_state = 98},
  [625] = {.lex_state = 98, .external_lex_state = 4},
  [626] = {.lex_state = 10, .external_lex_state = 2},
  [627] = {.lex_state = 98, .external_lex_state = 4},
  [628] = {.lex_state = 10, .external_lex_state = 2},
  [629] = {.lex_state = 10, .external_lex_state = 2},
  [630] = {.lex_state = 97, .external_lex_state = 2},
  [631] = {.lex_state = 98, .external_lex_state = 4},
  [632] = {.lex_state = 10, .external_lex_state = 2},
  [633] = {.lex_state = 10, .external_lex_state = 2},
  [634] = {.lex_state = 10, .external_lex_state = 2},
  [635] = {.lex_state = 97, .external_lex_state = 2},
  [636] = {.lex_state = 98, .external_lex_state = 4},
  [637] = {.lex_state = 98, .external_lex_state = 4},
  [638] = {.lex_state = 98, .external_lex_state = 4},
  [639] = {.lex_state = 98},
  [640] = {.lex_state = 98},
  [641] = {.lex_state = 10, .external_lex_state = 2},
  [642] = {.lex_state = 10, .external_lex_state = 2},
  [643] = {.lex_state = 10, .external_lex_state = 2},
  [644] = {.lex_state = 10, .external_lex_state = 3},
  [645] = {.lex_state = 10, .external_lex_state = 2},
  [646] = {.lex_state = 16},
  [647] = {.lex_state = 98, .external_lex_state = 4},
  [648] = {.lex_state = 98},
  [649] = {.lex_state = 10, .external_lex_state = 2},
  [650] = {.lex_state = 98, .external_lex_state = 4},
  [651] = {.lex_state = 98, .external_lex_state = 4},
  [652] = {.lex_state = 10, .external_lex_state = 2},
  [653] = {.lex_state = 98},
  [654] = {.lex_state = 98},
  [655] = {.lex_state = 97, .external_lex_state = 2},
  [656] = {.lex_state = 98, .external_lex_state = 4},
  [657] = {.lex_state = 10, .external_lex_state = 2},
  [658] = {.lex_state = 10, .external_lex_state = 2},
  [659] = {.lex_state = 10, .external_lex_state = 2},
  [660] = {.lex_state = 10, .external_lex_state = 2},
  [661] = {.lex_state = 10, .external_lex_state = 2},
  [662] = {.lex_state = 10, .external_lex_state = 3},
  [663] = {.lex_state = 10, .external_lex_state = 2},
  [664] = {.lex_state = 98},
  [665] = {.lex_state = 98},
  [666] = {.lex_state = 98},
  [667] = {.lex_state = 98},
  [668] = {.lex_state = 98},
  [669] = {.lex_state = 10, .external_lex_state = 2},
  [670] = {.lex_state = 98},
  [671] = {.lex_state = 98},
  [672] = {.lex_state = 98},
  [673] = {.lex_state = 98},
  [674] = {.lex_state = 98},
  [675] = {.lex_state = 98},
  [676] = {.lex_state = 98},
  [677] = {.lex_state = 10, .external_lex_state = 2},
  [678] = {.lex_state = 98},
  [679] = {.lex_state = 98},
  [680] = {.lex_state = 98},
  [681] = {.lex_state = 10, .external_lex_state = 2},
  [682] = {.lex_state = 98},
  [683] = {.lex_state = 98},
  [684] = {.lex_state = 98},
  [685] = {.lex_state = 10, .external_lex_state = 2},
  [686] = {.lex_state = 98},
  [687] = {.lex_state = 98},
  [688] = {.lex_state = 10, .external_lex_state = 2},
  [689] = {.lex_state = 98},
  [690] = {.lex_state = 8, .external_lex_state = 2},
  [691] = {.lex_state = 98},
  [692] = {.lex_state = 98},
  [693] = {.lex_state = 98},
  [694] = {.lex_state = 98},
  [695] = {.lex_state = 98},
  [696] = {.lex_state = 98},
  [697] = {.lex_state = 98},
  [698] = {.lex_state = 98},
  [699] = {.lex_state = 10, .external_lex_state = 3},
  [700] = {.lex_state = 98},
  [701] = {.lex_state = 98},
  [702] = {.lex_state = 10, .external_lex_state = 2},
  [703] = {.lex_state = 10, .external_lex_state = 2},
  [704] = {.lex_state = 98},
  [705] = {.lex_state = 98},
  [706] = {.lex_state = 98},
  [707] = {.lex_state = 10, .external_lex_state = 2},
  [708] = {.lex_state = 98},
  [709] = {.lex_state = 10, .external_lex_state = 2},
  [710] = {.lex_state = 10, .external_lex_state = 2},
  [711] = {.lex_state = 10, .external_lex_state = 2},
  [712] = {.lex_state = 10, .external_lex_state = 2},
  [713] = {.lex_state = 98},
  [714] = {.lex_state = 10, .external_lex_state = 3},
  [715] = {.lex_state = 98},
  [716] = {.lex_state = 10, .external_lex_state = 2},
  [717] = {.lex_state = 10, .external_lex_state = 2},
  [718] = {.lex_state = 10, .external_lex_state = 2},
  [719] = {.lex_state = 10, .external_lex_state = 2},
  [720] = {.lex_state = 98},
  [721] = {.lex_state = 98},
  [722] = {.lex_state = 98},
  [723] = {.lex_state = 98},
  [724] = {.lex_state = 98},
  [725] = {.lex_state = 98},
  [726] = {.lex_state = 98},
  [727] = {.lex_state = 98},
  [728] = {.lex_state = 98},
  [729] = {.lex_state = 98},
  [730] = {.lex_state = 10, .external_lex_state = 2},
  [731] = {.lex_state = 98},
  [732] = {.lex_state = 98},
  [733] = {.lex_state = 98},
  [734] = {.lex_state = 10, .external_lex_state = 2},
  [735] = {.lex_state = 98},
  [736] = {.lex_state = 98},
  [737] = {.lex_state = 98},
  [738] = {.lex_state = 98},
  [739] = {.lex_state = 10, .external_lex_state = 2},
  [740] = {.lex_state = 98},
  [741] = {.lex_state = 98},
  [742] = {.lex_state = 10, .external_lex_state = 2},
  [743] = {.lex_state = 98},
  [744] = {.lex_state = 98},
  [745] = {.lex_state = 98},
  [746] = {.lex_state = 10, .external_lex_state = 2},
  [747] = {.lex_state = 10, .external_lex_state = 2},
  [748] = {.lex_state = 10, .external_lex_state = 2},
  [749] = {.lex_state = 10, .external_lex_state = 2},
  [750] = {.lex_state = 98},
  [751] = {.lex_state = 10, .external_lex_state = 2},
  [752] = {.lex_state = 98},
  [753] = {.lex_state = 10, .external_lex_state = 2},
  [754] = {.lex_state = 10, .external_lex_state = 2},
  [755] = {.lex_state = 98},
  [756] = {.lex_state = 10, .external_lex_state = 2},
  [757] = {.lex_state = 98},
  [758] = {.lex_state = 10, .external_lex_state = 2},
  [759] = {.lex_state = 98},
  [760] = {.lex_state = 10, .external_lex_state = 2},
  [761] = {.lex_state = 98},
  [762] = {.lex_state = 10, .external_lex_state = 2},
  [763] = {.lex_state = 10, .external_lex_state = 2},
  [764] = {.lex_state = 10, .external_lex_state = 2},
  [765] = {.lex_state = 10, .external_lex_state = 2},
  [766] = {.lex_state = 98},
  [767] = {.lex_state = 10, .external_lex_state = 2},
  [768] = {.lex_state = 98},
  [769] = {.lex_state = 98},
  [770] = {.lex_state = 98},
  [771] = {.lex_state = 10, .external_lex_state = 2},
  [772] = {.lex_state = 10, .external_lex_state = 2},
  [773] = {.lex_state = 98},
  [774] = {.lex_state = 98},
  [775] = {.lex_state = 98},
  [776] = {.lex_state = 10, .external_lex_state = 2},
  [777] = {.lex_state = 10, .external_lex_state = 2},
  [778] = {.lex_state = 98},
  [779] = {.lex_state = 98},
  [780] = {.lex_state = 10, .external_lex_state = 2},
  [781] = {.lex_state = 98},
  [782] = {.lex_state = 98},
  [783] = {.lex_state = 98},
  [784] = {.lex_state = 98},
  [785] = {.lex_state = 98},
  [786] = {.lex_state = 10, .external_lex_state = 2},
  [787] = {.lex_state = 98},
  [788] = {.lex_state = 98},
  [789] = {.lex_state = 98},
  [790] = {.lex_state = 98},
  [791] = {.lex_state = 10, .external_lex_state = 2},
  [792] = {.lex_state = 98},
  [793] = {.lex_state = 10, .external_lex_state = 2},
  [794] = {.lex_state = 98},
  [795] = {.lex_state = 98},
  [796] = {.lex_state = 98},
  [797] = {.lex_state = 98},
  [798] = {.lex_state = 98},
  [799] = {.lex_state = 10, .external_lex_state = 2},
  [800] = {.lex_state = 10, .external_lex_state = 2},
  [801] = {.lex_state = 98},
  [802] = {.lex_state = 98},
  [803] = {.lex_state = 98},
  [804] = {.lex_state = 98},
  [805] = {.lex_state = 98},
  [806] = {.lex_state = 98},
  [807] = {.lex_state = 10, .external_lex_state = 2},
  [808] = {.lex_state = 98},
  [809] = {.lex_state = 98},
  [810] = {.lex_state = 98},
  [811] = {.lex_state = 98},
  [812] = {.lex_state = 10, .external_lex_state = 2},
  [813] = {.lex_state = 10, .external_lex_state = 2},
  [814] = {.lex_state = 98},
  [815] = {.lex_state = 98},
  [816] = {.lex_state = 10, .external_lex_state = 2},
  [817] = {.lex_state = 10, .external_lex_state = 2},
  [818] = {.lex_state = 10, .external_lex_state = 2},
  [819] = {.lex_state = 10, .external_lex_state = 2},
  [820] = {.lex_state = 10, .external_lex_state = 2},
  [821] = {.lex_state = 98},
  [822] = {.lex_state = 10, .external_lex_state = 2},
  [823] = {.lex_state = 10, .external_lex_state = 2},
  [824] = {.lex_state = 98},
  [825] = {.lex_state = 10, .external_lex_state = 2},
  [826] = {.lex_state = 10, .external_lex_state = 2},
  [827] = {.lex_state = 10, .external_lex_state = 2},
  [828] = {.lex_state = 10, .external_lex_state = 2},
  [829] = {.lex_state = 10, .external_lex_state = 2},
  [830] = {.lex_state = 10, .external_lex_state = 2},
  [831] = {.lex_state = 10, .external_lex_state = 2},
  [832] = {.lex_state = 10, .external_lex_state = 2},
  [833] = {.lex_state = 10, .external_lex_state = 2},
  [834] = {.lex_state = 10, .external_lex_state = 2},
  [835] = {.lex_state = 10, .external_lex_state = 2},
  [836] = {.lex_state = 10, .external_lex_state = 2},
  [837] = {.lex_state = 10, .external_lex_state = 2},
  [838] = {.lex_state = 98},
  [839] = {.lex_state = 10, .external_lex_state = 2},
  [840] = {.lex_state = 10, .external_lex_state = 2},
  [841] = {.lex_state = 10, .external_lex_state = 2},
  [842] = {.lex_state = 10, .external_lex_state = 2},
  [843] = {.lex_state = 10, .external_lex_state = 2},
  [844] = {.lex_state = 10, .external_lex_state = 2},
  [845] = {.lex_state = 10, .external_lex_state = 2},
  [846] = {.lex_state = 98},
  [847] = {.lex_state = 10, .external_lex_state = 2},
  [848] = {.lex_state = 98},
  [849] = {.lex_state = 98},
  [850] = {.lex_state = 10, .external_lex_state = 2},
  [851] = {.lex_state = 98},
  [852] = {.lex_state = 98},
  [853] = {.lex_state = 98},
  [854] = {.lex_state = 98},
  [855] = {.lex_state = 98},
  [856] = {.lex_state = 10, .external_lex_state = 2},
  [857] = {.lex_state = 98},
  [858] = {.lex_state = 10, .external_lex_state = 2},
  [859] = {.lex_state = 10, .external_lex_state = 2},
  [860] = {.lex_state = 10, .external_lex_state = 2},
  [861] = {.lex_state = 10, .external_lex_state = 2},
  [862] = {.lex_state = 98},
  [863] = {.lex_state = 10, .external_lex_state = 2},
  [864] = {.lex_state = 98},
  [865] = {.lex_state = 98},
  [866] = {.lex_state = 10, .external_lex_state = 2},
  [867] = {.lex_state = 98},
  [868] = {.lex_state = 98},
  [869] = {.lex_state = 98},
  [870] = {.lex_state = 98},
  [871] = {.lex_state = 10, .external_lex_state = 2},
  [872] = {.lex_state = 98},
  [873] = {.lex_state = 10, .external_lex_state = 2},
  [874] = {.lex_state = 10, .external_lex_state = 2},
  [875] = {.lex_state = 98},
  [876] = {.lex_state = 98},
  [877] = {.lex_state = 98},
  [878] = {.lex_state = 98},
  [879] = {.lex_state = 10, .external_lex_state = 2},
  [880] = {.lex_state = 10, .external_lex_state = 2},
  [881] = {.lex_state = 10, .external_lex_state = 2},
  [882] = {.lex_state = 98},
  [883] = {.lex_state = 10, .external_lex_state = 2},
  [884] = {.lex_state = 10, .external_lex_state = 2},
  [885] = {.lex_state = 98},
  [886] = {.lex_state = 10, .external_lex_state = 2},
  [887] = {.lex_state = 98},
  [888] = {.lex_state = 98},
  [889] = {.lex_state = 10, .external_lex_state = 2},
  [890] = {.lex_state = 98},
  [891] = {.lex_state = 10, .external_lex_state = 2},
  [892] = {.lex_state = 10, .external_lex_state = 2},
  [893] = {.lex_state = 10, .external_lex_state = 2},
  [894] = {.lex_state = 10, .external_lex_state = 2},
  [895] = {.lex_state = 10, .external_lex_state = 2},
  [896] = {.lex_state = 10, .external_lex_state = 2},
  [897] = {.lex_state = 10, .external_lex_state = 2},
  [898] = {.lex_state = 10, .external_lex_state = 2},
  [899] = {.lex_state = 10, .external_lex_state = 2},
  [900] = {.lex_state = 10, .external_lex_state = 2},
  [901] = {.lex_state = 10, .external_lex_state = 2},
  [902] = {.lex_state = 10, .external_lex_state = 2},
  [903] = {.lex_state = 10, .external_lex_state = 2},
  [904] = {.lex_state = 10, .external_lex_state = 2},
  [905] = {.lex_state = 10, .external_lex_state = 2},
  [906] = {.lex_state = 10, .external_lex_state = 2},
  [907] = {.lex_state = 10, .external_lex_state = 2},
  [908] = {.lex_state = 10, .external_lex_state = 2},
  [909] = {.lex_state = 10, .external_lex_state = 2},
  [910] = {.lex_state = 10, .external_lex_state = 2},
  [911] = {.lex_state = 10, .external_lex_state = 2},
  [912] = {.lex_state = 10, .external_lex_state = 2},
  [913] = {.lex_state = 10, .external_lex_state = 2},
  [914] = {.lex_state = 10, .external_lex_state = 2},
  [915] = {.lex_state = 10, .external_lex_state = 2},
  [916] = {.lex_state = 10, .external_lex_state = 2},
  [917] = {.lex_state = 10, .external_lex_state = 2},
  [918] = {.lex_state = 10, .external_lex_state = 2},
  [919] = {.lex_state = 10, .external_lex_state = 2},
  [920] = {.lex_state = 10, .external_lex_state = 2},
  [921] = {.lex_state = 10, .external_lex_state = 2},
  [922] = {.lex_state = 10, .external_lex_state = 2},
  [923] = {.lex_state = 10, .external_lex_state = 2},
  [924] = {.lex_state = 10, .external_lex_state = 2},
  [925] = {.lex_state = 10, .external_lex_state = 2},
  [926] = {.lex_state = 10, .external_lex_state = 2},
  [927] = {.lex_state = 10, .external_lex_state = 2},
  [928] = {.lex_state = 10, .external_lex_state = 2},
  [929] = {.lex_state = 10, .external_lex_state = 2},
  [930] = {.lex_state = 10, .external_lex_state = 2},
  [931] = {.lex_state = 10, .external_lex_state = 2},
  [932] = {.lex_state = 10, .external_lex_state = 2},
  [933] = {.lex_state = 10, .external_lex_state = 2},
  [934] = {.lex_state = 10, .external_lex_state = 2},
  [935] = {.lex_state = 10, .external_lex_state = 2},
  [936] = {.lex_state = 10, .external_lex_state = 2},
  [937] = {.lex_state = 10, .external_lex_state = 2},
  [938] = {.lex_state = 10, .external_lex_state = 2},
  [939] = {.lex_state = 10, .external_lex_state = 2},
  [940] = {.lex_state = 10, .external_lex_state = 2},
  [941] = {.lex_state = 10, .external_lex_state = 2},
  [942] = {.lex_state = 10, .external_lex_state = 2},
  [943] = {.lex_state = 10, .external_lex_state = 2},
  [944] = {.lex_state = 10, .external_lex_state = 2},
  [945] = {.lex_state = 10, .external_lex_state = 2},
  [946] = {.lex_state = 10, .external_lex_state = 2},
  [947] = {.lex_state = 10, .external_lex_state = 2},
  [948] = {.lex_state = 10, .external_lex_state = 2},
  [949] = {.lex_state = 10, .external_lex_state = 2},
  [950] = {.lex_state = 10, .external_lex_state = 2},
  [951] = {.lex_state = 10, .external_lex_state = 2},
  [952] = {.lex_state = 10, .external_lex_state = 2},
  [953] = {.lex_state = 10, .external_lex_state = 2},
  [954] = {.lex_state = 10, .external_lex_state = 2},
  [955] = {.lex_state = 10, .external_lex_state = 2},
  [956] = {.lex_state = 10, .external_lex_state = 2},
  [957] = {.lex_state = 10, .external_lex_state = 2},
  [958] = {.lex_state = 10, .external_lex_state = 2},
  [959] = {.lex_state = 10, .external_lex_state = 2},
  [960] = {.lex_state = 10, .external_lex_state = 2},
  [961] = {.lex_state = 10, .external_lex_state = 2},
  [962] = {.lex_state = 10, .external_lex_state = 2},
  [963] = {.lex_state = 10, .external_lex_state = 2},
  [964] = {.lex_state = 10, .external_lex_state = 2},
  [965] = {.lex_state = 10, .external_lex_state = 2},
  [966] = {.lex_state = 10, .external_lex_state = 2},
  [967] = {.lex_state = 10, .external_lex_state = 2},
  [968] = {.lex_state = 10, .external_lex_state = 2},
  [969] = {.lex_state = 10, .external_lex_state = 2},
  [970] = {.lex_state = 10, .external_lex_state = 2},
  [971] = {.lex_state = 10, .external_lex_state = 2},
  [972] = {.lex_state = 10, .external_lex_state = 2},
  [973] = {.lex_state = 10, .external_lex_state = 2},
  [974] = {.lex_state = 10, .external_lex_state = 2},
  [975] = {.lex_state = 10, .external_lex_state = 2},
  [976] = {.lex_state = 10, .external_lex_state = 2},
  [977] = {.lex_state = 10, .external_lex_state = 2},
  [978] = {.lex_state = 10, .external_lex_state = 2},
  [979] = {.lex_state = 10, .external_lex_state = 2},
  [980] = {.lex_state = 10, .external_lex_state = 2},
  [981] = {.lex_state = 10, .external_lex_state = 2},
  [982] = {.lex_state = 10, .external_lex_state = 2},
  [983] = {.lex_state = 10, .external_lex_state = 2},
  [984] = {.lex_state = 10, .external_lex_state = 2},
  [985] = {.lex_state = 10, .external_lex_state = 2},
  [986] = {.lex_state = 10, .external_lex_state = 2},
  [987] = {.lex_state = 10, .external_lex_state = 2},
  [988] = {.lex_state = 10, .external_lex_state = 2},
  [989] = {.lex_state = 10, .external_lex_state = 2},
  [990] = {.lex_state = 10, .external_lex_state = 2},
  [991] = {.lex_state = 10, .external_lex_state = 2},
  [992] = {.lex_state = 10, .external_lex_state = 2},
  [993] = {.lex_state = 10, .external_lex_state = 2},
  [994] = {.lex_state = 10, .external_lex_state = 2},
  [995] = {.lex_state = 10, .external_lex_state = 2},
  [996] = {.lex_state = 10, .external_lex_state = 2},
  [997] = {.lex_state = 10, .external_lex_state = 2},
  [998] = {.lex_state = 10, .external_lex_state = 2},
  [999] = {.lex_state = 10, .external_lex_state = 2},
  [1000] = {.lex_state = 10, .external_lex_state = 2},
  [1001] = {.lex_state = 10, .external_lex_state = 2},
  [1002] = {.lex_state = 10, .external_lex_state = 2},
  [1003] = {.lex_state = 10, .external_lex_state = 2},
  [1004] = {.lex_state = 8, .external_lex_state = 2},
  [1005] = {.lex_state = 100},
  [1006] = {.lex_state = 100},
  [1007] = {.lex_state = 100},
  [1008] = {.lex_state = 100},
  [1009] = {.lex_state = 100},
  [1010] = {.lex_state = 100},
  [1011] = {.lex_state = 10, .external_lex_state = 2},
  [1012] = {.lex_state = 100},
  [1013] = {.lex_state = 98},
  [1014] = {.lex_state = 98},
  [1015] = {.lex_state = 100},
  [1016] = {.lex_state = 100},
  [1017] = {.lex_state = 98},
  [1018] = {.lex_state = 100},
  [1019] = {.lex_state = 100},
  [1020] = {.lex_state = 98},
  [1021] = {.lex_state = 100},
  [1022] = {.lex_state = 98},
  [1023] = {.lex_state = 98},
  [1024] = {.lex_state = 100},
  [1025] = {.lex_state = 100},
  [1026] = {.lex_state = 98},
  [1027] = {.lex_state = 98},
  [1028] = {.lex_state = 100},
  [1029] = {.lex_state = 98},
  [1030] = {.lex_state = 100},
  [1031] = {.lex_state = 100},
  [1032] = {.lex_state = 100},
  [1033] = {.lex_state = 98},
  [1034] = {.lex_state = 98},
  [1035] = {.lex_state = 98},
  [1036] = {.lex_state = 98},
  [1037] = {.lex_state = 100},
  [1038] = {.lex_state = 97, .external_lex_state = 3},
  [1039] = {.lex_state = 100},
  [1040] = {.lex_state = 97, .external_lex_state = 3},
  [1041] = {.lex_state = 97, .external_lex_state = 3},
  [1042] = {.lex_state = 97, .external_lex_state = 3},
  [1043] = {.lex_state = 100},
  [1044] = {.lex_state = 100},
  [1045] = {.lex_state = 97, .external_lex_state = 3},
  [1046] = {.lex_state = 97, .external_lex_state = 2},
  [1047] = {.lex_state = 100},
  [1048] = {.lex_state = 97, .external_lex_state = 3},
  [1049] = {.lex_state = 100},
  [1050] = {.lex_state = 97, .external_lex_state = 2},
  [1051] = {.lex_state = 97, .external_lex_state = 2},
  [1052] = {.lex_state = 97, .external_lex_state = 3},
  [1053] = {.lex_state = 100},
  [1054] = {.lex_state = 100},
  [1055] = {.lex_state = 97, .external_lex_state = 3},
  [1056] = {.lex_state = 97, .external_lex_state = 3},
  [1057] = {.lex_state = 97, .external_lex_state = 2},
  [1058] = {.lex_state = 97, .external_lex_state = 2},
  [1059] = {.lex_state = 98},
  [1060] = {.lex_state = 100},
  [1061] = {.lex_state = 98},
  [1062] = {.lex_state = 100},
  [1063] = {.lex_state = 97, .external_lex_state = 3},
  [1064] = {.lex_state = 97, .external_lex_state = 3},
  [1065] = {.lex_state = 98},
  [1066] = {.lex_state = 97, .external_lex_state = 2},
  [1067] = {.lex_state = 97, .external_lex_state = 2},
  [1068] = {.lex_state = 100},
  [1069] = {.lex_state = 100},
  [1070] = {.lex_state = 100},
  [1071] = {.lex_state = 100},
  [1072] = {.lex_state = 100},
  [1073] = {.lex_state = 100},
  [1074] = {.lex_state = 100},
  [1075] = {.lex_state = 100},
  [1076] = {.lex_state = 100},
  [1077] = {.lex_state = 100},
  [1078] = {.lex_state = 100},
  [1079] = {.lex_state = 100},
  [1080] = {.lex_state = 100},
  [1081] = {.lex_state = 100},
  [1082] = {.lex_state = 100},
  [1083] = {.lex_state = 100},
  [1084] = {.lex_state = 100},
  [1085] = {.lex_state = 97, .external_lex_state = 2},
  [1086] = {.lex_state = 97, .external_lex_state = 2},
  [1087] = {.lex_state = 100},
  [1088] = {.lex_state = 100},
  [1089] = {.lex_state = 100},
  [1090] = {.lex_state = 100},
  [1091] = {.lex_state = 100},
  [1092] = {.lex_state = 100},
  [1093] = {.lex_state = 100},
  [1094] = {.lex_state = 100},
  [1095] = {.lex_state = 100},
  [1096] = {.lex_state = 97, .external_lex_state = 2},
  [1097] = {.lex_state = 100},
  [1098] = {.lex_state = 100},
  [1099] = {.lex_state = 100},
  [1100] = {.lex_state = 100},
  [1101] = {.lex_state = 100},
  [1102] = {.lex_state = 100},
  [1103] = {.lex_state = 100},
  [1104] = {.lex_state = 100},
  [1105] = {.lex_state = 100},
  [1106] = {.lex_state = 97, .external_lex_state = 2},
  [1107] = {.lex_state = 100},
  [1108] = {.lex_state = 100},
  [1109] = {.lex_state = 100},
  [1110] = {.lex_state = 100},
  [1111] = {.lex_state = 97, .external_lex_state = 2},
  [1112] = {.lex_state = 100},
  [1113] = {.lex_state = 100},
  [1114] = {.lex_state = 100},
  [1115] = {.lex_state = 100},
  [1116] = {.lex_state = 100},
  [1117] = {.lex_state = 100},
  [1118] = {.lex_state = 100},
  [1119] = {.lex_state = 100},
  [1120] = {.lex_state = 100},
  [1121] = {.lex_state = 100},
  [1122] = {.lex_state = 100},
  [1123] = {.lex_state = 100},
  [1124] = {.lex_state = 100},
  [1125] = {.lex_state = 100},
  [1126] = {.lex_state = 100},
  [1127] = {.lex_state = 100},
  [1128] = {.lex_state = 100},
  [1129] = {.lex_state = 100},
  [1130] = {.lex_state = 100},
  [1131] = {.lex_state = 100},
  [1132] = {.lex_state = 100},
  [1133] = {.lex_state = 100},
  [1134] = {.lex_state = 100},
  [1135] = {.lex_state = 100},
  [1136] = {.lex_state = 100},
  [1137] = {.lex_state = 100},
  [1138] = {.lex_state = 100},
  [1139] = {.lex_state = 100},
  [1140] = {.lex_state = 97, .external_lex_state = 3},
  [1141] = {.lex_state = 100},
  [1142] = {.lex_state = 100},
  [1143] = {.lex_state = 100},
  [1144] = {.lex_state = 100},
  [1145] = {.lex_state = 100},
  [1146] = {.lex_state = 100},
  [1147] = {.lex_state = 100},
  [1148] = {.lex_state = 100},
  [1149] = {.lex_state = 100},
  [1150] = {.lex_state = 100},
  [1151] = {.lex_state = 100},
  [1152] = {.lex_state = 100},
  [1153] = {.lex_state = 100},
  [1154] = {.lex_state = 100},
  [1155] = {.lex_state = 100},
  [1156] = {.lex_state = 100},
  [1157] = {.lex_state = 100},
  [1158] = {.lex_state = 100},
  [1159] = {.lex_state = 100},
  [1160] = {.lex_state = 97, .external_lex_state = 3},
  [1161] = {.lex_state = 100},
  [1162] = {.lex_state = 100},
  [1163] = {.lex_state = 97, .external_lex_state = 2},
  [1164] = {.lex_state = 100},
  [1165] = {.lex_state = 100},
  [1166] = {.lex_state = 100},
  [1167] = {.lex_state = 100},
  [1168] = {.lex_state = 100},
  [1169] = {.lex_state = 97, .external_lex_state = 2},
  [1170] = {.lex_state = 100},
  [1171] = {.lex_state = 100},
  [1172] = {.lex_state = 100},
  [1173] = {.lex_state = 100},
  [1174] = {.lex_state = 100},
  [1175] = {.lex_state = 100},
  [1176] = {.lex_state = 100},
  [1177] = {.lex_state = 100},
  [1178] = {.lex_state = 100},
  [1179] = {.lex_state = 100},
  [1180] = {.lex_state = 100},
  [1181] = {.lex_state = 100},
  [1182] = {.lex_state = 100},
  [1183] = {.lex_state = 100},
  [1184] = {.lex_state = 100},
  [1185] = {.lex_state = 100},
  [1186] = {.lex_state = 100},
  [1187] = {.lex_state = 100},
  [1188] = {.lex_state = 100},
  [1189] = {.lex_state = 100},
  [1190] = {.lex_state = 100},
  [1191] = {.lex_state = 100},
  [1192] = {.lex_state = 100},
  [1193] = {.lex_state = 100},
  [1194] = {.lex_state = 100},
  [1195] = {.lex_state = 100},
  [1196] = {.lex_state = 100},
  [1197] = {.lex_state = 100},
  [1198] = {.lex_state = 100},
  [1199] = {.lex_state = 100},
  [1200] = {.lex_state = 100},
  [1201] = {.lex_state = 100},
  [1202] = {.lex_state = 100},
  [1203] = {.lex_state = 100},
  [1204] = {.lex_state = 100},
  [1205] = {.lex_state = 100},
  [1206] = {.lex_state = 100},
  [1207] = {.lex_state = 100},
  [1208] = {.lex_state = 100},
  [1209] = {.lex_state = 100},
  [1210] = {.lex_state = 100},
  [1211] = {.lex_state = 100},
  [1212] = {.lex_state = 100},
  [1213] = {.lex_state = 97, .external_lex_state = 3},
  [1214] = {.lex_state = 100},
  [1215] = {.lex_state = 97, .external_lex_state = 3},
  [1216] = {.lex_state = 100},
  [1217] = {.lex_state = 100},
  [1218] = {.lex_state = 100},
  [1219] = {.lex_state = 97, .external_lex_state = 3},
  [1220] = {.lex_state = 100},
  [1221] = {.lex_state = 100},
  [1222] = {.lex_state = 100},
  [1223] = {.lex_state = 100},
  [1224] = {.lex_state = 100},
  [1225] = {.lex_state = 100},
  [1226] = {.lex_state = 100},
  [1227] = {.lex_state = 100},
  [1228] = {.lex_state = 100},
  [1229] = {.lex_state = 100},
  [1230] = {.lex_state = 100},
  [1231] = {.lex_state = 100},
  [1232] = {.lex_state = 100},
  [1233] = {.lex_state = 100},
  [1234] = {.lex_state = 100},
  [1235] = {.lex_state = 100},
  [1236] = {.lex_state = 100},
  [1237] = {.lex_state = 100},
  [1238] = {.lex_state = 100},
  [1239] = {.lex_state = 100},
  [1240] = {.lex_state = 100},
  [1241] = {.lex_state = 100},
  [1242] = {.lex_state = 100},
  [1243] = {.lex_state = 100},
  [1244] = {.lex_state = 100},
  [1245] = {.lex_state = 100},
  [1246] = {.lex_state = 100},
  [1247] = {.lex_state = 100},
  [1248] = {.lex_state = 100},
  [1249] = {.lex_state = 100},
  [1250] = {.lex_state = 100},
  [1251] = {.lex_state = 100},
  [1252] = {.lex_state = 100},
  [1253] = {.lex_state = 100},
  [1254] = {.lex_state = 100},
  [1255] = {.lex_state = 100},
  [1256] = {.lex_state = 100},
  [1257] = {.lex_state = 100},
  [1258] = {.lex_state = 100},
  [1259] = {.lex_state = 100},
  [1260] = {.lex_state = 97, .external_lex_state = 3},
  [1261] = {.lex_state = 100},
  [1262] = {.lex_state = 100},
  [1263] = {.lex_state = 100},
  [1264] = {.lex_state = 100},
  [1265] = {.lex_state = 100},
  [1266] = {.lex_state = 100},
  [1267] = {.lex_state = 100},
  [1268] = {.lex_state = 100},
  [1269] = {.lex_state = 97, .external_lex_state = 3},
  [1270] = {.lex_state = 100},
  [1271] = {.lex_state = 100},
  [1272] = {.lex_state = 100},
  [1273] = {.lex_state = 100},
  [1274] = {.lex_state = 100},
  [1275] = {.lex_state = 100},
  [1276] = {.lex_state = 100},
  [1277] = {.lex_state = 100},
  [1278] = {.lex_state = 100},
  [1279] = {.lex_state = 100},
  [1280] = {.lex_state = 100},
  [1281] = {.lex_state = 100},
  [1282] = {.lex_state = 100},
  [1283] = {.lex_state = 100},
  [1284] = {.lex_state = 100},
  [1285] = {.lex_state = 100},
  [1286] = {.lex_state = 100},
  [1287] = {.lex_state = 100},
  [1288] = {.lex_state = 100},
  [1289] = {.lex_state = 100},
  [1290] = {.lex_state = 100},
  [1291] = {.lex_state = 100},
  [1292] = {.lex_state = 100},
  [1293] = {.lex_state = 100},
  [1294] = {.lex_state = 100},
  [1295] = {.lex_state = 100},
  [1296] = {.lex_state = 100},
  [1297] = {.lex_state = 100},
  [1298] = {.lex_state = 100},
  [1299] = {.lex_state = 100},
  [1300] = {.lex_state = 97, .external_lex_state = 2},
  [1301] = {.lex_state = 97, .external_lex_state = 2},
  [1302] = {.lex_state = 97, .external_lex_state = 3},
  [1303] = {.lex_state = 97, .external_lex_state = 3},
  [1304] = {.lex_state = 97, .external_lex_state = 2},
  [1305] = {.lex_state = 99},
  [1306] = {.lex_state = 99},
  [1307] = {.lex_state = 99},
  [1308] = {.lex_state = 99},
  [1309] = {.lex_state = 99},
  [1310] = {.lex_state = 97, .external_lex_state = 2},
  [1311] = {.lex_state = 97, .external_lex_state = 2},
  [1312] = {.lex_state = 99},
  [1313] = {.lex_state = 97, .external_lex_state = 3},
  [1314] = {.lex_state = 99},
  [1315] = {.lex_state = 97, .external_lex_state = 2},
  [1316] = {.lex_state = 99},
  [1317] = {.lex_state = 97, .external_lex_state = 2},
  [1318] = {.lex_state = 97, .external_lex_state = 3},
  [1319] = {.lex_state = 97, .external_lex_state = 3},
  [1320] = {.lex_state = 97, .external_lex_state = 3},
  [1321] = {.lex_state = 97, .external_lex_state = 2},
  [1322] = {.lex_state = 97, .external_lex_state = 2},
  [1323] = {.lex_state = 97, .external_lex_state = 2},
  [1324] = {.lex_state = 97, .external_lex_state = 3},
  [1325] = {.lex_state = 97, .external_lex_state = 3},
  [1326] = {.lex_state = 97, .external_lex_state = 3},
  [1327] = {.lex_state = 97, .external_lex_state = 3},
  [1328] = {.lex_state = 97, .external_lex_state = 2},
  [1329] = {.lex_state = 97, .external_lex_state = 2},
  [1330] = {.lex_state = 97, .external_lex_state = 3},
  [1331] = {.lex_state = 97, .external_lex_state = 3},
  [1332] = {.lex_state = 97, .external_lex_state = 3},
  [1333] = {.lex_state = 97, .external_lex_state = 2},
  [1334] = {.lex_state = 97, .external_lex_state = 2},
  [1335] = {.lex_state = 97, .external_lex_state = 2},
  [1336] = {.lex_state = 97, .external_lex_state = 2},
  [1337] = {.lex_state = 97, .external_lex_state = 2},
  [1338] = {.lex_state = 97, .external_lex_state = 2},
  [1339] = {.lex_state = 97, .external_lex_state = 2},
  [1340] = {.lex_state = 97, .external_lex_state = 2},
  [1341] = {.lex_state = 97, .external_lex_state = 3},
  [1342] = {.lex_state = 97, .external_lex_state = 2},
  [1343] = {.lex_state = 97, .external_lex_state = 2},
  [1344] = {.lex_state = 99},
  [1345] = {.lex_state = 97, .external_lex_state = 2},
  [1346] = {.lex_state = 99},
  [1347] = {.lex_state = 97, .external_lex_state = 3},
  [1348] = {.lex_state = 97, .external_lex_state = 2},
  [1349] = {.lex_state = 97, .external_lex_state = 2},
  [1350] = {.lex_state = 97, .external_lex_state = 2},
  [1351] = {.lex_state = 97, .external_lex_state = 2},
  [1352] = {.lex_state = 97, .external_lex_state = 3},
  [1353] = {.lex_state = 97, .external_lex_state = 2},
  [1354] = {.lex_state = 97, .external_lex_state = 3},
  [1355] = {.lex_state = 97, .external_lex_state = 3},
  [1356] = {.lex_state = 97, .external_lex_state = 2},
  [1357] = {.lex_state = 97, .external_lex_state = 2},
  [1358] = {.lex_state = 97, .external_lex_state = 2},
  [1359] = {.lex_state = 97, .external_lex_state = 3},
  [1360] = {.lex_state = 97, .external_lex_state = 3},
  [1361] = {.lex_state = 98},
  [1362] = {.lex_state = 97, .external_lex_state = 3},
  [1363] = {.lex_state = 97, .external_lex_state = 2},
  [1364] = {.lex_state = 97, .external_lex_state = 3},
  [1365] = {.lex_state = 97, .external_lex_state = 3},
  [1366] = {.lex_state = 97, .external_lex_state = 3},
  [1367] = {.lex_state = 97, .external_lex_state = 3},
  [1368] = {.lex_state = 97, .external_lex_state = 3},
  [1369] = {.lex_state = 97, .external_lex_state = 3},
  [1370] = {.lex_state = 97, .external_lex_state = 3},
  [1371] = {.lex_state = 97, .external_lex_state = 2},
  [1372] = {.lex_state = 97, .external_lex_state = 3},
  [1373] = {.lex_state = 98},
  [1374] = {.lex_state = 97, .external_lex_state = 3},
  [1375] = {.lex_state = 97, .external_lex_state = 2},
  [1376] = {.lex_state = 97, .external_lex_state = 3},
  [1377] = {.lex_state = 97, .external_lex_state = 3},
  [1378] = {.lex_state = 97, .external_lex_state = 3},
  [1379] = {.lex_state = 97, .external_lex_state = 3},
  [1380] = {.lex_state = 97, .external_lex_state = 3},
  [1381] = {.lex_state = 98},
  [1382] = {.lex_state = 97, .external_lex_state = 2},
  [1383] = {.lex_state = 97, .external_lex_state = 2},
  [1384] = {.lex_state = 98},
  [1385] = {.lex_state = 97, .external_lex_state = 2},
  [1386] = {.lex_state = 98},
  [1387] = {.lex_state = 97, .external_lex_state = 3},
  [1388] = {.lex_state = 97, .external_lex_state = 2},
  [1389] = {.lex_state = 98},
  [1390] = {.lex_state = 98},
  [1391] = {.lex_state = 97, .external_lex_state = 3},
  [1392] = {.lex_state = 97, .external_lex_state = 3},
  [1393] = {.lex_state = 97, .external_lex_state = 2},
  [1394] = {.lex_state = 100, .external_lex_state = 4},
  [1395] = {.lex_state = 97, .external_lex_state = 2},
  [1396] = {.lex_state = 100, .external_lex_state = 4},
  [1397] = {.lex_state = 97, .external_lex_state = 2},
  [1398] = {.lex_state = 98},
  [1399] = {.lex_state = 98},
  [1400] = {.lex_state = 97, .external_lex_state = 2},
  [1401] = {.lex_state = 97, .external_lex_state = 2},
  [1402] = {.lex_state = 98},
  [1403] = {.lex_state = 100},
  [1404] = {.lex_state = 100},
  [1405] = {.lex_state = 100},
  [1406] = {.lex_state = 100},
  [1407] = {.lex_state = 100},
  [1408] = {.lex_state = 97, .external_lex_state = 2},
  [1409] = {.lex_state = 97, .external_lex_state = 2},
  [1410] = {.lex_state = 97, .external_lex_state = 2},
  [1411] = {.lex_state = 97, .external_lex_state = 2},
  [1412] = {.lex_state = 100},
  [1413] = {.lex_state = 97, .external_lex_state = 2},
  [1414] = {.lex_state = 97, .external_lex_state = 2},
  [1415] = {.lex_state = 100},
  [1416] = {.lex_state = 100},
  [1417] = {.lex_state = 100},
  [1418] = {.lex_state = 100},
  [1419] = {.lex_state = 100},
  [1420] = {.lex_state = 100},
  [1421] = {.lex_state = 100},
  [1422] = {.lex_state = 100},
  [1423] = {.lex_state = 100},
  [1424] = {.lex_state = 100},
  [1425] = {.lex_state = 100},
  [1426] = {.lex_state = 100},
  [1427] = {.lex_state = 100},
  [1428] = {.lex_state = 100},
  [1429] = {.lex_state = 100},
  [1430] = {.lex_state = 100},
  [1431] = {.lex_state = 100},
  [1432] = {.lex_state = 100},
  [1433] = {.lex_state = 100},
  [1434] = {.lex_state = 100},
  [1435] = {.lex_state = 100},
  [1436] = {.lex_state = 100},
  [1437] = {.lex_state = 100},
  [1438] = {.lex_state = 100},
  [1439] = {.lex_state = 100},
  [1440] = {.lex_state = 100},
  [1441] = {.lex_state = 100},
  [1442] = {.lex_state = 100},
  [1443] = {.lex_state = 100},
  [1444] = {.lex_state = 100},
  [1445] = {.lex_state = 100},
  [1446] = {.lex_state = 100},
  [1447] = {.lex_state = 100},
  [1448] = {.lex_state = 100},
  [1449] = {.lex_state = 100},
  [1450] = {.lex_state = 100},
  [1451] = {.lex_state = 100},
  [1452] = {.lex_state = 100},
  [1453] = {.lex_state = 100},
  [1454] = {.lex_state = 100},
  [1455] = {.lex_state = 100},
  [1456] = {.lex_state = 100},
  [1457] = {.lex_state = 100},
  [1458] = {.lex_state = 100},
  [1459] = {.lex_state = 100},
  [1460] = {.lex_state = 100},
  [1461] = {.lex_state = 100},
  [1462] = {.lex_state = 100},
  [1463] = {.lex_state = 100},
  [1464] = {.lex_state = 100},
  [1465] = {.lex_state = 100},
  [1466] = {.lex_state = 100},
  [1467] = {.lex_state = 100},
  [1468] = {.lex_state = 100},
  [1469] = {.lex_state = 100},
  [1470] = {.lex_state = 100},
  [1471] = {.lex_state = 100},
  [1472] = {.lex_state = 100},
  [1473] = {.lex_state = 100},
  [1474] = {.lex_state = 100},
  [1475] = {.lex_state = 100},
  [1476] = {.lex_state = 100},
  [1477] = {.lex_state = 100},
  [1478] = {.lex_state = 100},
  [1479] = {.lex_state = 100},
  [1480] = {.lex_state = 100},
  [1481] = {.lex_state = 100},
  [1482] = {.lex_state = 100},
  [1483] = {.lex_state = 100},
  [1484] = {.lex_state = 100},
  [1485] = {.lex_state = 100},
  [1486] = {.lex_state = 100},
  [1487] = {.lex_state = 100},
  [1488] = {.lex_state = 100},
  [1489] = {.lex_state = 100},
  [1490] = {.lex_state = 100},
  [1491] = {.lex_state = 100},
  [1492] = {.lex_state = 98},
  [1493] = {.lex_state = 98},
  [1494] = {.lex_state = 98},
  [1495] = {.lex_state = 98},
  [1496] = {.lex_state = 98},
  [1497] = {.lex_state = 13, .external_lex_state = 2},
  [1498] = {.lex_state = 98},
  [1499] = {.lex_state = 13, .external_lex_state = 2},
  [1500] = {.lex_state = 98},
  [1501] = {.lex_state = 98},
  [1502] = {.lex_state = 100},
  [1503] = {.lex_state = 100},
  [1504] = {.lex_state = 13, .external_lex_state = 3},
  [1505] = {.lex_state = 13, .external_lex_state = 2},
  [1506] = {.lex_state = 13, .external_lex_state = 2},
  [1507] = {.lex_state = 100},
  [1508] = {.lex_state = 100},
  [1509] = {.lex_state = 100},
  [1510] = {.lex_state = 13, .external_lex_state = 2},
  [1511] = {.lex_state = 13, .external_lex_state = 2},
  [1512] = {.lex_state = 13, .external_lex_state = 2},
  [1513] = {.lex_state = 100},
  [1514] = {.lex_state = 13, .external_lex_state = 2},
  [1515] = {.lex_state = 13, .external_lex_state = 2},
  [1516] = {.lex_state = 100},
  [1517] = {.lex_state = 13, .external_lex_state = 2},
  [1518] = {.lex_state = 13, .external_lex_state = 2},
  [1519] = {.lex_state = 13, .external_lex_state = 2},
  [1520] = {.lex_state = 13, .external_lex_state = 2},
  [1521] = {.lex_state = 100},
  [1522] = {.lex_state = 13, .external_lex_state = 2},
  [1523] = {.lex_state = 13, .external_lex_state = 2},
  [1524] = {.lex_state = 100},
  [1525] = {.lex_state = 13, .external_lex_state = 2},
  [1526] = {.lex_state = 100},
  [1527] = {.lex_state = 13, .external_lex_state = 2},
  [1528] = {.lex_state = 13, .external_lex_state = 2},
  [1529] = {.lex_state = 13, .external_lex_state = 2},
  [1530] = {.lex_state = 13, .external_lex_state = 2},
  [1531] = {.lex_state = 13, .external_lex_state = 2},
  [1532] = {.lex_state = 13, .external_lex_state = 2},
  [1533] = {.lex_state = 13, .external_lex_state = 2},
  [1534] = {.lex_state = 13, .external_lex_state = 2},
  [1535] = {.lex_state = 13, .external_lex_state = 2},
  [1536] = {.lex_state = 13, .external_lex_state = 3},
  [1537] = {.lex_state = 13, .external_lex_state = 2},
  [1538] = {.lex_state = 13, .external_lex_state = 2},
  [1539] = {.lex_state = 13, .external_lex_state = 2},
  [1540] = {.lex_state = 13, .external_lex_state = 2},
  [1541] = {.lex_state = 13, .external_lex_state = 2},
  [1542] = {.lex_state = 13, .external_lex_state = 2},
  [1543] = {.lex_state = 13, .external_lex_state = 2},
  [1544] = {.lex_state = 13, .external_lex_state = 2},
  [1545] = {.lex_state = 13, .external_lex_state = 2},
  [1546] = {.lex_state = 13, .external_lex_state = 2},
  [1547] = {.lex_state = 13, .external_lex_state = 2},
  [1548] = {.lex_state = 13, .external_lex_state = 2},
  [1549] = {.lex_state = 13, .external_lex_state = 2},
  [1550] = {.lex_state = 13, .external_lex_state = 2},
  [1551] = {.lex_state = 13, .external_lex_state = 2},
  [1552] = {.lex_state = 13, .external_lex_state = 2},
  [1553] = {.lex_state = 13, .external_lex_state = 2},
  [1554] = {.lex_state = 13, .external_lex_state = 2},
  [1555] = {.lex_state = 13, .external_lex_state = 2},
  [1556] = {.lex_state = 13, .external_lex_state = 2},
  [1557] = {.lex_state = 13, .external_lex_state = 2},
  [1558] = {.lex_state = 13, .external_lex_state = 2},
  [1559] = {.lex_state = 13, .external_lex_state = 2},
  [1560] = {.lex_state = 13, .external_lex_state = 2},
  [1561] = {.lex_state = 13, .external_lex_state = 2},
  [1562] = {.lex_state = 13, .external_lex_state = 2},
  [1563] = {.lex_state = 13, .external_lex_state = 2},
  [1564] = {.lex_state = 13, .external_lex_state = 2},
  [1565] = {.lex_state = 13, .external_lex_state = 2},
  [1566] = {.lex_state = 13, .external_lex_state = 2},
  [1567] = {.lex_state = 13, .external_lex_state = 2},
  [1568] = {.lex_state = 13, .external_lex_state = 2},
  [1569] = {.lex_state = 13, .external_lex_state = 2},
  [1570] = {.lex_state = 13, .external_lex_state = 2},
  [1571] = {.lex_state = 13, .external_lex_state = 2},
  [1572] = {.lex_state = 13, .external_lex_state = 2},
  [1573] = {.lex_state = 13, .external_lex_state = 2},
  [1574] = {.lex_state = 13, .external_lex_state = 2},
  [1575] = {.lex_state = 13, .external_lex_state = 2},
  [1576] = {.lex_state = 13, .external_lex_state = 2},
  [1577] = {.lex_state = 13, .external_lex_state = 2},
  [1578] = {.lex_state = 13, .external_lex_state = 2},
  [1579] = {.lex_state = 13, .external_lex_state = 2},
  [1580] = {.lex_state = 98},
  [1581] = {.lex_state = 13, .external_lex_state = 2},
  [1582] = {.lex_state = 13, .external_lex_state = 2},
  [1583] = {.lex_state = 13, .external_lex_state = 3},
  [1584] = {.lex_state = 13, .external_lex_state = 2},
  [1585] = {.lex_state = 13, .external_lex_state = 2},
  [1586] = {.lex_state = 13, .external_lex_state = 2},
  [1587] = {.lex_state = 13, .external_lex_state = 2},
  [1588] = {.lex_state = 13, .external_lex_state = 3},
  [1589] = {.lex_state = 13, .external_lex_state = 2},
  [1590] = {.lex_state = 13, .external_lex_state = 2},
  [1591] = {.lex_state = 13, .external_lex_state = 3},
  [1592] = {.lex_state = 13, .external_lex_state = 2},
  [1593] = {.lex_state = 13, .external_lex_state = 2},
  [1594] = {.lex_state = 13, .external_lex_state = 2},
  [1595] = {.lex_state = 13, .external_lex_state = 2},
  [1596] = {.lex_state = 100},
  [1597] = {.lex_state = 13, .external_lex_state = 2},
  [1598] = {.lex_state = 13, .external_lex_state = 2},
  [1599] = {.lex_state = 13, .external_lex_state = 2},
  [1600] = {.lex_state = 13, .external_lex_state = 2},
  [1601] = {.lex_state = 13, .external_lex_state = 2},
  [1602] = {.lex_state = 13, .external_lex_state = 2},
  [1603] = {.lex_state = 13, .external_lex_state = 2},
  [1604] = {.lex_state = 13, .external_lex_state = 2},
  [1605] = {.lex_state = 13, .external_lex_state = 2},
  [1606] = {.lex_state = 13, .external_lex_state = 2},
  [1607] = {.lex_state = 13, .external_lex_state = 2},
  [1608] = {.lex_state = 13, .external_lex_state = 2},
  [1609] = {.lex_state = 13, .external_lex_state = 2},
  [1610] = {.lex_state = 13, .external_lex_state = 2},
  [1611] = {.lex_state = 13, .external_lex_state = 2},
  [1612] = {.lex_state = 13, .external_lex_state = 2},
  [1613] = {.lex_state = 13, .external_lex_state = 2},
  [1614] = {.lex_state = 13, .external_lex_state = 2},
  [1615] = {.lex_state = 13, .external_lex_state = 2},
  [1616] = {.lex_state = 13, .external_lex_state = 2},
  [1617] = {.lex_state = 13, .external_lex_state = 2},
  [1618] = {.lex_state = 13, .external_lex_state = 2},
  [1619] = {.lex_state = 13, .external_lex_state = 2},
  [1620] = {.lex_state = 13, .external_lex_state = 2},
  [1621] = {.lex_state = 13, .external_lex_state = 2},
  [1622] = {.lex_state = 13, .external_lex_state = 2},
  [1623] = {.lex_state = 13, .external_lex_state = 2},
  [1624] = {.lex_state = 13, .external_lex_state = 2},
  [1625] = {.lex_state = 13, .external_lex_state = 2},
  [1626] = {.lex_state = 13, .external_lex_state = 2},
  [1627] = {.lex_state = 13, .external_lex_state = 2},
  [1628] = {.lex_state = 13, .external_lex_state = 2},
  [1629] = {.lex_state = 13, .external_lex_state = 2},
  [1630] = {.lex_state = 13, .external_lex_state = 2},
  [1631] = {.lex_state = 13, .external_lex_state = 2},
  [1632] = {.lex_state = 13, .external_lex_state = 2},
  [1633] = {.lex_state = 13, .external_lex_state = 2},
  [1634] = {.lex_state = 13, .external_lex_state = 3},
  [1635] = {.lex_state = 13, .external_lex_state = 2},
  [1636] = {.lex_state = 13, .external_lex_state = 2},
  [1637] = {.lex_state = 13, .external_lex_state = 2},
  [1638] = {.lex_state = 13, .external_lex_state = 2},
  [1639] = {.lex_state = 100},
  [1640] = {.lex_state = 13, .external_lex_state = 3},
  [1641] = {.lex_state = 13, .external_lex_state = 2},
  [1642] = {.lex_state = 13, .external_lex_state = 2},
  [1643] = {.lex_state = 13, .external_lex_state = 2},
  [1644] = {.lex_state = 13, .external_lex_state = 2},
  [1645] = {.lex_state = 13, .external_lex_state = 3},
  [1646] = {.lex_state = 13, .external_lex_state = 2},
  [1647] = {.lex_state = 13, .external_lex_state = 2},
  [1648] = {.lex_state = 13, .external_lex_state = 2},
  [1649] = {.lex_state = 13, .external_lex_state = 2},
  [1650] = {.lex_state = 13, .external_lex_state = 2},
  [1651] = {.lex_state = 13, .external_lex_state = 2},
  [1652] = {.lex_state = 13, .external_lex_state = 2},
  [1653] = {.lex_state = 13, .external_lex_state = 2},
  [1654] = {.lex_state = 13, .external_lex_state = 2},
  [1655] = {.lex_state = 13, .external_lex_state = 2},
  [1656] = {.lex_state = 13, .external_lex_state = 2},
  [1657] = {.lex_state = 13, .external_lex_state = 2},
  [1658] = {.lex_state = 13, .external_lex_state = 2},
  [1659] = {.lex_state = 13, .external_lex_state = 2},
  [1660] = {.lex_state = 13, .external_lex_state = 2},
  [1661] = {.lex_state = 100},
  [1662] = {.lex_state = 13, .external_lex_state = 2},
  [1663] = {.lex_state = 13, .external_lex_state = 2},
  [1664] = {.lex_state = 13, .external_lex_state = 2},
  [1665] = {.lex_state = 13, .external_lex_state = 2},
  [1666] = {.lex_state = 13, .external_lex_state = 2},
  [1667] = {.lex_state = 13, .external_lex_state = 2},
  [1668] = {.lex_state = 13, .external_lex_state = 2},
  [1669] = {.lex_state = 13, .external_lex_state = 2},
  [1670] = {.lex_state = 13, .external_lex_state = 2},
  [1671] = {.lex_state = 13, .external_lex_state = 2},
  [1672] = {.lex_state = 100},
  [1673] = {.lex_state = 100},
  [1674] = {.lex_state = 13, .external_lex_state = 2},
  [1675] = {.lex_state = 13, .external_lex_state = 2},
  [1676] = {.lex_state = 13, .external_lex_state = 2},
  [1677] = {.lex_state = 100},
  [1678] = {.lex_state = 13, .external_lex_state = 2},
  [1679] = {.lex_state = 100},
  [1680] = {.lex_state = 13, .external_lex_state = 2},
  [1681] = {.lex_state = 13, .external_lex_state = 2},
  [1682] = {.lex_state = 13, .external_lex_state = 2},
  [1683] = {.lex_state = 13, .external_lex_state = 2},
  [1684] = {.lex_state = 13, .external_lex_state = 2},
  [1685] = {.lex_state = 13, .external_lex_state = 2},
  [1686] = {.lex_state = 13, .external_lex_state = 2},
  [1687] = {.lex_state = 13, .external_lex_state = 2},
  [1688] = {.lex_state = 100},
  [1689] = {.lex_state = 13, .external_lex_state = 2},
  [1690] = {.lex_state = 13, .external_lex_state = 2},
  [1691] = {.lex_state = 13, .external_lex_state = 2},
  [1692] = {.lex_state = 13, .external_lex_state = 2},
  [1693] = {.lex_state = 13, .external_lex_state = 2},
  [1694] = {.lex_state = 13, .external_lex_state = 2},
  [1695] = {.lex_state = 13, .external_lex_state = 2},
  [1696] = {.lex_state = 13, .external_lex_state = 2},
  [1697] = {.lex_state = 13, .external_lex_state = 2},
  [1698] = {.lex_state = 13, .external_lex_state = 2},
  [1699] = {.lex_state = 13, .external_lex_state = 2},
  [1700] = {.lex_state = 13, .external_lex_state = 2},
  [1701] = {.lex_state = 13, .external_lex_state = 2},
  [1702] = {.lex_state = 13, .external_lex_state = 2},
  [1703] = {.lex_state = 13, .external_lex_state = 2},
  [1704] = {.lex_state = 100},
  [1705] = {.lex_state = 13, .external_lex_state = 2},
  [1706] = {.lex_state = 13, .external_lex_state = 2},
  [1707] = {.lex_state = 13, .external_lex_state = 2},
  [1708] = {.lex_state = 13, .external_lex_state = 3},
  [1709] = {.lex_state = 13, .external_lex_state = 2},
  [1710] = {.lex_state = 13, .external_lex_state = 2},
  [1711] = {.lex_state = 100},
  [1712] = {.lex_state = 100},
  [1713] = {.lex_state = 13, .external_lex_state = 2},
  [1714] = {.lex_state = 13, .external_lex_state = 2},
  [1715] = {.lex_state = 13, .external_lex_state = 2},
  [1716] = {.lex_state = 100},
  [1717] = {.lex_state = 13, .external_lex_state = 2},
  [1718] = {.lex_state = 13, .external_lex_state = 2},
  [1719] = {.lex_state = 13, .external_lex_state = 2},
  [1720] = {.lex_state = 100},
  [1721] = {.lex_state = 13, .external_lex_state = 2},
  [1722] = {.lex_state = 13, .external_lex_state = 2},
  [1723] = {.lex_state = 13, .external_lex_state = 2},
  [1724] = {.lex_state = 13, .external_lex_state = 2},
  [1725] = {.lex_state = 13, .external_lex_state = 2},
  [1726] = {.lex_state = 13, .external_lex_state = 2},
  [1727] = {.lex_state = 13, .external_lex_state = 2},
  [1728] = {.lex_state = 100},
  [1729] = {.lex_state = 13, .external_lex_state = 2},
  [1730] = {.lex_state = 13, .external_lex_state = 2},
  [1731] = {.lex_state = 13, .external_lex_state = 2},
  [1732] = {.lex_state = 13, .external_lex_state = 2},
  [1733] = {.lex_state = 13, .external_lex_state = 2},
  [1734] = {.lex_state = 100, .external_lex_state = 4},
  [1735] = {.lex_state = 13, .external_lex_state = 2},
  [1736] = {.lex_state = 13, .external_lex_state = 2},
  [1737] = {.lex_state = 13, .external_lex_state = 3},
  [1738] = {.lex_state = 100, .external_lex_state = 4},
  [1739] = {.lex_state = 13, .external_lex_state = 3},
  [1740] = {.lex_state = 13, .external_lex_state = 2},
  [1741] = {.lex_state = 13, .external_lex_state = 2},
  [1742] = {.lex_state = 13, .external_lex_state = 2},
  [1743] = {.lex_state = 13, .external_lex_state = 2},
  [1744] = {.lex_state = 13, .external_lex_state = 3},
  [1745] = {.lex_state = 13, .external_lex_state = 2},
  [1746] = {.lex_state = 13, .external_lex_state = 3},
  [1747] = {.lex_state = 13, .external_lex_state = 3},
  [1748] = {.lex_state = 100, .external_lex_state = 4},
  [1749] = {.lex_state = 13, .external_lex_state = 3},
  [1750] = {.lex_state = 13, .external_lex_state = 2},
  [1751] = {.lex_state = 13, .external_lex_state = 3},
  [1752] = {.lex_state = 13, .external_lex_state = 3},
  [1753] = {.lex_state = 13, .external_lex_state = 2},
  [1754] = {.lex_state = 13, .external_lex_state = 2},
  [1755] = {.lex_state = 13, .external_lex_state = 3},
  [1756] = {.lex_state = 13, .external_lex_state = 3},
  [1757] = {.lex_state = 13, .external_lex_state = 3},
  [1758] = {.lex_state = 100, .external_lex_state = 4},
  [1759] = {.lex_state = 13, .external_lex_state = 3},
  [1760] = {.lex_state = 13, .external_lex_state = 2},
  [1761] = {.lex_state = 13, .external_lex_state = 2},
  [1762] = {.lex_state = 13, .external_lex_state = 2},
  [1763] = {.lex_state = 13, .external_lex_state = 2},
  [1764] = {.lex_state = 13, .external_lex_state = 2},
  [1765] = {.lex_state = 13, .external_lex_state = 3},
  [1766] = {.lex_state = 13, .external_lex_state = 3},
  [1767] = {.lex_state = 13, .external_lex_state = 3},
  [1768] = {.lex_state = 13, .external_lex_state = 2},
  [1769] = {.lex_state = 13, .external_lex_state = 2},
  [1770] = {.lex_state = 13, .external_lex_state = 2},
  [1771] = {.lex_state = 13, .external_lex_state = 2},
  [1772] = {.lex_state = 13, .external_lex_state = 2},
  [1773] = {.lex_state = 13, .external_lex_state = 2},
  [1774] = {.lex_state = 13, .external_lex_state = 2},
  [1775] = {.lex_state = 13, .external_lex_state = 2},
  [1776] = {.lex_state = 13, .external_lex_state = 2},
  [1777] = {.lex_state = 13, .external_lex_state = 2},
  [1778] = {.lex_state = 13, .external_lex_state = 2},
  [1779] = {.lex_state = 13, .external_lex_state = 2},
  [1780] = {.lex_state = 13, .external_lex_state = 3},
  [1781] = {.lex_state = 13, .external_lex_state = 2},
  [1782] = {.lex_state = 13, .external_lex_state = 3},
  [1783] = {.lex_state = 13, .external_lex_state = 2},
  [1784] = {.lex_state = 13, .external_lex_state = 2},
  [1785] = {.lex_state = 13, .external_lex_state = 3},
  [1786] = {.lex_state = 13, .external_lex_state = 3},
  [1787] = {.lex_state = 13, .external_lex_state = 2},
  [1788] = {.lex_state = 13, .external_lex_state = 3},
  [1789] = {.lex_state = 13, .external_lex_state = 3},
  [1790] = {.lex_state = 13, .external_lex_state = 3},
  [1791] = {.lex_state = 13, .external_lex_state = 3},
  [1792] = {.lex_state = 13, .external_lex_state = 3},
  [1793] = {.lex_state = 13, .external_lex_state = 3},
  [1794] = {.lex_state = 13, .external_lex_state = 3},
  [1795] = {.lex_state = 13, .external_lex_state = 3},
  [1796] = {.lex_state = 13, .external_lex_state = 3},
  [1797] = {.lex_state = 13, .external_lex_state = 3},
  [1798] = {.lex_state = 13, .external_lex_state = 3},
  [1799] = {.lex_state = 13, .external_lex_state = 3},
  [1800] = {.lex_state = 13, .external_lex_state = 3},
  [1801] = {.lex_state = 13, .external_lex_state = 3},
  [1802] = {.lex_state = 13, .external_lex_state = 3},
  [1803] = {.lex_state = 13, .external_lex_state = 2},
  [1804] = {.lex_state = 13, .external_lex_state = 3},
  [1805] = {.lex_state = 13, .external_lex_state = 3},
  [1806] = {.lex_state = 13, .external_lex_state = 3},
  [1807] = {.lex_state = 13, .external_lex_state = 3},
  [1808] = {.lex_state = 13, .external_lex_state = 3},
  [1809] = {.lex_state = 13, .external_lex_state = 3},
  [1810] = {.lex_state = 13, .external_lex_state = 3},
  [1811] = {.lex_state = 13, .external_lex_state = 3},
  [1812] = {.lex_state = 13, .external_lex_state = 3},
  [1813] = {.lex_state = 13, .external_lex_state = 3},
  [1814] = {.lex_state = 13, .external_lex_state = 3},
  [1815] = {.lex_state = 13, .external_lex_state = 3},
  [1816] = {.lex_state = 13, .external_lex_state = 3},
  [1817] = {.lex_state = 13, .external_lex_state = 3},
  [1818] = {.lex_state = 13, .external_lex_state = 3},
  [1819] = {.lex_state = 13, .external_lex_state = 3},
  [1820] = {.lex_state = 13, .external_lex_state = 3},
  [1821] = {.lex_state = 13, .external_lex_state = 3},
  [1822] = {.lex_state = 13, .external_lex_state = 2},
  [1823] = {.lex_state = 13, .external_lex_state = 3},
  [1824] = {.lex_state = 13, .external_lex_state = 3},
  [1825] = {.lex_state = 13, .external_lex_state = 3},
  [1826] = {.lex_state = 13, .external_lex_state = 3},
  [1827] = {.lex_state = 13, .external_lex_state = 3},
  [1828] = {.lex_state = 13, .external_lex_state = 3},
  [1829] = {.lex_state = 13, .external_lex_state = 3},
  [1830] = {.lex_state = 13, .external_lex_state = 3},
  [1831] = {.lex_state = 13, .external_lex_state = 3},
  [1832] = {.lex_state = 13, .external_lex_state = 3},
  [1833] = {.lex_state = 13, .external_lex_state = 2},
  [1834] = {.lex_state = 13, .external_lex_state = 3},
  [1835] = {.lex_state = 13, .external_lex_state = 3},
  [1836] = {.lex_state = 13, .external_lex_state = 3},
  [1837] = {.lex_state = 13, .external_lex_state = 3},
  [1838] = {.lex_state = 13, .external_lex_state = 3},
  [1839] = {.lex_state = 13, .external_lex_state = 3},
  [1840] = {.lex_state = 13, .external_lex_state = 3},
  [1841] = {.lex_state = 13, .external_lex_state = 3},
  [1842] = {.lex_state = 13, .external_lex_state = 3},
  [1843] = {.lex_state = 13, .external_lex_state = 3},
  [1844] = {.lex_state = 13, .external_lex_state = 2},
  [1845] = {.lex_state = 13, .external_lex_state = 3},
  [1846] = {.lex_state = 13, .external_lex_state = 3},
  [1847] = {.lex_state = 13, .external_lex_state = 3},
  [1848] = {.lex_state = 13, .external_lex_state = 3},
  [1849] = {.lex_state = 13, .external_lex_state = 3},
  [1850] = {.lex_state = 13, .external_lex_state = 3},
  [1851] = {.lex_state = 13, .external_lex_state = 3},
  [1852] = {.lex_state = 13, .external_lex_state = 3},
  [1853] = {.lex_state = 13, .external_lex_state = 3},
  [1854] = {.lex_state = 13, .external_lex_state = 3},
  [1855] = {.lex_state = 13, .external_lex_state = 3},
  [1856] = {.lex_state = 13, .external_lex_state = 3},
  [1857] = {.lex_state = 13, .external_lex_state = 3},
  [1858] = {.lex_state = 13, .external_lex_state = 3},
  [1859] = {.lex_state = 13, .external_lex_state = 3},
  [1860] = {.lex_state = 13, .external_lex_state = 3},
  [1861] = {.lex_state = 13, .external_lex_state = 3},
  [1862] = {.lex_state = 13, .external_lex_state = 3},
  [1863] = {.lex_state = 13, .external_lex_state = 3},
  [1864] = {.lex_state = 13, .external_lex_state = 3},
  [1865] = {.lex_state = 13, .external_lex_state = 3},
  [1866] = {.lex_state = 13, .external_lex_state = 3},
  [1867] = {.lex_state = 13, .external_lex_state = 3},
  [1868] = {.lex_state = 13, .external_lex_state = 3},
  [1869] = {.lex_state = 13, .external_lex_state = 3},
  [1870] = {.lex_state = 13, .external_lex_state = 3},
  [1871] = {.lex_state = 13, .external_lex_state = 3},
  [1872] = {.lex_state = 13, .external_lex_state = 3},
  [1873] = {.lex_state = 13, .external_lex_state = 3},
  [1874] = {.lex_state = 13, .external_lex_state = 3},
  [1875] = {.lex_state = 13, .external_lex_state = 2},
  [1876] = {.lex_state = 13, .external_lex_state = 2},
  [1877] = {.lex_state = 13, .external_lex_state = 3},
  [1878] = {.lex_state = 13, .external_lex_state = 3},
  [1879] = {.lex_state = 13, .external_lex_state = 3},
  [1880] = {.lex_state = 13, .external_lex_state = 3},
  [1881] = {.lex_state = 13, .external_lex_state = 3},
  [1882] = {.lex_state = 13, .external_lex_state = 3},
  [1883] = {.lex_state = 13, .external_lex_state = 3},
  [1884] = {.lex_state = 13, .external_lex_state = 3},
  [1885] = {.lex_state = 13, .external_lex_state = 3},
  [1886] = {.lex_state = 13, .external_lex_state = 3},
  [1887] = {.lex_state = 13, .external_lex_state = 3},
  [1888] = {.lex_state = 13, .external_lex_state = 3},
  [1889] = {.lex_state = 13, .external_lex_state = 3},
  [1890] = {.lex_state = 13, .external_lex_state = 3},
  [1891] = {.lex_state = 13, .external_lex_state = 3},
  [1892] = {.lex_state = 13, .external_lex_state = 3},
  [1893] = {.lex_state = 13, .external_lex_state = 3},
  [1894] = {.lex_state = 13, .external_lex_state = 3},
  [1895] = {.lex_state = 13, .external_lex_state = 3},
  [1896] = {.lex_state = 13, .external_lex_state = 3},
  [1897] = {.lex_state = 13, .external_lex_state = 3},
  [1898] = {.lex_state = 13, .external_lex_state = 3},
  [1899] = {.lex_state = 13, .external_lex_state = 3},
  [1900] = {.lex_state = 13, .external_lex_state = 3},
  [1901] = {.lex_state = 13, .external_lex_state = 3},
  [1902] = {.lex_state = 13, .external_lex_state = 3},
  [1903] = {.lex_state = 13, .external_lex_state = 3},
  [1904] = {.lex_state = 13, .external_lex_state = 3},
  [1905] = {.lex_state = 13, .external_lex_state = 3},
  [1906] = {.lex_state = 13, .external_lex_state = 3},
  [1907] = {.lex_state = 13, .external_lex_state = 3},
  [1908] = {.lex_state = 13, .external_lex_state = 3},
  [1909] = {.lex_state = 99, .external_lex_state = 4},
  [1910] = {.lex_state = 13, .external_lex_state = 3},
  [1911] = {.lex_state = 13, .external_lex_state = 3},
  [1912] = {.lex_state = 13, .external_lex_state = 3},
  [1913] = {.lex_state = 13, .external_lex_state = 3},
  [1914] = {.lex_state = 13, .external_lex_state = 3},
  [1915] = {.lex_state = 13, .external_lex_state = 3},
  [1916] = {.lex_state = 13, .external_lex_state = 3},
  [1917] = {.lex_state = 13, .external_lex_state = 3},
  [1918] = {.lex_state = 13, .external_lex_state = 3},
  [1919] = {.lex_state = 13, .external_lex_state = 3},
  [1920] = {.lex_state = 13, .external_lex_state = 3},
  [1921] = {.lex_state = 13, .external_lex_state = 3},
  [1922] = {.lex_state = 13, .external_lex_state = 3},
  [1923] = {.lex_state = 13, .external_lex_state = 3},
  [1924] = {.lex_state = 13, .external_lex_state = 3},
  [1925] = {.lex_state = 13, .external_lex_state = 3},
  [1926] = {.lex_state = 13, .external_lex_state = 3},
  [1927] = {.lex_state = 13, .external_lex_state = 3},
  [1928] = {.lex_state = 13, .external_lex_state = 3},
  [1929] = {.lex_state = 13, .external_lex_state = 3},
  [1930] = {.lex_state = 11, .external_lex_state = 2},
  [1931] = {.lex_state = 13, .external_lex_state = 2},
  [1932] = {.lex_state = 13, .external_lex_state = 3},
  [1933] = {.lex_state = 13, .external_lex_state = 3},
  [1934] = {.lex_state = 13, .external_lex_state = 3},
  [1935] = {.lex_state = 13, .external_lex_state = 2},
  [1936] = {.lex_state = 13, .external_lex_state = 2},
  [1937] = {.lex_state = 13, .external_lex_state = 3},
  [1938] = {.lex_state = 13, .external_lex_state = 2},
  [1939] = {.lex_state = 100, .external_lex_state = 4},
  [1940] = {.lex_state = 13, .external_lex_state = 3},
  [1941] = {.lex_state = 100, .external_lex_state = 4},
  [1942] = {.lex_state = 13, .external_lex_state = 2},
  [1943] = {.lex_state = 13, .external_lex_state = 3},
  [1944] = {.lex_state = 13, .external_lex_state = 2},
  [1945] = {.lex_state = 13, .external_lex_state = 3},
  [1946] = {.lex_state = 13, .external_lex_state = 3},
  [1947] = {.lex_state = 13, .external_lex_state = 3},
  [1948] = {.lex_state = 13, .external_lex_state = 3},
  [1949] = {.lex_state = 13, .external_lex_state = 3},
  [1950] = {.lex_state = 13, .external_lex_state = 3},
  [1951] = {.lex_state = 13, .external_lex_state = 3},
  [1952] = {.lex_state = 13, .external_lex_state = 3},
  [1953] = {.lex_state = 13, .external_lex_state = 3},
  [1954] = {.lex_state = 13, .external_lex_state = 3},
  [1955] = {.lex_state = 100, .external_lex_state = 4},
  [1956] = {.lex_state = 13, .external_lex_state = 3},
  [1957] = {.lex_state = 100, .external_lex_state = 4},
  [1958] = {.lex_state = 13, .external_lex_state = 3},
  [1959] = {.lex_state = 13, .external_lex_state = 3},
  [1960] = {.lex_state = 13, .external_lex_state = 3},
  [1961] = {.lex_state = 13, .external_lex_state = 2},
  [1962] = {.lex_state = 100, .external_lex_state = 4},
  [1963] = {.lex_state = 13, .external_lex_state = 3},
  [1964] = {.lex_state = 100, .external_lex_state = 4},
  [1965] = {.lex_state = 13, .external_lex_state = 2},
  [1966] = {.lex_state = 13, .external_lex_state = 2},
  [1967] = {.lex_state = 13, .external_lex_state = 2},
  [1968] = {.lex_state = 13, .external_lex_state = 3},
  [1969] = {.lex_state = 100, .external_lex_state = 4},
  [1970] = {.lex_state = 100, .external_lex_state = 4},
  [1971] = {.lex_state = 13, .external_lex_state = 3},
  [1972] = {.lex_state = 13, .external_lex_state = 2},
  [1973] = {.lex_state = 13, .external_lex_state = 2},
  [1974] = {.lex_state = 13, .external_lex_state = 3},
  [1975] = {.lex_state = 13, .external_lex_state = 2},
  [1976] = {.lex_state = 13, .external_lex_state = 2},
  [1977] = {.lex_state = 100, .external_lex_state = 4},
  [1978] = {.lex_state = 13, .external_lex_state = 2},
  [1979] = {.lex_state = 13, .external_lex_state = 3},
  [1980] = {.lex_state = 100, .external_lex_state = 4},
  [1981] = {.lex_state = 13, .external_lex_state = 2},
  [1982] = {.lex_state = 13, .external_lex_state = 2},
  [1983] = {.lex_state = 13, .external_lex_state = 2},
  [1984] = {.lex_state = 13, .external_lex_state = 2},
  [1985] = {.lex_state = 13, .external_lex_state = 2},
  [1986] = {.lex_state = 13, .external_lex_state = 2},
  [1987] = {.lex_state = 13, .external_lex_state = 2},
  [1988] = {.lex_state = 100, .external_lex_state = 4},
  [1989] = {.lex_state = 13, .external_lex_state = 3},
  [1990] = {.lex_state = 13, .external_lex_state = 2},
  [1991] = {.lex_state = 13, .external_lex_state = 3},
  [1992] = {.lex_state = 13, .external_lex_state = 3},
  [1993] = {.lex_state = 13, .external_lex_state = 2},
  [1994] = {.lex_state = 13, .external_lex_state = 2},
  [1995] = {.lex_state = 13, .external_lex_state = 2},
  [1996] = {.lex_state = 13, .external_lex_state = 2},
  [1997] = {.lex_state = 13, .external_lex_state = 2},
  [1998] = {.lex_state = 13, .external_lex_state = 2},
  [1999] = {.lex_state = 13, .external_lex_state = 2},
  [2000] = {.lex_state = 11, .external_lex_state = 3},
  [2001] = {.lex_state = 13, .external_lex_state = 2},
  [2002] = {.lex_state = 13, .external_lex_state = 2},
  [2003] = {.lex_state = 13, .external_lex_state = 2},
  [2004] = {.lex_state = 13, .external_lex_state = 2},
  [2005] = {.lex_state = 13, .external_lex_state = 2},
  [2006] = {.lex_state = 13, .external_lex_state = 2},
  [2007] = {.lex_state = 13, .external_lex_state = 2},
  [2008] = {.lex_state = 13, .external_lex_state = 2},
  [2009] = {.lex_state = 13, .external_lex_state = 2},
  [2010] = {.lex_state = 13, .external_lex_state = 3},
  [2011] = {.lex_state = 13, .external_lex_state = 2},
  [2012] = {.lex_state = 13, .external_lex_state = 2},
  [2013] = {.lex_state = 13, .external_lex_state = 2},
  [2014] = {.lex_state = 13, .external_lex_state = 2},
  [2015] = {.lex_state = 13, .external_lex_state = 3},
  [2016] = {.lex_state = 13, .external_lex_state = 2},
  [2017] = {.lex_state = 13, .external_lex_state = 2},
  [2018] = {.lex_state = 13, .external_lex_state = 2},
  [2019] = {.lex_state = 13, .external_lex_state = 2},
  [2020] = {.lex_state = 11, .external_lex_state = 3},
  [2021] = {.lex_state = 13, .external_lex_state = 2},
  [2022] = {.lex_state = 13, .external_lex_state = 2},
  [2023] = {.lex_state = 13, .external_lex_state = 2},
  [2024] = {.lex_state = 13, .external_lex_state = 2},
  [2025] = {.lex_state = 13, .external_lex_state = 2},
  [2026] = {.lex_state = 13, .external_lex_state = 2},
  [2027] = {.lex_state = 13, .external_lex_state = 3},
  [2028] = {.lex_state = 13, .external_lex_state = 2},
  [2029] = {.lex_state = 13, .external_lex_state = 2},
  [2030] = {.lex_state = 13, .external_lex_state = 3},
  [2031] = {.lex_state = 13, .external_lex_state = 3},
  [2032] = {.lex_state = 13, .external_lex_state = 3},
  [2033] = {.lex_state = 13, .external_lex_state = 3},
  [2034] = {.lex_state = 13, .external_lex_state = 3},
  [2035] = {.lex_state = 13, .external_lex_state = 2},
  [2036] = {.lex_state = 13, .external_lex_state = 2},
  [2037] = {.lex_state = 13, .external_lex_state = 3},
  [2038] = {.lex_state = 13, .external_lex_state = 3},
  [2039] = {.lex_state = 13, .external_lex_state = 3},
  [2040] = {.lex_state = 13, .external_lex_state = 3},
  [2041] = {.lex_state = 13, .external_lex_state = 2},
  [2042] = {.lex_state = 13, .external_lex_state = 2},
  [2043] = {.lex_state = 13, .external_lex_state = 3},
  [2044] = {.lex_state = 13, .external_lex_state = 3},
  [2045] = {.lex_state = 13, .external_lex_state = 2},
  [2046] = {.lex_state = 13, .external_lex_state = 3},
  [2047] = {.lex_state = 13, .external_lex_state = 3},
  [2048] = {.lex_state = 100, .external_lex_state = 4},
  [2049] = {.lex_state = 13, .external_lex_state = 3},
  [2050] = {.lex_state = 13, .external_lex_state = 3},
  [2051] = {.lex_state = 13, .external_lex_state = 3},
  [2052] = {.lex_state = 13, .external_lex_state = 3},
  [2053] = {.lex_state = 13, .external_lex_state = 3},
  [2054] = {.lex_state = 13, .external_lex_state = 2},
  [2055] = {.lex_state = 13, .external_lex_state = 3},
  [2056] = {.lex_state = 13, .external_lex_state = 3},
  [2057] = {.lex_state = 13, .external_lex_state = 3},
  [2058] = {.lex_state = 13, .external_lex_state = 3},
  [2059] = {.lex_state = 13, .external_lex_state = 3},
  [2060] = {.lex_state = 13, .external_lex_state = 3},
  [2061] = {.lex_state = 13, .external_lex_state = 3},
  [2062] = {.lex_state = 13, .external_lex_state = 3},
  [2063] = {.lex_state = 13, .external_lex_state = 3},
  [2064] = {.lex_state = 13, .external_lex_state = 3},
  [2065] = {.lex_state = 13, .external_lex_state = 3},
  [2066] = {.lex_state = 13, .external_lex_state = 3},
  [2067] = {.lex_state = 13, .external_lex_state = 3},
  [2068] = {.lex_state = 13, .external_lex_state = 3},
  [2069] = {.lex_state = 13, .external_lex_state = 3},
  [2070] = {.lex_state = 13, .external_lex_state = 3},
  [2071] = {.lex_state = 13, .external_lex_state = 3},
  [2072] = {.lex_state = 13, .external_lex_state = 3},
  [2073] = {.lex_state = 13, .external_lex_state = 3},
  [2074] = {.lex_state = 13, .external_lex_state = 3},
  [2075] = {.lex_state = 13, .external_lex_state = 2},
  [2076] = {.lex_state = 13, .external_lex_state = 3},
  [2077] = {.lex_state = 13, .external_lex_state = 3},
  [2078] = {.lex_state = 13, .external_lex_state = 3},
  [2079] = {.lex_state = 13, .external_lex_state = 3},
  [2080] = {.lex_state = 13, .external_lex_state = 3},
  [2081] = {.lex_state = 13, .external_lex_state = 3},
  [2082] = {.lex_state = 13, .external_lex_state = 3},
  [2083] = {.lex_state = 13, .external_lex_state = 3},
  [2084] = {.lex_state = 13, .external_lex_state = 3},
  [2085] = {.lex_state = 13, .external_lex_state = 3},
  [2086] = {.lex_state = 13, .external_lex_state = 3},
  [2087] = {.lex_state = 13, .external_lex_state = 2},
  [2088] = {.lex_state = 13, .external_lex_state = 3},
  [2089] = {.lex_state = 13, .external_lex_state = 3},
  [2090] = {.lex_state = 13, .external_lex_state = 3},
  [2091] = {.lex_state = 13, .external_lex_state = 3},
  [2092] = {.lex_state = 13, .external_lex_state = 3},
  [2093] = {.lex_state = 13, .external_lex_state = 3},
  [2094] = {.lex_state = 13, .external_lex_state = 3},
  [2095] = {.lex_state = 13, .external_lex_state = 3},
  [2096] = {.lex_state = 13, .external_lex_state = 3},
  [2097] = {.lex_state = 13, .external_lex_state = 3},
  [2098] = {.lex_state = 13, .external_lex_state = 3},
  [2099] = {.lex_state = 13, .external_lex_state = 3},
  [2100] = {.lex_state = 13, .external_lex_state = 3},
  [2101] = {.lex_state = 13, .external_lex_state = 3},
  [2102] = {.lex_state = 13, .external_lex_state = 3},
  [2103] = {.lex_state = 13, .external_lex_state = 3},
  [2104] = {.lex_state = 100, .external_lex_state = 4},
  [2105] = {.lex_state = 13, .external_lex_state = 3},
  [2106] = {.lex_state = 13, .external_lex_state = 2},
  [2107] = {.lex_state = 13, .external_lex_state = 3},
  [2108] = {.lex_state = 13, .external_lex_state = 3},
  [2109] = {.lex_state = 13, .external_lex_state = 2},
  [2110] = {.lex_state = 13, .external_lex_state = 3},
  [2111] = {.lex_state = 13, .external_lex_state = 2},
  [2112] = {.lex_state = 13, .external_lex_state = 3},
  [2113] = {.lex_state = 13, .external_lex_state = 3},
  [2114] = {.lex_state = 13, .external_lex_state = 3},
  [2115] = {.lex_state = 13, .external_lex_state = 3},
  [2116] = {.lex_state = 13, .external_lex_state = 3},
  [2117] = {.lex_state = 13, .external_lex_state = 3},
  [2118] = {.lex_state = 13, .external_lex_state = 3},
  [2119] = {.lex_state = 13, .external_lex_state = 3},
  [2120] = {.lex_state = 13, .external_lex_state = 3},
  [2121] = {.lex_state = 13, .external_lex_state = 3},
  [2122] = {.lex_state = 13, .external_lex_state = 3},
  [2123] = {.lex_state = 13, .external_lex_state = 2},
  [2124] = {.lex_state = 13, .external_lex_state = 3},
  [2125] = {.lex_state = 13, .external_lex_state = 3},
  [2126] = {.lex_state = 13, .external_lex_state = 3},
  [2127] = {.lex_state = 100, .external_lex_state = 4},
  [2128] = {.lex_state = 13, .external_lex_state = 3},
  [2129] = {.lex_state = 13, .external_lex_state = 3},
  [2130] = {.lex_state = 13, .external_lex_state = 3},
  [2131] = {.lex_state = 13, .external_lex_state = 2},
  [2132] = {.lex_state = 13, .external_lex_state = 3},
  [2133] = {.lex_state = 13, .external_lex_state = 3},
  [2134] = {.lex_state = 13, .external_lex_state = 2},
  [2135] = {.lex_state = 13, .external_lex_state = 2},
  [2136] = {.lex_state = 13, .external_lex_state = 3},
  [2137] = {.lex_state = 13, .external_lex_state = 2},
  [2138] = {.lex_state = 13, .external_lex_state = 3},
  [2139] = {.lex_state = 13, .external_lex_state = 3},
  [2140] = {.lex_state = 13, .external_lex_state = 3},
  [2141] = {.lex_state = 13, .external_lex_state = 3},
  [2142] = {.lex_state = 13, .external_lex_state = 3},
  [2143] = {.lex_state = 13, .external_lex_state = 2},
  [2144] = {.lex_state = 13, .external_lex_state = 2},
  [2145] = {.lex_state = 13, .external_lex_state = 2},
  [2146] = {.lex_state = 13, .external_lex_state = 3},
  [2147] = {.lex_state = 13, .external_lex_state = 2},
  [2148] = {.lex_state = 13, .external_lex_state = 3},
  [2149] = {.lex_state = 13, .external_lex_state = 3},
  [2150] = {.lex_state = 13, .external_lex_state = 2},
  [2151] = {.lex_state = 13, .external_lex_state = 2},
  [2152] = {.lex_state = 13, .external_lex_state = 2},
  [2153] = {.lex_state = 13, .external_lex_state = 3},
  [2154] = {.lex_state = 13, .external_lex_state = 3},
  [2155] = {.lex_state = 13, .external_lex_state = 3},
  [2156] = {.lex_state = 13, .external_lex_state = 3},
  [2157] = {.lex_state = 13, .external_lex_state = 2},
  [2158] = {.lex_state = 13, .external_lex_state = 2},
  [2159] = {.lex_state = 13, .external_lex_state = 2},
  [2160] = {.lex_state = 13, .external_lex_state = 2},
  [2161] = {.lex_state = 13, .external_lex_state = 2},
  [2162] = {.lex_state = 13, .external_lex_state = 2},
  [2163] = {.lex_state = 13, .external_lex_state = 2},
  [2164] = {.lex_state = 13, .external_lex_state = 2},
  [2165] = {.lex_state = 100, .external_lex_state = 4},
  [2166] = {.lex_state = 100},
  [2167] = {.lex_state = 11, .external_lex_state = 2},
  [2168] = {.lex_state = 100},
  [2169] = {.lex_state = 13, .external_lex_state = 2},
  [2170] = {.lex_state = 13, .external_lex_state = 2},
  [2171] = {.lex_state = 100, .external_lex_state = 4},
  [2172] = {.lex_state = 13, .external_lex_state = 2},
  [2173] = {.lex_state = 13, .external_lex_state = 2},
  [2174] = {.lex_state = 13, .external_lex_state = 2},
  [2175] = {.lex_state = 13, .external_lex_state = 2},
  [2176] = {.lex_state = 100, .external_lex_state = 4},
  [2177] = {.lex_state = 100},
  [2178] = {.lex_state = 100, .external_lex_state = 4},
  [2179] = {.lex_state = 13, .external_lex_state = 2},
  [2180] = {.lex_state = 100, .external_lex_state = 4},
  [2181] = {.lex_state = 13, .external_lex_state = 2},
  [2182] = {.lex_state = 13, .external_lex_state = 2},
  [2183] = {.lex_state = 13, .external_lex_state = 2},
  [2184] = {.lex_state = 13, .external_lex_state = 2},
  [2185] = {.lex_state = 13, .external_lex_state = 2},
  [2186] = {.lex_state = 13, .external_lex_state = 2},
  [2187] = {.lex_state = 100},
  [2188] = {.lex_state = 100},
  [2189] = {.lex_state = 100, .external_lex_state = 4},
  [2190] = {.lex_state = 13, .external_lex_state = 2},
  [2191] = {.lex_state = 13, .external_lex_state = 2},
  [2192] = {.lex_state = 13, .external_lex_state = 2},
  [2193] = {.lex_state = 13, .external_lex_state = 2},
  [2194] = {.lex_state = 13, .external_lex_state = 2},
  [2195] = {.lex_state = 100},
  [2196] = {.lex_state = 13, .external_lex_state = 2},
  [2197] = {.lex_state = 98},
  [2198] = {.lex_state = 13, .external_lex_state = 2},
  [2199] = {.lex_state = 100},
  [2200] = {.lex_state = 13, .external_lex_state = 2},
  [2201] = {.lex_state = 98},
  [2202] = {.lex_state = 100},
  [2203] = {.lex_state = 13, .external_lex_state = 2},
  [2204] = {.lex_state = 13, .external_lex_state = 2},
  [2205] = {.lex_state = 13, .external_lex_state = 2},
  [2206] = {.lex_state = 100, .external_lex_state = 4},
  [2207] = {.lex_state = 13, .external_lex_state = 2},
  [2208] = {.lex_state = 100, .external_lex_state = 4},
  [2209] = {.lex_state = 100, .external_lex_state = 4},
  [2210] = {.lex_state = 13, .external_lex_state = 2},
  [2211] = {.lex_state = 100, .external_lex_state = 4},
  [2212] = {.lex_state = 13, .external_lex_state = 2},
  [2213] = {.lex_state = 100, .external_lex_state = 4},
  [2214] = {.lex_state = 13, .external_lex_state = 2},
  [2215] = {.lex_state = 100, .external_lex_state = 4},
  [2216] = {.lex_state = 100, .external_lex_state = 4},
  [2217] = {.lex_state = 100},
  [2218] = {.lex_state = 100},
  [2219] = {.lex_state = 100, .external_lex_state = 4},
  [2220] = {.lex_state = 100, .external_lex_state = 4},
  [2221] = {.lex_state = 100, .external_lex_state = 4},
  [2222] = {.lex_state = 13, .external_lex_state = 2},
  [2223] = {.lex_state = 13, .external_lex_state = 2},
  [2224] = {.lex_state = 100},
  [2225] = {.lex_state = 13, .external_lex_state = 2},
  [2226] = {.lex_state = 13, .external_lex_state = 2},
  [2227] = {.lex_state = 100},
  [2228] = {.lex_state = 13, .external_lex_state = 2},
  [2229] = {.lex_state = 100, .external_lex_state = 4},
  [2230] = {.lex_state = 13, .external_lex_state = 2},
  [2231] = {.lex_state = 100},
  [2232] = {.lex_state = 13, .external_lex_state = 2},
  [2233] = {.lex_state = 13, .external_lex_state = 2},
  [2234] = {.lex_state = 13, .external_lex_state = 2},
  [2235] = {.lex_state = 13, .external_lex_state = 2},
  [2236] = {.lex_state = 13, .external_lex_state = 2},
  [2237] = {.lex_state = 13, .external_lex_state = 2},
  [2238] = {.lex_state = 100, .external_lex_state = 4},
  [2239] = {.lex_state = 100},
  [2240] = {.lex_state = 100, .external_lex_state = 4},
  [2241] = {.lex_state = 13, .external_lex_state = 2},
  [2242] = {.lex_state = 13, .external_lex_state = 2},
  [2243] = {.lex_state = 100, .external_lex_state = 4},
  [2244] = {.lex_state = 100, .external_lex_state = 4},
  [2245] = {.lex_state = 13, .external_lex_state = 2},
  [2246] = {.lex_state = 100},
  [2247] = {.lex_state = 100},
  [2248] = {.lex_state = 13, .external_lex_state = 2},
  [2249] = {.lex_state = 100, .external_lex_state = 4},
  [2250] = {.lex_state = 100, .external_lex_state = 4},
  [2251] = {.lex_state = 13, .external_lex_state = 2},
  [2252] = {.lex_state = 13, .external_lex_state = 2},
  [2253] = {.lex_state = 100, .external_lex_state = 4},
  [2254] = {.lex_state = 13, .external_lex_state = 2},
  [2255] = {.lex_state = 13, .external_lex_state = 2},
  [2256] = {.lex_state = 100, .external_lex_state = 4},
  [2257] = {.lex_state = 100, .external_lex_state = 4},
  [2258] = {.lex_state = 13, .external_lex_state = 2},
  [2259] = {.lex_state = 13, .external_lex_state = 2},
  [2260] = {.lex_state = 13, .external_lex_state = 2},
  [2261] = {.lex_state = 13, .external_lex_state = 2},
  [2262] = {.lex_state = 13, .external_lex_state = 2},
  [2263] = {.lex_state = 98},
  [2264] = {.lex_state = 100, .external_lex_state = 4},
  [2265] = {.lex_state = 13, .external_lex_state = 2},
  [2266] = {.lex_state = 13, .external_lex_state = 2},
  [2267] = {.lex_state = 13, .external_lex_state = 2},
  [2268] = {.lex_state = 13, .external_lex_state = 2},
  [2269] = {.lex_state = 13, .external_lex_state = 2},
  [2270] = {.lex_state = 13, .external_lex_state = 2},
  [2271] = {.lex_state = 100, .external_lex_state = 4},
  [2272] = {.lex_state = 13, .external_lex_state = 2},
  [2273] = {.lex_state = 13, .external_lex_state = 2},
  [2274] = {.lex_state = 13, .external_lex_state = 2},
  [2275] = {.lex_state = 13, .external_lex_state = 2},
  [2276] = {.lex_state = 100},
  [2277] = {.lex_state = 13, .external_lex_state = 2},
  [2278] = {.lex_state = 13, .external_lex_state = 2},
  [2279] = {.lex_state = 100},
  [2280] = {.lex_state = 13, .external_lex_state = 2},
  [2281] = {.lex_state = 13, .external_lex_state = 2},
  [2282] = {.lex_state = 13, .external_lex_state = 2},
  [2283] = {.lex_state = 13, .external_lex_state = 2},
  [2284] = {.lex_state = 13, .external_lex_state = 2},
  [2285] = {.lex_state = 13, .external_lex_state = 2},
  [2286] = {.lex_state = 13, .external_lex_state = 2},
  [2287] = {.lex_state = 13, .external_lex_state = 2},
  [2288] = {.lex_state = 13, .external_lex_state = 2},
  [2289] = {.lex_state = 100, .external_lex_state = 4},
  [2290] = {.lex_state = 100, .external_lex_state = 4},
  [2291] = {.lex_state = 13, .external_lex_state = 2},
  [2292] = {.lex_state = 13, .external_lex_state = 2},
  [2293] = {.lex_state = 13, .external_lex_state = 2},
  [2294] = {.lex_state = 100},
  [2295] = {.lex_state = 100, .external_lex_state = 4},
  [2296] = {.lex_state = 100, .external_lex_state = 4},
  [2297] = {.lex_state = 100, .external_lex_state = 4},
  [2298] = {.lex_state = 100, .external_lex_state = 4},
  [2299] = {.lex_state = 100, .external_lex_state = 4},
  [2300] = {.lex_state = 13, .external_lex_state = 2},
  [2301] = {.lex_state = 100, .external_lex_state = 4},
  [2302] = {.lex_state = 100},
  [2303] = {.lex_state = 13, .external_lex_state = 2},
  [2304] = {.lex_state = 100, .external_lex_state = 4},
  [2305] = {.lex_state = 13, .external_lex_state = 2},
  [2306] = {.lex_state = 13, .external_lex_state = 2},
  [2307] = {.lex_state = 100},
  [2308] = {.lex_state = 13, .external_lex_state = 2},
  [2309] = {.lex_state = 100},
  [2310] = {.lex_state = 100},
  [2311] = {.lex_state = 100, .external_lex_state = 4},
  [2312] = {.lex_state = 100},
  [2313] = {.lex_state = 13, .external_lex_state = 2},
  [2314] = {.lex_state = 13, .external_lex_state = 2},
  [2315] = {.lex_state = 100, .external_lex_state = 4},
  [2316] = {.lex_state = 100, .external_lex_state = 4},
  [2317] = {.lex_state = 100, .external_lex_state = 4},
  [2318] = {.lex_state = 100, .external_lex_state = 4},
  [2319] = {.lex_state = 100},
  [2320] = {.lex_state = 100, .external_lex_state = 4},
  [2321] = {.lex_state = 100, .external_lex_state = 4},
  [2322] = {.lex_state = 100, .external_lex_state = 4},
  [2323] = {.lex_state = 100, .external_lex_state = 4},
  [2324] = {.lex_state = 100},
  [2325] = {.lex_state = 100, .external_lex_state = 4},
  [2326] = {.lex_state = 100, .external_lex_state = 4},
  [2327] = {.lex_state = 100, .external_lex_state = 4},
  [2328] = {.lex_state = 100},
  [2329] = {.lex_state = 100, .external_lex_state = 4},
  [2330] = {.lex_state = 100, .external_lex_state = 4},
  [2331] = {.lex_state = 100},
  [2332] = {.lex_state = 13, .external_lex_state = 2},
  [2333] = {.lex_state = 100, .external_lex_state = 4},
  [2334] = {.lex_state = 98},
  [2335] = {.lex_state = 100, .external_lex_state = 4},
  [2336] = {.lex_state = 100, .external_lex_state = 4},
  [2337] = {.lex_state = 100, .external_lex_state = 4},
  [2338] = {.lex_state = 100},
  [2339] = {.lex_state = 100, .external_lex_state = 4},
  [2340] = {.lex_state = 100, .external_lex_state = 4},
  [2341] = {.lex_state = 13, .external_lex_state = 2},
  [2342] = {.lex_state = 13, .external_lex_state = 2},
  [2343] = {.lex_state = 100},
  [2344] = {.lex_state = 13, .external_lex_state = 2},
  [2345] = {.lex_state = 100, .external_lex_state = 4},
  [2346] = {.lex_state = 13, .external_lex_state = 2},
  [2347] = {.lex_state = 100, .external_lex_state = 4},
  [2348] = {.lex_state = 100},
  [2349] = {.lex_state = 100},
  [2350] = {.lex_state = 11, .external_lex_state = 2},
  [2351] = {.lex_state = 100, .external_lex_state = 4},
  [2352] = {.lex_state = 13, .external_lex_state = 2},
  [2353] = {.lex_state = 100, .external_lex_state = 4},
  [2354] = {.lex_state = 13, .external_lex_state = 2},
  [2355] = {.lex_state = 13, .external_lex_state = 2},
  [2356] = {.lex_state = 100},
  [2357] = {.lex_state = 98, .external_lex_state = 4},
  [2358] = {.lex_state = 100},
  [2359] = {.lex_state = 100},
  [2360] = {.lex_state = 100, .external_lex_state = 4},
  [2361] = {.lex_state = 98, .external_lex_state = 4},
  [2362] = {.lex_state = 100, .external_lex_state = 4},
  [2363] = {.lex_state = 100},
  [2364] = {.lex_state = 98, .external_lex_state = 4},
  [2365] = {.lex_state = 98, .external_lex_state = 4},
  [2366] = {.lex_state = 100},
  [2367] = {.lex_state = 100},
  [2368] = {.lex_state = 100},
  [2369] = {.lex_state = 100},
  [2370] = {.lex_state = 100},
  [2371] = {.lex_state = 100},
  [2372] = {.lex_state = 100},
  [2373] = {.lex_state = 100},
  [2374] = {.lex_state = 100},
  [2375] = {.lex_state = 100},
  [2376] = {.lex_state = 96},
  [2377] = {.lex_state = 100},
  [2378] = {.lex_state = 100},
  [2379] = {.lex_state = 100},
  [2380] = {.lex_state = 100},
  [2381] = {.lex_state = 98, .external_lex_state = 4},
  [2382] = {.lex_state = 100},
  [2383] = {.lex_state = 96},
  [2384] = {.lex_state = 100},
  [2385] = {.lex_state = 100},
  [2386] = {.lex_state = 100},
  [2387] = {.lex_state = 98, .external_lex_state = 4},
  [2388] = {.lex_state = 100},
  [2389] = {.lex_state = 100},
  [2390] = {.lex_state = 100, .external_lex_state = 4},
  [2391] = {.lex_state = 100, .external_lex_state = 4},
  [2392] = {.lex_state = 100},
  [2393] = {.lex_state = 102},
  [2394] = {.lex_state = 100},
  [2395] = {.lex_state = 100},
  [2396] = {.lex_state = 100, .external_lex_state = 4},
  [2397] = {.lex_state = 100, .external_lex_state = 4},
  [2398] = {.lex_state = 100},
  [2399] = {.lex_state = 100},
  [2400] = {.lex_state = 100, .external_lex_state = 4},
  [2401] = {.lex_state = 100},
  [2402] = {.lex_state = 102},
  [2403] = {.lex_state = 100, .external_lex_state = 4},
  [2404] = {.lex_state = 100},
  [2405] = {.lex_state = 100},
  [2406] = {.lex_state = 100},
  [2407] = {.lex_state = 100, .external_lex_state = 4},
  [2408] = {.lex_state = 100, .external_lex_state = 4},
  [2409] = {.lex_state = 100, .external_lex_state = 4},
  [2410] = {.lex_state = 100, .external_lex_state = 4},
  [2411] = {.lex_state = 100, .external_lex_state = 4},
  [2412] = {.lex_state = 100, .external_lex_state = 4},
  [2413] = {.lex_state = 100, .external_lex_state = 4},
  [2414] = {.lex_state = 100, .external_lex_state = 4},
  [2415] = {.lex_state = 100, .external_lex_state = 4},
  [2416] = {.lex_state = 100, .external_lex_state = 4},
  [2417] = {.lex_state = 100, .external_lex_state = 4},
  [2418] = {.lex_state = 100, .external_lex_state = 4},
  [2419] = {.lex_state = 100, .external_lex_state = 4},
  [2420] = {.lex_state = 100, .external_lex_state = 4},
  [2421] = {.lex_state = 100, .external_lex_state = 4},
  [2422] = {.lex_state = 100, .external_lex_state = 4},
  [2423] = {.lex_state = 100, .external_lex_state = 4},
  [2424] = {.lex_state = 100, .external_lex_state = 4},
  [2425] = {.lex_state = 100, .external_lex_state = 4},
  [2426] = {.lex_state = 100},
  [2427] = {.lex_state = 100},
  [2428] = {.lex_state = 100, .external_lex_state = 4},
  [2429] = {.lex_state = 100, .external_lex_state = 4},
  [2430] = {.lex_state = 100},
  [2431] = {.lex_state = 100},
  [2432] = {.lex_state = 100},
  [2433] = {.lex_state = 100},
  [2434] = {.lex_state = 100, .external_lex_state = 4},
  [2435] = {.lex_state = 100},
  [2436] = {.lex_state = 100},
  [2437] = {.lex_state = 100},
  [2438] = {.lex_state = 100},
  [2439] = {.lex_state = 100},
  [2440] = {.lex_state = 100},
  [2441] = {.lex_state = 100},
  [2442] = {.lex_state = 98},
  [2443] = {.lex_state = 100},
  [2444] = {.lex_state = 100},
  [2445] = {.lex_state = 100},
  [2446] = {.lex_state = 100},
  [2447] = {.lex_state = 100},
  [2448] = {.lex_state = 100},
  [2449] = {.lex_state = 100},
  [2450] = {.lex_state = 100},
  [2451] = {.lex_state = 100},
  [2452] = {.lex_state = 100},
  [2453] = {.lex_state = 100, .external_lex_state = 4},
  [2454] = {.lex_state = 100},
  [2455] = {.lex_state = 100},
  [2456] = {.lex_state = 96},
  [2457] = {.lex_state = 96},
  [2458] = {.lex_state = 100},
  [2459] = {.lex_state = 96},
  [2460] = {.lex_state = 98},
  [2461] = {.lex_state = 96},
  [2462] = {.lex_state = 100},
  [2463] = {.lex_state = 96},
  [2464] = {.lex_state = 100},
  [2465] = {.lex_state = 100},
  [2466] = {.lex_state = 100},
  [2467] = {.lex_state = 100},
  [2468] = {.lex_state = 100},
  [2469] = {.lex_state = 98},
  [2470] = {.lex_state = 100},
  [2471] = {.lex_state = 96},
  [2472] = {.lex_state = 98},
  [2473] = {.lex_state = 98},
  [2474] = {.lex_state = 98},
  [2475] = {.lex_state = 98},
  [2476] = {.lex_state = 98},
  [2477] = {.lex_state = 98},
  [2478] = {.lex_state = 98},
  [2479] = {.lex_state = 98},
  [2480] = {.lex_state = 100},
  [2481] = {.lex_state = 98},
  [2482] = {.lex_state = 98},
  [2483] = {.lex_state = 98},
  [2484] = {.lex_state = 98},
  [2485] = {.lex_state = 98},
  [2486] = {.lex_state = 98},
  [2487] = {.lex_state = 98},
  [2488] = {.lex_state = 96},
  [2489] = {.lex_state = 96},
  [2490] = {.lex_state = 96},
  [2491] = {.lex_state = 96},
  [2492] = {.lex_state = 96},
  [2493] = {.lex_state = 96},
  [2494] = {.lex_state = 96},
  [2495] = {.lex_state = 96},
  [2496] = {.lex_state = 96},
  [2497] = {.lex_state = 96},
  [2498] = {.lex_state = 96},
  [2499] = {.lex_state = 96},
  [2500] = {.lex_state = 96},
  [2501] = {.lex_state = 96},
  [2502] = {.lex_state = 96},
  [2503] = {.lex_state = 96},
  [2504] = {.lex_state = 96},
  [2505] = {.lex_state = 96},
  [2506] = {.lex_state = 96},
  [2507] = {.lex_state = 96},
  [2508] = {.lex_state = 96},
  [2509] = {.lex_state = 96},
  [2510] = {.lex_state = 96},
  [2511] = {.lex_state = 96},
  [2512] = {.lex_state = 96},
  [2513] = {.lex_state = 96},
  [2514] = {.lex_state = 96},
  [2515] = {.lex_state = 96},
  [2516] = {.lex_state = 96},
  [2517] = {.lex_state = 96},
  [2518] = {.lex_state = 96},
  [2519] = {.lex_state = 96},
  [2520] = {.lex_state = 96},
  [2521] = {.lex_state = 96},
  [2522] = {.lex_state = 96},
  [2523] = {.lex_state = 99},
  [2524] = {.lex_state = 103},
  [2525] = {.lex_state = 103},
  [2526] = {.lex_state = 103},
  [2527] = {.lex_state = 99},
  [2528] = {.lex_state = 96},
  [2529] = {.lex_state = 18},
  [2530] = {.lex_state = 103},
  [2531] = {.lex_state = 103},
  [2532] = {.lex_state = 103},
  [2533] = {.lex_state = 103},
  [2534] = {.lex_state = 103},
  [2535] = {.lex_state = 103},
  [2536] = {.lex_state = 103},
  [2537] = {.lex_state = 103},
  [2538] = {.lex_state = 103},
  [2539] = {.lex_state = 103},
  [2540] = {.lex_state = 103},
  [2541] = {.lex_state = 103},
  [2542] = {.lex_state = 103},
  [2543] = {.lex_state = 103},
  [2544] = {.lex_state = 103},
  [2545] = {.lex_state = 103},
  [2546] = {.lex_state = 103},
  [2547] = {.lex_state = 103},
  [2548] = {.lex_state = 103},
  [2549] = {.lex_state = 103},
  [2550] = {.lex_state = 103},
  [2551] = {.lex_state = 103},
  [2552] = {.lex_state = 103},
  [2553] = {.lex_state = 103},
  [2554] = {.lex_state = 103},
  [2555] = {.lex_state = 103},
  [2556] = {.lex_state = 103},
  [2557] = {.lex_state = 103},
  [2558] = {.lex_state = 103},
  [2559] = {.lex_state = 103},
  [2560] = {.lex_state = 103},
  [2561] = {.lex_state = 103},
  [2562] = {.lex_state = 103},
  [2563] = {.lex_state = 103},
  [2564] = {.lex_state = 103},
  [2565] = {.lex_state = 103},
  [2566] = {.lex_state = 103},
  [2567] = {.lex_state = 103},
  [2568] = {.lex_state = 103},
  [2569] = {.lex_state = 98},
  [2570] = {.lex_state = 98},
  [2571] = {.lex_state = 103},
  [2572] = {.lex_state = 103},
  [2573] = {.lex_state = 103},
  [2574] = {.lex_state = 103},
  [2575] = {.lex_state = 98},
  [2576] = {.lex_state = 98},
  [2577] = {.lex_state = 98},
  [2578] = {.lex_state = 98},
  [2579] = {.lex_state = 103},
  [2580] = {.lex_state = 103, .external_lex_state = 4},
  [2581] = {.lex_state = 98},
  [2582] = {.lex_state = 99},
  [2583] = {.lex_state = 99, .external_lex_state = 4},
  [2584] = {.lex_state = 98},
  [2585] = {.lex_state = 99, .external_lex_state = 4},
  [2586] = {.lex_state = 98},
  [2587] = {.lex_state = 103, .external_lex_state = 4},
  [2588] = {.lex_state = 98},
  [2589] = {.lex_state = 98},
  [2590] = {.lex_state = 103, .external_lex_state = 4},
  [2591] = {.lex_state = 96},
  [2592] = {.lex_state = 98},
  [2593] = {.lex_state = 96},
  [2594] = {.lex_state = 103, .external_lex_state = 4},
  [2595] = {.lex_state = 98},
  [2596] = {.lex_state = 98},
  [2597] = {.lex_state = 96},
  [2598] = {.lex_state = 98},
  [2599] = {.lex_state = 98},
  [2600] = {.lex_state = 98},
  [2601] = {.lex_state = 98},
  [2602] = {.lex_state = 98},
  [2603] = {.lex_state = 98},
  [2604] = {.lex_state = 18},
  [2605] = {.lex_state = 98},
  [2606] = {.lex_state = 98},
  [2607] = {.lex_state = 98},
  [2608] = {.lex_state = 98},
  [2609] = {.lex_state = 98},
  [2610] = {.lex_state = 98},
  [2611] = {.lex_state = 96},
  [2612] = {.lex_state = 98},
  [2613] = {.lex_state = 96},
  [2614] = {.lex_state = 98},
  [2615] = {.lex_state = 98},
  [2616] = {.lex_state = 96},
  [2617] = {.lex_state = 98},
  [2618] = {.lex_state = 98},
  [2619] = {.lex_state = 98},
  [2620] = {.lex_state = 98},
  [2621] = {.lex_state = 98},
  [2622] = {.lex_state = 96},
  [2623] = {.lex_state = 103, .external_lex_state = 4},
  [2624] = {.lex_state = 98},
  [2625] = {.lex_state = 103, .external_lex_state = 4},
  [2626] = {.lex_state = 103, .external_lex_state = 4},
  [2627] = {.lex_state = 103},
  [2628] = {.lex_state = 96},
  [2629] = {.lex_state = 103, .external_lex_state = 4},
  [2630] = {.lex_state = 96},
  [2631] = {.lex_state = 100, .external_lex_state = 4},
  [2632] = {.lex_state = 100, .external_lex_state = 4},
  [2633] = {.lex_state = 96},
  [2634] = {.lex_state = 96},
  [2635] = {.lex_state = 100, .external_lex_state = 4},
  [2636] = {.lex_state = 96},
  [2637] = {.lex_state = 102},
  [2638] = {.lex_state = 100, .external_lex_state = 4},
  [2639] = {.lex_state = 103, .external_lex_state = 4},
  [2640] = {.lex_state = 103, .external_lex_state = 4},
  [2641] = {.lex_state = 103, .external_lex_state = 4},
  [2642] = {.lex_state = 103, .external_lex_state = 4},
  [2643] = {.lex_state = 103, .external_lex_state = 4},
  [2644] = {.lex_state = 103, .external_lex_state = 4},
  [2645] = {.lex_state = 103, .external_lex_state = 4},
  [2646] = {.lex_state = 103, .external_lex_state = 4},
  [2647] = {.lex_state = 103, .external_lex_state = 4},
  [2648] = {.lex_state = 103, .external_lex_state = 4},
  [2649] = {.lex_state = 103, .external_lex_state = 4},
  [2650] = {.lex_state = 103, .external_lex_state = 4},
  [2651] = {.lex_state = 103, .external_lex_state = 4},
  [2652] = {.lex_state = 103, .external_lex_state = 4},
  [2653] = {.lex_state = 103, .external_lex_state = 4},
  [2654] = {.lex_state = 96},
  [2655] = {.lex_state = 100, .external_lex_state = 4},
  [2656] = {.lex_state = 96},
  [2657] = {.lex_state = 96},
  [2658] = {.lex_state = 96},
  [2659] = {.lex_state = 100, .external_lex_state = 4},
  [2660] = {.lex_state = 96},
  [2661] = {.lex_state = 96},
  [2662] = {.lex_state = 96},
  [2663] = {.lex_state = 96},
  [2664] = {.lex_state = 96},
  [2665] = {.lex_state = 96},
  [2666] = {.lex_state = 96},
  [2667] = {.lex_state = 96},
  [2668] = {.lex_state = 96},
  [2669] = {.lex_state = 100, .external_lex_state = 4},
  [2670] = {.lex_state = 96},
  [2671] = {.lex_state = 103, .external_lex_state = 4},
  [2672] = {.lex_state = 103, .external_lex_state = 4},
  [2673] = {.lex_state = 103, .external_lex_state = 4},
  [2674] = {.lex_state = 103, .external_lex_state = 4},
  [2675] = {.lex_state = 103, .external_lex_state = 4},
  [2676] = {.lex_state = 103, .external_lex_state = 4},
  [2677] = {.lex_state = 103, .external_lex_state = 4},
  [2678] = {.lex_state = 103, .external_lex_state = 4},
  [2679] = {.lex_state = 103, .external_lex_state = 4},
  [2680] = {.lex_state = 96},
  [2681] = {.lex_state = 18},
  [2682] = {.lex_state = 103, .external_lex_state = 4},
  [2683] = {.lex_state = 96},
  [2684] = {.lex_state = 96},
  [2685] = {.lex_state = 96},
  [2686] = {.lex_state = 96},
  [2687] = {.lex_state = 103, .external_lex_state = 4},
  [2688] = {.lex_state = 103, .external_lex_state = 4},
  [2689] = {.lex_state = 103, .external_lex_state = 4},
  [2690] = {.lex_state = 103, .external_lex_state = 4},
  [2691] = {.lex_state = 103, .external_lex_state = 4},
  [2692] = {.lex_state = 103, .external_lex_state = 4},
  [2693] = {.lex_state = 103, .external_lex_state = 4},
  [2694] = {.lex_state = 103, .external_lex_state = 4},
  [2695] = {.lex_state = 100, .external_lex_state = 4},
  [2696] = {.lex_state = 100, .external_lex_state = 4},
  [2697] = {.lex_state = 103, .external_lex_state = 4},
  [2698] = {.lex_state = 96},
  [2699] = {.lex_state = 99, .external_lex_state = 4},
  [2700] = {.lex_state = 103, .external_lex_state = 4},
  [2701] = {.lex_state = 102},
  [2702] = {.lex_state = 103, .external_lex_state = 4},
  [2703] = {.lex_state = 103, .external_lex_state = 4},
  [2704] = {.lex_state = 100, .external_lex_state = 4},
  [2705] = {.lex_state = 103, .external_lex_state = 5},
  [2706] = {.lex_state = 102},
  [2707] = {.lex_state = 103},
  [2708] = {.lex_state = 103, .external_lex_state = 4},
  [2709] = {.lex_state = 103, .external_lex_state = 5},
  [2710] = {.lex_state = 103, .external_lex_state = 5},
  [2711] = {.lex_state = 103, .external_lex_state = 4},
  [2712] = {.lex_state = 100, .external_lex_state = 4},
  [2713] = {.lex_state = 100, .external_lex_state = 4},
  [2714] = {.lex_state = 103},
  [2715] = {.lex_state = 100, .external_lex_state = 4},
  [2716] = {.lex_state = 100, .external_lex_state = 4},
  [2717] = {.lex_state = 96},
  [2718] = {.lex_state = 100, .external_lex_state = 4},
  [2719] = {.lex_state = 103, .external_lex_state = 5},
  [2720] = {.lex_state = 102},
  [2721] = {.lex_state = 96},
  [2722] = {.lex_state = 103, .external_lex_state = 4},
  [2723] = {.lex_state = 100, .external_lex_state = 4},
  [2724] = {.lex_state = 103, .external_lex_state = 4},
  [2725] = {.lex_state = 100, .external_lex_state = 4},
  [2726] = {.lex_state = 96},
  [2727] = {.lex_state = 100, .external_lex_state = 4},
  [2728] = {.lex_state = 103, .external_lex_state = 4},
  [2729] = {.lex_state = 96},
  [2730] = {.lex_state = 100, .external_lex_state = 4},
  [2731] = {.lex_state = 96},
  [2732] = {.lex_state = 100, .external_lex_state = 4},
  [2733] = {.lex_state = 96},
  [2734] = {.lex_state = 100, .external_lex_state = 4},
  [2735] = {.lex_state = 96},
  [2736] = {.lex_state = 96},
  [2737] = {.lex_state = 100, .external_lex_state = 4},
  [2738] = {.lex_state = 103, .external_lex_state = 5},
  [2739] = {.lex_state = 100, .external_lex_state = 4},
  [2740] = {.lex_state = 103, .external_lex_state = 5},
  [2741] = {.lex_state = 98, .external_lex_state = 4},
  [2742] = {.lex_state = 103, .external_lex_state = 5},
  [2743] = {.lex_state = 103, .external_lex_state = 5},
  [2744] = {.lex_state = 100, .external_lex_state = 4},
  [2745] = {.lex_state = 100, .external_lex_state = 4},
  [2746] = {.lex_state = 103, .external_lex_state = 5},
  [2747] = {.lex_state = 103, .external_lex_state = 5},
  [2748] = {.lex_state = 103, .external_lex_state = 5},
  [2749] = {.lex_state = 103, .external_lex_state = 5},
  [2750] = {.lex_state = 103, .external_lex_state = 5},
  [2751] = {.lex_state = 103},
  [2752] = {.lex_state = 102},
  [2753] = {.lex_state = 103, .external_lex_state = 5},
  [2754] = {.lex_state = 100, .external_lex_state = 4},
  [2755] = {.lex_state = 100, .external_lex_state = 4},
  [2756] = {.lex_state = 103, .external_lex_state = 5},
  [2757] = {.lex_state = 103, .external_lex_state = 5},
  [2758] = {.lex_state = 103, .external_lex_state = 5},
  [2759] = {.lex_state = 103, .external_lex_state = 5},
  [2760] = {.lex_state = 103, .external_lex_state = 5},
  [2761] = {.lex_state = 98},
  [2762] = {.lex_state = 100, .external_lex_state = 4},
  [2763] = {.lex_state = 100, .external_lex_state = 4},
  [2764] = {.lex_state = 103, .external_lex_state = 5},
  [2765] = {.lex_state = 103, .external_lex_state = 5},
  [2766] = {.lex_state = 100, .external_lex_state = 4},
  [2767] = {.lex_state = 100, .external_lex_state = 4},
  [2768] = {.lex_state = 100, .external_lex_state = 4},
  [2769] = {.lex_state = 98},
  [2770] = {.lex_state = 103, .external_lex_state = 5},
  [2771] = {.lex_state = 103, .external_lex_state = 5},
  [2772] = {.lex_state = 103, .external_lex_state = 5},
  [2773] = {.lex_state = 103, .external_lex_state = 5},
  [2774] = {.lex_state = 103, .external_lex_state = 5},
  [2775] = {.lex_state = 103, .external_lex_state = 5},
  [2776] = {.lex_state = 103, .external_lex_state = 5},
  [2777] = {.lex_state = 100, .external_lex_state = 4},
  [2778] = {.lex_state = 18},
  [2779] = {.lex_state = 103, .external_lex_state = 5},
  [2780] = {.lex_state = 100, .external_lex_state = 4},
  [2781] = {.lex_state = 103, .external_lex_state = 5},
  [2782] = {.lex_state = 103, .external_lex_state = 5},
  [2783] = {.lex_state = 100, .external_lex_state = 4},
  [2784] = {.lex_state = 100, .external_lex_state = 4},
  [2785] = {.lex_state = 103, .external_lex_state = 5},
  [2786] = {.lex_state = 100, .external_lex_state = 4},
  [2787] = {.lex_state = 103, .external_lex_state = 4},
  [2788] = {.lex_state = 100, .external_lex_state = 4},
  [2789] = {.lex_state = 100, .external_lex_state = 4},
  [2790] = {.lex_state = 100, .external_lex_state = 4},
  [2791] = {.lex_state = 100, .external_lex_state = 4},
  [2792] = {.lex_state = 103, .external_lex_state = 5},
  [2793] = {.lex_state = 103, .external_lex_state = 5},
  [2794] = {.lex_state = 103, .external_lex_state = 5},
  [2795] = {.lex_state = 100, .external_lex_state = 4},
  [2796] = {.lex_state = 103, .external_lex_state = 5},
  [2797] = {.lex_state = 103, .external_lex_state = 5},
  [2798] = {.lex_state = 103, .external_lex_state = 5},
  [2799] = {.lex_state = 103, .external_lex_state = 5},
  [2800] = {.lex_state = 98, .external_lex_state = 4},
  [2801] = {.lex_state = 103, .external_lex_state = 5},
  [2802] = {.lex_state = 100, .external_lex_state = 4},
  [2803] = {.lex_state = 98, .external_lex_state = 4},
  [2804] = {.lex_state = 98, .external_lex_state = 4},
  [2805] = {.lex_state = 98, .external_lex_state = 4},
  [2806] = {.lex_state = 103, .external_lex_state = 5},
  [2807] = {.lex_state = 98},
  [2808] = {.lex_state = 98},
  [2809] = {.lex_state = 98},
  [2810] = {.lex_state = 99, .external_lex_state = 5},
  [2811] = {.lex_state = 98, .external_lex_state = 4},
  [2812] = {.lex_state = 98, .external_lex_state = 4},
  [2813] = {.lex_state = 103, .external_lex_state = 5},
  [2814] = {.lex_state = 98, .external_lex_state = 4},
  [2815] = {.lex_state = 98, .external_lex_state = 4},
  [2816] = {.lex_state = 98, .external_lex_state = 4},
  [2817] = {.lex_state = 98, .external_lex_state = 4},
  [2818] = {.lex_state = 103, .external_lex_state = 5},
  [2819] = {.lex_state = 98, .external_lex_state = 4},
  [2820] = {.lex_state = 98, .external_lex_state = 4},
  [2821] = {.lex_state = 103, .external_lex_state = 5},
  [2822] = {.lex_state = 98, .external_lex_state = 4},
  [2823] = {.lex_state = 98, .external_lex_state = 4},
  [2824] = {.lex_state = 103, .external_lex_state = 5},
  [2825] = {.lex_state = 103, .external_lex_state = 5},
  [2826] = {.lex_state = 98, .external_lex_state = 4},
  [2827] = {.lex_state = 98, .external_lex_state = 4},
  [2828] = {.lex_state = 98, .external_lex_state = 4},
  [2829] = {.lex_state = 98, .external_lex_state = 4},
  [2830] = {.lex_state = 98, .external_lex_state = 4},
  [2831] = {.lex_state = 98, .external_lex_state = 4},
  [2832] = {.lex_state = 98, .external_lex_state = 4},
  [2833] = {.lex_state = 98, .external_lex_state = 4},
  [2834] = {.lex_state = 98},
  [2835] = {.lex_state = 98, .external_lex_state = 4},
  [2836] = {.lex_state = 97},
  [2837] = {.lex_state = 98},
  [2838] = {.lex_state = 98},
  [2839] = {.lex_state = 98, .external_lex_state = 4},
  [2840] = {.lex_state = 100, .external_lex_state = 4},
  [2841] = {.lex_state = 98, .external_lex_state = 4},
  [2842] = {.lex_state = 98, .external_lex_state = 4},
  [2843] = {.lex_state = 98, .external_lex_state = 4},
  [2844] = {.lex_state = 98, .external_lex_state = 4},
  [2845] = {.lex_state = 98, .external_lex_state = 4},
  [2846] = {.lex_state = 98, .external_lex_state = 4},
  [2847] = {.lex_state = 98, .external_lex_state = 4},
  [2848] = {.lex_state = 98, .external_lex_state = 4},
  [2849] = {.lex_state = 98, .external_lex_state = 4},
  [2850] = {.lex_state = 98, .external_lex_state = 4},
  [2851] = {.lex_state = 98, .external_lex_state = 4},
  [2852] = {.lex_state = 98, .external_lex_state = 4},
  [2853] = {.lex_state = 103, .external_lex_state = 5},
  [2854] = {.lex_state = 98, .external_lex_state = 4},
  [2855] = {.lex_state = 100, .external_lex_state = 4},
  [2856] = {.lex_state = 98, .external_lex_state = 4},
  [2857] = {.lex_state = 98},
  [2858] = {.lex_state = 98},
  [2859] = {.lex_state = 98, .external_lex_state = 4},
  [2860] = {.lex_state = 98},
  [2861] = {.lex_state = 98},
  [2862] = {.lex_state = 98, .external_lex_state = 4},
  [2863] = {.lex_state = 98, .external_lex_state = 4},
  [2864] = {.lex_state = 97},
  [2865] = {.lex_state = 99},
  [2866] = {.lex_state = 103},
  [2867] = {.lex_state = 98, .external_lex_state = 4},
  [2868] = {.lex_state = 99},
  [2869] = {.lex_state = 98},
  [2870] = {.lex_state = 98, .external_lex_state = 4},
  [2871] = {.lex_state = 99},
  [2872] = {.lex_state = 98, .external_lex_state = 4},
  [2873] = {.lex_state = 98, .external_lex_state = 4},
  [2874] = {.lex_state = 100, .external_lex_state = 4},
  [2875] = {.lex_state = 96},
  [2876] = {.lex_state = 98, .external_lex_state = 4},
  [2877] = {.lex_state = 98},
  [2878] = {.lex_state = 98},
  [2879] = {.lex_state = 99},
  [2880] = {.lex_state = 97},
  [2881] = {.lex_state = 103},
  [2882] = {.lex_state = 98, .external_lex_state = 4},
  [2883] = {.lex_state = 98, .external_lex_state = 5},
  [2884] = {.lex_state = 98, .external_lex_state = 5},
  [2885] = {.lex_state = 98, .external_lex_state = 5},
  [2886] = {.lex_state = 99},
  [2887] = {.lex_state = 98, .external_lex_state = 4},
  [2888] = {.lex_state = 98, .external_lex_state = 4},
  [2889] = {.lex_state = 98},
  [2890] = {.lex_state = 99},
  [2891] = {.lex_state = 97},
  [2892] = {.lex_state = 98},
  [2893] = {.lex_state = 99},
  [2894] = {.lex_state = 98, .external_lex_state = 4},
  [2895] = {.lex_state = 99},
  [2896] = {.lex_state = 98, .external_lex_state = 4},
  [2897] = {.lex_state = 97},
  [2898] = {.lex_state = 99},
  [2899] = {.lex_state = 98, .external_lex_state = 4},
  [2900] = {.lex_state = 98, .external_lex_state = 4},
  [2901] = {.lex_state = 98, .external_lex_state = 4},
  [2902] = {.lex_state = 98, .external_lex_state = 4},
  [2903] = {.lex_state = 98, .external_lex_state = 4},
  [2904] = {.lex_state = 99},
  [2905] = {.lex_state = 98},
  [2906] = {.lex_state = 98},
  [2907] = {.lex_state = 98, .external_lex_state = 4},
  [2908] = {.lex_state = 98, .external_lex_state = 4},
  [2909] = {.lex_state = 98},
  [2910] = {.lex_state = 99},
  [2911] = {.lex_state = 98, .external_lex_state = 4},
  [2912] = {.lex_state = 97},
  [2913] = {.lex_state = 97},
  [2914] = {.lex_state = 98, .external_lex_state = 4},
  [2915] = {.lex_state = 100, .external_lex_state = 4},
  [2916] = {.lex_state = 98, .external_lex_state = 4},
  [2917] = {.lex_state = 98},
  [2918] = {.lex_state = 15},
  [2919] = {.lex_state = 98, .external_lex_state = 5},
  [2920] = {.lex_state = 97},
  [2921] = {.lex_state = 99},
  [2922] = {.lex_state = 99},
  [2923] = {.lex_state = 98, .external_lex_state = 5},
  [2924] = {.lex_state = 98, .external_lex_state = 5},
  [2925] = {.lex_state = 99},
  [2926] = {.lex_state = 100},
  [2927] = {.lex_state = 98, .external_lex_state = 5},
  [2928] = {.lex_state = 98, .external_lex_state = 4},
  [2929] = {.lex_state = 100},
  [2930] = {.lex_state = 103},
  [2931] = {.lex_state = 97},
  [2932] = {.lex_state = 98, .external_lex_state = 5},
  [2933] = {.lex_state = 15},
  [2934] = {.lex_state = 98, .external_lex_state = 5},
  [2935] = {.lex_state = 98, .external_lex_state = 5},
  [2936] = {.lex_state = 98, .external_lex_state = 5},
  [2937] = {.lex_state = 98, .external_lex_state = 5},
  [2938] = {.lex_state = 98, .external_lex_state = 5},
  [2939] = {.lex_state = 98, .external_lex_state = 5},
  [2940] = {.lex_state = 99},
  [2941] = {.lex_state = 98},
  [2942] = {.lex_state = 98},
  [2943] = {.lex_state = 99},
  [2944] = {.lex_state = 98, .external_lex_state = 5},
  [2945] = {.lex_state = 99},
  [2946] = {.lex_state = 100},
  [2947] = {.lex_state = 100},
  [2948] = {.lex_state = 99},
  [2949] = {.lex_state = 15},
  [2950] = {.lex_state = 98, .external_lex_state = 5},
  [2951] = {.lex_state = 98, .external_lex_state = 5},
  [2952] = {.lex_state = 100},
  [2953] = {.lex_state = 98, .external_lex_state = 5},
  [2954] = {.lex_state = 97},
  [2955] = {.lex_state = 98, .external_lex_state = 5},
  [2956] = {.lex_state = 98, .external_lex_state = 5},
  [2957] = {.lex_state = 98, .external_lex_state = 5},
  [2958] = {.lex_state = 98, .external_lex_state = 4},
  [2959] = {.lex_state = 98, .external_lex_state = 5},
  [2960] = {.lex_state = 98, .external_lex_state = 5},
  [2961] = {.lex_state = 98, .external_lex_state = 5},
  [2962] = {.lex_state = 98, .external_lex_state = 5},
  [2963] = {.lex_state = 98, .external_lex_state = 5},
  [2964] = {.lex_state = 97},
  [2965] = {.lex_state = 99},
  [2966] = {.lex_state = 98},
  [2967] = {.lex_state = 98, .external_lex_state = 5},
  [2968] = {.lex_state = 96, .external_lex_state = 4},
  [2969] = {.lex_state = 98, .external_lex_state = 5},
  [2970] = {.lex_state = 97},
  [2971] = {.lex_state = 0, .external_lex_state = 4},
  [2972] = {.lex_state = 99},
  [2973] = {.lex_state = 99},
  [2974] = {.lex_state = 0, .external_lex_state = 4},
  [2975] = {.lex_state = 98, .external_lex_state = 5},
  [2976] = {.lex_state = 98, .external_lex_state = 5},
  [2977] = {.lex_state = 98, .external_lex_state = 5},
  [2978] = {.lex_state = 98},
  [2979] = {.lex_state = 100},
  [2980] = {.lex_state = 98, .external_lex_state = 5},
  [2981] = {.lex_state = 98, .external_lex_state = 4},
  [2982] = {.lex_state = 98, .external_lex_state = 5},
  [2983] = {.lex_state = 98, .external_lex_state = 5},
  [2984] = {.lex_state = 98, .external_lex_state = 5},
  [2985] = {.lex_state = 98, .external_lex_state = 5},
  [2986] = {.lex_state = 98, .external_lex_state = 5},
  [2987] = {.lex_state = 98, .external_lex_state = 5},
  [2988] = {.lex_state = 98, .external_lex_state = 5},
  [2989] = {.lex_state = 98, .external_lex_state = 5},
  [2990] = {.lex_state = 98, .external_lex_state = 5},
  [2991] = {.lex_state = 98, .external_lex_state = 5},
  [2992] = {.lex_state = 98, .external_lex_state = 4},
  [2993] = {.lex_state = 98, .external_lex_state = 4},
  [2994] = {.lex_state = 98, .external_lex_state = 5},
  [2995] = {.lex_state = 98, .external_lex_state = 4},
  [2996] = {.lex_state = 99},
  [2997] = {.lex_state = 98, .external_lex_state = 4},
  [2998] = {.lex_state = 99},
  [2999] = {.lex_state = 98, .external_lex_state = 5},
  [3000] = {.lex_state = 99},
  [3001] = {.lex_state = 98, .external_lex_state = 5},
  [3002] = {.lex_state = 96},
  [3003] = {.lex_state = 99},
  [3004] = {.lex_state = 98, .external_lex_state = 5},
  [3005] = {.lex_state = 98, .external_lex_state = 5},
  [3006] = {.lex_state = 98, .external_lex_state = 5},
  [3007] = {.lex_state = 100},
  [3008] = {.lex_state = 99},
  [3009] = {.lex_state = 100},
  [3010] = {.lex_state = 98, .external_lex_state = 5},
  [3011] = {.lex_state = 97},
  [3012] = {.lex_state = 98, .external_lex_state = 5},
  [3013] = {.lex_state = 96, .external_lex_state = 4},
  [3014] = {.lex_state = 98, .external_lex_state = 5},
  [3015] = {.lex_state = 98, .external_lex_state = 5},
  [3016] = {.lex_state = 19, .external_lex_state = 6},
  [3017] = {.lex_state = 98, .external_lex_state = 4},
  [3018] = {.lex_state = 98, .external_lex_state = 5},
  [3019] = {.lex_state = 98},
  [3020] = {.lex_state = 19, .external_lex_state = 6},
  [3021] = {.lex_state = 19, .external_lex_state = 6},
  [3022] = {.lex_state = 100},
  [3023] = {.lex_state = 98, .external_lex_state = 4},
  [3024] = {.lex_state = 19, .external_lex_state = 6},
  [3025] = {.lex_state = 98, .external_lex_state = 4},
  [3026] = {.lex_state = 19, .external_lex_state = 6},
  [3027] = {.lex_state = 98, .external_lex_state = 4},
  [3028] = {.lex_state = 98, .external_lex_state = 4},
  [3029] = {.lex_state = 103},
  [3030] = {.lex_state = 98},
  [3031] = {.lex_state = 96, .external_lex_state = 4},
  [3032] = {.lex_state = 98, .external_lex_state = 4},
  [3033] = {.lex_state = 98},
  [3034] = {.lex_state = 98},
  [3035] = {.lex_state = 103},
  [3036] = {.lex_state = 98},
  [3037] = {.lex_state = 98},
  [3038] = {.lex_state = 97},
  [3039] = {.lex_state = 19},
  [3040] = {.lex_state = 0, .external_lex_state = 4},
  [3041] = {.lex_state = 98, .external_lex_state = 4},
  [3042] = {.lex_state = 98},
  [3043] = {.lex_state = 98, .external_lex_state = 4},
  [3044] = {.lex_state = 98},
  [3045] = {.lex_state = 98, .external_lex_state = 4},
  [3046] = {.lex_state = 98},
  [3047] = {.lex_state = 98},
  [3048] = {.lex_state = 98},
  [3049] = {.lex_state = 98},
  [3050] = {.lex_state = 98, .external_lex_state = 4},
  [3051] = {.lex_state = 98, .external_lex_state = 4},
  [3052] = {.lex_state = 103},
  [3053] = {.lex_state = 0, .external_lex_state = 4},
  [3054] = {.lex_state = 98},
  [3055] = {.lex_state = 98},
  [3056] = {.lex_state = 100},
  [3057] = {.lex_state = 100},
  [3058] = {.lex_state = 98},
  [3059] = {.lex_state = 103},
  [3060] = {.lex_state = 98},
  [3061] = {.lex_state = 96, .external_lex_state = 4},
  [3062] = {.lex_state = 0, .external_lex_state = 4},
  [3063] = {.lex_state = 0, .external_lex_state = 4},
  [3064] = {.lex_state = 98},
  [3065] = {.lex_state = 98},
  [3066] = {.lex_state = 98},
  [3067] = {.lex_state = 96},
  [3068] = {.lex_state = 98},
  [3069] = {.lex_state = 98},
  [3070] = {.lex_state = 98},
  [3071] = {.lex_state = 100},
  [3072] = {.lex_state = 98, .external_lex_state = 4},
  [3073] = {.lex_state = 98},
  [3074] = {.lex_state = 103},
  [3075] = {.lex_state = 98},
  [3076] = {.lex_state = 0, .external_lex_state = 4},
  [3077] = {.lex_state = 98},
  [3078] = {.lex_state = 96, .external_lex_state = 4},
  [3079] = {.lex_state = 98, .external_lex_state = 4},
  [3080] = {.lex_state = 98},
  [3081] = {.lex_state = 0, .external_lex_state = 4},
  [3082] = {.lex_state = 98, .external_lex_state = 4},
  [3083] = {.lex_state = 100},
  [3084] = {.lex_state = 100},
  [3085] = {.lex_state = 103},
  [3086] = {.lex_state = 97},
  [3087] = {.lex_state = 98, .external_lex_state = 4},
  [3088] = {.lex_state = 100},
  [3089] = {.lex_state = 98, .external_lex_state = 4},
  [3090] = {.lex_state = 0, .external_lex_state = 4},
  [3091] = {.lex_state = 103},
  [3092] = {.lex_state = 96, .external_lex_state = 4},
  [3093] = {.lex_state = 98},
  [3094] = {.lex_state = 98},
  [3095] = {.lex_state = 100},
  [3096] = {.lex_state = 96, .external_lex_state = 4},
  [3097] = {.lex_state = 96, .external_lex_state = 4},
  [3098] = {.lex_state = 98, .external_lex_state = 4},
  [3099] = {.lex_state = 98, .external_lex_state = 4},
  [3100] = {.lex_state = 98},
  [3101] = {.lex_state = 98},
  [3102] = {.lex_state = 98},
  [3103] = {.lex_state = 100},
  [3104] = {.lex_state = 98},
  [3105] = {.lex_state = 98, .external_lex_state = 4},
  [3106] = {.lex_state = 103},
  [3107] = {.lex_state = 100},
  [3108] = {.lex_state = 98, .external_lex_state = 4},
  [3109] = {.lex_state = 97},
  [3110] = {.lex_state = 100},
  [3111] = {.lex_state = 0, .external_lex_state = 4},
  [3112] = {.lex_state = 96, .external_lex_state = 4},
  [3113] = {.lex_state = 98, .external_lex_state = 4},
  [3114] = {.lex_state = 98, .external_lex_state = 4},
  [3115] = {.lex_state = 98, .external_lex_state = 4},
  [3116] = {.lex_state = 98},
  [3117] = {.lex_state = 100},
  [3118] = {.lex_state = 98},
  [3119] = {.lex_state = 100},
  [3120] = {.lex_state = 100},
  [3121] = {.lex_state = 98},
  [3122] = {.lex_state = 100},
  [3123] = {.lex_state = 98, .external_lex_state = 4},
  [3124] = {.lex_state = 98, .external_lex_state = 4},
  [3125] = {.lex_state = 100},
  [3126] = {.lex_state = 98, .external_lex_state = 4},
  [3127] = {.lex_state = 98, .external_lex_state = 4},
  [3128] = {.lex_state = 103},
  [3129] = {.lex_state = 103},
  [3130] = {.lex_state = 98, .external_lex_state = 4},
  [3131] = {.lex_state = 98, .external_lex_state = 4},
  [3132] = {.lex_state = 98, .external_lex_state = 4},
  [3133] = {.lex_state = 103},
  [3134] = {.lex_state = 97},
  [3135] = {.lex_state = 96},
  [3136] = {.lex_state = 0, .external_lex_state = 4},
  [3137] = {.lex_state = 96, .external_lex_state = 4},
  [3138] = {.lex_state = 98},
  [3139] = {.lex_state = 98},
  [3140] = {.lex_state = 98},
  [3141] = {.lex_state = 0, .external_lex_state = 4},
  [3142] = {.lex_state = 100},
  [3143] = {.lex_state = 100},
  [3144] = {.lex_state = 103},
  [3145] = {.lex_state = 0, .external_lex_state = 4},
  [3146] = {.lex_state = 100},
  [3147] = {.lex_state = 96},
  [3148] = {.lex_state = 98, .external_lex_state = 5},
  [3149] = {.lex_state = 98, .external_lex_state = 5},
  [3150] = {.lex_state = 98, .external_lex_state = 5},
  [3151] = {.lex_state = 98, .external_lex_state = 5},
  [3152] = {.lex_state = 21, .external_lex_state = 6},
  [3153] = {.lex_state = 100},
  [3154] = {.lex_state = 0, .external_lex_state = 4},
  [3155] = {.lex_state = 100},
  [3156] = {.lex_state = 0, .external_lex_state = 4},
  [3157] = {.lex_state = 98},
  [3158] = {.lex_state = 98},
  [3159] = {.lex_state = 98, .external_lex_state = 5},
  [3160] = {.lex_state = 0, .external_lex_state = 4},
  [3161] = {.lex_state = 19, .external_lex_state = 6},
  [3162] = {.lex_state = 103},
  [3163] = {.lex_state = 19},
  [3164] = {.lex_state = 103},
  [3165] = {.lex_state = 19},
  [3166] = {.lex_state = 100},
  [3167] = {.lex_state = 103},
  [3168] = {.lex_state = 100},
  [3169] = {.lex_state = 98, .external_lex_state = 5},
  [3170] = {.lex_state = 98, .external_lex_state = 5},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 98, .external_lex_state = 5},
  [3173] = {.lex_state = 98, .external_lex_state = 5},
  [3174] = {.lex_state = 98},
  [3175] = {.lex_state = 100},
  [3176] = {.lex_state = 0, .external_lex_state = 4},
  [3177] = {.lex_state = 100},
  [3178] = {.lex_state = 0, .external_lex_state = 4},
  [3179] = {.lex_state = 100},
  [3180] = {.lex_state = 100},
  [3181] = {.lex_state = 0, .external_lex_state = 4},
  [3182] = {.lex_state = 98},
  [3183] = {.lex_state = 98, .external_lex_state = 5},
  [3184] = {.lex_state = 0, .external_lex_state = 4},
  [3185] = {.lex_state = 0, .external_lex_state = 4},
  [3186] = {.lex_state = 100},
  [3187] = {.lex_state = 100},
  [3188] = {.lex_state = 100},
  [3189] = {.lex_state = 21, .external_lex_state = 6},
  [3190] = {.lex_state = 103},
  [3191] = {.lex_state = 100},
  [3192] = {.lex_state = 98, .external_lex_state = 5},
  [3193] = {.lex_state = 96},
  [3194] = {.lex_state = 96},
  [3195] = {.lex_state = 0, .external_lex_state = 4},
  [3196] = {.lex_state = 19, .external_lex_state = 6},
  [3197] = {.lex_state = 100},
  [3198] = {.lex_state = 100},
  [3199] = {.lex_state = 98},
  [3200] = {.lex_state = 100},
  [3201] = {.lex_state = 96},
  [3202] = {.lex_state = 97},
  [3203] = {.lex_state = 100},
  [3204] = {.lex_state = 96},
  [3205] = {.lex_state = 96},
  [3206] = {.lex_state = 21, .external_lex_state = 6},
  [3207] = {.lex_state = 19, .external_lex_state = 6},
  [3208] = {.lex_state = 96},
  [3209] = {.lex_state = 0, .external_lex_state = 4},
  [3210] = {.lex_state = 100},
  [3211] = {.lex_state = 19, .external_lex_state = 6},
  [3212] = {.lex_state = 98, .external_lex_state = 5},
  [3213] = {.lex_state = 0, .external_lex_state = 4},
  [3214] = {.lex_state = 100},
  [3215] = {.lex_state = 98},
  [3216] = {.lex_state = 98, .external_lex_state = 5},
  [3217] = {.lex_state = 100},
  [3218] = {.lex_state = 100},
  [3219] = {.lex_state = 103},
  [3220] = {.lex_state = 100},
  [3221] = {.lex_state = 0, .external_lex_state = 4},
  [3222] = {.lex_state = 96},
  [3223] = {.lex_state = 98, .external_lex_state = 5},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 98, .external_lex_state = 4},
  [3226] = {.lex_state = 96},
  [3227] = {.lex_state = 19, .external_lex_state = 6},
  [3228] = {.lex_state = 98, .external_lex_state = 5},
  [3229] = {.lex_state = 19, .external_lex_state = 6},
  [3230] = {.lex_state = 100},
  [3231] = {.lex_state = 21, .external_lex_state = 6},
  [3232] = {.lex_state = 97},
  [3233] = {.lex_state = 19, .external_lex_state = 6},
  [3234] = {.lex_state = 100},
  [3235] = {.lex_state = 98, .external_lex_state = 5},
  [3236] = {.lex_state = 100},
  [3237] = {.lex_state = 21, .external_lex_state = 6},
  [3238] = {.lex_state = 103},
  [3239] = {.lex_state = 0, .external_lex_state = 4},
  [3240] = {.lex_state = 19, .external_lex_state = 6},
  [3241] = {.lex_state = 19},
  [3242] = {.lex_state = 100},
  [3243] = {.lex_state = 96},
  [3244] = {.lex_state = 96},
  [3245] = {.lex_state = 98},
  [3246] = {.lex_state = 96},
  [3247] = {.lex_state = 103},
  [3248] = {.lex_state = 19, .external_lex_state = 6},
  [3249] = {.lex_state = 98},
  [3250] = {.lex_state = 0, .external_lex_state = 4},
  [3251] = {.lex_state = 100},
  [3252] = {.lex_state = 100},
  [3253] = {.lex_state = 98},
  [3254] = {.lex_state = 0, .external_lex_state = 4},
  [3255] = {.lex_state = 98, .external_lex_state = 5},
  [3256] = {.lex_state = 100},
  [3257] = {.lex_state = 19},
  [3258] = {.lex_state = 98, .external_lex_state = 5},
  [3259] = {.lex_state = 0, .external_lex_state = 4},
  [3260] = {.lex_state = 97},
  [3261] = {.lex_state = 98, .external_lex_state = 5},
  [3262] = {.lex_state = 19, .external_lex_state = 6},
  [3263] = {.lex_state = 98, .external_lex_state = 5},
  [3264] = {.lex_state = 21, .external_lex_state = 6},
  [3265] = {.lex_state = 100},
  [3266] = {.lex_state = 98},
  [3267] = {.lex_state = 98},
  [3268] = {.lex_state = 19},
  [3269] = {.lex_state = 19},
  [3270] = {.lex_state = 98, .external_lex_state = 5},
  [3271] = {.lex_state = 98},
  [3272] = {.lex_state = 98},
  [3273] = {.lex_state = 100},
  [3274] = {.lex_state = 98},
  [3275] = {.lex_state = 103},
  [3276] = {.lex_state = 98, .external_lex_state = 5},
  [3277] = {.lex_state = 100},
  [3278] = {.lex_state = 98, .external_lex_state = 4},
  [3279] = {.lex_state = 98, .external_lex_state = 4},
  [3280] = {.lex_state = 98},
  [3281] = {.lex_state = 0, .external_lex_state = 4},
  [3282] = {.lex_state = 19},
  [3283] = {.lex_state = 100},
  [3284] = {.lex_state = 100},
  [3285] = {.lex_state = 19, .external_lex_state = 6},
  [3286] = {.lex_state = 19, .external_lex_state = 6},
  [3287] = {.lex_state = 21, .external_lex_state = 6},
  [3288] = {.lex_state = 97},
  [3289] = {.lex_state = 103},
  [3290] = {.lex_state = 98, .external_lex_state = 5},
  [3291] = {.lex_state = 98},
  [3292] = {.lex_state = 98},
  [3293] = {.lex_state = 100},
  [3294] = {.lex_state = 0, .external_lex_state = 4},
  [3295] = {.lex_state = 98},
  [3296] = {.lex_state = 0},
  [3297] = {.lex_state = 96},
  [3298] = {.lex_state = 96},
  [3299] = {.lex_state = 0, .external_lex_state = 4},
  [3300] = {.lex_state = 0, .external_lex_state = 4},
  [3301] = {.lex_state = 0, .external_lex_state = 4},
  [3302] = {.lex_state = 98},
  [3303] = {.lex_state = 100},
  [3304] = {.lex_state = 96},
  [3305] = {.lex_state = 100},
  [3306] = {.lex_state = 103},
  [3307] = {.lex_state = 96},
  [3308] = {.lex_state = 103},
  [3309] = {.lex_state = 98, .external_lex_state = 5},
  [3310] = {.lex_state = 98, .external_lex_state = 5},
  [3311] = {.lex_state = 0, .external_lex_state = 4},
  [3312] = {.lex_state = 0, .external_lex_state = 4},
  [3313] = {.lex_state = 98, .external_lex_state = 5},
  [3314] = {.lex_state = 103},
  [3315] = {.lex_state = 97},
  [3316] = {.lex_state = 19},
  [3317] = {.lex_state = 0, .external_lex_state = 4},
  [3318] = {.lex_state = 0, .external_lex_state = 4},
  [3319] = {.lex_state = 103},
  [3320] = {.lex_state = 19},
  [3321] = {.lex_state = 21, .external_lex_state = 6},
  [3322] = {.lex_state = 98, .external_lex_state = 5},
  [3323] = {.lex_state = 0, .external_lex_state = 4},
  [3324] = {.lex_state = 100},
  [3325] = {.lex_state = 98},
  [3326] = {.lex_state = 19, .external_lex_state = 6},
  [3327] = {.lex_state = 0, .external_lex_state = 4},
  [3328] = {.lex_state = 21, .external_lex_state = 6},
  [3329] = {.lex_state = 98},
  [3330] = {.lex_state = 19, .external_lex_state = 6},
  [3331] = {.lex_state = 98},
  [3332] = {.lex_state = 98, .external_lex_state = 4},
  [3333] = {.lex_state = 96, .external_lex_state = 4},
  [3334] = {.lex_state = 19},
  [3335] = {.lex_state = 19, .external_lex_state = 6},
  [3336] = {.lex_state = 100},
  [3337] = {.lex_state = 19, .external_lex_state = 6},
  [3338] = {.lex_state = 98},
  [3339] = {.lex_state = 96},
  [3340] = {.lex_state = 19, .external_lex_state = 6},
  [3341] = {.lex_state = 100},
  [3342] = {.lex_state = 100},
  [3343] = {.lex_state = 100},
  [3344] = {.lex_state = 19, .external_lex_state = 6},
  [3345] = {.lex_state = 98, .external_lex_state = 5},
  [3346] = {.lex_state = 100},
  [3347] = {.lex_state = 100},
  [3348] = {.lex_state = 97},
  [3349] = {.lex_state = 0, .external_lex_state = 4},
  [3350] = {.lex_state = 0, .external_lex_state = 4},
  [3351] = {.lex_state = 100},
  [3352] = {.lex_state = 96},
  [3353] = {.lex_state = 0, .external_lex_state = 4},
  [3354] = {.lex_state = 19, .external_lex_state = 6},
  [3355] = {.lex_state = 0, .external_lex_state = 4},
  [3356] = {.lex_state = 100},
  [3357] = {.lex_state = 0},
  [3358] = {.lex_state = 0, .external_lex_state = 4},
  [3359] = {.lex_state = 0, .external_lex_state = 4},
  [3360] = {.lex_state = 0, .external_lex_state = 4},
  [3361] = {.lex_state = 98},
  [3362] = {.lex_state = 0, .external_lex_state = 4},
  [3363] = {.lex_state = 0, .external_lex_state = 4},
  [3364] = {.lex_state = 0, .external_lex_state = 4},
  [3365] = {.lex_state = 96},
  [3366] = {.lex_state = 0, .external_lex_state = 4},
  [3367] = {.lex_state = 19, .external_lex_state = 6},
  [3368] = {.lex_state = 96},
  [3369] = {.lex_state = 98, .external_lex_state = 4},
  [3370] = {.lex_state = 98},
  [3371] = {.lex_state = 19, .external_lex_state = 6},
  [3372] = {.lex_state = 100},
  [3373] = {.lex_state = 0, .external_lex_state = 4},
  [3374] = {.lex_state = 0, .external_lex_state = 4},
  [3375] = {.lex_state = 0, .external_lex_state = 4},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 0, .external_lex_state = 4},
  [3378] = {.lex_state = 96},
  [3379] = {.lex_state = 0},
  [3380] = {.lex_state = 0},
  [3381] = {.lex_state = 0, .external_lex_state = 4},
  [3382] = {.lex_state = 0, .external_lex_state = 4},
  [3383] = {.lex_state = 98, .external_lex_state = 5},
  [3384] = {.lex_state = 0, .external_lex_state = 4},
  [3385] = {.lex_state = 100},
  [3386] = {.lex_state = 0, .external_lex_state = 4},
  [3387] = {.lex_state = 98},
  [3388] = {.lex_state = 0, .external_lex_state = 4},
  [3389] = {.lex_state = 100},
  [3390] = {.lex_state = 100},
  [3391] = {.lex_state = 98, .external_lex_state = 5},
  [3392] = {.lex_state = 0, .external_lex_state = 4},
  [3393] = {.lex_state = 96},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0, .external_lex_state = 4},
  [3396] = {.lex_state = 98},
  [3397] = {.lex_state = 98},
  [3398] = {.lex_state = 98},
  [3399] = {.lex_state = 100},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 19, .external_lex_state = 6},
  [3402] = {.lex_state = 96},
  [3403] = {.lex_state = 98},
  [3404] = {.lex_state = 19, .external_lex_state = 6},
  [3405] = {.lex_state = 100},
  [3406] = {.lex_state = 100},
  [3407] = {.lex_state = 100},
  [3408] = {.lex_state = 98},
  [3409] = {.lex_state = 0, .external_lex_state = 4},
  [3410] = {.lex_state = 100},
  [3411] = {.lex_state = 100},
  [3412] = {.lex_state = 0, .external_lex_state = 4},
  [3413] = {.lex_state = 0, .external_lex_state = 4},
  [3414] = {.lex_state = 100},
  [3415] = {.lex_state = 19, .external_lex_state = 6},
  [3416] = {.lex_state = 0, .external_lex_state = 4},
  [3417] = {.lex_state = 0, .external_lex_state = 4},
  [3418] = {.lex_state = 100},
  [3419] = {.lex_state = 100},
  [3420] = {.lex_state = 96},
  [3421] = {.lex_state = 0, .external_lex_state = 4},
  [3422] = {.lex_state = 0, .external_lex_state = 4},
  [3423] = {.lex_state = 0, .external_lex_state = 4},
  [3424] = {.lex_state = 0, .external_lex_state = 4},
  [3425] = {.lex_state = 0, .external_lex_state = 4},
  [3426] = {.lex_state = 98, .external_lex_state = 4},
  [3427] = {.lex_state = 0, .external_lex_state = 4},
  [3428] = {.lex_state = 96, .external_lex_state = 4},
  [3429] = {.lex_state = 96, .external_lex_state = 4},
  [3430] = {.lex_state = 98},
  [3431] = {.lex_state = 98},
  [3432] = {.lex_state = 98},
  [3433] = {.lex_state = 100},
  [3434] = {.lex_state = 0},
  [3435] = {.lex_state = 0, .external_lex_state = 4},
  [3436] = {.lex_state = 0},
  [3437] = {.lex_state = 0, .external_lex_state = 4},
  [3438] = {.lex_state = 98},
  [3439] = {.lex_state = 96},
  [3440] = {.lex_state = 0, .external_lex_state = 4},
  [3441] = {.lex_state = 0, .external_lex_state = 4},
  [3442] = {.lex_state = 0, .external_lex_state = 4},
  [3443] = {.lex_state = 100},
  [3444] = {.lex_state = 100},
  [3445] = {.lex_state = 0, .external_lex_state = 4},
  [3446] = {.lex_state = 19, .external_lex_state = 6},
  [3447] = {.lex_state = 0, .external_lex_state = 4},
  [3448] = {.lex_state = 100},
  [3449] = {.lex_state = 100},
  [3450] = {.lex_state = 100},
  [3451] = {.lex_state = 96},
  [3452] = {.lex_state = 0, .external_lex_state = 4},
  [3453] = {.lex_state = 96},
  [3454] = {.lex_state = 100},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 100},
  [3457] = {.lex_state = 98},
  [3458] = {.lex_state = 0, .external_lex_state = 4},
  [3459] = {.lex_state = 0},
  [3460] = {.lex_state = 98},
  [3461] = {.lex_state = 100},
  [3462] = {.lex_state = 100},
  [3463] = {.lex_state = 100},
  [3464] = {.lex_state = 100},
  [3465] = {.lex_state = 100},
  [3466] = {.lex_state = 96},
  [3467] = {.lex_state = 100},
  [3468] = {.lex_state = 98, .external_lex_state = 5},
  [3469] = {.lex_state = 98},
  [3470] = {.lex_state = 98},
  [3471] = {.lex_state = 98},
  [3472] = {.lex_state = 98, .external_lex_state = 5},
  [3473] = {.lex_state = 98, .external_lex_state = 5},
  [3474] = {.lex_state = 98, .external_lex_state = 5},
  [3475] = {.lex_state = 98},
  [3476] = {.lex_state = 96},
  [3477] = {.lex_state = 98},
  [3478] = {.lex_state = 19, .external_lex_state = 6},
  [3479] = {.lex_state = 100},
  [3480] = {.lex_state = 96},
  [3481] = {.lex_state = 100},
  [3482] = {.lex_state = 100},
  [3483] = {.lex_state = 100},
  [3484] = {.lex_state = 100},
  [3485] = {.lex_state = 98},
  [3486] = {.lex_state = 98, .external_lex_state = 5},
  [3487] = {.lex_state = 0, .external_lex_state = 4},
  [3488] = {.lex_state = 19, .external_lex_state = 6},
  [3489] = {.lex_state = 0, .external_lex_state = 4},
  [3490] = {.lex_state = 19, .external_lex_state = 6},
  [3491] = {.lex_state = 98},
  [3492] = {.lex_state = 100},
  [3493] = {.lex_state = 98},
  [3494] = {.lex_state = 100},
  [3495] = {.lex_state = 0, .external_lex_state = 4},
  [3496] = {.lex_state = 19},
  [3497] = {.lex_state = 0, .external_lex_state = 4},
  [3498] = {.lex_state = 0, .external_lex_state = 4},
  [3499] = {.lex_state = 0, .external_lex_state = 4},
  [3500] = {.lex_state = 0},
  [3501] = {.lex_state = 100},
  [3502] = {.lex_state = 100},
  [3503] = {.lex_state = 100},
  [3504] = {.lex_state = 96},
  [3505] = {.lex_state = 100},
  [3506] = {.lex_state = 0, .external_lex_state = 4},
  [3507] = {.lex_state = 98, .external_lex_state = 5},
  [3508] = {.lex_state = 98},
  [3509] = {.lex_state = 98, .external_lex_state = 5},
  [3510] = {.lex_state = 98, .external_lex_state = 5},
  [3511] = {.lex_state = 98, .external_lex_state = 5},
  [3512] = {.lex_state = 100},
  [3513] = {.lex_state = 96},
  [3514] = {.lex_state = 96},
  [3515] = {.lex_state = 0},
  [3516] = {.lex_state = 0},
  [3517] = {.lex_state = 0},
  [3518] = {.lex_state = 0, .external_lex_state = 4},
  [3519] = {.lex_state = 100},
  [3520] = {.lex_state = 100},
  [3521] = {.lex_state = 0, .external_lex_state = 4},
  [3522] = {.lex_state = 0, .external_lex_state = 4},
  [3523] = {.lex_state = 0, .external_lex_state = 4},
  [3524] = {.lex_state = 97},
  [3525] = {.lex_state = 100},
  [3526] = {.lex_state = 0, .external_lex_state = 4},
  [3527] = {.lex_state = 100},
  [3528] = {.lex_state = 98},
  [3529] = {.lex_state = 0, .external_lex_state = 4},
  [3530] = {.lex_state = 98, .external_lex_state = 4},
  [3531] = {.lex_state = 96},
  [3532] = {.lex_state = 100},
  [3533] = {.lex_state = 100},
  [3534] = {.lex_state = 98},
  [3535] = {.lex_state = 100},
  [3536] = {.lex_state = 0, .external_lex_state = 4},
  [3537] = {.lex_state = 0, .external_lex_state = 4},
  [3538] = {.lex_state = 100},
  [3539] = {.lex_state = 0, .external_lex_state = 4},
  [3540] = {.lex_state = 0, .external_lex_state = 4},
  [3541] = {.lex_state = 0, .external_lex_state = 4},
  [3542] = {.lex_state = 98},
  [3543] = {.lex_state = 0, .external_lex_state = 4},
  [3544] = {.lex_state = 100},
  [3545] = {.lex_state = 4},
  [3546] = {.lex_state = 96},
  [3547] = {.lex_state = 17},
  [3548] = {.lex_state = 100},
  [3549] = {.lex_state = 1},
  [3550] = {.lex_state = 100},
  [3551] = {.lex_state = 98},
  [3552] = {.lex_state = 23},
  [3553] = {.lex_state = 17},
  [3554] = {.lex_state = 98},
  [3555] = {.lex_state = 98},
  [3556] = {.lex_state = 4},
  [3557] = {.lex_state = 96},
  [3558] = {.lex_state = 96},
  [3559] = {.lex_state = 98},
  [3560] = {.lex_state = 17},
  [3561] = {.lex_state = 23},
  [3562] = {.lex_state = 0},
  [3563] = {.lex_state = 100},
  [3564] = {.lex_state = 100},
  [3565] = {.lex_state = 100},
  [3566] = {.lex_state = 17},
  [3567] = {.lex_state = 23},
  [3568] = {.lex_state = 4},
  [3569] = {.lex_state = 100},
  [3570] = {.lex_state = 98},
  [3571] = {.lex_state = 98},
  [3572] = {.lex_state = 1},
  [3573] = {.lex_state = 98},
  [3574] = {.lex_state = 100},
  [3575] = {.lex_state = 0, .external_lex_state = 4},
  [3576] = {.lex_state = 0, .external_lex_state = 4},
  [3577] = {.lex_state = 17},
  [3578] = {.lex_state = 98},
  [3579] = {.lex_state = 100},
  [3580] = {.lex_state = 17},
  [3581] = {.lex_state = 98},
  [3582] = {.lex_state = 23},
  [3583] = {.lex_state = 23},
  [3584] = {.lex_state = 4},
  [3585] = {.lex_state = 17},
  [3586] = {.lex_state = 0, .external_lex_state = 5},
  [3587] = {.lex_state = 100},
  [3588] = {.lex_state = 98},
  [3589] = {.lex_state = 98},
  [3590] = {.lex_state = 4},
  [3591] = {.lex_state = 100},
  [3592] = {.lex_state = 23},
  [3593] = {.lex_state = 98},
  [3594] = {.lex_state = 4},
  [3595] = {.lex_state = 96},
  [3596] = {.lex_state = 98},
  [3597] = {.lex_state = 98},
  [3598] = {.lex_state = 0},
  [3599] = {.lex_state = 100},
  [3600] = {.lex_state = 98},
  [3601] = {.lex_state = 98},
  [3602] = {.lex_state = 0, .external_lex_state = 4},
  [3603] = {.lex_state = 23},
  [3604] = {.lex_state = 0},
  [3605] = {.lex_state = 17},
  [3606] = {.lex_state = 21, .external_lex_state = 6},
  [3607] = {.lex_state = 0},
  [3608] = {.lex_state = 23},
  [3609] = {.lex_state = 17},
  [3610] = {.lex_state = 4},
  [3611] = {.lex_state = 98},
  [3612] = {.lex_state = 100},
  [3613] = {.lex_state = 19, .external_lex_state = 6},
  [3614] = {.lex_state = 98},
  [3615] = {.lex_state = 4},
  [3616] = {.lex_state = 98},
  [3617] = {.lex_state = 100},
  [3618] = {.lex_state = 98},
  [3619] = {.lex_state = 98},
  [3620] = {.lex_state = 1},
  [3621] = {.lex_state = 98},
  [3622] = {.lex_state = 98},
  [3623] = {.lex_state = 98},
  [3624] = {.lex_state = 98},
  [3625] = {.lex_state = 98},
  [3626] = {.lex_state = 4},
  [3627] = {.lex_state = 98},
  [3628] = {.lex_state = 98},
  [3629] = {.lex_state = 23},
  [3630] = {.lex_state = 4},
  [3631] = {.lex_state = 17},
  [3632] = {.lex_state = 97},
  [3633] = {.lex_state = 98},
  [3634] = {.lex_state = 0},
  [3635] = {.lex_state = 96},
  [3636] = {.lex_state = 100},
  [3637] = {.lex_state = 4},
  [3638] = {.lex_state = 1},
  [3639] = {.lex_state = 100},
  [3640] = {.lex_state = 100},
  [3641] = {.lex_state = 23},
  [3642] = {.lex_state = 98},
  [3643] = {.lex_state = 0},
  [3644] = {.lex_state = 100},
  [3645] = {.lex_state = 100},
  [3646] = {.lex_state = 100},
  [3647] = {.lex_state = 0, .external_lex_state = 4},
  [3648] = {.lex_state = 0, .external_lex_state = 4},
  [3649] = {.lex_state = 4},
  [3650] = {.lex_state = 98},
  [3651] = {.lex_state = 98},
  [3652] = {.lex_state = 97},
  [3653] = {.lex_state = 98},
  [3654] = {.lex_state = 98},
  [3655] = {.lex_state = 4},
  [3656] = {.lex_state = 97},
  [3657] = {.lex_state = 4},
  [3658] = {.lex_state = 100},
  [3659] = {.lex_state = 23},
  [3660] = {.lex_state = 98},
  [3661] = {.lex_state = 17},
  [3662] = {.lex_state = 23},
  [3663] = {.lex_state = 4},
  [3664] = {.lex_state = 100},
  [3665] = {.lex_state = 98},
  [3666] = {.lex_state = 23},
  [3667] = {.lex_state = 4},
  [3668] = {.lex_state = 98},
  [3669] = {.lex_state = 17},
  [3670] = {.lex_state = 23},
  [3671] = {.lex_state = 17},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 98},
  [3675] = {.lex_state = 0},
  [3676] = {.lex_state = 0},
  [3677] = {.lex_state = 96},
  [3678] = {.lex_state = 96},
  [3679] = {.lex_state = 4},
  [3680] = {.lex_state = 19, .external_lex_state = 6},
  [3681] = {.lex_state = 98},
  [3682] = {.lex_state = 0},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 0},
  [3685] = {.lex_state = 96},
  [3686] = {.lex_state = 98},
  [3687] = {.lex_state = 98},
  [3688] = {.lex_state = 0},
  [3689] = {.lex_state = 98},
  [3690] = {.lex_state = 4},
  [3691] = {.lex_state = 4},
  [3692] = {.lex_state = 1},
  [3693] = {.lex_state = 17},
  [3694] = {.lex_state = 1},
  [3695] = {.lex_state = 98},
  [3696] = {.lex_state = 23},
  [3697] = {.lex_state = 17},
  [3698] = {.lex_state = 98},
  [3699] = {.lex_state = 100},
  [3700] = {.lex_state = 0},
  [3701] = {.lex_state = 4},
  [3702] = {.lex_state = 0, .external_lex_state = 4},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 0},
  [3705] = {.lex_state = 98},
  [3706] = {.lex_state = 96},
  [3707] = {.lex_state = 98},
  [3708] = {.lex_state = 98},
  [3709] = {.lex_state = 0},
  [3710] = {.lex_state = 98},
  [3711] = {.lex_state = 0, .external_lex_state = 4},
  [3712] = {.lex_state = 96},
  [3713] = {.lex_state = 0},
  [3714] = {.lex_state = 0},
  [3715] = {.lex_state = 98},
  [3716] = {.lex_state = 0},
  [3717] = {.lex_state = 0},
  [3718] = {.lex_state = 0},
  [3719] = {.lex_state = 0},
  [3720] = {.lex_state = 0},
  [3721] = {.lex_state = 96},
  [3722] = {.lex_state = 0},
  [3723] = {.lex_state = 96},
  [3724] = {.lex_state = 0},
  [3725] = {.lex_state = 98},
  [3726] = {.lex_state = 98},
  [3727] = {.lex_state = 98},
  [3728] = {.lex_state = 0},
  [3729] = {.lex_state = 0},
  [3730] = {.lex_state = 98},
  [3731] = {.lex_state = 0},
  [3732] = {.lex_state = 0},
  [3733] = {.lex_state = 0},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 96},
  [3736] = {.lex_state = 0},
  [3737] = {.lex_state = 19, .external_lex_state = 6},
  [3738] = {.lex_state = 0},
  [3739] = {.lex_state = 0},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 98},
  [3743] = {.lex_state = 96},
  [3744] = {.lex_state = 0},
  [3745] = {.lex_state = 0},
  [3746] = {.lex_state = 0},
  [3747] = {.lex_state = 0},
  [3748] = {.lex_state = 98},
  [3749] = {.lex_state = 98},
  [3750] = {.lex_state = 0},
  [3751] = {.lex_state = 0},
  [3752] = {.lex_state = 0},
  [3753] = {.lex_state = 98},
  [3754] = {.lex_state = 96},
  [3755] = {.lex_state = 0},
  [3756] = {.lex_state = 0},
  [3757] = {.lex_state = 0},
  [3758] = {.lex_state = 96, .external_lex_state = 4},
  [3759] = {.lex_state = 0},
  [3760] = {.lex_state = 0},
  [3761] = {.lex_state = 0},
  [3762] = {.lex_state = 96, .external_lex_state = 4},
  [3763] = {.lex_state = 0},
  [3764] = {.lex_state = 100},
  [3765] = {.lex_state = 98},
  [3766] = {.lex_state = 96},
  [3767] = {.lex_state = 97},
  [3768] = {.lex_state = 0, .external_lex_state = 4},
  [3769] = {.lex_state = 0, .external_lex_state = 4},
  [3770] = {.lex_state = 0, .external_lex_state = 4},
  [3771] = {.lex_state = 0, .external_lex_state = 4},
  [3772] = {.lex_state = 0, .external_lex_state = 4},
  [3773] = {.lex_state = 0},
  [3774] = {.lex_state = 0, .external_lex_state = 4},
  [3775] = {.lex_state = 0, .external_lex_state = 4},
  [3776] = {.lex_state = 97},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 96},
  [3779] = {.lex_state = 0, .external_lex_state = 4},
  [3780] = {.lex_state = 98},
  [3781] = {.lex_state = 0, .external_lex_state = 4},
  [3782] = {.lex_state = 0},
  [3783] = {.lex_state = 0, .external_lex_state = 4},
  [3784] = {.lex_state = 0, .external_lex_state = 4},
  [3785] = {.lex_state = 0, .external_lex_state = 4},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 98},
  [3788] = {.lex_state = 0},
  [3789] = {.lex_state = 0, .external_lex_state = 4},
  [3790] = {.lex_state = 0},
  [3791] = {.lex_state = 98},
  [3792] = {.lex_state = 98},
  [3793] = {.lex_state = 98},
  [3794] = {.lex_state = 0, .external_lex_state = 4},
  [3795] = {.lex_state = 96},
  [3796] = {.lex_state = 0},
  [3797] = {.lex_state = 0},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 98},
  [3801] = {.lex_state = 0},
  [3802] = {.lex_state = 0},
  [3803] = {.lex_state = 0, .external_lex_state = 4},
  [3804] = {.lex_state = 96},
  [3805] = {.lex_state = 0},
  [3806] = {.lex_state = 98},
  [3807] = {.lex_state = 0, .external_lex_state = 4},
  [3808] = {.lex_state = 0},
  [3809] = {.lex_state = 0},
  [3810] = {.lex_state = 0, .external_lex_state = 4},
  [3811] = {.lex_state = 0},
  [3812] = {.lex_state = 98},
  [3813] = {.lex_state = 0, .external_lex_state = 4},
  [3814] = {.lex_state = 96},
  [3815] = {.lex_state = 0, .external_lex_state = 4},
  [3816] = {.lex_state = 0, .external_lex_state = 4},
  [3817] = {.lex_state = 96},
  [3818] = {.lex_state = 0, .external_lex_state = 4},
  [3819] = {.lex_state = 0, .external_lex_state = 4},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 0, .external_lex_state = 4},
  [3822] = {.lex_state = 96},
  [3823] = {.lex_state = 96},
  [3824] = {.lex_state = 0},
  [3825] = {.lex_state = 0},
  [3826] = {.lex_state = 0},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 0},
  [3830] = {.lex_state = 0},
  [3831] = {.lex_state = 0},
  [3832] = {.lex_state = 98},
  [3833] = {.lex_state = 0},
  [3834] = {.lex_state = 0},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 0},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 0},
  [3839] = {.lex_state = 0},
  [3840] = {.lex_state = 96},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 0},
  [3843] = {.lex_state = 0},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 0},
  [3846] = {.lex_state = 0},
  [3847] = {.lex_state = 97, .external_lex_state = 4},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 98},
  [3850] = {.lex_state = 0},
  [3851] = {.lex_state = 96},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 0},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 96},
  [3856] = {.lex_state = 0, .external_lex_state = 4},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 96},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 0, .external_lex_state = 4},
  [3861] = {.lex_state = 0, .external_lex_state = 4},
  [3862] = {.lex_state = 0, .external_lex_state = 4},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 0},
  [3865] = {.lex_state = 0, .external_lex_state = 4},
  [3866] = {.lex_state = 97, .external_lex_state = 4},
  [3867] = {.lex_state = 96},
  [3868] = {.lex_state = 96},
  [3869] = {.lex_state = 96},
  [3870] = {.lex_state = 0},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 98},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 0},
  [3875] = {.lex_state = 0},
  [3876] = {.lex_state = 1},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 96},
  [3879] = {.lex_state = 0},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 0, .external_lex_state = 4},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 0},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 0, .external_lex_state = 4},
  [3889] = {.lex_state = 0, .external_lex_state = 4},
  [3890] = {.lex_state = 0},
  [3891] = {.lex_state = 0},
  [3892] = {.lex_state = 0, .external_lex_state = 4},
  [3893] = {.lex_state = 98},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 98},
  [3896] = {.lex_state = 0, .external_lex_state = 4},
  [3897] = {.lex_state = 98},
  [3898] = {.lex_state = 0, .external_lex_state = 4},
  [3899] = {.lex_state = 0, .external_lex_state = 4},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 0, .external_lex_state = 4},
  [3902] = {.lex_state = 0},
  [3903] = {.lex_state = 0, .external_lex_state = 4},
  [3904] = {.lex_state = 98},
  [3905] = {.lex_state = 0, .external_lex_state = 4},
  [3906] = {.lex_state = 0, .external_lex_state = 4},
  [3907] = {.lex_state = 0, .external_lex_state = 4},
  [3908] = {.lex_state = 0},
  [3909] = {.lex_state = 0, .external_lex_state = 4},
  [3910] = {.lex_state = 98},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 96},
  [3914] = {.lex_state = 0, .external_lex_state = 4},
  [3915] = {.lex_state = 0},
  [3916] = {.lex_state = 96},
  [3917] = {.lex_state = 96},
  [3918] = {.lex_state = 98},
  [3919] = {.lex_state = 0, .external_lex_state = 4},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 0, .external_lex_state = 4},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 96},
  [3924] = {.lex_state = 96},
  [3925] = {.lex_state = 98},
  [3926] = {.lex_state = 98},
  [3927] = {.lex_state = 0},
  [3928] = {.lex_state = 0},
  [3929] = {.lex_state = 98},
  [3930] = {.lex_state = 98},
  [3931] = {.lex_state = 0},
  [3932] = {.lex_state = 0},
  [3933] = {.lex_state = 0, .external_lex_state = 4},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 98},
  [3937] = {.lex_state = 96},
  [3938] = {.lex_state = 0},
  [3939] = {.lex_state = 0},
  [3940] = {.lex_state = 0},
  [3941] = {.lex_state = 96},
  [3942] = {.lex_state = 0},
  [3943] = {.lex_state = 0, .external_lex_state = 4},
  [3944] = {.lex_state = 0, .external_lex_state = 4},
  [3945] = {.lex_state = 0},
  [3946] = {.lex_state = 0, .external_lex_state = 4},
  [3947] = {.lex_state = 96, .external_lex_state = 4},
  [3948] = {.lex_state = 98},
  [3949] = {.lex_state = 96, .external_lex_state = 4},
  [3950] = {.lex_state = 0, .external_lex_state = 4},
  [3951] = {.lex_state = 98},
  [3952] = {.lex_state = 98},
  [3953] = {.lex_state = 98},
  [3954] = {.lex_state = 98},
  [3955] = {.lex_state = 98},
  [3956] = {.lex_state = 98},
  [3957] = {.lex_state = 96},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 98},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 98},
  [3962] = {.lex_state = 98},
  [3963] = {.lex_state = 96},
  [3964] = {.lex_state = 98},
  [3965] = {.lex_state = 98},
  [3966] = {.lex_state = 0},
  [3967] = {.lex_state = 98},
  [3968] = {.lex_state = 98},
  [3969] = {.lex_state = 98},
  [3970] = {.lex_state = 98},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 98},
  [3973] = {.lex_state = 98},
  [3974] = {.lex_state = 0},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 96},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 96},
  [3979] = {.lex_state = 98},
  [3980] = {.lex_state = 96},
  [3981] = {.lex_state = 96},
  [3982] = {.lex_state = 96},
  [3983] = {.lex_state = 96},
  [3984] = {.lex_state = 0},
  [3985] = {.lex_state = 98},
  [3986] = {.lex_state = 98},
  [3987] = {.lex_state = 96},
  [3988] = {.lex_state = 98},
  [3989] = {.lex_state = 0},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 98},
  [3993] = {.lex_state = 98},
  [3994] = {.lex_state = 0},
  [3995] = {.lex_state = 0},
  [3996] = {.lex_state = 1},
  [3997] = {.lex_state = 96},
  [3998] = {.lex_state = 98},
  [3999] = {.lex_state = 96},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 96},
  [4002] = {.lex_state = 98},
  [4003] = {.lex_state = 96},
  [4004] = {.lex_state = 98},
  [4005] = {.lex_state = 98},
  [4006] = {.lex_state = 96},
  [4007] = {.lex_state = 96},
  [4008] = {.lex_state = 98},
  [4009] = {.lex_state = 96},
  [4010] = {.lex_state = 96},
  [4011] = {.lex_state = 96},
  [4012] = {.lex_state = 98},
  [4013] = {.lex_state = 98},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 0},
  [4016] = {.lex_state = 96},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 96},
  [4019] = {.lex_state = 98},
  [4020] = {.lex_state = 98},
  [4021] = {.lex_state = 96},
  [4022] = {.lex_state = 98},
  [4023] = {.lex_state = 98},
  [4024] = {.lex_state = 98},
  [4025] = {.lex_state = 98},
  [4026] = {.lex_state = 0},
  [4027] = {.lex_state = 98},
  [4028] = {.lex_state = 98},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 98},
  [4031] = {.lex_state = 98},
  [4032] = {.lex_state = 98},
  [4033] = {.lex_state = 96},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 98},
  [4036] = {.lex_state = 98},
  [4037] = {.lex_state = 98},
  [4038] = {.lex_state = 98},
  [4039] = {.lex_state = 98},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 0},
  [4042] = {.lex_state = 0},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 98},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 98},
  [4047] = {.lex_state = 98},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 98},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 96},
  [4053] = {.lex_state = 98},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 98},
  [4056] = {.lex_state = 98},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 96},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 98},
  [4061] = {.lex_state = 98},
  [4062] = {.lex_state = 98},
  [4063] = {.lex_state = 0},
  [4064] = {.lex_state = 96},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 98},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 98},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 98},
  [4071] = {.lex_state = 98},
  [4072] = {.lex_state = 98},
  [4073] = {.lex_state = 98},
  [4074] = {.lex_state = 0, .external_lex_state = 4},
  [4075] = {.lex_state = 0, .external_lex_state = 4},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 96},
  [4078] = {.lex_state = 0},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 96},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 98},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 0},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 98},
  [4092] = {.lex_state = 98},
  [4093] = {.lex_state = 98},
  [4094] = {.lex_state = 0},
  [4095] = {.lex_state = 98},
  [4096] = {.lex_state = 96},
  [4097] = {.lex_state = 0, .external_lex_state = 4},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 98},
  [4101] = {.lex_state = 96},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 98},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 96},
  [4108] = {.lex_state = 96},
  [4109] = {.lex_state = 96},
  [4110] = {.lex_state = 96},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 96},
  [4113] = {.lex_state = 98},
  [4114] = {.lex_state = 98},
  [4115] = {.lex_state = 98},
  [4116] = {.lex_state = 98},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 96},
  [4120] = {.lex_state = 98},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 98},
  [4126] = {.lex_state = 98},
  [4127] = {.lex_state = 98},
  [4128] = {.lex_state = 98},
  [4129] = {.lex_state = 98},
  [4130] = {.lex_state = 98},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 98},
  [4136] = {.lex_state = 0},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 98},
  [4139] = {.lex_state = 0},
  [4140] = {.lex_state = 98},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 98},
  [4143] = {.lex_state = 98},
  [4144] = {.lex_state = 98},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 98},
  [4147] = {.lex_state = 98},
  [4148] = {.lex_state = 98},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 98},
  [4151] = {.lex_state = 98},
  [4152] = {.lex_state = 0, .external_lex_state = 4},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0, .external_lex_state = 4},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0, .external_lex_state = 4},
  [4158] = {.lex_state = 0, .external_lex_state = 4},
  [4159] = {.lex_state = 98},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 98},
  [4162] = {.lex_state = 98},
  [4163] = {.lex_state = 98},
  [4164] = {.lex_state = 98},
  [4165] = {.lex_state = 0, .external_lex_state = 4},
  [4166] = {.lex_state = 98},
  [4167] = {.lex_state = 98},
  [4168] = {.lex_state = 98},
  [4169] = {.lex_state = 98},
  [4170] = {.lex_state = 98},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 98},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 98},
  [4175] = {.lex_state = 98},
  [4176] = {.lex_state = 98},
  [4177] = {.lex_state = 0},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 98},
  [4182] = {.lex_state = 96},
  [4183] = {.lex_state = 96},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 98},
  [4186] = {.lex_state = 96},
  [4187] = {.lex_state = 96},
  [4188] = {.lex_state = 98},
  [4189] = {.lex_state = 96},
  [4190] = {.lex_state = 98},
  [4191] = {.lex_state = 96},
  [4192] = {.lex_state = 0},
  [4193] = {.lex_state = 0},
  [4194] = {.lex_state = 98},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 96},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 98},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 0},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 98},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 98},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 0},
  [4208] = {.lex_state = 98},
  [4209] = {.lex_state = 98},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 98},
  [4212] = {.lex_state = 98},
  [4213] = {.lex_state = 98},
  [4214] = {.lex_state = 98},
  [4215] = {.lex_state = 98},
  [4216] = {.lex_state = 98},
  [4217] = {.lex_state = 98},
  [4218] = {.lex_state = 98},
  [4219] = {.lex_state = 98},
  [4220] = {.lex_state = 98},
  [4221] = {.lex_state = 98},
  [4222] = {.lex_state = 96},
  [4223] = {.lex_state = 0},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 98},
  [4226] = {.lex_state = 98},
  [4227] = {.lex_state = 96},
  [4228] = {.lex_state = 98},
  [4229] = {.lex_state = 98},
  [4230] = {.lex_state = 98},
  [4231] = {.lex_state = 98},
  [4232] = {.lex_state = 98},
  [4233] = {.lex_state = 98},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 98},
  [4237] = {.lex_state = 0},
  [4238] = {.lex_state = 98},
  [4239] = {.lex_state = 98},
  [4240] = {.lex_state = 0},
  [4241] = {.lex_state = 0},
  [4242] = {.lex_state = 98},
  [4243] = {.lex_state = 98},
  [4244] = {.lex_state = 98},
  [4245] = {.lex_state = 98},
  [4246] = {.lex_state = 98},
  [4247] = {.lex_state = 98},
  [4248] = {.lex_state = 98},
  [4249] = {.lex_state = 98},
  [4250] = {.lex_state = 98},
  [4251] = {.lex_state = 0, .external_lex_state = 4},
  [4252] = {.lex_state = 98},
  [4253] = {.lex_state = 98},
  [4254] = {.lex_state = 98},
  [4255] = {.lex_state = 98},
  [4256] = {.lex_state = 98},
  [4257] = {.lex_state = 98},
  [4258] = {.lex_state = 98},
  [4259] = {.lex_state = 98},
  [4260] = {.lex_state = 98},
  [4261] = {.lex_state = 98},
  [4262] = {.lex_state = 98},
  [4263] = {.lex_state = 98},
  [4264] = {.lex_state = 98},
  [4265] = {.lex_state = 98},
  [4266] = {.lex_state = 98},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 98},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 0},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 96},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 98},
  [4277] = {.lex_state = 96},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 96},
  [4280] = {.lex_state = 98},
  [4281] = {.lex_state = 96},
  [4282] = {.lex_state = 0, .external_lex_state = 4},
  [4283] = {.lex_state = 98},
  [4284] = {.lex_state = 98},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 96},
  [4288] = {.lex_state = 96},
  [4289] = {.lex_state = 2},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 0},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 0},
  [4295] = {.lex_state = 96},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 0},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 96},
  [4300] = {.lex_state = 96},
  [4301] = {.lex_state = 97},
  [4302] = {.lex_state = 0},
  [4303] = {.lex_state = 0},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 0},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 0},
  [4309] = {.lex_state = 0},
  [4310] = {.lex_state = 0},
  [4311] = {.lex_state = 0},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 0},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 96},
  [4317] = {.lex_state = 0},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 0},
  [4321] = {.lex_state = 0},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 0},
  [4324] = {.lex_state = 0},
  [4325] = {.lex_state = 0},
  [4326] = {.lex_state = 96},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 0},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 96},
  [4331] = {.lex_state = 0},
  [4332] = {.lex_state = 0},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 96},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 0},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 0},
  [4346] = {.lex_state = 0},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 0},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 0},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 96},
  [4353] = {.lex_state = 0},
  [4354] = {.lex_state = 0},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 0},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0},
  [4359] = {.lex_state = 0},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 0},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 96},
  [4366] = {.lex_state = 0},
  [4367] = {.lex_state = 98},
  [4368] = {.lex_state = 100},
  [4369] = {.lex_state = 0},
  [4370] = {.lex_state = 0},
  [4371] = {.lex_state = 0},
  [4372] = {.lex_state = 96},
  [4373] = {.lex_state = 0},
  [4374] = {.lex_state = 0},
  [4375] = {.lex_state = 96},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 0},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 0},
  [4380] = {.lex_state = 98},
  [4381] = {.lex_state = 96},
  [4382] = {.lex_state = 96},
  [4383] = {.lex_state = 2},
  [4384] = {.lex_state = 96},
  [4385] = {.lex_state = 96},
  [4386] = {.lex_state = 0},
  [4387] = {.lex_state = 96},
  [4388] = {.lex_state = 97},
  [4389] = {.lex_state = 96},
  [4390] = {.lex_state = 0},
  [4391] = {.lex_state = 96},
  [4392] = {.lex_state = 0},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 0},
  [4395] = {.lex_state = 0},
  [4396] = {.lex_state = 96},
  [4397] = {.lex_state = 0},
  [4398] = {.lex_state = 0},
  [4399] = {.lex_state = 2},
  [4400] = {.lex_state = 0},
  [4401] = {.lex_state = 0},
  [4402] = {.lex_state = 96},
  [4403] = {.lex_state = 97},
  [4404] = {.lex_state = 97},
  [4405] = {.lex_state = 0},
  [4406] = {.lex_state = 96},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 0},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 96},
  [4411] = {.lex_state = 2},
  [4412] = {.lex_state = 0},
  [4413] = {.lex_state = 96},
  [4414] = {.lex_state = 2},
  [4415] = {.lex_state = 0},
  [4416] = {.lex_state = 0},
  [4417] = {.lex_state = 96},
  [4418] = {.lex_state = 97},
  [4419] = {.lex_state = 96},
  [4420] = {.lex_state = 0},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 0},
  [4423] = {.lex_state = 96},
  [4424] = {.lex_state = 0},
  [4425] = {.lex_state = 0},
  [4426] = {.lex_state = 0},
  [4427] = {.lex_state = 0},
  [4428] = {.lex_state = 2},
  [4429] = {.lex_state = 96},
  [4430] = {.lex_state = 0},
  [4431] = {.lex_state = 97},
  [4432] = {.lex_state = 0},
  [4433] = {.lex_state = 0},
  [4434] = {.lex_state = 0},
  [4435] = {.lex_state = 0},
  [4436] = {.lex_state = 0},
  [4437] = {.lex_state = 97},
  [4438] = {.lex_state = 97},
  [4439] = {.lex_state = 0},
  [4440] = {.lex_state = 96},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 0},
  [4443] = {.lex_state = 0},
  [4444] = {.lex_state = 0},
  [4445] = {.lex_state = 0},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 0},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 0},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 0},
  [4452] = {.lex_state = 0},
  [4453] = {.lex_state = 0},
  [4454] = {.lex_state = 0},
  [4455] = {.lex_state = 0},
  [4456] = {.lex_state = 0},
  [4457] = {.lex_state = 96},
  [4458] = {.lex_state = 0},
  [4459] = {.lex_state = 0},
  [4460] = {.lex_state = 96},
  [4461] = {.lex_state = 0},
  [4462] = {.lex_state = 0},
  [4463] = {.lex_state = 0},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 0},
  [4466] = {.lex_state = 96},
  [4467] = {.lex_state = 0},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 0},
  [4470] = {.lex_state = 0},
  [4471] = {.lex_state = 96},
  [4472] = {.lex_state = 0},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 0},
  [4476] = {.lex_state = 0},
  [4477] = {.lex_state = 100},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 0},
  [4480] = {.lex_state = 96},
  [4481] = {.lex_state = 0},
  [4482] = {.lex_state = 0},
  [4483] = {.lex_state = 96},
  [4484] = {.lex_state = 96},
  [4485] = {.lex_state = 96},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 100},
  [4488] = {.lex_state = 96},
  [4489] = {.lex_state = 96},
  [4490] = {.lex_state = 0},
  [4491] = {.lex_state = 0},
  [4492] = {.lex_state = 96},
  [4493] = {.lex_state = 0},
  [4494] = {.lex_state = 0},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 0},
  [4497] = {.lex_state = 0},
  [4498] = {.lex_state = 0},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 0},
  [4501] = {.lex_state = 0},
  [4502] = {.lex_state = 0},
  [4503] = {.lex_state = 0},
  [4504] = {.lex_state = 0},
  [4505] = {.lex_state = 100},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 96},
  [4508] = {.lex_state = 96},
  [4509] = {.lex_state = 0},
  [4510] = {.lex_state = 0},
  [4511] = {.lex_state = 0},
  [4512] = {.lex_state = 0},
  [4513] = {.lex_state = 0},
  [4514] = {.lex_state = 0},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 0},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 0},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 96},
  [4522] = {.lex_state = 0},
  [4523] = {.lex_state = 96},
  [4524] = {.lex_state = 0},
  [4525] = {.lex_state = 0},
  [4526] = {.lex_state = 0},
  [4527] = {.lex_state = 98},
  [4528] = {.lex_state = 0},
  [4529] = {.lex_state = 0},
  [4530] = {.lex_state = 100},
  [4531] = {.lex_state = 0},
  [4532] = {.lex_state = 97},
  [4533] = {.lex_state = 0},
  [4534] = {.lex_state = 0},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 0},
  [4538] = {.lex_state = 0},
  [4539] = {.lex_state = 0},
  [4540] = {.lex_state = 0},
  [4541] = {.lex_state = 0},
  [4542] = {.lex_state = 0},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 96},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 0},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 0},
  [4549] = {.lex_state = 0},
  [4550] = {.lex_state = 96},
  [4551] = {.lex_state = 0},
  [4552] = {.lex_state = 0},
  [4553] = {.lex_state = 96},
  [4554] = {.lex_state = 0},
  [4555] = {.lex_state = 0},
  [4556] = {.lex_state = 0},
  [4557] = {.lex_state = 0},
  [4558] = {.lex_state = 0},
  [4559] = {.lex_state = 0},
  [4560] = {.lex_state = 0},
  [4561] = {.lex_state = 0},
  [4562] = {.lex_state = 96},
  [4563] = {.lex_state = 96},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 0},
  [4566] = {.lex_state = 0},
  [4567] = {.lex_state = 96},
  [4568] = {.lex_state = 96},
  [4569] = {.lex_state = 96},
  [4570] = {.lex_state = 100},
  [4571] = {.lex_state = 0},
  [4572] = {.lex_state = 0},
  [4573] = {.lex_state = 96},
  [4574] = {.lex_state = 0},
  [4575] = {.lex_state = 0},
  [4576] = {.lex_state = 0},
  [4577] = {.lex_state = 0},
  [4578] = {.lex_state = 0},
  [4579] = {.lex_state = 0},
  [4580] = {.lex_state = 0},
  [4581] = {.lex_state = 96},
  [4582] = {.lex_state = 0},
  [4583] = {.lex_state = 0},
  [4584] = {.lex_state = 0},
  [4585] = {.lex_state = 0},
  [4586] = {.lex_state = 0},
  [4587] = {.lex_state = 0},
  [4588] = {.lex_state = 0},
  [4589] = {.lex_state = 0},
  [4590] = {.lex_state = 0},
  [4591] = {.lex_state = 0},
  [4592] = {.lex_state = 2},
  [4593] = {.lex_state = 0},
  [4594] = {.lex_state = 0},
  [4595] = {.lex_state = 0},
  [4596] = {.lex_state = 0},
  [4597] = {.lex_state = 0},
  [4598] = {.lex_state = 96},
  [4599] = {.lex_state = 0},
  [4600] = {.lex_state = 0},
  [4601] = {.lex_state = 96},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 0},
  [4604] = {.lex_state = 0},
  [4605] = {.lex_state = 0},
  [4606] = {.lex_state = 0},
  [4607] = {.lex_state = 0},
  [4608] = {.lex_state = 0},
  [4609] = {.lex_state = 96},
  [4610] = {.lex_state = 96},
  [4611] = {.lex_state = 96},
  [4612] = {.lex_state = 0},
  [4613] = {.lex_state = 0},
  [4614] = {.lex_state = 0},
  [4615] = {.lex_state = 0},
  [4616] = {.lex_state = 0},
  [4617] = {.lex_state = 0},
  [4618] = {.lex_state = 0},
  [4619] = {.lex_state = 96},
  [4620] = {.lex_state = 96},
  [4621] = {.lex_state = 96},
  [4622] = {.lex_state = 0},
  [4623] = {.lex_state = 96},
  [4624] = {.lex_state = 0},
  [4625] = {.lex_state = 96},
  [4626] = {.lex_state = 96},
  [4627] = {.lex_state = 0},
  [4628] = {.lex_state = 96},
  [4629] = {.lex_state = 0},
  [4630] = {.lex_state = 96},
  [4631] = {.lex_state = 0},
  [4632] = {.lex_state = 96},
  [4633] = {.lex_state = 96},
  [4634] = {.lex_state = 96},
  [4635] = {.lex_state = 96},
  [4636] = {.lex_state = 100},
  [4637] = {.lex_state = 0},
  [4638] = {.lex_state = 0},
  [4639] = {.lex_state = 0},
  [4640] = {.lex_state = 96},
  [4641] = {.lex_state = 96},
  [4642] = {.lex_state = 96},
  [4643] = {.lex_state = 0},
  [4644] = {.lex_state = 96},
  [4645] = {.lex_state = 96},
  [4646] = {.lex_state = 96},
  [4647] = {.lex_state = 0},
  [4648] = {.lex_state = 0},
  [4649] = {.lex_state = 96},
  [4650] = {.lex_state = 96},
  [4651] = {.lex_state = 96},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 0},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 0},
  [4656] = {.lex_state = 0},
  [4657] = {.lex_state = 96},
  [4658] = {.lex_state = 0},
  [4659] = {.lex_state = 0},
  [4660] = {.lex_state = 0},
  [4661] = {.lex_state = 96},
  [4662] = {.lex_state = 0},
  [4663] = {.lex_state = 0},
  [4664] = {.lex_state = 96},
  [4665] = {.lex_state = 0},
  [4666] = {.lex_state = 0},
  [4667] = {.lex_state = 96},
  [4668] = {.lex_state = 96},
  [4669] = {.lex_state = 0},
  [4670] = {.lex_state = 96},
  [4671] = {.lex_state = 96},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_component] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1),
    [anon_sym_prop] = ACTIONS(1),
    [anon_sym_id] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4665),
    [sym_import_statement] = STATE(2736),
    [sym_decorator] = STATE(1390),
    [sym_js_import_statement] = STATE(2736),
    [sym_component_declaration] = STATE(2736),
    [sym_component_instance] = STATE(3941),
    [sym_component_instance_statement] = STATE(2736),
    [aux_sym_program_repeat1] = STATE(2736),
    [aux_sym_class_repeat1] = STATE(3557),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_hash_bang_line] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_component] = ACTIONS(13),
    [anon_sym_instance] = ACTIONS(15),
  },
  [2] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(93),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [3] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(93),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(101),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [4] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3747),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3747),
    [sym_pair] = STATE(3747),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(21),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(21),
    [aux_sym_object_repeat1] = STATE(3750),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(122),
    [anon_sym_export] = ACTIONS(124),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(132),
    [anon_sym_type] = ACTIONS(134),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(210),
    [anon_sym_readonly] = ACTIONS(212),
    [anon_sym_get] = ACTIONS(214),
    [anon_sym_set] = ACTIONS(214),
    [anon_sym_declare] = ACTIONS(216),
    [anon_sym_namespace] = ACTIONS(218),
    [anon_sym_public] = ACTIONS(220),
    [anon_sym_private] = ACTIONS(220),
    [anon_sym_protected] = ACTIONS(220),
    [anon_sym_override] = ACTIONS(222),
    [anon_sym_module] = ACTIONS(224),
    [anon_sym_any] = ACTIONS(226),
    [anon_sym_number] = ACTIONS(226),
    [anon_sym_boolean] = ACTIONS(226),
    [anon_sym_string] = ACTIONS(226),
    [anon_sym_symbol] = ACTIONS(226),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [5] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3882),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3882),
    [sym_pair] = STATE(3882),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(25),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(25),
    [aux_sym_object_repeat1] = STATE(3881),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_export] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_type] = ACTIONS(242),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(244),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(248),
    [anon_sym_get] = ACTIONS(250),
    [anon_sym_set] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(252),
    [anon_sym_namespace] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(256),
    [anon_sym_private] = ACTIONS(256),
    [anon_sym_protected] = ACTIONS(256),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_any] = ACTIONS(262),
    [anon_sym_number] = ACTIONS(262),
    [anon_sym_boolean] = ACTIONS(262),
    [anon_sym_string] = ACTIONS(262),
    [anon_sym_symbol] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [6] = {
    [sym_export_statement] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3751),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3751),
    [sym_pair] = STATE(3751),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(26),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [aux_sym_object_repeat1] = STATE(3724),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(264),
    [anon_sym_export] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(272),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(274),
    [anon_sym_readonly] = ACTIONS(276),
    [anon_sym_get] = ACTIONS(278),
    [anon_sym_set] = ACTIONS(278),
    [anon_sym_declare] = ACTIONS(280),
    [anon_sym_namespace] = ACTIONS(282),
    [anon_sym_public] = ACTIONS(284),
    [anon_sym_private] = ACTIONS(284),
    [anon_sym_protected] = ACTIONS(284),
    [anon_sym_override] = ACTIONS(286),
    [anon_sym_module] = ACTIONS(288),
    [anon_sym_any] = ACTIONS(290),
    [anon_sym_number] = ACTIONS(290),
    [anon_sym_boolean] = ACTIONS(290),
    [anon_sym_string] = ACTIONS(290),
    [anon_sym_symbol] = ACTIONS(290),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [7] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3882),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3882),
    [sym_pair] = STATE(3882),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(17),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(17),
    [aux_sym_object_repeat1] = STATE(3881),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_export] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_type] = ACTIONS(242),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(244),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(248),
    [anon_sym_get] = ACTIONS(250),
    [anon_sym_set] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(252),
    [anon_sym_namespace] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(256),
    [anon_sym_private] = ACTIONS(256),
    [anon_sym_protected] = ACTIONS(256),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_any] = ACTIONS(262),
    [anon_sym_number] = ACTIONS(262),
    [anon_sym_boolean] = ACTIONS(262),
    [anon_sym_string] = ACTIONS(262),
    [anon_sym_symbol] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [8] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3882),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3882),
    [sym_pair] = STATE(3882),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(18),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(18),
    [aux_sym_object_repeat1] = STATE(3881),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_export] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(294),
    [anon_sym_type] = ACTIONS(242),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(244),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(248),
    [anon_sym_get] = ACTIONS(250),
    [anon_sym_set] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(252),
    [anon_sym_namespace] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(256),
    [anon_sym_private] = ACTIONS(256),
    [anon_sym_protected] = ACTIONS(256),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_any] = ACTIONS(262),
    [anon_sym_number] = ACTIONS(262),
    [anon_sym_boolean] = ACTIONS(262),
    [anon_sym_string] = ACTIONS(262),
    [anon_sym_symbol] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [9] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4293),
    [sym_object_assignment_pattern] = STATE(3752),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4293),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4293),
    [sym_spread_element] = STATE(3747),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_rest_pattern] = STATE(3752),
    [sym_method_definition] = STATE(3747),
    [sym_pair] = STATE(3747),
    [sym_pair_pattern] = STATE(3752),
    [sym__property_name] = STATE(3056),
    [sym_computed_property_name] = STATE(3056),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_accessibility_modifier] = STATE(2469),
    [sym_override_modifier] = STATE(2479),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(18),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(18),
    [aux_sym_object_repeat1] = STATE(3750),
    [aux_sym_object_pattern_repeat1] = STATE(3746),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(122),
    [anon_sym_export] = ACTIONS(124),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_COMMA] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(296),
    [anon_sym_type] = ACTIONS(134),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(202),
    [sym_private_property_identifier] = ACTIONS(204),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(210),
    [anon_sym_readonly] = ACTIONS(212),
    [anon_sym_get] = ACTIONS(214),
    [anon_sym_set] = ACTIONS(214),
    [anon_sym_declare] = ACTIONS(216),
    [anon_sym_namespace] = ACTIONS(218),
    [anon_sym_public] = ACTIONS(220),
    [anon_sym_private] = ACTIONS(220),
    [anon_sym_protected] = ACTIONS(220),
    [anon_sym_override] = ACTIONS(222),
    [anon_sym_module] = ACTIONS(224),
    [anon_sym_any] = ACTIONS(226),
    [anon_sym_number] = ACTIONS(226),
    [anon_sym_boolean] = ACTIONS(226),
    [anon_sym_string] = ACTIONS(226),
    [anon_sym_symbol] = ACTIONS(226),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [10] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(298),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_type] = ACTIONS(309),
    [anon_sym_typeof] = ACTIONS(312),
    [anon_sym_import] = ACTIONS(315),
    [anon_sym_var] = ACTIONS(318),
    [anon_sym_let] = ACTIONS(321),
    [anon_sym_const] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(327),
    [anon_sym_if] = ACTIONS(330),
    [anon_sym_switch] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(336),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_await] = ACTIONS(342),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(348),
    [anon_sym_try] = ACTIONS(351),
    [anon_sym_with] = ACTIONS(354),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(360),
    [anon_sym_debugger] = ACTIONS(363),
    [anon_sym_return] = ACTIONS(366),
    [anon_sym_throw] = ACTIONS(369),
    [anon_sym_SEMI] = ACTIONS(372),
    [anon_sym_case] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_LTtemplate_GT] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_class] = ACTIONS(392),
    [anon_sym_async] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(398),
    [anon_sym_new] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_TILDE] = ACTIONS(327),
    [anon_sym_void] = ACTIONS(312),
    [anon_sym_delete] = ACTIONS(312),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [anon_sym_SQUOTE] = ACTIONS(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(413),
    [sym_number] = ACTIONS(416),
    [sym_this] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_null] = ACTIONS(419),
    [sym_undefined] = ACTIONS(422),
    [anon_sym_AT] = ACTIONS(425),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_readonly] = ACTIONS(428),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_declare] = ACTIONS(431),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_override] = ACTIONS(428),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_any] = ACTIONS(428),
    [anon_sym_number] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [anon_sym_abstract] = ACTIONS(440),
    [anon_sym_interface] = ACTIONS(443),
    [anon_sym_enum] = ACTIONS(446),
    [anon_sym_component] = ACTIONS(449),
  },
  [11] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_case] = ACTIONS(460),
    [anon_sym_default] = ACTIONS(460),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [12] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_case] = ACTIONS(478),
    [anon_sym_default] = ACTIONS(478),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [13] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_case] = ACTIONS(482),
    [anon_sym_default] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [14] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(12),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_case] = ACTIONS(486),
    [anon_sym_default] = ACTIONS(486),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [15] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(22),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(22),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [16] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(21),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(21),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [17] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [18] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [19] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [20] = {
    [sym_export_statement] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(26),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(498),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [21] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [22] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [23] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(25),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(25),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [24] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [25] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [26] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [27] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(19),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(19),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [28] = {
    [sym_export_statement] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(24),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(24),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [29] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(17),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(17),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [30] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [31] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(18),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(18),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [32] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(10),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(10),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [33] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(30),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(30),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [34] = {
    [sym_export_statement] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_for_in_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_debugger_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_empty_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(32),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_statement_block_repeat1] = STATE(32),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [35] = {
    [sym_export_statement] = STATE(665),
    [sym_declaration] = STATE(665),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_for_in_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_try_statement] = STATE(665),
    [sym_with_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_debugger_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_throw_statement] = STATE(665),
    [sym_empty_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(665),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [36] = {
    [sym_export_statement] = STATE(733),
    [sym_declaration] = STATE(750),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(752),
    [sym_expression_statement] = STATE(759),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(761),
    [sym_if_statement] = STATE(782),
    [sym_switch_statement] = STATE(783),
    [sym_for_statement] = STATE(785),
    [sym_for_in_statement] = STATE(792),
    [sym_while_statement] = STATE(794),
    [sym_do_statement] = STATE(795),
    [sym_try_statement] = STATE(796),
    [sym_with_statement] = STATE(797),
    [sym_break_statement] = STATE(798),
    [sym_continue_statement] = STATE(801),
    [sym_debugger_statement] = STATE(802),
    [sym_return_statement] = STATE(664),
    [sym_throw_statement] = STATE(803),
    [sym_empty_statement] = STATE(804),
    [sym_labeled_statement] = STATE(806),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(810),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [37] = {
    [sym_export_statement] = STATE(778),
    [sym_declaration] = STATE(778),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(778),
    [sym_expression_statement] = STATE(778),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(778),
    [sym_if_statement] = STATE(778),
    [sym_switch_statement] = STATE(778),
    [sym_for_statement] = STATE(778),
    [sym_for_in_statement] = STATE(778),
    [sym_while_statement] = STATE(778),
    [sym_do_statement] = STATE(778),
    [sym_try_statement] = STATE(778),
    [sym_with_statement] = STATE(778),
    [sym_break_statement] = STATE(778),
    [sym_continue_statement] = STATE(778),
    [sym_debugger_statement] = STATE(778),
    [sym_return_statement] = STATE(778),
    [sym_throw_statement] = STATE(778),
    [sym_empty_statement] = STATE(778),
    [sym_labeled_statement] = STATE(778),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(778),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [38] = {
    [sym_export_statement] = STATE(689),
    [sym_declaration] = STATE(689),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(689),
    [sym_expression_statement] = STATE(689),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(689),
    [sym_if_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_for_statement] = STATE(689),
    [sym_for_in_statement] = STATE(689),
    [sym_while_statement] = STATE(689),
    [sym_do_statement] = STATE(689),
    [sym_try_statement] = STATE(689),
    [sym_with_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_continue_statement] = STATE(689),
    [sym_debugger_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(689),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [39] = {
    [sym_export_statement] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(671),
    [sym_expression_statement] = STATE(671),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(671),
    [sym_if_statement] = STATE(671),
    [sym_switch_statement] = STATE(671),
    [sym_for_statement] = STATE(671),
    [sym_for_in_statement] = STATE(671),
    [sym_while_statement] = STATE(671),
    [sym_do_statement] = STATE(671),
    [sym_try_statement] = STATE(671),
    [sym_with_statement] = STATE(671),
    [sym_break_statement] = STATE(671),
    [sym_continue_statement] = STATE(671),
    [sym_debugger_statement] = STATE(671),
    [sym_return_statement] = STATE(671),
    [sym_throw_statement] = STATE(671),
    [sym_empty_statement] = STATE(671),
    [sym_labeled_statement] = STATE(671),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(671),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [40] = {
    [sym_export_statement] = STATE(3706),
    [sym_declaration] = STATE(3706),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(3706),
    [sym_expression_statement] = STATE(3706),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(3706),
    [sym_if_statement] = STATE(3706),
    [sym_switch_statement] = STATE(3706),
    [sym_for_statement] = STATE(3706),
    [sym_for_in_statement] = STATE(3706),
    [sym_while_statement] = STATE(3706),
    [sym_do_statement] = STATE(3706),
    [sym_try_statement] = STATE(3706),
    [sym_with_statement] = STATE(3706),
    [sym_break_statement] = STATE(3706),
    [sym_continue_statement] = STATE(3706),
    [sym_debugger_statement] = STATE(3706),
    [sym_return_statement] = STATE(3706),
    [sym_throw_statement] = STATE(3706),
    [sym_empty_statement] = STATE(3706),
    [sym_labeled_statement] = STATE(3706),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(3706),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [41] = {
    [sym_export_statement] = STATE(671),
    [sym_declaration] = STATE(671),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(671),
    [sym_expression_statement] = STATE(671),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(671),
    [sym_if_statement] = STATE(671),
    [sym_switch_statement] = STATE(671),
    [sym_for_statement] = STATE(671),
    [sym_for_in_statement] = STATE(671),
    [sym_while_statement] = STATE(671),
    [sym_do_statement] = STATE(671),
    [sym_try_statement] = STATE(671),
    [sym_with_statement] = STATE(671),
    [sym_break_statement] = STATE(671),
    [sym_continue_statement] = STATE(671),
    [sym_debugger_statement] = STATE(671),
    [sym_return_statement] = STATE(671),
    [sym_throw_statement] = STATE(671),
    [sym_empty_statement] = STATE(671),
    [sym_labeled_statement] = STATE(671),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(671),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [42] = {
    [sym_export_statement] = STATE(745),
    [sym_declaration] = STATE(741),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(738),
    [sym_expression_statement] = STATE(736),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(729),
    [sym_if_statement] = STATE(728),
    [sym_switch_statement] = STATE(727),
    [sym_for_statement] = STATE(725),
    [sym_for_in_statement] = STATE(724),
    [sym_while_statement] = STATE(723),
    [sym_do_statement] = STATE(722),
    [sym_try_statement] = STATE(708),
    [sym_with_statement] = STATE(706),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(696),
    [sym_debugger_statement] = STATE(694),
    [sym_return_statement] = STATE(693),
    [sym_throw_statement] = STATE(692),
    [sym_empty_statement] = STATE(687),
    [sym_labeled_statement] = STATE(686),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(684),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [43] = {
    [sym_export_statement] = STATE(653),
    [sym_declaration] = STATE(653),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(653),
    [sym_expression_statement] = STATE(653),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_switch_statement] = STATE(653),
    [sym_for_statement] = STATE(653),
    [sym_for_in_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_do_statement] = STATE(653),
    [sym_try_statement] = STATE(653),
    [sym_with_statement] = STATE(653),
    [sym_break_statement] = STATE(653),
    [sym_continue_statement] = STATE(653),
    [sym_debugger_statement] = STATE(653),
    [sym_return_statement] = STATE(653),
    [sym_throw_statement] = STATE(653),
    [sym_empty_statement] = STATE(653),
    [sym_labeled_statement] = STATE(653),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(653),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [44] = {
    [sym_export_statement] = STATE(689),
    [sym_declaration] = STATE(689),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(689),
    [sym_expression_statement] = STATE(689),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(689),
    [sym_if_statement] = STATE(689),
    [sym_switch_statement] = STATE(689),
    [sym_for_statement] = STATE(689),
    [sym_for_in_statement] = STATE(689),
    [sym_while_statement] = STATE(689),
    [sym_do_statement] = STATE(689),
    [sym_try_statement] = STATE(689),
    [sym_with_statement] = STATE(689),
    [sym_break_statement] = STATE(689),
    [sym_continue_statement] = STATE(689),
    [sym_debugger_statement] = STATE(689),
    [sym_return_statement] = STATE(689),
    [sym_throw_statement] = STATE(689),
    [sym_empty_statement] = STATE(689),
    [sym_labeled_statement] = STATE(689),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(689),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [45] = {
    [sym_export_statement] = STATE(778),
    [sym_declaration] = STATE(778),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(778),
    [sym_expression_statement] = STATE(778),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(778),
    [sym_if_statement] = STATE(778),
    [sym_switch_statement] = STATE(778),
    [sym_for_statement] = STATE(778),
    [sym_for_in_statement] = STATE(778),
    [sym_while_statement] = STATE(778),
    [sym_do_statement] = STATE(778),
    [sym_try_statement] = STATE(778),
    [sym_with_statement] = STATE(778),
    [sym_break_statement] = STATE(778),
    [sym_continue_statement] = STATE(778),
    [sym_debugger_statement] = STATE(778),
    [sym_return_statement] = STATE(778),
    [sym_throw_statement] = STATE(778),
    [sym_empty_statement] = STATE(778),
    [sym_labeled_statement] = STATE(778),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(778),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [46] = {
    [sym_export_statement] = STATE(665),
    [sym_declaration] = STATE(665),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(665),
    [sym_expression_statement] = STATE(665),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(665),
    [sym_if_statement] = STATE(665),
    [sym_switch_statement] = STATE(665),
    [sym_for_statement] = STATE(665),
    [sym_for_in_statement] = STATE(665),
    [sym_while_statement] = STATE(665),
    [sym_do_statement] = STATE(665),
    [sym_try_statement] = STATE(665),
    [sym_with_statement] = STATE(665),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(665),
    [sym_debugger_statement] = STATE(665),
    [sym_return_statement] = STATE(665),
    [sym_throw_statement] = STATE(665),
    [sym_empty_statement] = STATE(665),
    [sym_labeled_statement] = STATE(665),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(665),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [47] = {
    [sym_export_statement] = STATE(733),
    [sym_declaration] = STATE(750),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(752),
    [sym_expression_statement] = STATE(759),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(761),
    [sym_if_statement] = STATE(782),
    [sym_switch_statement] = STATE(783),
    [sym_for_statement] = STATE(785),
    [sym_for_in_statement] = STATE(792),
    [sym_while_statement] = STATE(794),
    [sym_do_statement] = STATE(795),
    [sym_try_statement] = STATE(796),
    [sym_with_statement] = STATE(797),
    [sym_break_statement] = STATE(798),
    [sym_continue_statement] = STATE(801),
    [sym_debugger_statement] = STATE(802),
    [sym_return_statement] = STATE(664),
    [sym_throw_statement] = STATE(803),
    [sym_empty_statement] = STATE(804),
    [sym_labeled_statement] = STATE(806),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(810),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [48] = {
    [sym_export_statement] = STATE(745),
    [sym_declaration] = STATE(741),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(738),
    [sym_expression_statement] = STATE(736),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(729),
    [sym_if_statement] = STATE(728),
    [sym_switch_statement] = STATE(727),
    [sym_for_statement] = STATE(725),
    [sym_for_in_statement] = STATE(724),
    [sym_while_statement] = STATE(723),
    [sym_do_statement] = STATE(722),
    [sym_try_statement] = STATE(708),
    [sym_with_statement] = STATE(706),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(696),
    [sym_debugger_statement] = STATE(694),
    [sym_return_statement] = STATE(693),
    [sym_throw_statement] = STATE(692),
    [sym_empty_statement] = STATE(687),
    [sym_labeled_statement] = STATE(686),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(684),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [49] = {
    [sym_export_statement] = STATE(4375),
    [sym_declaration] = STATE(4375),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(4375),
    [sym_expression_statement] = STATE(4375),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(4375),
    [sym_if_statement] = STATE(4375),
    [sym_switch_statement] = STATE(4375),
    [sym_for_statement] = STATE(4375),
    [sym_for_in_statement] = STATE(4375),
    [sym_while_statement] = STATE(4375),
    [sym_do_statement] = STATE(4375),
    [sym_try_statement] = STATE(4375),
    [sym_with_statement] = STATE(4375),
    [sym_break_statement] = STATE(4375),
    [sym_continue_statement] = STATE(4375),
    [sym_debugger_statement] = STATE(4375),
    [sym_return_statement] = STATE(4375),
    [sym_throw_statement] = STATE(4375),
    [sym_empty_statement] = STATE(4375),
    [sym_labeled_statement] = STATE(4375),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(4375),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [50] = {
    [sym_export_statement] = STATE(789),
    [sym_declaration] = STATE(789),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(789),
    [sym_expression_statement] = STATE(789),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_switch_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_for_in_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_do_statement] = STATE(789),
    [sym_try_statement] = STATE(789),
    [sym_with_statement] = STATE(789),
    [sym_break_statement] = STATE(789),
    [sym_continue_statement] = STATE(789),
    [sym_debugger_statement] = STATE(789),
    [sym_return_statement] = STATE(789),
    [sym_throw_statement] = STATE(789),
    [sym_empty_statement] = STATE(789),
    [sym_labeled_statement] = STATE(789),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(789),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [51] = {
    [sym_export_statement] = STATE(789),
    [sym_declaration] = STATE(789),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(789),
    [sym_expression_statement] = STATE(789),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(789),
    [sym_if_statement] = STATE(789),
    [sym_switch_statement] = STATE(789),
    [sym_for_statement] = STATE(789),
    [sym_for_in_statement] = STATE(789),
    [sym_while_statement] = STATE(789),
    [sym_do_statement] = STATE(789),
    [sym_try_statement] = STATE(789),
    [sym_with_statement] = STATE(789),
    [sym_break_statement] = STATE(789),
    [sym_continue_statement] = STATE(789),
    [sym_debugger_statement] = STATE(789),
    [sym_return_statement] = STATE(789),
    [sym_throw_statement] = STATE(789),
    [sym_empty_statement] = STATE(789),
    [sym_labeled_statement] = STATE(789),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(789),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [52] = {
    [sym_export_statement] = STATE(846),
    [sym_declaration] = STATE(846),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(846),
    [sym_expression_statement] = STATE(846),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(846),
    [sym_if_statement] = STATE(846),
    [sym_switch_statement] = STATE(846),
    [sym_for_statement] = STATE(846),
    [sym_for_in_statement] = STATE(846),
    [sym_while_statement] = STATE(846),
    [sym_do_statement] = STATE(846),
    [sym_try_statement] = STATE(846),
    [sym_with_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_debugger_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_throw_statement] = STATE(846),
    [sym_empty_statement] = STATE(846),
    [sym_labeled_statement] = STATE(846),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(846),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3194),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_export] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_type] = ACTIONS(458),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(148),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(158),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(162),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(184),
    [anon_sym_async] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(468),
    [anon_sym_readonly] = ACTIONS(468),
    [anon_sym_get] = ACTIONS(468),
    [anon_sym_set] = ACTIONS(468),
    [anon_sym_declare] = ACTIONS(470),
    [anon_sym_namespace] = ACTIONS(472),
    [anon_sym_public] = ACTIONS(468),
    [anon_sym_private] = ACTIONS(468),
    [anon_sym_protected] = ACTIONS(468),
    [anon_sym_override] = ACTIONS(468),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_any] = ACTIONS(468),
    [anon_sym_number] = ACTIONS(468),
    [anon_sym_boolean] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_symbol] = ACTIONS(468),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(234),
  },
  [53] = {
    [sym_export_statement] = STATE(846),
    [sym_declaration] = STATE(846),
    [sym_import] = STATE(2149),
    [sym_import_statement] = STATE(846),
    [sym_expression_statement] = STATE(846),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_statement_block] = STATE(846),
    [sym_if_statement] = STATE(846),
    [sym_switch_statement] = STATE(846),
    [sym_for_statement] = STATE(846),
    [sym_for_in_statement] = STATE(846),
    [sym_while_statement] = STATE(846),
    [sym_do_statement] = STATE(846),
    [sym_try_statement] = STATE(846),
    [sym_with_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_debugger_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_throw_statement] = STATE(846),
    [sym_empty_statement] = STATE(846),
    [sym_labeled_statement] = STATE(846),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_class_declaration] = STATE(775),
    [sym_function] = STATE(2149),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function] = STATE(2149),
    [sym_generator_function_declaration] = STATE(775),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_function_signature] = STATE(775),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_js_import_statement] = STATE(846),
    [sym_component] = STATE(2149),
    [sym_component_declaration] = STATE(775),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3208),
    [sym_identifier] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(140),
    [anon_sym_let] = ACTIONS(142),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(160),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(166),
    [anon_sym_continue] = ACTIONS(168),
    [anon_sym_debugger] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(172),
    [anon_sym_throw] = ACTIONS(174),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(550),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_readonly] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
    [anon_sym_declare] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(554),
    [anon_sym_private] = ACTIONS(554),
    [anon_sym_protected] = ACTIONS(554),
    [anon_sym_override] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_any] = ACTIONS(554),
    [anon_sym_number] = ACTIONS(554),
    [anon_sym_boolean] = ACTIONS(554),
    [anon_sym_string] = ACTIONS(554),
    [anon_sym_symbol] = ACTIONS(554),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(232),
    [anon_sym_component] = ACTIONS(564),
  },
  [54] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [55] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3403),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [56] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3477),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [57] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3370),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(595),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [58] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3397),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(597),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [59] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3475),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(599),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [60] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3338),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [61] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(82),
    [anon_sym_DASH_DASH] = ACTIONS(82),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [62] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [63] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [64] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3736),
    [sym_optional_tuple_parameter] = STATE(3736),
    [sym_optional_type] = STATE(3736),
    [sym_rest_type] = STATE(3736),
    [sym__tuple_type_member] = STATE(3736),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [65] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [66] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [67] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [68] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3517),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(641),
    [anon_sym_number] = ACTIONS(641),
    [anon_sym_boolean] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [anon_sym_symbol] = ACTIONS(641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [69] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1803),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4539),
    [sym_string] = STATE(2011),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3627),
    [sym_constructor_type] = STATE(3627),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3627),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3627),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3627),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(657),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_number] = ACTIONS(667),
    [sym_this] = ACTIONS(669),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_null] = ACTIONS(671),
    [sym_undefined] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(683),
    [anon_sym_number] = ACTIONS(683),
    [anon_sym_boolean] = ACTIONS(683),
    [anon_sym_string] = ACTIONS(683),
    [anon_sym_symbol] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [70] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1803),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4539),
    [sym_string] = STATE(2011),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3698),
    [sym_constructor_type] = STATE(3698),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3698),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3698),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3698),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(657),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_number] = ACTIONS(667),
    [sym_this] = ACTIONS(669),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_null] = ACTIONS(671),
    [sym_undefined] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(683),
    [anon_sym_number] = ACTIONS(683),
    [anon_sym_boolean] = ACTIONS(683),
    [anon_sym_string] = ACTIONS(683),
    [anon_sym_symbol] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [71] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3559),
    [sym_constructor_type] = STATE(3559),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3559),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3559),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3559),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [72] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3698),
    [sym_constructor_type] = STATE(3698),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3698),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3698),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3698),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [73] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3627),
    [sym_constructor_type] = STATE(3627),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3627),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3627),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3627),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [74] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3616),
    [sym_constructor_type] = STATE(3616),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3616),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3616),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3616),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [75] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3581),
    [sym_constructor_type] = STATE(3581),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3581),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3581),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3581),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [76] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym__type] = STATE(3642),
    [sym_constructor_type] = STATE(3642),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3642),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3642),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3642),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(105),
    [anon_sym_number] = ACTIONS(105),
    [anon_sym_boolean] = ACTIONS(105),
    [anon_sym_string] = ACTIONS(105),
    [anon_sym_symbol] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [77] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(652),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(699),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_infer] = ACTIONS(699),
    [anon_sym_keyof] = ACTIONS(699),
    [anon_sym_unknown] = ACTIONS(699),
    [anon_sym_never] = ACTIONS(699),
    [anon_sym_object] = ACTIONS(699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(703),
    [anon_sym_component] = ACTIONS(743),
    [anon_sym_constructor] = ACTIONS(699),
    [anon_sym_prop] = ACTIONS(699),
    [anon_sym_id] = ACTIONS(699),
    [anon_sym_event] = ACTIONS(699),
    [anon_sym_fn] = ACTIONS(699),
    [anon_sym_on] = ACTIONS(699),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [78] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(995),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_abstract] = ACTIONS(699),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_infer] = ACTIONS(699),
    [anon_sym_keyof] = ACTIONS(699),
    [anon_sym_unknown] = ACTIONS(699),
    [anon_sym_never] = ACTIONS(699),
    [anon_sym_object] = ACTIONS(699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(703),
    [anon_sym_component] = ACTIONS(743),
    [anon_sym_prop] = ACTIONS(699),
    [anon_sym_id] = ACTIONS(699),
    [anon_sym_event] = ACTIONS(699),
    [anon_sym_fn] = ACTIONS(699),
    [anon_sym_on] = ACTIONS(699),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [79] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2157),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4278),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(3011),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1908),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3376),
    [sym_pattern] = STATE(3741),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2997),
    [sym_constructor_type] = STATE(2997),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2997),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4153),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2997),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2997),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(775),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(789),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(791),
    [sym_number] = ACTIONS(793),
    [sym_this] = ACTIONS(795),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(797),
    [sym_false] = ACTIONS(797),
    [sym_null] = ACTIONS(797),
    [sym_undefined] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(801),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(805),
    [anon_sym_number] = ACTIONS(805),
    [anon_sym_boolean] = ACTIONS(805),
    [anon_sym_string] = ACTIONS(805),
    [anon_sym_symbol] = ACTIONS(805),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
    [anon_sym_component] = ACTIONS(117),
  },
  [80] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2170),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4373),
    [sym_string] = STATE(2011),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(3491),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3633),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(29),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(823),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_number] = ACTIONS(667),
    [sym_this] = ACTIONS(827),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_null] = ACTIONS(671),
    [sym_undefined] = ACTIONS(829),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(831),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(833),
    [anon_sym_number] = ACTIONS(833),
    [anon_sym_boolean] = ACTIONS(833),
    [anon_sym_string] = ACTIONS(833),
    [anon_sym_symbol] = ACTIONS(833),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [81] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3042),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3042),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3042),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_non_null_expression] = STATE(1385),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3508),
    [sym_constructor_type] = STATE(3508),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3508),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3508),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3508),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_export] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(837),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_this] = ACTIONS(849),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(853),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(837),
    [anon_sym_readonly] = ACTIONS(855),
    [anon_sym_get] = ACTIONS(837),
    [anon_sym_set] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(837),
    [anon_sym_namespace] = ACTIONS(837),
    [anon_sym_public] = ACTIONS(837),
    [anon_sym_private] = ACTIONS(837),
    [anon_sym_protected] = ACTIONS(837),
    [anon_sym_override] = ACTIONS(837),
    [anon_sym_module] = ACTIONS(837),
    [anon_sym_any] = ACTIONS(857),
    [anon_sym_number] = ACTIONS(857),
    [anon_sym_boolean] = ACTIONS(857),
    [anon_sym_string] = ACTIONS(857),
    [anon_sym_symbol] = ACTIONS(857),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [82] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1844),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3042),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3042),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3042),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_non_null_expression] = STATE(1385),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3508),
    [sym_constructor_type] = STATE(3508),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3508),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(439),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3508),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3508),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(837),
    [anon_sym_typeof] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(64),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(78),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [sym_number] = ACTIONS(91),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(837),
    [anon_sym_readonly] = ACTIONS(855),
    [anon_sym_get] = ACTIONS(837),
    [anon_sym_set] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(837),
    [anon_sym_namespace] = ACTIONS(837),
    [anon_sym_public] = ACTIONS(837),
    [anon_sym_private] = ACTIONS(837),
    [anon_sym_protected] = ACTIONS(837),
    [anon_sym_override] = ACTIONS(837),
    [anon_sym_module] = ACTIONS(837),
    [anon_sym_any] = ACTIONS(865),
    [anon_sym_number] = ACTIONS(865),
    [anon_sym_boolean] = ACTIONS(865),
    [anon_sym_string] = ACTIONS(865),
    [anon_sym_symbol] = ACTIONS(865),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [83] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2001),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2970),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2161),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3459),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3249),
    [sym_constructor_type] = STATE(3249),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3249),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_type_arguments] = STATE(447),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4042),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3249),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3249),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(867),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(873),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(891),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(897),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(903),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(907),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(909),
    [anon_sym_number] = ACTIONS(909),
    [anon_sym_boolean] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(909),
    [anon_sym_symbol] = ACTIONS(909),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_component] = ACTIONS(117),
  },
  [84] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1731),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(80),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [85] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1951),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(136),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_component] = ACTIONS(939),
    [sym__automatic_semicolon] = ACTIONS(703),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [86] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1856),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_of] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_component] = ACTIONS(939),
    [sym__automatic_semicolon] = ACTIONS(703),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [87] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2029),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_implements] = ACTIONS(699),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [88] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2274),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_of] = ACTIONS(699),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(699),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_QMARK_DOT] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(703),
    [anon_sym_LT_LT] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(699),
    [anon_sym_CARET] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_QMARK_QMARK] = ACTIONS(703),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_satisfies] = ACTIONS(699),
    [anon_sym_component] = ACTIONS(117),
    [sym__ternary_qmark] = ACTIONS(703),
  },
  [89] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1822),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4378),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1003),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(1007),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [90] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1966),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4560),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1003),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(1007),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [91] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(1013),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [92] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1803),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4539),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1003),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(1007),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [93] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [94] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3740),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3740),
    [sym_optional_parameter] = STATE(3740),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [95] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [96] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1054),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [97] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1056),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [98] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [99] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3763),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3763),
    [sym_optional_parameter] = STATE(3763),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [100] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(1062),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(1064),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_implements] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [101] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2872),
    [sym_constructor_type] = STATE(2872),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2872),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2872),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2872),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(1100),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [102] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(3880),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(3880),
    [sym_optional_parameter] = STATE(3880),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [103] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [104] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1104),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [105] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [106] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(72),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [107] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1110),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [108] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3879),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3877),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1112),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [109] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2054),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3879),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3877),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1112),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [110] = {
    [sym_import] = STATE(2149),
    [sym_expression_statement] = STATE(173),
    [sym_variable_declaration] = STATE(173),
    [sym_lexical_declaration] = STATE(173),
    [sym_empty_statement] = STATE(173),
    [sym_parenthesized_expression] = STATE(1392),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(3924),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(3924),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1392),
    [sym_subscript_expression] = STATE(1392),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(3924),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1392),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_const] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(1124),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(1126),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_readonly] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_override] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [anon_sym_component] = ACTIONS(939),
  },
  [111] = {
    [sym_import] = STATE(2149),
    [sym_expression_statement] = STATE(168),
    [sym_variable_declaration] = STATE(168),
    [sym_lexical_declaration] = STATE(168),
    [sym_empty_statement] = STATE(168),
    [sym_parenthesized_expression] = STATE(1392),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(3924),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(3924),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1392),
    [sym_subscript_expression] = STATE(1392),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(3924),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1392),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_const] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(1124),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(1126),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_readonly] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_override] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [anon_sym_component] = ACTIONS(939),
  },
  [112] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1130),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [113] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1132),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [114] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3879),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3877),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1134),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [115] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1136),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [116] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3738),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3733),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1138),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [117] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym__formal_parameter] = STATE(4272),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3430),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(165),
    [sym_override_modifier] = STATE(186),
    [sym_required_parameter] = STATE(4272),
    [sym_optional_parameter] = STATE(4272),
    [sym__parameter_name] = STATE(3058),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [118] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1981),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3782),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3788),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1140),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [119] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1142),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_RBRACK] = ACTIONS(1142),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(1142),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_extends] = ACTIONS(1144),
    [anon_sym_component] = ACTIONS(117),
  },
  [120] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_mapped_type_clause] = STATE(4360),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_export] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(1148),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1148),
    [anon_sym_readonly] = ACTIONS(1148),
    [anon_sym_get] = ACTIONS(1148),
    [anon_sym_set] = ACTIONS(1148),
    [anon_sym_declare] = ACTIONS(1148),
    [anon_sym_namespace] = ACTIONS(1148),
    [anon_sym_public] = ACTIONS(1148),
    [anon_sym_private] = ACTIONS(1148),
    [anon_sym_protected] = ACTIONS(1148),
    [anon_sym_override] = ACTIONS(1148),
    [anon_sym_module] = ACTIONS(1148),
    [anon_sym_any] = ACTIONS(1148),
    [anon_sym_number] = ACTIONS(1148),
    [anon_sym_boolean] = ACTIONS(1148),
    [anon_sym_string] = ACTIONS(1148),
    [anon_sym_symbol] = ACTIONS(1148),
    [anon_sym_component] = ACTIONS(117),
  },
  [121] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_extends] = ACTIONS(1144),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1142),
    [anon_sym_component] = ACTIONS(117),
    [sym__automatic_semicolon] = ACTIONS(1142),
  },
  [122] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4121),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3745),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1161),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [123] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4121),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3745),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [124] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4121),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_spread_element] = STATE(3745),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1158),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [125] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3773),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1411),
    [sym_subscript_expression] = STATE(1411),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3643),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1411),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_pattern_repeat1] = STATE(3790),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(1171),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(1171),
    [anon_sym_get] = ACTIONS(1171),
    [anon_sym_set] = ACTIONS(1171),
    [anon_sym_declare] = ACTIONS(1171),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_any] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_boolean] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [anon_sym_symbol] = ACTIONS(1171),
    [anon_sym_component] = ACTIONS(117),
  },
  [126] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2232),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [127] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(3739),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1411),
    [sym_subscript_expression] = STATE(1411),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3675),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1411),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_pattern_repeat1] = STATE(3732),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(1171),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(1171),
    [anon_sym_get] = ACTIONS(1171),
    [anon_sym_set] = ACTIONS(1171),
    [anon_sym_declare] = ACTIONS(1171),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_any] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_boolean] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [anon_sym_symbol] = ACTIONS(1171),
    [anon_sym_component] = ACTIONS(117),
  },
  [128] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4121),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1411),
    [sym_subscript_expression] = STATE(1411),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1411),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_type] = ACTIONS(1171),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_RBRACK] = ACTIONS(1183),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_readonly] = ACTIONS(1171),
    [anon_sym_get] = ACTIONS(1171),
    [anon_sym_set] = ACTIONS(1171),
    [anon_sym_declare] = ACTIONS(1171),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_any] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_boolean] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [anon_sym_symbol] = ACTIONS(1171),
    [anon_sym_component] = ACTIONS(117),
  },
  [129] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2009),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3756),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3757),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [130] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3911),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3902),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [131] = {
    [sym__call_signature] = STATE(4595),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(1193),
    [anon_sym_export] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1196),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1209),
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(1206),
    [anon_sym_readonly] = ACTIONS(1206),
    [anon_sym_get] = ACTIONS(1206),
    [anon_sym_set] = ACTIONS(1206),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(1196),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_public] = ACTIONS(1196),
    [anon_sym_private] = ACTIONS(1196),
    [anon_sym_protected] = ACTIONS(1196),
    [anon_sym_override] = ACTIONS(1196),
    [anon_sym_module] = ACTIONS(1196),
    [anon_sym_any] = ACTIONS(1206),
    [anon_sym_number] = ACTIONS(1206),
    [anon_sym_boolean] = ACTIONS(1206),
    [anon_sym_string] = ACTIONS(1206),
    [anon_sym_symbol] = ACTIONS(1206),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_constructor] = ACTIONS(23),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [132] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2087),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3831),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3830),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [133] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2023),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3871),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3870),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [134] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3863),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3864),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1217),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [135] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LTtemplate_GT] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(1225),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1221),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_override] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_satisfies] = ACTIONS(1221),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_component] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1229),
    [sym__ternary_qmark] = ACTIONS(1225),
  },
  [136] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1986),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3938),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3939),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [137] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1987),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3718),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3722),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [138] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3745),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_RBRACK] = ACTIONS(1235),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [139] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3801),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3799),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [140] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2075),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_spread_element] = STATE(3843),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_array_repeat1] = STATE(3842),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [141] = {
    [sym__call_signature] = STATE(4595),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(1193),
    [anon_sym_export] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1196),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1209),
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(1206),
    [anon_sym_readonly] = ACTIONS(1206),
    [anon_sym_get] = ACTIONS(1206),
    [anon_sym_set] = ACTIONS(1206),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(1196),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_public] = ACTIONS(1196),
    [anon_sym_private] = ACTIONS(1196),
    [anon_sym_protected] = ACTIONS(1196),
    [anon_sym_override] = ACTIONS(1196),
    [anon_sym_module] = ACTIONS(1196),
    [anon_sym_any] = ACTIONS(1206),
    [anon_sym_number] = ACTIONS(1206),
    [anon_sym_boolean] = ACTIONS(1206),
    [anon_sym_string] = ACTIONS(1206),
    [anon_sym_symbol] = ACTIONS(1206),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_constructor] = ACTIONS(23),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [142] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_GT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_extends] = ACTIONS(1144),
    [anon_sym_component] = ACTIONS(117),
  },
  [143] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3528),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_accessibility_modifier] = STATE(160),
    [sym_override_modifier] = STATE(182),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(1381),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(1241),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(1247),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1249),
    [anon_sym_export] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1249),
    [anon_sym_import] = ACTIONS(1249),
    [anon_sym_var] = ACTIONS(1249),
    [anon_sym_let] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_in] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_debugger] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_throw] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_LTtemplate_GT] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1249),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_class] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_function] = ACTIONS(1249),
    [anon_sym_QMARK_DOT] = ACTIONS(1255),
    [anon_sym_new] = ACTIONS(1249),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [anon_sym_GT_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_QMARK_QMARK] = ACTIONS(1255),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1253),
    [sym_number] = ACTIONS(1253),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_undefined] = ACTIONS(1249),
    [anon_sym_AT] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_get] = ACTIONS(1249),
    [anon_sym_set] = ACTIONS(1249),
    [anon_sym_declare] = ACTIONS(1249),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_public] = ACTIONS(1249),
    [anon_sym_private] = ACTIONS(1249),
    [anon_sym_protected] = ACTIONS(1249),
    [anon_sym_override] = ACTIONS(1249),
    [anon_sym_module] = ACTIONS(1249),
    [anon_sym_any] = ACTIONS(1249),
    [anon_sym_number] = ACTIONS(1249),
    [anon_sym_boolean] = ACTIONS(1249),
    [anon_sym_string] = ACTIONS(1249),
    [anon_sym_symbol] = ACTIONS(1249),
    [anon_sym_abstract] = ACTIONS(1249),
    [anon_sym_satisfies] = ACTIONS(1251),
    [anon_sym_interface] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_component] = ACTIONS(1249),
    [sym__automatic_semicolon] = ACTIONS(1257),
    [sym__ternary_qmark] = ACTIONS(1255),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_as] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1259),
    [anon_sym_typeof] = ACTIONS(1259),
    [anon_sym_import] = ACTIONS(1259),
    [anon_sym_var] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_else] = ACTIONS(1259),
    [anon_sym_if] = ACTIONS(1259),
    [anon_sym_switch] = ACTIONS(1259),
    [anon_sym_for] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1259),
    [anon_sym_do] = ACTIONS(1259),
    [anon_sym_try] = ACTIONS(1259),
    [anon_sym_with] = ACTIONS(1259),
    [anon_sym_break] = ACTIONS(1259),
    [anon_sym_continue] = ACTIONS(1259),
    [anon_sym_debugger] = ACTIONS(1259),
    [anon_sym_return] = ACTIONS(1259),
    [anon_sym_throw] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(1259),
    [anon_sym_yield] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_LTtemplate_GT] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1261),
    [anon_sym_class] = ACTIONS(1259),
    [anon_sym_async] = ACTIONS(1259),
    [anon_sym_function] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_GT_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_QMARK_QMARK] = ACTIONS(1265),
    [anon_sym_instanceof] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_void] = ACTIONS(1259),
    [anon_sym_delete] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1259),
    [sym_super] = ACTIONS(1259),
    [sym_true] = ACTIONS(1259),
    [sym_false] = ACTIONS(1259),
    [sym_null] = ACTIONS(1259),
    [sym_undefined] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(1263),
    [anon_sym_static] = ACTIONS(1259),
    [anon_sym_readonly] = ACTIONS(1259),
    [anon_sym_get] = ACTIONS(1259),
    [anon_sym_set] = ACTIONS(1259),
    [anon_sym_declare] = ACTIONS(1259),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_public] = ACTIONS(1259),
    [anon_sym_private] = ACTIONS(1259),
    [anon_sym_protected] = ACTIONS(1259),
    [anon_sym_override] = ACTIONS(1259),
    [anon_sym_module] = ACTIONS(1259),
    [anon_sym_any] = ACTIONS(1259),
    [anon_sym_number] = ACTIONS(1259),
    [anon_sym_boolean] = ACTIONS(1259),
    [anon_sym_string] = ACTIONS(1259),
    [anon_sym_symbol] = ACTIONS(1259),
    [anon_sym_abstract] = ACTIONS(1259),
    [anon_sym_satisfies] = ACTIONS(1261),
    [anon_sym_interface] = ACTIONS(1259),
    [anon_sym_enum] = ACTIONS(1259),
    [anon_sym_component] = ACTIONS(1259),
    [sym__automatic_semicolon] = ACTIONS(1267),
    [sym__ternary_qmark] = ACTIONS(1265),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_as] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_type] = ACTIONS(1269),
    [anon_sym_typeof] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_in] = ACTIONS(1271),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_try] = ACTIONS(1269),
    [anon_sym_with] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_debugger] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_throw] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_yield] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_LTtemplate_GT] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1269),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_class] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_function] = ACTIONS(1269),
    [anon_sym_QMARK_DOT] = ACTIONS(1275),
    [anon_sym_new] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_GT_GT_GT] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1275),
    [anon_sym_QMARK_QMARK] = ACTIONS(1275),
    [anon_sym_instanceof] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1273),
    [anon_sym_void] = ACTIONS(1269),
    [anon_sym_delete] = ACTIONS(1269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_SQUOTE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_number] = ACTIONS(1273),
    [sym_this] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [sym_null] = ACTIONS(1269),
    [sym_undefined] = ACTIONS(1269),
    [anon_sym_AT] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_get] = ACTIONS(1269),
    [anon_sym_set] = ACTIONS(1269),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_public] = ACTIONS(1269),
    [anon_sym_private] = ACTIONS(1269),
    [anon_sym_protected] = ACTIONS(1269),
    [anon_sym_override] = ACTIONS(1269),
    [anon_sym_module] = ACTIONS(1269),
    [anon_sym_any] = ACTIONS(1269),
    [anon_sym_number] = ACTIONS(1269),
    [anon_sym_boolean] = ACTIONS(1269),
    [anon_sym_string] = ACTIONS(1269),
    [anon_sym_symbol] = ACTIONS(1269),
    [anon_sym_abstract] = ACTIONS(1269),
    [anon_sym_satisfies] = ACTIONS(1271),
    [anon_sym_interface] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_component] = ACTIONS(1269),
    [sym__automatic_semicolon] = ACTIONS(1277),
    [sym__ternary_qmark] = ACTIONS(1275),
  },
  [147] = {
    [sym__call_signature] = STATE(4355),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(1279),
    [anon_sym_export] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1284),
    [anon_sym_function] = ACTIONS(1209),
    [anon_sym_EQ_GT] = ACTIONS(1287),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(1284),
    [anon_sym_readonly] = ACTIONS(1284),
    [anon_sym_get] = ACTIONS(1282),
    [anon_sym_set] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(1282),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_public] = ACTIONS(1282),
    [anon_sym_private] = ACTIONS(1282),
    [anon_sym_protected] = ACTIONS(1282),
    [anon_sym_override] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [anon_sym_any] = ACTIONS(1284),
    [anon_sym_number] = ACTIONS(1284),
    [anon_sym_boolean] = ACTIONS(1284),
    [anon_sym_string] = ACTIONS(1284),
    [anon_sym_symbol] = ACTIONS(1284),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [148] = {
    [sym__call_signature] = STATE(4355),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(1279),
    [anon_sym_export] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1284),
    [anon_sym_function] = ACTIONS(1209),
    [anon_sym_EQ_GT] = ACTIONS(1287),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(1284),
    [anon_sym_readonly] = ACTIONS(1284),
    [anon_sym_get] = ACTIONS(1282),
    [anon_sym_set] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(1282),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_public] = ACTIONS(1282),
    [anon_sym_private] = ACTIONS(1282),
    [anon_sym_protected] = ACTIONS(1282),
    [anon_sym_override] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [anon_sym_any] = ACTIONS(1284),
    [anon_sym_number] = ACTIONS(1284),
    [anon_sym_boolean] = ACTIONS(1284),
    [anon_sym_string] = ACTIONS(1284),
    [anon_sym_symbol] = ACTIONS(1284),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [149] = {
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_as] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_type] = ACTIONS(1291),
    [anon_sym_typeof] = ACTIONS(1291),
    [anon_sym_import] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_let] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_try] = ACTIONS(1291),
    [anon_sym_with] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1291),
    [anon_sym_continue] = ACTIONS(1291),
    [anon_sym_debugger] = ACTIONS(1291),
    [anon_sym_return] = ACTIONS(1291),
    [anon_sym_throw] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1291),
    [anon_sym_default] = ACTIONS(1291),
    [anon_sym_yield] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1295),
    [anon_sym_LTtemplate_GT] = ACTIONS(1295),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_class] = ACTIONS(1291),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1291),
    [anon_sym_QMARK_DOT] = ACTIONS(1297),
    [anon_sym_new] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_GT_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_STAR] = ACTIONS(1297),
    [anon_sym_LT_EQ] = ACTIONS(1297),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1297),
    [anon_sym_BANG_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1297),
    [anon_sym_GT_EQ] = ACTIONS(1297),
    [anon_sym_QMARK_QMARK] = ACTIONS(1297),
    [anon_sym_instanceof] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_void] = ACTIONS(1291),
    [anon_sym_delete] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1295),
    [sym_this] = ACTIONS(1291),
    [sym_super] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_null] = ACTIONS(1291),
    [sym_undefined] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1295),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_readonly] = ACTIONS(1291),
    [anon_sym_get] = ACTIONS(1291),
    [anon_sym_set] = ACTIONS(1291),
    [anon_sym_declare] = ACTIONS(1291),
    [anon_sym_namespace] = ACTIONS(1291),
    [anon_sym_public] = ACTIONS(1291),
    [anon_sym_private] = ACTIONS(1291),
    [anon_sym_protected] = ACTIONS(1291),
    [anon_sym_override] = ACTIONS(1291),
    [anon_sym_module] = ACTIONS(1291),
    [anon_sym_any] = ACTIONS(1291),
    [anon_sym_number] = ACTIONS(1291),
    [anon_sym_boolean] = ACTIONS(1291),
    [anon_sym_string] = ACTIONS(1291),
    [anon_sym_symbol] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(1291),
    [anon_sym_satisfies] = ACTIONS(1293),
    [anon_sym_interface] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [anon_sym_component] = ACTIONS(1291),
    [sym__automatic_semicolon] = ACTIONS(1299),
    [sym__ternary_qmark] = ACTIONS(1297),
  },
  [150] = {
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_as] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1301),
    [anon_sym_typeof] = ACTIONS(1301),
    [anon_sym_import] = ACTIONS(1301),
    [anon_sym_var] = ACTIONS(1301),
    [anon_sym_let] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_await] = ACTIONS(1301),
    [anon_sym_in] = ACTIONS(1303),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_try] = ACTIONS(1301),
    [anon_sym_with] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_debugger] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_throw] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LTtemplate_GT] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_class] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1301),
    [anon_sym_function] = ACTIONS(1301),
    [anon_sym_QMARK_DOT] = ACTIONS(1307),
    [anon_sym_new] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_GT_GT_GT] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1307),
    [anon_sym_STAR_STAR] = ACTIONS(1307),
    [anon_sym_LT_EQ] = ACTIONS(1307),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1307),
    [anon_sym_BANG_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1307),
    [anon_sym_GT_EQ] = ACTIONS(1307),
    [anon_sym_QMARK_QMARK] = ACTIONS(1307),
    [anon_sym_instanceof] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_void] = ACTIONS(1301),
    [anon_sym_delete] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [sym_number] = ACTIONS(1305),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_get] = ACTIONS(1301),
    [anon_sym_set] = ACTIONS(1301),
    [anon_sym_declare] = ACTIONS(1301),
    [anon_sym_namespace] = ACTIONS(1301),
    [anon_sym_public] = ACTIONS(1301),
    [anon_sym_private] = ACTIONS(1301),
    [anon_sym_protected] = ACTIONS(1301),
    [anon_sym_override] = ACTIONS(1301),
    [anon_sym_module] = ACTIONS(1301),
    [anon_sym_any] = ACTIONS(1301),
    [anon_sym_number] = ACTIONS(1301),
    [anon_sym_boolean] = ACTIONS(1301),
    [anon_sym_string] = ACTIONS(1301),
    [anon_sym_symbol] = ACTIONS(1301),
    [anon_sym_abstract] = ACTIONS(1301),
    [anon_sym_satisfies] = ACTIONS(1303),
    [anon_sym_interface] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_component] = ACTIONS(1301),
    [sym__automatic_semicolon] = ACTIONS(1309),
    [sym__ternary_qmark] = ACTIONS(1307),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1313),
    [anon_sym_as] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_COMMA] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_typeof] = ACTIONS(1311),
    [anon_sym_import] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_do] = ACTIONS(1311),
    [anon_sym_try] = ACTIONS(1311),
    [anon_sym_with] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_debugger] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_throw] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_LTtemplate_GT] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1313),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_class] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(1317),
    [anon_sym_new] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_GT_GT_GT] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_CARET] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_STAR] = ACTIONS(1317),
    [anon_sym_LT_EQ] = ACTIONS(1317),
    [anon_sym_EQ_EQ] = ACTIONS(1313),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ] = ACTIONS(1313),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1317),
    [anon_sym_GT_EQ] = ACTIONS(1317),
    [anon_sym_QMARK_QMARK] = ACTIONS(1317),
    [anon_sym_instanceof] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_void] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [sym_number] = ACTIONS(1315),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1315),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_readonly] = ACTIONS(1311),
    [anon_sym_get] = ACTIONS(1311),
    [anon_sym_set] = ACTIONS(1311),
    [anon_sym_declare] = ACTIONS(1311),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_public] = ACTIONS(1311),
    [anon_sym_private] = ACTIONS(1311),
    [anon_sym_protected] = ACTIONS(1311),
    [anon_sym_override] = ACTIONS(1311),
    [anon_sym_module] = ACTIONS(1311),
    [anon_sym_any] = ACTIONS(1311),
    [anon_sym_number] = ACTIONS(1311),
    [anon_sym_boolean] = ACTIONS(1311),
    [anon_sym_string] = ACTIONS(1311),
    [anon_sym_symbol] = ACTIONS(1311),
    [anon_sym_abstract] = ACTIONS(1311),
    [anon_sym_satisfies] = ACTIONS(1313),
    [anon_sym_interface] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_component] = ACTIONS(1311),
    [sym__automatic_semicolon] = ACTIONS(1319),
    [sym__ternary_qmark] = ACTIONS(1317),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_as] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_var] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_await] = ACTIONS(1321),
    [anon_sym_in] = ACTIONS(1323),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_try] = ACTIONS(1321),
    [anon_sym_with] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_debugger] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_throw] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_yield] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_LTtemplate_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1321),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_SLASH] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_class] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(1321),
    [anon_sym_QMARK_DOT] = ACTIONS(1327),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_GT_GT] = ACTIONS(1323),
    [anon_sym_GT_GT_GT] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_EQ_EQ] = ACTIONS(1323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1327),
    [anon_sym_BANG_EQ] = ACTIONS(1323),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1327),
    [anon_sym_QMARK_QMARK] = ACTIONS(1327),
    [anon_sym_instanceof] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_void] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(1321),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1325),
    [sym_number] = ACTIONS(1325),
    [sym_this] = ACTIONS(1321),
    [sym_super] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_undefined] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1321),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_override] = ACTIONS(1321),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_abstract] = ACTIONS(1321),
    [anon_sym_satisfies] = ACTIONS(1323),
    [anon_sym_interface] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_component] = ACTIONS(1321),
    [sym__automatic_semicolon] = ACTIONS(1329),
    [sym__ternary_qmark] = ACTIONS(1327),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1331),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_as] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_COMMA] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1335),
    [anon_sym_type] = ACTIONS(1331),
    [anon_sym_typeof] = ACTIONS(1331),
    [anon_sym_import] = ACTIONS(1331),
    [anon_sym_var] = ACTIONS(1331),
    [anon_sym_let] = ACTIONS(1331),
    [anon_sym_const] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_else] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_switch] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [anon_sym_await] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_do] = ACTIONS(1331),
    [anon_sym_try] = ACTIONS(1331),
    [anon_sym_with] = ACTIONS(1331),
    [anon_sym_break] = ACTIONS(1331),
    [anon_sym_continue] = ACTIONS(1331),
    [anon_sym_debugger] = ACTIONS(1331),
    [anon_sym_return] = ACTIONS(1331),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_case] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_GT] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1331),
    [anon_sym_DOT] = ACTIONS(1333),
    [anon_sym_class] = ACTIONS(1331),
    [anon_sym_async] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_QMARK_DOT] = ACTIONS(1337),
    [anon_sym_new] = ACTIONS(1331),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_GT_GT_GT] = ACTIONS(1337),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_QMARK_QMARK] = ACTIONS(1337),
    [anon_sym_instanceof] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_delete] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [sym_number] = ACTIONS(1335),
    [sym_this] = ACTIONS(1331),
    [sym_super] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_undefined] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(1335),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_readonly] = ACTIONS(1331),
    [anon_sym_get] = ACTIONS(1331),
    [anon_sym_set] = ACTIONS(1331),
    [anon_sym_declare] = ACTIONS(1331),
    [anon_sym_namespace] = ACTIONS(1331),
    [anon_sym_public] = ACTIONS(1331),
    [anon_sym_private] = ACTIONS(1331),
    [anon_sym_protected] = ACTIONS(1331),
    [anon_sym_override] = ACTIONS(1331),
    [anon_sym_module] = ACTIONS(1331),
    [anon_sym_any] = ACTIONS(1331),
    [anon_sym_number] = ACTIONS(1331),
    [anon_sym_boolean] = ACTIONS(1331),
    [anon_sym_string] = ACTIONS(1331),
    [anon_sym_symbol] = ACTIONS(1331),
    [anon_sym_abstract] = ACTIONS(1331),
    [anon_sym_satisfies] = ACTIONS(1333),
    [anon_sym_interface] = ACTIONS(1331),
    [anon_sym_enum] = ACTIONS(1331),
    [anon_sym_component] = ACTIONS(1331),
    [sym__automatic_semicolon] = ACTIONS(1339),
    [sym__ternary_qmark] = ACTIONS(1337),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1341),
    [anon_sym_export] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_as] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_COMMA] = ACTIONS(1343),
    [anon_sym_RBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(1341),
    [anon_sym_typeof] = ACTIONS(1341),
    [anon_sym_import] = ACTIONS(1341),
    [anon_sym_var] = ACTIONS(1341),
    [anon_sym_let] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1343),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_try] = ACTIONS(1341),
    [anon_sym_with] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_debugger] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_throw] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_yield] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1343),
    [anon_sym_LTtemplate_GT] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1341),
    [anon_sym_class] = ACTIONS(1341),
    [anon_sym_async] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_QMARK_DOT] = ACTIONS(1343),
    [anon_sym_new] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1343),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1343),
    [anon_sym_GT_EQ] = ACTIONS(1343),
    [anon_sym_QMARK_QMARK] = ACTIONS(1343),
    [anon_sym_instanceof] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_void] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [sym_number] = ACTIONS(1343),
    [sym_this] = ACTIONS(1341),
    [sym_super] = ACTIONS(1341),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [sym_null] = ACTIONS(1341),
    [sym_undefined] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_get] = ACTIONS(1341),
    [anon_sym_set] = ACTIONS(1341),
    [anon_sym_declare] = ACTIONS(1341),
    [anon_sym_namespace] = ACTIONS(1341),
    [anon_sym_public] = ACTIONS(1341),
    [anon_sym_private] = ACTIONS(1341),
    [anon_sym_protected] = ACTIONS(1341),
    [anon_sym_override] = ACTIONS(1341),
    [anon_sym_module] = ACTIONS(1341),
    [anon_sym_any] = ACTIONS(1341),
    [anon_sym_number] = ACTIONS(1341),
    [anon_sym_boolean] = ACTIONS(1341),
    [anon_sym_string] = ACTIONS(1341),
    [anon_sym_symbol] = ACTIONS(1341),
    [anon_sym_abstract] = ACTIONS(1341),
    [anon_sym_satisfies] = ACTIONS(1341),
    [anon_sym_interface] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_component] = ACTIONS(1341),
    [sym__automatic_semicolon] = ACTIONS(1343),
    [sym__ternary_qmark] = ACTIONS(1343),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_COMMA] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_QMARK_DOT] = ACTIONS(1347),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_GT_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1347),
    [anon_sym_QMARK_QMARK] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_satisfies] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(1347),
    [sym__ternary_qmark] = ACTIONS(1347),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_export] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_as] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_type] = ACTIONS(1349),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(1349),
    [anon_sym_var] = ACTIONS(1349),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_await] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_try] = ACTIONS(1349),
    [anon_sym_with] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_debugger] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_throw] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_LTtemplate_GT] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1349),
    [anon_sym_QMARK_DOT] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1351),
    [anon_sym_GT_GT_GT] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1355),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_QMARK_QMARK] = ACTIONS(1355),
    [anon_sym_instanceof] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1353),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1349),
    [sym_super] = ACTIONS(1349),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [sym_null] = ACTIONS(1349),
    [sym_undefined] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_get] = ACTIONS(1349),
    [anon_sym_set] = ACTIONS(1349),
    [anon_sym_declare] = ACTIONS(1349),
    [anon_sym_namespace] = ACTIONS(1349),
    [anon_sym_public] = ACTIONS(1349),
    [anon_sym_private] = ACTIONS(1349),
    [anon_sym_protected] = ACTIONS(1349),
    [anon_sym_override] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_any] = ACTIONS(1349),
    [anon_sym_number] = ACTIONS(1349),
    [anon_sym_boolean] = ACTIONS(1349),
    [anon_sym_string] = ACTIONS(1349),
    [anon_sym_symbol] = ACTIONS(1349),
    [anon_sym_abstract] = ACTIONS(1349),
    [anon_sym_satisfies] = ACTIONS(1351),
    [anon_sym_interface] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_component] = ACTIONS(1349),
    [sym__automatic_semicolon] = ACTIONS(1357),
    [sym__ternary_qmark] = ACTIONS(1355),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_as] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_await] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_try] = ACTIONS(1359),
    [anon_sym_with] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_debugger] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_throw] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1359),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_yield] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_LTtemplate_GT] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_class] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1359),
    [anon_sym_QMARK_DOT] = ACTIONS(1361),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_GT_GT] = ACTIONS(1359),
    [anon_sym_GT_GT_GT] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1361),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1361),
    [anon_sym_QMARK_QMARK] = ACTIONS(1361),
    [anon_sym_instanceof] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_number] = ACTIONS(1361),
    [sym_this] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_readonly] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_declare] = ACTIONS(1359),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_public] = ACTIONS(1359),
    [anon_sym_private] = ACTIONS(1359),
    [anon_sym_protected] = ACTIONS(1359),
    [anon_sym_override] = ACTIONS(1359),
    [anon_sym_module] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_satisfies] = ACTIONS(1359),
    [anon_sym_interface] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_component] = ACTIONS(1359),
    [sym__automatic_semicolon] = ACTIONS(1361),
    [sym__ternary_qmark] = ACTIONS(1361),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1363),
    [anon_sym_export] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_as] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_type] = ACTIONS(1363),
    [anon_sym_typeof] = ACTIONS(1363),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1363),
    [anon_sym_let] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_else] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1363),
    [anon_sym_switch] = ACTIONS(1363),
    [anon_sym_for] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1363),
    [anon_sym_do] = ACTIONS(1363),
    [anon_sym_try] = ACTIONS(1363),
    [anon_sym_with] = ACTIONS(1363),
    [anon_sym_break] = ACTIONS(1363),
    [anon_sym_continue] = ACTIONS(1363),
    [anon_sym_debugger] = ACTIONS(1363),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_throw] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(1363),
    [anon_sym_yield] = ACTIONS(1363),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_LTtemplate_GT] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_DOT] = ACTIONS(1365),
    [anon_sym_class] = ACTIONS(1363),
    [anon_sym_async] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1363),
    [anon_sym_QMARK_DOT] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1369),
    [anon_sym_PIPE_PIPE] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_GT_GT_GT] = ACTIONS(1369),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(1369),
    [anon_sym_LT_EQ] = ACTIONS(1369),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1369),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_QMARK_QMARK] = ACTIONS(1369),
    [anon_sym_instanceof] = ACTIONS(1365),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_void] = ACTIONS(1363),
    [anon_sym_delete] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [sym_number] = ACTIONS(1367),
    [sym_this] = ACTIONS(1363),
    [sym_super] = ACTIONS(1363),
    [sym_true] = ACTIONS(1363),
    [sym_false] = ACTIONS(1363),
    [sym_null] = ACTIONS(1363),
    [sym_undefined] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1363),
    [anon_sym_readonly] = ACTIONS(1363),
    [anon_sym_get] = ACTIONS(1363),
    [anon_sym_set] = ACTIONS(1363),
    [anon_sym_declare] = ACTIONS(1363),
    [anon_sym_namespace] = ACTIONS(1363),
    [anon_sym_public] = ACTIONS(1363),
    [anon_sym_private] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(1363),
    [anon_sym_override] = ACTIONS(1363),
    [anon_sym_module] = ACTIONS(1363),
    [anon_sym_any] = ACTIONS(1363),
    [anon_sym_number] = ACTIONS(1363),
    [anon_sym_boolean] = ACTIONS(1363),
    [anon_sym_string] = ACTIONS(1363),
    [anon_sym_symbol] = ACTIONS(1363),
    [anon_sym_abstract] = ACTIONS(1363),
    [anon_sym_satisfies] = ACTIONS(1365),
    [anon_sym_interface] = ACTIONS(1363),
    [anon_sym_enum] = ACTIONS(1363),
    [anon_sym_component] = ACTIONS(1363),
    [sym__automatic_semicolon] = ACTIONS(1371),
    [sym__ternary_qmark] = ACTIONS(1369),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_as] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_COMMA] = ACTIONS(1379),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_typeof] = ACTIONS(1373),
    [anon_sym_import] = ACTIONS(1373),
    [anon_sym_var] = ACTIONS(1373),
    [anon_sym_let] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1373),
    [anon_sym_in] = ACTIONS(1375),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_try] = ACTIONS(1373),
    [anon_sym_with] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_debugger] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_throw] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1377),
    [anon_sym_LTtemplate_GT] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1373),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_class] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1373),
    [anon_sym_QMARK_DOT] = ACTIONS(1379),
    [anon_sym_new] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1375),
    [anon_sym_GT_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_QMARK_QMARK] = ACTIONS(1379),
    [anon_sym_instanceof] = ACTIONS(1375),
    [anon_sym_TILDE] = ACTIONS(1377),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_delete] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_SQUOTE] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [sym_number] = ACTIONS(1377),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_namespace] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_override] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_any] = ACTIONS(1373),
    [anon_sym_number] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(1373),
    [anon_sym_satisfies] = ACTIONS(1375),
    [anon_sym_interface] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_component] = ACTIONS(1373),
    [sym__automatic_semicolon] = ACTIONS(1381),
    [sym__ternary_qmark] = ACTIONS(1379),
  },
  [160] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3471),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_override_modifier] = STATE(185),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1383),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1385),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1387),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1389),
    [anon_sym_as] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_type] = ACTIONS(1387),
    [anon_sym_typeof] = ACTIONS(1387),
    [anon_sym_import] = ACTIONS(1387),
    [anon_sym_var] = ACTIONS(1387),
    [anon_sym_let] = ACTIONS(1387),
    [anon_sym_const] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1387),
    [anon_sym_switch] = ACTIONS(1387),
    [anon_sym_for] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1391),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1387),
    [anon_sym_do] = ACTIONS(1387),
    [anon_sym_try] = ACTIONS(1387),
    [anon_sym_with] = ACTIONS(1387),
    [anon_sym_break] = ACTIONS(1387),
    [anon_sym_continue] = ACTIONS(1387),
    [anon_sym_debugger] = ACTIONS(1387),
    [anon_sym_return] = ACTIONS(1387),
    [anon_sym_throw] = ACTIONS(1387),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_case] = ACTIONS(1387),
    [anon_sym_default] = ACTIONS(1387),
    [anon_sym_yield] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1391),
    [anon_sym_LTtemplate_GT] = ACTIONS(1391),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1389),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1387),
    [anon_sym_async] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1387),
    [anon_sym_QMARK_DOT] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1387),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_GT_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1389),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_QMARK_QMARK] = ACTIONS(1393),
    [anon_sym_instanceof] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1391),
    [sym_number] = ACTIONS(1391),
    [sym_this] = ACTIONS(1387),
    [sym_super] = ACTIONS(1387),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [sym_null] = ACTIONS(1387),
    [sym_undefined] = ACTIONS(1387),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_static] = ACTIONS(1387),
    [anon_sym_readonly] = ACTIONS(1387),
    [anon_sym_get] = ACTIONS(1387),
    [anon_sym_set] = ACTIONS(1387),
    [anon_sym_declare] = ACTIONS(1387),
    [anon_sym_namespace] = ACTIONS(1387),
    [anon_sym_public] = ACTIONS(1387),
    [anon_sym_private] = ACTIONS(1387),
    [anon_sym_protected] = ACTIONS(1387),
    [anon_sym_override] = ACTIONS(1387),
    [anon_sym_module] = ACTIONS(1387),
    [anon_sym_any] = ACTIONS(1387),
    [anon_sym_number] = ACTIONS(1387),
    [anon_sym_boolean] = ACTIONS(1387),
    [anon_sym_string] = ACTIONS(1387),
    [anon_sym_symbol] = ACTIONS(1387),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_satisfies] = ACTIONS(1389),
    [anon_sym_interface] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1387),
    [anon_sym_component] = ACTIONS(1387),
    [sym__automatic_semicolon] = ACTIONS(1395),
    [sym__ternary_qmark] = ACTIONS(1393),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1397),
    [anon_sym_export] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1397),
    [anon_sym_as] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_COMMA] = ACTIONS(1399),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_type] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1397),
    [anon_sym_import] = ACTIONS(1397),
    [anon_sym_var] = ACTIONS(1397),
    [anon_sym_let] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1397),
    [anon_sym_else] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1399),
    [anon_sym_await] = ACTIONS(1397),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_try] = ACTIONS(1397),
    [anon_sym_with] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_debugger] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_throw] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [anon_sym_LTtemplate_GT] = ACTIONS(1399),
    [anon_sym_LT] = ACTIONS(1397),
    [anon_sym_GT] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1397),
    [anon_sym_function] = ACTIONS(1397),
    [anon_sym_QMARK_DOT] = ACTIONS(1399),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE_PIPE] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_GT_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1397),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PERCENT] = ACTIONS(1399),
    [anon_sym_STAR_STAR] = ACTIONS(1399),
    [anon_sym_LT_EQ] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1399),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1399),
    [anon_sym_GT_EQ] = ACTIONS(1399),
    [anon_sym_QMARK_QMARK] = ACTIONS(1399),
    [anon_sym_instanceof] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_void] = ACTIONS(1397),
    [anon_sym_delete] = ACTIONS(1397),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1399),
    [sym_number] = ACTIONS(1399),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(1399),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_get] = ACTIONS(1397),
    [anon_sym_set] = ACTIONS(1397),
    [anon_sym_declare] = ACTIONS(1397),
    [anon_sym_namespace] = ACTIONS(1397),
    [anon_sym_public] = ACTIONS(1397),
    [anon_sym_private] = ACTIONS(1397),
    [anon_sym_protected] = ACTIONS(1397),
    [anon_sym_override] = ACTIONS(1397),
    [anon_sym_module] = ACTIONS(1397),
    [anon_sym_any] = ACTIONS(1397),
    [anon_sym_number] = ACTIONS(1397),
    [anon_sym_boolean] = ACTIONS(1397),
    [anon_sym_string] = ACTIONS(1397),
    [anon_sym_symbol] = ACTIONS(1397),
    [anon_sym_abstract] = ACTIONS(1397),
    [anon_sym_satisfies] = ACTIONS(1397),
    [anon_sym_interface] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_component] = ACTIONS(1397),
    [sym__automatic_semicolon] = ACTIONS(1399),
    [sym__ternary_qmark] = ACTIONS(1399),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1401),
    [anon_sym_var] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_try] = ACTIONS(1401),
    [anon_sym_with] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_debugger] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1401),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_SLASH] = ACTIONS(1401),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1401),
    [anon_sym_QMARK_DOT] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(1401),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [anon_sym_GT_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_CARET] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1403),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_QMARK_QMARK] = ACTIONS(1407),
    [anon_sym_instanceof] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1405),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1405),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1405),
    [sym_number] = ACTIONS(1405),
    [sym_this] = ACTIONS(1401),
    [sym_super] = ACTIONS(1401),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_undefined] = ACTIONS(1401),
    [anon_sym_AT] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_abstract] = ACTIONS(1401),
    [anon_sym_satisfies] = ACTIONS(1403),
    [anon_sym_interface] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_component] = ACTIONS(1401),
    [sym__automatic_semicolon] = ACTIONS(1409),
    [sym__ternary_qmark] = ACTIONS(1407),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_as] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1411),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_let] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_in] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_try] = ACTIONS(1411),
    [anon_sym_with] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_debugger] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_throw] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_function] = ACTIONS(1411),
    [anon_sym_QMARK_DOT] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1411),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_GT_GT_GT] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_QMARK_QMARK] = ACTIONS(1413),
    [anon_sym_instanceof] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1413),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [sym_number] = ACTIONS(1413),
    [sym_this] = ACTIONS(1411),
    [sym_super] = ACTIONS(1411),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_readonly] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1411),
    [anon_sym_public] = ACTIONS(1411),
    [anon_sym_private] = ACTIONS(1411),
    [anon_sym_protected] = ACTIONS(1411),
    [anon_sym_override] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [anon_sym_abstract] = ACTIONS(1411),
    [anon_sym_satisfies] = ACTIONS(1411),
    [anon_sym_interface] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_component] = ACTIONS(1411),
    [sym__automatic_semicolon] = ACTIONS(1413),
    [sym__ternary_qmark] = ACTIONS(1413),
  },
  [165] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_override_modifier] = STATE(181),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1417),
    [anon_sym_export] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_as] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1423),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1417),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym_import] = ACTIONS(1417),
    [anon_sym_var] = ACTIONS(1417),
    [anon_sym_let] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_BANG] = ACTIONS(1417),
    [anon_sym_else] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_await] = ACTIONS(1417),
    [anon_sym_in] = ACTIONS(1419),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_try] = ACTIONS(1417),
    [anon_sym_with] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_debugger] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_throw] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_yield] = ACTIONS(1417),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_LTtemplate_GT] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1417),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_SLASH] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1419),
    [anon_sym_class] = ACTIONS(1417),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(1417),
    [anon_sym_QMARK_DOT] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1417),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_PIPE_PIPE] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_GT_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1423),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_PERCENT] = ACTIONS(1423),
    [anon_sym_STAR_STAR] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1423),
    [anon_sym_EQ_EQ] = ACTIONS(1419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1423),
    [anon_sym_BANG_EQ] = ACTIONS(1419),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1423),
    [anon_sym_GT_EQ] = ACTIONS(1423),
    [anon_sym_QMARK_QMARK] = ACTIONS(1423),
    [anon_sym_instanceof] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1417),
    [anon_sym_delete] = ACTIONS(1417),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1421),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [sym_number] = ACTIONS(1421),
    [sym_this] = ACTIONS(1417),
    [sym_super] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_undefined] = ACTIONS(1417),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_get] = ACTIONS(1417),
    [anon_sym_set] = ACTIONS(1417),
    [anon_sym_declare] = ACTIONS(1417),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_public] = ACTIONS(1417),
    [anon_sym_private] = ACTIONS(1417),
    [anon_sym_protected] = ACTIONS(1417),
    [anon_sym_override] = ACTIONS(1417),
    [anon_sym_module] = ACTIONS(1417),
    [anon_sym_any] = ACTIONS(1417),
    [anon_sym_number] = ACTIONS(1417),
    [anon_sym_boolean] = ACTIONS(1417),
    [anon_sym_string] = ACTIONS(1417),
    [anon_sym_symbol] = ACTIONS(1417),
    [anon_sym_abstract] = ACTIONS(1417),
    [anon_sym_satisfies] = ACTIONS(1419),
    [anon_sym_interface] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_component] = ACTIONS(1417),
    [sym__automatic_semicolon] = ACTIONS(1425),
    [sym__ternary_qmark] = ACTIONS(1423),
  },
  [167] = {
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_as] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_type] = ACTIONS(1427),
    [anon_sym_typeof] = ACTIONS(1427),
    [anon_sym_import] = ACTIONS(1427),
    [anon_sym_var] = ACTIONS(1427),
    [anon_sym_let] = ACTIONS(1427),
    [anon_sym_const] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_else] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_switch] = ACTIONS(1427),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_await] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_try] = ACTIONS(1427),
    [anon_sym_with] = ACTIONS(1427),
    [anon_sym_break] = ACTIONS(1427),
    [anon_sym_continue] = ACTIONS(1427),
    [anon_sym_debugger] = ACTIONS(1427),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_LTtemplate_GT] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(1427),
    [anon_sym_QMARK_DOT] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_AMP_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_QMARK_QMARK] = ACTIONS(1433),
    [anon_sym_instanceof] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_void] = ACTIONS(1427),
    [anon_sym_delete] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1431),
    [sym_number] = ACTIONS(1431),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(1427),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_get] = ACTIONS(1427),
    [anon_sym_set] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [anon_sym_namespace] = ACTIONS(1427),
    [anon_sym_public] = ACTIONS(1427),
    [anon_sym_private] = ACTIONS(1427),
    [anon_sym_protected] = ACTIONS(1427),
    [anon_sym_override] = ACTIONS(1427),
    [anon_sym_module] = ACTIONS(1427),
    [anon_sym_any] = ACTIONS(1427),
    [anon_sym_number] = ACTIONS(1427),
    [anon_sym_boolean] = ACTIONS(1427),
    [anon_sym_string] = ACTIONS(1427),
    [anon_sym_symbol] = ACTIONS(1427),
    [anon_sym_abstract] = ACTIONS(1427),
    [anon_sym_satisfies] = ACTIONS(1429),
    [anon_sym_interface] = ACTIONS(1427),
    [anon_sym_enum] = ACTIONS(1427),
    [anon_sym_component] = ACTIONS(1427),
    [sym__automatic_semicolon] = ACTIONS(1435),
    [sym__ternary_qmark] = ACTIONS(1433),
  },
  [168] = {
    [sym_import] = STATE(2149),
    [sym_expression_statement] = STATE(192),
    [sym_empty_statement] = STATE(192),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1437),
    [anon_sym_export] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_COMMA] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_type] = ACTIONS(1437),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(1437),
    [anon_sym_var] = ACTIONS(1437),
    [anon_sym_let] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_await] = ACTIONS(1437),
    [anon_sym_in] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_try] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_debugger] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_yield] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_LTtemplate_GT] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_class] = ACTIONS(1437),
    [anon_sym_async] = ACTIONS(1437),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_QMARK_DOT] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_GT_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1443),
    [anon_sym_QMARK_QMARK] = ACTIONS(1443),
    [anon_sym_instanceof] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1441),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1441),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1437),
    [sym_super] = ACTIONS(1437),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [sym_null] = ACTIONS(1437),
    [sym_undefined] = ACTIONS(1437),
    [anon_sym_AT] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1437),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_public] = ACTIONS(1437),
    [anon_sym_private] = ACTIONS(1437),
    [anon_sym_protected] = ACTIONS(1437),
    [anon_sym_override] = ACTIONS(1437),
    [anon_sym_module] = ACTIONS(1437),
    [anon_sym_any] = ACTIONS(1437),
    [anon_sym_number] = ACTIONS(1437),
    [anon_sym_boolean] = ACTIONS(1437),
    [anon_sym_string] = ACTIONS(1437),
    [anon_sym_symbol] = ACTIONS(1437),
    [anon_sym_abstract] = ACTIONS(1437),
    [anon_sym_satisfies] = ACTIONS(1439),
    [anon_sym_interface] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_component] = ACTIONS(1437),
    [sym__automatic_semicolon] = ACTIONS(1445),
    [sym__ternary_qmark] = ACTIONS(1443),
  },
  [170] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_COMMA] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_QMARK_DOT] = ACTIONS(1347),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_GT_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1347),
    [anon_sym_QMARK_QMARK] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_satisfies] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(1447),
    [sym__ternary_qmark] = ACTIONS(1347),
  },
  [171] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4278),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3741),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [172] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2157),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_assignment_pattern] = STATE(4278),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3741),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(605),
    [anon_sym_set] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(605),
    [anon_sym_namespace] = ACTIONS(605),
    [anon_sym_public] = ACTIONS(605),
    [anon_sym_private] = ACTIONS(605),
    [anon_sym_protected] = ACTIONS(605),
    [anon_sym_override] = ACTIONS(605),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [anon_sym_component] = ACTIONS(117),
  },
  [173] = {
    [sym_import] = STATE(2149),
    [sym_expression_statement] = STATE(196),
    [sym_empty_statement] = STATE(196),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4282),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LTtemplate_GT] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1219),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(1223),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_QMARK_QMARK] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_override] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_satisfies] = ACTIONS(1219),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_component] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1449),
    [sym__ternary_qmark] = ACTIONS(1223),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1451),
    [anon_sym_export] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_as] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_type] = ACTIONS(1451),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym_import] = ACTIONS(1451),
    [anon_sym_var] = ACTIONS(1451),
    [anon_sym_let] = ACTIONS(1451),
    [anon_sym_const] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_else] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_switch] = ACTIONS(1451),
    [anon_sym_for] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_await] = ACTIONS(1451),
    [anon_sym_in] = ACTIONS(1451),
    [anon_sym_while] = ACTIONS(1451),
    [anon_sym_do] = ACTIONS(1451),
    [anon_sym_try] = ACTIONS(1451),
    [anon_sym_with] = ACTIONS(1451),
    [anon_sym_break] = ACTIONS(1451),
    [anon_sym_continue] = ACTIONS(1451),
    [anon_sym_debugger] = ACTIONS(1451),
    [anon_sym_return] = ACTIONS(1451),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1451),
    [anon_sym_default] = ACTIONS(1451),
    [anon_sym_yield] = ACTIONS(1451),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_class] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(1451),
    [anon_sym_QMARK_DOT] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1453),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_GT_GT_GT] = ACTIONS(1453),
    [anon_sym_LT_LT] = ACTIONS(1453),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_CARET] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_LT_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_BANG_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1453),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_QMARK_QMARK] = ACTIONS(1453),
    [anon_sym_instanceof] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1453),
    [anon_sym_void] = ACTIONS(1451),
    [anon_sym_delete] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1453),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1451),
    [sym_super] = ACTIONS(1451),
    [sym_true] = ACTIONS(1451),
    [sym_false] = ACTIONS(1451),
    [sym_null] = ACTIONS(1451),
    [sym_undefined] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1451),
    [anon_sym_readonly] = ACTIONS(1451),
    [anon_sym_get] = ACTIONS(1451),
    [anon_sym_set] = ACTIONS(1451),
    [anon_sym_declare] = ACTIONS(1451),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_public] = ACTIONS(1451),
    [anon_sym_private] = ACTIONS(1451),
    [anon_sym_protected] = ACTIONS(1451),
    [anon_sym_override] = ACTIONS(1451),
    [anon_sym_module] = ACTIONS(1451),
    [anon_sym_any] = ACTIONS(1451),
    [anon_sym_number] = ACTIONS(1451),
    [anon_sym_boolean] = ACTIONS(1451),
    [anon_sym_string] = ACTIONS(1451),
    [anon_sym_symbol] = ACTIONS(1451),
    [anon_sym_abstract] = ACTIONS(1451),
    [anon_sym_satisfies] = ACTIONS(1451),
    [anon_sym_interface] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(1451),
    [anon_sym_component] = ACTIONS(1451),
    [sym__automatic_semicolon] = ACTIONS(1453),
    [sym__ternary_qmark] = ACTIONS(1453),
  },
  [176] = {
    [sym_identifier] = ACTIONS(1455),
    [anon_sym_export] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1457),
    [anon_sym_as] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_type] = ACTIONS(1455),
    [anon_sym_typeof] = ACTIONS(1455),
    [anon_sym_import] = ACTIONS(1455),
    [anon_sym_var] = ACTIONS(1455),
    [anon_sym_let] = ACTIONS(1455),
    [anon_sym_const] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_else] = ACTIONS(1455),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_switch] = ACTIONS(1455),
    [anon_sym_for] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1455),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1455),
    [anon_sym_do] = ACTIONS(1455),
    [anon_sym_try] = ACTIONS(1455),
    [anon_sym_with] = ACTIONS(1455),
    [anon_sym_break] = ACTIONS(1455),
    [anon_sym_continue] = ACTIONS(1455),
    [anon_sym_debugger] = ACTIONS(1455),
    [anon_sym_return] = ACTIONS(1455),
    [anon_sym_throw] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1455),
    [anon_sym_default] = ACTIONS(1455),
    [anon_sym_yield] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_DOT] = ACTIONS(1457),
    [anon_sym_class] = ACTIONS(1455),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(1455),
    [anon_sym_QMARK_DOT] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1461),
    [anon_sym_GT_GT] = ACTIONS(1457),
    [anon_sym_GT_GT_GT] = ACTIONS(1461),
    [anon_sym_LT_LT] = ACTIONS(1461),
    [anon_sym_AMP] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1461),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_QMARK_QMARK] = ACTIONS(1461),
    [anon_sym_instanceof] = ACTIONS(1457),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1455),
    [anon_sym_delete] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(1455),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_undefined] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1455),
    [anon_sym_readonly] = ACTIONS(1455),
    [anon_sym_get] = ACTIONS(1455),
    [anon_sym_set] = ACTIONS(1455),
    [anon_sym_declare] = ACTIONS(1455),
    [anon_sym_namespace] = ACTIONS(1455),
    [anon_sym_public] = ACTIONS(1455),
    [anon_sym_private] = ACTIONS(1455),
    [anon_sym_protected] = ACTIONS(1455),
    [anon_sym_override] = ACTIONS(1455),
    [anon_sym_module] = ACTIONS(1455),
    [anon_sym_any] = ACTIONS(1455),
    [anon_sym_number] = ACTIONS(1455),
    [anon_sym_boolean] = ACTIONS(1455),
    [anon_sym_string] = ACTIONS(1455),
    [anon_sym_symbol] = ACTIONS(1455),
    [anon_sym_abstract] = ACTIONS(1455),
    [anon_sym_satisfies] = ACTIONS(1457),
    [anon_sym_interface] = ACTIONS(1455),
    [anon_sym_enum] = ACTIONS(1455),
    [anon_sym_component] = ACTIONS(1455),
    [sym__automatic_semicolon] = ACTIONS(1463),
    [sym__ternary_qmark] = ACTIONS(1461),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1401),
    [anon_sym_var] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_try] = ACTIONS(1401),
    [anon_sym_with] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_debugger] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1401),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_SLASH] = ACTIONS(1401),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_class] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1401),
    [anon_sym_QMARK_DOT] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(1401),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [anon_sym_GT_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_CARET] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1403),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_QMARK_QMARK] = ACTIONS(1407),
    [anon_sym_instanceof] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1405),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1405),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1405),
    [sym_number] = ACTIONS(1405),
    [sym_this] = ACTIONS(1401),
    [sym_super] = ACTIONS(1401),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_undefined] = ACTIONS(1401),
    [anon_sym_AT] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_abstract] = ACTIONS(1401),
    [anon_sym_satisfies] = ACTIONS(1403),
    [anon_sym_interface] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_component] = ACTIONS(1401),
    [sym__automatic_semicolon] = ACTIONS(1465),
    [sym__ternary_qmark] = ACTIONS(1407),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1467),
    [anon_sym_STAR] = ACTIONS(1469),
    [anon_sym_as] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_type] = ACTIONS(1467),
    [anon_sym_typeof] = ACTIONS(1467),
    [anon_sym_import] = ACTIONS(1467),
    [anon_sym_var] = ACTIONS(1467),
    [anon_sym_let] = ACTIONS(1467),
    [anon_sym_const] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_do] = ACTIONS(1467),
    [anon_sym_try] = ACTIONS(1467),
    [anon_sym_with] = ACTIONS(1467),
    [anon_sym_break] = ACTIONS(1467),
    [anon_sym_continue] = ACTIONS(1467),
    [anon_sym_debugger] = ACTIONS(1467),
    [anon_sym_return] = ACTIONS(1467),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1467),
    [anon_sym_default] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_GT] = ACTIONS(1469),
    [anon_sym_SLASH] = ACTIONS(1467),
    [anon_sym_DOT] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(1467),
    [anon_sym_async] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_QMARK_DOT] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1469),
    [anon_sym_GT_GT_GT] = ACTIONS(1473),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_PERCENT] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1473),
    [anon_sym_LT_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1473),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_QMARK_QMARK] = ACTIONS(1473),
    [anon_sym_instanceof] = ACTIONS(1469),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_void] = ACTIONS(1467),
    [anon_sym_delete] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1467),
    [sym_super] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_undefined] = ACTIONS(1467),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_static] = ACTIONS(1467),
    [anon_sym_readonly] = ACTIONS(1467),
    [anon_sym_get] = ACTIONS(1467),
    [anon_sym_set] = ACTIONS(1467),
    [anon_sym_declare] = ACTIONS(1467),
    [anon_sym_namespace] = ACTIONS(1467),
    [anon_sym_public] = ACTIONS(1467),
    [anon_sym_private] = ACTIONS(1467),
    [anon_sym_protected] = ACTIONS(1467),
    [anon_sym_override] = ACTIONS(1467),
    [anon_sym_module] = ACTIONS(1467),
    [anon_sym_any] = ACTIONS(1467),
    [anon_sym_number] = ACTIONS(1467),
    [anon_sym_boolean] = ACTIONS(1467),
    [anon_sym_string] = ACTIONS(1467),
    [anon_sym_symbol] = ACTIONS(1467),
    [anon_sym_abstract] = ACTIONS(1467),
    [anon_sym_satisfies] = ACTIONS(1469),
    [anon_sym_interface] = ACTIONS(1467),
    [anon_sym_enum] = ACTIONS(1467),
    [anon_sym_component] = ACTIONS(1467),
    [sym__automatic_semicolon] = ACTIONS(1475),
    [sym__ternary_qmark] = ACTIONS(1473),
  },
  [179] = {
    [sym_import] = STATE(2261),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym__type_query_member_expression] = STATE(2594),
    [sym__type_query_subscript_expression] = STATE(2623),
    [sym__type_query_call_expression] = STATE(2703),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [180] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1413),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3868),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3868),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1413),
    [sym_subscript_expression] = STATE(1413),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3868),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1413),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1479),
    [anon_sym_export] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(1481),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(1485),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1489),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1491),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1493),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_readonly] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(1481),
    [anon_sym_set] = ACTIONS(1481),
    [anon_sym_declare] = ACTIONS(1481),
    [anon_sym_namespace] = ACTIONS(1481),
    [anon_sym_public] = ACTIONS(1481),
    [anon_sym_private] = ACTIONS(1481),
    [anon_sym_protected] = ACTIONS(1481),
    [anon_sym_override] = ACTIONS(1481),
    [anon_sym_module] = ACTIONS(1481),
    [anon_sym_any] = ACTIONS(1481),
    [anon_sym_number] = ACTIONS(1481),
    [anon_sym_boolean] = ACTIONS(1481),
    [anon_sym_string] = ACTIONS(1481),
    [anon_sym_symbol] = ACTIONS(1481),
    [anon_sym_component] = ACTIONS(117),
  },
  [181] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3477),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(593),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1495),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [182] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1497),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [183] = {
    [sym_import] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym__type_query_member_expression] = STATE(2531),
    [sym__type_query_subscript_expression] = STATE(2532),
    [sym__type_query_call_expression] = STATE(2572),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1501),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [184] = {
    [sym_import] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym__type_query_member_expression] = STATE(2531),
    [sym__type_query_subscript_expression] = STATE(2532),
    [sym__type_query_call_expression] = STATE(2572),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [185] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3398),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(1505),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1507),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [186] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3060),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3060),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3060),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_pattern] = STATE(3534),
    [sym_rest_pattern] = STATE(3064),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(56),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(68),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(117),
  },
  [187] = {
    [sym_import] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym__type_query_member_expression] = STATE(2531),
    [sym__type_query_subscript_expression] = STATE(2532),
    [sym__type_query_call_expression] = STATE(2572),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1509),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [188] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2027),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4155),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
    [sym__automatic_semicolon] = ACTIONS(1511),
  },
  [189] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1468),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1468),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [190] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1451),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1451),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [191] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1440),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1440),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [192] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2200),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4454),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [193] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1435),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1435),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [194] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1431),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1431),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [195] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1451),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1451),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [196] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2193),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4353),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(1517),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [197] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1429),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1429),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [198] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1445),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1445),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [199] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1440),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1440),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [200] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1431),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1431),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [201] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1435),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1435),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [202] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1465),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1465),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [203] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1445),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(660),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1445),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [204] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1468),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1468),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [205] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1465),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1465),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [206] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1429),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(981),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_property_assignment_expression] = STATE(1429),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [207] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2300),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [208] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(907),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(980),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [209] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2086),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [210] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2190),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4313),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [211] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2089),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1959),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [212] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1663),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [213] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2089),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1882),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [214] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(971),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(996),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [215] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1525),
    [anon_sym_export] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_get] = ACTIONS(1527),
    [anon_sym_set] = ACTIONS(1527),
    [anon_sym_declare] = ACTIONS(1527),
    [anon_sym_namespace] = ACTIONS(1527),
    [anon_sym_public] = ACTIONS(1527),
    [anon_sym_private] = ACTIONS(1527),
    [anon_sym_protected] = ACTIONS(1527),
    [anon_sym_override] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_any] = ACTIONS(1527),
    [anon_sym_number] = ACTIONS(1527),
    [anon_sym_boolean] = ACTIONS(1527),
    [anon_sym_string] = ACTIONS(1527),
    [anon_sym_symbol] = ACTIONS(1527),
    [anon_sym_component] = ACTIONS(117),
  },
  [216] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2046),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4152),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [217] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2223),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [218] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(479),
    [sym_expression] = STATE(2352),
    [sym_primary_expression] = STATE(581),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(479),
    [sym_subscript_expression] = STATE(479),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(479),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(1535),
    [anon_sym_set] = ACTIONS(1535),
    [anon_sym_declare] = ACTIONS(1535),
    [anon_sym_namespace] = ACTIONS(1535),
    [anon_sym_public] = ACTIONS(1535),
    [anon_sym_private] = ACTIONS(1535),
    [anon_sym_protected] = ACTIONS(1535),
    [anon_sym_override] = ACTIONS(1535),
    [anon_sym_module] = ACTIONS(1535),
    [anon_sym_any] = ACTIONS(1535),
    [anon_sym_number] = ACTIONS(1535),
    [anon_sym_boolean] = ACTIONS(1535),
    [anon_sym_string] = ACTIONS(1535),
    [anon_sym_symbol] = ACTIONS(1535),
    [anon_sym_component] = ACTIONS(743),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1549),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(1547),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1549),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_await] = ACTIONS(1547),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_yield] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_LTtemplate_GT] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1547),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1549),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1547),
    [sym_super] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_undefined] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(1547),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_export] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1553),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1551),
    [anon_sym_import] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_LPAREN] = ACTIONS(1553),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LTtemplate_GT] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(1551),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(1551),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_void] = ACTIONS(1551),
    [anon_sym_delete] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [sym_number] = ACTIONS(1553),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_readonly] = ACTIONS(1551),
    [anon_sym_get] = ACTIONS(1551),
    [anon_sym_set] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(1551),
    [anon_sym_namespace] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1551),
    [anon_sym_private] = ACTIONS(1551),
    [anon_sym_protected] = ACTIONS(1551),
    [anon_sym_override] = ACTIONS(1551),
    [anon_sym_module] = ACTIONS(1551),
    [anon_sym_any] = ACTIONS(1551),
    [anon_sym_number] = ACTIONS(1551),
    [anon_sym_boolean] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_symbol] = ACTIONS(1551),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(1551),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [221] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1663),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2237),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [222] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2085),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1880),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [223] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2086),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1881),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [224] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2179),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4401),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [225] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(479),
    [sym_expression] = STATE(2352),
    [sym_primary_expression] = STATE(581),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(479),
    [sym_subscript_expression] = STATE(479),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(479),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(1559),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_readonly] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_override] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_component] = ACTIONS(743),
  },
  [226] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2205),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4304),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [227] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1745),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(3676),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [228] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1376),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(1645),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1376),
    [sym_subscript_expression] = STATE(1376),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1376),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_export] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(1563),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_readonly] = ACTIONS(1563),
    [anon_sym_get] = ACTIONS(1563),
    [anon_sym_set] = ACTIONS(1563),
    [anon_sym_declare] = ACTIONS(1563),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_public] = ACTIONS(1563),
    [anon_sym_private] = ACTIONS(1563),
    [anon_sym_protected] = ACTIONS(1563),
    [anon_sym_override] = ACTIONS(1563),
    [anon_sym_module] = ACTIONS(1563),
    [anon_sym_any] = ACTIONS(1563),
    [anon_sym_number] = ACTIONS(1563),
    [anon_sym_boolean] = ACTIONS(1563),
    [anon_sym_string] = ACTIONS(1563),
    [anon_sym_symbol] = ACTIONS(1563),
    [anon_sym_component] = ACTIONS(939),
  },
  [229] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1464),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(994),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [230] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(930),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(628),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [231] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(928),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(623),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [232] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(926),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(629),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [233] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2101),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1954),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [234] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2305),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [235] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(1575),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1577),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_get] = ACTIONS(1575),
    [anon_sym_set] = ACTIONS(1575),
    [anon_sym_declare] = ACTIONS(1575),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_private] = ACTIONS(1575),
    [anon_sym_protected] = ACTIONS(1575),
    [anon_sym_override] = ACTIONS(1575),
    [anon_sym_module] = ACTIONS(1575),
    [anon_sym_any] = ACTIONS(1575),
    [anon_sym_number] = ACTIONS(1575),
    [anon_sym_boolean] = ACTIONS(1575),
    [anon_sym_string] = ACTIONS(1575),
    [anon_sym_symbol] = ACTIONS(1575),
    [anon_sym_component] = ACTIONS(117),
  },
  [236] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2047),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_sequence_expression] = STATE(4097),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [237] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1931),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4502),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [238] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3379),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4193),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [239] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [240] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(926),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(993),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [241] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1995),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [242] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3516),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4192),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [243] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(928),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(988),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [244] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1696),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2291),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [245] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(930),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(999),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [246] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2184),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4397),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [247] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2282),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [248] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2085),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1963),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [249] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(1464),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(621),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [250] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(970),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(642),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [251] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1376),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(1645),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1376),
    [sym_subscript_expression] = STATE(1376),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1376),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(1581),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_DOT] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_readonly] = ACTIONS(1581),
    [anon_sym_get] = ACTIONS(1581),
    [anon_sym_set] = ACTIONS(1581),
    [anon_sym_declare] = ACTIONS(1581),
    [anon_sym_namespace] = ACTIONS(1581),
    [anon_sym_public] = ACTIONS(1581),
    [anon_sym_private] = ACTIONS(1581),
    [anon_sym_protected] = ACTIONS(1581),
    [anon_sym_override] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_any] = ACTIONS(1581),
    [anon_sym_number] = ACTIONS(1581),
    [anon_sym_boolean] = ACTIONS(1581),
    [anon_sym_string] = ACTIONS(1581),
    [anon_sym_symbol] = ACTIONS(1581),
    [anon_sym_component] = ACTIONS(939),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1549),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(1547),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1549),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1547),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_LTtemplate_GT] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1547),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1549),
    [anon_sym_DASH_DASH] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1549),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1547),
    [sym_super] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_undefined] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(1547),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [253] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1920),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [254] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [255] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2183),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4398),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [256] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2162),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4659),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [257] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2122),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1804),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [258] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2204),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4556),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [259] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_export] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(1553),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1551),
    [anon_sym_import] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_LPAREN] = ACTIONS(1553),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LTtemplate_GT] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(1551),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(1551),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_void] = ACTIONS(1551),
    [anon_sym_delete] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [sym_number] = ACTIONS(1553),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_readonly] = ACTIONS(1551),
    [anon_sym_get] = ACTIONS(1551),
    [anon_sym_set] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(1551),
    [anon_sym_namespace] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1551),
    [anon_sym_private] = ACTIONS(1551),
    [anon_sym_protected] = ACTIONS(1551),
    [anon_sym_override] = ACTIONS(1551),
    [anon_sym_module] = ACTIONS(1551),
    [anon_sym_any] = ACTIONS(1551),
    [anon_sym_number] = ACTIONS(1551),
    [anon_sym_boolean] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_symbol] = ACTIONS(1551),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(1551),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [260] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2192),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4340),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [261] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3516),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4192),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1525),
    [anon_sym_export] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_get] = ACTIONS(1527),
    [anon_sym_set] = ACTIONS(1527),
    [anon_sym_declare] = ACTIONS(1527),
    [anon_sym_namespace] = ACTIONS(1527),
    [anon_sym_public] = ACTIONS(1527),
    [anon_sym_private] = ACTIONS(1527),
    [anon_sym_protected] = ACTIONS(1527),
    [anon_sym_override] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_any] = ACTIONS(1527),
    [anon_sym_number] = ACTIONS(1527),
    [anon_sym_boolean] = ACTIONS(1527),
    [anon_sym_string] = ACTIONS(1527),
    [anon_sym_symbol] = ACTIONS(1527),
    [anon_sym_component] = ACTIONS(117),
  },
  [262] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2207),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4648),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [263] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2170),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4373),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [264] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(971),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(599),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [265] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_mapped_type_clause] = STATE(4360),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1587),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1589),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1587),
    [anon_sym_readonly] = ACTIONS(1587),
    [anon_sym_get] = ACTIONS(1587),
    [anon_sym_set] = ACTIONS(1587),
    [anon_sym_declare] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1587),
    [anon_sym_public] = ACTIONS(1587),
    [anon_sym_private] = ACTIONS(1587),
    [anon_sym_protected] = ACTIONS(1587),
    [anon_sym_override] = ACTIONS(1587),
    [anon_sym_module] = ACTIONS(1587),
    [anon_sym_any] = ACTIONS(1587),
    [anon_sym_number] = ACTIONS(1587),
    [anon_sym_boolean] = ACTIONS(1587),
    [anon_sym_string] = ACTIONS(1587),
    [anon_sym_symbol] = ACTIONS(1587),
    [anon_sym_component] = ACTIONS(117),
  },
  [266] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1663),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1777),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [267] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2181),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4315),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [268] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2101),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1886),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [269] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_mapped_type_clause] = STATE(4321),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_export] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1595),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_readonly] = ACTIONS(1593),
    [anon_sym_get] = ACTIONS(1593),
    [anon_sym_set] = ACTIONS(1593),
    [anon_sym_declare] = ACTIONS(1593),
    [anon_sym_namespace] = ACTIONS(1593),
    [anon_sym_public] = ACTIONS(1593),
    [anon_sym_private] = ACTIONS(1593),
    [anon_sym_protected] = ACTIONS(1593),
    [anon_sym_override] = ACTIONS(1593),
    [anon_sym_module] = ACTIONS(1593),
    [anon_sym_any] = ACTIONS(1593),
    [anon_sym_number] = ACTIONS(1593),
    [anon_sym_boolean] = ACTIONS(1593),
    [anon_sym_string] = ACTIONS(1593),
    [anon_sym_symbol] = ACTIONS(1593),
    [anon_sym_component] = ACTIONS(117),
  },
  [270] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1740),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [271] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1696),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1743),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [272] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1741),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [273] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2191),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4298),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [274] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2024),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [275] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2196),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4358),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [276] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(970),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(998),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [277] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1696),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [278] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2182),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4400),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [279] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1833),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4371),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [280] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1761),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [281] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1900),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [282] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2169),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4369),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [283] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [284] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2198),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_sequence_expression] = STATE(4354),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [285] = {
    [sym_import] = STATE(2149),
    [sym_statement_block] = STATE(2122),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [286] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2022),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [287] = {
    [sym_import] = STATE(900),
    [sym_statement_block] = STATE(907),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(633),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [288] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1497),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [289] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1783),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [290] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [291] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2159),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [292] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1776),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [293] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(634),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [294] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(626),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [295] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1755),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [296] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1774),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [297] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [298] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1772),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [299] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1771),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [300] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1770),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [301] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1769),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [302] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1768),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [303] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1764),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [304] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1763),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [305] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1762),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [306] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1756),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [307] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1904),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [308] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1971),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [309] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(658),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [310] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1760),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [311] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2262),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [312] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1756),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [313] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1809),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [314] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(645),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [315] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [316] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2266),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [317] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [318] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(622),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [319] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(607),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [320] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [321] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1751),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [322] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1901),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [323] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [324] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(616),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [325] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(985),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [326] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(615),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [327] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(611),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [328] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(609),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [329] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1918),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [330] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1919),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [331] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2273),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [332] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1921),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [333] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1755),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [334] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1925),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [335] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(608),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [336] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(1597),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [337] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(605),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [338] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1926),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [339] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [340] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [341] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1940),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [342] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [343] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(1599),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [344] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1779),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [345] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2026),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [346] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [347] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1946),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [348] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1947),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [349] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1735),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [350] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1984),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [351] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1899),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [352] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1898),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [353] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1948),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [354] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1897),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [355] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [356] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1950),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [357] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [358] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1953),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [359] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(604),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [360] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [361] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [362] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(1601),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [363] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1781),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [364] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1896),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [365] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1982),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [366] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1958),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [367] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [368] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1933),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [369] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(603),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [370] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [371] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1883),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [372] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [373] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1990),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [374] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1893),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [375] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1993),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [376] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [377] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(649),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [378] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1891),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [379] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1751),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [380] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3042),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3042),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3042),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_export] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(1605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1607),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_readonly] = ACTIONS(1605),
    [anon_sym_get] = ACTIONS(1605),
    [anon_sym_set] = ACTIONS(1605),
    [anon_sym_declare] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1605),
    [anon_sym_public] = ACTIONS(1605),
    [anon_sym_private] = ACTIONS(1605),
    [anon_sym_protected] = ACTIONS(1605),
    [anon_sym_override] = ACTIONS(1605),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1605),
    [anon_sym_number] = ACTIONS(1605),
    [anon_sym_boolean] = ACTIONS(1605),
    [anon_sym_string] = ACTIONS(1605),
    [anon_sym_symbol] = ACTIONS(1605),
    [anon_sym_component] = ACTIONS(117),
  },
  [381] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1890),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [382] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [383] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [384] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1998),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [385] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1999),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [386] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(632),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [387] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2157),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [388] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(602),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [389] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(594),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [390] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [391] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2001),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [392] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2002),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [393] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2222),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [394] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(1002),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [395] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2006),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [396] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(986),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [397] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2232),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [398] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1844),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3042),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3042),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3042),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1385),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(837),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(843),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(837),
    [anon_sym_readonly] = ACTIONS(837),
    [anon_sym_get] = ACTIONS(837),
    [anon_sym_set] = ACTIONS(837),
    [anon_sym_declare] = ACTIONS(837),
    [anon_sym_namespace] = ACTIONS(837),
    [anon_sym_public] = ACTIONS(837),
    [anon_sym_private] = ACTIONS(837),
    [anon_sym_protected] = ACTIONS(837),
    [anon_sym_override] = ACTIONS(837),
    [anon_sym_module] = ACTIONS(837),
    [anon_sym_any] = ACTIONS(837),
    [anon_sym_number] = ACTIONS(837),
    [anon_sym_boolean] = ACTIONS(837),
    [anon_sym_string] = ACTIONS(837),
    [anon_sym_symbol] = ACTIONS(837),
    [anon_sym_component] = ACTIONS(117),
  },
  [399] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [400] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(978),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [401] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2012),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [402] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(987),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [403] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(984),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [404] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(982),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [405] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(997),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [406] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1784),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [407] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(1001),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [408] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(601),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [409] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1885),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [410] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(3042),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(3042),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(3042),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_export] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1605),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(1607),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_readonly] = ACTIONS(1605),
    [anon_sym_get] = ACTIONS(1605),
    [anon_sym_set] = ACTIONS(1605),
    [anon_sym_declare] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1605),
    [anon_sym_public] = ACTIONS(1605),
    [anon_sym_private] = ACTIONS(1605),
    [anon_sym_protected] = ACTIONS(1605),
    [anon_sym_override] = ACTIONS(1605),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1605),
    [anon_sym_number] = ACTIONS(1605),
    [anon_sym_boolean] = ACTIONS(1605),
    [anon_sym_string] = ACTIONS(1605),
    [anon_sym_symbol] = ACTIONS(1605),
    [anon_sym_component] = ACTIONS(117),
  },
  [411] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(992),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [412] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2281),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [413] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(989),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [414] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(983),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [415] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(991),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [416] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(596),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [417] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [418] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(2025),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [419] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(643),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [420] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [421] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [422] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(1000),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [423] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(1877),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [424] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [425] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2152),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [426] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(1003),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [427] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1844),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [428] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(1517),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [429] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [430] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [431] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4363),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4363),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4362),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2591),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4363),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(306),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(136),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(146),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(182),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_DASH] = ACTIONS(136),
    [anon_sym_TILDE] = ACTIONS(146),
    [anon_sym_void] = ACTIONS(136),
    [anon_sym_delete] = ACTIONS(136),
    [anon_sym_PLUS_PLUS] = ACTIONS(194),
    [anon_sym_DASH_DASH] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(925),
    [anon_sym_number] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(925),
    [anon_sym_symbol] = ACTIONS(925),
    [anon_sym_component] = ACTIONS(939),
  },
  [432] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2212),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [433] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(594),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [434] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(1615),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [435] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [436] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [437] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2308),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [438] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [439] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(1517),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [440] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2286),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [441] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2284),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [442] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(990),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [443] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [444] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2280),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [445] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2268),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [446] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2265),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [447] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1517),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [448] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4453),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4453),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4451),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4453),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1395),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(447),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(893),
    [anon_sym_delete] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(869),
    [anon_sym_readonly] = ACTIONS(869),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_declare] = ACTIONS(869),
    [anon_sym_namespace] = ACTIONS(869),
    [anon_sym_public] = ACTIONS(869),
    [anon_sym_private] = ACTIONS(869),
    [anon_sym_protected] = ACTIONS(869),
    [anon_sym_override] = ACTIONS(869),
    [anon_sym_module] = ACTIONS(869),
    [anon_sym_any] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_boolean] = ACTIONS(869),
    [anon_sym_string] = ACTIONS(869),
    [anon_sym_symbol] = ACTIONS(869),
    [anon_sym_component] = ACTIONS(117),
  },
  [449] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2314),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [450] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2210),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [451] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2144),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [452] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2258),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [453] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2226),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [454] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(508),
    [sym_expression] = STATE(979),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4394),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4394),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4395),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(508),
    [sym_subscript_expression] = STATE(508),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4394),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(508),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(389),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_export] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_typeof] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_delete] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_get] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(747),
    [anon_sym_declare] = ACTIONS(747),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_module] = ACTIONS(747),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_component] = ACTIONS(743),
  },
  [455] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2254),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [456] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2236),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [457] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2252),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [458] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(632),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [459] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [460] = {
    [sym_import] = STATE(2149),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1956),
    [sym_yield_expression] = STATE(2146),
    [sym_object] = STATE(2149),
    [sym_object_pattern] = STATE(4577),
    [sym_array] = STATE(2149),
    [sym_array_pattern] = STATE(4577),
    [sym_glimmer_template] = STATE(2146),
    [sym_glimmer_opening_tag] = STATE(3572),
    [sym_nested_identifier] = STATE(2964),
    [sym_class] = STATE(2149),
    [sym_function] = STATE(2149),
    [sym_generator_function] = STATE(2149),
    [sym_arrow_function] = STATE(2149),
    [sym__call_signature] = STATE(4575),
    [sym_call_expression] = STATE(2149),
    [sym_new_expression] = STATE(2146),
    [sym_await_expression] = STATE(2146),
    [sym_member_expression] = STATE(1387),
    [sym_subscript_expression] = STATE(1387),
    [sym_assignment_expression] = STATE(2146),
    [sym__augmented_assignment_lhs] = STATE(2613),
    [sym_augmented_assignment_expression] = STATE(2146),
    [sym__destructuring_pattern] = STATE(4577),
    [sym_ternary_expression] = STATE(2146),
    [sym_binary_expression] = STATE(2146),
    [sym_unary_expression] = STATE(2146),
    [sym_update_expression] = STATE(2146),
    [sym_string] = STATE(2149),
    [sym_template_string] = STATE(2149),
    [sym_regex] = STATE(2149),
    [sym_meta_property] = STATE(2149),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1387),
    [sym_type_assertion] = STATE(2146),
    [sym_as_expression] = STATE(2146),
    [sym_satisfies_expression] = STATE(2146),
    [sym_type_arguments] = STATE(312),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(2149),
    [sym_new_component_expression] = STATE(2146),
    [sym_new_tagged_component_expression] = STATE(2146),
    [sym_new_tripple_tagged_component_expression] = STATE(2146),
    [aux_sym_class_repeat1] = STATE(3480),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_await] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_delete] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [sym_number] = ACTIONS(466),
    [sym_this] = ACTIONS(206),
    [sym_super] = ACTIONS(206),
    [sym_true] = ACTIONS(206),
    [sym_false] = ACTIONS(206),
    [sym_null] = ACTIONS(206),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_readonly] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_override] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_component] = ACTIONS(939),
  },
  [461] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2241),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [462] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_expression] = STATE(2158),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4588),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4588),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4589),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1338),
    [sym_subscript_expression] = STATE(1338),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4588),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(439),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_typeof] = ACTIONS(80),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(38),
    [anon_sym_yield] = ACTIONS(40),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(80),
    [anon_sym_DASH] = ACTIONS(80),
    [anon_sym_TILDE] = ACTIONS(76),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(80),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_get] = ACTIONS(819),
    [anon_sym_set] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(819),
    [anon_sym_any] = ACTIONS(819),
    [anon_sym_number] = ACTIONS(819),
    [anon_sym_boolean] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_symbol] = ACTIONS(819),
    [anon_sym_component] = ACTIONS(117),
  },
  [463] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2248),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [464] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(1414),
    [sym_expression] = STATE(2242),
    [sym_primary_expression] = STATE(1565),
    [sym_yield_expression] = STATE(1721),
    [sym_object] = STATE(1724),
    [sym_object_pattern] = STATE(4593),
    [sym_array] = STATE(1724),
    [sym_array_pattern] = STATE(4593),
    [sym_glimmer_template] = STATE(1721),
    [sym_glimmer_opening_tag] = STATE(3638),
    [sym_nested_identifier] = STATE(2920),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(4591),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1721),
    [sym_await_expression] = STATE(1721),
    [sym_member_expression] = STATE(1414),
    [sym_subscript_expression] = STATE(1414),
    [sym_assignment_expression] = STATE(1721),
    [sym__augmented_assignment_lhs] = STATE(2622),
    [sym_augmented_assignment_expression] = STATE(1721),
    [sym__destructuring_pattern] = STATE(4593),
    [sym_ternary_expression] = STATE(1721),
    [sym_binary_expression] = STATE(1721),
    [sym_unary_expression] = STATE(1721),
    [sym_update_expression] = STATE(1721),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1721),
    [sym_as_expression] = STATE(1721),
    [sym_satisfies_expression] = STATE(1721),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(1724),
    [sym_new_component_expression] = STATE(1721),
    [sym_new_tagged_component_expression] = STATE(1721),
    [sym_new_tripple_tagged_component_expression] = STATE(1721),
    [aux_sym_class_repeat1] = STATE(3402),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(979),
    [anon_sym_import] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(54),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(58),
    [anon_sym_new] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_delete] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(95),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_override] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_component] = ACTIONS(117),
  },
  [465] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(649),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [466] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(641),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [467] = {
    [sym_import] = STATE(900),
    [sym_parenthesized_expression] = STATE(481),
    [sym_expression] = STATE(658),
    [sym_primary_expression] = STATE(856),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(900),
    [sym_object_pattern] = STATE(4513),
    [sym_array] = STATE(900),
    [sym_array_pattern] = STATE(4513),
    [sym_glimmer_template] = STATE(958),
    [sym_glimmer_opening_tag] = STATE(3694),
    [sym_nested_identifier] = STATE(2954),
    [sym_class] = STATE(900),
    [sym_function] = STATE(900),
    [sym_generator_function] = STATE(900),
    [sym_arrow_function] = STATE(900),
    [sym__call_signature] = STATE(4416),
    [sym_call_expression] = STATE(900),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(481),
    [sym_subscript_expression] = STATE(481),
    [sym_assignment_expression] = STATE(958),
    [sym__augmented_assignment_lhs] = STATE(2616),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym__destructuring_pattern] = STATE(4513),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(900),
    [sym_template_string] = STATE(900),
    [sym_regex] = STATE(900),
    [sym_meta_property] = STATE(900),
    [sym_decorator] = STATE(1390),
    [sym_formal_parameters] = STATE(3400),
    [sym_non_null_expression] = STATE(481),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_satisfies_expression] = STATE(958),
    [sym_type_arguments] = STATE(433),
    [sym_type_parameters] = STATE(4000),
    [sym_component] = STATE(900),
    [sym_new_component_expression] = STATE(958),
    [sym_new_tagged_component_expression] = STATE(958),
    [sym_new_tripple_tagged_component_expression] = STATE(958),
    [aux_sym_class_repeat1] = STATE(3393),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_export] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_typeof] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_await] = ACTIONS(711),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LTtemplate_GT] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_delete] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(739),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_component] = ACTIONS(743),
  },
  [468] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1628),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [469] = {
    [sym_component_identifier] = STATE(3315),
    [sym_new_component_body] = STATE(861),
    [sym_tagged_type_string] = STATE(937),
    [sym_tripple_tagged_type_string] = STATE(896),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1628),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1643),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1646),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [470] = {
    [sym_component_identifier] = STATE(3315),
    [sym_new_component_body] = STATE(861),
    [sym_tagged_type_string] = STATE(937),
    [sym_tripple_tagged_type_string] = STATE(896),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1650),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1643),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1646),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [471] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1650),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [472] = {
    [sym_declaration] = STATE(667),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_class_declaration] = STATE(775),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function_declaration] = STATE(775),
    [sym_decorator] = STATE(1390),
    [sym_function_signature] = STATE(775),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_component_declaration] = STATE(775),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [aux_sym_class_repeat1] = STATE(3201),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1658),
    [anon_sym_let] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(62),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1685),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_satisfies] = ACTIONS(62),
    [anon_sym_global] = ACTIONS(1693),
    [anon_sym_interface] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_component] = ACTIONS(13),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [473] = {
    [sym_declaration] = STATE(667),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_class_declaration] = STATE(775),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function_declaration] = STATE(775),
    [sym_decorator] = STATE(1390),
    [sym_function_signature] = STATE(775),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_component_declaration] = STATE(775),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [aux_sym_class_repeat1] = STATE(3201),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1658),
    [anon_sym_let] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(62),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1685),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_satisfies] = ACTIONS(62),
    [anon_sym_global] = ACTIONS(1693),
    [anon_sym_interface] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_component] = ACTIONS(13),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [474] = {
    [sym_declaration] = STATE(667),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_class_declaration] = STATE(775),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function_declaration] = STATE(775),
    [sym_decorator] = STATE(1390),
    [sym_function_signature] = STATE(775),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_component_declaration] = STATE(775),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [aux_sym_class_repeat1] = STATE(3201),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1658),
    [anon_sym_let] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(62),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1685),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_satisfies] = ACTIONS(62),
    [anon_sym_global] = ACTIONS(1693),
    [anon_sym_interface] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_component] = ACTIONS(13),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [475] = {
    [sym_identifier] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_constructor] = ACTIONS(23),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [476] = {
    [sym_identifier] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_constructor] = ACTIONS(23),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [477] = {
    [sym__call_signature] = STATE(4379),
    [sym_string] = STATE(3265),
    [sym_formal_parameters] = STATE(3400),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_type_parameters] = STATE(4000),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_function] = ACTIONS(1721),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1705),
    [anon_sym_private] = ACTIONS(1705),
    [anon_sym_protected] = ACTIONS(1705),
    [anon_sym_override] = ACTIONS(1705),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1705),
    [anon_sym_number] = ACTIONS(1705),
    [anon_sym_boolean] = ACTIONS(1705),
    [anon_sym_string] = ACTIONS(1705),
    [anon_sym_symbol] = ACTIONS(1705),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [478] = {
    [sym_identifier] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_in] = ACTIONS(1727),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_QMARK_DOT] = ACTIONS(1729),
    [anon_sym_new] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1729),
    [anon_sym_DASH_EQ] = ACTIONS(1729),
    [anon_sym_STAR_EQ] = ACTIONS(1729),
    [anon_sym_SLASH_EQ] = ACTIONS(1729),
    [anon_sym_PERCENT_EQ] = ACTIONS(1729),
    [anon_sym_CARET_EQ] = ACTIONS(1729),
    [anon_sym_AMP_EQ] = ACTIONS(1729),
    [anon_sym_PIPE_EQ] = ACTIONS(1729),
    [anon_sym_GT_GT_EQ] = ACTIONS(1729),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1729),
    [anon_sym_LT_LT_EQ] = ACTIONS(1729),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1729),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_GT_GT] = ACTIONS(1727),
    [anon_sym_GT_GT_GT] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_DASH] = ACTIONS(1727),
    [anon_sym_PERCENT] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_QMARK_QMARK] = ACTIONS(1727),
    [anon_sym_instanceof] = ACTIONS(1727),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [sym_number] = ACTIONS(1729),
    [sym_this] = ACTIONS(1727),
    [sym_true] = ACTIONS(1727),
    [sym_false] = ACTIONS(1727),
    [sym_null] = ACTIONS(1727),
    [sym_undefined] = ACTIONS(1727),
    [anon_sym_static] = ACTIONS(1727),
    [anon_sym_readonly] = ACTIONS(1727),
    [anon_sym_get] = ACTIONS(1727),
    [anon_sym_set] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_any] = ACTIONS(1727),
    [anon_sym_number] = ACTIONS(1727),
    [anon_sym_boolean] = ACTIONS(1727),
    [anon_sym_string] = ACTIONS(1727),
    [anon_sym_symbol] = ACTIONS(1727),
    [anon_sym_abstract] = ACTIONS(1727),
    [anon_sym_satisfies] = ACTIONS(1727),
    [anon_sym_infer] = ACTIONS(1727),
    [anon_sym_keyof] = ACTIONS(1727),
    [anon_sym_unknown] = ACTIONS(1727),
    [anon_sym_never] = ACTIONS(1727),
    [anon_sym_object] = ACTIONS(1727),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1729),
    [anon_sym_constructor] = ACTIONS(1727),
    [anon_sym_prop] = ACTIONS(1727),
    [anon_sym_id] = ACTIONS(1727),
    [anon_sym_event] = ACTIONS(1727),
    [anon_sym_fn] = ACTIONS(1727),
    [anon_sym_on] = ACTIONS(1727),
    [sym__ternary_qmark] = ACTIONS(1729),
  },
  [479] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [480] = {
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_as] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1733),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [anon_sym_DOT] = ACTIONS(1731),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_QMARK_DOT] = ACTIONS(1733),
    [anon_sym_new] = ACTIONS(1731),
    [anon_sym_PLUS_EQ] = ACTIONS(1733),
    [anon_sym_DASH_EQ] = ACTIONS(1733),
    [anon_sym_STAR_EQ] = ACTIONS(1733),
    [anon_sym_SLASH_EQ] = ACTIONS(1733),
    [anon_sym_PERCENT_EQ] = ACTIONS(1733),
    [anon_sym_CARET_EQ] = ACTIONS(1733),
    [anon_sym_AMP_EQ] = ACTIONS(1733),
    [anon_sym_PIPE_EQ] = ACTIONS(1733),
    [anon_sym_GT_GT_EQ] = ACTIONS(1733),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1733),
    [anon_sym_LT_LT_EQ] = ACTIONS(1733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1733),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_GT_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_CARET] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_PERCENT] = ACTIONS(1731),
    [anon_sym_STAR_STAR] = ACTIONS(1731),
    [anon_sym_LT_EQ] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1733),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1733),
    [anon_sym_QMARK_QMARK] = ACTIONS(1731),
    [anon_sym_instanceof] = ACTIONS(1731),
    [anon_sym_void] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [anon_sym_SQUOTE] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [sym_number] = ACTIONS(1733),
    [sym_this] = ACTIONS(1731),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_undefined] = ACTIONS(1731),
    [anon_sym_static] = ACTIONS(1731),
    [anon_sym_readonly] = ACTIONS(1731),
    [anon_sym_get] = ACTIONS(1731),
    [anon_sym_set] = ACTIONS(1731),
    [anon_sym_QMARK] = ACTIONS(1731),
    [anon_sym_any] = ACTIONS(1731),
    [anon_sym_number] = ACTIONS(1731),
    [anon_sym_boolean] = ACTIONS(1731),
    [anon_sym_string] = ACTIONS(1731),
    [anon_sym_symbol] = ACTIONS(1731),
    [anon_sym_abstract] = ACTIONS(1731),
    [anon_sym_satisfies] = ACTIONS(1731),
    [anon_sym_infer] = ACTIONS(1731),
    [anon_sym_keyof] = ACTIONS(1731),
    [anon_sym_unknown] = ACTIONS(1731),
    [anon_sym_never] = ACTIONS(1731),
    [anon_sym_object] = ACTIONS(1731),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1733),
    [anon_sym_constructor] = ACTIONS(1731),
    [anon_sym_prop] = ACTIONS(1731),
    [anon_sym_id] = ACTIONS(1731),
    [anon_sym_event] = ACTIONS(1731),
    [anon_sym_fn] = ACTIONS(1731),
    [anon_sym_on] = ACTIONS(1731),
    [sym__ternary_qmark] = ACTIONS(1733),
  },
  [481] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [482] = {
    [sym_identifier] = ACTIONS(1735),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_as] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_typeof] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [anon_sym_in] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_DOT] = ACTIONS(1735),
    [anon_sym_async] = ACTIONS(1735),
    [anon_sym_QMARK_DOT] = ACTIONS(1737),
    [anon_sym_new] = ACTIONS(1735),
    [anon_sym_PLUS_EQ] = ACTIONS(1737),
    [anon_sym_DASH_EQ] = ACTIONS(1737),
    [anon_sym_STAR_EQ] = ACTIONS(1737),
    [anon_sym_SLASH_EQ] = ACTIONS(1737),
    [anon_sym_PERCENT_EQ] = ACTIONS(1737),
    [anon_sym_CARET_EQ] = ACTIONS(1737),
    [anon_sym_AMP_EQ] = ACTIONS(1737),
    [anon_sym_PIPE_EQ] = ACTIONS(1737),
    [anon_sym_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_LT_LT_EQ] = ACTIONS(1737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1737),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1737),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1737),
    [anon_sym_AMP_AMP] = ACTIONS(1735),
    [anon_sym_PIPE_PIPE] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(1735),
    [anon_sym_GT_GT_GT] = ACTIONS(1735),
    [anon_sym_LT_LT] = ACTIONS(1735),
    [anon_sym_AMP] = ACTIONS(1735),
    [anon_sym_CARET] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_STAR_STAR] = ACTIONS(1735),
    [anon_sym_LT_EQ] = ACTIONS(1737),
    [anon_sym_EQ_EQ] = ACTIONS(1735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1737),
    [anon_sym_BANG_EQ] = ACTIONS(1735),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1737),
    [anon_sym_GT_EQ] = ACTIONS(1737),
    [anon_sym_QMARK_QMARK] = ACTIONS(1735),
    [anon_sym_instanceof] = ACTIONS(1735),
    [anon_sym_void] = ACTIONS(1735),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_SQUOTE] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [sym_number] = ACTIONS(1737),
    [sym_this] = ACTIONS(1735),
    [sym_true] = ACTIONS(1735),
    [sym_false] = ACTIONS(1735),
    [sym_null] = ACTIONS(1735),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1735),
    [anon_sym_readonly] = ACTIONS(1735),
    [anon_sym_get] = ACTIONS(1735),
    [anon_sym_set] = ACTIONS(1735),
    [anon_sym_QMARK] = ACTIONS(1735),
    [anon_sym_any] = ACTIONS(1735),
    [anon_sym_number] = ACTIONS(1735),
    [anon_sym_boolean] = ACTIONS(1735),
    [anon_sym_string] = ACTIONS(1735),
    [anon_sym_symbol] = ACTIONS(1735),
    [anon_sym_abstract] = ACTIONS(1735),
    [anon_sym_satisfies] = ACTIONS(1735),
    [anon_sym_infer] = ACTIONS(1735),
    [anon_sym_keyof] = ACTIONS(1735),
    [anon_sym_unknown] = ACTIONS(1735),
    [anon_sym_never] = ACTIONS(1735),
    [anon_sym_object] = ACTIONS(1735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1737),
    [anon_sym_constructor] = ACTIONS(1735),
    [anon_sym_prop] = ACTIONS(1735),
    [anon_sym_id] = ACTIONS(1735),
    [anon_sym_event] = ACTIONS(1735),
    [anon_sym_fn] = ACTIONS(1735),
    [anon_sym_on] = ACTIONS(1735),
    [sym__ternary_qmark] = ACTIONS(1737),
  },
  [483] = {
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1739),
    [anon_sym_as] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_typeof] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_EQ] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_SLASH] = ACTIONS(1739),
    [anon_sym_DOT] = ACTIONS(1739),
    [anon_sym_async] = ACTIONS(1739),
    [anon_sym_QMARK_DOT] = ACTIONS(1741),
    [anon_sym_new] = ACTIONS(1739),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1741),
    [anon_sym_AMP_AMP] = ACTIONS(1739),
    [anon_sym_PIPE_PIPE] = ACTIONS(1739),
    [anon_sym_GT_GT] = ACTIONS(1739),
    [anon_sym_GT_GT_GT] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(1739),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_CARET] = ACTIONS(1739),
    [anon_sym_PIPE] = ACTIONS(1739),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_PERCENT] = ACTIONS(1739),
    [anon_sym_STAR_STAR] = ACTIONS(1739),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG_EQ] = ACTIONS(1739),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_QMARK_QMARK] = ACTIONS(1739),
    [anon_sym_instanceof] = ACTIONS(1739),
    [anon_sym_void] = ACTIONS(1739),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_DQUOTE] = ACTIONS(1741),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [sym_number] = ACTIONS(1741),
    [sym_this] = ACTIONS(1739),
    [sym_true] = ACTIONS(1739),
    [sym_false] = ACTIONS(1739),
    [sym_null] = ACTIONS(1739),
    [sym_undefined] = ACTIONS(1739),
    [anon_sym_static] = ACTIONS(1739),
    [anon_sym_readonly] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_QMARK] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [anon_sym_abstract] = ACTIONS(1739),
    [anon_sym_satisfies] = ACTIONS(1739),
    [anon_sym_infer] = ACTIONS(1739),
    [anon_sym_keyof] = ACTIONS(1739),
    [anon_sym_unknown] = ACTIONS(1739),
    [anon_sym_never] = ACTIONS(1739),
    [anon_sym_object] = ACTIONS(1739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1741),
    [anon_sym_constructor] = ACTIONS(1739),
    [anon_sym_prop] = ACTIONS(1739),
    [anon_sym_id] = ACTIONS(1739),
    [anon_sym_event] = ACTIONS(1739),
    [anon_sym_fn] = ACTIONS(1739),
    [anon_sym_on] = ACTIONS(1739),
    [sym__ternary_qmark] = ACTIONS(1741),
  },
  [484] = {
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_as] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_RBRACE] = ACTIONS(1745),
    [anon_sym_typeof] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LPAREN] = ACTIONS(1745),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1745),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [anon_sym_DOT] = ACTIONS(1743),
    [anon_sym_async] = ACTIONS(1743),
    [anon_sym_QMARK_DOT] = ACTIONS(1745),
    [anon_sym_new] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1745),
    [anon_sym_DASH_EQ] = ACTIONS(1745),
    [anon_sym_STAR_EQ] = ACTIONS(1745),
    [anon_sym_SLASH_EQ] = ACTIONS(1745),
    [anon_sym_PERCENT_EQ] = ACTIONS(1745),
    [anon_sym_CARET_EQ] = ACTIONS(1745),
    [anon_sym_AMP_EQ] = ACTIONS(1745),
    [anon_sym_PIPE_EQ] = ACTIONS(1745),
    [anon_sym_GT_GT_EQ] = ACTIONS(1745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1745),
    [anon_sym_LT_LT_EQ] = ACTIONS(1745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1745),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1745),
    [anon_sym_AMP_AMP] = ACTIONS(1743),
    [anon_sym_PIPE_PIPE] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PIPE] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1745),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1745),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1745),
    [anon_sym_GT_EQ] = ACTIONS(1745),
    [anon_sym_QMARK_QMARK] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1743),
    [anon_sym_void] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1745),
    [anon_sym_DASH_DASH] = ACTIONS(1745),
    [anon_sym_DQUOTE] = ACTIONS(1745),
    [anon_sym_SQUOTE] = ACTIONS(1745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1745),
    [sym_number] = ACTIONS(1745),
    [sym_this] = ACTIONS(1743),
    [sym_true] = ACTIONS(1743),
    [sym_false] = ACTIONS(1743),
    [sym_null] = ACTIONS(1743),
    [sym_undefined] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1743),
    [anon_sym_readonly] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(1743),
    [anon_sym_set] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1743),
    [anon_sym_any] = ACTIONS(1743),
    [anon_sym_number] = ACTIONS(1743),
    [anon_sym_boolean] = ACTIONS(1743),
    [anon_sym_string] = ACTIONS(1743),
    [anon_sym_symbol] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1743),
    [anon_sym_satisfies] = ACTIONS(1743),
    [anon_sym_infer] = ACTIONS(1743),
    [anon_sym_keyof] = ACTIONS(1743),
    [anon_sym_unknown] = ACTIONS(1743),
    [anon_sym_never] = ACTIONS(1743),
    [anon_sym_object] = ACTIONS(1743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1745),
    [anon_sym_constructor] = ACTIONS(1743),
    [anon_sym_prop] = ACTIONS(1743),
    [anon_sym_id] = ACTIONS(1743),
    [anon_sym_event] = ACTIONS(1743),
    [anon_sym_fn] = ACTIONS(1743),
    [anon_sym_on] = ACTIONS(1743),
    [sym__ternary_qmark] = ACTIONS(1745),
  },
  [485] = {
    [sym__call_signature] = STATE(4379),
    [sym_string] = STATE(3265),
    [sym_formal_parameters] = STATE(3400),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_type_parameters] = STATE(4000),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_function] = ACTIONS(1721),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1705),
    [anon_sym_private] = ACTIONS(1705),
    [anon_sym_protected] = ACTIONS(1705),
    [anon_sym_override] = ACTIONS(1705),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1705),
    [anon_sym_number] = ACTIONS(1705),
    [anon_sym_boolean] = ACTIONS(1705),
    [anon_sym_string] = ACTIONS(1705),
    [anon_sym_symbol] = ACTIONS(1705),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [486] = {
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1749),
    [anon_sym_typeof] = ACTIONS(1747),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_EQ] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_DOT] = ACTIONS(1747),
    [anon_sym_async] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(1749),
    [anon_sym_new] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1749),
    [anon_sym_DASH_EQ] = ACTIONS(1749),
    [anon_sym_STAR_EQ] = ACTIONS(1749),
    [anon_sym_SLASH_EQ] = ACTIONS(1749),
    [anon_sym_PERCENT_EQ] = ACTIONS(1749),
    [anon_sym_CARET_EQ] = ACTIONS(1749),
    [anon_sym_AMP_EQ] = ACTIONS(1749),
    [anon_sym_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_GT_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1749),
    [anon_sym_LT_LT_EQ] = ACTIONS(1749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1749),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1747),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_void] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_DQUOTE] = ACTIONS(1749),
    [anon_sym_SQUOTE] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [sym_number] = ACTIONS(1749),
    [sym_this] = ACTIONS(1747),
    [sym_true] = ACTIONS(1747),
    [sym_false] = ACTIONS(1747),
    [sym_null] = ACTIONS(1747),
    [sym_undefined] = ACTIONS(1747),
    [anon_sym_static] = ACTIONS(1747),
    [anon_sym_readonly] = ACTIONS(1747),
    [anon_sym_get] = ACTIONS(1747),
    [anon_sym_set] = ACTIONS(1747),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_any] = ACTIONS(1747),
    [anon_sym_number] = ACTIONS(1747),
    [anon_sym_boolean] = ACTIONS(1747),
    [anon_sym_string] = ACTIONS(1747),
    [anon_sym_symbol] = ACTIONS(1747),
    [anon_sym_abstract] = ACTIONS(1747),
    [anon_sym_satisfies] = ACTIONS(1747),
    [anon_sym_infer] = ACTIONS(1747),
    [anon_sym_keyof] = ACTIONS(1747),
    [anon_sym_unknown] = ACTIONS(1747),
    [anon_sym_never] = ACTIONS(1747),
    [anon_sym_object] = ACTIONS(1747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1749),
    [anon_sym_constructor] = ACTIONS(1747),
    [anon_sym_prop] = ACTIONS(1747),
    [anon_sym_id] = ACTIONS(1747),
    [anon_sym_event] = ACTIONS(1747),
    [anon_sym_fn] = ACTIONS(1747),
    [anon_sym_on] = ACTIONS(1747),
    [sym__ternary_qmark] = ACTIONS(1749),
  },
  [487] = {
    [sym__call_signature] = STATE(4379),
    [sym_string] = STATE(3265),
    [sym_formal_parameters] = STATE(3400),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_type_parameters] = STATE(4000),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_function] = ACTIONS(1721),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1705),
    [anon_sym_private] = ACTIONS(1705),
    [anon_sym_protected] = ACTIONS(1705),
    [anon_sym_override] = ACTIONS(1705),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1705),
    [anon_sym_number] = ACTIONS(1705),
    [anon_sym_boolean] = ACTIONS(1705),
    [anon_sym_string] = ACTIONS(1705),
    [anon_sym_symbol] = ACTIONS(1705),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [488] = {
    [sym_declaration] = STATE(667),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_class_declaration] = STATE(775),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function_declaration] = STATE(775),
    [sym_decorator] = STATE(1390),
    [sym_function_signature] = STATE(775),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_component_declaration] = STATE(775),
    [aux_sym_class_repeat1] = STATE(3201),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1658),
    [anon_sym_let] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1751),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1757),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(62),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_declare] = ACTIONS(1759),
    [anon_sym_namespace] = ACTIONS(1761),
    [anon_sym_module] = ACTIONS(1763),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_satisfies] = ACTIONS(62),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_interface] = ACTIONS(1767),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_component] = ACTIONS(13),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_as] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1769),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [anon_sym_typeof] = ACTIONS(1769),
    [anon_sym_BANG] = ACTIONS(1769),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_in] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1769),
    [anon_sym_DOT] = ACTIONS(1769),
    [anon_sym_async] = ACTIONS(1769),
    [anon_sym_QMARK_DOT] = ACTIONS(1771),
    [anon_sym_new] = ACTIONS(1769),
    [anon_sym_PLUS_EQ] = ACTIONS(1771),
    [anon_sym_DASH_EQ] = ACTIONS(1771),
    [anon_sym_STAR_EQ] = ACTIONS(1771),
    [anon_sym_SLASH_EQ] = ACTIONS(1771),
    [anon_sym_PERCENT_EQ] = ACTIONS(1771),
    [anon_sym_CARET_EQ] = ACTIONS(1771),
    [anon_sym_AMP_EQ] = ACTIONS(1771),
    [anon_sym_PIPE_EQ] = ACTIONS(1771),
    [anon_sym_GT_GT_EQ] = ACTIONS(1771),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1771),
    [anon_sym_LT_LT_EQ] = ACTIONS(1771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1771),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1771),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1771),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(1769),
    [anon_sym_PIPE_PIPE] = ACTIONS(1769),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_GT_GT_GT] = ACTIONS(1769),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_AMP] = ACTIONS(1769),
    [anon_sym_CARET] = ACTIONS(1769),
    [anon_sym_PIPE] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PERCENT] = ACTIONS(1769),
    [anon_sym_STAR_STAR] = ACTIONS(1769),
    [anon_sym_LT_EQ] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1771),
    [anon_sym_BANG_EQ] = ACTIONS(1769),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1771),
    [anon_sym_GT_EQ] = ACTIONS(1771),
    [anon_sym_QMARK_QMARK] = ACTIONS(1769),
    [anon_sym_instanceof] = ACTIONS(1769),
    [anon_sym_void] = ACTIONS(1769),
    [anon_sym_PLUS_PLUS] = ACTIONS(1771),
    [anon_sym_DASH_DASH] = ACTIONS(1771),
    [anon_sym_DQUOTE] = ACTIONS(1771),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1771),
    [sym_number] = ACTIONS(1771),
    [sym_this] = ACTIONS(1769),
    [sym_true] = ACTIONS(1769),
    [sym_false] = ACTIONS(1769),
    [sym_null] = ACTIONS(1769),
    [sym_undefined] = ACTIONS(1769),
    [anon_sym_static] = ACTIONS(1769),
    [anon_sym_readonly] = ACTIONS(1769),
    [anon_sym_get] = ACTIONS(1769),
    [anon_sym_set] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_any] = ACTIONS(1769),
    [anon_sym_number] = ACTIONS(1769),
    [anon_sym_boolean] = ACTIONS(1769),
    [anon_sym_string] = ACTIONS(1769),
    [anon_sym_symbol] = ACTIONS(1769),
    [anon_sym_abstract] = ACTIONS(1769),
    [anon_sym_satisfies] = ACTIONS(1769),
    [anon_sym_infer] = ACTIONS(1769),
    [anon_sym_keyof] = ACTIONS(1769),
    [anon_sym_unknown] = ACTIONS(1769),
    [anon_sym_never] = ACTIONS(1769),
    [anon_sym_object] = ACTIONS(1769),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1771),
    [anon_sym_constructor] = ACTIONS(1769),
    [anon_sym_prop] = ACTIONS(1769),
    [anon_sym_id] = ACTIONS(1769),
    [anon_sym_event] = ACTIONS(1769),
    [anon_sym_fn] = ACTIONS(1769),
    [anon_sym_on] = ACTIONS(1769),
    [sym__ternary_qmark] = ACTIONS(1771),
  },
  [490] = {
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_as] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_RBRACE] = ACTIONS(1775),
    [anon_sym_typeof] = ACTIONS(1773),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_in] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_EQ] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(1775),
    [anon_sym_LT] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1773),
    [anon_sym_SLASH] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_async] = ACTIONS(1773),
    [anon_sym_QMARK_DOT] = ACTIONS(1775),
    [anon_sym_new] = ACTIONS(1773),
    [anon_sym_PLUS_EQ] = ACTIONS(1775),
    [anon_sym_DASH_EQ] = ACTIONS(1775),
    [anon_sym_STAR_EQ] = ACTIONS(1775),
    [anon_sym_SLASH_EQ] = ACTIONS(1775),
    [anon_sym_PERCENT_EQ] = ACTIONS(1775),
    [anon_sym_CARET_EQ] = ACTIONS(1775),
    [anon_sym_AMP_EQ] = ACTIONS(1775),
    [anon_sym_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_GT_GT_EQ] = ACTIONS(1775),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1775),
    [anon_sym_LT_LT_EQ] = ACTIONS(1775),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1775),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_GT_GT] = ACTIONS(1773),
    [anon_sym_GT_GT_GT] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1773),
    [anon_sym_PLUS] = ACTIONS(1773),
    [anon_sym_DASH] = ACTIONS(1773),
    [anon_sym_PERCENT] = ACTIONS(1773),
    [anon_sym_STAR_STAR] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1775),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1775),
    [anon_sym_GT_EQ] = ACTIONS(1775),
    [anon_sym_QMARK_QMARK] = ACTIONS(1773),
    [anon_sym_instanceof] = ACTIONS(1773),
    [anon_sym_void] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1775),
    [anon_sym_DASH_DASH] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1775),
    [anon_sym_SQUOTE] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1775),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1773),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [sym_undefined] = ACTIONS(1773),
    [anon_sym_static] = ACTIONS(1773),
    [anon_sym_readonly] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(1773),
    [anon_sym_set] = ACTIONS(1773),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_any] = ACTIONS(1773),
    [anon_sym_number] = ACTIONS(1773),
    [anon_sym_boolean] = ACTIONS(1773),
    [anon_sym_string] = ACTIONS(1773),
    [anon_sym_symbol] = ACTIONS(1773),
    [anon_sym_abstract] = ACTIONS(1773),
    [anon_sym_satisfies] = ACTIONS(1773),
    [anon_sym_infer] = ACTIONS(1773),
    [anon_sym_keyof] = ACTIONS(1773),
    [anon_sym_unknown] = ACTIONS(1773),
    [anon_sym_never] = ACTIONS(1773),
    [anon_sym_object] = ACTIONS(1773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1775),
    [anon_sym_constructor] = ACTIONS(1773),
    [anon_sym_prop] = ACTIONS(1773),
    [anon_sym_id] = ACTIONS(1773),
    [anon_sym_event] = ACTIONS(1773),
    [anon_sym_fn] = ACTIONS(1773),
    [anon_sym_on] = ACTIONS(1773),
    [sym__ternary_qmark] = ACTIONS(1775),
  },
  [491] = {
    [sym_identifier] = ACTIONS(1777),
    [anon_sym_STAR] = ACTIONS(1777),
    [anon_sym_as] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1777),
    [anon_sym_RBRACE] = ACTIONS(1779),
    [anon_sym_typeof] = ACTIONS(1777),
    [anon_sym_BANG] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1779),
    [anon_sym_EQ] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_SLASH] = ACTIONS(1777),
    [anon_sym_DOT] = ACTIONS(1777),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_QMARK_DOT] = ACTIONS(1779),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS_EQ] = ACTIONS(1779),
    [anon_sym_DASH_EQ] = ACTIONS(1779),
    [anon_sym_STAR_EQ] = ACTIONS(1779),
    [anon_sym_SLASH_EQ] = ACTIONS(1779),
    [anon_sym_PERCENT_EQ] = ACTIONS(1779),
    [anon_sym_CARET_EQ] = ACTIONS(1779),
    [anon_sym_AMP_EQ] = ACTIONS(1779),
    [anon_sym_PIPE_EQ] = ACTIONS(1779),
    [anon_sym_GT_GT_EQ] = ACTIONS(1779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1779),
    [anon_sym_LT_LT_EQ] = ACTIONS(1779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1779),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1779),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_GT_GT] = ACTIONS(1777),
    [anon_sym_GT_GT_GT] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_CARET] = ACTIONS(1777),
    [anon_sym_PIPE] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1777),
    [anon_sym_DASH] = ACTIONS(1777),
    [anon_sym_PERCENT] = ACTIONS(1777),
    [anon_sym_STAR_STAR] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1779),
    [anon_sym_QMARK_QMARK] = ACTIONS(1777),
    [anon_sym_instanceof] = ACTIONS(1777),
    [anon_sym_void] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_DQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1779),
    [sym_number] = ACTIONS(1779),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [sym_undefined] = ACTIONS(1777),
    [anon_sym_static] = ACTIONS(1777),
    [anon_sym_readonly] = ACTIONS(1777),
    [anon_sym_get] = ACTIONS(1777),
    [anon_sym_set] = ACTIONS(1777),
    [anon_sym_QMARK] = ACTIONS(1777),
    [anon_sym_any] = ACTIONS(1777),
    [anon_sym_number] = ACTIONS(1777),
    [anon_sym_boolean] = ACTIONS(1777),
    [anon_sym_string] = ACTIONS(1777),
    [anon_sym_symbol] = ACTIONS(1777),
    [anon_sym_abstract] = ACTIONS(1777),
    [anon_sym_satisfies] = ACTIONS(1777),
    [anon_sym_infer] = ACTIONS(1777),
    [anon_sym_keyof] = ACTIONS(1777),
    [anon_sym_unknown] = ACTIONS(1777),
    [anon_sym_never] = ACTIONS(1777),
    [anon_sym_object] = ACTIONS(1777),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1779),
    [anon_sym_constructor] = ACTIONS(1777),
    [anon_sym_prop] = ACTIONS(1777),
    [anon_sym_id] = ACTIONS(1777),
    [anon_sym_event] = ACTIONS(1777),
    [anon_sym_fn] = ACTIONS(1777),
    [anon_sym_on] = ACTIONS(1777),
    [sym__ternary_qmark] = ACTIONS(1779),
  },
  [492] = {
    [sym_declaration] = STATE(667),
    [sym_variable_declaration] = STATE(775),
    [sym_lexical_declaration] = STATE(775),
    [sym_class_declaration] = STATE(775),
    [sym_function_declaration] = STATE(775),
    [sym_generator_function_declaration] = STATE(775),
    [sym_decorator] = STATE(1390),
    [sym_function_signature] = STATE(775),
    [sym_ambient_declaration] = STATE(775),
    [sym_abstract_class_declaration] = STATE(775),
    [sym_module] = STATE(775),
    [sym_internal_module] = STATE(779),
    [sym_import_alias] = STATE(775),
    [sym_interface_declaration] = STATE(775),
    [sym_enum_declaration] = STATE(775),
    [sym_type_alias_declaration] = STATE(775),
    [sym_component_declaration] = STATE(775),
    [aux_sym_class_repeat1] = STATE(3201),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1658),
    [anon_sym_let] = ACTIONS(1660),
    [anon_sym_const] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1781),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(62),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(11),
    [anon_sym_declare] = ACTIONS(1685),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_satisfies] = ACTIONS(62),
    [anon_sym_global] = ACTIONS(1693),
    [anon_sym_interface] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_component] = ACTIONS(13),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [493] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [494] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1811),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [495] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1813),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [496] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(495),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1815),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [497] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(502),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [498] = {
    [sym_identifier] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(1287),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [499] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1819),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [500] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [501] = {
    [sym_identifier] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_typeof] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(23),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(23),
    [anon_sym_EQ_GT] = ACTIONS(1287),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_void] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [sym_number] = ACTIONS(62),
    [sym_this] = ACTIONS(23),
    [sym_true] = ACTIONS(23),
    [sym_false] = ACTIONS(23),
    [sym_null] = ACTIONS(23),
    [sym_undefined] = ACTIONS(23),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_infer] = ACTIONS(23),
    [anon_sym_keyof] = ACTIONS(23),
    [anon_sym_unknown] = ACTIONS(23),
    [anon_sym_never] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_LBRACE_PIPE] = ACTIONS(62),
    [anon_sym_prop] = ACTIONS(23),
    [anon_sym_id] = ACTIONS(23),
    [anon_sym_event] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [502] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [503] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1825),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [504] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(1827),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1833),
    [anon_sym_RBRACE] = ACTIONS(1836),
    [anon_sym_typeof] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1847),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_void] = ACTIONS(1865),
    [anon_sym_DQUOTE] = ACTIONS(1868),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(1880),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [sym_null] = ACTIONS(1883),
    [sym_undefined] = ACTIONS(1883),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1889),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1895),
    [anon_sym_QMARK] = ACTIONS(1898),
    [anon_sym_any] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1865),
    [anon_sym_string] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1865),
    [anon_sym_abstract] = ACTIONS(1901),
    [anon_sym_infer] = ACTIONS(1904),
    [anon_sym_keyof] = ACTIONS(1907),
    [anon_sym_unknown] = ACTIONS(1865),
    [anon_sym_never] = ACTIONS(1865),
    [anon_sym_object] = ACTIONS(1865),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1910),
    [anon_sym_constructor] = ACTIONS(1913),
    [anon_sym_prop] = ACTIONS(1916),
    [anon_sym_id] = ACTIONS(1919),
    [anon_sym_event] = ACTIONS(1922),
    [anon_sym_fn] = ACTIONS(1925),
    [anon_sym_on] = ACTIONS(1928),
  },
  [505] = {
    [sym_nested_identifier] = STATE(2864),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1437),
    [sym_new_tagged_component_expression] = STATE(1437),
    [sym_new_tripple_tagged_component_expression] = STATE(1437),
    [sym_constructor_definition] = STATE(1437),
    [sym_type_narrow] = STATE(4018),
    [sym_property_declaration] = STATE(1437),
    [sym_static_property_declaration] = STATE(1437),
    [sym_identifier_property_assignment] = STATE(1437),
    [sym_property_assignment] = STATE(1437),
    [sym_event_declaration] = STATE(1437),
    [sym_property_accessor_declaration] = STATE(1437),
    [sym_typed_method_declaration] = STATE(1437),
    [sym_listener_declaration] = STATE(1437),
    [aux_sym_component_body_repeat1] = STATE(499),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1931),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_get] = ACTIONS(1795),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_constructor] = ACTIONS(1799),
    [anon_sym_prop] = ACTIONS(1801),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1809),
  },
  [506] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_override_modifier] = STATE(2477),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [507] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_override_modifier] = STATE(2477),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [508] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [509] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [sym_override_modifier] = STATE(2477),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [510] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [511] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [512] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [513] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [514] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [515] = {
    [sym_string] = STATE(3265),
    [sym__property_name] = STATE(3265),
    [sym_computed_property_name] = STATE(3265),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1723),
    [sym_private_property_identifier] = ACTIONS(1723),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_readonly] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_override] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [516] = {
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1549),
    [sym_private_property_identifier] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [517] = {
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1549),
    [sym_private_property_identifier] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [518] = {
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_export] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1553),
    [sym_private_property_identifier] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_readonly] = ACTIONS(1551),
    [anon_sym_get] = ACTIONS(1551),
    [anon_sym_set] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1551),
    [anon_sym_namespace] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1551),
    [anon_sym_private] = ACTIONS(1551),
    [anon_sym_protected] = ACTIONS(1551),
    [anon_sym_override] = ACTIONS(1551),
    [anon_sym_module] = ACTIONS(1551),
    [anon_sym_any] = ACTIONS(1551),
    [anon_sym_number] = ACTIONS(1551),
    [anon_sym_boolean] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_symbol] = ACTIONS(1551),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [519] = {
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_export] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1553),
    [sym_private_property_identifier] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_readonly] = ACTIONS(1551),
    [anon_sym_get] = ACTIONS(1551),
    [anon_sym_set] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1551),
    [anon_sym_namespace] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1551),
    [anon_sym_private] = ACTIONS(1551),
    [anon_sym_protected] = ACTIONS(1551),
    [anon_sym_override] = ACTIONS(1551),
    [anon_sym_module] = ACTIONS(1551),
    [anon_sym_any] = ACTIONS(1551),
    [anon_sym_number] = ACTIONS(1551),
    [anon_sym_boolean] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_symbol] = ACTIONS(1551),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [520] = {
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1549),
    [sym_private_property_identifier] = ACTIONS(1549),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [521] = {
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_export] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1553),
    [sym_private_property_identifier] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_readonly] = ACTIONS(1551),
    [anon_sym_get] = ACTIONS(1551),
    [anon_sym_set] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_declare] = ACTIONS(1551),
    [anon_sym_namespace] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1551),
    [anon_sym_private] = ACTIONS(1551),
    [anon_sym_protected] = ACTIONS(1551),
    [anon_sym_override] = ACTIONS(1551),
    [anon_sym_module] = ACTIONS(1551),
    [anon_sym_any] = ACTIONS(1551),
    [anon_sym_number] = ACTIONS(1551),
    [anon_sym_boolean] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_symbol] = ACTIONS(1551),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [522] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(526),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [523] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(530),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [524] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(522),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [525] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(526),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [526] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(526),
    [sym_identifier] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1962),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1970),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_void] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(2000),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [sym_number] = ACTIONS(2009),
    [sym_this] = ACTIONS(2012),
    [sym_true] = ACTIONS(2015),
    [sym_false] = ACTIONS(2015),
    [sym_null] = ACTIONS(2015),
    [sym_undefined] = ACTIONS(2015),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2021),
    [anon_sym_QMARK] = ACTIONS(2024),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [anon_sym_abstract] = ACTIONS(2027),
    [anon_sym_infer] = ACTIONS(2030),
    [anon_sym_keyof] = ACTIONS(2033),
    [anon_sym_unknown] = ACTIONS(1997),
    [anon_sym_never] = ACTIONS(1997),
    [anon_sym_object] = ACTIONS(1997),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2036),
    [anon_sym_prop] = ACTIONS(2039),
    [anon_sym_id] = ACTIONS(2042),
    [anon_sym_event] = ACTIONS(2045),
    [anon_sym_fn] = ACTIONS(2048),
    [anon_sym_on] = ACTIONS(2051),
  },
  [527] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(526),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [528] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(525),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [529] = {
    [aux_sym_import_path_segment_repeat1] = STATE(547),
    [aux_sym_js_import_statement_repeat1] = STATE(3822),
    [sym_identifier] = ACTIONS(2058),
    [anon_sym_export] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_type] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(2061),
    [anon_sym_import] = ACTIONS(2061),
    [anon_sym_from] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2061),
    [anon_sym_const] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_else] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2063),
    [anon_sym_await] = ACTIONS(2061),
    [anon_sym_while] = ACTIONS(2061),
    [anon_sym_do] = ACTIONS(2061),
    [anon_sym_try] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_debugger] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_case] = ACTIONS(2061),
    [anon_sym_default] = ACTIONS(2061),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(2063),
    [anon_sym_LTtemplate_GT] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_class] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_function] = ACTIONS(2061),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_void] = ACTIONS(2061),
    [anon_sym_delete] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2063),
    [anon_sym_DASH_DASH] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [sym_number] = ACTIONS(2071),
    [sym_this] = ACTIONS(2061),
    [sym_super] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_null] = ACTIONS(2061),
    [sym_undefined] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2063),
    [anon_sym_static] = ACTIONS(2061),
    [anon_sym_readonly] = ACTIONS(2061),
    [anon_sym_get] = ACTIONS(2061),
    [anon_sym_set] = ACTIONS(2061),
    [anon_sym_declare] = ACTIONS(2061),
    [anon_sym_namespace] = ACTIONS(2061),
    [anon_sym_public] = ACTIONS(2061),
    [anon_sym_private] = ACTIONS(2061),
    [anon_sym_protected] = ACTIONS(2061),
    [anon_sym_override] = ACTIONS(2061),
    [anon_sym_module] = ACTIONS(2061),
    [anon_sym_any] = ACTIONS(2061),
    [anon_sym_number] = ACTIONS(2061),
    [anon_sym_boolean] = ACTIONS(2061),
    [anon_sym_string] = ACTIONS(2061),
    [anon_sym_symbol] = ACTIONS(2061),
    [anon_sym_abstract] = ACTIONS(2061),
    [anon_sym_interface] = ACTIONS(2061),
    [anon_sym_enum] = ACTIONS(2061),
    [anon_sym_component] = ACTIONS(2061),
  },
  [530] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(526),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [531] = {
    [sym_nested_identifier] = STATE(2836),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_new_component_expression] = STATE(1524),
    [sym_new_tagged_component_expression] = STATE(1524),
    [sym_new_tripple_tagged_component_expression] = STATE(1524),
    [sym_type_narrow] = STATE(4064),
    [sym_property_declaration] = STATE(1524),
    [sym_identifier_property_assignment] = STATE(1524),
    [sym_property_assignment] = STATE(1524),
    [sym_event_declaration] = STATE(1524),
    [sym_typed_method_declaration] = STATE(1524),
    [sym_listener_declaration] = STATE(1524),
    [aux_sym_new_component_body_repeat1] = STATE(527),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(2076),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(1949),
    [anon_sym_id] = ACTIONS(1803),
    [anon_sym_event] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_on] = ACTIONS(1951),
  },
  [532] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(1020),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_QMARK] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [533] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(27),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [534] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [535] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(62),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [536] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(1013),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [537] = {
    [sym__call_signature] = STATE(4379),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [538] = {
    [sym__call_signature] = STATE(4580),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2094),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_EQ_GT] = ACTIONS(2098),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_readonly] = ACTIONS(2094),
    [anon_sym_get] = ACTIONS(2094),
    [anon_sym_set] = ACTIONS(2094),
    [anon_sym_declare] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_override] = ACTIONS(2094),
    [anon_sym_module] = ACTIONS(2094),
    [anon_sym_any] = ACTIONS(2094),
    [anon_sym_number] = ACTIONS(2094),
    [anon_sym_boolean] = ACTIONS(2094),
    [anon_sym_string] = ACTIONS(2094),
    [anon_sym_symbol] = ACTIONS(2094),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [539] = {
    [sym_catch_clause] = STATE(569),
    [sym_finally_clause] = STATE(670),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_catch] = ACTIONS(2104),
    [anon_sym_finally] = ACTIONS(2106),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LTtemplate_GT] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2100),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2102),
    [anon_sym_DASH_DASH] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2102),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
    [anon_sym_component] = ACTIONS(2100),
  },
  [540] = {
    [sym__call_signature] = STATE(4379),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [541] = {
    [sym__call_signature] = STATE(4379),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1781),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(1721),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [542] = {
    [sym__call_signature] = STATE(4580),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2094),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_EQ_GT] = ACTIONS(2098),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_readonly] = ACTIONS(2094),
    [anon_sym_get] = ACTIONS(2094),
    [anon_sym_set] = ACTIONS(2094),
    [anon_sym_declare] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_override] = ACTIONS(2094),
    [anon_sym_module] = ACTIONS(2094),
    [anon_sym_any] = ACTIONS(2094),
    [anon_sym_number] = ACTIONS(2094),
    [anon_sym_boolean] = ACTIONS(2094),
    [anon_sym_string] = ACTIONS(2094),
    [anon_sym_symbol] = ACTIONS(2094),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [543] = {
    [sym__call_signature] = STATE(4379),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(2108),
    [anon_sym_of] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [544] = {
    [sym__call_signature] = STATE(4379),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1751),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2113),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1405),
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1401),
    [anon_sym_var] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1405),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_try] = ACTIONS(1401),
    [anon_sym_with] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_debugger] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1401),
    [anon_sym_class] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1405),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1405),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1405),
    [sym_number] = ACTIONS(1405),
    [sym_this] = ACTIONS(1401),
    [sym_super] = ACTIONS(1401),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_undefined] = ACTIONS(1401),
    [anon_sym_AT] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_abstract] = ACTIONS(1401),
    [anon_sym_interface] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_component] = ACTIONS(1401),
    [anon_sym_instance] = ACTIONS(1401),
    [sym__automatic_semicolon] = ACTIONS(1409),
  },
  [546] = {
    [sym__call_signature] = STATE(4469),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(62),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(1064),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_readonly] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_override] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_implements] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [547] = {
    [aux_sym_import_path_segment_repeat1] = STATE(558),
    [sym_identifier] = ACTIONS(2119),
    [anon_sym_export] = ACTIONS(2122),
    [anon_sym_as] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_RBRACE] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2122),
    [anon_sym_typeof] = ACTIONS(2122),
    [anon_sym_import] = ACTIONS(2122),
    [anon_sym_var] = ACTIONS(2122),
    [anon_sym_let] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_else] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_await] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_with] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_debugger] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym_case] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_yield] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2124),
    [anon_sym_LTtemplate_GT] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_SLASH] = ACTIONS(2122),
    [anon_sym_DOT] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_async] = ACTIONS(2122),
    [anon_sym_function] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_void] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2124),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2122),
    [sym_super] = ACTIONS(2122),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [sym_null] = ACTIONS(2122),
    [sym_undefined] = ACTIONS(2122),
    [anon_sym_AT] = ACTIONS(2124),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_readonly] = ACTIONS(2122),
    [anon_sym_get] = ACTIONS(2122),
    [anon_sym_set] = ACTIONS(2122),
    [anon_sym_declare] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_public] = ACTIONS(2122),
    [anon_sym_private] = ACTIONS(2122),
    [anon_sym_protected] = ACTIONS(2122),
    [anon_sym_override] = ACTIONS(2122),
    [anon_sym_module] = ACTIONS(2122),
    [anon_sym_any] = ACTIONS(2122),
    [anon_sym_number] = ACTIONS(2122),
    [anon_sym_boolean] = ACTIONS(2122),
    [anon_sym_string] = ACTIONS(2122),
    [anon_sym_symbol] = ACTIONS(2122),
    [anon_sym_abstract] = ACTIONS(2122),
    [anon_sym_interface] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_component] = ACTIONS(2122),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1301),
    [anon_sym_typeof] = ACTIONS(1301),
    [anon_sym_import] = ACTIONS(1301),
    [anon_sym_var] = ACTIONS(1301),
    [anon_sym_let] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_await] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_try] = ACTIONS(1301),
    [anon_sym_with] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_debugger] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_throw] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LTtemplate_GT] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_class] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1301),
    [anon_sym_function] = ACTIONS(1301),
    [anon_sym_new] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_TILDE] = ACTIONS(1305),
    [anon_sym_void] = ACTIONS(1301),
    [anon_sym_delete] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [sym_number] = ACTIONS(1305),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_get] = ACTIONS(1301),
    [anon_sym_set] = ACTIONS(1301),
    [anon_sym_declare] = ACTIONS(1301),
    [anon_sym_namespace] = ACTIONS(1301),
    [anon_sym_public] = ACTIONS(1301),
    [anon_sym_private] = ACTIONS(1301),
    [anon_sym_protected] = ACTIONS(1301),
    [anon_sym_override] = ACTIONS(1301),
    [anon_sym_module] = ACTIONS(1301),
    [anon_sym_any] = ACTIONS(1301),
    [anon_sym_number] = ACTIONS(1301),
    [anon_sym_boolean] = ACTIONS(1301),
    [anon_sym_string] = ACTIONS(1301),
    [anon_sym_symbol] = ACTIONS(1301),
    [anon_sym_abstract] = ACTIONS(1301),
    [anon_sym_interface] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_component] = ACTIONS(1301),
    [anon_sym_instance] = ACTIONS(1301),
    [sym__automatic_semicolon] = ACTIONS(1309),
  },
  [549] = {
    [aux_sym_import_path_repeat1] = STATE(556),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_as] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_LTtemplate_GT] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_DOT] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_number] = ACTIONS(2131),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [anon_sym_component] = ACTIONS(2129),
  },
  [550] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_catch] = ACTIONS(1345),
    [anon_sym_finally] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(2135),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1397),
    [anon_sym_export] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_type] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1397),
    [anon_sym_import] = ACTIONS(1397),
    [anon_sym_var] = ACTIONS(1397),
    [anon_sym_let] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_else] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1399),
    [anon_sym_await] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_try] = ACTIONS(1397),
    [anon_sym_with] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_debugger] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_throw] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [anon_sym_LTtemplate_GT] = ACTIONS(1399),
    [anon_sym_LT] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1397),
    [anon_sym_function] = ACTIONS(1397),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_void] = ACTIONS(1397),
    [anon_sym_delete] = ACTIONS(1397),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1399),
    [sym_number] = ACTIONS(1399),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(1399),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_get] = ACTIONS(1397),
    [anon_sym_set] = ACTIONS(1397),
    [anon_sym_declare] = ACTIONS(1397),
    [anon_sym_namespace] = ACTIONS(1397),
    [anon_sym_public] = ACTIONS(1397),
    [anon_sym_private] = ACTIONS(1397),
    [anon_sym_protected] = ACTIONS(1397),
    [anon_sym_override] = ACTIONS(1397),
    [anon_sym_module] = ACTIONS(1397),
    [anon_sym_any] = ACTIONS(1397),
    [anon_sym_number] = ACTIONS(1397),
    [anon_sym_boolean] = ACTIONS(1397),
    [anon_sym_string] = ACTIONS(1397),
    [anon_sym_symbol] = ACTIONS(1397),
    [anon_sym_abstract] = ACTIONS(1397),
    [anon_sym_interface] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_component] = ACTIONS(1397),
    [anon_sym_instance] = ACTIONS(1397),
    [sym__automatic_semicolon] = ACTIONS(1399),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1253),
    [sym_identifier] = ACTIONS(1249),
    [anon_sym_export] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1249),
    [anon_sym_import] = ACTIONS(1249),
    [anon_sym_var] = ACTIONS(1249),
    [anon_sym_let] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_debugger] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_throw] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_LTtemplate_GT] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_class] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_function] = ACTIONS(1249),
    [anon_sym_new] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1253),
    [sym_number] = ACTIONS(1253),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_undefined] = ACTIONS(1249),
    [anon_sym_AT] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_get] = ACTIONS(1249),
    [anon_sym_set] = ACTIONS(1249),
    [anon_sym_declare] = ACTIONS(1249),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_public] = ACTIONS(1249),
    [anon_sym_private] = ACTIONS(1249),
    [anon_sym_protected] = ACTIONS(1249),
    [anon_sym_override] = ACTIONS(1249),
    [anon_sym_module] = ACTIONS(1249),
    [anon_sym_any] = ACTIONS(1249),
    [anon_sym_number] = ACTIONS(1249),
    [anon_sym_boolean] = ACTIONS(1249),
    [anon_sym_string] = ACTIONS(1249),
    [anon_sym_symbol] = ACTIONS(1249),
    [anon_sym_abstract] = ACTIONS(1249),
    [anon_sym_interface] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_component] = ACTIONS(1249),
    [anon_sym_instance] = ACTIONS(1249),
    [sym__automatic_semicolon] = ACTIONS(1257),
  },
  [553] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(2137),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [554] = {
    [sym__call_signature] = STATE(4469),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(62),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(1062),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(1064),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_readonly] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_override] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_satisfies] = ACTIONS(23),
    [anon_sym_implements] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [555] = {
    [aux_sym_import_path_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_export] = ACTIONS(2139),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_type] = ACTIONS(2139),
    [anon_sym_typeof] = ACTIONS(2139),
    [anon_sym_import] = ACTIONS(2139),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_else] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(2141),
    [anon_sym_await] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_with] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_debugger] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [anon_sym_LTtemplate_GT] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_async] = ACTIONS(2139),
    [anon_sym_function] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_void] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [sym_number] = ACTIONS(2141),
    [sym_this] = ACTIONS(2139),
    [sym_super] = ACTIONS(2139),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [sym_undefined] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(2141),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_readonly] = ACTIONS(2139),
    [anon_sym_get] = ACTIONS(2139),
    [anon_sym_set] = ACTIONS(2139),
    [anon_sym_declare] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_public] = ACTIONS(2139),
    [anon_sym_private] = ACTIONS(2139),
    [anon_sym_protected] = ACTIONS(2139),
    [anon_sym_override] = ACTIONS(2139),
    [anon_sym_module] = ACTIONS(2139),
    [anon_sym_any] = ACTIONS(2139),
    [anon_sym_number] = ACTIONS(2139),
    [anon_sym_boolean] = ACTIONS(2139),
    [anon_sym_string] = ACTIONS(2139),
    [anon_sym_symbol] = ACTIONS(2139),
    [anon_sym_abstract] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_component] = ACTIONS(2139),
  },
  [556] = {
    [aux_sym_import_path_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2143),
    [anon_sym_as] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2143),
    [anon_sym_import] = ACTIONS(2143),
    [anon_sym_var] = ACTIONS(2143),
    [anon_sym_let] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2143),
    [anon_sym_if] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_do] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2143),
    [anon_sym_with] = ACTIONS(2143),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_continue] = ACTIONS(2143),
    [anon_sym_debugger] = ACTIONS(2143),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_throw] = ACTIONS(2143),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2143),
    [anon_sym_default] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2143),
    [anon_sym_DOT] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2143),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2143),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2143),
    [anon_sym_delete] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_this] = ACTIONS(2143),
    [sym_super] = ACTIONS(2143),
    [sym_true] = ACTIONS(2143),
    [sym_false] = ACTIONS(2143),
    [sym_null] = ACTIONS(2143),
    [sym_undefined] = ACTIONS(2143),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_readonly] = ACTIONS(2143),
    [anon_sym_get] = ACTIONS(2143),
    [anon_sym_set] = ACTIONS(2143),
    [anon_sym_declare] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_override] = ACTIONS(2143),
    [anon_sym_module] = ACTIONS(2143),
    [anon_sym_any] = ACTIONS(2143),
    [anon_sym_number] = ACTIONS(2143),
    [anon_sym_boolean] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2143),
    [anon_sym_abstract] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2143),
    [anon_sym_enum] = ACTIONS(2143),
    [anon_sym_component] = ACTIONS(2143),
  },
  [557] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_catch] = ACTIONS(1219),
    [anon_sym_finally] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LTtemplate_GT] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_override] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_component] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [558] = {
    [aux_sym_import_path_segment_repeat1] = STATE(558),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_export] = ACTIONS(2150),
    [anon_sym_as] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2150),
    [anon_sym_typeof] = ACTIONS(2150),
    [anon_sym_import] = ACTIONS(2150),
    [anon_sym_var] = ACTIONS(2150),
    [anon_sym_let] = ACTIONS(2150),
    [anon_sym_const] = ACTIONS(2150),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_else] = ACTIONS(2150),
    [anon_sym_if] = ACTIONS(2150),
    [anon_sym_switch] = ACTIONS(2150),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2150),
    [anon_sym_while] = ACTIONS(2150),
    [anon_sym_do] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2150),
    [anon_sym_with] = ACTIONS(2150),
    [anon_sym_break] = ACTIONS(2150),
    [anon_sym_continue] = ACTIONS(2150),
    [anon_sym_debugger] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(2150),
    [anon_sym_throw] = ACTIONS(2150),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(2150),
    [anon_sym_default] = ACTIONS(2150),
    [anon_sym_yield] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2150),
    [anon_sym_DOT] = ACTIONS(2150),
    [anon_sym_class] = ACTIONS(2150),
    [anon_sym_async] = ACTIONS(2150),
    [anon_sym_function] = ACTIONS(2150),
    [anon_sym_new] = ACTIONS(2150),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2150),
    [anon_sym_delete] = ACTIONS(2150),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2154),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(2150),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2150),
    [anon_sym_readonly] = ACTIONS(2150),
    [anon_sym_get] = ACTIONS(2150),
    [anon_sym_set] = ACTIONS(2150),
    [anon_sym_declare] = ACTIONS(2150),
    [anon_sym_namespace] = ACTIONS(2150),
    [anon_sym_public] = ACTIONS(2150),
    [anon_sym_private] = ACTIONS(2150),
    [anon_sym_protected] = ACTIONS(2150),
    [anon_sym_override] = ACTIONS(2150),
    [anon_sym_module] = ACTIONS(2150),
    [anon_sym_any] = ACTIONS(2150),
    [anon_sym_number] = ACTIONS(2150),
    [anon_sym_boolean] = ACTIONS(2150),
    [anon_sym_string] = ACTIONS(2150),
    [anon_sym_symbol] = ACTIONS(2150),
    [anon_sym_abstract] = ACTIONS(2150),
    [anon_sym_interface] = ACTIONS(2150),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_component] = ACTIONS(2150),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_type] = ACTIONS(1427),
    [anon_sym_typeof] = ACTIONS(1427),
    [anon_sym_import] = ACTIONS(1427),
    [anon_sym_var] = ACTIONS(1427),
    [anon_sym_let] = ACTIONS(1427),
    [anon_sym_const] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_else] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_switch] = ACTIONS(1427),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_await] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_try] = ACTIONS(1427),
    [anon_sym_with] = ACTIONS(1427),
    [anon_sym_break] = ACTIONS(1427),
    [anon_sym_continue] = ACTIONS(1427),
    [anon_sym_debugger] = ACTIONS(1427),
    [anon_sym_return] = ACTIONS(1427),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_default] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_LTtemplate_GT] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(1427),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_PLUS] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_void] = ACTIONS(1427),
    [anon_sym_delete] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1431),
    [sym_number] = ACTIONS(1431),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(1427),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_get] = ACTIONS(1427),
    [anon_sym_set] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [anon_sym_namespace] = ACTIONS(1427),
    [anon_sym_public] = ACTIONS(1427),
    [anon_sym_private] = ACTIONS(1427),
    [anon_sym_protected] = ACTIONS(1427),
    [anon_sym_override] = ACTIONS(1427),
    [anon_sym_module] = ACTIONS(1427),
    [anon_sym_any] = ACTIONS(1427),
    [anon_sym_number] = ACTIONS(1427),
    [anon_sym_boolean] = ACTIONS(1427),
    [anon_sym_string] = ACTIONS(1427),
    [anon_sym_symbol] = ACTIONS(1427),
    [anon_sym_abstract] = ACTIONS(1427),
    [anon_sym_interface] = ACTIONS(1427),
    [anon_sym_enum] = ACTIONS(1427),
    [anon_sym_component] = ACTIONS(1427),
    [anon_sym_instance] = ACTIONS(1427),
    [sym__automatic_semicolon] = ACTIONS(1435),
  },
  [560] = {
    [aux_sym_import_path_segment_repeat1] = STATE(547),
    [sym_identifier] = ACTIONS(2058),
    [anon_sym_export] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_type] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(2061),
    [anon_sym_import] = ACTIONS(2061),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2061),
    [anon_sym_const] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_else] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2063),
    [anon_sym_await] = ACTIONS(2061),
    [anon_sym_while] = ACTIONS(2061),
    [anon_sym_do] = ACTIONS(2061),
    [anon_sym_try] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_debugger] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_case] = ACTIONS(2061),
    [anon_sym_default] = ACTIONS(2061),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2063),
    [anon_sym_LTtemplate_GT] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_class] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_function] = ACTIONS(2061),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_void] = ACTIONS(2061),
    [anon_sym_delete] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2063),
    [anon_sym_DASH_DASH] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [sym_number] = ACTIONS(2071),
    [sym_this] = ACTIONS(2061),
    [sym_super] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_null] = ACTIONS(2061),
    [sym_undefined] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2063),
    [anon_sym_static] = ACTIONS(2061),
    [anon_sym_readonly] = ACTIONS(2061),
    [anon_sym_get] = ACTIONS(2061),
    [anon_sym_set] = ACTIONS(2061),
    [anon_sym_declare] = ACTIONS(2061),
    [anon_sym_namespace] = ACTIONS(2061),
    [anon_sym_public] = ACTIONS(2061),
    [anon_sym_private] = ACTIONS(2061),
    [anon_sym_protected] = ACTIONS(2061),
    [anon_sym_override] = ACTIONS(2061),
    [anon_sym_module] = ACTIONS(2061),
    [anon_sym_any] = ACTIONS(2061),
    [anon_sym_number] = ACTIONS(2061),
    [anon_sym_boolean] = ACTIONS(2061),
    [anon_sym_string] = ACTIONS(2061),
    [anon_sym_symbol] = ACTIONS(2061),
    [anon_sym_abstract] = ACTIONS(2061),
    [anon_sym_interface] = ACTIONS(2061),
    [anon_sym_enum] = ACTIONS(2061),
    [anon_sym_component] = ACTIONS(2061),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(1341),
    [anon_sym_export] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_RBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(1341),
    [anon_sym_typeof] = ACTIONS(1341),
    [anon_sym_import] = ACTIONS(1341),
    [anon_sym_var] = ACTIONS(1341),
    [anon_sym_let] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1343),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_try] = ACTIONS(1341),
    [anon_sym_with] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_debugger] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_throw] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_yield] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1343),
    [anon_sym_LTtemplate_GT] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_class] = ACTIONS(1341),
    [anon_sym_async] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1341),
    [anon_sym_new] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_void] = ACTIONS(1341),
    [anon_sym_delete] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [sym_number] = ACTIONS(1343),
    [sym_this] = ACTIONS(1341),
    [sym_super] = ACTIONS(1341),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [sym_null] = ACTIONS(1341),
    [sym_undefined] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_get] = ACTIONS(1341),
    [anon_sym_set] = ACTIONS(1341),
    [anon_sym_declare] = ACTIONS(1341),
    [anon_sym_namespace] = ACTIONS(1341),
    [anon_sym_public] = ACTIONS(1341),
    [anon_sym_private] = ACTIONS(1341),
    [anon_sym_protected] = ACTIONS(1341),
    [anon_sym_override] = ACTIONS(1341),
    [anon_sym_module] = ACTIONS(1341),
    [anon_sym_any] = ACTIONS(1341),
    [anon_sym_number] = ACTIONS(1341),
    [anon_sym_boolean] = ACTIONS(1341),
    [anon_sym_string] = ACTIONS(1341),
    [anon_sym_symbol] = ACTIONS(1341),
    [anon_sym_abstract] = ACTIONS(1341),
    [anon_sym_interface] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_component] = ACTIONS(1341),
    [anon_sym_instance] = ACTIONS(1341),
    [sym__automatic_semicolon] = ACTIONS(1343),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(1405),
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(1401),
    [anon_sym_var] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1405),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_await] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_try] = ACTIONS(1401),
    [anon_sym_with] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_debugger] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_throw] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_LTtemplate_GT] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1401),
    [anon_sym_class] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_function] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_TILDE] = ACTIONS(1405),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1405),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1405),
    [sym_number] = ACTIONS(1405),
    [sym_this] = ACTIONS(1401),
    [sym_super] = ACTIONS(1401),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_undefined] = ACTIONS(1401),
    [anon_sym_AT] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_abstract] = ACTIONS(1401),
    [anon_sym_interface] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_component] = ACTIONS(1401),
    [anon_sym_instance] = ACTIONS(1401),
    [sym__automatic_semicolon] = ACTIONS(1465),
  },
  [563] = {
    [aux_sym_import_path_repeat1] = STATE(563),
    [sym_identifier] = ACTIONS(2157),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_as] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_typeof] = ACTIONS(2157),
    [anon_sym_import] = ACTIONS(2157),
    [anon_sym_var] = ACTIONS(2157),
    [anon_sym_let] = ACTIONS(2157),
    [anon_sym_const] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2157),
    [anon_sym_if] = ACTIONS(2157),
    [anon_sym_switch] = ACTIONS(2157),
    [anon_sym_for] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_await] = ACTIONS(2157),
    [anon_sym_while] = ACTIONS(2157),
    [anon_sym_do] = ACTIONS(2157),
    [anon_sym_try] = ACTIONS(2157),
    [anon_sym_with] = ACTIONS(2157),
    [anon_sym_break] = ACTIONS(2157),
    [anon_sym_continue] = ACTIONS(2157),
    [anon_sym_debugger] = ACTIONS(2157),
    [anon_sym_return] = ACTIONS(2157),
    [anon_sym_throw] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2157),
    [anon_sym_default] = ACTIONS(2157),
    [anon_sym_yield] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_LTtemplate_GT] = ACTIONS(2159),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2157),
    [anon_sym_DOT] = ACTIONS(2161),
    [anon_sym_class] = ACTIONS(2157),
    [anon_sym_async] = ACTIONS(2157),
    [anon_sym_function] = ACTIONS(2157),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2157),
    [anon_sym_delete] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2159),
    [anon_sym_DQUOTE] = ACTIONS(2159),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_number] = ACTIONS(2159),
    [sym_this] = ACTIONS(2157),
    [sym_super] = ACTIONS(2157),
    [sym_true] = ACTIONS(2157),
    [sym_false] = ACTIONS(2157),
    [sym_null] = ACTIONS(2157),
    [sym_undefined] = ACTIONS(2157),
    [anon_sym_AT] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_override] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_interface] = ACTIONS(2157),
    [anon_sym_enum] = ACTIONS(2157),
    [anon_sym_component] = ACTIONS(2157),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(1273),
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_type] = ACTIONS(1269),
    [anon_sym_typeof] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_BANG] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_try] = ACTIONS(1269),
    [anon_sym_with] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_debugger] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_throw] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_yield] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_LTtemplate_GT] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1269),
    [anon_sym_class] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_function] = ACTIONS(1269),
    [anon_sym_new] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1273),
    [anon_sym_void] = ACTIONS(1269),
    [anon_sym_delete] = ACTIONS(1269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_SQUOTE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_number] = ACTIONS(1273),
    [sym_this] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [sym_null] = ACTIONS(1269),
    [sym_undefined] = ACTIONS(1269),
    [anon_sym_AT] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_get] = ACTIONS(1269),
    [anon_sym_set] = ACTIONS(1269),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_public] = ACTIONS(1269),
    [anon_sym_private] = ACTIONS(1269),
    [anon_sym_protected] = ACTIONS(1269),
    [anon_sym_override] = ACTIONS(1269),
    [anon_sym_module] = ACTIONS(1269),
    [anon_sym_any] = ACTIONS(1269),
    [anon_sym_number] = ACTIONS(1269),
    [anon_sym_boolean] = ACTIONS(1269),
    [anon_sym_string] = ACTIONS(1269),
    [anon_sym_symbol] = ACTIONS(1269),
    [anon_sym_abstract] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_component] = ACTIONS(1269),
    [anon_sym_instance] = ACTIONS(1269),
    [sym__automatic_semicolon] = ACTIONS(1277),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1391),
    [sym_identifier] = ACTIONS(1387),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_type] = ACTIONS(1387),
    [anon_sym_typeof] = ACTIONS(1387),
    [anon_sym_import] = ACTIONS(1387),
    [anon_sym_var] = ACTIONS(1387),
    [anon_sym_let] = ACTIONS(1387),
    [anon_sym_const] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1387),
    [anon_sym_switch] = ACTIONS(1387),
    [anon_sym_for] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1391),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_while] = ACTIONS(1387),
    [anon_sym_do] = ACTIONS(1387),
    [anon_sym_try] = ACTIONS(1387),
    [anon_sym_with] = ACTIONS(1387),
    [anon_sym_break] = ACTIONS(1387),
    [anon_sym_continue] = ACTIONS(1387),
    [anon_sym_debugger] = ACTIONS(1387),
    [anon_sym_return] = ACTIONS(1387),
    [anon_sym_throw] = ACTIONS(1387),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_case] = ACTIONS(1387),
    [anon_sym_default] = ACTIONS(1387),
    [anon_sym_yield] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1391),
    [anon_sym_LTtemplate_GT] = ACTIONS(1391),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_class] = ACTIONS(1387),
    [anon_sym_async] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1387),
    [anon_sym_new] = ACTIONS(1387),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1391),
    [sym_number] = ACTIONS(1391),
    [sym_this] = ACTIONS(1387),
    [sym_super] = ACTIONS(1387),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [sym_null] = ACTIONS(1387),
    [sym_undefined] = ACTIONS(1387),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_static] = ACTIONS(1387),
    [anon_sym_readonly] = ACTIONS(1387),
    [anon_sym_get] = ACTIONS(1387),
    [anon_sym_set] = ACTIONS(1387),
    [anon_sym_declare] = ACTIONS(1387),
    [anon_sym_namespace] = ACTIONS(1387),
    [anon_sym_public] = ACTIONS(1387),
    [anon_sym_private] = ACTIONS(1387),
    [anon_sym_protected] = ACTIONS(1387),
    [anon_sym_override] = ACTIONS(1387),
    [anon_sym_module] = ACTIONS(1387),
    [anon_sym_any] = ACTIONS(1387),
    [anon_sym_number] = ACTIONS(1387),
    [anon_sym_boolean] = ACTIONS(1387),
    [anon_sym_string] = ACTIONS(1387),
    [anon_sym_symbol] = ACTIONS(1387),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_interface] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1387),
    [anon_sym_component] = ACTIONS(1387),
    [anon_sym_instance] = ACTIONS(1387),
    [sym__automatic_semicolon] = ACTIONS(1395),
  },
  [566] = {
    [aux_sym_import_path_repeat1] = STATE(555),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_export] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_typeof] = ACTIONS(2164),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_var] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [anon_sym_with] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_debugger] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_throw] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2164),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_DOT] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_function] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2164),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2164),
    [anon_sym_delete] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_readonly] = ACTIONS(2164),
    [anon_sym_get] = ACTIONS(2164),
    [anon_sym_set] = ACTIONS(2164),
    [anon_sym_declare] = ACTIONS(2164),
    [anon_sym_namespace] = ACTIONS(2164),
    [anon_sym_public] = ACTIONS(2164),
    [anon_sym_private] = ACTIONS(2164),
    [anon_sym_protected] = ACTIONS(2164),
    [anon_sym_override] = ACTIONS(2164),
    [anon_sym_module] = ACTIONS(2164),
    [anon_sym_any] = ACTIONS(2164),
    [anon_sym_number] = ACTIONS(2164),
    [anon_sym_boolean] = ACTIONS(2164),
    [anon_sym_string] = ACTIONS(2164),
    [anon_sym_symbol] = ACTIONS(2164),
    [anon_sym_abstract] = ACTIONS(2164),
    [anon_sym_interface] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_component] = ACTIONS(2164),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_export] = ACTIONS(2170),
    [anon_sym_LBRACE] = ACTIONS(2168),
    [anon_sym_RBRACE] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2170),
    [anon_sym_typeof] = ACTIONS(2170),
    [anon_sym_import] = ACTIONS(2170),
    [anon_sym_var] = ACTIONS(2170),
    [anon_sym_let] = ACTIONS(2170),
    [anon_sym_const] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2168),
    [anon_sym_else] = ACTIONS(2170),
    [anon_sym_if] = ACTIONS(2170),
    [anon_sym_switch] = ACTIONS(2170),
    [anon_sym_for] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_await] = ACTIONS(2170),
    [anon_sym_while] = ACTIONS(2170),
    [anon_sym_do] = ACTIONS(2170),
    [anon_sym_try] = ACTIONS(2170),
    [anon_sym_with] = ACTIONS(2170),
    [anon_sym_break] = ACTIONS(2170),
    [anon_sym_continue] = ACTIONS(2170),
    [anon_sym_debugger] = ACTIONS(2170),
    [anon_sym_return] = ACTIONS(2170),
    [anon_sym_throw] = ACTIONS(2170),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_case] = ACTIONS(2170),
    [anon_sym_default] = ACTIONS(2170),
    [anon_sym_yield] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_LTtemplate_GT] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_SLASH] = ACTIONS(2170),
    [anon_sym_class] = ACTIONS(2170),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_function] = ACTIONS(2170),
    [anon_sym_new] = ACTIONS(2170),
    [anon_sym_PLUS] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2170),
    [anon_sym_TILDE] = ACTIONS(2168),
    [anon_sym_void] = ACTIONS(2170),
    [anon_sym_delete] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2168),
    [anon_sym_DASH_DASH] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [sym_number] = ACTIONS(2168),
    [sym_this] = ACTIONS(2170),
    [sym_super] = ACTIONS(2170),
    [sym_true] = ACTIONS(2170),
    [sym_false] = ACTIONS(2170),
    [sym_null] = ACTIONS(2170),
    [sym_undefined] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2170),
    [anon_sym_readonly] = ACTIONS(2170),
    [anon_sym_get] = ACTIONS(2170),
    [anon_sym_set] = ACTIONS(2170),
    [anon_sym_declare] = ACTIONS(2170),
    [anon_sym_namespace] = ACTIONS(2170),
    [anon_sym_public] = ACTIONS(2170),
    [anon_sym_private] = ACTIONS(2170),
    [anon_sym_protected] = ACTIONS(2170),
    [anon_sym_override] = ACTIONS(2170),
    [anon_sym_module] = ACTIONS(2170),
    [anon_sym_any] = ACTIONS(2170),
    [anon_sym_number] = ACTIONS(2170),
    [anon_sym_boolean] = ACTIONS(2170),
    [anon_sym_string] = ACTIONS(2170),
    [anon_sym_symbol] = ACTIONS(2170),
    [anon_sym_abstract] = ACTIONS(2170),
    [anon_sym_interface] = ACTIONS(2170),
    [anon_sym_enum] = ACTIONS(2170),
    [anon_sym_component] = ACTIONS(2170),
    [anon_sym_instance] = ACTIONS(2170),
  },
  [568] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [569] = {
    [sym_finally_clause] = STATE(815),
    [sym_identifier] = ACTIONS(2174),
    [anon_sym_export] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2174),
    [anon_sym_typeof] = ACTIONS(2174),
    [anon_sym_import] = ACTIONS(2174),
    [anon_sym_var] = ACTIONS(2174),
    [anon_sym_let] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_else] = ACTIONS(2174),
    [anon_sym_if] = ACTIONS(2174),
    [anon_sym_switch] = ACTIONS(2174),
    [anon_sym_for] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_await] = ACTIONS(2174),
    [anon_sym_while] = ACTIONS(2174),
    [anon_sym_do] = ACTIONS(2174),
    [anon_sym_try] = ACTIONS(2174),
    [anon_sym_with] = ACTIONS(2174),
    [anon_sym_break] = ACTIONS(2174),
    [anon_sym_continue] = ACTIONS(2174),
    [anon_sym_debugger] = ACTIONS(2174),
    [anon_sym_return] = ACTIONS(2174),
    [anon_sym_throw] = ACTIONS(2174),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_case] = ACTIONS(2174),
    [anon_sym_default] = ACTIONS(2174),
    [anon_sym_finally] = ACTIONS(2106),
    [anon_sym_yield] = ACTIONS(2174),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_LTtemplate_GT] = ACTIONS(2176),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_class] = ACTIONS(2174),
    [anon_sym_async] = ACTIONS(2174),
    [anon_sym_function] = ACTIONS(2174),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_void] = ACTIONS(2174),
    [anon_sym_delete] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2176),
    [sym_number] = ACTIONS(2176),
    [sym_this] = ACTIONS(2174),
    [sym_super] = ACTIONS(2174),
    [sym_true] = ACTIONS(2174),
    [sym_false] = ACTIONS(2174),
    [sym_null] = ACTIONS(2174),
    [sym_undefined] = ACTIONS(2174),
    [anon_sym_AT] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_readonly] = ACTIONS(2174),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_declare] = ACTIONS(2174),
    [anon_sym_namespace] = ACTIONS(2174),
    [anon_sym_public] = ACTIONS(2174),
    [anon_sym_private] = ACTIONS(2174),
    [anon_sym_protected] = ACTIONS(2174),
    [anon_sym_override] = ACTIONS(2174),
    [anon_sym_module] = ACTIONS(2174),
    [anon_sym_any] = ACTIONS(2174),
    [anon_sym_number] = ACTIONS(2174),
    [anon_sym_boolean] = ACTIONS(2174),
    [anon_sym_string] = ACTIONS(2174),
    [anon_sym_symbol] = ACTIONS(2174),
    [anon_sym_abstract] = ACTIONS(2174),
    [anon_sym_interface] = ACTIONS(2174),
    [anon_sym_enum] = ACTIONS(2174),
    [anon_sym_component] = ACTIONS(2174),
  },
  [570] = {
    [sym_statement_block] = STATE(877),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_DOT] = ACTIONS(2184),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [anon_sym_component] = ACTIONS(2178),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LTtemplate_GT] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2186),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2186),
    [anon_sym_DQUOTE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [anon_sym_component] = ACTIONS(2188),
    [anon_sym_instance] = ACTIONS(2188),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LTtemplate_GT] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
    [anon_sym_component] = ACTIONS(2192),
    [anon_sym_instance] = ACTIONS(2192),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LTtemplate_GT] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
    [anon_sym_component] = ACTIONS(2192),
    [anon_sym_instance] = ACTIONS(2192),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LTtemplate_GT] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2194),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2194),
    [anon_sym_DQUOTE] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2194),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [anon_sym_component] = ACTIONS(2196),
    [anon_sym_instance] = ACTIONS(2196),
  },
  [575] = {
    [sym_type_arguments] = STATE(707),
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_typeof] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_QMARK_DOT] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_GT_GT_GT] = ACTIONS(2200),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_STAR_STAR] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2200),
    [anon_sym_EQ_EQ] = ACTIONS(2198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2198),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2200),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_QMARK_QMARK] = ACTIONS(2200),
    [anon_sym_instanceof] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2198),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [sym_number] = ACTIONS(2200),
    [sym_this] = ACTIONS(2198),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [sym_null] = ACTIONS(2198),
    [sym_undefined] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(2198),
    [anon_sym_get] = ACTIONS(2198),
    [anon_sym_set] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2198),
    [anon_sym_any] = ACTIONS(2198),
    [anon_sym_number] = ACTIONS(2198),
    [anon_sym_boolean] = ACTIONS(2198),
    [anon_sym_string] = ACTIONS(2198),
    [anon_sym_symbol] = ACTIONS(2198),
    [anon_sym_abstract] = ACTIONS(2198),
    [anon_sym_satisfies] = ACTIONS(2198),
    [anon_sym_extends] = ACTIONS(2198),
    [anon_sym_infer] = ACTIONS(2198),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_keyof] = ACTIONS(2198),
    [anon_sym_unknown] = ACTIONS(2198),
    [anon_sym_never] = ACTIONS(2198),
    [anon_sym_object] = ACTIONS(2198),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2200),
    [anon_sym_constructor] = ACTIONS(2198),
    [anon_sym_prop] = ACTIONS(2198),
    [anon_sym_id] = ACTIONS(2198),
    [anon_sym_event] = ACTIONS(2198),
    [anon_sym_fn] = ACTIONS(2198),
    [anon_sym_on] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2200),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_export] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2210),
    [anon_sym_typeof] = ACTIONS(2210),
    [anon_sym_import] = ACTIONS(2210),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_LPAREN] = ACTIONS(2208),
    [anon_sym_await] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_with] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_debugger] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_yield] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_LTtemplate_GT] = ACTIONS(2208),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_SLASH] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_async] = ACTIONS(2210),
    [anon_sym_function] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2208),
    [anon_sym_void] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2208),
    [anon_sym_DASH_DASH] = ACTIONS(2208),
    [anon_sym_DQUOTE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2208),
    [sym_number] = ACTIONS(2208),
    [sym_this] = ACTIONS(2210),
    [sym_super] = ACTIONS(2210),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [sym_null] = ACTIONS(2210),
    [sym_undefined] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_readonly] = ACTIONS(2210),
    [anon_sym_get] = ACTIONS(2210),
    [anon_sym_set] = ACTIONS(2210),
    [anon_sym_declare] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_public] = ACTIONS(2210),
    [anon_sym_private] = ACTIONS(2210),
    [anon_sym_protected] = ACTIONS(2210),
    [anon_sym_override] = ACTIONS(2210),
    [anon_sym_module] = ACTIONS(2210),
    [anon_sym_any] = ACTIONS(2210),
    [anon_sym_number] = ACTIONS(2210),
    [anon_sym_boolean] = ACTIONS(2210),
    [anon_sym_string] = ACTIONS(2210),
    [anon_sym_symbol] = ACTIONS(2210),
    [anon_sym_abstract] = ACTIONS(2210),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_component] = ACTIONS(2210),
    [anon_sym_instance] = ACTIONS(2210),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2212),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_export] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2214),
    [anon_sym_import] = ACTIONS(2214),
    [anon_sym_var] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_with] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_debugger] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_yield] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_async] = ACTIONS(2214),
    [anon_sym_function] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_this] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [sym_null] = ACTIONS(2214),
    [sym_undefined] = ACTIONS(2214),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_readonly] = ACTIONS(2214),
    [anon_sym_get] = ACTIONS(2214),
    [anon_sym_set] = ACTIONS(2214),
    [anon_sym_declare] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_public] = ACTIONS(2214),
    [anon_sym_private] = ACTIONS(2214),
    [anon_sym_protected] = ACTIONS(2214),
    [anon_sym_override] = ACTIONS(2214),
    [anon_sym_module] = ACTIONS(2214),
    [anon_sym_any] = ACTIONS(2214),
    [anon_sym_number] = ACTIONS(2214),
    [anon_sym_boolean] = ACTIONS(2214),
    [anon_sym_string] = ACTIONS(2214),
    [anon_sym_symbol] = ACTIONS(2214),
    [anon_sym_abstract] = ACTIONS(2214),
    [anon_sym_interface] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_component] = ACTIONS(2214),
    [anon_sym_instance] = ACTIONS(2214),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2218),
    [anon_sym_export] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2218),
    [anon_sym_typeof] = ACTIONS(2218),
    [anon_sym_import] = ACTIONS(2218),
    [anon_sym_var] = ACTIONS(2218),
    [anon_sym_let] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_await] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_with] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_debugger] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym_case] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_yield] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_LTtemplate_GT] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_SLASH] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_async] = ACTIONS(2218),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_void] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2216),
    [sym_number] = ACTIONS(2216),
    [sym_this] = ACTIONS(2218),
    [sym_super] = ACTIONS(2218),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [sym_null] = ACTIONS(2218),
    [sym_undefined] = ACTIONS(2218),
    [anon_sym_AT] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_readonly] = ACTIONS(2218),
    [anon_sym_get] = ACTIONS(2218),
    [anon_sym_set] = ACTIONS(2218),
    [anon_sym_declare] = ACTIONS(2218),
    [anon_sym_namespace] = ACTIONS(2218),
    [anon_sym_public] = ACTIONS(2218),
    [anon_sym_private] = ACTIONS(2218),
    [anon_sym_protected] = ACTIONS(2218),
    [anon_sym_override] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(2218),
    [anon_sym_any] = ACTIONS(2218),
    [anon_sym_number] = ACTIONS(2218),
    [anon_sym_boolean] = ACTIONS(2218),
    [anon_sym_string] = ACTIONS(2218),
    [anon_sym_symbol] = ACTIONS(2218),
    [anon_sym_abstract] = ACTIONS(2218),
    [anon_sym_interface] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_component] = ACTIONS(2218),
    [anon_sym_instance] = ACTIONS(2218),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(2220),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_export] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2222),
    [anon_sym_typeof] = ACTIONS(2222),
    [anon_sym_import] = ACTIONS(2222),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2220),
    [anon_sym_await] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_with] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_debugger] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_yield] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_LTtemplate_GT] = ACTIONS(2220),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_async] = ACTIONS(2222),
    [anon_sym_function] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2220),
    [sym_number] = ACTIONS(2220),
    [sym_this] = ACTIONS(2222),
    [sym_super] = ACTIONS(2222),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [sym_null] = ACTIONS(2222),
    [sym_undefined] = ACTIONS(2222),
    [anon_sym_AT] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_readonly] = ACTIONS(2222),
    [anon_sym_get] = ACTIONS(2222),
    [anon_sym_set] = ACTIONS(2222),
    [anon_sym_declare] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(2222),
    [anon_sym_private] = ACTIONS(2222),
    [anon_sym_protected] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_module] = ACTIONS(2222),
    [anon_sym_any] = ACTIONS(2222),
    [anon_sym_number] = ACTIONS(2222),
    [anon_sym_boolean] = ACTIONS(2222),
    [anon_sym_string] = ACTIONS(2222),
    [anon_sym_symbol] = ACTIONS(2222),
    [anon_sym_abstract] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_component] = ACTIONS(2222),
    [anon_sym_instance] = ACTIONS(2222),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2224),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_LTtemplate_GT] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2224),
    [sym_number] = ACTIONS(2224),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_component] = ACTIONS(2226),
    [anon_sym_instance] = ACTIONS(2226),
  },
  [581] = {
    [sym_optional_chain] = STATE(3378),
    [sym_arguments] = STATE(921),
    [sym_type_arguments] = STATE(879),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_typeof] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_GT_GT_GT] = ACTIONS(2230),
    [anon_sym_LT_LT] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_STAR_STAR] = ACTIONS(2230),
    [anon_sym_LT_EQ] = ACTIONS(2230),
    [anon_sym_EQ_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2230),
    [anon_sym_GT_EQ] = ACTIONS(2230),
    [anon_sym_QMARK_QMARK] = ACTIONS(2230),
    [anon_sym_instanceof] = ACTIONS(2228),
    [anon_sym_void] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2230),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2228),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_readonly] = ACTIONS(2228),
    [anon_sym_get] = ACTIONS(2228),
    [anon_sym_set] = ACTIONS(2228),
    [anon_sym_QMARK] = ACTIONS(2228),
    [anon_sym_any] = ACTIONS(2228),
    [anon_sym_number] = ACTIONS(2228),
    [anon_sym_boolean] = ACTIONS(2228),
    [anon_sym_string] = ACTIONS(2228),
    [anon_sym_symbol] = ACTIONS(2228),
    [anon_sym_abstract] = ACTIONS(2228),
    [anon_sym_satisfies] = ACTIONS(2228),
    [anon_sym_infer] = ACTIONS(2228),
    [anon_sym_keyof] = ACTIONS(2228),
    [anon_sym_unknown] = ACTIONS(2228),
    [anon_sym_never] = ACTIONS(2228),
    [anon_sym_object] = ACTIONS(2228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2230),
    [anon_sym_constructor] = ACTIONS(2228),
    [anon_sym_prop] = ACTIONS(2228),
    [anon_sym_id] = ACTIONS(2228),
    [anon_sym_event] = ACTIONS(2228),
    [anon_sym_fn] = ACTIONS(2228),
    [anon_sym_on] = ACTIONS(2228),
    [sym__ternary_qmark] = ACTIONS(2230),
  },
  [582] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(42),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(2240),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2240),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_LTtemplate_GT] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2240),
    [sym_number] = ACTIONS(2240),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_component] = ACTIONS(2242),
    [anon_sym_instance] = ACTIONS(2242),
  },
  [584] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(2137),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_RBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2157),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_as] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_typeof] = ACTIONS(2157),
    [anon_sym_import] = ACTIONS(2157),
    [anon_sym_var] = ACTIONS(2157),
    [anon_sym_let] = ACTIONS(2157),
    [anon_sym_const] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2157),
    [anon_sym_if] = ACTIONS(2157),
    [anon_sym_switch] = ACTIONS(2157),
    [anon_sym_for] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_await] = ACTIONS(2157),
    [anon_sym_while] = ACTIONS(2157),
    [anon_sym_do] = ACTIONS(2157),
    [anon_sym_try] = ACTIONS(2157),
    [anon_sym_with] = ACTIONS(2157),
    [anon_sym_break] = ACTIONS(2157),
    [anon_sym_continue] = ACTIONS(2157),
    [anon_sym_debugger] = ACTIONS(2157),
    [anon_sym_return] = ACTIONS(2157),
    [anon_sym_throw] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2157),
    [anon_sym_default] = ACTIONS(2157),
    [anon_sym_yield] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_LTtemplate_GT] = ACTIONS(2159),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2157),
    [anon_sym_DOT] = ACTIONS(2157),
    [anon_sym_class] = ACTIONS(2157),
    [anon_sym_async] = ACTIONS(2157),
    [anon_sym_function] = ACTIONS(2157),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2157),
    [anon_sym_delete] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2159),
    [anon_sym_DQUOTE] = ACTIONS(2159),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_number] = ACTIONS(2159),
    [sym_this] = ACTIONS(2157),
    [sym_super] = ACTIONS(2157),
    [sym_true] = ACTIONS(2157),
    [sym_false] = ACTIONS(2157),
    [sym_null] = ACTIONS(2157),
    [sym_undefined] = ACTIONS(2157),
    [anon_sym_AT] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_override] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_interface] = ACTIONS(2157),
    [anon_sym_enum] = ACTIONS(2157),
    [anon_sym_component] = ACTIONS(2157),
  },
  [586] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_catch] = ACTIONS(1345),
    [anon_sym_finally] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
  },
  [587] = {
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_await] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_try] = ACTIONS(1359),
    [anon_sym_with] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_debugger] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_throw] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1359),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_catch] = ACTIONS(1359),
    [anon_sym_finally] = ACTIONS(1359),
    [anon_sym_yield] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_LTtemplate_GT] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_class] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1359),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_number] = ACTIONS(1361),
    [sym_this] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_readonly] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_declare] = ACTIONS(1359),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_public] = ACTIONS(1359),
    [anon_sym_private] = ACTIONS(1359),
    [anon_sym_protected] = ACTIONS(1359),
    [anon_sym_override] = ACTIONS(1359),
    [anon_sym_module] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_interface] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_component] = ACTIONS(1359),
  },
  [588] = {
    [sym_import_as] = STATE(583),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_export] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_typeof] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2248),
    [anon_sym_await] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_with] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_debugger] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_LTtemplate_GT] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_void] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2248),
    [sym_number] = ACTIONS(2248),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_readonly] = ACTIONS(2244),
    [anon_sym_get] = ACTIONS(2244),
    [anon_sym_set] = ACTIONS(2244),
    [anon_sym_declare] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_public] = ACTIONS(2244),
    [anon_sym_private] = ACTIONS(2244),
    [anon_sym_protected] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_module] = ACTIONS(2244),
    [anon_sym_any] = ACTIONS(2244),
    [anon_sym_number] = ACTIONS(2244),
    [anon_sym_boolean] = ACTIONS(2244),
    [anon_sym_string] = ACTIONS(2244),
    [anon_sym_symbol] = ACTIONS(2244),
    [anon_sym_abstract] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_component] = ACTIONS(2244),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_export] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_debugger] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_declare] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_module] = ACTIONS(2252),
    [anon_sym_any] = ACTIONS(2252),
    [anon_sym_number] = ACTIONS(2252),
    [anon_sym_boolean] = ACTIONS(2252),
    [anon_sym_string] = ACTIONS(2252),
    [anon_sym_symbol] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_component] = ACTIONS(2252),
    [anon_sym_instance] = ACTIONS(2252),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LTtemplate_GT] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_component] = ACTIONS(2256),
    [anon_sym_instance] = ACTIONS(2256),
  },
  [591] = {
    [sym_import_path_segment] = STATE(566),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_export] = ACTIONS(2261),
    [anon_sym_as] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_type] = ACTIONS(2261),
    [anon_sym_typeof] = ACTIONS(2261),
    [anon_sym_import] = ACTIONS(2261),
    [anon_sym_var] = ACTIONS(2261),
    [anon_sym_let] = ACTIONS(2261),
    [anon_sym_const] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2263),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_switch] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(2261),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_await] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_try] = ACTIONS(2261),
    [anon_sym_with] = ACTIONS(2261),
    [anon_sym_break] = ACTIONS(2261),
    [anon_sym_continue] = ACTIONS(2261),
    [anon_sym_debugger] = ACTIONS(2261),
    [anon_sym_return] = ACTIONS(2261),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_case] = ACTIONS(2261),
    [anon_sym_default] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_LTtemplate_GT] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_class] = ACTIONS(2261),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_function] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2263),
    [anon_sym_void] = ACTIONS(2261),
    [anon_sym_delete] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2263),
    [anon_sym_DASH_DASH] = ACTIONS(2263),
    [anon_sym_DQUOTE] = ACTIONS(2263),
    [anon_sym_SQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_number] = ACTIONS(2263),
    [sym_this] = ACTIONS(2261),
    [sym_super] = ACTIONS(2261),
    [sym_true] = ACTIONS(2261),
    [sym_false] = ACTIONS(2261),
    [sym_null] = ACTIONS(2261),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2263),
    [anon_sym_static] = ACTIONS(2261),
    [anon_sym_readonly] = ACTIONS(2261),
    [anon_sym_get] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(2261),
    [anon_sym_declare] = ACTIONS(2261),
    [anon_sym_namespace] = ACTIONS(2261),
    [anon_sym_public] = ACTIONS(2261),
    [anon_sym_private] = ACTIONS(2261),
    [anon_sym_protected] = ACTIONS(2261),
    [anon_sym_override] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(2261),
    [anon_sym_any] = ACTIONS(2261),
    [anon_sym_number] = ACTIONS(2261),
    [anon_sym_boolean] = ACTIONS(2261),
    [anon_sym_string] = ACTIONS(2261),
    [anon_sym_symbol] = ACTIONS(2261),
    [anon_sym_abstract] = ACTIONS(2261),
    [anon_sym_interface] = ACTIONS(2261),
    [anon_sym_enum] = ACTIONS(2261),
    [anon_sym_component] = ACTIONS(2261),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2265),
    [sym_identifier] = ACTIONS(2267),
    [anon_sym_export] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_type] = ACTIONS(2267),
    [anon_sym_typeof] = ACTIONS(2267),
    [anon_sym_import] = ACTIONS(2267),
    [anon_sym_var] = ACTIONS(2267),
    [anon_sym_let] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_LPAREN] = ACTIONS(2265),
    [anon_sym_await] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_with] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_debugger] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_yield] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2265),
    [anon_sym_LTtemplate_GT] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_async] = ACTIONS(2267),
    [anon_sym_function] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2265),
    [anon_sym_void] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2265),
    [anon_sym_SQUOTE] = ACTIONS(2265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [sym_number] = ACTIONS(2265),
    [sym_this] = ACTIONS(2267),
    [sym_super] = ACTIONS(2267),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [sym_null] = ACTIONS(2267),
    [sym_undefined] = ACTIONS(2267),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_readonly] = ACTIONS(2267),
    [anon_sym_get] = ACTIONS(2267),
    [anon_sym_set] = ACTIONS(2267),
    [anon_sym_declare] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_override] = ACTIONS(2267),
    [anon_sym_module] = ACTIONS(2267),
    [anon_sym_any] = ACTIONS(2267),
    [anon_sym_number] = ACTIONS(2267),
    [anon_sym_boolean] = ACTIONS(2267),
    [anon_sym_string] = ACTIONS(2267),
    [anon_sym_symbol] = ACTIONS(2267),
    [anon_sym_abstract] = ACTIONS(2267),
    [anon_sym_interface] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_component] = ACTIONS(2267),
    [anon_sym_instance] = ACTIONS(2267),
  },
  [593] = {
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_type] = ACTIONS(1291),
    [anon_sym_typeof] = ACTIONS(1291),
    [anon_sym_import] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_let] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_try] = ACTIONS(1291),
    [anon_sym_with] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1291),
    [anon_sym_continue] = ACTIONS(1291),
    [anon_sym_debugger] = ACTIONS(1291),
    [anon_sym_return] = ACTIONS(1291),
    [anon_sym_throw] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1291),
    [anon_sym_default] = ACTIONS(1291),
    [anon_sym_yield] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1295),
    [anon_sym_LTtemplate_GT] = ACTIONS(1295),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_class] = ACTIONS(1291),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1291),
    [anon_sym_new] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_void] = ACTIONS(1291),
    [anon_sym_delete] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1295),
    [sym_number] = ACTIONS(1295),
    [sym_this] = ACTIONS(1291),
    [sym_super] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_null] = ACTIONS(1291),
    [sym_undefined] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1295),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_readonly] = ACTIONS(1291),
    [anon_sym_get] = ACTIONS(1291),
    [anon_sym_set] = ACTIONS(1291),
    [anon_sym_declare] = ACTIONS(1291),
    [anon_sym_namespace] = ACTIONS(1291),
    [anon_sym_public] = ACTIONS(1291),
    [anon_sym_private] = ACTIONS(1291),
    [anon_sym_protected] = ACTIONS(1291),
    [anon_sym_override] = ACTIONS(1291),
    [anon_sym_module] = ACTIONS(1291),
    [anon_sym_any] = ACTIONS(1291),
    [anon_sym_number] = ACTIONS(1291),
    [anon_sym_boolean] = ACTIONS(1291),
    [anon_sym_string] = ACTIONS(1291),
    [anon_sym_symbol] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(1291),
    [anon_sym_interface] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [anon_sym_component] = ACTIONS(1291),
    [sym__automatic_semicolon] = ACTIONS(1299),
  },
  [594] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_typeof] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2269),
    [anon_sym_QMARK_DOT] = ACTIONS(2271),
    [anon_sym_new] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_GT_GT_GT] = ACTIONS(2271),
    [anon_sym_LT_LT] = ACTIONS(2271),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2271),
    [anon_sym_STAR_STAR] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2271),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2271),
    [anon_sym_GT_EQ] = ACTIONS(2271),
    [anon_sym_QMARK_QMARK] = ACTIONS(2271),
    [anon_sym_instanceof] = ACTIONS(2269),
    [anon_sym_void] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2271),
    [anon_sym_DQUOTE] = ACTIONS(2271),
    [anon_sym_SQUOTE] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [sym_number] = ACTIONS(2271),
    [sym_this] = ACTIONS(2269),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_null] = ACTIONS(2269),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_static] = ACTIONS(2269),
    [anon_sym_readonly] = ACTIONS(2269),
    [anon_sym_get] = ACTIONS(2269),
    [anon_sym_set] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_any] = ACTIONS(2269),
    [anon_sym_number] = ACTIONS(2269),
    [anon_sym_boolean] = ACTIONS(2269),
    [anon_sym_string] = ACTIONS(2269),
    [anon_sym_symbol] = ACTIONS(2269),
    [anon_sym_abstract] = ACTIONS(2269),
    [anon_sym_satisfies] = ACTIONS(2269),
    [anon_sym_infer] = ACTIONS(2269),
    [anon_sym_keyof] = ACTIONS(2269),
    [anon_sym_unknown] = ACTIONS(2269),
    [anon_sym_never] = ACTIONS(2269),
    [anon_sym_object] = ACTIONS(2269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2271),
    [anon_sym_constructor] = ACTIONS(2269),
    [anon_sym_prop] = ACTIONS(2269),
    [anon_sym_id] = ACTIONS(2269),
    [anon_sym_event] = ACTIONS(2269),
    [anon_sym_fn] = ACTIONS(2269),
    [anon_sym_on] = ACTIONS(2269),
    [sym__ternary_qmark] = ACTIONS(2271),
  },
  [595] = {
    [sym_identifier] = ACTIONS(1437),
    [anon_sym_export] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_type] = ACTIONS(1437),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(1437),
    [anon_sym_var] = ACTIONS(1437),
    [anon_sym_let] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_await] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_try] = ACTIONS(1437),
    [anon_sym_with] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_debugger] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_yield] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_LTtemplate_GT] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1437),
    [anon_sym_class] = ACTIONS(1437),
    [anon_sym_async] = ACTIONS(1437),
    [anon_sym_function] = ACTIONS(1437),
    [anon_sym_new] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1441),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1441),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1437),
    [sym_super] = ACTIONS(1437),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [sym_null] = ACTIONS(1437),
    [sym_undefined] = ACTIONS(1437),
    [anon_sym_AT] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1437),
    [anon_sym_namespace] = ACTIONS(1437),
    [anon_sym_public] = ACTIONS(1437),
    [anon_sym_private] = ACTIONS(1437),
    [anon_sym_protected] = ACTIONS(1437),
    [anon_sym_override] = ACTIONS(1437),
    [anon_sym_module] = ACTIONS(1437),
    [anon_sym_any] = ACTIONS(1437),
    [anon_sym_number] = ACTIONS(1437),
    [anon_sym_boolean] = ACTIONS(1437),
    [anon_sym_string] = ACTIONS(1437),
    [anon_sym_symbol] = ACTIONS(1437),
    [anon_sym_abstract] = ACTIONS(1437),
    [anon_sym_interface] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_component] = ACTIONS(1437),
    [sym__automatic_semicolon] = ACTIONS(1445),
  },
  [596] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_typeof] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2273),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_number] = ACTIONS(2279),
    [sym_this] = ACTIONS(2273),
    [sym_true] = ACTIONS(2273),
    [sym_false] = ACTIONS(2273),
    [sym_null] = ACTIONS(2273),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(2273),
    [anon_sym_readonly] = ACTIONS(2273),
    [anon_sym_get] = ACTIONS(2273),
    [anon_sym_set] = ACTIONS(2273),
    [anon_sym_QMARK] = ACTIONS(2273),
    [anon_sym_any] = ACTIONS(2273),
    [anon_sym_number] = ACTIONS(2273),
    [anon_sym_boolean] = ACTIONS(2273),
    [anon_sym_string] = ACTIONS(2273),
    [anon_sym_symbol] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2273),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2273),
    [anon_sym_keyof] = ACTIONS(2273),
    [anon_sym_unknown] = ACTIONS(2273),
    [anon_sym_never] = ACTIONS(2273),
    [anon_sym_object] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2279),
    [anon_sym_constructor] = ACTIONS(2273),
    [anon_sym_prop] = ACTIONS(2273),
    [anon_sym_id] = ACTIONS(2273),
    [anon_sym_event] = ACTIONS(2273),
    [anon_sym_fn] = ACTIONS(2273),
    [anon_sym_on] = ACTIONS(2273),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [597] = {
    [sym_arguments] = STATE(748),
    [sym_identifier] = ACTIONS(2319),
    [anon_sym_STAR] = ACTIONS(2319),
    [anon_sym_as] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2321),
    [anon_sym_typeof] = ACTIONS(2319),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2319),
    [anon_sym_SEMI] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2319),
    [anon_sym_GT] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(2319),
    [anon_sym_DOT] = ACTIONS(2323),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_QMARK_DOT] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_GT_GT] = ACTIONS(2319),
    [anon_sym_GT_GT_GT] = ACTIONS(2321),
    [anon_sym_LT_LT] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_CARET] = ACTIONS(2321),
    [anon_sym_PIPE] = ACTIONS(2319),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_STAR_STAR] = ACTIONS(2321),
    [anon_sym_LT_EQ] = ACTIONS(2321),
    [anon_sym_EQ_EQ] = ACTIONS(2319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2319),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2321),
    [anon_sym_GT_EQ] = ACTIONS(2321),
    [anon_sym_QMARK_QMARK] = ACTIONS(2321),
    [anon_sym_instanceof] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2319),
    [anon_sym_PLUS_PLUS] = ACTIONS(2321),
    [anon_sym_DASH_DASH] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2321),
    [sym_number] = ACTIONS(2321),
    [sym_this] = ACTIONS(2319),
    [sym_true] = ACTIONS(2319),
    [sym_false] = ACTIONS(2319),
    [sym_null] = ACTIONS(2319),
    [sym_undefined] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2319),
    [anon_sym_readonly] = ACTIONS(2319),
    [anon_sym_get] = ACTIONS(2319),
    [anon_sym_set] = ACTIONS(2319),
    [anon_sym_QMARK] = ACTIONS(2319),
    [anon_sym_any] = ACTIONS(2319),
    [anon_sym_number] = ACTIONS(2319),
    [anon_sym_boolean] = ACTIONS(2319),
    [anon_sym_string] = ACTIONS(2319),
    [anon_sym_symbol] = ACTIONS(2319),
    [anon_sym_abstract] = ACTIONS(2319),
    [anon_sym_satisfies] = ACTIONS(2319),
    [anon_sym_extends] = ACTIONS(2319),
    [anon_sym_infer] = ACTIONS(2319),
    [anon_sym_keyof] = ACTIONS(2319),
    [anon_sym_unknown] = ACTIONS(2319),
    [anon_sym_never] = ACTIONS(2319),
    [anon_sym_object] = ACTIONS(2319),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2321),
    [anon_sym_constructor] = ACTIONS(2319),
    [anon_sym_prop] = ACTIONS(2319),
    [anon_sym_id] = ACTIONS(2319),
    [anon_sym_event] = ACTIONS(2319),
    [anon_sym_fn] = ACTIONS(2319),
    [anon_sym_on] = ACTIONS(2319),
    [sym__ternary_qmark] = ACTIONS(2321),
  },
  [598] = {
    [sym_type_arguments] = STATE(718),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(2325),
    [anon_sym_RBRACE] = ACTIONS(2327),
    [anon_sym_typeof] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_in] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2327),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2325),
    [anon_sym_SLASH] = ACTIONS(2325),
    [anon_sym_DOT] = ACTIONS(2325),
    [anon_sym_async] = ACTIONS(2325),
    [anon_sym_QMARK_DOT] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2325),
    [anon_sym_AMP_AMP] = ACTIONS(2327),
    [anon_sym_PIPE_PIPE] = ACTIONS(2327),
    [anon_sym_GT_GT] = ACTIONS(2325),
    [anon_sym_GT_GT_GT] = ACTIONS(2327),
    [anon_sym_LT_LT] = ACTIONS(2327),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_CARET] = ACTIONS(2327),
    [anon_sym_PIPE] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2325),
    [anon_sym_PERCENT] = ACTIONS(2327),
    [anon_sym_STAR_STAR] = ACTIONS(2327),
    [anon_sym_LT_EQ] = ACTIONS(2327),
    [anon_sym_EQ_EQ] = ACTIONS(2325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2327),
    [anon_sym_BANG_EQ] = ACTIONS(2325),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2327),
    [anon_sym_GT_EQ] = ACTIONS(2327),
    [anon_sym_QMARK_QMARK] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2325),
    [anon_sym_void] = ACTIONS(2325),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2327),
    [anon_sym_SQUOTE] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [sym_number] = ACTIONS(2327),
    [sym_this] = ACTIONS(2325),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [sym_null] = ACTIONS(2325),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_static] = ACTIONS(2325),
    [anon_sym_readonly] = ACTIONS(2325),
    [anon_sym_get] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(2325),
    [anon_sym_QMARK] = ACTIONS(2325),
    [anon_sym_any] = ACTIONS(2325),
    [anon_sym_number] = ACTIONS(2325),
    [anon_sym_boolean] = ACTIONS(2325),
    [anon_sym_string] = ACTIONS(2325),
    [anon_sym_symbol] = ACTIONS(2325),
    [anon_sym_abstract] = ACTIONS(2325),
    [anon_sym_satisfies] = ACTIONS(2325),
    [anon_sym_extends] = ACTIONS(2325),
    [anon_sym_infer] = ACTIONS(2325),
    [anon_sym_keyof] = ACTIONS(2325),
    [anon_sym_unknown] = ACTIONS(2325),
    [anon_sym_never] = ACTIONS(2325),
    [anon_sym_object] = ACTIONS(2325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2327),
    [anon_sym_constructor] = ACTIONS(2325),
    [anon_sym_prop] = ACTIONS(2325),
    [anon_sym_id] = ACTIONS(2325),
    [anon_sym_event] = ACTIONS(2325),
    [anon_sym_fn] = ACTIONS(2325),
    [anon_sym_on] = ACTIONS(2325),
    [sym__ternary_qmark] = ACTIONS(2327),
  },
  [599] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_get] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(2329),
    [anon_sym_QMARK] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2329),
    [anon_sym_keyof] = ACTIONS(2329),
    [anon_sym_unknown] = ACTIONS(2329),
    [anon_sym_never] = ACTIONS(2329),
    [anon_sym_object] = ACTIONS(2329),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2331),
    [anon_sym_constructor] = ACTIONS(2329),
    [anon_sym_prop] = ACTIONS(2329),
    [anon_sym_id] = ACTIONS(2329),
    [anon_sym_event] = ACTIONS(2329),
    [anon_sym_fn] = ACTIONS(2329),
    [anon_sym_on] = ACTIONS(2329),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2333),
    [anon_sym_typeof] = ACTIONS(2333),
    [anon_sym_import] = ACTIONS(2333),
    [anon_sym_var] = ACTIONS(2333),
    [anon_sym_let] = ACTIONS(2333),
    [anon_sym_const] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_else] = ACTIONS(2333),
    [anon_sym_if] = ACTIONS(2333),
    [anon_sym_switch] = ACTIONS(2333),
    [anon_sym_for] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_await] = ACTIONS(2333),
    [anon_sym_while] = ACTIONS(2333),
    [anon_sym_do] = ACTIONS(2333),
    [anon_sym_try] = ACTIONS(2333),
    [anon_sym_with] = ACTIONS(2333),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_continue] = ACTIONS(2333),
    [anon_sym_debugger] = ACTIONS(2333),
    [anon_sym_return] = ACTIONS(2333),
    [anon_sym_throw] = ACTIONS(2333),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_case] = ACTIONS(2333),
    [anon_sym_default] = ACTIONS(2333),
    [anon_sym_finally] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2335),
    [anon_sym_LTtemplate_GT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2333),
    [anon_sym_SLASH] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2333),
    [anon_sym_async] = ACTIONS(2333),
    [anon_sym_function] = ACTIONS(2333),
    [anon_sym_new] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_void] = ACTIONS(2333),
    [anon_sym_delete] = ACTIONS(2333),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2335),
    [sym_number] = ACTIONS(2335),
    [sym_this] = ACTIONS(2333),
    [sym_super] = ACTIONS(2333),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_null] = ACTIONS(2333),
    [sym_undefined] = ACTIONS(2333),
    [anon_sym_AT] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2333),
    [anon_sym_readonly] = ACTIONS(2333),
    [anon_sym_get] = ACTIONS(2333),
    [anon_sym_set] = ACTIONS(2333),
    [anon_sym_declare] = ACTIONS(2333),
    [anon_sym_namespace] = ACTIONS(2333),
    [anon_sym_public] = ACTIONS(2333),
    [anon_sym_private] = ACTIONS(2333),
    [anon_sym_protected] = ACTIONS(2333),
    [anon_sym_override] = ACTIONS(2333),
    [anon_sym_module] = ACTIONS(2333),
    [anon_sym_any] = ACTIONS(2333),
    [anon_sym_number] = ACTIONS(2333),
    [anon_sym_boolean] = ACTIONS(2333),
    [anon_sym_string] = ACTIONS(2333),
    [anon_sym_symbol] = ACTIONS(2333),
    [anon_sym_abstract] = ACTIONS(2333),
    [anon_sym_interface] = ACTIONS(2333),
    [anon_sym_enum] = ACTIONS(2333),
    [anon_sym_component] = ACTIONS(2333),
  },
  [601] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [602] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [603] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(2339),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [604] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [605] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [606] = {
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_as] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_typeof] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_QMARK_DOT] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_AMP_AMP] = ACTIONS(1142),
    [anon_sym_PIPE_PIPE] = ACTIONS(1142),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_GT_GT_GT] = ACTIONS(1142),
    [anon_sym_LT_LT] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_CARET] = ACTIONS(1142),
    [anon_sym_PIPE] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1142),
    [anon_sym_STAR_STAR] = ACTIONS(1142),
    [anon_sym_LT_EQ] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1142),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1142),
    [anon_sym_GT_EQ] = ACTIONS(1142),
    [anon_sym_QMARK_QMARK] = ACTIONS(1142),
    [anon_sym_instanceof] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [sym_number] = ACTIONS(1142),
    [sym_this] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_null] = ACTIONS(1144),
    [sym_undefined] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_readonly] = ACTIONS(1144),
    [anon_sym_get] = ACTIONS(1144),
    [anon_sym_set] = ACTIONS(1144),
    [anon_sym_QMARK] = ACTIONS(1144),
    [anon_sym_any] = ACTIONS(1144),
    [anon_sym_number] = ACTIONS(1144),
    [anon_sym_boolean] = ACTIONS(1144),
    [anon_sym_string] = ACTIONS(1144),
    [anon_sym_symbol] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_satisfies] = ACTIONS(1144),
    [anon_sym_extends] = ACTIONS(1144),
    [anon_sym_infer] = ACTIONS(1144),
    [anon_sym_is] = ACTIONS(1144),
    [anon_sym_keyof] = ACTIONS(1144),
    [anon_sym_unknown] = ACTIONS(1144),
    [anon_sym_never] = ACTIONS(1144),
    [anon_sym_object] = ACTIONS(1144),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1142),
    [anon_sym_constructor] = ACTIONS(1144),
    [anon_sym_prop] = ACTIONS(1144),
    [anon_sym_id] = ACTIONS(1144),
    [anon_sym_event] = ACTIONS(1144),
    [anon_sym_fn] = ACTIONS(1144),
    [anon_sym_on] = ACTIONS(1144),
    [sym__ternary_qmark] = ACTIONS(1142),
  },
  [607] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_typeof] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [sym_number] = ACTIONS(2343),
    [sym_this] = ACTIONS(2341),
    [sym_true] = ACTIONS(2341),
    [sym_false] = ACTIONS(2341),
    [sym_null] = ACTIONS(2341),
    [sym_undefined] = ACTIONS(2341),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_abstract] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2341),
    [anon_sym_keyof] = ACTIONS(2341),
    [anon_sym_unknown] = ACTIONS(2341),
    [anon_sym_never] = ACTIONS(2341),
    [anon_sym_object] = ACTIONS(2341),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2343),
    [anon_sym_constructor] = ACTIONS(2341),
    [anon_sym_prop] = ACTIONS(2341),
    [anon_sym_id] = ACTIONS(2341),
    [anon_sym_event] = ACTIONS(2341),
    [anon_sym_fn] = ACTIONS(2341),
    [anon_sym_on] = ACTIONS(2341),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [608] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [609] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [610] = {
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_export] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_type] = ACTIONS(1349),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(1349),
    [anon_sym_var] = ACTIONS(1349),
    [anon_sym_let] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_await] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_try] = ACTIONS(1349),
    [anon_sym_with] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_debugger] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_throw] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_LTtemplate_GT] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1349),
    [anon_sym_new] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1353),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1349),
    [sym_super] = ACTIONS(1349),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [sym_null] = ACTIONS(1349),
    [sym_undefined] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_get] = ACTIONS(1349),
    [anon_sym_set] = ACTIONS(1349),
    [anon_sym_declare] = ACTIONS(1349),
    [anon_sym_namespace] = ACTIONS(1349),
    [anon_sym_public] = ACTIONS(1349),
    [anon_sym_private] = ACTIONS(1349),
    [anon_sym_protected] = ACTIONS(1349),
    [anon_sym_override] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_any] = ACTIONS(1349),
    [anon_sym_number] = ACTIONS(1349),
    [anon_sym_boolean] = ACTIONS(1349),
    [anon_sym_string] = ACTIONS(1349),
    [anon_sym_symbol] = ACTIONS(1349),
    [anon_sym_abstract] = ACTIONS(1349),
    [anon_sym_interface] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_component] = ACTIONS(1349),
    [sym__automatic_semicolon] = ACTIONS(1357),
  },
  [611] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [612] = {
    [sym_identifier] = ACTIONS(1455),
    [anon_sym_export] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_type] = ACTIONS(1455),
    [anon_sym_typeof] = ACTIONS(1455),
    [anon_sym_import] = ACTIONS(1455),
    [anon_sym_var] = ACTIONS(1455),
    [anon_sym_let] = ACTIONS(1455),
    [anon_sym_const] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1455),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_switch] = ACTIONS(1455),
    [anon_sym_for] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1455),
    [anon_sym_while] = ACTIONS(1455),
    [anon_sym_do] = ACTIONS(1455),
    [anon_sym_try] = ACTIONS(1455),
    [anon_sym_with] = ACTIONS(1455),
    [anon_sym_break] = ACTIONS(1455),
    [anon_sym_continue] = ACTIONS(1455),
    [anon_sym_debugger] = ACTIONS(1455),
    [anon_sym_return] = ACTIONS(1455),
    [anon_sym_throw] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1455),
    [anon_sym_default] = ACTIONS(1455),
    [anon_sym_yield] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(1455),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(1455),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1455),
    [anon_sym_delete] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(1455),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_undefined] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1455),
    [anon_sym_readonly] = ACTIONS(1455),
    [anon_sym_get] = ACTIONS(1455),
    [anon_sym_set] = ACTIONS(1455),
    [anon_sym_declare] = ACTIONS(1455),
    [anon_sym_namespace] = ACTIONS(1455),
    [anon_sym_public] = ACTIONS(1455),
    [anon_sym_private] = ACTIONS(1455),
    [anon_sym_protected] = ACTIONS(1455),
    [anon_sym_override] = ACTIONS(1455),
    [anon_sym_module] = ACTIONS(1455),
    [anon_sym_any] = ACTIONS(1455),
    [anon_sym_number] = ACTIONS(1455),
    [anon_sym_boolean] = ACTIONS(1455),
    [anon_sym_string] = ACTIONS(1455),
    [anon_sym_symbol] = ACTIONS(1455),
    [anon_sym_abstract] = ACTIONS(1455),
    [anon_sym_interface] = ACTIONS(1455),
    [anon_sym_enum] = ACTIONS(1455),
    [anon_sym_component] = ACTIONS(1455),
    [sym__automatic_semicolon] = ACTIONS(1463),
  },
  [613] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1331),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_RBRACE] = ACTIONS(1335),
    [anon_sym_type] = ACTIONS(1331),
    [anon_sym_typeof] = ACTIONS(1331),
    [anon_sym_import] = ACTIONS(1331),
    [anon_sym_var] = ACTIONS(1331),
    [anon_sym_let] = ACTIONS(1331),
    [anon_sym_const] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_else] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_switch] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [anon_sym_await] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_do] = ACTIONS(1331),
    [anon_sym_try] = ACTIONS(1331),
    [anon_sym_with] = ACTIONS(1331),
    [anon_sym_break] = ACTIONS(1331),
    [anon_sym_continue] = ACTIONS(1331),
    [anon_sym_debugger] = ACTIONS(1331),
    [anon_sym_return] = ACTIONS(1331),
    [anon_sym_throw] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_case] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1331),
    [anon_sym_class] = ACTIONS(1331),
    [anon_sym_async] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_new] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_delete] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [sym_number] = ACTIONS(1335),
    [sym_this] = ACTIONS(1331),
    [sym_super] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_undefined] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(1335),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_readonly] = ACTIONS(1331),
    [anon_sym_get] = ACTIONS(1331),
    [anon_sym_set] = ACTIONS(1331),
    [anon_sym_declare] = ACTIONS(1331),
    [anon_sym_namespace] = ACTIONS(1331),
    [anon_sym_public] = ACTIONS(1331),
    [anon_sym_private] = ACTIONS(1331),
    [anon_sym_protected] = ACTIONS(1331),
    [anon_sym_override] = ACTIONS(1331),
    [anon_sym_module] = ACTIONS(1331),
    [anon_sym_any] = ACTIONS(1331),
    [anon_sym_number] = ACTIONS(1331),
    [anon_sym_boolean] = ACTIONS(1331),
    [anon_sym_string] = ACTIONS(1331),
    [anon_sym_symbol] = ACTIONS(1331),
    [anon_sym_abstract] = ACTIONS(1331),
    [anon_sym_interface] = ACTIONS(1331),
    [anon_sym_enum] = ACTIONS(1331),
    [anon_sym_component] = ACTIONS(1331),
    [sym__automatic_semicolon] = ACTIONS(1339),
  },
  [614] = {
    [sym_type_arguments] = STATE(707),
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(2198),
    [anon_sym_as] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_typeof] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_DOT] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_QMARK_DOT] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_AMP_AMP] = ACTIONS(2200),
    [anon_sym_PIPE_PIPE] = ACTIONS(2200),
    [anon_sym_GT_GT] = ACTIONS(2198),
    [anon_sym_GT_GT_GT] = ACTIONS(2200),
    [anon_sym_LT_LT] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2198),
    [anon_sym_CARET] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_PERCENT] = ACTIONS(2200),
    [anon_sym_STAR_STAR] = ACTIONS(2200),
    [anon_sym_LT_EQ] = ACTIONS(2200),
    [anon_sym_EQ_EQ] = ACTIONS(2198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2200),
    [anon_sym_BANG_EQ] = ACTIONS(2198),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2200),
    [anon_sym_GT_EQ] = ACTIONS(2200),
    [anon_sym_QMARK_QMARK] = ACTIONS(2200),
    [anon_sym_instanceof] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2198),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [sym_number] = ACTIONS(2200),
    [sym_this] = ACTIONS(2198),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [sym_null] = ACTIONS(2198),
    [sym_undefined] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(2198),
    [anon_sym_get] = ACTIONS(2198),
    [anon_sym_set] = ACTIONS(2198),
    [anon_sym_QMARK] = ACTIONS(2198),
    [anon_sym_any] = ACTIONS(2198),
    [anon_sym_number] = ACTIONS(2198),
    [anon_sym_boolean] = ACTIONS(2198),
    [anon_sym_string] = ACTIONS(2198),
    [anon_sym_symbol] = ACTIONS(2198),
    [anon_sym_abstract] = ACTIONS(2198),
    [anon_sym_satisfies] = ACTIONS(2198),
    [anon_sym_extends] = ACTIONS(2198),
    [anon_sym_infer] = ACTIONS(2198),
    [anon_sym_keyof] = ACTIONS(2198),
    [anon_sym_unknown] = ACTIONS(2198),
    [anon_sym_never] = ACTIONS(2198),
    [anon_sym_object] = ACTIONS(2198),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2200),
    [anon_sym_constructor] = ACTIONS(2198),
    [anon_sym_prop] = ACTIONS(2198),
    [anon_sym_id] = ACTIONS(2198),
    [anon_sym_event] = ACTIONS(2198),
    [anon_sym_fn] = ACTIONS(2198),
    [anon_sym_on] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2200),
  },
  [615] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [616] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [617] = {
    [sym_arguments] = STATE(747),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_STAR] = ACTIONS(2345),
    [anon_sym_as] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2345),
    [anon_sym_BANG] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2345),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2349),
    [anon_sym_async] = ACTIONS(2345),
    [anon_sym_QMARK_DOT] = ACTIONS(2347),
    [anon_sym_new] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2345),
    [anon_sym_GT_GT_GT] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_DASH] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_QMARK_QMARK] = ACTIONS(2347),
    [anon_sym_instanceof] = ACTIONS(2345),
    [anon_sym_void] = ACTIONS(2345),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2347),
    [sym_number] = ACTIONS(2347),
    [sym_this] = ACTIONS(2345),
    [sym_true] = ACTIONS(2345),
    [sym_false] = ACTIONS(2345),
    [sym_null] = ACTIONS(2345),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_static] = ACTIONS(2345),
    [anon_sym_readonly] = ACTIONS(2345),
    [anon_sym_get] = ACTIONS(2345),
    [anon_sym_set] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2345),
    [anon_sym_number] = ACTIONS(2345),
    [anon_sym_boolean] = ACTIONS(2345),
    [anon_sym_string] = ACTIONS(2345),
    [anon_sym_symbol] = ACTIONS(2345),
    [anon_sym_abstract] = ACTIONS(2345),
    [anon_sym_satisfies] = ACTIONS(2345),
    [anon_sym_extends] = ACTIONS(2345),
    [anon_sym_infer] = ACTIONS(2345),
    [anon_sym_keyof] = ACTIONS(2345),
    [anon_sym_unknown] = ACTIONS(2345),
    [anon_sym_never] = ACTIONS(2345),
    [anon_sym_object] = ACTIONS(2345),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2347),
    [anon_sym_constructor] = ACTIONS(2345),
    [anon_sym_prop] = ACTIONS(2345),
    [anon_sym_id] = ACTIONS(2345),
    [anon_sym_event] = ACTIONS(2345),
    [anon_sym_fn] = ACTIONS(2345),
    [anon_sym_on] = ACTIONS(2345),
    [sym__ternary_qmark] = ACTIONS(2347),
  },
  [618] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LTtemplate_GT] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_override] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_component] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(2351),
  },
  [619] = {
    [sym_identifier] = ACTIONS(1417),
    [anon_sym_export] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1417),
    [anon_sym_typeof] = ACTIONS(1417),
    [anon_sym_import] = ACTIONS(1417),
    [anon_sym_var] = ACTIONS(1417),
    [anon_sym_let] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_await] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_try] = ACTIONS(1417),
    [anon_sym_with] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_debugger] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_throw] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_yield] = ACTIONS(1417),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_LTtemplate_GT] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1417),
    [anon_sym_SLASH] = ACTIONS(1417),
    [anon_sym_class] = ACTIONS(1417),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(1417),
    [anon_sym_new] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1417),
    [anon_sym_delete] = ACTIONS(1417),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1421),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [sym_number] = ACTIONS(1421),
    [sym_this] = ACTIONS(1417),
    [sym_super] = ACTIONS(1417),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [sym_null] = ACTIONS(1417),
    [sym_undefined] = ACTIONS(1417),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_get] = ACTIONS(1417),
    [anon_sym_set] = ACTIONS(1417),
    [anon_sym_declare] = ACTIONS(1417),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_public] = ACTIONS(1417),
    [anon_sym_private] = ACTIONS(1417),
    [anon_sym_protected] = ACTIONS(1417),
    [anon_sym_override] = ACTIONS(1417),
    [anon_sym_module] = ACTIONS(1417),
    [anon_sym_any] = ACTIONS(1417),
    [anon_sym_number] = ACTIONS(1417),
    [anon_sym_boolean] = ACTIONS(1417),
    [anon_sym_string] = ACTIONS(1417),
    [anon_sym_symbol] = ACTIONS(1417),
    [anon_sym_abstract] = ACTIONS(1417),
    [anon_sym_interface] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_component] = ACTIONS(1417),
    [sym__automatic_semicolon] = ACTIONS(1425),
  },
  [620] = {
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_type] = ACTIONS(1467),
    [anon_sym_typeof] = ACTIONS(1467),
    [anon_sym_import] = ACTIONS(1467),
    [anon_sym_var] = ACTIONS(1467),
    [anon_sym_let] = ACTIONS(1467),
    [anon_sym_const] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_else] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1467),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1467),
    [anon_sym_do] = ACTIONS(1467),
    [anon_sym_try] = ACTIONS(1467),
    [anon_sym_with] = ACTIONS(1467),
    [anon_sym_break] = ACTIONS(1467),
    [anon_sym_continue] = ACTIONS(1467),
    [anon_sym_debugger] = ACTIONS(1467),
    [anon_sym_return] = ACTIONS(1467),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1467),
    [anon_sym_default] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(1467),
    [anon_sym_class] = ACTIONS(1467),
    [anon_sym_async] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1467),
    [anon_sym_new] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_void] = ACTIONS(1467),
    [anon_sym_delete] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1467),
    [sym_super] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_null] = ACTIONS(1467),
    [sym_undefined] = ACTIONS(1467),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_static] = ACTIONS(1467),
    [anon_sym_readonly] = ACTIONS(1467),
    [anon_sym_get] = ACTIONS(1467),
    [anon_sym_set] = ACTIONS(1467),
    [anon_sym_declare] = ACTIONS(1467),
    [anon_sym_namespace] = ACTIONS(1467),
    [anon_sym_public] = ACTIONS(1467),
    [anon_sym_private] = ACTIONS(1467),
    [anon_sym_protected] = ACTIONS(1467),
    [anon_sym_override] = ACTIONS(1467),
    [anon_sym_module] = ACTIONS(1467),
    [anon_sym_any] = ACTIONS(1467),
    [anon_sym_number] = ACTIONS(1467),
    [anon_sym_boolean] = ACTIONS(1467),
    [anon_sym_string] = ACTIONS(1467),
    [anon_sym_symbol] = ACTIONS(1467),
    [anon_sym_abstract] = ACTIONS(1467),
    [anon_sym_interface] = ACTIONS(1467),
    [anon_sym_enum] = ACTIONS(1467),
    [anon_sym_component] = ACTIONS(1467),
    [sym__automatic_semicolon] = ACTIONS(1475),
  },
  [621] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_typeof] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2353),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2355),
    [anon_sym_SQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2353),
    [sym_true] = ACTIONS(2353),
    [sym_false] = ACTIONS(2353),
    [sym_null] = ACTIONS(2353),
    [sym_undefined] = ACTIONS(2353),
    [anon_sym_static] = ACTIONS(2353),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_get] = ACTIONS(2353),
    [anon_sym_set] = ACTIONS(2353),
    [anon_sym_QMARK] = ACTIONS(2353),
    [anon_sym_any] = ACTIONS(2353),
    [anon_sym_number] = ACTIONS(2353),
    [anon_sym_boolean] = ACTIONS(2353),
    [anon_sym_string] = ACTIONS(2353),
    [anon_sym_symbol] = ACTIONS(2353),
    [anon_sym_abstract] = ACTIONS(2353),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2353),
    [anon_sym_keyof] = ACTIONS(2353),
    [anon_sym_unknown] = ACTIONS(2353),
    [anon_sym_never] = ACTIONS(2353),
    [anon_sym_object] = ACTIONS(2353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2355),
    [anon_sym_constructor] = ACTIONS(2353),
    [anon_sym_prop] = ACTIONS(2353),
    [anon_sym_id] = ACTIONS(2353),
    [anon_sym_event] = ACTIONS(2353),
    [anon_sym_fn] = ACTIONS(2353),
    [anon_sym_on] = ACTIONS(2353),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [622] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [623] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2359),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_number] = ACTIONS(2359),
    [sym_this] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_QMARK] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2357),
    [anon_sym_keyof] = ACTIONS(2357),
    [anon_sym_unknown] = ACTIONS(2357),
    [anon_sym_never] = ACTIONS(2357),
    [anon_sym_object] = ACTIONS(2357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2359),
    [anon_sym_constructor] = ACTIONS(2357),
    [anon_sym_prop] = ACTIONS(2357),
    [anon_sym_id] = ACTIONS(2357),
    [anon_sym_event] = ACTIONS(2357),
    [anon_sym_fn] = ACTIONS(2357),
    [anon_sym_on] = ACTIONS(2357),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [624] = {
    [sym_identifier] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(2363),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_typeof] = ACTIONS(2361),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_var] = ACTIONS(2361),
    [anon_sym_let] = ACTIONS(2361),
    [anon_sym_const] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2361),
    [anon_sym_switch] = ACTIONS(2361),
    [anon_sym_for] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_await] = ACTIONS(2361),
    [anon_sym_while] = ACTIONS(2361),
    [anon_sym_do] = ACTIONS(2361),
    [anon_sym_try] = ACTIONS(2361),
    [anon_sym_with] = ACTIONS(2361),
    [anon_sym_break] = ACTIONS(2361),
    [anon_sym_continue] = ACTIONS(2361),
    [anon_sym_debugger] = ACTIONS(2361),
    [anon_sym_return] = ACTIONS(2361),
    [anon_sym_throw] = ACTIONS(2361),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2361),
    [anon_sym_default] = ACTIONS(2361),
    [anon_sym_finally] = ACTIONS(2361),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LTtemplate_GT] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_class] = ACTIONS(2361),
    [anon_sym_async] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(2361),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_delete] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2363),
    [anon_sym_DQUOTE] = ACTIONS(2363),
    [anon_sym_SQUOTE] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2363),
    [sym_number] = ACTIONS(2363),
    [sym_this] = ACTIONS(2361),
    [sym_super] = ACTIONS(2361),
    [sym_true] = ACTIONS(2361),
    [sym_false] = ACTIONS(2361),
    [sym_null] = ACTIONS(2361),
    [sym_undefined] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2361),
    [anon_sym_readonly] = ACTIONS(2361),
    [anon_sym_get] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2361),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_public] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2361),
    [anon_sym_protected] = ACTIONS(2361),
    [anon_sym_override] = ACTIONS(2361),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_abstract] = ACTIONS(2361),
    [anon_sym_interface] = ACTIONS(2361),
    [anon_sym_enum] = ACTIONS(2361),
    [anon_sym_component] = ACTIONS(2361),
  },
  [625] = {
    [sym_identifier] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1259),
    [anon_sym_typeof] = ACTIONS(1259),
    [anon_sym_import] = ACTIONS(1259),
    [anon_sym_var] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1259),
    [anon_sym_if] = ACTIONS(1259),
    [anon_sym_switch] = ACTIONS(1259),
    [anon_sym_for] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_while] = ACTIONS(1259),
    [anon_sym_do] = ACTIONS(1259),
    [anon_sym_try] = ACTIONS(1259),
    [anon_sym_with] = ACTIONS(1259),
    [anon_sym_break] = ACTIONS(1259),
    [anon_sym_continue] = ACTIONS(1259),
    [anon_sym_debugger] = ACTIONS(1259),
    [anon_sym_return] = ACTIONS(1259),
    [anon_sym_throw] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(1259),
    [anon_sym_yield] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_LTtemplate_GT] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1259),
    [anon_sym_class] = ACTIONS(1259),
    [anon_sym_async] = ACTIONS(1259),
    [anon_sym_function] = ACTIONS(1259),
    [anon_sym_new] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_void] = ACTIONS(1259),
    [anon_sym_delete] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1259),
    [sym_super] = ACTIONS(1259),
    [sym_true] = ACTIONS(1259),
    [sym_false] = ACTIONS(1259),
    [sym_null] = ACTIONS(1259),
    [sym_undefined] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(1263),
    [anon_sym_static] = ACTIONS(1259),
    [anon_sym_readonly] = ACTIONS(1259),
    [anon_sym_get] = ACTIONS(1259),
    [anon_sym_set] = ACTIONS(1259),
    [anon_sym_declare] = ACTIONS(1259),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_public] = ACTIONS(1259),
    [anon_sym_private] = ACTIONS(1259),
    [anon_sym_protected] = ACTIONS(1259),
    [anon_sym_override] = ACTIONS(1259),
    [anon_sym_module] = ACTIONS(1259),
    [anon_sym_any] = ACTIONS(1259),
    [anon_sym_number] = ACTIONS(1259),
    [anon_sym_boolean] = ACTIONS(1259),
    [anon_sym_string] = ACTIONS(1259),
    [anon_sym_symbol] = ACTIONS(1259),
    [anon_sym_abstract] = ACTIONS(1259),
    [anon_sym_interface] = ACTIONS(1259),
    [anon_sym_enum] = ACTIONS(1259),
    [anon_sym_component] = ACTIONS(1259),
    [sym__automatic_semicolon] = ACTIONS(1267),
  },
  [626] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(2339),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_constructor] = ACTIONS(2337),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [627] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(1347),
  },
  [628] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2365),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_number] = ACTIONS(2367),
    [sym_this] = ACTIONS(2365),
    [sym_true] = ACTIONS(2365),
    [sym_false] = ACTIONS(2365),
    [sym_null] = ACTIONS(2365),
    [sym_undefined] = ACTIONS(2365),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_get] = ACTIONS(2365),
    [anon_sym_set] = ACTIONS(2365),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_any] = ACTIONS(2365),
    [anon_sym_number] = ACTIONS(2365),
    [anon_sym_boolean] = ACTIONS(2365),
    [anon_sym_string] = ACTIONS(2365),
    [anon_sym_symbol] = ACTIONS(2365),
    [anon_sym_abstract] = ACTIONS(2365),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2365),
    [anon_sym_keyof] = ACTIONS(2365),
    [anon_sym_unknown] = ACTIONS(2365),
    [anon_sym_never] = ACTIONS(2365),
    [anon_sym_object] = ACTIONS(2365),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2367),
    [anon_sym_constructor] = ACTIONS(2365),
    [anon_sym_prop] = ACTIONS(2365),
    [anon_sym_id] = ACTIONS(2365),
    [anon_sym_event] = ACTIONS(2365),
    [anon_sym_fn] = ACTIONS(2365),
    [anon_sym_on] = ACTIONS(2365),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [629] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2369),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [sym_this] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [sym_false] = ACTIONS(2369),
    [sym_null] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_readonly] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2369),
    [anon_sym_keyof] = ACTIONS(2369),
    [anon_sym_unknown] = ACTIONS(2369),
    [anon_sym_never] = ACTIONS(2369),
    [anon_sym_object] = ACTIONS(2369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2371),
    [anon_sym_constructor] = ACTIONS(2369),
    [anon_sym_prop] = ACTIONS(2369),
    [anon_sym_id] = ACTIONS(2369),
    [anon_sym_event] = ACTIONS(2369),
    [anon_sym_fn] = ACTIONS(2369),
    [anon_sym_on] = ACTIONS(2369),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [630] = {
    [sym__call_signature] = STATE(4606),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(2375),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2375),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2375),
    [anon_sym_readonly] = ACTIONS(2375),
    [anon_sym_get] = ACTIONS(2375),
    [anon_sym_set] = ACTIONS(2375),
    [anon_sym_declare] = ACTIONS(2375),
    [anon_sym_namespace] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2375),
    [anon_sym_private] = ACTIONS(2375),
    [anon_sym_protected] = ACTIONS(2375),
    [anon_sym_override] = ACTIONS(2375),
    [anon_sym_module] = ACTIONS(2375),
    [anon_sym_any] = ACTIONS(2375),
    [anon_sym_number] = ACTIONS(2375),
    [anon_sym_boolean] = ACTIONS(2375),
    [anon_sym_string] = ACTIONS(2375),
    [anon_sym_symbol] = ACTIONS(2375),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [631] = {
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_await] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_try] = ACTIONS(1359),
    [anon_sym_with] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_debugger] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_throw] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1359),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_yield] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_LTtemplate_GT] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_class] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1359),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_number] = ACTIONS(1361),
    [sym_this] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_readonly] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_declare] = ACTIONS(1359),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_public] = ACTIONS(1359),
    [anon_sym_private] = ACTIONS(1359),
    [anon_sym_protected] = ACTIONS(1359),
    [anon_sym_override] = ACTIONS(1359),
    [anon_sym_module] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_interface] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_component] = ACTIONS(1359),
    [sym__automatic_semicolon] = ACTIONS(1361),
  },
  [632] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2379),
    [anon_sym_STAR] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2379),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [anon_sym_typeof] = ACTIONS(2379),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(2379),
    [anon_sym_SLASH] = ACTIONS(2379),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2379),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2379),
    [anon_sym_AMP_AMP] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2381),
    [anon_sym_GT_GT] = ACTIONS(2379),
    [anon_sym_GT_GT_GT] = ACTIONS(2381),
    [anon_sym_LT_LT] = ACTIONS(2381),
    [anon_sym_AMP] = ACTIONS(2379),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_PIPE] = ACTIONS(2379),
    [anon_sym_PLUS] = ACTIONS(2379),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_PERCENT] = ACTIONS(2381),
    [anon_sym_STAR_STAR] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2381),
    [anon_sym_EQ_EQ] = ACTIONS(2379),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2379),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2381),
    [anon_sym_GT_EQ] = ACTIONS(2381),
    [anon_sym_QMARK_QMARK] = ACTIONS(2381),
    [anon_sym_instanceof] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2379),
    [anon_sym_PLUS_PLUS] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(2381),
    [anon_sym_DQUOTE] = ACTIONS(2381),
    [anon_sym_SQUOTE] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2381),
    [sym_number] = ACTIONS(2381),
    [sym_this] = ACTIONS(2379),
    [sym_true] = ACTIONS(2379),
    [sym_false] = ACTIONS(2379),
    [sym_null] = ACTIONS(2379),
    [sym_undefined] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2379),
    [anon_sym_readonly] = ACTIONS(2379),
    [anon_sym_get] = ACTIONS(2379),
    [anon_sym_set] = ACTIONS(2379),
    [anon_sym_QMARK] = ACTIONS(2379),
    [anon_sym_any] = ACTIONS(2379),
    [anon_sym_number] = ACTIONS(2379),
    [anon_sym_boolean] = ACTIONS(2379),
    [anon_sym_string] = ACTIONS(2379),
    [anon_sym_symbol] = ACTIONS(2379),
    [anon_sym_abstract] = ACTIONS(2379),
    [anon_sym_satisfies] = ACTIONS(2379),
    [anon_sym_infer] = ACTIONS(2379),
    [anon_sym_keyof] = ACTIONS(2379),
    [anon_sym_unknown] = ACTIONS(2379),
    [anon_sym_never] = ACTIONS(2379),
    [anon_sym_object] = ACTIONS(2379),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2381),
    [anon_sym_constructor] = ACTIONS(2379),
    [anon_sym_prop] = ACTIONS(2379),
    [anon_sym_id] = ACTIONS(2379),
    [anon_sym_event] = ACTIONS(2379),
    [anon_sym_fn] = ACTIONS(2379),
    [anon_sym_on] = ACTIONS(2379),
    [sym__ternary_qmark] = ACTIONS(2381),
  },
  [633] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2385),
    [anon_sym_typeof] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2385),
    [sym_number] = ACTIONS(2385),
    [sym_this] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_null] = ACTIONS(2383),
    [sym_undefined] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2383),
    [anon_sym_readonly] = ACTIONS(2383),
    [anon_sym_get] = ACTIONS(2383),
    [anon_sym_set] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_any] = ACTIONS(2383),
    [anon_sym_number] = ACTIONS(2383),
    [anon_sym_boolean] = ACTIONS(2383),
    [anon_sym_string] = ACTIONS(2383),
    [anon_sym_symbol] = ACTIONS(2383),
    [anon_sym_abstract] = ACTIONS(2383),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2383),
    [anon_sym_keyof] = ACTIONS(2383),
    [anon_sym_unknown] = ACTIONS(2383),
    [anon_sym_never] = ACTIONS(2383),
    [anon_sym_object] = ACTIONS(2383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2385),
    [anon_sym_constructor] = ACTIONS(2383),
    [anon_sym_prop] = ACTIONS(2383),
    [anon_sym_id] = ACTIONS(2383),
    [anon_sym_event] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_on] = ACTIONS(2383),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [634] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_typeof] = ACTIONS(2387),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2387),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2389),
    [anon_sym_SQUOTE] = ACTIONS(2389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2389),
    [sym_number] = ACTIONS(2389),
    [sym_this] = ACTIONS(2387),
    [sym_true] = ACTIONS(2387),
    [sym_false] = ACTIONS(2387),
    [sym_null] = ACTIONS(2387),
    [sym_undefined] = ACTIONS(2387),
    [anon_sym_static] = ACTIONS(2387),
    [anon_sym_readonly] = ACTIONS(2387),
    [anon_sym_get] = ACTIONS(2387),
    [anon_sym_set] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_any] = ACTIONS(2387),
    [anon_sym_number] = ACTIONS(2387),
    [anon_sym_boolean] = ACTIONS(2387),
    [anon_sym_string] = ACTIONS(2387),
    [anon_sym_symbol] = ACTIONS(2387),
    [anon_sym_abstract] = ACTIONS(2387),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2387),
    [anon_sym_keyof] = ACTIONS(2387),
    [anon_sym_unknown] = ACTIONS(2387),
    [anon_sym_never] = ACTIONS(2387),
    [anon_sym_object] = ACTIONS(2387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2389),
    [anon_sym_constructor] = ACTIONS(2387),
    [anon_sym_prop] = ACTIONS(2387),
    [anon_sym_id] = ACTIONS(2387),
    [anon_sym_event] = ACTIONS(2387),
    [anon_sym_fn] = ACTIONS(2387),
    [anon_sym_on] = ACTIONS(2387),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [635] = {
    [sym__call_signature] = STATE(4524),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(2108),
    [anon_sym_of] = ACTIONS(2111),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [636] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_export] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1345),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_import] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [anon_sym_let] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_debugger] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LTtemplate_GT] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_class] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(1345),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_delete] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_super] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_declare] = ACTIONS(1345),
    [anon_sym_namespace] = ACTIONS(1345),
    [anon_sym_public] = ACTIONS(1345),
    [anon_sym_private] = ACTIONS(1345),
    [anon_sym_protected] = ACTIONS(1345),
    [anon_sym_override] = ACTIONS(1345),
    [anon_sym_module] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_interface] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_component] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(2391),
  },
  [637] = {
    [sym_identifier] = ACTIONS(1363),
    [anon_sym_export] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_type] = ACTIONS(1363),
    [anon_sym_typeof] = ACTIONS(1363),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1363),
    [anon_sym_let] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_else] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1363),
    [anon_sym_switch] = ACTIONS(1363),
    [anon_sym_for] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_while] = ACTIONS(1363),
    [anon_sym_do] = ACTIONS(1363),
    [anon_sym_try] = ACTIONS(1363),
    [anon_sym_with] = ACTIONS(1363),
    [anon_sym_break] = ACTIONS(1363),
    [anon_sym_continue] = ACTIONS(1363),
    [anon_sym_debugger] = ACTIONS(1363),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_throw] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(1363),
    [anon_sym_yield] = ACTIONS(1363),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_LTtemplate_GT] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1363),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_class] = ACTIONS(1363),
    [anon_sym_async] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1363),
    [anon_sym_new] = ACTIONS(1363),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_void] = ACTIONS(1363),
    [anon_sym_delete] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [sym_number] = ACTIONS(1367),
    [sym_this] = ACTIONS(1363),
    [sym_super] = ACTIONS(1363),
    [sym_true] = ACTIONS(1363),
    [sym_false] = ACTIONS(1363),
    [sym_null] = ACTIONS(1363),
    [sym_undefined] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1363),
    [anon_sym_readonly] = ACTIONS(1363),
    [anon_sym_get] = ACTIONS(1363),
    [anon_sym_set] = ACTIONS(1363),
    [anon_sym_declare] = ACTIONS(1363),
    [anon_sym_namespace] = ACTIONS(1363),
    [anon_sym_public] = ACTIONS(1363),
    [anon_sym_private] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(1363),
    [anon_sym_override] = ACTIONS(1363),
    [anon_sym_module] = ACTIONS(1363),
    [anon_sym_any] = ACTIONS(1363),
    [anon_sym_number] = ACTIONS(1363),
    [anon_sym_boolean] = ACTIONS(1363),
    [anon_sym_string] = ACTIONS(1363),
    [anon_sym_symbol] = ACTIONS(1363),
    [anon_sym_abstract] = ACTIONS(1363),
    [anon_sym_interface] = ACTIONS(1363),
    [anon_sym_enum] = ACTIONS(1363),
    [anon_sym_component] = ACTIONS(1363),
    [sym__automatic_semicolon] = ACTIONS(1371),
  },
  [638] = {
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_var] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_await] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_try] = ACTIONS(1321),
    [anon_sym_with] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_debugger] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_throw] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_yield] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_LTtemplate_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_void] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(1321),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1325),
    [sym_number] = ACTIONS(1325),
    [sym_this] = ACTIONS(1321),
    [sym_super] = ACTIONS(1321),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [sym_null] = ACTIONS(1321),
    [sym_undefined] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1321),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_override] = ACTIONS(1321),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_abstract] = ACTIONS(1321),
    [anon_sym_interface] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_component] = ACTIONS(1321),
    [sym__automatic_semicolon] = ACTIONS(1329),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_export] = ACTIONS(2393),
    [anon_sym_LBRACE] = ACTIONS(2395),
    [anon_sym_RBRACE] = ACTIONS(2395),
    [anon_sym_type] = ACTIONS(2393),
    [anon_sym_typeof] = ACTIONS(2393),
    [anon_sym_import] = ACTIONS(2393),
    [anon_sym_var] = ACTIONS(2393),
    [anon_sym_let] = ACTIONS(2393),
    [anon_sym_const] = ACTIONS(2393),
    [anon_sym_BANG] = ACTIONS(2395),
    [anon_sym_else] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2393),
    [anon_sym_switch] = ACTIONS(2393),
    [anon_sym_for] = ACTIONS(2393),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_await] = ACTIONS(2393),
    [anon_sym_while] = ACTIONS(2393),
    [anon_sym_do] = ACTIONS(2393),
    [anon_sym_try] = ACTIONS(2393),
    [anon_sym_with] = ACTIONS(2393),
    [anon_sym_break] = ACTIONS(2393),
    [anon_sym_continue] = ACTIONS(2393),
    [anon_sym_debugger] = ACTIONS(2393),
    [anon_sym_return] = ACTIONS(2393),
    [anon_sym_throw] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2395),
    [anon_sym_case] = ACTIONS(2393),
    [anon_sym_default] = ACTIONS(2393),
    [anon_sym_finally] = ACTIONS(2393),
    [anon_sym_yield] = ACTIONS(2393),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_LTtemplate_GT] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_class] = ACTIONS(2393),
    [anon_sym_async] = ACTIONS(2393),
    [anon_sym_function] = ACTIONS(2393),
    [anon_sym_new] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_DASH] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_void] = ACTIONS(2393),
    [anon_sym_delete] = ACTIONS(2393),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_DASH_DASH] = ACTIONS(2395),
    [anon_sym_DQUOTE] = ACTIONS(2395),
    [anon_sym_SQUOTE] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [sym_number] = ACTIONS(2395),
    [sym_this] = ACTIONS(2393),
    [sym_super] = ACTIONS(2393),
    [sym_true] = ACTIONS(2393),
    [sym_false] = ACTIONS(2393),
    [sym_null] = ACTIONS(2393),
    [sym_undefined] = ACTIONS(2393),
    [anon_sym_AT] = ACTIONS(2395),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_readonly] = ACTIONS(2393),
    [anon_sym_get] = ACTIONS(2393),
    [anon_sym_set] = ACTIONS(2393),
    [anon_sym_declare] = ACTIONS(2393),
    [anon_sym_namespace] = ACTIONS(2393),
    [anon_sym_public] = ACTIONS(2393),
    [anon_sym_private] = ACTIONS(2393),
    [anon_sym_protected] = ACTIONS(2393),
    [anon_sym_override] = ACTIONS(2393),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_any] = ACTIONS(2393),
    [anon_sym_number] = ACTIONS(2393),
    [anon_sym_boolean] = ACTIONS(2393),
    [anon_sym_string] = ACTIONS(2393),
    [anon_sym_symbol] = ACTIONS(2393),
    [anon_sym_abstract] = ACTIONS(2393),
    [anon_sym_interface] = ACTIONS(2393),
    [anon_sym_enum] = ACTIONS(2393),
    [anon_sym_component] = ACTIONS(2393),
  },
  [640] = {
    [sym_statement_block] = STATE(877),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [anon_sym_component] = ACTIONS(2178),
  },
  [641] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [sym_number] = ACTIONS(2399),
    [sym_this] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_null] = ACTIONS(2397),
    [sym_undefined] = ACTIONS(2397),
    [anon_sym_static] = ACTIONS(2397),
    [anon_sym_readonly] = ACTIONS(2397),
    [anon_sym_get] = ACTIONS(2397),
    [anon_sym_set] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_any] = ACTIONS(2397),
    [anon_sym_number] = ACTIONS(2397),
    [anon_sym_boolean] = ACTIONS(2397),
    [anon_sym_string] = ACTIONS(2397),
    [anon_sym_symbol] = ACTIONS(2397),
    [anon_sym_abstract] = ACTIONS(2397),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2397),
    [anon_sym_keyof] = ACTIONS(2397),
    [anon_sym_unknown] = ACTIONS(2397),
    [anon_sym_never] = ACTIONS(2397),
    [anon_sym_object] = ACTIONS(2397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2399),
    [anon_sym_constructor] = ACTIONS(2397),
    [anon_sym_prop] = ACTIONS(2397),
    [anon_sym_id] = ACTIONS(2397),
    [anon_sym_event] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_on] = ACTIONS(2397),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [642] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2401),
    [anon_sym_keyof] = ACTIONS(2401),
    [anon_sym_unknown] = ACTIONS(2401),
    [anon_sym_never] = ACTIONS(2401),
    [anon_sym_object] = ACTIONS(2401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2403),
    [anon_sym_constructor] = ACTIONS(2401),
    [anon_sym_prop] = ACTIONS(2401),
    [anon_sym_id] = ACTIONS(2401),
    [anon_sym_event] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_on] = ACTIONS(2401),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [643] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_abstract] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2405),
    [anon_sym_keyof] = ACTIONS(2405),
    [anon_sym_unknown] = ACTIONS(2405),
    [anon_sym_never] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2407),
    [anon_sym_constructor] = ACTIONS(2405),
    [anon_sym_prop] = ACTIONS(2405),
    [anon_sym_id] = ACTIONS(2405),
    [anon_sym_event] = ACTIONS(2405),
    [anon_sym_fn] = ACTIONS(2405),
    [anon_sym_on] = ACTIONS(2405),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [644] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(1225),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1221),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_satisfies] = ACTIONS(1221),
    [anon_sym_infer] = ACTIONS(1219),
    [anon_sym_keyof] = ACTIONS(1219),
    [anon_sym_unknown] = ACTIONS(1219),
    [anon_sym_never] = ACTIONS(1219),
    [anon_sym_object] = ACTIONS(1219),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
    [anon_sym_constructor] = ACTIONS(1219),
    [anon_sym_prop] = ACTIONS(1219),
    [anon_sym_id] = ACTIONS(1219),
    [anon_sym_event] = ACTIONS(1219),
    [anon_sym_fn] = ACTIONS(1219),
    [anon_sym_on] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(2409),
    [sym__ternary_qmark] = ACTIONS(1225),
  },
  [645] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_typeof] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2413),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2413),
    [anon_sym_SQUOTE] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2413),
    [sym_number] = ACTIONS(2413),
    [sym_this] = ACTIONS(2411),
    [sym_true] = ACTIONS(2411),
    [sym_false] = ACTIONS(2411),
    [sym_null] = ACTIONS(2411),
    [sym_undefined] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_readonly] = ACTIONS(2411),
    [anon_sym_get] = ACTIONS(2411),
    [anon_sym_set] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_any] = ACTIONS(2411),
    [anon_sym_number] = ACTIONS(2411),
    [anon_sym_boolean] = ACTIONS(2411),
    [anon_sym_string] = ACTIONS(2411),
    [anon_sym_symbol] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2411),
    [anon_sym_keyof] = ACTIONS(2411),
    [anon_sym_unknown] = ACTIONS(2411),
    [anon_sym_never] = ACTIONS(2411),
    [anon_sym_object] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_constructor] = ACTIONS(2411),
    [anon_sym_prop] = ACTIONS(2411),
    [anon_sym_id] = ACTIONS(2411),
    [anon_sym_event] = ACTIONS(2411),
    [anon_sym_fn] = ACTIONS(2411),
    [anon_sym_on] = ACTIONS(2411),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [646] = {
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_export] = ACTIONS(2415),
    [anon_sym_LBRACE] = ACTIONS(2417),
    [anon_sym_RBRACE] = ACTIONS(2417),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_typeof] = ACTIONS(2415),
    [anon_sym_import] = ACTIONS(2415),
    [anon_sym_var] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_const] = ACTIONS(2415),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_else] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_switch] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_await] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_with] = ACTIONS(2415),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_continue] = ACTIONS(2415),
    [anon_sym_debugger] = ACTIONS(2415),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_throw] = ACTIONS(2415),
    [anon_sym_SEMI] = ACTIONS(2417),
    [anon_sym_case] = ACTIONS(2415),
    [anon_sym_default] = ACTIONS(2415),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2417),
    [anon_sym_LTtemplate_GT] = ACTIONS(2417),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_SLASH] = ACTIONS(2415),
    [anon_sym_DOT] = ACTIONS(2415),
    [anon_sym_class] = ACTIONS(2415),
    [anon_sym_async] = ACTIONS(2415),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2417),
    [anon_sym_void] = ACTIONS(2415),
    [anon_sym_delete] = ACTIONS(2415),
    [anon_sym_PLUS_PLUS] = ACTIONS(2417),
    [anon_sym_DASH_DASH] = ACTIONS(2417),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2417),
    [sym_number] = ACTIONS(2417),
    [sym_this] = ACTIONS(2415),
    [sym_super] = ACTIONS(2415),
    [sym_true] = ACTIONS(2415),
    [sym_false] = ACTIONS(2415),
    [sym_null] = ACTIONS(2415),
    [sym_undefined] = ACTIONS(2415),
    [anon_sym_AT] = ACTIONS(2417),
    [anon_sym_static] = ACTIONS(2415),
    [anon_sym_readonly] = ACTIONS(2415),
    [anon_sym_get] = ACTIONS(2415),
    [anon_sym_set] = ACTIONS(2415),
    [anon_sym_declare] = ACTIONS(2415),
    [anon_sym_namespace] = ACTIONS(2415),
    [anon_sym_public] = ACTIONS(2415),
    [anon_sym_private] = ACTIONS(2415),
    [anon_sym_protected] = ACTIONS(2415),
    [anon_sym_override] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_any] = ACTIONS(2415),
    [anon_sym_number] = ACTIONS(2415),
    [anon_sym_boolean] = ACTIONS(2415),
    [anon_sym_string] = ACTIONS(2415),
    [anon_sym_symbol] = ACTIONS(2415),
    [anon_sym_abstract] = ACTIONS(2415),
    [anon_sym_interface] = ACTIONS(2415),
    [anon_sym_enum] = ACTIONS(2415),
    [anon_sym_component] = ACTIONS(2415),
  },
  [647] = {
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_typeof] = ACTIONS(1373),
    [anon_sym_import] = ACTIONS(1373),
    [anon_sym_var] = ACTIONS(1373),
    [anon_sym_let] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1377),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_try] = ACTIONS(1373),
    [anon_sym_with] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_debugger] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_throw] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1377),
    [anon_sym_LTtemplate_GT] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_SLASH] = ACTIONS(1373),
    [anon_sym_class] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1373),
    [anon_sym_new] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1377),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_delete] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_SQUOTE] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [sym_number] = ACTIONS(1377),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_namespace] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_override] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_any] = ACTIONS(1373),
    [anon_sym_number] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(1373),
    [anon_sym_interface] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_component] = ACTIONS(1373),
    [sym__automatic_semicolon] = ACTIONS(1381),
  },
  [648] = {
    [sym_identifier] = ACTIONS(2419),
    [anon_sym_export] = ACTIONS(2419),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_RBRACE] = ACTIONS(2421),
    [anon_sym_type] = ACTIONS(2419),
    [anon_sym_typeof] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2419),
    [anon_sym_var] = ACTIONS(2419),
    [anon_sym_let] = ACTIONS(2419),
    [anon_sym_const] = ACTIONS(2419),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_else] = ACTIONS(2419),
    [anon_sym_if] = ACTIONS(2419),
    [anon_sym_switch] = ACTIONS(2419),
    [anon_sym_for] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_RPAREN] = ACTIONS(2421),
    [anon_sym_await] = ACTIONS(2419),
    [anon_sym_while] = ACTIONS(2419),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_try] = ACTIONS(2419),
    [anon_sym_with] = ACTIONS(2419),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_continue] = ACTIONS(2419),
    [anon_sym_debugger] = ACTIONS(2419),
    [anon_sym_return] = ACTIONS(2419),
    [anon_sym_throw] = ACTIONS(2419),
    [anon_sym_SEMI] = ACTIONS(2421),
    [anon_sym_case] = ACTIONS(2419),
    [anon_sym_default] = ACTIONS(2419),
    [anon_sym_yield] = ACTIONS(2419),
    [anon_sym_LBRACK] = ACTIONS(2421),
    [anon_sym_LTtemplate_GT] = ACTIONS(2421),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_SLASH] = ACTIONS(2419),
    [anon_sym_class] = ACTIONS(2419),
    [anon_sym_async] = ACTIONS(2419),
    [anon_sym_function] = ACTIONS(2419),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_PLUS] = ACTIONS(2419),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2421),
    [anon_sym_void] = ACTIONS(2419),
    [anon_sym_delete] = ACTIONS(2419),
    [anon_sym_PLUS_PLUS] = ACTIONS(2421),
    [anon_sym_DASH_DASH] = ACTIONS(2421),
    [anon_sym_DQUOTE] = ACTIONS(2421),
    [anon_sym_SQUOTE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2421),
    [sym_number] = ACTIONS(2421),
    [sym_this] = ACTIONS(2419),
    [sym_super] = ACTIONS(2419),
    [sym_true] = ACTIONS(2419),
    [sym_false] = ACTIONS(2419),
    [sym_null] = ACTIONS(2419),
    [sym_undefined] = ACTIONS(2419),
    [anon_sym_AT] = ACTIONS(2421),
    [anon_sym_static] = ACTIONS(2419),
    [anon_sym_readonly] = ACTIONS(2419),
    [anon_sym_get] = ACTIONS(2419),
    [anon_sym_set] = ACTIONS(2419),
    [anon_sym_declare] = ACTIONS(2419),
    [anon_sym_namespace] = ACTIONS(2419),
    [anon_sym_public] = ACTIONS(2419),
    [anon_sym_private] = ACTIONS(2419),
    [anon_sym_protected] = ACTIONS(2419),
    [anon_sym_override] = ACTIONS(2419),
    [anon_sym_module] = ACTIONS(2419),
    [anon_sym_any] = ACTIONS(2419),
    [anon_sym_number] = ACTIONS(2419),
    [anon_sym_boolean] = ACTIONS(2419),
    [anon_sym_string] = ACTIONS(2419),
    [anon_sym_symbol] = ACTIONS(2419),
    [anon_sym_abstract] = ACTIONS(2419),
    [anon_sym_interface] = ACTIONS(2419),
    [anon_sym_enum] = ACTIONS(2419),
    [anon_sym_component] = ACTIONS(2419),
  },
  [649] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2423),
    [anon_sym_STAR] = ACTIONS(2423),
    [anon_sym_as] = ACTIONS(2423),
    [anon_sym_LBRACE] = ACTIONS(2423),
    [anon_sym_RBRACE] = ACTIONS(2425),
    [anon_sym_typeof] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2423),
    [anon_sym_SEMI] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2423),
    [anon_sym_SLASH] = ACTIONS(2423),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2423),
    [anon_sym_AMP_AMP] = ACTIONS(2425),
    [anon_sym_PIPE_PIPE] = ACTIONS(2425),
    [anon_sym_GT_GT] = ACTIONS(2423),
    [anon_sym_GT_GT_GT] = ACTIONS(2425),
    [anon_sym_LT_LT] = ACTIONS(2425),
    [anon_sym_AMP] = ACTIONS(2423),
    [anon_sym_CARET] = ACTIONS(2425),
    [anon_sym_PIPE] = ACTIONS(2423),
    [anon_sym_PLUS] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(2423),
    [anon_sym_PERCENT] = ACTIONS(2425),
    [anon_sym_STAR_STAR] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2425),
    [anon_sym_EQ_EQ] = ACTIONS(2423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2425),
    [anon_sym_BANG_EQ] = ACTIONS(2423),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2425),
    [anon_sym_GT_EQ] = ACTIONS(2425),
    [anon_sym_QMARK_QMARK] = ACTIONS(2425),
    [anon_sym_instanceof] = ACTIONS(2423),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2425),
    [sym_number] = ACTIONS(2425),
    [sym_this] = ACTIONS(2423),
    [sym_true] = ACTIONS(2423),
    [sym_false] = ACTIONS(2423),
    [sym_null] = ACTIONS(2423),
    [sym_undefined] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_QMARK] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [anon_sym_abstract] = ACTIONS(2423),
    [anon_sym_satisfies] = ACTIONS(2423),
    [anon_sym_infer] = ACTIONS(2423),
    [anon_sym_keyof] = ACTIONS(2423),
    [anon_sym_unknown] = ACTIONS(2423),
    [anon_sym_never] = ACTIONS(2423),
    [anon_sym_object] = ACTIONS(2423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2425),
    [anon_sym_constructor] = ACTIONS(2423),
    [anon_sym_prop] = ACTIONS(2423),
    [anon_sym_id] = ACTIONS(2423),
    [anon_sym_event] = ACTIONS(2423),
    [anon_sym_fn] = ACTIONS(2423),
    [anon_sym_on] = ACTIONS(2423),
    [sym__ternary_qmark] = ACTIONS(2425),
  },
  [650] = {
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1411),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_let] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_try] = ACTIONS(1411),
    [anon_sym_with] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_debugger] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_throw] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_function] = ACTIONS(1411),
    [anon_sym_new] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1413),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [sym_number] = ACTIONS(1413),
    [sym_this] = ACTIONS(1411),
    [sym_super] = ACTIONS(1411),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_readonly] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1411),
    [anon_sym_public] = ACTIONS(1411),
    [anon_sym_private] = ACTIONS(1411),
    [anon_sym_protected] = ACTIONS(1411),
    [anon_sym_override] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [anon_sym_abstract] = ACTIONS(1411),
    [anon_sym_interface] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_component] = ACTIONS(1411),
    [sym__automatic_semicolon] = ACTIONS(1413),
  },
  [651] = {
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_typeof] = ACTIONS(1311),
    [anon_sym_import] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_do] = ACTIONS(1311),
    [anon_sym_try] = ACTIONS(1311),
    [anon_sym_with] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_debugger] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_throw] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_LTtemplate_GT] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_class] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(1311),
    [anon_sym_new] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_void] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [sym_number] = ACTIONS(1315),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1315),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_readonly] = ACTIONS(1311),
    [anon_sym_get] = ACTIONS(1311),
    [anon_sym_set] = ACTIONS(1311),
    [anon_sym_declare] = ACTIONS(1311),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_public] = ACTIONS(1311),
    [anon_sym_private] = ACTIONS(1311),
    [anon_sym_protected] = ACTIONS(1311),
    [anon_sym_override] = ACTIONS(1311),
    [anon_sym_module] = ACTIONS(1311),
    [anon_sym_any] = ACTIONS(1311),
    [anon_sym_number] = ACTIONS(1311),
    [anon_sym_boolean] = ACTIONS(1311),
    [anon_sym_string] = ACTIONS(1311),
    [anon_sym_symbol] = ACTIONS(1311),
    [anon_sym_abstract] = ACTIONS(1311),
    [anon_sym_interface] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_component] = ACTIONS(1311),
    [sym__automatic_semicolon] = ACTIONS(1319),
  },
  [652] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_typeof] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2429),
    [sym_number] = ACTIONS(2429),
    [sym_this] = ACTIONS(2427),
    [sym_true] = ACTIONS(2427),
    [sym_false] = ACTIONS(2427),
    [sym_null] = ACTIONS(2427),
    [sym_undefined] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2427),
    [anon_sym_readonly] = ACTIONS(2427),
    [anon_sym_get] = ACTIONS(2427),
    [anon_sym_set] = ACTIONS(2427),
    [anon_sym_QMARK] = ACTIONS(2427),
    [anon_sym_any] = ACTIONS(2427),
    [anon_sym_number] = ACTIONS(2427),
    [anon_sym_boolean] = ACTIONS(2427),
    [anon_sym_string] = ACTIONS(2427),
    [anon_sym_symbol] = ACTIONS(2427),
    [anon_sym_abstract] = ACTIONS(2427),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2427),
    [anon_sym_keyof] = ACTIONS(2427),
    [anon_sym_unknown] = ACTIONS(2427),
    [anon_sym_never] = ACTIONS(2427),
    [anon_sym_object] = ACTIONS(2427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2429),
    [anon_sym_constructor] = ACTIONS(2427),
    [anon_sym_prop] = ACTIONS(2427),
    [anon_sym_id] = ACTIONS(2427),
    [anon_sym_event] = ACTIONS(2427),
    [anon_sym_fn] = ACTIONS(2427),
    [anon_sym_on] = ACTIONS(2427),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [653] = {
    [sym_else_clause] = STATE(731),
    [sym_identifier] = ACTIONS(2431),
    [anon_sym_export] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2433),
    [anon_sym_RBRACE] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2431),
    [anon_sym_typeof] = ACTIONS(2431),
    [anon_sym_import] = ACTIONS(2431),
    [anon_sym_var] = ACTIONS(2431),
    [anon_sym_let] = ACTIONS(2431),
    [anon_sym_const] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2433),
    [anon_sym_else] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_switch] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2433),
    [anon_sym_await] = ACTIONS(2431),
    [anon_sym_while] = ACTIONS(2431),
    [anon_sym_do] = ACTIONS(2431),
    [anon_sym_try] = ACTIONS(2431),
    [anon_sym_with] = ACTIONS(2431),
    [anon_sym_break] = ACTIONS(2431),
    [anon_sym_continue] = ACTIONS(2431),
    [anon_sym_debugger] = ACTIONS(2431),
    [anon_sym_return] = ACTIONS(2431),
    [anon_sym_throw] = ACTIONS(2431),
    [anon_sym_SEMI] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2431),
    [anon_sym_default] = ACTIONS(2431),
    [anon_sym_yield] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_LTtemplate_GT] = ACTIONS(2433),
    [anon_sym_LT] = ACTIONS(2431),
    [anon_sym_SLASH] = ACTIONS(2431),
    [anon_sym_class] = ACTIONS(2431),
    [anon_sym_async] = ACTIONS(2431),
    [anon_sym_function] = ACTIONS(2431),
    [anon_sym_new] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2433),
    [anon_sym_void] = ACTIONS(2431),
    [anon_sym_delete] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2433),
    [anon_sym_DQUOTE] = ACTIONS(2433),
    [anon_sym_SQUOTE] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2433),
    [sym_number] = ACTIONS(2433),
    [sym_this] = ACTIONS(2431),
    [sym_super] = ACTIONS(2431),
    [sym_true] = ACTIONS(2431),
    [sym_false] = ACTIONS(2431),
    [sym_null] = ACTIONS(2431),
    [sym_undefined] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2431),
    [anon_sym_readonly] = ACTIONS(2431),
    [anon_sym_get] = ACTIONS(2431),
    [anon_sym_set] = ACTIONS(2431),
    [anon_sym_declare] = ACTIONS(2431),
    [anon_sym_namespace] = ACTIONS(2431),
    [anon_sym_public] = ACTIONS(2431),
    [anon_sym_private] = ACTIONS(2431),
    [anon_sym_protected] = ACTIONS(2431),
    [anon_sym_override] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(2431),
    [anon_sym_any] = ACTIONS(2431),
    [anon_sym_number] = ACTIONS(2431),
    [anon_sym_boolean] = ACTIONS(2431),
    [anon_sym_string] = ACTIONS(2431),
    [anon_sym_symbol] = ACTIONS(2431),
    [anon_sym_abstract] = ACTIONS(2431),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_enum] = ACTIONS(2431),
    [anon_sym_component] = ACTIONS(2431),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2437),
    [anon_sym_export] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_type] = ACTIONS(2437),
    [anon_sym_typeof] = ACTIONS(2437),
    [anon_sym_import] = ACTIONS(2437),
    [anon_sym_var] = ACTIONS(2437),
    [anon_sym_let] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [anon_sym_await] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_with] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_debugger] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_yield] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LTtemplate_GT] = ACTIONS(2439),
    [anon_sym_LT] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_async] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_void] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [sym_number] = ACTIONS(2439),
    [sym_this] = ACTIONS(2437),
    [sym_super] = ACTIONS(2437),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [sym_null] = ACTIONS(2437),
    [sym_undefined] = ACTIONS(2437),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_readonly] = ACTIONS(2437),
    [anon_sym_get] = ACTIONS(2437),
    [anon_sym_set] = ACTIONS(2437),
    [anon_sym_declare] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_override] = ACTIONS(2437),
    [anon_sym_module] = ACTIONS(2437),
    [anon_sym_any] = ACTIONS(2437),
    [anon_sym_number] = ACTIONS(2437),
    [anon_sym_boolean] = ACTIONS(2437),
    [anon_sym_string] = ACTIONS(2437),
    [anon_sym_symbol] = ACTIONS(2437),
    [anon_sym_abstract] = ACTIONS(2437),
    [anon_sym_interface] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_component] = ACTIONS(2437),
  },
  [655] = {
    [sym__call_signature] = STATE(4606),
    [sym_formal_parameters] = STATE(3400),
    [sym_type_parameters] = STATE(4000),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(2375),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2375),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_EQ_GT] = ACTIONS(2377),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2375),
    [anon_sym_readonly] = ACTIONS(2375),
    [anon_sym_get] = ACTIONS(2375),
    [anon_sym_set] = ACTIONS(2375),
    [anon_sym_declare] = ACTIONS(2375),
    [anon_sym_namespace] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2375),
    [anon_sym_private] = ACTIONS(2375),
    [anon_sym_protected] = ACTIONS(2375),
    [anon_sym_override] = ACTIONS(2375),
    [anon_sym_module] = ACTIONS(2375),
    [anon_sym_any] = ACTIONS(2375),
    [anon_sym_number] = ACTIONS(2375),
    [anon_sym_boolean] = ACTIONS(2375),
    [anon_sym_string] = ACTIONS(2375),
    [anon_sym_symbol] = ACTIONS(2375),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [656] = {
    [sym_identifier] = ACTIONS(1451),
    [anon_sym_export] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_type] = ACTIONS(1451),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym_import] = ACTIONS(1451),
    [anon_sym_var] = ACTIONS(1451),
    [anon_sym_let] = ACTIONS(1451),
    [anon_sym_const] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_switch] = ACTIONS(1451),
    [anon_sym_for] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_await] = ACTIONS(1451),
    [anon_sym_while] = ACTIONS(1451),
    [anon_sym_do] = ACTIONS(1451),
    [anon_sym_try] = ACTIONS(1451),
    [anon_sym_with] = ACTIONS(1451),
    [anon_sym_break] = ACTIONS(1451),
    [anon_sym_continue] = ACTIONS(1451),
    [anon_sym_debugger] = ACTIONS(1451),
    [anon_sym_return] = ACTIONS(1451),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1451),
    [anon_sym_default] = ACTIONS(1451),
    [anon_sym_yield] = ACTIONS(1451),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_class] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(1451),
    [anon_sym_new] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1453),
    [anon_sym_void] = ACTIONS(1451),
    [anon_sym_delete] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1453),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1451),
    [sym_super] = ACTIONS(1451),
    [sym_true] = ACTIONS(1451),
    [sym_false] = ACTIONS(1451),
    [sym_null] = ACTIONS(1451),
    [sym_undefined] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1451),
    [anon_sym_readonly] = ACTIONS(1451),
    [anon_sym_get] = ACTIONS(1451),
    [anon_sym_set] = ACTIONS(1451),
    [anon_sym_declare] = ACTIONS(1451),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_public] = ACTIONS(1451),
    [anon_sym_private] = ACTIONS(1451),
    [anon_sym_protected] = ACTIONS(1451),
    [anon_sym_override] = ACTIONS(1451),
    [anon_sym_module] = ACTIONS(1451),
    [anon_sym_any] = ACTIONS(1451),
    [anon_sym_number] = ACTIONS(1451),
    [anon_sym_boolean] = ACTIONS(1451),
    [anon_sym_string] = ACTIONS(1451),
    [anon_sym_symbol] = ACTIONS(1451),
    [anon_sym_abstract] = ACTIONS(1451),
    [anon_sym_interface] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(1451),
    [anon_sym_component] = ACTIONS(1451),
    [sym__automatic_semicolon] = ACTIONS(1453),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_as] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2445),
    [anon_sym_typeof] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2443),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_SLASH] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2443),
    [anon_sym_async] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2443),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2443),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_STAR_STAR] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2443),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_QMARK_QMARK] = ACTIONS(2445),
    [anon_sym_instanceof] = ACTIONS(2443),
    [anon_sym_void] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2445),
    [sym_number] = ACTIONS(2445),
    [sym_this] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_null] = ACTIONS(2443),
    [sym_undefined] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_QMARK] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
    [anon_sym_abstract] = ACTIONS(2443),
    [anon_sym_satisfies] = ACTIONS(2443),
    [anon_sym_extends] = ACTIONS(2443),
    [anon_sym_infer] = ACTIONS(2443),
    [anon_sym_is] = ACTIONS(2206),
    [anon_sym_keyof] = ACTIONS(2443),
    [anon_sym_unknown] = ACTIONS(2443),
    [anon_sym_never] = ACTIONS(2443),
    [anon_sym_object] = ACTIONS(2443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2445),
    [anon_sym_constructor] = ACTIONS(2443),
    [anon_sym_prop] = ACTIONS(2443),
    [anon_sym_id] = ACTIONS(2443),
    [anon_sym_event] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_on] = ACTIONS(2443),
    [sym__ternary_qmark] = ACTIONS(2445),
  },
  [658] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2447),
    [anon_sym_STAR] = ACTIONS(2447),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_RBRACE] = ACTIONS(2449),
    [anon_sym_typeof] = ACTIONS(2447),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2447),
    [anon_sym_SEMI] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2447),
    [anon_sym_GT] = ACTIONS(2447),
    [anon_sym_SLASH] = ACTIONS(2447),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2447),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(2449),
    [anon_sym_PIPE_PIPE] = ACTIONS(2449),
    [anon_sym_GT_GT] = ACTIONS(2447),
    [anon_sym_GT_GT_GT] = ACTIONS(2449),
    [anon_sym_LT_LT] = ACTIONS(2449),
    [anon_sym_AMP] = ACTIONS(2447),
    [anon_sym_CARET] = ACTIONS(2449),
    [anon_sym_PIPE] = ACTIONS(2447),
    [anon_sym_PLUS] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(2447),
    [anon_sym_PERCENT] = ACTIONS(2449),
    [anon_sym_STAR_STAR] = ACTIONS(2449),
    [anon_sym_LT_EQ] = ACTIONS(2449),
    [anon_sym_EQ_EQ] = ACTIONS(2447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2449),
    [anon_sym_BANG_EQ] = ACTIONS(2447),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2449),
    [anon_sym_GT_EQ] = ACTIONS(2449),
    [anon_sym_QMARK_QMARK] = ACTIONS(2449),
    [anon_sym_instanceof] = ACTIONS(2447),
    [anon_sym_void] = ACTIONS(2447),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2449),
    [anon_sym_SQUOTE] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2449),
    [sym_number] = ACTIONS(2449),
    [sym_this] = ACTIONS(2447),
    [sym_true] = ACTIONS(2447),
    [sym_false] = ACTIONS(2447),
    [sym_null] = ACTIONS(2447),
    [sym_undefined] = ACTIONS(2447),
    [anon_sym_static] = ACTIONS(2447),
    [anon_sym_readonly] = ACTIONS(2447),
    [anon_sym_get] = ACTIONS(2447),
    [anon_sym_set] = ACTIONS(2447),
    [anon_sym_QMARK] = ACTIONS(2447),
    [anon_sym_any] = ACTIONS(2447),
    [anon_sym_number] = ACTIONS(2447),
    [anon_sym_boolean] = ACTIONS(2447),
    [anon_sym_string] = ACTIONS(2447),
    [anon_sym_symbol] = ACTIONS(2447),
    [anon_sym_abstract] = ACTIONS(2447),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2447),
    [anon_sym_keyof] = ACTIONS(2447),
    [anon_sym_unknown] = ACTIONS(2447),
    [anon_sym_never] = ACTIONS(2447),
    [anon_sym_object] = ACTIONS(2447),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2449),
    [anon_sym_constructor] = ACTIONS(2447),
    [anon_sym_prop] = ACTIONS(2447),
    [anon_sym_id] = ACTIONS(2447),
    [anon_sym_event] = ACTIONS(2447),
    [anon_sym_fn] = ACTIONS(2447),
    [anon_sym_on] = ACTIONS(2447),
    [sym__ternary_qmark] = ACTIONS(2449),
  },
  [659] = {
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(2325),
    [anon_sym_RBRACE] = ACTIONS(2327),
    [anon_sym_typeof] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_in] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2327),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_LT] = ACTIONS(2325),
    [anon_sym_GT] = ACTIONS(2325),
    [anon_sym_SLASH] = ACTIONS(2325),
    [anon_sym_DOT] = ACTIONS(2325),
    [anon_sym_async] = ACTIONS(2325),
    [anon_sym_QMARK_DOT] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2325),
    [anon_sym_AMP_AMP] = ACTIONS(2327),
    [anon_sym_PIPE_PIPE] = ACTIONS(2327),
    [anon_sym_GT_GT] = ACTIONS(2325),
    [anon_sym_GT_GT_GT] = ACTIONS(2327),
    [anon_sym_LT_LT] = ACTIONS(2327),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_CARET] = ACTIONS(2327),
    [anon_sym_PIPE] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2325),
    [anon_sym_PERCENT] = ACTIONS(2327),
    [anon_sym_STAR_STAR] = ACTIONS(2327),
    [anon_sym_LT_EQ] = ACTIONS(2327),
    [anon_sym_EQ_EQ] = ACTIONS(2325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2327),
    [anon_sym_BANG_EQ] = ACTIONS(2325),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2327),
    [anon_sym_GT_EQ] = ACTIONS(2327),
    [anon_sym_QMARK_QMARK] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2325),
    [anon_sym_void] = ACTIONS(2325),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2327),
    [anon_sym_SQUOTE] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [sym_number] = ACTIONS(2327),
    [sym_this] = ACTIONS(2325),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [sym_null] = ACTIONS(2325),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_static] = ACTIONS(2325),
    [anon_sym_readonly] = ACTIONS(2325),
    [anon_sym_get] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(2325),
    [anon_sym_QMARK] = ACTIONS(2325),
    [anon_sym_any] = ACTIONS(2325),
    [anon_sym_number] = ACTIONS(2325),
    [anon_sym_boolean] = ACTIONS(2325),
    [anon_sym_string] = ACTIONS(2325),
    [anon_sym_symbol] = ACTIONS(2325),
    [anon_sym_abstract] = ACTIONS(2325),
    [anon_sym_satisfies] = ACTIONS(2325),
    [anon_sym_extends] = ACTIONS(2325),
    [anon_sym_infer] = ACTIONS(2325),
    [anon_sym_is] = ACTIONS(2451),
    [anon_sym_keyof] = ACTIONS(2325),
    [anon_sym_unknown] = ACTIONS(2325),
    [anon_sym_never] = ACTIONS(2325),
    [anon_sym_object] = ACTIONS(2325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2327),
    [anon_sym_constructor] = ACTIONS(2325),
    [anon_sym_prop] = ACTIONS(2325),
    [anon_sym_id] = ACTIONS(2325),
    [anon_sym_event] = ACTIONS(2325),
    [anon_sym_fn] = ACTIONS(2325),
    [anon_sym_on] = ACTIONS(2325),
    [sym__ternary_qmark] = ACTIONS(2327),
  },
  [660] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2275),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_QMARK_QMARK] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [sym_number] = ACTIONS(2455),
    [sym_this] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_undefined] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_readonly] = ACTIONS(2453),
    [anon_sym_get] = ACTIONS(2453),
    [anon_sym_set] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_any] = ACTIONS(2453),
    [anon_sym_number] = ACTIONS(2453),
    [anon_sym_boolean] = ACTIONS(2453),
    [anon_sym_string] = ACTIONS(2453),
    [anon_sym_symbol] = ACTIONS(2453),
    [anon_sym_abstract] = ACTIONS(2453),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2453),
    [anon_sym_keyof] = ACTIONS(2453),
    [anon_sym_unknown] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_object] = ACTIONS(2453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2455),
    [anon_sym_constructor] = ACTIONS(2453),
    [anon_sym_prop] = ACTIONS(2453),
    [anon_sym_id] = ACTIONS(2453),
    [anon_sym_event] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_on] = ACTIONS(2453),
    [sym__ternary_qmark] = ACTIONS(2317),
  },
  [661] = {
    [sym_arguments] = STATE(749),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2457),
    [anon_sym_as] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_LBRACK] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_DOT] = ACTIONS(2461),
    [anon_sym_async] = ACTIONS(2457),
    [anon_sym_QMARK_DOT] = ACTIONS(2459),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_PIPE_PIPE] = ACTIONS(2459),
    [anon_sym_GT_GT] = ACTIONS(2457),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_CARET] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_STAR_STAR] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_EQ_EQ] = ACTIONS(2457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2459),
    [anon_sym_BANG_EQ] = ACTIONS(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2459),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_QMARK_QMARK] = ACTIONS(2459),
    [anon_sym_instanceof] = ACTIONS(2457),
    [anon_sym_void] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2459),
    [sym_number] = ACTIONS(2459),
    [sym_this] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_undefined] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_readonly] = ACTIONS(2457),
    [anon_sym_get] = ACTIONS(2457),
    [anon_sym_set] = ACTIONS(2457),
    [anon_sym_QMARK] = ACTIONS(2457),
    [anon_sym_any] = ACTIONS(2457),
    [anon_sym_number] = ACTIONS(2457),
    [anon_sym_boolean] = ACTIONS(2457),
    [anon_sym_string] = ACTIONS(2457),
    [anon_sym_symbol] = ACTIONS(2457),
    [anon_sym_abstract] = ACTIONS(2457),
    [anon_sym_satisfies] = ACTIONS(2457),
    [anon_sym_extends] = ACTIONS(2457),
    [anon_sym_infer] = ACTIONS(2457),
    [anon_sym_keyof] = ACTIONS(2457),
    [anon_sym_unknown] = ACTIONS(2457),
    [anon_sym_never] = ACTIONS(2457),
    [anon_sym_object] = ACTIONS(2457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2459),
    [anon_sym_constructor] = ACTIONS(2457),
    [anon_sym_prop] = ACTIONS(2457),
    [anon_sym_id] = ACTIONS(2457),
    [anon_sym_event] = ACTIONS(2457),
    [anon_sym_fn] = ACTIONS(2457),
    [anon_sym_on] = ACTIONS(2457),
    [sym__ternary_qmark] = ACTIONS(2459),
  },
  [662] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(1223),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_QMARK_QMARK] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1219),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_satisfies] = ACTIONS(1219),
    [anon_sym_infer] = ACTIONS(1219),
    [anon_sym_keyof] = ACTIONS(1219),
    [anon_sym_unknown] = ACTIONS(1219),
    [anon_sym_never] = ACTIONS(1219),
    [anon_sym_object] = ACTIONS(1219),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
    [anon_sym_constructor] = ACTIONS(1219),
    [anon_sym_prop] = ACTIONS(1219),
    [anon_sym_id] = ACTIONS(1219),
    [anon_sym_event] = ACTIONS(1219),
    [anon_sym_fn] = ACTIONS(1219),
    [anon_sym_on] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(2463),
    [sym__ternary_qmark] = ACTIONS(1223),
  },
  [663] = {
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_LBRACK] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2467),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2467),
    [anon_sym_STAR_STAR] = ACTIONS(2467),
    [anon_sym_LT_EQ] = ACTIONS(2467),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2467),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2467),
    [anon_sym_GT_EQ] = ACTIONS(2467),
    [anon_sym_QMARK_QMARK] = ACTIONS(2467),
    [anon_sym_instanceof] = ACTIONS(2465),
    [anon_sym_void] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [sym_number] = ACTIONS(2467),
    [sym_this] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_null] = ACTIONS(2465),
    [sym_undefined] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_readonly] = ACTIONS(2465),
    [anon_sym_get] = ACTIONS(2465),
    [anon_sym_set] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_any] = ACTIONS(2465),
    [anon_sym_number] = ACTIONS(2465),
    [anon_sym_boolean] = ACTIONS(2465),
    [anon_sym_string] = ACTIONS(2465),
    [anon_sym_symbol] = ACTIONS(2465),
    [anon_sym_abstract] = ACTIONS(2465),
    [anon_sym_satisfies] = ACTIONS(2465),
    [anon_sym_extends] = ACTIONS(2465),
    [anon_sym_infer] = ACTIONS(2465),
    [anon_sym_keyof] = ACTIONS(2465),
    [anon_sym_unknown] = ACTIONS(2465),
    [anon_sym_never] = ACTIONS(2465),
    [anon_sym_object] = ACTIONS(2465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2467),
    [anon_sym_constructor] = ACTIONS(2465),
    [anon_sym_prop] = ACTIONS(2465),
    [anon_sym_id] = ACTIONS(2465),
    [anon_sym_event] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_on] = ACTIONS(2465),
    [sym__ternary_qmark] = ACTIONS(2467),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_export] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_type] = ACTIONS(2473),
    [anon_sym_typeof] = ACTIONS(2473),
    [anon_sym_import] = ACTIONS(2473),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2475),
    [anon_sym_await] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_with] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_debugger] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_LTtemplate_GT] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_async] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_void] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2475),
    [sym_number] = ACTIONS(2475),
    [sym_this] = ACTIONS(2473),
    [sym_super] = ACTIONS(2473),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_undefined] = ACTIONS(2473),
    [anon_sym_AT] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_readonly] = ACTIONS(2473),
    [anon_sym_get] = ACTIONS(2473),
    [anon_sym_set] = ACTIONS(2473),
    [anon_sym_declare] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_override] = ACTIONS(2473),
    [anon_sym_module] = ACTIONS(2473),
    [anon_sym_any] = ACTIONS(2473),
    [anon_sym_number] = ACTIONS(2473),
    [anon_sym_boolean] = ACTIONS(2473),
    [anon_sym_string] = ACTIONS(2473),
    [anon_sym_symbol] = ACTIONS(2473),
    [anon_sym_abstract] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_component] = ACTIONS(2473),
  },
  [666] = {
    [sym_identifier] = ACTIONS(2477),
    [anon_sym_export] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_RBRACE] = ACTIONS(2479),
    [anon_sym_type] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(2477),
    [anon_sym_import] = ACTIONS(2477),
    [anon_sym_var] = ACTIONS(2477),
    [anon_sym_let] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_else] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_LPAREN] = ACTIONS(2479),
    [anon_sym_await] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_with] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_debugger] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_yield] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2479),
    [anon_sym_LTtemplate_GT] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2477),
    [anon_sym_SLASH] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_async] = ACTIONS(2477),
    [anon_sym_function] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_void] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2479),
    [sym_number] = ACTIONS(2479),
    [sym_this] = ACTIONS(2477),
    [sym_super] = ACTIONS(2477),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [sym_null] = ACTIONS(2477),
    [sym_undefined] = ACTIONS(2477),
    [anon_sym_AT] = ACTIONS(2479),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_readonly] = ACTIONS(2477),
    [anon_sym_get] = ACTIONS(2477),
    [anon_sym_set] = ACTIONS(2477),
    [anon_sym_declare] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_override] = ACTIONS(2477),
    [anon_sym_module] = ACTIONS(2477),
    [anon_sym_any] = ACTIONS(2477),
    [anon_sym_number] = ACTIONS(2477),
    [anon_sym_boolean] = ACTIONS(2477),
    [anon_sym_string] = ACTIONS(2477),
    [anon_sym_symbol] = ACTIONS(2477),
    [anon_sym_abstract] = ACTIONS(2477),
    [anon_sym_interface] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_component] = ACTIONS(2477),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2481),
    [anon_sym_export] = ACTIONS(2481),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_RBRACE] = ACTIONS(2483),
    [anon_sym_type] = ACTIONS(2481),
    [anon_sym_typeof] = ACTIONS(2481),
    [anon_sym_import] = ACTIONS(2481),
    [anon_sym_var] = ACTIONS(2481),
    [anon_sym_let] = ACTIONS(2481),
    [anon_sym_const] = ACTIONS(2481),
    [anon_sym_BANG] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2481),
    [anon_sym_if] = ACTIONS(2481),
    [anon_sym_switch] = ACTIONS(2481),
    [anon_sym_for] = ACTIONS(2481),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_await] = ACTIONS(2481),
    [anon_sym_while] = ACTIONS(2481),
    [anon_sym_do] = ACTIONS(2481),
    [anon_sym_try] = ACTIONS(2481),
    [anon_sym_with] = ACTIONS(2481),
    [anon_sym_break] = ACTIONS(2481),
    [anon_sym_continue] = ACTIONS(2481),
    [anon_sym_debugger] = ACTIONS(2481),
    [anon_sym_return] = ACTIONS(2481),
    [anon_sym_throw] = ACTIONS(2481),
    [anon_sym_SEMI] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2481),
    [anon_sym_default] = ACTIONS(2481),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_LTtemplate_GT] = ACTIONS(2483),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_SLASH] = ACTIONS(2481),
    [anon_sym_class] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2481),
    [anon_sym_function] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2481),
    [anon_sym_PLUS] = ACTIONS(2481),
    [anon_sym_DASH] = ACTIONS(2481),
    [anon_sym_TILDE] = ACTIONS(2483),
    [anon_sym_void] = ACTIONS(2481),
    [anon_sym_delete] = ACTIONS(2481),
    [anon_sym_PLUS_PLUS] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2483),
    [anon_sym_DQUOTE] = ACTIONS(2483),
    [anon_sym_SQUOTE] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2483),
    [sym_number] = ACTIONS(2483),
    [sym_this] = ACTIONS(2481),
    [sym_super] = ACTIONS(2481),
    [sym_true] = ACTIONS(2481),
    [sym_false] = ACTIONS(2481),
    [sym_null] = ACTIONS(2481),
    [sym_undefined] = ACTIONS(2481),
    [anon_sym_AT] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2481),
    [anon_sym_readonly] = ACTIONS(2481),
    [anon_sym_get] = ACTIONS(2481),
    [anon_sym_set] = ACTIONS(2481),
    [anon_sym_declare] = ACTIONS(2481),
    [anon_sym_namespace] = ACTIONS(2481),
    [anon_sym_public] = ACTIONS(2481),
    [anon_sym_private] = ACTIONS(2481),
    [anon_sym_protected] = ACTIONS(2481),
    [anon_sym_override] = ACTIONS(2481),
    [anon_sym_module] = ACTIONS(2481),
    [anon_sym_any] = ACTIONS(2481),
    [anon_sym_number] = ACTIONS(2481),
    [anon_sym_boolean] = ACTIONS(2481),
    [anon_sym_string] = ACTIONS(2481),
    [anon_sym_symbol] = ACTIONS(2481),
    [anon_sym_abstract] = ACTIONS(2481),
    [anon_sym_interface] = ACTIONS(2481),
    [anon_sym_enum] = ACTIONS(2481),
    [anon_sym_component] = ACTIONS(2481),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(2485),
    [anon_sym_import] = ACTIONS(2485),
    [anon_sym_var] = ACTIONS(2485),
    [anon_sym_let] = ACTIONS(2485),
    [anon_sym_const] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2487),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_switch] = ACTIONS(2485),
    [anon_sym_for] = ACTIONS(2485),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_await] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_try] = ACTIONS(2485),
    [anon_sym_with] = ACTIONS(2485),
    [anon_sym_break] = ACTIONS(2485),
    [anon_sym_continue] = ACTIONS(2485),
    [anon_sym_debugger] = ACTIONS(2485),
    [anon_sym_return] = ACTIONS(2485),
    [anon_sym_throw] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_case] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(2485),
    [anon_sym_yield] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [anon_sym_LTtemplate_GT] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_class] = ACTIONS(2485),
    [anon_sym_async] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_void] = ACTIONS(2485),
    [anon_sym_delete] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2487),
    [anon_sym_DASH_DASH] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [sym_number] = ACTIONS(2487),
    [sym_this] = ACTIONS(2485),
    [sym_super] = ACTIONS(2485),
    [sym_true] = ACTIONS(2485),
    [sym_false] = ACTIONS(2485),
    [sym_null] = ACTIONS(2485),
    [sym_undefined] = ACTIONS(2485),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_static] = ACTIONS(2485),
    [anon_sym_readonly] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_override] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
    [anon_sym_abstract] = ACTIONS(2485),
    [anon_sym_interface] = ACTIONS(2485),
    [anon_sym_enum] = ACTIONS(2485),
    [anon_sym_component] = ACTIONS(2485),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2489),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_async] = ACTIONS(2489),
    [anon_sym_QMARK_DOT] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2489),
    [anon_sym_GT_GT_GT] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2489),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_BANG_EQ] = ACTIONS(2489),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2491),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_QMARK_QMARK] = ACTIONS(2491),
    [anon_sym_instanceof] = ACTIONS(2489),
    [anon_sym_void] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2491),
    [anon_sym_DQUOTE] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2491),
    [sym_number] = ACTIONS(2491),
    [sym_this] = ACTIONS(2489),
    [sym_true] = ACTIONS(2489),
    [sym_false] = ACTIONS(2489),
    [sym_null] = ACTIONS(2489),
    [sym_undefined] = ACTIONS(2489),
    [anon_sym_static] = ACTIONS(2489),
    [anon_sym_readonly] = ACTIONS(2489),
    [anon_sym_get] = ACTIONS(2489),
    [anon_sym_set] = ACTIONS(2489),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_any] = ACTIONS(2489),
    [anon_sym_number] = ACTIONS(2489),
    [anon_sym_boolean] = ACTIONS(2489),
    [anon_sym_string] = ACTIONS(2489),
    [anon_sym_symbol] = ACTIONS(2489),
    [anon_sym_abstract] = ACTIONS(2489),
    [anon_sym_satisfies] = ACTIONS(2489),
    [anon_sym_extends] = ACTIONS(2489),
    [anon_sym_infer] = ACTIONS(2489),
    [anon_sym_keyof] = ACTIONS(2489),
    [anon_sym_unknown] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_object] = ACTIONS(2489),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2491),
    [anon_sym_constructor] = ACTIONS(2489),
    [anon_sym_prop] = ACTIONS(2489),
    [anon_sym_id] = ACTIONS(2489),
    [anon_sym_event] = ACTIONS(2489),
    [anon_sym_fn] = ACTIONS(2489),
    [anon_sym_on] = ACTIONS(2489),
    [sym__ternary_qmark] = ACTIONS(2491),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2496),
    [anon_sym_import] = ACTIONS(2496),
    [anon_sym_var] = ACTIONS(2496),
    [anon_sym_let] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_with] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_debugger] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_LTtemplate_GT] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_async] = ACTIONS(2496),
    [anon_sym_function] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_void] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [sym_number] = ACTIONS(2498),
    [sym_this] = ACTIONS(2496),
    [sym_super] = ACTIONS(2496),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [sym_null] = ACTIONS(2496),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_AT] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_readonly] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(2496),
    [anon_sym_declare] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_public] = ACTIONS(2496),
    [anon_sym_private] = ACTIONS(2496),
    [anon_sym_protected] = ACTIONS(2496),
    [anon_sym_override] = ACTIONS(2496),
    [anon_sym_module] = ACTIONS(2496),
    [anon_sym_any] = ACTIONS(2496),
    [anon_sym_number] = ACTIONS(2496),
    [anon_sym_boolean] = ACTIONS(2496),
    [anon_sym_string] = ACTIONS(2496),
    [anon_sym_symbol] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2496),
    [anon_sym_interface] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_component] = ACTIONS(2496),
  },
  [671] = {
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2500),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_var] = ACTIONS(2500),
    [anon_sym_let] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_with] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_debugger] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LTtemplate_GT] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_async] = ACTIONS(2500),
    [anon_sym_function] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_void] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_number] = ACTIONS(2502),
    [sym_this] = ACTIONS(2500),
    [sym_super] = ACTIONS(2500),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [sym_null] = ACTIONS(2500),
    [sym_undefined] = ACTIONS(2500),
    [anon_sym_AT] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_readonly] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2500),
    [anon_sym_set] = ACTIONS(2500),
    [anon_sym_declare] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_override] = ACTIONS(2500),
    [anon_sym_module] = ACTIONS(2500),
    [anon_sym_any] = ACTIONS(2500),
    [anon_sym_number] = ACTIONS(2500),
    [anon_sym_boolean] = ACTIONS(2500),
    [anon_sym_string] = ACTIONS(2500),
    [anon_sym_symbol] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2500),
    [anon_sym_interface] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_component] = ACTIONS(2500),
  },
  [672] = {
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2504),
    [anon_sym_import] = ACTIONS(2504),
    [anon_sym_var] = ACTIONS(2504),
    [anon_sym_let] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_with] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_debugger] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LTtemplate_GT] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_async] = ACTIONS(2504),
    [anon_sym_function] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_void] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_number] = ACTIONS(2506),
    [sym_this] = ACTIONS(2504),
    [sym_super] = ACTIONS(2504),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [sym_null] = ACTIONS(2504),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_readonly] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2504),
    [anon_sym_set] = ACTIONS(2504),
    [anon_sym_declare] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_override] = ACTIONS(2504),
    [anon_sym_module] = ACTIONS(2504),
    [anon_sym_any] = ACTIONS(2504),
    [anon_sym_number] = ACTIONS(2504),
    [anon_sym_boolean] = ACTIONS(2504),
    [anon_sym_string] = ACTIONS(2504),
    [anon_sym_symbol] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2504),
    [anon_sym_interface] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_component] = ACTIONS(2504),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_export] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_import] = ACTIONS(2508),
    [anon_sym_var] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_await] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_with] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_debugger] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LTtemplate_GT] = ACTIONS(2510),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_void] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [sym_number] = ACTIONS(2510),
    [sym_this] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [sym_null] = ACTIONS(2508),
    [sym_undefined] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_readonly] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2508),
    [anon_sym_set] = ACTIONS(2508),
    [anon_sym_declare] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_override] = ACTIONS(2508),
    [anon_sym_module] = ACTIONS(2508),
    [anon_sym_any] = ACTIONS(2508),
    [anon_sym_number] = ACTIONS(2508),
    [anon_sym_boolean] = ACTIONS(2508),
    [anon_sym_string] = ACTIONS(2508),
    [anon_sym_symbol] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2508),
    [anon_sym_interface] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_component] = ACTIONS(2508),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2512),
    [anon_sym_export] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2512),
    [anon_sym_typeof] = ACTIONS(2512),
    [anon_sym_import] = ACTIONS(2512),
    [anon_sym_var] = ACTIONS(2512),
    [anon_sym_let] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_await] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_with] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_debugger] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LTtemplate_GT] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_SLASH] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_async] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_void] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2514),
    [sym_number] = ACTIONS(2514),
    [sym_this] = ACTIONS(2512),
    [sym_super] = ACTIONS(2512),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [sym_null] = ACTIONS(2512),
    [sym_undefined] = ACTIONS(2512),
    [anon_sym_AT] = ACTIONS(2514),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_readonly] = ACTIONS(2512),
    [anon_sym_get] = ACTIONS(2512),
    [anon_sym_set] = ACTIONS(2512),
    [anon_sym_declare] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_public] = ACTIONS(2512),
    [anon_sym_private] = ACTIONS(2512),
    [anon_sym_protected] = ACTIONS(2512),
    [anon_sym_override] = ACTIONS(2512),
    [anon_sym_module] = ACTIONS(2512),
    [anon_sym_any] = ACTIONS(2512),
    [anon_sym_number] = ACTIONS(2512),
    [anon_sym_boolean] = ACTIONS(2512),
    [anon_sym_string] = ACTIONS(2512),
    [anon_sym_symbol] = ACTIONS(2512),
    [anon_sym_abstract] = ACTIONS(2512),
    [anon_sym_interface] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_component] = ACTIONS(2512),
  },
  [675] = {
    [sym_identifier] = ACTIONS(2516),
    [anon_sym_export] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_type] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2516),
    [anon_sym_import] = ACTIONS(2516),
    [anon_sym_var] = ACTIONS(2516),
    [anon_sym_let] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_switch] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_await] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_do] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [anon_sym_with] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_debugger] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_throw] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_case] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LTtemplate_GT] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_async] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2516),
    [anon_sym_DASH] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_void] = ACTIONS(2516),
    [anon_sym_delete] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2518),
    [sym_number] = ACTIONS(2518),
    [sym_this] = ACTIONS(2516),
    [sym_super] = ACTIONS(2516),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [sym_null] = ACTIONS(2516),
    [sym_undefined] = ACTIONS(2516),
    [anon_sym_AT] = ACTIONS(2518),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_readonly] = ACTIONS(2516),
    [anon_sym_get] = ACTIONS(2516),
    [anon_sym_set] = ACTIONS(2516),
    [anon_sym_declare] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_override] = ACTIONS(2516),
    [anon_sym_module] = ACTIONS(2516),
    [anon_sym_any] = ACTIONS(2516),
    [anon_sym_number] = ACTIONS(2516),
    [anon_sym_boolean] = ACTIONS(2516),
    [anon_sym_string] = ACTIONS(2516),
    [anon_sym_symbol] = ACTIONS(2516),
    [anon_sym_abstract] = ACTIONS(2516),
    [anon_sym_interface] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_component] = ACTIONS(2516),
  },
  [676] = {
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_import] = ACTIONS(1411),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_let] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_try] = ACTIONS(1411),
    [anon_sym_with] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_debugger] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_throw] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_class] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_function] = ACTIONS(1411),
    [anon_sym_new] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1413),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_delete] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [sym_number] = ACTIONS(1413),
    [sym_this] = ACTIONS(1411),
    [sym_super] = ACTIONS(1411),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_readonly] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1411),
    [anon_sym_public] = ACTIONS(1411),
    [anon_sym_private] = ACTIONS(1411),
    [anon_sym_protected] = ACTIONS(1411),
    [anon_sym_override] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [anon_sym_abstract] = ACTIONS(1411),
    [anon_sym_interface] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_component] = ACTIONS(1411),
  },
  [677] = {
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(2520),
    [anon_sym_as] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_typeof] = ACTIONS(2520),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_SLASH] = ACTIONS(2520),
    [anon_sym_DOT] = ACTIONS(2520),
    [anon_sym_async] = ACTIONS(2520),
    [anon_sym_QMARK_DOT] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_GT_GT_GT] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_CARET] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_PERCENT] = ACTIONS(2522),
    [anon_sym_STAR_STAR] = ACTIONS(2522),
    [anon_sym_LT_EQ] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2522),
    [anon_sym_BANG_EQ] = ACTIONS(2520),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2522),
    [anon_sym_GT_EQ] = ACTIONS(2522),
    [anon_sym_QMARK_QMARK] = ACTIONS(2522),
    [anon_sym_instanceof] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2522),
    [sym_number] = ACTIONS(2522),
    [sym_this] = ACTIONS(2520),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [sym_null] = ACTIONS(2520),
    [sym_undefined] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_readonly] = ACTIONS(2520),
    [anon_sym_get] = ACTIONS(2520),
    [anon_sym_set] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_any] = ACTIONS(2520),
    [anon_sym_number] = ACTIONS(2520),
    [anon_sym_boolean] = ACTIONS(2520),
    [anon_sym_string] = ACTIONS(2520),
    [anon_sym_symbol] = ACTIONS(2520),
    [anon_sym_abstract] = ACTIONS(2520),
    [anon_sym_satisfies] = ACTIONS(2520),
    [anon_sym_extends] = ACTIONS(2520),
    [anon_sym_infer] = ACTIONS(2520),
    [anon_sym_keyof] = ACTIONS(2520),
    [anon_sym_unknown] = ACTIONS(2520),
    [anon_sym_never] = ACTIONS(2520),
    [anon_sym_object] = ACTIONS(2520),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2522),
    [anon_sym_constructor] = ACTIONS(2520),
    [anon_sym_prop] = ACTIONS(2520),
    [anon_sym_id] = ACTIONS(2520),
    [anon_sym_event] = ACTIONS(2520),
    [anon_sym_fn] = ACTIONS(2520),
    [anon_sym_on] = ACTIONS(2520),
    [sym__ternary_qmark] = ACTIONS(2522),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_typeof] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_var] = ACTIONS(2524),
    [anon_sym_let] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_await] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_with] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_debugger] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_yield] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_LTtemplate_GT] = ACTIONS(2526),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_SLASH] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_function] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2526),
    [sym_number] = ACTIONS(2526),
    [sym_this] = ACTIONS(2524),
    [sym_super] = ACTIONS(2524),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [sym_null] = ACTIONS(2524),
    [sym_undefined] = ACTIONS(2524),
    [anon_sym_AT] = ACTIONS(2526),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_readonly] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_override] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [anon_sym_abstract] = ACTIONS(2524),
    [anon_sym_interface] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_component] = ACTIONS(2524),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2528),
    [anon_sym_export] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2528),
    [anon_sym_typeof] = ACTIONS(2528),
    [anon_sym_import] = ACTIONS(2528),
    [anon_sym_var] = ACTIONS(2528),
    [anon_sym_let] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_await] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_with] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_debugger] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [anon_sym_LTtemplate_GT] = ACTIONS(2530),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_SLASH] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_async] = ACTIONS(2528),
    [anon_sym_function] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_void] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2530),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2528),
    [sym_super] = ACTIONS(2528),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [sym_null] = ACTIONS(2528),
    [sym_undefined] = ACTIONS(2528),
    [anon_sym_AT] = ACTIONS(2530),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_readonly] = ACTIONS(2528),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_public] = ACTIONS(2528),
    [anon_sym_private] = ACTIONS(2528),
    [anon_sym_protected] = ACTIONS(2528),
    [anon_sym_override] = ACTIONS(2528),
    [anon_sym_module] = ACTIONS(2528),
    [anon_sym_any] = ACTIONS(2528),
    [anon_sym_number] = ACTIONS(2528),
    [anon_sym_boolean] = ACTIONS(2528),
    [anon_sym_string] = ACTIONS(2528),
    [anon_sym_symbol] = ACTIONS(2528),
    [anon_sym_abstract] = ACTIONS(2528),
    [anon_sym_interface] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_component] = ACTIONS(2528),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2532),
    [anon_sym_export] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_import] = ACTIONS(2532),
    [anon_sym_var] = ACTIONS(2532),
    [anon_sym_let] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_await] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_with] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_debugger] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_yield] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2534),
    [anon_sym_LTtemplate_GT] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_SLASH] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_async] = ACTIONS(2532),
    [anon_sym_function] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_void] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [sym_number] = ACTIONS(2534),
    [sym_this] = ACTIONS(2532),
    [sym_super] = ACTIONS(2532),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [sym_null] = ACTIONS(2532),
    [sym_undefined] = ACTIONS(2532),
    [anon_sym_AT] = ACTIONS(2534),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_readonly] = ACTIONS(2532),
    [anon_sym_get] = ACTIONS(2532),
    [anon_sym_set] = ACTIONS(2532),
    [anon_sym_declare] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_override] = ACTIONS(2532),
    [anon_sym_module] = ACTIONS(2532),
    [anon_sym_any] = ACTIONS(2532),
    [anon_sym_number] = ACTIONS(2532),
    [anon_sym_boolean] = ACTIONS(2532),
    [anon_sym_string] = ACTIONS(2532),
    [anon_sym_symbol] = ACTIONS(2532),
    [anon_sym_abstract] = ACTIONS(2532),
    [anon_sym_interface] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_component] = ACTIONS(2532),
  },
  [681] = {
    [sym_identifier] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_typeof] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1221),
    [anon_sym_QMARK_DOT] = ACTIONS(1225),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1221),
    [anon_sym_void] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1225),
    [sym_this] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_null] = ACTIONS(1221),
    [sym_undefined] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_readonly] = ACTIONS(1221),
    [anon_sym_get] = ACTIONS(1221),
    [anon_sym_set] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1221),
    [anon_sym_any] = ACTIONS(1221),
    [anon_sym_number] = ACTIONS(1221),
    [anon_sym_boolean] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [anon_sym_symbol] = ACTIONS(1221),
    [anon_sym_abstract] = ACTIONS(1221),
    [anon_sym_satisfies] = ACTIONS(1221),
    [anon_sym_infer] = ACTIONS(1221),
    [anon_sym_keyof] = ACTIONS(1221),
    [anon_sym_unknown] = ACTIONS(1221),
    [anon_sym_never] = ACTIONS(1221),
    [anon_sym_object] = ACTIONS(1221),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1225),
    [anon_sym_constructor] = ACTIONS(1221),
    [anon_sym_prop] = ACTIONS(1221),
    [anon_sym_id] = ACTIONS(1221),
    [anon_sym_event] = ACTIONS(1221),
    [anon_sym_fn] = ACTIONS(1221),
    [anon_sym_on] = ACTIONS(1221),
    [sym__ternary_qmark] = ACTIONS(1225),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_export] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_type] = ACTIONS(2536),
    [anon_sym_typeof] = ACTIONS(2536),
    [anon_sym_import] = ACTIONS(2536),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_await] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_with] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_debugger] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2538),
    [anon_sym_LTtemplate_GT] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_async] = ACTIONS(2536),
    [anon_sym_function] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_void] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2538),
    [sym_number] = ACTIONS(2538),
    [sym_this] = ACTIONS(2536),
    [sym_super] = ACTIONS(2536),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [sym_null] = ACTIONS(2536),
    [sym_undefined] = ACTIONS(2536),
    [anon_sym_AT] = ACTIONS(2538),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_readonly] = ACTIONS(2536),
    [anon_sym_get] = ACTIONS(2536),
    [anon_sym_set] = ACTIONS(2536),
    [anon_sym_declare] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_public] = ACTIONS(2536),
    [anon_sym_private] = ACTIONS(2536),
    [anon_sym_protected] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_module] = ACTIONS(2536),
    [anon_sym_any] = ACTIONS(2536),
    [anon_sym_number] = ACTIONS(2536),
    [anon_sym_boolean] = ACTIONS(2536),
    [anon_sym_string] = ACTIONS(2536),
    [anon_sym_symbol] = ACTIONS(2536),
    [anon_sym_abstract] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_component] = ACTIONS(2536),
  },
  [683] = {
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_typeof] = ACTIONS(2540),
    [anon_sym_import] = ACTIONS(2540),
    [anon_sym_var] = ACTIONS(2540),
    [anon_sym_let] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_await] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_with] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_debugger] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_yield] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2542),
    [anon_sym_LTtemplate_GT] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_SLASH] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(2542),
    [anon_sym_DASH_DASH] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2542),
    [sym_number] = ACTIONS(2542),
    [sym_this] = ACTIONS(2540),
    [sym_super] = ACTIONS(2540),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [sym_null] = ACTIONS(2540),
    [sym_undefined] = ACTIONS(2540),
    [anon_sym_AT] = ACTIONS(2542),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_readonly] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_override] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [anon_sym_abstract] = ACTIONS(2540),
    [anon_sym_interface] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_component] = ACTIONS(2540),
  },
  [684] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [685] = {
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_as] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_SLASH] = ACTIONS(2548),
    [anon_sym_DOT] = ACTIONS(2548),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_QMARK_DOT] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_GT_GT] = ACTIONS(2548),
    [anon_sym_GT_GT_GT] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_CARET] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_PERCENT] = ACTIONS(2550),
    [anon_sym_STAR_STAR] = ACTIONS(2550),
    [anon_sym_LT_EQ] = ACTIONS(2550),
    [anon_sym_EQ_EQ] = ACTIONS(2548),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2550),
    [anon_sym_BANG_EQ] = ACTIONS(2548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2550),
    [anon_sym_GT_EQ] = ACTIONS(2550),
    [anon_sym_QMARK_QMARK] = ACTIONS(2550),
    [anon_sym_instanceof] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2550),
    [sym_number] = ACTIONS(2550),
    [sym_this] = ACTIONS(2548),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [sym_null] = ACTIONS(2548),
    [sym_undefined] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_readonly] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [anon_sym_abstract] = ACTIONS(2548),
    [anon_sym_satisfies] = ACTIONS(2548),
    [anon_sym_extends] = ACTIONS(2548),
    [anon_sym_infer] = ACTIONS(2548),
    [anon_sym_keyof] = ACTIONS(2548),
    [anon_sym_unknown] = ACTIONS(2548),
    [anon_sym_never] = ACTIONS(2548),
    [anon_sym_object] = ACTIONS(2548),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2550),
    [anon_sym_constructor] = ACTIONS(2548),
    [anon_sym_prop] = ACTIONS(2548),
    [anon_sym_id] = ACTIONS(2548),
    [anon_sym_event] = ACTIONS(2548),
    [anon_sym_fn] = ACTIONS(2548),
    [anon_sym_on] = ACTIONS(2548),
    [sym__ternary_qmark] = ACTIONS(2550),
  },
  [686] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [687] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [688] = {
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_as] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_SLASH] = ACTIONS(2552),
    [anon_sym_DOT] = ACTIONS(2552),
    [anon_sym_async] = ACTIONS(2552),
    [anon_sym_QMARK_DOT] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_GT_GT] = ACTIONS(2552),
    [anon_sym_GT_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PERCENT] = ACTIONS(2554),
    [anon_sym_STAR_STAR] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2554),
    [anon_sym_BANG_EQ] = ACTIONS(2552),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_QMARK_QMARK] = ACTIONS(2554),
    [anon_sym_instanceof] = ACTIONS(2552),
    [anon_sym_void] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [sym_number] = ACTIONS(2554),
    [sym_this] = ACTIONS(2552),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_undefined] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_readonly] = ACTIONS(2552),
    [anon_sym_get] = ACTIONS(2552),
    [anon_sym_set] = ACTIONS(2552),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_any] = ACTIONS(2552),
    [anon_sym_number] = ACTIONS(2552),
    [anon_sym_boolean] = ACTIONS(2552),
    [anon_sym_string] = ACTIONS(2552),
    [anon_sym_symbol] = ACTIONS(2552),
    [anon_sym_abstract] = ACTIONS(2552),
    [anon_sym_satisfies] = ACTIONS(2552),
    [anon_sym_extends] = ACTIONS(2552),
    [anon_sym_infer] = ACTIONS(2552),
    [anon_sym_keyof] = ACTIONS(2552),
    [anon_sym_unknown] = ACTIONS(2552),
    [anon_sym_never] = ACTIONS(2552),
    [anon_sym_object] = ACTIONS(2552),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2554),
    [anon_sym_constructor] = ACTIONS(2552),
    [anon_sym_prop] = ACTIONS(2552),
    [anon_sym_id] = ACTIONS(2552),
    [anon_sym_event] = ACTIONS(2552),
    [anon_sym_fn] = ACTIONS(2552),
    [anon_sym_on] = ACTIONS(2552),
    [sym__ternary_qmark] = ACTIONS(2554),
  },
  [689] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_type] = ACTIONS(2558),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_var] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2560),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_switch] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_await] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_with] = ACTIONS(2558),
    [anon_sym_break] = ACTIONS(2558),
    [anon_sym_continue] = ACTIONS(2558),
    [anon_sym_debugger] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_throw] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_default] = ACTIONS(2558),
    [anon_sym_yield] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_LTtemplate_GT] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_SLASH] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(2558),
    [anon_sym_async] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_new] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_void] = ACTIONS(2558),
    [anon_sym_delete] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_number] = ACTIONS(2560),
    [sym_this] = ACTIONS(2558),
    [sym_super] = ACTIONS(2558),
    [sym_true] = ACTIONS(2558),
    [sym_false] = ACTIONS(2558),
    [sym_null] = ACTIONS(2558),
    [sym_undefined] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_get] = ACTIONS(2558),
    [anon_sym_set] = ACTIONS(2558),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_namespace] = ACTIONS(2558),
    [anon_sym_public] = ACTIONS(2558),
    [anon_sym_private] = ACTIONS(2558),
    [anon_sym_protected] = ACTIONS(2558),
    [anon_sym_override] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_any] = ACTIONS(2558),
    [anon_sym_number] = ACTIONS(2558),
    [anon_sym_boolean] = ACTIONS(2558),
    [anon_sym_string] = ACTIONS(2558),
    [anon_sym_symbol] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_interface] = ACTIONS(2558),
    [anon_sym_enum] = ACTIONS(2558),
    [anon_sym_component] = ACTIONS(2558),
  },
  [690] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_as] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_typeof] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_GT_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2564),
    [anon_sym_STAR_STAR] = ACTIONS(2564),
    [anon_sym_LT_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_BANG_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2564),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_QMARK_QMARK] = ACTIONS(2564),
    [anon_sym_instanceof] = ACTIONS(2562),
    [anon_sym_void] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_regex_flags] = ACTIONS(2566),
    [sym_number] = ACTIONS(2564),
    [sym_this] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_null] = ACTIONS(2562),
    [sym_undefined] = ACTIONS(2562),
    [anon_sym_static] = ACTIONS(2562),
    [anon_sym_readonly] = ACTIONS(2562),
    [anon_sym_get] = ACTIONS(2562),
    [anon_sym_set] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_any] = ACTIONS(2562),
    [anon_sym_number] = ACTIONS(2562),
    [anon_sym_boolean] = ACTIONS(2562),
    [anon_sym_string] = ACTIONS(2562),
    [anon_sym_symbol] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_satisfies] = ACTIONS(2562),
    [anon_sym_infer] = ACTIONS(2562),
    [anon_sym_keyof] = ACTIONS(2562),
    [anon_sym_unknown] = ACTIONS(2562),
    [anon_sym_never] = ACTIONS(2562),
    [anon_sym_object] = ACTIONS(2562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2564),
    [anon_sym_constructor] = ACTIONS(2562),
    [anon_sym_prop] = ACTIONS(2562),
    [anon_sym_id] = ACTIONS(2562),
    [anon_sym_event] = ACTIONS(2562),
    [anon_sym_fn] = ACTIONS(2562),
    [anon_sym_on] = ACTIONS(2562),
    [sym__ternary_qmark] = ACTIONS(2564),
  },
  [691] = {
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2568),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(2568),
    [anon_sym_import] = ACTIONS(2568),
    [anon_sym_var] = ACTIONS(2568),
    [anon_sym_let] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_switch] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_await] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_with] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_debugger] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_throw] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_yield] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2570),
    [anon_sym_LTtemplate_GT] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2568),
    [anon_sym_SLASH] = ACTIONS(2568),
    [anon_sym_class] = ACTIONS(2568),
    [anon_sym_async] = ACTIONS(2568),
    [anon_sym_function] = ACTIONS(2568),
    [anon_sym_new] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_void] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2570),
    [anon_sym_DASH_DASH] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2570),
    [sym_number] = ACTIONS(2570),
    [sym_this] = ACTIONS(2568),
    [sym_super] = ACTIONS(2568),
    [sym_true] = ACTIONS(2568),
    [sym_false] = ACTIONS(2568),
    [sym_null] = ACTIONS(2568),
    [sym_undefined] = ACTIONS(2568),
    [anon_sym_AT] = ACTIONS(2570),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_readonly] = ACTIONS(2568),
    [anon_sym_get] = ACTIONS(2568),
    [anon_sym_set] = ACTIONS(2568),
    [anon_sym_declare] = ACTIONS(2568),
    [anon_sym_namespace] = ACTIONS(2568),
    [anon_sym_public] = ACTIONS(2568),
    [anon_sym_private] = ACTIONS(2568),
    [anon_sym_protected] = ACTIONS(2568),
    [anon_sym_override] = ACTIONS(2568),
    [anon_sym_module] = ACTIONS(2568),
    [anon_sym_any] = ACTIONS(2568),
    [anon_sym_number] = ACTIONS(2568),
    [anon_sym_boolean] = ACTIONS(2568),
    [anon_sym_string] = ACTIONS(2568),
    [anon_sym_symbol] = ACTIONS(2568),
    [anon_sym_abstract] = ACTIONS(2568),
    [anon_sym_interface] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_component] = ACTIONS(2568),
  },
  [692] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [693] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [694] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [695] = {
    [sym_identifier] = ACTIONS(2572),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_typeof] = ACTIONS(2572),
    [anon_sym_import] = ACTIONS(2572),
    [anon_sym_var] = ACTIONS(2572),
    [anon_sym_let] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_await] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_with] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_debugger] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_yield] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_LTtemplate_GT] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2572),
    [anon_sym_SLASH] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2574),
    [sym_number] = ACTIONS(2574),
    [sym_this] = ACTIONS(2572),
    [sym_super] = ACTIONS(2572),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [sym_null] = ACTIONS(2572),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2574),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_override] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [anon_sym_abstract] = ACTIONS(2572),
    [anon_sym_interface] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_component] = ACTIONS(2572),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [697] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_RBRACE] = ACTIONS(2578),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_typeof] = ACTIONS(2576),
    [anon_sym_import] = ACTIONS(2576),
    [anon_sym_var] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_await] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_with] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_debugger] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_yield] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LTtemplate_GT] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2576),
    [anon_sym_SLASH] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_function] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_TILDE] = ACTIONS(2578),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(2578),
    [anon_sym_DASH_DASH] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2578),
    [sym_number] = ACTIONS(2578),
    [sym_this] = ACTIONS(2576),
    [sym_super] = ACTIONS(2576),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [sym_null] = ACTIONS(2576),
    [sym_undefined] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_readonly] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_override] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [anon_sym_abstract] = ACTIONS(2576),
    [anon_sym_interface] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_component] = ACTIONS(2576),
  },
  [698] = {
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_type] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(2580),
    [anon_sym_import] = ACTIONS(2580),
    [anon_sym_var] = ACTIONS(2580),
    [anon_sym_let] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_await] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_with] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_debugger] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_yield] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LTtemplate_GT] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_async] = ACTIONS(2580),
    [anon_sym_function] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_void] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [sym_number] = ACTIONS(2582),
    [sym_this] = ACTIONS(2580),
    [sym_super] = ACTIONS(2580),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [sym_null] = ACTIONS(2580),
    [sym_undefined] = ACTIONS(2580),
    [anon_sym_AT] = ACTIONS(2582),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_readonly] = ACTIONS(2580),
    [anon_sym_get] = ACTIONS(2580),
    [anon_sym_set] = ACTIONS(2580),
    [anon_sym_declare] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_public] = ACTIONS(2580),
    [anon_sym_private] = ACTIONS(2580),
    [anon_sym_protected] = ACTIONS(2580),
    [anon_sym_override] = ACTIONS(2580),
    [anon_sym_module] = ACTIONS(2580),
    [anon_sym_any] = ACTIONS(2580),
    [anon_sym_number] = ACTIONS(2580),
    [anon_sym_boolean] = ACTIONS(2580),
    [anon_sym_string] = ACTIONS(2580),
    [anon_sym_symbol] = ACTIONS(2580),
    [anon_sym_abstract] = ACTIONS(2580),
    [anon_sym_interface] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_component] = ACTIONS(2580),
  },
  [699] = {
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(1223),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_QMARK_QMARK] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1219),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_satisfies] = ACTIONS(1219),
    [anon_sym_infer] = ACTIONS(1219),
    [anon_sym_keyof] = ACTIONS(1219),
    [anon_sym_unknown] = ACTIONS(1219),
    [anon_sym_never] = ACTIONS(1219),
    [anon_sym_object] = ACTIONS(1219),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
    [anon_sym_constructor] = ACTIONS(1219),
    [anon_sym_prop] = ACTIONS(1219),
    [anon_sym_id] = ACTIONS(1219),
    [anon_sym_event] = ACTIONS(1219),
    [anon_sym_fn] = ACTIONS(1219),
    [anon_sym_on] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(2463),
    [sym__ternary_qmark] = ACTIONS(1223),
  },
  [700] = {
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_export] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2584),
    [anon_sym_typeof] = ACTIONS(2584),
    [anon_sym_import] = ACTIONS(2584),
    [anon_sym_var] = ACTIONS(2584),
    [anon_sym_let] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_await] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_with] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_debugger] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LTtemplate_GT] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_function] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_void] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2584),
    [sym_super] = ACTIONS(2584),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [sym_null] = ACTIONS(2584),
    [sym_undefined] = ACTIONS(2584),
    [anon_sym_AT] = ACTIONS(2586),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_readonly] = ACTIONS(2584),
    [anon_sym_get] = ACTIONS(2584),
    [anon_sym_set] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_public] = ACTIONS(2584),
    [anon_sym_private] = ACTIONS(2584),
    [anon_sym_protected] = ACTIONS(2584),
    [anon_sym_override] = ACTIONS(2584),
    [anon_sym_module] = ACTIONS(2584),
    [anon_sym_any] = ACTIONS(2584),
    [anon_sym_number] = ACTIONS(2584),
    [anon_sym_boolean] = ACTIONS(2584),
    [anon_sym_string] = ACTIONS(2584),
    [anon_sym_symbol] = ACTIONS(2584),
    [anon_sym_abstract] = ACTIONS(2584),
    [anon_sym_interface] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_component] = ACTIONS(2584),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2588),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_import] = ACTIONS(2588),
    [anon_sym_var] = ACTIONS(2588),
    [anon_sym_let] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_await] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_with] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_debugger] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_yield] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LTtemplate_GT] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_void] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2588),
    [sym_super] = ACTIONS(2588),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [sym_null] = ACTIONS(2588),
    [sym_undefined] = ACTIONS(2588),
    [anon_sym_AT] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_get] = ACTIONS(2588),
    [anon_sym_set] = ACTIONS(2588),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_public] = ACTIONS(2588),
    [anon_sym_private] = ACTIONS(2588),
    [anon_sym_protected] = ACTIONS(2588),
    [anon_sym_override] = ACTIONS(2588),
    [anon_sym_module] = ACTIONS(2588),
    [anon_sym_any] = ACTIONS(2588),
    [anon_sym_number] = ACTIONS(2588),
    [anon_sym_boolean] = ACTIONS(2588),
    [anon_sym_string] = ACTIONS(2588),
    [anon_sym_symbol] = ACTIONS(2588),
    [anon_sym_abstract] = ACTIONS(2588),
    [anon_sym_interface] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_component] = ACTIONS(2588),
  },
  [702] = {
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_typeof] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_QMARK_DOT] = ACTIONS(2594),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
    [anon_sym_CARET] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_STAR_STAR] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2594),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2594),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(2594),
    [anon_sym_QMARK_QMARK] = ACTIONS(2594),
    [anon_sym_instanceof] = ACTIONS(2592),
    [anon_sym_void] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [sym_number] = ACTIONS(2594),
    [sym_this] = ACTIONS(2592),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [sym_null] = ACTIONS(2592),
    [sym_undefined] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_readonly] = ACTIONS(2592),
    [anon_sym_get] = ACTIONS(2592),
    [anon_sym_set] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2592),
    [anon_sym_any] = ACTIONS(2592),
    [anon_sym_number] = ACTIONS(2592),
    [anon_sym_boolean] = ACTIONS(2592),
    [anon_sym_string] = ACTIONS(2592),
    [anon_sym_symbol] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_satisfies] = ACTIONS(2592),
    [anon_sym_extends] = ACTIONS(2592),
    [anon_sym_infer] = ACTIONS(2592),
    [anon_sym_keyof] = ACTIONS(2592),
    [anon_sym_unknown] = ACTIONS(2592),
    [anon_sym_never] = ACTIONS(2592),
    [anon_sym_object] = ACTIONS(2592),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2594),
    [anon_sym_constructor] = ACTIONS(2592),
    [anon_sym_prop] = ACTIONS(2592),
    [anon_sym_id] = ACTIONS(2592),
    [anon_sym_event] = ACTIONS(2592),
    [anon_sym_fn] = ACTIONS(2592),
    [anon_sym_on] = ACTIONS(2592),
    [sym__ternary_qmark] = ACTIONS(2594),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2596),
    [anon_sym_as] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_typeof] = ACTIONS(2596),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_QMARK_DOT] = ACTIONS(2598),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_QMARK_QMARK] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2596),
    [anon_sym_void] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2596),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [sym_null] = ACTIONS(2596),
    [sym_undefined] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_readonly] = ACTIONS(2596),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_QMARK] = ACTIONS(2596),
    [anon_sym_any] = ACTIONS(2596),
    [anon_sym_number] = ACTIONS(2596),
    [anon_sym_boolean] = ACTIONS(2596),
    [anon_sym_string] = ACTIONS(2596),
    [anon_sym_symbol] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_satisfies] = ACTIONS(2596),
    [anon_sym_extends] = ACTIONS(2596),
    [anon_sym_infer] = ACTIONS(2596),
    [anon_sym_keyof] = ACTIONS(2596),
    [anon_sym_unknown] = ACTIONS(2596),
    [anon_sym_never] = ACTIONS(2596),
    [anon_sym_object] = ACTIONS(2596),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2598),
    [anon_sym_constructor] = ACTIONS(2596),
    [anon_sym_prop] = ACTIONS(2596),
    [anon_sym_id] = ACTIONS(2596),
    [anon_sym_event] = ACTIONS(2596),
    [anon_sym_fn] = ACTIONS(2596),
    [anon_sym_on] = ACTIONS(2596),
    [sym__ternary_qmark] = ACTIONS(2598),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_var] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_await] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LTtemplate_GT] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_void] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym_number] = ACTIONS(2602),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_readonly] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_component] = ACTIONS(2600),
  },
  [706] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [707] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_QMARK_DOT] = ACTIONS(2606),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_PIPE_PIPE] = ACTIONS(2606),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2606),
    [anon_sym_LT_LT] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_CARET] = ACTIONS(2606),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2606),
    [anon_sym_STAR_STAR] = ACTIONS(2606),
    [anon_sym_LT_EQ] = ACTIONS(2606),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2606),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2606),
    [anon_sym_GT_EQ] = ACTIONS(2606),
    [anon_sym_QMARK_QMARK] = ACTIONS(2606),
    [anon_sym_instanceof] = ACTIONS(2604),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_QMARK] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_satisfies] = ACTIONS(2604),
    [anon_sym_extends] = ACTIONS(2604),
    [anon_sym_infer] = ACTIONS(2604),
    [anon_sym_keyof] = ACTIONS(2604),
    [anon_sym_unknown] = ACTIONS(2604),
    [anon_sym_never] = ACTIONS(2604),
    [anon_sym_object] = ACTIONS(2604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2606),
    [anon_sym_constructor] = ACTIONS(2604),
    [anon_sym_prop] = ACTIONS(2604),
    [anon_sym_id] = ACTIONS(2604),
    [anon_sym_event] = ACTIONS(2604),
    [anon_sym_fn] = ACTIONS(2604),
    [anon_sym_on] = ACTIONS(2604),
    [sym__ternary_qmark] = ACTIONS(2606),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_STAR] = ACTIONS(2608),
    [anon_sym_as] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2608),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_in] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_EQ] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_DOT] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_QMARK_DOT] = ACTIONS(2610),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_GT_GT] = ACTIONS(2608),
    [anon_sym_GT_GT_GT] = ACTIONS(2610),
    [anon_sym_LT_LT] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2608),
    [anon_sym_CARET] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_PERCENT] = ACTIONS(2610),
    [anon_sym_STAR_STAR] = ACTIONS(2610),
    [anon_sym_LT_EQ] = ACTIONS(2610),
    [anon_sym_EQ_EQ] = ACTIONS(2608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2610),
    [anon_sym_BANG_EQ] = ACTIONS(2608),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2610),
    [anon_sym_GT_EQ] = ACTIONS(2610),
    [anon_sym_QMARK_QMARK] = ACTIONS(2610),
    [anon_sym_instanceof] = ACTIONS(2608),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_QMARK] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_satisfies] = ACTIONS(2608),
    [anon_sym_infer] = ACTIONS(2608),
    [anon_sym_keyof] = ACTIONS(2608),
    [anon_sym_unknown] = ACTIONS(2608),
    [anon_sym_never] = ACTIONS(2608),
    [anon_sym_object] = ACTIONS(2608),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2610),
    [anon_sym_constructor] = ACTIONS(2608),
    [anon_sym_prop] = ACTIONS(2608),
    [anon_sym_id] = ACTIONS(2608),
    [anon_sym_event] = ACTIONS(2608),
    [anon_sym_fn] = ACTIONS(2608),
    [anon_sym_on] = ACTIONS(2608),
    [sym__ternary_qmark] = ACTIONS(2610),
  },
  [710] = {
    [sym_identifier] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [anon_sym_typeof] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2614),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_QMARK_DOT] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2614),
    [anon_sym_GT_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2614),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_STAR_STAR] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2614),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2616),
    [anon_sym_QMARK_QMARK] = ACTIONS(2616),
    [anon_sym_instanceof] = ACTIONS(2614),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [sym_number] = ACTIONS(2616),
    [sym_this] = ACTIONS(2614),
    [sym_true] = ACTIONS(2614),
    [sym_false] = ACTIONS(2614),
    [sym_null] = ACTIONS(2614),
    [sym_undefined] = ACTIONS(2614),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_readonly] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_QMARK] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_abstract] = ACTIONS(2614),
    [anon_sym_satisfies] = ACTIONS(2614),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2614),
    [anon_sym_keyof] = ACTIONS(2614),
    [anon_sym_unknown] = ACTIONS(2614),
    [anon_sym_never] = ACTIONS(2614),
    [anon_sym_object] = ACTIONS(2614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2616),
    [anon_sym_constructor] = ACTIONS(2614),
    [anon_sym_prop] = ACTIONS(2614),
    [anon_sym_id] = ACTIONS(2614),
    [anon_sym_event] = ACTIONS(2614),
    [anon_sym_fn] = ACTIONS(2614),
    [anon_sym_on] = ACTIONS(2614),
    [sym__ternary_qmark] = ACTIONS(2616),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_as] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2624),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_async] = ACTIONS(2622),
    [anon_sym_QMARK_DOT] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_GT_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_STAR_STAR] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2624),
    [anon_sym_QMARK_QMARK] = ACTIONS(2624),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2624),
    [anon_sym_DQUOTE] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2624),
    [sym_number] = ACTIONS(2624),
    [sym_this] = ACTIONS(2622),
    [sym_true] = ACTIONS(2622),
    [sym_false] = ACTIONS(2622),
    [sym_null] = ACTIONS(2622),
    [sym_undefined] = ACTIONS(2622),
    [anon_sym_static] = ACTIONS(2622),
    [anon_sym_readonly] = ACTIONS(2622),
    [anon_sym_get] = ACTIONS(2622),
    [anon_sym_set] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_any] = ACTIONS(2622),
    [anon_sym_number] = ACTIONS(2622),
    [anon_sym_boolean] = ACTIONS(2622),
    [anon_sym_string] = ACTIONS(2622),
    [anon_sym_symbol] = ACTIONS(2622),
    [anon_sym_abstract] = ACTIONS(2622),
    [anon_sym_satisfies] = ACTIONS(2622),
    [anon_sym_extends] = ACTIONS(2628),
    [anon_sym_infer] = ACTIONS(2622),
    [anon_sym_keyof] = ACTIONS(2622),
    [anon_sym_unknown] = ACTIONS(2622),
    [anon_sym_never] = ACTIONS(2622),
    [anon_sym_object] = ACTIONS(2622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2624),
    [anon_sym_constructor] = ACTIONS(2622),
    [anon_sym_prop] = ACTIONS(2622),
    [anon_sym_id] = ACTIONS(2622),
    [anon_sym_event] = ACTIONS(2622),
    [anon_sym_fn] = ACTIONS(2622),
    [anon_sym_on] = ACTIONS(2622),
    [sym__ternary_qmark] = ACTIONS(2624),
  },
  [712] = {
    [sym_identifier] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_as] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_typeof] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(2630),
    [anon_sym_QMARK_DOT] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_GT_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2630),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_PIPE] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_STAR_STAR] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2632),
    [anon_sym_QMARK_QMARK] = ACTIONS(2632),
    [anon_sym_instanceof] = ACTIONS(2630),
    [anon_sym_void] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [sym_number] = ACTIONS(2632),
    [sym_this] = ACTIONS(2630),
    [sym_true] = ACTIONS(2630),
    [sym_false] = ACTIONS(2630),
    [sym_null] = ACTIONS(2630),
    [sym_undefined] = ACTIONS(2630),
    [anon_sym_static] = ACTIONS(2630),
    [anon_sym_readonly] = ACTIONS(2630),
    [anon_sym_get] = ACTIONS(2630),
    [anon_sym_set] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_abstract] = ACTIONS(2630),
    [anon_sym_satisfies] = ACTIONS(2630),
    [anon_sym_extends] = ACTIONS(2630),
    [anon_sym_infer] = ACTIONS(2630),
    [anon_sym_keyof] = ACTIONS(2630),
    [anon_sym_unknown] = ACTIONS(2630),
    [anon_sym_never] = ACTIONS(2630),
    [anon_sym_object] = ACTIONS(2630),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2632),
    [anon_sym_constructor] = ACTIONS(2630),
    [anon_sym_prop] = ACTIONS(2630),
    [anon_sym_id] = ACTIONS(2630),
    [anon_sym_event] = ACTIONS(2630),
    [anon_sym_fn] = ACTIONS(2630),
    [anon_sym_on] = ACTIONS(2630),
    [sym__ternary_qmark] = ACTIONS(2632),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_export] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_type] = ACTIONS(2634),
    [anon_sym_typeof] = ACTIONS(2634),
    [anon_sym_import] = ACTIONS(2634),
    [anon_sym_var] = ACTIONS(2634),
    [anon_sym_let] = ACTIONS(2634),
    [anon_sym_const] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_if] = ACTIONS(2634),
    [anon_sym_switch] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_await] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_try] = ACTIONS(2634),
    [anon_sym_with] = ACTIONS(2634),
    [anon_sym_break] = ACTIONS(2634),
    [anon_sym_continue] = ACTIONS(2634),
    [anon_sym_debugger] = ACTIONS(2634),
    [anon_sym_return] = ACTIONS(2634),
    [anon_sym_throw] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_default] = ACTIONS(2634),
    [anon_sym_yield] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_LTtemplate_GT] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_class] = ACTIONS(2634),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_function] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_delete] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_undefined] = ACTIONS(2634),
    [anon_sym_AT] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2634),
    [anon_sym_readonly] = ACTIONS(2634),
    [anon_sym_get] = ACTIONS(2634),
    [anon_sym_set] = ACTIONS(2634),
    [anon_sym_declare] = ACTIONS(2634),
    [anon_sym_namespace] = ACTIONS(2634),
    [anon_sym_public] = ACTIONS(2634),
    [anon_sym_private] = ACTIONS(2634),
    [anon_sym_protected] = ACTIONS(2634),
    [anon_sym_override] = ACTIONS(2634),
    [anon_sym_module] = ACTIONS(2634),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [anon_sym_abstract] = ACTIONS(2634),
    [anon_sym_interface] = ACTIONS(2634),
    [anon_sym_enum] = ACTIONS(2634),
    [anon_sym_component] = ACTIONS(2634),
  },
  [714] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_QMARK_DOT] = ACTIONS(1347),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_GT_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1347),
    [anon_sym_QMARK_QMARK] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_QMARK] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_satisfies] = ACTIONS(1345),
    [anon_sym_infer] = ACTIONS(1345),
    [anon_sym_keyof] = ACTIONS(1345),
    [anon_sym_unknown] = ACTIONS(1345),
    [anon_sym_never] = ACTIONS(1345),
    [anon_sym_object] = ACTIONS(1345),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1347),
    [anon_sym_constructor] = ACTIONS(1345),
    [anon_sym_prop] = ACTIONS(1345),
    [anon_sym_id] = ACTIONS(1345),
    [anon_sym_event] = ACTIONS(1345),
    [anon_sym_fn] = ACTIONS(1345),
    [anon_sym_on] = ACTIONS(1345),
    [sym__automatic_semicolon] = ACTIONS(2638),
    [sym__ternary_qmark] = ACTIONS(1347),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_export] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_typeof] = ACTIONS(2640),
    [anon_sym_import] = ACTIONS(2640),
    [anon_sym_var] = ACTIONS(2640),
    [anon_sym_let] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_else] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_switch] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_await] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [anon_sym_with] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_debugger] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_throw] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LTtemplate_GT] = ACTIONS(2642),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_async] = ACTIONS(2640),
    [anon_sym_function] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [anon_sym_void] = ACTIONS(2640),
    [anon_sym_delete] = ACTIONS(2640),
    [anon_sym_PLUS_PLUS] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2642),
    [anon_sym_DQUOTE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2642),
    [sym_number] = ACTIONS(2642),
    [sym_this] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_null] = ACTIONS(2640),
    [sym_undefined] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(2642),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_readonly] = ACTIONS(2640),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_public] = ACTIONS(2640),
    [anon_sym_private] = ACTIONS(2640),
    [anon_sym_protected] = ACTIONS(2640),
    [anon_sym_override] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_any] = ACTIONS(2640),
    [anon_sym_number] = ACTIONS(2640),
    [anon_sym_boolean] = ACTIONS(2640),
    [anon_sym_string] = ACTIONS(2640),
    [anon_sym_symbol] = ACTIONS(2640),
    [anon_sym_abstract] = ACTIONS(2640),
    [anon_sym_interface] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_component] = ACTIONS(2640),
  },
  [716] = {
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_as] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_typeof] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_async] = ACTIONS(2644),
    [anon_sym_QMARK_DOT] = ACTIONS(2646),
    [anon_sym_new] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_GT_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_STAR_STAR] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2646),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_QMARK_QMARK] = ACTIONS(2646),
    [anon_sym_instanceof] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2644),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_number] = ACTIONS(2646),
    [sym_this] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_null] = ACTIONS(2644),
    [sym_undefined] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_readonly] = ACTIONS(2644),
    [anon_sym_get] = ACTIONS(2644),
    [anon_sym_set] = ACTIONS(2644),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_any] = ACTIONS(2644),
    [anon_sym_number] = ACTIONS(2644),
    [anon_sym_boolean] = ACTIONS(2644),
    [anon_sym_string] = ACTIONS(2644),
    [anon_sym_symbol] = ACTIONS(2644),
    [anon_sym_abstract] = ACTIONS(2644),
    [anon_sym_satisfies] = ACTIONS(2644),
    [anon_sym_extends] = ACTIONS(2644),
    [anon_sym_infer] = ACTIONS(2644),
    [anon_sym_keyof] = ACTIONS(2644),
    [anon_sym_unknown] = ACTIONS(2644),
    [anon_sym_never] = ACTIONS(2644),
    [anon_sym_object] = ACTIONS(2644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2646),
    [anon_sym_constructor] = ACTIONS(2644),
    [anon_sym_prop] = ACTIONS(2644),
    [anon_sym_id] = ACTIONS(2644),
    [anon_sym_event] = ACTIONS(2644),
    [anon_sym_fn] = ACTIONS(2644),
    [anon_sym_on] = ACTIONS(2644),
    [sym__ternary_qmark] = ACTIONS(2646),
  },
  [717] = {
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_as] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_typeof] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2650),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2650),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_async] = ACTIONS(2648),
    [anon_sym_QMARK_DOT] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2650),
    [anon_sym_PIPE_PIPE] = ACTIONS(2650),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2650),
    [anon_sym_LT_LT] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2650),
    [anon_sym_STAR_STAR] = ACTIONS(2650),
    [anon_sym_LT_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2650),
    [anon_sym_BANG_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2650),
    [anon_sym_GT_EQ] = ACTIONS(2650),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2648),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2650),
    [sym_number] = ACTIONS(2650),
    [sym_this] = ACTIONS(2648),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [sym_null] = ACTIONS(2648),
    [sym_undefined] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_readonly] = ACTIONS(2648),
    [anon_sym_get] = ACTIONS(2648),
    [anon_sym_set] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_satisfies] = ACTIONS(2648),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2648),
    [anon_sym_keyof] = ACTIONS(2648),
    [anon_sym_unknown] = ACTIONS(2648),
    [anon_sym_never] = ACTIONS(2648),
    [anon_sym_object] = ACTIONS(2648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2650),
    [anon_sym_constructor] = ACTIONS(2648),
    [anon_sym_prop] = ACTIONS(2648),
    [anon_sym_id] = ACTIONS(2648),
    [anon_sym_event] = ACTIONS(2648),
    [anon_sym_fn] = ACTIONS(2648),
    [anon_sym_on] = ACTIONS(2648),
    [sym__ternary_qmark] = ACTIONS(2650),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2652),
    [anon_sym_as] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2652),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2652),
    [anon_sym_GT] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_async] = ACTIONS(2652),
    [anon_sym_QMARK_DOT] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_PIPE_PIPE] = ACTIONS(2654),
    [anon_sym_GT_GT] = ACTIONS(2652),
    [anon_sym_GT_GT_GT] = ACTIONS(2654),
    [anon_sym_LT_LT] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_CARET] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_PERCENT] = ACTIONS(2654),
    [anon_sym_STAR_STAR] = ACTIONS(2654),
    [anon_sym_LT_EQ] = ACTIONS(2654),
    [anon_sym_EQ_EQ] = ACTIONS(2652),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2654),
    [anon_sym_BANG_EQ] = ACTIONS(2652),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2654),
    [anon_sym_GT_EQ] = ACTIONS(2654),
    [anon_sym_QMARK_QMARK] = ACTIONS(2654),
    [anon_sym_instanceof] = ACTIONS(2652),
    [anon_sym_void] = ACTIONS(2652),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2654),
    [sym_number] = ACTIONS(2654),
    [sym_this] = ACTIONS(2652),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [sym_null] = ACTIONS(2652),
    [sym_undefined] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_readonly] = ACTIONS(2652),
    [anon_sym_get] = ACTIONS(2652),
    [anon_sym_set] = ACTIONS(2652),
    [anon_sym_QMARK] = ACTIONS(2652),
    [anon_sym_any] = ACTIONS(2652),
    [anon_sym_number] = ACTIONS(2652),
    [anon_sym_boolean] = ACTIONS(2652),
    [anon_sym_string] = ACTIONS(2652),
    [anon_sym_symbol] = ACTIONS(2652),
    [anon_sym_abstract] = ACTIONS(2652),
    [anon_sym_satisfies] = ACTIONS(2652),
    [anon_sym_extends] = ACTIONS(2652),
    [anon_sym_infer] = ACTIONS(2652),
    [anon_sym_keyof] = ACTIONS(2652),
    [anon_sym_unknown] = ACTIONS(2652),
    [anon_sym_never] = ACTIONS(2652),
    [anon_sym_object] = ACTIONS(2652),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2654),
    [anon_sym_constructor] = ACTIONS(2652),
    [anon_sym_prop] = ACTIONS(2652),
    [anon_sym_id] = ACTIONS(2652),
    [anon_sym_event] = ACTIONS(2652),
    [anon_sym_fn] = ACTIONS(2652),
    [anon_sym_on] = ACTIONS(2652),
    [sym__ternary_qmark] = ACTIONS(2654),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2656),
    [anon_sym_as] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_typeof] = ACTIONS(2656),
    [anon_sym_BANG] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2656),
    [anon_sym_SLASH] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_QMARK_DOT] = ACTIONS(2658),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2656),
    [anon_sym_GT_GT_GT] = ACTIONS(2658),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2658),
    [anon_sym_STAR_STAR] = ACTIONS(2658),
    [anon_sym_LT_EQ] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2658),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2658),
    [anon_sym_GT_EQ] = ACTIONS(2658),
    [anon_sym_QMARK_QMARK] = ACTIONS(2658),
    [anon_sym_instanceof] = ACTIONS(2656),
    [anon_sym_void] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [sym_number] = ACTIONS(2658),
    [sym_this] = ACTIONS(2656),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [sym_null] = ACTIONS(2656),
    [sym_undefined] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_readonly] = ACTIONS(2656),
    [anon_sym_get] = ACTIONS(2656),
    [anon_sym_set] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_any] = ACTIONS(2656),
    [anon_sym_number] = ACTIONS(2656),
    [anon_sym_boolean] = ACTIONS(2656),
    [anon_sym_string] = ACTIONS(2656),
    [anon_sym_symbol] = ACTIONS(2656),
    [anon_sym_abstract] = ACTIONS(2656),
    [anon_sym_satisfies] = ACTIONS(2656),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2656),
    [anon_sym_keyof] = ACTIONS(2656),
    [anon_sym_unknown] = ACTIONS(2656),
    [anon_sym_never] = ACTIONS(2656),
    [anon_sym_object] = ACTIONS(2656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2658),
    [anon_sym_constructor] = ACTIONS(2656),
    [anon_sym_prop] = ACTIONS(2656),
    [anon_sym_id] = ACTIONS(2656),
    [anon_sym_event] = ACTIONS(2656),
    [anon_sym_fn] = ACTIONS(2656),
    [anon_sym_on] = ACTIONS(2656),
    [sym__ternary_qmark] = ACTIONS(2658),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_typeof] = ACTIONS(2660),
    [anon_sym_import] = ACTIONS(2660),
    [anon_sym_var] = ACTIONS(2660),
    [anon_sym_let] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_await] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_with] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_debugger] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2662),
    [anon_sym_LTtemplate_GT] = ACTIONS(2662),
    [anon_sym_LT] = ACTIONS(2660),
    [anon_sym_SLASH] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_void] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [sym_number] = ACTIONS(2662),
    [sym_this] = ACTIONS(2660),
    [sym_super] = ACTIONS(2660),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [sym_null] = ACTIONS(2660),
    [sym_undefined] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_readonly] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_override] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_abstract] = ACTIONS(2660),
    [anon_sym_interface] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_component] = ACTIONS(2660),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_typeof] = ACTIONS(2664),
    [anon_sym_import] = ACTIONS(2664),
    [anon_sym_var] = ACTIONS(2664),
    [anon_sym_let] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_await] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_with] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_debugger] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_yield] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2666),
    [anon_sym_LTtemplate_GT] = ACTIONS(2666),
    [anon_sym_LT] = ACTIONS(2664),
    [anon_sym_SLASH] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2666),
    [sym_number] = ACTIONS(2666),
    [sym_this] = ACTIONS(2664),
    [sym_super] = ACTIONS(2664),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [sym_null] = ACTIONS(2664),
    [sym_undefined] = ACTIONS(2664),
    [anon_sym_AT] = ACTIONS(2666),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_readonly] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_override] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_abstract] = ACTIONS(2664),
    [anon_sym_interface] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_component] = ACTIONS(2664),
  },
  [722] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [724] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [725] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [726] = {
    [sym_identifier] = ACTIONS(2668),
    [anon_sym_export] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2668),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_import] = ACTIONS(2668),
    [anon_sym_var] = ACTIONS(2668),
    [anon_sym_let] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_else] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_await] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_with] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_debugger] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_yield] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LTtemplate_GT] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2668),
    [anon_sym_SLASH] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_async] = ACTIONS(2668),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2668),
    [sym_super] = ACTIONS(2668),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [sym_null] = ACTIONS(2668),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(2670),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_readonly] = ACTIONS(2668),
    [anon_sym_get] = ACTIONS(2668),
    [anon_sym_set] = ACTIONS(2668),
    [anon_sym_declare] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_public] = ACTIONS(2668),
    [anon_sym_private] = ACTIONS(2668),
    [anon_sym_protected] = ACTIONS(2668),
    [anon_sym_override] = ACTIONS(2668),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_any] = ACTIONS(2668),
    [anon_sym_number] = ACTIONS(2668),
    [anon_sym_boolean] = ACTIONS(2668),
    [anon_sym_string] = ACTIONS(2668),
    [anon_sym_symbol] = ACTIONS(2668),
    [anon_sym_abstract] = ACTIONS(2668),
    [anon_sym_interface] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_component] = ACTIONS(2668),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [728] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [729] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [730] = {
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_STAR] = ACTIONS(2672),
    [anon_sym_as] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_typeof] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(2672),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_in] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_EQ] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2672),
    [anon_sym_GT] = ACTIONS(2672),
    [anon_sym_SLASH] = ACTIONS(2672),
    [anon_sym_DOT] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_QMARK_DOT] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2672),
    [anon_sym_GT_GT_GT] = ACTIONS(2674),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_CARET] = ACTIONS(2674),
    [anon_sym_PIPE] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_PERCENT] = ACTIONS(2674),
    [anon_sym_STAR_STAR] = ACTIONS(2674),
    [anon_sym_LT_EQ] = ACTIONS(2674),
    [anon_sym_EQ_EQ] = ACTIONS(2672),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2674),
    [anon_sym_BANG_EQ] = ACTIONS(2672),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2674),
    [anon_sym_GT_EQ] = ACTIONS(2674),
    [anon_sym_QMARK_QMARK] = ACTIONS(2674),
    [anon_sym_instanceof] = ACTIONS(2672),
    [anon_sym_void] = ACTIONS(2672),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2674),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_readonly] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_QMARK] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_abstract] = ACTIONS(2672),
    [anon_sym_satisfies] = ACTIONS(2672),
    [anon_sym_infer] = ACTIONS(2672),
    [anon_sym_keyof] = ACTIONS(2672),
    [anon_sym_unknown] = ACTIONS(2672),
    [anon_sym_never] = ACTIONS(2672),
    [anon_sym_object] = ACTIONS(2672),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2674),
    [anon_sym_constructor] = ACTIONS(2672),
    [anon_sym_prop] = ACTIONS(2672),
    [anon_sym_id] = ACTIONS(2672),
    [anon_sym_event] = ACTIONS(2672),
    [anon_sym_fn] = ACTIONS(2672),
    [anon_sym_on] = ACTIONS(2672),
    [sym__ternary_qmark] = ACTIONS(2674),
  },
  [731] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2682),
    [anon_sym_typeof] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_var] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_switch] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_await] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [anon_sym_do] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_with] = ACTIONS(2682),
    [anon_sym_break] = ACTIONS(2682),
    [anon_sym_continue] = ACTIONS(2682),
    [anon_sym_debugger] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_throw] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2682),
    [anon_sym_default] = ACTIONS(2682),
    [anon_sym_yield] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_LTtemplate_GT] = ACTIONS(2684),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2682),
    [anon_sym_async] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_new] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2684),
    [anon_sym_void] = ACTIONS(2682),
    [anon_sym_delete] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2684),
    [anon_sym_DQUOTE] = ACTIONS(2684),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2684),
    [sym_number] = ACTIONS(2684),
    [sym_this] = ACTIONS(2682),
    [sym_super] = ACTIONS(2682),
    [sym_true] = ACTIONS(2682),
    [sym_false] = ACTIONS(2682),
    [sym_null] = ACTIONS(2682),
    [sym_undefined] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_readonly] = ACTIONS(2682),
    [anon_sym_get] = ACTIONS(2682),
    [anon_sym_set] = ACTIONS(2682),
    [anon_sym_declare] = ACTIONS(2682),
    [anon_sym_namespace] = ACTIONS(2682),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_any] = ACTIONS(2682),
    [anon_sym_number] = ACTIONS(2682),
    [anon_sym_boolean] = ACTIONS(2682),
    [anon_sym_string] = ACTIONS(2682),
    [anon_sym_symbol] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_interface] = ACTIONS(2682),
    [anon_sym_enum] = ACTIONS(2682),
    [anon_sym_component] = ACTIONS(2682),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [734] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_as] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_typeof] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_GT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_async] = ACTIONS(2686),
    [anon_sym_QMARK_DOT] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_GT_GT] = ACTIONS(2686),
    [anon_sym_GT_GT_GT] = ACTIONS(2688),
    [anon_sym_LT_LT] = ACTIONS(2688),
    [anon_sym_AMP] = ACTIONS(2686),
    [anon_sym_CARET] = ACTIONS(2688),
    [anon_sym_PIPE] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_PERCENT] = ACTIONS(2688),
    [anon_sym_STAR_STAR] = ACTIONS(2688),
    [anon_sym_LT_EQ] = ACTIONS(2688),
    [anon_sym_EQ_EQ] = ACTIONS(2686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2688),
    [anon_sym_BANG_EQ] = ACTIONS(2686),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2688),
    [anon_sym_GT_EQ] = ACTIONS(2688),
    [anon_sym_QMARK_QMARK] = ACTIONS(2688),
    [anon_sym_instanceof] = ACTIONS(2686),
    [anon_sym_void] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2686),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_static] = ACTIONS(2686),
    [anon_sym_readonly] = ACTIONS(2686),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_QMARK] = ACTIONS(2686),
    [anon_sym_any] = ACTIONS(2686),
    [anon_sym_number] = ACTIONS(2686),
    [anon_sym_boolean] = ACTIONS(2686),
    [anon_sym_string] = ACTIONS(2686),
    [anon_sym_symbol] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_satisfies] = ACTIONS(2686),
    [anon_sym_extends] = ACTIONS(2686),
    [anon_sym_infer] = ACTIONS(2686),
    [anon_sym_keyof] = ACTIONS(2686),
    [anon_sym_unknown] = ACTIONS(2686),
    [anon_sym_never] = ACTIONS(2686),
    [anon_sym_object] = ACTIONS(2686),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2688),
    [anon_sym_constructor] = ACTIONS(2686),
    [anon_sym_prop] = ACTIONS(2686),
    [anon_sym_id] = ACTIONS(2686),
    [anon_sym_event] = ACTIONS(2686),
    [anon_sym_fn] = ACTIONS(2686),
    [anon_sym_on] = ACTIONS(2686),
    [sym__ternary_qmark] = ACTIONS(2688),
  },
  [735] = {
    [sym_identifier] = ACTIONS(1451),
    [anon_sym_export] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_type] = ACTIONS(1451),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym_import] = ACTIONS(1451),
    [anon_sym_var] = ACTIONS(1451),
    [anon_sym_let] = ACTIONS(1451),
    [anon_sym_const] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_switch] = ACTIONS(1451),
    [anon_sym_for] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_await] = ACTIONS(1451),
    [anon_sym_while] = ACTIONS(1451),
    [anon_sym_do] = ACTIONS(1451),
    [anon_sym_try] = ACTIONS(1451),
    [anon_sym_with] = ACTIONS(1451),
    [anon_sym_break] = ACTIONS(1451),
    [anon_sym_continue] = ACTIONS(1451),
    [anon_sym_debugger] = ACTIONS(1451),
    [anon_sym_return] = ACTIONS(1451),
    [anon_sym_throw] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1451),
    [anon_sym_default] = ACTIONS(1451),
    [anon_sym_yield] = ACTIONS(1451),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_class] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_function] = ACTIONS(1451),
    [anon_sym_new] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1453),
    [anon_sym_void] = ACTIONS(1451),
    [anon_sym_delete] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1453),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1451),
    [sym_super] = ACTIONS(1451),
    [sym_true] = ACTIONS(1451),
    [sym_false] = ACTIONS(1451),
    [sym_null] = ACTIONS(1451),
    [sym_undefined] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1451),
    [anon_sym_readonly] = ACTIONS(1451),
    [anon_sym_get] = ACTIONS(1451),
    [anon_sym_set] = ACTIONS(1451),
    [anon_sym_declare] = ACTIONS(1451),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_public] = ACTIONS(1451),
    [anon_sym_private] = ACTIONS(1451),
    [anon_sym_protected] = ACTIONS(1451),
    [anon_sym_override] = ACTIONS(1451),
    [anon_sym_module] = ACTIONS(1451),
    [anon_sym_any] = ACTIONS(1451),
    [anon_sym_number] = ACTIONS(1451),
    [anon_sym_boolean] = ACTIONS(1451),
    [anon_sym_string] = ACTIONS(1451),
    [anon_sym_symbol] = ACTIONS(1451),
    [anon_sym_abstract] = ACTIONS(1451),
    [anon_sym_interface] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(1451),
    [anon_sym_component] = ACTIONS(1451),
  },
  [736] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [737] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2690),
    [anon_sym_typeof] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_var] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_switch] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_await] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_with] = ACTIONS(2690),
    [anon_sym_break] = ACTIONS(2690),
    [anon_sym_continue] = ACTIONS(2690),
    [anon_sym_debugger] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_throw] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2690),
    [anon_sym_default] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LTtemplate_GT] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2690),
    [anon_sym_async] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2692),
    [anon_sym_void] = ACTIONS(2690),
    [anon_sym_delete] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_number] = ACTIONS(2692),
    [sym_this] = ACTIONS(2690),
    [sym_super] = ACTIONS(2690),
    [sym_true] = ACTIONS(2690),
    [sym_false] = ACTIONS(2690),
    [sym_null] = ACTIONS(2690),
    [sym_undefined] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2690),
    [anon_sym_readonly] = ACTIONS(2690),
    [anon_sym_get] = ACTIONS(2690),
    [anon_sym_set] = ACTIONS(2690),
    [anon_sym_declare] = ACTIONS(2690),
    [anon_sym_namespace] = ACTIONS(2690),
    [anon_sym_public] = ACTIONS(2690),
    [anon_sym_private] = ACTIONS(2690),
    [anon_sym_protected] = ACTIONS(2690),
    [anon_sym_override] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_any] = ACTIONS(2690),
    [anon_sym_number] = ACTIONS(2690),
    [anon_sym_boolean] = ACTIONS(2690),
    [anon_sym_string] = ACTIONS(2690),
    [anon_sym_symbol] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_interface] = ACTIONS(2690),
    [anon_sym_enum] = ACTIONS(2690),
    [anon_sym_component] = ACTIONS(2690),
  },
  [738] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [739] = {
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_as] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_typeof] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_in] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_DOT] = ACTIONS(2694),
    [anon_sym_async] = ACTIONS(2694),
    [anon_sym_QMARK_DOT] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_GT_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2694),
    [anon_sym_CARET] = ACTIONS(2696),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2696),
    [anon_sym_STAR_STAR] = ACTIONS(2696),
    [anon_sym_LT_EQ] = ACTIONS(2696),
    [anon_sym_EQ_EQ] = ACTIONS(2694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2696),
    [anon_sym_BANG_EQ] = ACTIONS(2694),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2696),
    [anon_sym_GT_EQ] = ACTIONS(2696),
    [anon_sym_QMARK_QMARK] = ACTIONS(2696),
    [anon_sym_instanceof] = ACTIONS(2694),
    [anon_sym_void] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(2696),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2694),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_static] = ACTIONS(2694),
    [anon_sym_readonly] = ACTIONS(2694),
    [anon_sym_get] = ACTIONS(2694),
    [anon_sym_set] = ACTIONS(2694),
    [anon_sym_QMARK] = ACTIONS(2694),
    [anon_sym_any] = ACTIONS(2694),
    [anon_sym_number] = ACTIONS(2694),
    [anon_sym_boolean] = ACTIONS(2694),
    [anon_sym_string] = ACTIONS(2694),
    [anon_sym_symbol] = ACTIONS(2694),
    [anon_sym_abstract] = ACTIONS(2694),
    [anon_sym_satisfies] = ACTIONS(2694),
    [anon_sym_extends] = ACTIONS(2694),
    [anon_sym_infer] = ACTIONS(2694),
    [anon_sym_keyof] = ACTIONS(2694),
    [anon_sym_unknown] = ACTIONS(2694),
    [anon_sym_never] = ACTIONS(2694),
    [anon_sym_object] = ACTIONS(2694),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2696),
    [anon_sym_constructor] = ACTIONS(2694),
    [anon_sym_prop] = ACTIONS(2694),
    [anon_sym_id] = ACTIONS(2694),
    [anon_sym_event] = ACTIONS(2694),
    [anon_sym_fn] = ACTIONS(2694),
    [anon_sym_on] = ACTIONS(2694),
    [sym__ternary_qmark] = ACTIONS(2696),
  },
  [740] = {
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_export] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2700),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_type] = ACTIONS(2698),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_import] = ACTIONS(2698),
    [anon_sym_var] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2700),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_switch] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2700),
    [anon_sym_await] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_break] = ACTIONS(2698),
    [anon_sym_continue] = ACTIONS(2698),
    [anon_sym_debugger] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_throw] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_case] = ACTIONS(2698),
    [anon_sym_default] = ACTIONS(2698),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LTtemplate_GT] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_delete] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2700),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_super] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_AT] = ACTIONS(2700),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2698),
    [anon_sym_namespace] = ACTIONS(2698),
    [anon_sym_public] = ACTIONS(2698),
    [anon_sym_private] = ACTIONS(2698),
    [anon_sym_protected] = ACTIONS(2698),
    [anon_sym_override] = ACTIONS(2698),
    [anon_sym_module] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_interface] = ACTIONS(2698),
    [anon_sym_enum] = ACTIONS(2698),
    [anon_sym_component] = ACTIONS(2698),
  },
  [741] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [742] = {
    [sym_arguments] = STATE(912),
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2702),
    [anon_sym_as] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2702),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2704),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_GT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(2702),
    [anon_sym_async] = ACTIONS(2702),
    [anon_sym_QMARK_DOT] = ACTIONS(2704),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2702),
    [anon_sym_GT_GT_GT] = ACTIONS(2704),
    [anon_sym_LT_LT] = ACTIONS(2704),
    [anon_sym_AMP] = ACTIONS(2702),
    [anon_sym_CARET] = ACTIONS(2704),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_PERCENT] = ACTIONS(2704),
    [anon_sym_STAR_STAR] = ACTIONS(2704),
    [anon_sym_LT_EQ] = ACTIONS(2704),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2704),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2704),
    [anon_sym_GT_EQ] = ACTIONS(2704),
    [anon_sym_QMARK_QMARK] = ACTIONS(2704),
    [anon_sym_instanceof] = ACTIONS(2702),
    [anon_sym_void] = ACTIONS(2702),
    [anon_sym_PLUS_PLUS] = ACTIONS(2704),
    [anon_sym_DASH_DASH] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2704),
    [sym_number] = ACTIONS(2704),
    [sym_this] = ACTIONS(2702),
    [sym_true] = ACTIONS(2702),
    [sym_false] = ACTIONS(2702),
    [sym_null] = ACTIONS(2702),
    [sym_undefined] = ACTIONS(2702),
    [anon_sym_static] = ACTIONS(2702),
    [anon_sym_readonly] = ACTIONS(2702),
    [anon_sym_get] = ACTIONS(2702),
    [anon_sym_set] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_any] = ACTIONS(2702),
    [anon_sym_number] = ACTIONS(2702),
    [anon_sym_boolean] = ACTIONS(2702),
    [anon_sym_string] = ACTIONS(2702),
    [anon_sym_symbol] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_satisfies] = ACTIONS(2702),
    [anon_sym_infer] = ACTIONS(2702),
    [anon_sym_keyof] = ACTIONS(2702),
    [anon_sym_unknown] = ACTIONS(2702),
    [anon_sym_never] = ACTIONS(2702),
    [anon_sym_object] = ACTIONS(2702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2704),
    [anon_sym_constructor] = ACTIONS(2702),
    [anon_sym_prop] = ACTIONS(2702),
    [anon_sym_id] = ACTIONS(2702),
    [anon_sym_event] = ACTIONS(2702),
    [anon_sym_fn] = ACTIONS(2702),
    [anon_sym_on] = ACTIONS(2702),
    [sym__ternary_qmark] = ACTIONS(2704),
  },
  [743] = {
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_type] = ACTIONS(2709),
    [anon_sym_typeof] = ACTIONS(2709),
    [anon_sym_import] = ACTIONS(2709),
    [anon_sym_var] = ACTIONS(2709),
    [anon_sym_let] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_await] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_with] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_debugger] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_yield] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_LTtemplate_GT] = ACTIONS(2711),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_async] = ACTIONS(2709),
    [anon_sym_function] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_void] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2711),
    [sym_number] = ACTIONS(2711),
    [sym_this] = ACTIONS(2709),
    [sym_super] = ACTIONS(2709),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [sym_null] = ACTIONS(2709),
    [sym_undefined] = ACTIONS(2709),
    [anon_sym_AT] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_readonly] = ACTIONS(2709),
    [anon_sym_get] = ACTIONS(2709),
    [anon_sym_set] = ACTIONS(2709),
    [anon_sym_declare] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_public] = ACTIONS(2709),
    [anon_sym_private] = ACTIONS(2709),
    [anon_sym_protected] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2709),
    [anon_sym_module] = ACTIONS(2709),
    [anon_sym_any] = ACTIONS(2709),
    [anon_sym_number] = ACTIONS(2709),
    [anon_sym_boolean] = ACTIONS(2709),
    [anon_sym_string] = ACTIONS(2709),
    [anon_sym_symbol] = ACTIONS(2709),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_interface] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_component] = ACTIONS(2709),
  },
  [744] = {
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_export] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_type] = ACTIONS(2713),
    [anon_sym_typeof] = ACTIONS(2713),
    [anon_sym_import] = ACTIONS(2713),
    [anon_sym_var] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2715),
    [anon_sym_await] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_debugger] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_LTtemplate_GT] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_void] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [sym_number] = ACTIONS(2715),
    [sym_this] = ACTIONS(2713),
    [sym_super] = ACTIONS(2713),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [sym_null] = ACTIONS(2713),
    [sym_undefined] = ACTIONS(2713),
    [anon_sym_AT] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_readonly] = ACTIONS(2713),
    [anon_sym_get] = ACTIONS(2713),
    [anon_sym_set] = ACTIONS(2713),
    [anon_sym_declare] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_public] = ACTIONS(2713),
    [anon_sym_private] = ACTIONS(2713),
    [anon_sym_protected] = ACTIONS(2713),
    [anon_sym_override] = ACTIONS(2713),
    [anon_sym_module] = ACTIONS(2713),
    [anon_sym_any] = ACTIONS(2713),
    [anon_sym_number] = ACTIONS(2713),
    [anon_sym_boolean] = ACTIONS(2713),
    [anon_sym_string] = ACTIONS(2713),
    [anon_sym_symbol] = ACTIONS(2713),
    [anon_sym_abstract] = ACTIONS(2713),
    [anon_sym_interface] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_component] = ACTIONS(2713),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [746] = {
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_as] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_LPAREN] = ACTIONS(2719),
    [anon_sym_in] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2717),
    [anon_sym_GT] = ACTIONS(2717),
    [anon_sym_SLASH] = ACTIONS(2717),
    [anon_sym_DOT] = ACTIONS(2717),
    [anon_sym_async] = ACTIONS(2717),
    [anon_sym_QMARK_DOT] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_GT_GT] = ACTIONS(2717),
    [anon_sym_GT_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_CARET] = ACTIONS(2719),
    [anon_sym_PIPE] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PERCENT] = ACTIONS(2719),
    [anon_sym_STAR_STAR] = ACTIONS(2719),
    [anon_sym_LT_EQ] = ACTIONS(2719),
    [anon_sym_EQ_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2719),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2719),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_QMARK_QMARK] = ACTIONS(2719),
    [anon_sym_instanceof] = ACTIONS(2717),
    [anon_sym_void] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [sym_number] = ACTIONS(2719),
    [sym_this] = ACTIONS(2717),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [sym_null] = ACTIONS(2717),
    [sym_undefined] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_readonly] = ACTIONS(2717),
    [anon_sym_get] = ACTIONS(2717),
    [anon_sym_set] = ACTIONS(2717),
    [anon_sym_QMARK] = ACTIONS(2717),
    [anon_sym_any] = ACTIONS(2717),
    [anon_sym_number] = ACTIONS(2717),
    [anon_sym_boolean] = ACTIONS(2717),
    [anon_sym_string] = ACTIONS(2717),
    [anon_sym_symbol] = ACTIONS(2717),
    [anon_sym_abstract] = ACTIONS(2717),
    [anon_sym_satisfies] = ACTIONS(2717),
    [anon_sym_extends] = ACTIONS(2717),
    [anon_sym_infer] = ACTIONS(2717),
    [anon_sym_keyof] = ACTIONS(2717),
    [anon_sym_unknown] = ACTIONS(2717),
    [anon_sym_never] = ACTIONS(2717),
    [anon_sym_object] = ACTIONS(2717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2719),
    [anon_sym_constructor] = ACTIONS(2717),
    [anon_sym_prop] = ACTIONS(2717),
    [anon_sym_id] = ACTIONS(2717),
    [anon_sym_event] = ACTIONS(2717),
    [anon_sym_fn] = ACTIONS(2717),
    [anon_sym_on] = ACTIONS(2717),
    [sym__ternary_qmark] = ACTIONS(2719),
  },
  [747] = {
    [sym_identifier] = ACTIONS(2721),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_as] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_in] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_async] = ACTIONS(2721),
    [anon_sym_QMARK_DOT] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_GT_GT] = ACTIONS(2721),
    [anon_sym_GT_GT_GT] = ACTIONS(2723),
    [anon_sym_LT_LT] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_CARET] = ACTIONS(2723),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_STAR_STAR] = ACTIONS(2723),
    [anon_sym_LT_EQ] = ACTIONS(2723),
    [anon_sym_EQ_EQ] = ACTIONS(2721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2721),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2723),
    [anon_sym_GT_EQ] = ACTIONS(2723),
    [anon_sym_QMARK_QMARK] = ACTIONS(2723),
    [anon_sym_instanceof] = ACTIONS(2721),
    [anon_sym_void] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2723),
    [sym_number] = ACTIONS(2723),
    [sym_this] = ACTIONS(2721),
    [sym_true] = ACTIONS(2721),
    [sym_false] = ACTIONS(2721),
    [sym_null] = ACTIONS(2721),
    [sym_undefined] = ACTIONS(2721),
    [anon_sym_static] = ACTIONS(2721),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_get] = ACTIONS(2721),
    [anon_sym_set] = ACTIONS(2721),
    [anon_sym_QMARK] = ACTIONS(2721),
    [anon_sym_any] = ACTIONS(2721),
    [anon_sym_number] = ACTIONS(2721),
    [anon_sym_boolean] = ACTIONS(2721),
    [anon_sym_string] = ACTIONS(2721),
    [anon_sym_symbol] = ACTIONS(2721),
    [anon_sym_abstract] = ACTIONS(2721),
    [anon_sym_satisfies] = ACTIONS(2721),
    [anon_sym_extends] = ACTIONS(2721),
    [anon_sym_infer] = ACTIONS(2721),
    [anon_sym_keyof] = ACTIONS(2721),
    [anon_sym_unknown] = ACTIONS(2721),
    [anon_sym_never] = ACTIONS(2721),
    [anon_sym_object] = ACTIONS(2721),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2723),
    [anon_sym_constructor] = ACTIONS(2721),
    [anon_sym_prop] = ACTIONS(2721),
    [anon_sym_id] = ACTIONS(2721),
    [anon_sym_event] = ACTIONS(2721),
    [anon_sym_fn] = ACTIONS(2721),
    [anon_sym_on] = ACTIONS(2721),
    [sym__ternary_qmark] = ACTIONS(2723),
  },
  [748] = {
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2727),
    [anon_sym_typeof] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(2725),
    [anon_sym_SLASH] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_async] = ACTIONS(2725),
    [anon_sym_QMARK_DOT] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2727),
    [anon_sym_PIPE_PIPE] = ACTIONS(2727),
    [anon_sym_GT_GT] = ACTIONS(2725),
    [anon_sym_GT_GT_GT] = ACTIONS(2727),
    [anon_sym_LT_LT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2725),
    [anon_sym_PERCENT] = ACTIONS(2727),
    [anon_sym_STAR_STAR] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2727),
    [anon_sym_EQ_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2727),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2727),
    [anon_sym_GT_EQ] = ACTIONS(2727),
    [anon_sym_QMARK_QMARK] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2725),
    [anon_sym_void] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2727),
    [anon_sym_DQUOTE] = ACTIONS(2727),
    [anon_sym_SQUOTE] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2727),
    [sym_number] = ACTIONS(2727),
    [sym_this] = ACTIONS(2725),
    [sym_true] = ACTIONS(2725),
    [sym_false] = ACTIONS(2725),
    [sym_null] = ACTIONS(2725),
    [sym_undefined] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2725),
    [anon_sym_readonly] = ACTIONS(2725),
    [anon_sym_get] = ACTIONS(2725),
    [anon_sym_set] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_any] = ACTIONS(2725),
    [anon_sym_number] = ACTIONS(2725),
    [anon_sym_boolean] = ACTIONS(2725),
    [anon_sym_string] = ACTIONS(2725),
    [anon_sym_symbol] = ACTIONS(2725),
    [anon_sym_abstract] = ACTIONS(2725),
    [anon_sym_satisfies] = ACTIONS(2725),
    [anon_sym_extends] = ACTIONS(2725),
    [anon_sym_infer] = ACTIONS(2725),
    [anon_sym_keyof] = ACTIONS(2725),
    [anon_sym_unknown] = ACTIONS(2725),
    [anon_sym_never] = ACTIONS(2725),
    [anon_sym_object] = ACTIONS(2725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2727),
    [anon_sym_constructor] = ACTIONS(2725),
    [anon_sym_prop] = ACTIONS(2725),
    [anon_sym_id] = ACTIONS(2725),
    [anon_sym_event] = ACTIONS(2725),
    [anon_sym_fn] = ACTIONS(2725),
    [anon_sym_on] = ACTIONS(2725),
    [sym__ternary_qmark] = ACTIONS(2727),
  },
  [749] = {
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_typeof] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2731),
    [anon_sym_in] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_async] = ACTIONS(2729),
    [anon_sym_QMARK_DOT] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2731),
    [anon_sym_PIPE_PIPE] = ACTIONS(2731),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_GT_GT_GT] = ACTIONS(2731),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_CARET] = ACTIONS(2731),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2731),
    [anon_sym_STAR_STAR] = ACTIONS(2731),
    [anon_sym_LT_EQ] = ACTIONS(2731),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2731),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2731),
    [anon_sym_GT_EQ] = ACTIONS(2731),
    [anon_sym_QMARK_QMARK] = ACTIONS(2731),
    [anon_sym_instanceof] = ACTIONS(2729),
    [anon_sym_void] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_SQUOTE] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2731),
    [sym_number] = ACTIONS(2731),
    [sym_this] = ACTIONS(2729),
    [sym_true] = ACTIONS(2729),
    [sym_false] = ACTIONS(2729),
    [sym_null] = ACTIONS(2729),
    [sym_undefined] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_readonly] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2729),
    [anon_sym_set] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_any] = ACTIONS(2729),
    [anon_sym_number] = ACTIONS(2729),
    [anon_sym_boolean] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(2729),
    [anon_sym_symbol] = ACTIONS(2729),
    [anon_sym_abstract] = ACTIONS(2729),
    [anon_sym_satisfies] = ACTIONS(2729),
    [anon_sym_extends] = ACTIONS(2729),
    [anon_sym_infer] = ACTIONS(2729),
    [anon_sym_keyof] = ACTIONS(2729),
    [anon_sym_unknown] = ACTIONS(2729),
    [anon_sym_never] = ACTIONS(2729),
    [anon_sym_object] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_constructor] = ACTIONS(2729),
    [anon_sym_prop] = ACTIONS(2729),
    [anon_sym_id] = ACTIONS(2729),
    [anon_sym_event] = ACTIONS(2729),
    [anon_sym_fn] = ACTIONS(2729),
    [anon_sym_on] = ACTIONS(2729),
    [sym__ternary_qmark] = ACTIONS(2731),
  },
  [750] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [751] = {
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_as] = ACTIONS(2733),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_typeof] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_LPAREN] = ACTIONS(2735),
    [anon_sym_in] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_LT] = ACTIONS(2733),
    [anon_sym_GT] = ACTIONS(2733),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_DOT] = ACTIONS(2733),
    [anon_sym_async] = ACTIONS(2733),
    [anon_sym_QMARK_DOT] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2735),
    [anon_sym_GT_GT] = ACTIONS(2733),
    [anon_sym_GT_GT_GT] = ACTIONS(2735),
    [anon_sym_LT_LT] = ACTIONS(2735),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_CARET] = ACTIONS(2735),
    [anon_sym_PIPE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_PERCENT] = ACTIONS(2735),
    [anon_sym_STAR_STAR] = ACTIONS(2735),
    [anon_sym_LT_EQ] = ACTIONS(2735),
    [anon_sym_EQ_EQ] = ACTIONS(2733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2735),
    [anon_sym_BANG_EQ] = ACTIONS(2733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2735),
    [anon_sym_GT_EQ] = ACTIONS(2735),
    [anon_sym_QMARK_QMARK] = ACTIONS(2735),
    [anon_sym_instanceof] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(2735),
    [anon_sym_SQUOTE] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2735),
    [sym_number] = ACTIONS(2735),
    [sym_this] = ACTIONS(2733),
    [sym_true] = ACTIONS(2733),
    [sym_false] = ACTIONS(2733),
    [sym_null] = ACTIONS(2733),
    [sym_undefined] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2733),
    [anon_sym_readonly] = ACTIONS(2733),
    [anon_sym_get] = ACTIONS(2733),
    [anon_sym_set] = ACTIONS(2733),
    [anon_sym_QMARK] = ACTIONS(2733),
    [anon_sym_any] = ACTIONS(2733),
    [anon_sym_number] = ACTIONS(2733),
    [anon_sym_boolean] = ACTIONS(2733),
    [anon_sym_string] = ACTIONS(2733),
    [anon_sym_symbol] = ACTIONS(2733),
    [anon_sym_abstract] = ACTIONS(2733),
    [anon_sym_satisfies] = ACTIONS(2733),
    [anon_sym_extends] = ACTIONS(2733),
    [anon_sym_infer] = ACTIONS(2733),
    [anon_sym_keyof] = ACTIONS(2733),
    [anon_sym_unknown] = ACTIONS(2733),
    [anon_sym_never] = ACTIONS(2733),
    [anon_sym_object] = ACTIONS(2733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2735),
    [anon_sym_constructor] = ACTIONS(2733),
    [anon_sym_prop] = ACTIONS(2733),
    [anon_sym_id] = ACTIONS(2733),
    [anon_sym_event] = ACTIONS(2733),
    [anon_sym_fn] = ACTIONS(2733),
    [anon_sym_on] = ACTIONS(2733),
    [sym__ternary_qmark] = ACTIONS(2735),
  },
  [752] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [753] = {
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_as] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(2325),
    [anon_sym_RBRACE] = ACTIONS(2327),
    [anon_sym_typeof] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_in] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2327),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_LT] = ACTIONS(2325),
    [anon_sym_GT] = ACTIONS(2325),
    [anon_sym_SLASH] = ACTIONS(2325),
    [anon_sym_DOT] = ACTIONS(2325),
    [anon_sym_async] = ACTIONS(2325),
    [anon_sym_QMARK_DOT] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2325),
    [anon_sym_AMP_AMP] = ACTIONS(2327),
    [anon_sym_PIPE_PIPE] = ACTIONS(2327),
    [anon_sym_GT_GT] = ACTIONS(2325),
    [anon_sym_GT_GT_GT] = ACTIONS(2327),
    [anon_sym_LT_LT] = ACTIONS(2327),
    [anon_sym_AMP] = ACTIONS(2325),
    [anon_sym_CARET] = ACTIONS(2327),
    [anon_sym_PIPE] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2325),
    [anon_sym_PERCENT] = ACTIONS(2327),
    [anon_sym_STAR_STAR] = ACTIONS(2327),
    [anon_sym_LT_EQ] = ACTIONS(2327),
    [anon_sym_EQ_EQ] = ACTIONS(2325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2327),
    [anon_sym_BANG_EQ] = ACTIONS(2325),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2327),
    [anon_sym_GT_EQ] = ACTIONS(2327),
    [anon_sym_QMARK_QMARK] = ACTIONS(2327),
    [anon_sym_instanceof] = ACTIONS(2325),
    [anon_sym_void] = ACTIONS(2325),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2327),
    [anon_sym_SQUOTE] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [sym_number] = ACTIONS(2327),
    [sym_this] = ACTIONS(2325),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [sym_null] = ACTIONS(2325),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_static] = ACTIONS(2325),
    [anon_sym_readonly] = ACTIONS(2325),
    [anon_sym_get] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(2325),
    [anon_sym_QMARK] = ACTIONS(2325),
    [anon_sym_any] = ACTIONS(2325),
    [anon_sym_number] = ACTIONS(2325),
    [anon_sym_boolean] = ACTIONS(2325),
    [anon_sym_string] = ACTIONS(2325),
    [anon_sym_symbol] = ACTIONS(2325),
    [anon_sym_abstract] = ACTIONS(2325),
    [anon_sym_satisfies] = ACTIONS(2325),
    [anon_sym_extends] = ACTIONS(2325),
    [anon_sym_infer] = ACTIONS(2325),
    [anon_sym_keyof] = ACTIONS(2325),
    [anon_sym_unknown] = ACTIONS(2325),
    [anon_sym_never] = ACTIONS(2325),
    [anon_sym_object] = ACTIONS(2325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2327),
    [anon_sym_constructor] = ACTIONS(2325),
    [anon_sym_prop] = ACTIONS(2325),
    [anon_sym_id] = ACTIONS(2325),
    [anon_sym_event] = ACTIONS(2325),
    [anon_sym_fn] = ACTIONS(2325),
    [anon_sym_on] = ACTIONS(2325),
    [sym__ternary_qmark] = ACTIONS(2327),
  },
  [754] = {
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_as] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2739),
    [anon_sym_typeof] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(2739),
    [anon_sym_in] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2737),
    [anon_sym_GT] = ACTIONS(2737),
    [anon_sym_SLASH] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_QMARK_DOT] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2737),
    [anon_sym_GT_GT_GT] = ACTIONS(2739),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_STAR_STAR] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2739),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2739),
    [anon_sym_GT_EQ] = ACTIONS(2739),
    [anon_sym_QMARK_QMARK] = ACTIONS(2739),
    [anon_sym_instanceof] = ACTIONS(2737),
    [anon_sym_void] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2739),
    [anon_sym_DQUOTE] = ACTIONS(2739),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2739),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2737),
    [sym_true] = ACTIONS(2737),
    [sym_false] = ACTIONS(2737),
    [sym_null] = ACTIONS(2737),
    [sym_undefined] = ACTIONS(2737),
    [anon_sym_static] = ACTIONS(2737),
    [anon_sym_readonly] = ACTIONS(2737),
    [anon_sym_get] = ACTIONS(2737),
    [anon_sym_set] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_any] = ACTIONS(2737),
    [anon_sym_number] = ACTIONS(2737),
    [anon_sym_boolean] = ACTIONS(2737),
    [anon_sym_string] = ACTIONS(2737),
    [anon_sym_symbol] = ACTIONS(2737),
    [anon_sym_abstract] = ACTIONS(2737),
    [anon_sym_satisfies] = ACTIONS(2737),
    [anon_sym_extends] = ACTIONS(2737),
    [anon_sym_infer] = ACTIONS(2737),
    [anon_sym_keyof] = ACTIONS(2737),
    [anon_sym_unknown] = ACTIONS(2737),
    [anon_sym_never] = ACTIONS(2737),
    [anon_sym_object] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_constructor] = ACTIONS(2737),
    [anon_sym_prop] = ACTIONS(2737),
    [anon_sym_id] = ACTIONS(2737),
    [anon_sym_event] = ACTIONS(2737),
    [anon_sym_fn] = ACTIONS(2737),
    [anon_sym_on] = ACTIONS(2737),
    [sym__ternary_qmark] = ACTIONS(2739),
  },
  [755] = {
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_export] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_type] = ACTIONS(2741),
    [anon_sym_typeof] = ACTIONS(2741),
    [anon_sym_import] = ACTIONS(2741),
    [anon_sym_var] = ACTIONS(2741),
    [anon_sym_let] = ACTIONS(2741),
    [anon_sym_const] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2741),
    [anon_sym_switch] = ACTIONS(2741),
    [anon_sym_for] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_await] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2741),
    [anon_sym_do] = ACTIONS(2741),
    [anon_sym_try] = ACTIONS(2741),
    [anon_sym_with] = ACTIONS(2741),
    [anon_sym_break] = ACTIONS(2741),
    [anon_sym_continue] = ACTIONS(2741),
    [anon_sym_debugger] = ACTIONS(2741),
    [anon_sym_return] = ACTIONS(2741),
    [anon_sym_throw] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2741),
    [anon_sym_yield] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_LTtemplate_GT] = ACTIONS(2743),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2741),
    [anon_sym_class] = ACTIONS(2741),
    [anon_sym_async] = ACTIONS(2741),
    [anon_sym_function] = ACTIONS(2741),
    [anon_sym_new] = ACTIONS(2741),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_void] = ACTIONS(2741),
    [anon_sym_delete] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2743),
    [sym_number] = ACTIONS(2743),
    [sym_this] = ACTIONS(2741),
    [sym_super] = ACTIONS(2741),
    [sym_true] = ACTIONS(2741),
    [sym_false] = ACTIONS(2741),
    [sym_null] = ACTIONS(2741),
    [sym_undefined] = ACTIONS(2741),
    [anon_sym_AT] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2741),
    [anon_sym_readonly] = ACTIONS(2741),
    [anon_sym_get] = ACTIONS(2741),
    [anon_sym_set] = ACTIONS(2741),
    [anon_sym_declare] = ACTIONS(2741),
    [anon_sym_namespace] = ACTIONS(2741),
    [anon_sym_public] = ACTIONS(2741),
    [anon_sym_private] = ACTIONS(2741),
    [anon_sym_protected] = ACTIONS(2741),
    [anon_sym_override] = ACTIONS(2741),
    [anon_sym_module] = ACTIONS(2741),
    [anon_sym_any] = ACTIONS(2741),
    [anon_sym_number] = ACTIONS(2741),
    [anon_sym_boolean] = ACTIONS(2741),
    [anon_sym_string] = ACTIONS(2741),
    [anon_sym_symbol] = ACTIONS(2741),
    [anon_sym_abstract] = ACTIONS(2741),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_enum] = ACTIONS(2741),
    [anon_sym_component] = ACTIONS(2741),
  },
  [756] = {
    [sym_identifier] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_as] = ACTIONS(2745),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_typeof] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_in] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_SLASH] = ACTIONS(2745),
    [anon_sym_DOT] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_QMARK_DOT] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2747),
    [anon_sym_PIPE_PIPE] = ACTIONS(2747),
    [anon_sym_GT_GT] = ACTIONS(2745),
    [anon_sym_GT_GT_GT] = ACTIONS(2747),
    [anon_sym_LT_LT] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2745),
    [anon_sym_CARET] = ACTIONS(2747),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_LT_EQ] = ACTIONS(2747),
    [anon_sym_EQ_EQ] = ACTIONS(2745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2747),
    [anon_sym_BANG_EQ] = ACTIONS(2745),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2747),
    [anon_sym_GT_EQ] = ACTIONS(2747),
    [anon_sym_QMARK_QMARK] = ACTIONS(2747),
    [anon_sym_instanceof] = ACTIONS(2745),
    [anon_sym_void] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2747),
    [anon_sym_SQUOTE] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2747),
    [sym_number] = ACTIONS(2747),
    [sym_this] = ACTIONS(2745),
    [sym_true] = ACTIONS(2745),
    [sym_false] = ACTIONS(2745),
    [sym_null] = ACTIONS(2745),
    [sym_undefined] = ACTIONS(2745),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_get] = ACTIONS(2745),
    [anon_sym_set] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2745),
    [anon_sym_any] = ACTIONS(2745),
    [anon_sym_number] = ACTIONS(2745),
    [anon_sym_boolean] = ACTIONS(2745),
    [anon_sym_string] = ACTIONS(2745),
    [anon_sym_symbol] = ACTIONS(2745),
    [anon_sym_abstract] = ACTIONS(2745),
    [anon_sym_satisfies] = ACTIONS(2745),
    [anon_sym_extends] = ACTIONS(2745),
    [anon_sym_infer] = ACTIONS(2745),
    [anon_sym_keyof] = ACTIONS(2745),
    [anon_sym_unknown] = ACTIONS(2745),
    [anon_sym_never] = ACTIONS(2745),
    [anon_sym_object] = ACTIONS(2745),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2747),
    [anon_sym_constructor] = ACTIONS(2745),
    [anon_sym_prop] = ACTIONS(2745),
    [anon_sym_id] = ACTIONS(2745),
    [anon_sym_event] = ACTIONS(2745),
    [anon_sym_fn] = ACTIONS(2745),
    [anon_sym_on] = ACTIONS(2745),
    [sym__ternary_qmark] = ACTIONS(2747),
  },
  [757] = {
    [sym_identifier] = ACTIONS(2749),
    [anon_sym_export] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_type] = ACTIONS(2749),
    [anon_sym_typeof] = ACTIONS(2749),
    [anon_sym_import] = ACTIONS(2749),
    [anon_sym_var] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2749),
    [anon_sym_if] = ACTIONS(2749),
    [anon_sym_switch] = ACTIONS(2749),
    [anon_sym_for] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_await] = ACTIONS(2749),
    [anon_sym_while] = ACTIONS(2749),
    [anon_sym_do] = ACTIONS(2749),
    [anon_sym_try] = ACTIONS(2749),
    [anon_sym_with] = ACTIONS(2749),
    [anon_sym_break] = ACTIONS(2749),
    [anon_sym_continue] = ACTIONS(2749),
    [anon_sym_debugger] = ACTIONS(2749),
    [anon_sym_return] = ACTIONS(2749),
    [anon_sym_throw] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2749),
    [anon_sym_yield] = ACTIONS(2749),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LTtemplate_GT] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2749),
    [anon_sym_SLASH] = ACTIONS(2749),
    [anon_sym_class] = ACTIONS(2749),
    [anon_sym_async] = ACTIONS(2749),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_new] = ACTIONS(2749),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2751),
    [anon_sym_void] = ACTIONS(2749),
    [anon_sym_delete] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2751),
    [sym_number] = ACTIONS(2751),
    [sym_this] = ACTIONS(2749),
    [sym_super] = ACTIONS(2749),
    [sym_true] = ACTIONS(2749),
    [sym_false] = ACTIONS(2749),
    [sym_null] = ACTIONS(2749),
    [sym_undefined] = ACTIONS(2749),
    [anon_sym_AT] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2749),
    [anon_sym_readonly] = ACTIONS(2749),
    [anon_sym_get] = ACTIONS(2749),
    [anon_sym_set] = ACTIONS(2749),
    [anon_sym_declare] = ACTIONS(2749),
    [anon_sym_namespace] = ACTIONS(2749),
    [anon_sym_public] = ACTIONS(2749),
    [anon_sym_private] = ACTIONS(2749),
    [anon_sym_protected] = ACTIONS(2749),
    [anon_sym_override] = ACTIONS(2749),
    [anon_sym_module] = ACTIONS(2749),
    [anon_sym_any] = ACTIONS(2749),
    [anon_sym_number] = ACTIONS(2749),
    [anon_sym_boolean] = ACTIONS(2749),
    [anon_sym_string] = ACTIONS(2749),
    [anon_sym_symbol] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_interface] = ACTIONS(2749),
    [anon_sym_enum] = ACTIONS(2749),
    [anon_sym_component] = ACTIONS(2749),
  },
  [758] = {
    [sym_identifier] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_as] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_typeof] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_in] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_GT] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_DOT] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2753),
    [anon_sym_QMARK_DOT] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2755),
    [anon_sym_PIPE_PIPE] = ACTIONS(2755),
    [anon_sym_GT_GT] = ACTIONS(2753),
    [anon_sym_GT_GT_GT] = ACTIONS(2755),
    [anon_sym_LT_LT] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2753),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2753),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [anon_sym_STAR_STAR] = ACTIONS(2755),
    [anon_sym_LT_EQ] = ACTIONS(2755),
    [anon_sym_EQ_EQ] = ACTIONS(2753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2755),
    [anon_sym_BANG_EQ] = ACTIONS(2753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2755),
    [anon_sym_GT_EQ] = ACTIONS(2755),
    [anon_sym_QMARK_QMARK] = ACTIONS(2755),
    [anon_sym_instanceof] = ACTIONS(2753),
    [anon_sym_void] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2755),
    [sym_number] = ACTIONS(2755),
    [sym_this] = ACTIONS(2753),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [sym_null] = ACTIONS(2753),
    [sym_undefined] = ACTIONS(2753),
    [anon_sym_static] = ACTIONS(2753),
    [anon_sym_readonly] = ACTIONS(2753),
    [anon_sym_get] = ACTIONS(2753),
    [anon_sym_set] = ACTIONS(2753),
    [anon_sym_QMARK] = ACTIONS(2753),
    [anon_sym_any] = ACTIONS(2753),
    [anon_sym_number] = ACTIONS(2753),
    [anon_sym_boolean] = ACTIONS(2753),
    [anon_sym_string] = ACTIONS(2753),
    [anon_sym_symbol] = ACTIONS(2753),
    [anon_sym_abstract] = ACTIONS(2753),
    [anon_sym_satisfies] = ACTIONS(2753),
    [anon_sym_extends] = ACTIONS(2753),
    [anon_sym_infer] = ACTIONS(2753),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2753),
    [anon_sym_never] = ACTIONS(2753),
    [anon_sym_object] = ACTIONS(2753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
    [anon_sym_constructor] = ACTIONS(2753),
    [anon_sym_prop] = ACTIONS(2753),
    [anon_sym_id] = ACTIONS(2753),
    [anon_sym_event] = ACTIONS(2753),
    [anon_sym_fn] = ACTIONS(2753),
    [anon_sym_on] = ACTIONS(2753),
    [sym__ternary_qmark] = ACTIONS(2755),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [760] = {
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2759),
    [anon_sym_as] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_typeof] = ACTIONS(2759),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_LPAREN] = ACTIONS(2761),
    [anon_sym_in] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2759),
    [anon_sym_GT] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2759),
    [anon_sym_QMARK_DOT] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_GT_GT_GT] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2761),
    [anon_sym_QMARK_QMARK] = ACTIONS(2761),
    [anon_sym_instanceof] = ACTIONS(2759),
    [anon_sym_void] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2761),
    [sym_number] = ACTIONS(2761),
    [sym_this] = ACTIONS(2759),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [sym_null] = ACTIONS(2759),
    [sym_undefined] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_readonly] = ACTIONS(2759),
    [anon_sym_get] = ACTIONS(2759),
    [anon_sym_set] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_any] = ACTIONS(2759),
    [anon_sym_number] = ACTIONS(2759),
    [anon_sym_boolean] = ACTIONS(2759),
    [anon_sym_string] = ACTIONS(2759),
    [anon_sym_symbol] = ACTIONS(2759),
    [anon_sym_abstract] = ACTIONS(2759),
    [anon_sym_satisfies] = ACTIONS(2759),
    [anon_sym_extends] = ACTIONS(2759),
    [anon_sym_infer] = ACTIONS(2759),
    [anon_sym_keyof] = ACTIONS(2759),
    [anon_sym_unknown] = ACTIONS(2759),
    [anon_sym_never] = ACTIONS(2759),
    [anon_sym_object] = ACTIONS(2759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2761),
    [anon_sym_constructor] = ACTIONS(2759),
    [anon_sym_prop] = ACTIONS(2759),
    [anon_sym_id] = ACTIONS(2759),
    [anon_sym_event] = ACTIONS(2759),
    [anon_sym_fn] = ACTIONS(2759),
    [anon_sym_on] = ACTIONS(2759),
    [sym__ternary_qmark] = ACTIONS(2761),
  },
  [761] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [762] = {
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_as] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_typeof] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(2765),
    [anon_sym_in] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_LT] = ACTIONS(2763),
    [anon_sym_GT] = ACTIONS(2763),
    [anon_sym_SLASH] = ACTIONS(2763),
    [anon_sym_DOT] = ACTIONS(2763),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_QMARK_DOT] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_PIPE_PIPE] = ACTIONS(2765),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_GT_GT_GT] = ACTIONS(2765),
    [anon_sym_LT_LT] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2765),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PERCENT] = ACTIONS(2765),
    [anon_sym_STAR_STAR] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ] = ACTIONS(2763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_BANG_EQ] = ACTIONS(2763),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2765),
    [anon_sym_GT_EQ] = ACTIONS(2765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2765),
    [anon_sym_instanceof] = ACTIONS(2763),
    [anon_sym_void] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2765),
    [sym_number] = ACTIONS(2765),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [sym_null] = ACTIONS(2763),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_readonly] = ACTIONS(2763),
    [anon_sym_get] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(2763),
    [anon_sym_QMARK] = ACTIONS(2763),
    [anon_sym_any] = ACTIONS(2763),
    [anon_sym_number] = ACTIONS(2763),
    [anon_sym_boolean] = ACTIONS(2763),
    [anon_sym_string] = ACTIONS(2763),
    [anon_sym_symbol] = ACTIONS(2763),
    [anon_sym_abstract] = ACTIONS(2763),
    [anon_sym_satisfies] = ACTIONS(2763),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2763),
    [anon_sym_keyof] = ACTIONS(2763),
    [anon_sym_unknown] = ACTIONS(2763),
    [anon_sym_never] = ACTIONS(2763),
    [anon_sym_object] = ACTIONS(2763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2765),
    [anon_sym_constructor] = ACTIONS(2763),
    [anon_sym_prop] = ACTIONS(2763),
    [anon_sym_id] = ACTIONS(2763),
    [anon_sym_event] = ACTIONS(2763),
    [anon_sym_fn] = ACTIONS(2763),
    [anon_sym_on] = ACTIONS(2763),
    [sym__ternary_qmark] = ACTIONS(2765),
  },
  [763] = {
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_as] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_typeof] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(2765),
    [anon_sym_in] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_LT] = ACTIONS(2763),
    [anon_sym_GT] = ACTIONS(2763),
    [anon_sym_SLASH] = ACTIONS(2763),
    [anon_sym_DOT] = ACTIONS(2763),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_QMARK_DOT] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_PIPE_PIPE] = ACTIONS(2765),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_GT_GT_GT] = ACTIONS(2765),
    [anon_sym_LT_LT] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_CARET] = ACTIONS(2765),
    [anon_sym_PIPE] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PERCENT] = ACTIONS(2765),
    [anon_sym_STAR_STAR] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ] = ACTIONS(2763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_BANG_EQ] = ACTIONS(2763),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2765),
    [anon_sym_GT_EQ] = ACTIONS(2765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2765),
    [anon_sym_instanceof] = ACTIONS(2763),
    [anon_sym_void] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2765),
    [sym_number] = ACTIONS(2765),
    [sym_this] = ACTIONS(2763),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [sym_null] = ACTIONS(2763),
    [sym_undefined] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_readonly] = ACTIONS(2763),
    [anon_sym_get] = ACTIONS(2763),
    [anon_sym_set] = ACTIONS(2763),
    [anon_sym_QMARK] = ACTIONS(2763),
    [anon_sym_any] = ACTIONS(2763),
    [anon_sym_number] = ACTIONS(2763),
    [anon_sym_boolean] = ACTIONS(2763),
    [anon_sym_string] = ACTIONS(2763),
    [anon_sym_symbol] = ACTIONS(2763),
    [anon_sym_abstract] = ACTIONS(2763),
    [anon_sym_satisfies] = ACTIONS(2763),
    [anon_sym_extends] = ACTIONS(2763),
    [anon_sym_infer] = ACTIONS(2763),
    [anon_sym_keyof] = ACTIONS(2763),
    [anon_sym_unknown] = ACTIONS(2763),
    [anon_sym_never] = ACTIONS(2763),
    [anon_sym_object] = ACTIONS(2763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2765),
    [anon_sym_constructor] = ACTIONS(2763),
    [anon_sym_prop] = ACTIONS(2763),
    [anon_sym_id] = ACTIONS(2763),
    [anon_sym_event] = ACTIONS(2763),
    [anon_sym_fn] = ACTIONS(2763),
    [anon_sym_on] = ACTIONS(2763),
    [sym__ternary_qmark] = ACTIONS(2765),
  },
  [764] = {
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_as] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_typeof] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_LPAREN] = ACTIONS(2769),
    [anon_sym_in] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2767),
    [anon_sym_GT] = ACTIONS(2767),
    [anon_sym_SLASH] = ACTIONS(2767),
    [anon_sym_DOT] = ACTIONS(2767),
    [anon_sym_async] = ACTIONS(2767),
    [anon_sym_QMARK_DOT] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_PIPE_PIPE] = ACTIONS(2769),
    [anon_sym_GT_GT] = ACTIONS(2767),
    [anon_sym_GT_GT_GT] = ACTIONS(2769),
    [anon_sym_LT_LT] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2769),
    [anon_sym_PIPE] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_STAR_STAR] = ACTIONS(2769),
    [anon_sym_LT_EQ] = ACTIONS(2769),
    [anon_sym_EQ_EQ] = ACTIONS(2767),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2769),
    [anon_sym_BANG_EQ] = ACTIONS(2767),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2769),
    [anon_sym_GT_EQ] = ACTIONS(2769),
    [anon_sym_QMARK_QMARK] = ACTIONS(2769),
    [anon_sym_instanceof] = ACTIONS(2767),
    [anon_sym_void] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2769),
    [sym_number] = ACTIONS(2769),
    [sym_this] = ACTIONS(2767),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [sym_null] = ACTIONS(2767),
    [sym_undefined] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_readonly] = ACTIONS(2767),
    [anon_sym_get] = ACTIONS(2767),
    [anon_sym_set] = ACTIONS(2767),
    [anon_sym_QMARK] = ACTIONS(2767),
    [anon_sym_any] = ACTIONS(2767),
    [anon_sym_number] = ACTIONS(2767),
    [anon_sym_boolean] = ACTIONS(2767),
    [anon_sym_string] = ACTIONS(2767),
    [anon_sym_symbol] = ACTIONS(2767),
    [anon_sym_abstract] = ACTIONS(2767),
    [anon_sym_satisfies] = ACTIONS(2767),
    [anon_sym_extends] = ACTIONS(2767),
    [anon_sym_infer] = ACTIONS(2767),
    [anon_sym_keyof] = ACTIONS(2767),
    [anon_sym_unknown] = ACTIONS(2767),
    [anon_sym_never] = ACTIONS(2767),
    [anon_sym_object] = ACTIONS(2767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2769),
    [anon_sym_constructor] = ACTIONS(2767),
    [anon_sym_prop] = ACTIONS(2767),
    [anon_sym_id] = ACTIONS(2767),
    [anon_sym_event] = ACTIONS(2767),
    [anon_sym_fn] = ACTIONS(2767),
    [anon_sym_on] = ACTIONS(2767),
    [sym__ternary_qmark] = ACTIONS(2769),
  },
  [765] = {
    [sym_identifier] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_as] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_typeof] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2771),
    [anon_sym_SLASH] = ACTIONS(2771),
    [anon_sym_DOT] = ACTIONS(2771),
    [anon_sym_async] = ACTIONS(2771),
    [anon_sym_QMARK_DOT] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2773),
    [anon_sym_GT_GT] = ACTIONS(2771),
    [anon_sym_GT_GT_GT] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_QMARK_QMARK] = ACTIONS(2773),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_void] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2773),
    [sym_number] = ACTIONS(2773),
    [sym_this] = ACTIONS(2771),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [sym_null] = ACTIONS(2771),
    [sym_undefined] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_readonly] = ACTIONS(2771),
    [anon_sym_get] = ACTIONS(2771),
    [anon_sym_set] = ACTIONS(2771),
    [anon_sym_QMARK] = ACTIONS(2771),
    [anon_sym_any] = ACTIONS(2771),
    [anon_sym_number] = ACTIONS(2771),
    [anon_sym_boolean] = ACTIONS(2771),
    [anon_sym_string] = ACTIONS(2771),
    [anon_sym_symbol] = ACTIONS(2771),
    [anon_sym_abstract] = ACTIONS(2771),
    [anon_sym_satisfies] = ACTIONS(2771),
    [anon_sym_extends] = ACTIONS(2771),
    [anon_sym_infer] = ACTIONS(2771),
    [anon_sym_keyof] = ACTIONS(2771),
    [anon_sym_unknown] = ACTIONS(2771),
    [anon_sym_never] = ACTIONS(2771),
    [anon_sym_object] = ACTIONS(2771),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2773),
    [anon_sym_constructor] = ACTIONS(2771),
    [anon_sym_prop] = ACTIONS(2771),
    [anon_sym_id] = ACTIONS(2771),
    [anon_sym_event] = ACTIONS(2771),
    [anon_sym_fn] = ACTIONS(2771),
    [anon_sym_on] = ACTIONS(2771),
    [sym__ternary_qmark] = ACTIONS(2773),
  },
  [766] = {
    [sym_identifier] = ACTIONS(2775),
    [anon_sym_export] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_type] = ACTIONS(2775),
    [anon_sym_typeof] = ACTIONS(2775),
    [anon_sym_import] = ACTIONS(2775),
    [anon_sym_var] = ACTIONS(2775),
    [anon_sym_let] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_else] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_await] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [anon_sym_with] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_debugger] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_throw] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2777),
    [anon_sym_LTtemplate_GT] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_async] = ACTIONS(2775),
    [anon_sym_function] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_void] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2777),
    [anon_sym_DASH_DASH] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2777),
    [sym_number] = ACTIONS(2777),
    [sym_this] = ACTIONS(2775),
    [sym_super] = ACTIONS(2775),
    [sym_true] = ACTIONS(2775),
    [sym_false] = ACTIONS(2775),
    [sym_null] = ACTIONS(2775),
    [sym_undefined] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2777),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_readonly] = ACTIONS(2775),
    [anon_sym_get] = ACTIONS(2775),
    [anon_sym_set] = ACTIONS(2775),
    [anon_sym_declare] = ACTIONS(2775),
    [anon_sym_namespace] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_override] = ACTIONS(2775),
    [anon_sym_module] = ACTIONS(2775),
    [anon_sym_any] = ACTIONS(2775),
    [anon_sym_number] = ACTIONS(2775),
    [anon_sym_boolean] = ACTIONS(2775),
    [anon_sym_string] = ACTIONS(2775),
    [anon_sym_symbol] = ACTIONS(2775),
    [anon_sym_abstract] = ACTIONS(2775),
    [anon_sym_interface] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_component] = ACTIONS(2775),
  },
  [767] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2779),
    [anon_sym_as] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_typeof] = ACTIONS(2779),
    [anon_sym_BANG] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2781),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_LT] = ACTIONS(2779),
    [anon_sym_GT] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(2779),
    [anon_sym_DOT] = ACTIONS(2779),
    [anon_sym_async] = ACTIONS(2779),
    [anon_sym_QMARK_DOT] = ACTIONS(2781),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_PIPE_PIPE] = ACTIONS(2781),
    [anon_sym_GT_GT] = ACTIONS(2779),
    [anon_sym_GT_GT_GT] = ACTIONS(2781),
    [anon_sym_LT_LT] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_CARET] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PERCENT] = ACTIONS(2781),
    [anon_sym_STAR_STAR] = ACTIONS(2781),
    [anon_sym_LT_EQ] = ACTIONS(2781),
    [anon_sym_EQ_EQ] = ACTIONS(2779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2781),
    [anon_sym_BANG_EQ] = ACTIONS(2779),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2781),
    [anon_sym_GT_EQ] = ACTIONS(2781),
    [anon_sym_QMARK_QMARK] = ACTIONS(2781),
    [anon_sym_instanceof] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(2779),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2781),
    [sym_number] = ACTIONS(2781),
    [sym_this] = ACTIONS(2779),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [sym_null] = ACTIONS(2779),
    [sym_undefined] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_readonly] = ACTIONS(2779),
    [anon_sym_get] = ACTIONS(2779),
    [anon_sym_set] = ACTIONS(2779),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_any] = ACTIONS(2779),
    [anon_sym_number] = ACTIONS(2779),
    [anon_sym_boolean] = ACTIONS(2779),
    [anon_sym_string] = ACTIONS(2779),
    [anon_sym_symbol] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_satisfies] = ACTIONS(2779),
    [anon_sym_extends] = ACTIONS(2779),
    [anon_sym_infer] = ACTIONS(2779),
    [anon_sym_keyof] = ACTIONS(2779),
    [anon_sym_unknown] = ACTIONS(2779),
    [anon_sym_never] = ACTIONS(2779),
    [anon_sym_object] = ACTIONS(2779),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2781),
    [anon_sym_constructor] = ACTIONS(2779),
    [anon_sym_prop] = ACTIONS(2779),
    [anon_sym_id] = ACTIONS(2779),
    [anon_sym_event] = ACTIONS(2779),
    [anon_sym_fn] = ACTIONS(2779),
    [anon_sym_on] = ACTIONS(2779),
    [sym__ternary_qmark] = ACTIONS(2781),
  },
  [768] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_type] = ACTIONS(2783),
    [anon_sym_typeof] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_var] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_await] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_debugger] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_LTtemplate_GT] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_async] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_void] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [sym_number] = ACTIONS(2785),
    [sym_this] = ACTIONS(2783),
    [sym_super] = ACTIONS(2783),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [sym_null] = ACTIONS(2783),
    [sym_undefined] = ACTIONS(2783),
    [anon_sym_AT] = ACTIONS(2785),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_readonly] = ACTIONS(2783),
    [anon_sym_get] = ACTIONS(2783),
    [anon_sym_set] = ACTIONS(2783),
    [anon_sym_declare] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_override] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_any] = ACTIONS(2783),
    [anon_sym_number] = ACTIONS(2783),
    [anon_sym_boolean] = ACTIONS(2783),
    [anon_sym_string] = ACTIONS(2783),
    [anon_sym_symbol] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_interface] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_component] = ACTIONS(2783),
  },
  [769] = {
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_typeof] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_var] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_else] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_await] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_with] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_debugger] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_yield] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_LTtemplate_GT] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2787),
    [anon_sym_SLASH] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_async] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_void] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2789),
    [sym_number] = ACTIONS(2789),
    [sym_this] = ACTIONS(2787),
    [sym_super] = ACTIONS(2787),
    [sym_true] = ACTIONS(2787),
    [sym_false] = ACTIONS(2787),
    [sym_null] = ACTIONS(2787),
    [sym_undefined] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2789),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_readonly] = ACTIONS(2787),
    [anon_sym_get] = ACTIONS(2787),
    [anon_sym_set] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2787),
    [anon_sym_private] = ACTIONS(2787),
    [anon_sym_protected] = ACTIONS(2787),
    [anon_sym_override] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_any] = ACTIONS(2787),
    [anon_sym_number] = ACTIONS(2787),
    [anon_sym_boolean] = ACTIONS(2787),
    [anon_sym_string] = ACTIONS(2787),
    [anon_sym_symbol] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_interface] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_component] = ACTIONS(2787),
  },
  [770] = {
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_typeof] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_var] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2793),
    [anon_sym_await] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_debugger] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_LTtemplate_GT] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_async] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_void] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_PLUS_PLUS] = ACTIONS(2793),
    [anon_sym_DASH_DASH] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2793),
    [sym_number] = ACTIONS(2793),
    [sym_this] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [sym_true] = ACTIONS(2791),
    [sym_false] = ACTIONS(2791),
    [sym_null] = ACTIONS(2791),
    [sym_undefined] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2793),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_readonly] = ACTIONS(2791),
    [anon_sym_get] = ACTIONS(2791),
    [anon_sym_set] = ACTIONS(2791),
    [anon_sym_declare] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_public] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2791),
    [anon_sym_protected] = ACTIONS(2791),
    [anon_sym_override] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_any] = ACTIONS(2791),
    [anon_sym_number] = ACTIONS(2791),
    [anon_sym_boolean] = ACTIONS(2791),
    [anon_sym_string] = ACTIONS(2791),
    [anon_sym_symbol] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_interface] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_component] = ACTIONS(2791),
  },
  [771] = {
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2795),
    [anon_sym_as] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2797),
    [anon_sym_typeof] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2797),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_GT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2795),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_async] = ACTIONS(2795),
    [anon_sym_QMARK_DOT] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2797),
    [anon_sym_PIPE_PIPE] = ACTIONS(2797),
    [anon_sym_GT_GT] = ACTIONS(2795),
    [anon_sym_GT_GT_GT] = ACTIONS(2797),
    [anon_sym_LT_LT] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2797),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_PERCENT] = ACTIONS(2797),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_LT_EQ] = ACTIONS(2797),
    [anon_sym_EQ_EQ] = ACTIONS(2795),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2797),
    [anon_sym_BANG_EQ] = ACTIONS(2795),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2797),
    [anon_sym_GT_EQ] = ACTIONS(2797),
    [anon_sym_QMARK_QMARK] = ACTIONS(2797),
    [anon_sym_instanceof] = ACTIONS(2795),
    [anon_sym_void] = ACTIONS(2795),
    [anon_sym_PLUS_PLUS] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2797),
    [sym_number] = ACTIONS(2797),
    [sym_this] = ACTIONS(2795),
    [sym_true] = ACTIONS(2795),
    [sym_false] = ACTIONS(2795),
    [sym_null] = ACTIONS(2795),
    [sym_undefined] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_readonly] = ACTIONS(2795),
    [anon_sym_get] = ACTIONS(2795),
    [anon_sym_set] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_any] = ACTIONS(2795),
    [anon_sym_number] = ACTIONS(2795),
    [anon_sym_boolean] = ACTIONS(2795),
    [anon_sym_string] = ACTIONS(2795),
    [anon_sym_symbol] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_satisfies] = ACTIONS(2795),
    [anon_sym_extends] = ACTIONS(2795),
    [anon_sym_infer] = ACTIONS(2795),
    [anon_sym_keyof] = ACTIONS(2795),
    [anon_sym_unknown] = ACTIONS(2795),
    [anon_sym_never] = ACTIONS(2795),
    [anon_sym_object] = ACTIONS(2795),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2797),
    [anon_sym_constructor] = ACTIONS(2795),
    [anon_sym_prop] = ACTIONS(2795),
    [anon_sym_id] = ACTIONS(2795),
    [anon_sym_event] = ACTIONS(2795),
    [anon_sym_fn] = ACTIONS(2795),
    [anon_sym_on] = ACTIONS(2795),
    [sym__ternary_qmark] = ACTIONS(2797),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_as] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_typeof] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_LPAREN] = ACTIONS(2801),
    [anon_sym_in] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2799),
    [anon_sym_SLASH] = ACTIONS(2799),
    [anon_sym_DOT] = ACTIONS(2799),
    [anon_sym_async] = ACTIONS(2799),
    [anon_sym_QMARK_DOT] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2801),
    [anon_sym_GT_GT] = ACTIONS(2799),
    [anon_sym_GT_GT_GT] = ACTIONS(2801),
    [anon_sym_LT_LT] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_CARET] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2801),
    [anon_sym_STAR_STAR] = ACTIONS(2801),
    [anon_sym_LT_EQ] = ACTIONS(2801),
    [anon_sym_EQ_EQ] = ACTIONS(2799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_EQ] = ACTIONS(2799),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2801),
    [anon_sym_GT_EQ] = ACTIONS(2801),
    [anon_sym_QMARK_QMARK] = ACTIONS(2801),
    [anon_sym_instanceof] = ACTIONS(2799),
    [anon_sym_void] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2801),
    [sym_number] = ACTIONS(2801),
    [sym_this] = ACTIONS(2799),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [sym_null] = ACTIONS(2799),
    [sym_undefined] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_get] = ACTIONS(2799),
    [anon_sym_set] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2799),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_abstract] = ACTIONS(2799),
    [anon_sym_satisfies] = ACTIONS(2799),
    [anon_sym_extends] = ACTIONS(2799),
    [anon_sym_infer] = ACTIONS(2799),
    [anon_sym_keyof] = ACTIONS(2799),
    [anon_sym_unknown] = ACTIONS(2799),
    [anon_sym_never] = ACTIONS(2799),
    [anon_sym_object] = ACTIONS(2799),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2801),
    [anon_sym_constructor] = ACTIONS(2799),
    [anon_sym_prop] = ACTIONS(2799),
    [anon_sym_id] = ACTIONS(2799),
    [anon_sym_event] = ACTIONS(2799),
    [anon_sym_fn] = ACTIONS(2799),
    [anon_sym_on] = ACTIONS(2799),
    [sym__ternary_qmark] = ACTIONS(2801),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2803),
    [anon_sym_export] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2803),
    [anon_sym_typeof] = ACTIONS(2803),
    [anon_sym_import] = ACTIONS(2803),
    [anon_sym_var] = ACTIONS(2803),
    [anon_sym_let] = ACTIONS(2803),
    [anon_sym_const] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_else] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2805),
    [anon_sym_await] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_do] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2803),
    [anon_sym_with] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2803),
    [anon_sym_continue] = ACTIONS(2803),
    [anon_sym_debugger] = ACTIONS(2803),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_throw] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2803),
    [anon_sym_default] = ACTIONS(2803),
    [anon_sym_yield] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_LTtemplate_GT] = ACTIONS(2805),
    [anon_sym_LT] = ACTIONS(2803),
    [anon_sym_SLASH] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2803),
    [anon_sym_async] = ACTIONS(2803),
    [anon_sym_function] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_void] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2805),
    [sym_number] = ACTIONS(2805),
    [sym_this] = ACTIONS(2803),
    [sym_super] = ACTIONS(2803),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [sym_null] = ACTIONS(2803),
    [sym_undefined] = ACTIONS(2803),
    [anon_sym_AT] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2803),
    [anon_sym_readonly] = ACTIONS(2803),
    [anon_sym_get] = ACTIONS(2803),
    [anon_sym_set] = ACTIONS(2803),
    [anon_sym_declare] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2803),
    [anon_sym_public] = ACTIONS(2803),
    [anon_sym_private] = ACTIONS(2803),
    [anon_sym_protected] = ACTIONS(2803),
    [anon_sym_override] = ACTIONS(2803),
    [anon_sym_module] = ACTIONS(2803),
    [anon_sym_any] = ACTIONS(2803),
    [anon_sym_number] = ACTIONS(2803),
    [anon_sym_boolean] = ACTIONS(2803),
    [anon_sym_string] = ACTIONS(2803),
    [anon_sym_symbol] = ACTIONS(2803),
    [anon_sym_abstract] = ACTIONS(2803),
    [anon_sym_interface] = ACTIONS(2803),
    [anon_sym_enum] = ACTIONS(2803),
    [anon_sym_component] = ACTIONS(2803),
  },
  [774] = {
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_type] = ACTIONS(2807),
    [anon_sym_typeof] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_var] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_switch] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2809),
    [anon_sym_await] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2807),
    [anon_sym_break] = ACTIONS(2807),
    [anon_sym_continue] = ACTIONS(2807),
    [anon_sym_debugger] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_throw] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2807),
    [anon_sym_default] = ACTIONS(2807),
    [anon_sym_yield] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_LTtemplate_GT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_async] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_void] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2809),
    [sym_number] = ACTIONS(2809),
    [sym_this] = ACTIONS(2807),
    [sym_super] = ACTIONS(2807),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [sym_null] = ACTIONS(2807),
    [sym_undefined] = ACTIONS(2807),
    [anon_sym_AT] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_readonly] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2807),
    [anon_sym_set] = ACTIONS(2807),
    [anon_sym_declare] = ACTIONS(2807),
    [anon_sym_namespace] = ACTIONS(2807),
    [anon_sym_public] = ACTIONS(2807),
    [anon_sym_private] = ACTIONS(2807),
    [anon_sym_protected] = ACTIONS(2807),
    [anon_sym_override] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_any] = ACTIONS(2807),
    [anon_sym_number] = ACTIONS(2807),
    [anon_sym_boolean] = ACTIONS(2807),
    [anon_sym_string] = ACTIONS(2807),
    [anon_sym_symbol] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_interface] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_component] = ACTIONS(2807),
  },
  [775] = {
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2811),
    [anon_sym_typeof] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_var] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_else] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2813),
    [anon_sym_await] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_debugger] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_yield] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_LTtemplate_GT] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_SLASH] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_void] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2813),
    [sym_number] = ACTIONS(2813),
    [sym_this] = ACTIONS(2811),
    [sym_super] = ACTIONS(2811),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [sym_null] = ACTIONS(2811),
    [sym_undefined] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_readonly] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2811),
    [anon_sym_set] = ACTIONS(2811),
    [anon_sym_declare] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_public] = ACTIONS(2811),
    [anon_sym_private] = ACTIONS(2811),
    [anon_sym_protected] = ACTIONS(2811),
    [anon_sym_override] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_any] = ACTIONS(2811),
    [anon_sym_number] = ACTIONS(2811),
    [anon_sym_boolean] = ACTIONS(2811),
    [anon_sym_string] = ACTIONS(2811),
    [anon_sym_symbol] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_interface] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_component] = ACTIONS(2811),
  },
  [776] = {
    [sym_identifier] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_as] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_typeof] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2815),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_async] = ACTIONS(2815),
    [anon_sym_QMARK_DOT] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2815),
    [anon_sym_GT_GT_GT] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_STAR_STAR] = ACTIONS(2817),
    [anon_sym_LT_EQ] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2817),
    [anon_sym_GT_EQ] = ACTIONS(2817),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_instanceof] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2817),
    [sym_number] = ACTIONS(2817),
    [sym_this] = ACTIONS(2815),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [sym_null] = ACTIONS(2815),
    [sym_undefined] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_readonly] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(2815),
    [anon_sym_set] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_any] = ACTIONS(2815),
    [anon_sym_number] = ACTIONS(2815),
    [anon_sym_boolean] = ACTIONS(2815),
    [anon_sym_string] = ACTIONS(2815),
    [anon_sym_symbol] = ACTIONS(2815),
    [anon_sym_abstract] = ACTIONS(2815),
    [anon_sym_satisfies] = ACTIONS(2815),
    [anon_sym_extends] = ACTIONS(2815),
    [anon_sym_infer] = ACTIONS(2815),
    [anon_sym_keyof] = ACTIONS(2815),
    [anon_sym_unknown] = ACTIONS(2815),
    [anon_sym_never] = ACTIONS(2815),
    [anon_sym_object] = ACTIONS(2815),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2817),
    [anon_sym_constructor] = ACTIONS(2815),
    [anon_sym_prop] = ACTIONS(2815),
    [anon_sym_id] = ACTIONS(2815),
    [anon_sym_event] = ACTIONS(2815),
    [anon_sym_fn] = ACTIONS(2815),
    [anon_sym_on] = ACTIONS(2815),
    [sym__ternary_qmark] = ACTIONS(2817),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_typeof] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2821),
    [anon_sym_in] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_async] = ACTIONS(2819),
    [anon_sym_QMARK_DOT] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_PIPE_PIPE] = ACTIONS(2821),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_GT_GT_GT] = ACTIONS(2821),
    [anon_sym_LT_LT] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2821),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2821),
    [anon_sym_LT_EQ] = ACTIONS(2821),
    [anon_sym_EQ_EQ] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2821),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2821),
    [anon_sym_GT_EQ] = ACTIONS(2821),
    [anon_sym_QMARK_QMARK] = ACTIONS(2821),
    [anon_sym_instanceof] = ACTIONS(2819),
    [anon_sym_void] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2821),
    [sym_number] = ACTIONS(2821),
    [sym_this] = ACTIONS(2819),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [sym_null] = ACTIONS(2819),
    [sym_undefined] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_readonly] = ACTIONS(2819),
    [anon_sym_get] = ACTIONS(2819),
    [anon_sym_set] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_any] = ACTIONS(2819),
    [anon_sym_number] = ACTIONS(2819),
    [anon_sym_boolean] = ACTIONS(2819),
    [anon_sym_string] = ACTIONS(2819),
    [anon_sym_symbol] = ACTIONS(2819),
    [anon_sym_abstract] = ACTIONS(2819),
    [anon_sym_satisfies] = ACTIONS(2819),
    [anon_sym_extends] = ACTIONS(2819),
    [anon_sym_infer] = ACTIONS(2819),
    [anon_sym_keyof] = ACTIONS(2819),
    [anon_sym_unknown] = ACTIONS(2819),
    [anon_sym_never] = ACTIONS(2819),
    [anon_sym_object] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_constructor] = ACTIONS(2819),
    [anon_sym_prop] = ACTIONS(2819),
    [anon_sym_id] = ACTIONS(2819),
    [anon_sym_event] = ACTIONS(2819),
    [anon_sym_fn] = ACTIONS(2819),
    [anon_sym_on] = ACTIONS(2819),
    [sym__ternary_qmark] = ACTIONS(2821),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2823),
    [anon_sym_export] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2823),
    [anon_sym_typeof] = ACTIONS(2823),
    [anon_sym_import] = ACTIONS(2823),
    [anon_sym_var] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_else] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_switch] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2825),
    [anon_sym_await] = ACTIONS(2823),
    [anon_sym_while] = ACTIONS(2823),
    [anon_sym_do] = ACTIONS(2823),
    [anon_sym_try] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_debugger] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2823),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2825),
    [anon_sym_LTtemplate_GT] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2823),
    [anon_sym_async] = ACTIONS(2823),
    [anon_sym_function] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_void] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2823),
    [anon_sym_PLUS_PLUS] = ACTIONS(2825),
    [anon_sym_DASH_DASH] = ACTIONS(2825),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2825),
    [sym_number] = ACTIONS(2825),
    [sym_this] = ACTIONS(2823),
    [sym_super] = ACTIONS(2823),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [sym_null] = ACTIONS(2823),
    [sym_undefined] = ACTIONS(2823),
    [anon_sym_AT] = ACTIONS(2825),
    [anon_sym_static] = ACTIONS(2823),
    [anon_sym_readonly] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2823),
    [anon_sym_set] = ACTIONS(2823),
    [anon_sym_declare] = ACTIONS(2823),
    [anon_sym_namespace] = ACTIONS(2823),
    [anon_sym_public] = ACTIONS(2823),
    [anon_sym_private] = ACTIONS(2823),
    [anon_sym_protected] = ACTIONS(2823),
    [anon_sym_override] = ACTIONS(2823),
    [anon_sym_module] = ACTIONS(2823),
    [anon_sym_any] = ACTIONS(2823),
    [anon_sym_number] = ACTIONS(2823),
    [anon_sym_boolean] = ACTIONS(2823),
    [anon_sym_string] = ACTIONS(2823),
    [anon_sym_symbol] = ACTIONS(2823),
    [anon_sym_abstract] = ACTIONS(2823),
    [anon_sym_interface] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_component] = ACTIONS(2823),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2811),
    [anon_sym_typeof] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_var] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_else] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2813),
    [anon_sym_await] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_debugger] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_yield] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_LTtemplate_GT] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_SLASH] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_async] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_void] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2813),
    [sym_number] = ACTIONS(2813),
    [sym_this] = ACTIONS(2811),
    [sym_super] = ACTIONS(2811),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [sym_null] = ACTIONS(2811),
    [sym_undefined] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_readonly] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2811),
    [anon_sym_set] = ACTIONS(2811),
    [anon_sym_declare] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_public] = ACTIONS(2811),
    [anon_sym_private] = ACTIONS(2811),
    [anon_sym_protected] = ACTIONS(2811),
    [anon_sym_override] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_any] = ACTIONS(2811),
    [anon_sym_number] = ACTIONS(2811),
    [anon_sym_boolean] = ACTIONS(2811),
    [anon_sym_string] = ACTIONS(2811),
    [anon_sym_symbol] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_interface] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_component] = ACTIONS(2811),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_typeof] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2628),
    [anon_sym_QMARK_DOT] = ACTIONS(2827),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_STAR_STAR] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2827),
    [anon_sym_BANG_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2827),
    [anon_sym_GT_EQ] = ACTIONS(2827),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_instanceof] = ACTIONS(2628),
    [anon_sym_void] = ACTIONS(2628),
    [anon_sym_PLUS_PLUS] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2827),
    [anon_sym_DQUOTE] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2827),
    [sym_number] = ACTIONS(2827),
    [sym_this] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_null] = ACTIONS(2628),
    [sym_undefined] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_readonly] = ACTIONS(2628),
    [anon_sym_get] = ACTIONS(2628),
    [anon_sym_set] = ACTIONS(2628),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_satisfies] = ACTIONS(2628),
    [anon_sym_extends] = ACTIONS(2628),
    [anon_sym_infer] = ACTIONS(2628),
    [anon_sym_keyof] = ACTIONS(2628),
    [anon_sym_unknown] = ACTIONS(2628),
    [anon_sym_never] = ACTIONS(2628),
    [anon_sym_object] = ACTIONS(2628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2827),
    [anon_sym_constructor] = ACTIONS(2628),
    [anon_sym_prop] = ACTIONS(2628),
    [anon_sym_id] = ACTIONS(2628),
    [anon_sym_event] = ACTIONS(2628),
    [anon_sym_fn] = ACTIONS(2628),
    [anon_sym_on] = ACTIONS(2628),
    [sym__ternary_qmark] = ACTIONS(2827),
  },
  [781] = {
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_typeof] = ACTIONS(2829),
    [anon_sym_import] = ACTIONS(2829),
    [anon_sym_var] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2831),
    [anon_sym_else] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_await] = ACTIONS(2829),
    [anon_sym_while] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_try] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_debugger] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_throw] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2829),
    [anon_sym_default] = ACTIONS(2829),
    [anon_sym_yield] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LTtemplate_GT] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_class] = ACTIONS(2829),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_new] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2831),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_delete] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [sym_number] = ACTIONS(2831),
    [sym_this] = ACTIONS(2829),
    [sym_super] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_null] = ACTIONS(2829),
    [sym_undefined] = ACTIONS(2829),
    [anon_sym_AT] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_readonly] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_override] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2829),
    [anon_sym_interface] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_component] = ACTIONS(2829),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(2485),
    [anon_sym_import] = ACTIONS(2485),
    [anon_sym_var] = ACTIONS(2485),
    [anon_sym_let] = ACTIONS(2485),
    [anon_sym_const] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2487),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_switch] = ACTIONS(2485),
    [anon_sym_for] = ACTIONS(2485),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_await] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_try] = ACTIONS(2485),
    [anon_sym_with] = ACTIONS(2485),
    [anon_sym_break] = ACTIONS(2485),
    [anon_sym_continue] = ACTIONS(2485),
    [anon_sym_debugger] = ACTIONS(2485),
    [anon_sym_return] = ACTIONS(2485),
    [anon_sym_throw] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_case] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(2485),
    [anon_sym_yield] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [anon_sym_LTtemplate_GT] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_class] = ACTIONS(2485),
    [anon_sym_async] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_void] = ACTIONS(2485),
    [anon_sym_delete] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2487),
    [anon_sym_DASH_DASH] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [sym_number] = ACTIONS(2487),
    [sym_this] = ACTIONS(2485),
    [sym_super] = ACTIONS(2485),
    [sym_true] = ACTIONS(2485),
    [sym_false] = ACTIONS(2485),
    [sym_null] = ACTIONS(2485),
    [sym_undefined] = ACTIONS(2485),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_static] = ACTIONS(2485),
    [anon_sym_readonly] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_override] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
    [anon_sym_abstract] = ACTIONS(2485),
    [anon_sym_interface] = ACTIONS(2485),
    [anon_sym_enum] = ACTIONS(2485),
    [anon_sym_component] = ACTIONS(2485),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [786] = {
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_typeof] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_QMARK_DOT] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_STAR_STAR] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(2833),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2835),
    [sym_number] = ACTIONS(2835),
    [sym_this] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_null] = ACTIONS(2833),
    [sym_undefined] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_satisfies] = ACTIONS(2833),
    [anon_sym_extends] = ACTIONS(2833),
    [anon_sym_infer] = ACTIONS(2833),
    [anon_sym_keyof] = ACTIONS(2833),
    [anon_sym_unknown] = ACTIONS(2833),
    [anon_sym_never] = ACTIONS(2833),
    [anon_sym_object] = ACTIONS(2833),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2835),
    [anon_sym_constructor] = ACTIONS(2833),
    [anon_sym_prop] = ACTIONS(2833),
    [anon_sym_id] = ACTIONS(2833),
    [anon_sym_event] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_on] = ACTIONS(2833),
    [sym__ternary_qmark] = ACTIONS(2835),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_typeof] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_var] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_switch] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_await] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_do] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_with] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_debugger] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_throw] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LTtemplate_GT] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_class] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_void] = ACTIONS(2837),
    [anon_sym_delete] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_number] = ACTIONS(2839),
    [sym_this] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_null] = ACTIONS(2837),
    [sym_undefined] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_override] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_component] = ACTIONS(2837),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2841),
    [anon_sym_var] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_switch] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_await] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_do] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [anon_sym_with] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_debugger] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_throw] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LTtemplate_GT] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_class] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_void] = ACTIONS(2841),
    [anon_sym_delete] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_number] = ACTIONS(2843),
    [sym_this] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_null] = ACTIONS(2841),
    [sym_undefined] = ACTIONS(2841),
    [anon_sym_AT] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_get] = ACTIONS(2841),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_declare] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2841),
    [anon_sym_public] = ACTIONS(2841),
    [anon_sym_private] = ACTIONS(2841),
    [anon_sym_protected] = ACTIONS(2841),
    [anon_sym_override] = ACTIONS(2841),
    [anon_sym_module] = ACTIONS(2841),
    [anon_sym_any] = ACTIONS(2841),
    [anon_sym_number] = ACTIONS(2841),
    [anon_sym_boolean] = ACTIONS(2841),
    [anon_sym_string] = ACTIONS(2841),
    [anon_sym_symbol] = ACTIONS(2841),
    [anon_sym_abstract] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_component] = ACTIONS(2841),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_export] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_typeof] = ACTIONS(2845),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_else] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_switch] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_do] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [anon_sym_with] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_debugger] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_throw] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LTtemplate_GT] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_class] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2847),
    [anon_sym_void] = ACTIONS(2845),
    [anon_sym_delete] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2847),
    [sym_number] = ACTIONS(2847),
    [sym_this] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_null] = ACTIONS(2845),
    [sym_undefined] = ACTIONS(2845),
    [anon_sym_AT] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_readonly] = ACTIONS(2845),
    [anon_sym_get] = ACTIONS(2845),
    [anon_sym_set] = ACTIONS(2845),
    [anon_sym_declare] = ACTIONS(2845),
    [anon_sym_namespace] = ACTIONS(2845),
    [anon_sym_public] = ACTIONS(2845),
    [anon_sym_private] = ACTIONS(2845),
    [anon_sym_protected] = ACTIONS(2845),
    [anon_sym_override] = ACTIONS(2845),
    [anon_sym_module] = ACTIONS(2845),
    [anon_sym_any] = ACTIONS(2845),
    [anon_sym_number] = ACTIONS(2845),
    [anon_sym_boolean] = ACTIONS(2845),
    [anon_sym_string] = ACTIONS(2845),
    [anon_sym_symbol] = ACTIONS(2845),
    [anon_sym_abstract] = ACTIONS(2845),
    [anon_sym_interface] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_component] = ACTIONS(2845),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(2485),
    [anon_sym_import] = ACTIONS(2485),
    [anon_sym_var] = ACTIONS(2485),
    [anon_sym_let] = ACTIONS(2485),
    [anon_sym_const] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2487),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_switch] = ACTIONS(2485),
    [anon_sym_for] = ACTIONS(2485),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_await] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_try] = ACTIONS(2485),
    [anon_sym_with] = ACTIONS(2485),
    [anon_sym_break] = ACTIONS(2485),
    [anon_sym_continue] = ACTIONS(2485),
    [anon_sym_debugger] = ACTIONS(2485),
    [anon_sym_return] = ACTIONS(2485),
    [anon_sym_throw] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_case] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(2485),
    [anon_sym_yield] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [anon_sym_LTtemplate_GT] = ACTIONS(2487),
    [anon_sym_LT] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2485),
    [anon_sym_class] = ACTIONS(2485),
    [anon_sym_async] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_void] = ACTIONS(2485),
    [anon_sym_delete] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2487),
    [anon_sym_DASH_DASH] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [sym_number] = ACTIONS(2487),
    [sym_this] = ACTIONS(2485),
    [sym_super] = ACTIONS(2485),
    [sym_true] = ACTIONS(2485),
    [sym_false] = ACTIONS(2485),
    [sym_null] = ACTIONS(2485),
    [sym_undefined] = ACTIONS(2485),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_static] = ACTIONS(2485),
    [anon_sym_readonly] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_override] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
    [anon_sym_abstract] = ACTIONS(2485),
    [anon_sym_interface] = ACTIONS(2485),
    [anon_sym_enum] = ACTIONS(2485),
    [anon_sym_component] = ACTIONS(2485),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_typeof] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_QMARK_DOT] = ACTIONS(2851),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2851),
    [anon_sym_LT_LT] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_CARET] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_STAR_STAR] = ACTIONS(2851),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2849),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2849),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2851),
    [anon_sym_GT_EQ] = ACTIONS(2851),
    [anon_sym_QMARK_QMARK] = ACTIONS(2851),
    [anon_sym_instanceof] = ACTIONS(2849),
    [anon_sym_void] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2851),
    [sym_number] = ACTIONS(2851),
    [sym_this] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_null] = ACTIONS(2849),
    [sym_undefined] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
    [anon_sym_abstract] = ACTIONS(2849),
    [anon_sym_satisfies] = ACTIONS(2849),
    [anon_sym_extends] = ACTIONS(2849),
    [anon_sym_infer] = ACTIONS(2849),
    [anon_sym_keyof] = ACTIONS(2849),
    [anon_sym_unknown] = ACTIONS(2849),
    [anon_sym_never] = ACTIONS(2849),
    [anon_sym_object] = ACTIONS(2849),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2851),
    [anon_sym_constructor] = ACTIONS(2849),
    [anon_sym_prop] = ACTIONS(2849),
    [anon_sym_id] = ACTIONS(2849),
    [anon_sym_event] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_on] = ACTIONS(2849),
    [sym__ternary_qmark] = ACTIONS(2851),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_as] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_typeof] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2853),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_QMARK_DOT] = ACTIONS(2855),
    [anon_sym_new] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_GT_GT_GT] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2853),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2855),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_instanceof] = ACTIONS(2853),
    [anon_sym_void] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [sym_number] = ACTIONS(2855),
    [sym_this] = ACTIONS(2853),
    [sym_true] = ACTIONS(2853),
    [sym_false] = ACTIONS(2853),
    [sym_null] = ACTIONS(2853),
    [sym_undefined] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_get] = ACTIONS(2853),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2853),
    [anon_sym_satisfies] = ACTIONS(2853),
    [anon_sym_extends] = ACTIONS(2853),
    [anon_sym_infer] = ACTIONS(2853),
    [anon_sym_keyof] = ACTIONS(2853),
    [anon_sym_unknown] = ACTIONS(2853),
    [anon_sym_never] = ACTIONS(2853),
    [anon_sym_object] = ACTIONS(2853),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2855),
    [anon_sym_constructor] = ACTIONS(2853),
    [anon_sym_prop] = ACTIONS(2853),
    [anon_sym_id] = ACTIONS(2853),
    [anon_sym_event] = ACTIONS(2853),
    [anon_sym_fn] = ACTIONS(2853),
    [anon_sym_on] = ACTIONS(2853),
    [sym__ternary_qmark] = ACTIONS(2855),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [799] = {
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_as] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_typeof] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_QMARK_DOT] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_GT_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_STAR_STAR] = ACTIONS(2859),
    [anon_sym_LT_EQ] = ACTIONS(2859),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2859),
    [anon_sym_GT_EQ] = ACTIONS(2859),
    [anon_sym_QMARK_QMARK] = ACTIONS(2859),
    [anon_sym_instanceof] = ACTIONS(2857),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2859),
    [sym_this] = ACTIONS(2857),
    [sym_true] = ACTIONS(2857),
    [sym_false] = ACTIONS(2857),
    [sym_null] = ACTIONS(2857),
    [sym_undefined] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2857),
    [anon_sym_satisfies] = ACTIONS(2857),
    [anon_sym_extends] = ACTIONS(2857),
    [anon_sym_infer] = ACTIONS(2857),
    [anon_sym_keyof] = ACTIONS(2857),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2859),
    [anon_sym_constructor] = ACTIONS(2857),
    [anon_sym_prop] = ACTIONS(2857),
    [anon_sym_id] = ACTIONS(2857),
    [anon_sym_event] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_on] = ACTIONS(2857),
    [sym__ternary_qmark] = ACTIONS(2859),
  },
  [800] = {
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_as] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_typeof] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2861),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_QMARK_DOT] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2861),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2861),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_QMARK_QMARK] = ACTIONS(2863),
    [anon_sym_instanceof] = ACTIONS(2861),
    [anon_sym_void] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [sym_number] = ACTIONS(2863),
    [sym_this] = ACTIONS(2861),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_undefined] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_QMARK] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [anon_sym_abstract] = ACTIONS(2861),
    [anon_sym_satisfies] = ACTIONS(2861),
    [anon_sym_extends] = ACTIONS(2861),
    [anon_sym_infer] = ACTIONS(2861),
    [anon_sym_keyof] = ACTIONS(2861),
    [anon_sym_unknown] = ACTIONS(2861),
    [anon_sym_never] = ACTIONS(2861),
    [anon_sym_object] = ACTIONS(2861),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2863),
    [anon_sym_constructor] = ACTIONS(2861),
    [anon_sym_prop] = ACTIONS(2861),
    [anon_sym_id] = ACTIONS(2861),
    [anon_sym_event] = ACTIONS(2861),
    [anon_sym_fn] = ACTIONS(2861),
    [anon_sym_on] = ACTIONS(2861),
    [sym__ternary_qmark] = ACTIONS(2863),
  },
  [801] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [802] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [804] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [805] = {
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_typeof] = ACTIONS(2865),
    [anon_sym_import] = ACTIONS(2865),
    [anon_sym_var] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_else] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_switch] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_await] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_do] = ACTIONS(2865),
    [anon_sym_try] = ACTIONS(2865),
    [anon_sym_with] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_debugger] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_throw] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LTtemplate_GT] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_class] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_void] = ACTIONS(2865),
    [anon_sym_delete] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [sym_number] = ACTIONS(2867),
    [sym_this] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_override] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_component] = ACTIONS(2865),
  },
  [806] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_as] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_typeof] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_QMARK_DOT] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_GT_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_STAR_STAR] = ACTIONS(2859),
    [anon_sym_LT_EQ] = ACTIONS(2859),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2859),
    [anon_sym_GT_EQ] = ACTIONS(2859),
    [anon_sym_QMARK_QMARK] = ACTIONS(2859),
    [anon_sym_instanceof] = ACTIONS(2857),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2859),
    [sym_this] = ACTIONS(2857),
    [sym_true] = ACTIONS(2857),
    [sym_false] = ACTIONS(2857),
    [sym_null] = ACTIONS(2857),
    [sym_undefined] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2857),
    [anon_sym_satisfies] = ACTIONS(2857),
    [anon_sym_extends] = ACTIONS(2857),
    [anon_sym_infer] = ACTIONS(2857),
    [anon_sym_keyof] = ACTIONS(2857),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2859),
    [anon_sym_constructor] = ACTIONS(2857),
    [anon_sym_prop] = ACTIONS(2857),
    [anon_sym_id] = ACTIONS(2857),
    [anon_sym_event] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_on] = ACTIONS(2857),
    [sym__ternary_qmark] = ACTIONS(2859),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_export] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_typeof] = ACTIONS(2869),
    [anon_sym_import] = ACTIONS(2869),
    [anon_sym_var] = ACTIONS(2869),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_await] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_with] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_debugger] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_LTtemplate_GT] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_SLASH] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2871),
    [anon_sym_void] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2871),
    [sym_number] = ACTIONS(2871),
    [sym_this] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_undefined] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_readonly] = ACTIONS(2869),
    [anon_sym_get] = ACTIONS(2869),
    [anon_sym_set] = ACTIONS(2869),
    [anon_sym_declare] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2869),
    [anon_sym_private] = ACTIONS(2869),
    [anon_sym_protected] = ACTIONS(2869),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2869),
    [anon_sym_number] = ACTIONS(2869),
    [anon_sym_boolean] = ACTIONS(2869),
    [anon_sym_string] = ACTIONS(2869),
    [anon_sym_symbol] = ACTIONS(2869),
    [anon_sym_abstract] = ACTIONS(2869),
    [anon_sym_interface] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_component] = ACTIONS(2869),
  },
  [809] = {
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_typeof] = ACTIONS(2873),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_var] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_else] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_switch] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_await] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_debugger] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_throw] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2873),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LTtemplate_GT] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_class] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_void] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [sym_number] = ACTIONS(2875),
    [sym_this] = ACTIONS(2873),
    [sym_super] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_null] = ACTIONS(2873),
    [sym_undefined] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_readonly] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2873),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_override] = ACTIONS(2873),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_abstract] = ACTIONS(2873),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_component] = ACTIONS(2873),
  },
  [810] = {
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_component] = ACTIONS(2469),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_typeof] = ACTIONS(2877),
    [anon_sym_import] = ACTIONS(2877),
    [anon_sym_var] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_else] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_await] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_debugger] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LTtemplate_GT] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_void] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2879),
    [sym_number] = ACTIONS(2879),
    [sym_this] = ACTIONS(2877),
    [sym_super] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_null] = ACTIONS(2877),
    [sym_undefined] = ACTIONS(2877),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_readonly] = ACTIONS(2877),
    [anon_sym_get] = ACTIONS(2877),
    [anon_sym_set] = ACTIONS(2877),
    [anon_sym_declare] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2877),
    [anon_sym_private] = ACTIONS(2877),
    [anon_sym_protected] = ACTIONS(2877),
    [anon_sym_override] = ACTIONS(2877),
    [anon_sym_module] = ACTIONS(2877),
    [anon_sym_any] = ACTIONS(2877),
    [anon_sym_number] = ACTIONS(2877),
    [anon_sym_boolean] = ACTIONS(2877),
    [anon_sym_string] = ACTIONS(2877),
    [anon_sym_symbol] = ACTIONS(2877),
    [anon_sym_abstract] = ACTIONS(2877),
    [anon_sym_interface] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_component] = ACTIONS(2877),
  },
  [812] = {
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_as] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_typeof] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_QMARK_DOT] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_GT_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_STAR_STAR] = ACTIONS(2859),
    [anon_sym_LT_EQ] = ACTIONS(2859),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2859),
    [anon_sym_GT_EQ] = ACTIONS(2859),
    [anon_sym_QMARK_QMARK] = ACTIONS(2859),
    [anon_sym_instanceof] = ACTIONS(2857),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2859),
    [sym_this] = ACTIONS(2857),
    [sym_true] = ACTIONS(2857),
    [sym_false] = ACTIONS(2857),
    [sym_null] = ACTIONS(2857),
    [sym_undefined] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2857),
    [anon_sym_satisfies] = ACTIONS(2857),
    [anon_sym_extends] = ACTIONS(2857),
    [anon_sym_infer] = ACTIONS(2857),
    [anon_sym_keyof] = ACTIONS(2857),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2859),
    [anon_sym_constructor] = ACTIONS(2857),
    [anon_sym_prop] = ACTIONS(2857),
    [anon_sym_id] = ACTIONS(2857),
    [anon_sym_event] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_on] = ACTIONS(2857),
    [sym__ternary_qmark] = ACTIONS(2859),
  },
  [813] = {
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_typeof] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_QMARK_DOT] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_GT_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_STAR_STAR] = ACTIONS(2883),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2883),
    [anon_sym_QMARK_QMARK] = ACTIONS(2883),
    [anon_sym_instanceof] = ACTIONS(2881),
    [anon_sym_void] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [sym_number] = ACTIONS(2883),
    [sym_this] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_null] = ACTIONS(2881),
    [sym_undefined] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_readonly] = ACTIONS(2881),
    [anon_sym_get] = ACTIONS(2881),
    [anon_sym_set] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_any] = ACTIONS(2881),
    [anon_sym_number] = ACTIONS(2881),
    [anon_sym_boolean] = ACTIONS(2881),
    [anon_sym_string] = ACTIONS(2881),
    [anon_sym_symbol] = ACTIONS(2881),
    [anon_sym_abstract] = ACTIONS(2881),
    [anon_sym_satisfies] = ACTIONS(2881),
    [anon_sym_extends] = ACTIONS(2881),
    [anon_sym_infer] = ACTIONS(2881),
    [anon_sym_keyof] = ACTIONS(2881),
    [anon_sym_unknown] = ACTIONS(2881),
    [anon_sym_never] = ACTIONS(2881),
    [anon_sym_object] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2883),
    [anon_sym_constructor] = ACTIONS(2881),
    [anon_sym_prop] = ACTIONS(2881),
    [anon_sym_id] = ACTIONS(2881),
    [anon_sym_event] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_on] = ACTIONS(2881),
    [sym__ternary_qmark] = ACTIONS(2883),
  },
  [814] = {
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_typeof] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_await] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_with] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_debugger] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LTtemplate_GT] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_async] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_void] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2887),
    [sym_number] = ACTIONS(2887),
    [sym_this] = ACTIONS(2885),
    [sym_super] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_null] = ACTIONS(2885),
    [sym_undefined] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_readonly] = ACTIONS(2885),
    [anon_sym_get] = ACTIONS(2885),
    [anon_sym_set] = ACTIONS(2885),
    [anon_sym_declare] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_override] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_any] = ACTIONS(2885),
    [anon_sym_number] = ACTIONS(2885),
    [anon_sym_boolean] = ACTIONS(2885),
    [anon_sym_string] = ACTIONS(2885),
    [anon_sym_symbol] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_component] = ACTIONS(2885),
  },
  [815] = {
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_typeof] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_await] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_with] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_debugger] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LTtemplate_GT] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_void] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [sym_number] = ACTIONS(2891),
    [sym_this] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_null] = ACTIONS(2889),
    [sym_undefined] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_readonly] = ACTIONS(2889),
    [anon_sym_get] = ACTIONS(2889),
    [anon_sym_set] = ACTIONS(2889),
    [anon_sym_declare] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_public] = ACTIONS(2889),
    [anon_sym_private] = ACTIONS(2889),
    [anon_sym_protected] = ACTIONS(2889),
    [anon_sym_override] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_any] = ACTIONS(2889),
    [anon_sym_number] = ACTIONS(2889),
    [anon_sym_boolean] = ACTIONS(2889),
    [anon_sym_string] = ACTIONS(2889),
    [anon_sym_symbol] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_component] = ACTIONS(2889),
  },
  [816] = {
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_QMARK_DOT] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2895),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_QMARK_QMARK] = ACTIONS(2895),
    [anon_sym_instanceof] = ACTIONS(2893),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_satisfies] = ACTIONS(2893),
    [anon_sym_extends] = ACTIONS(2893),
    [anon_sym_infer] = ACTIONS(2893),
    [anon_sym_keyof] = ACTIONS(2893),
    [anon_sym_unknown] = ACTIONS(2893),
    [anon_sym_never] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2895),
    [anon_sym_constructor] = ACTIONS(2893),
    [anon_sym_prop] = ACTIONS(2893),
    [anon_sym_id] = ACTIONS(2893),
    [anon_sym_event] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [sym__ternary_qmark] = ACTIONS(2895),
  },
  [817] = {
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_as] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_in] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_QMARK_DOT] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_GT_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_STAR_STAR] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2899),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_instanceof] = ACTIONS(2897),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_this] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_readonly] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_satisfies] = ACTIONS(2897),
    [anon_sym_extends] = ACTIONS(2897),
    [anon_sym_infer] = ACTIONS(2897),
    [anon_sym_keyof] = ACTIONS(2897),
    [anon_sym_unknown] = ACTIONS(2897),
    [anon_sym_never] = ACTIONS(2897),
    [anon_sym_object] = ACTIONS(2897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2899),
    [anon_sym_constructor] = ACTIONS(2897),
    [anon_sym_prop] = ACTIONS(2897),
    [anon_sym_id] = ACTIONS(2897),
    [anon_sym_event] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_on] = ACTIONS(2897),
    [sym__ternary_qmark] = ACTIONS(2899),
  },
  [818] = {
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_as] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_typeof] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_QMARK_DOT] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_PIPE_PIPE] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2901),
    [anon_sym_GT_GT_GT] = ACTIONS(2903),
    [anon_sym_LT_LT] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PERCENT] = ACTIONS(2903),
    [anon_sym_STAR_STAR] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2903),
    [anon_sym_GT_EQ] = ACTIONS(2903),
    [anon_sym_QMARK_QMARK] = ACTIONS(2903),
    [anon_sym_instanceof] = ACTIONS(2901),
    [anon_sym_void] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2903),
    [sym_number] = ACTIONS(2903),
    [sym_this] = ACTIONS(2901),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [sym_null] = ACTIONS(2901),
    [sym_undefined] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_readonly] = ACTIONS(2901),
    [anon_sym_get] = ACTIONS(2901),
    [anon_sym_set] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_any] = ACTIONS(2901),
    [anon_sym_number] = ACTIONS(2901),
    [anon_sym_boolean] = ACTIONS(2901),
    [anon_sym_string] = ACTIONS(2901),
    [anon_sym_symbol] = ACTIONS(2901),
    [anon_sym_abstract] = ACTIONS(2901),
    [anon_sym_satisfies] = ACTIONS(2901),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2901),
    [anon_sym_keyof] = ACTIONS(2901),
    [anon_sym_unknown] = ACTIONS(2901),
    [anon_sym_never] = ACTIONS(2901),
    [anon_sym_object] = ACTIONS(2901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2903),
    [anon_sym_constructor] = ACTIONS(2901),
    [anon_sym_prop] = ACTIONS(2901),
    [anon_sym_id] = ACTIONS(2901),
    [anon_sym_event] = ACTIONS(2901),
    [anon_sym_fn] = ACTIONS(2901),
    [anon_sym_on] = ACTIONS(2901),
    [sym__ternary_qmark] = ACTIONS(2903),
  },
  [819] = {
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_as] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_in] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_QMARK_DOT] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_GT_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_STAR_STAR] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2899),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_instanceof] = ACTIONS(2897),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_this] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_readonly] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_satisfies] = ACTIONS(2897),
    [anon_sym_extends] = ACTIONS(2897),
    [anon_sym_infer] = ACTIONS(2897),
    [anon_sym_keyof] = ACTIONS(2897),
    [anon_sym_unknown] = ACTIONS(2897),
    [anon_sym_never] = ACTIONS(2897),
    [anon_sym_object] = ACTIONS(2897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2899),
    [anon_sym_constructor] = ACTIONS(2897),
    [anon_sym_prop] = ACTIONS(2897),
    [anon_sym_id] = ACTIONS(2897),
    [anon_sym_event] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_on] = ACTIONS(2897),
    [sym__ternary_qmark] = ACTIONS(2899),
  },
  [820] = {
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_as] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_in] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_QMARK_DOT] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_GT_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_STAR_STAR] = ACTIONS(2899),
    [anon_sym_LT_EQ] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2899),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2899),
    [anon_sym_GT_EQ] = ACTIONS(2899),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_instanceof] = ACTIONS(2897),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_this] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_readonly] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_QMARK] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_satisfies] = ACTIONS(2897),
    [anon_sym_extends] = ACTIONS(2897),
    [anon_sym_infer] = ACTIONS(2897),
    [anon_sym_keyof] = ACTIONS(2897),
    [anon_sym_unknown] = ACTIONS(2897),
    [anon_sym_never] = ACTIONS(2897),
    [anon_sym_object] = ACTIONS(2897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2899),
    [anon_sym_constructor] = ACTIONS(2897),
    [anon_sym_prop] = ACTIONS(2897),
    [anon_sym_id] = ACTIONS(2897),
    [anon_sym_event] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_on] = ACTIONS(2897),
    [sym__ternary_qmark] = ACTIONS(2899),
  },
  [821] = {
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_typeof] = ACTIONS(2905),
    [anon_sym_import] = ACTIONS(2905),
    [anon_sym_var] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_await] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_debugger] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LTtemplate_GT] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_void] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_number] = ACTIONS(2907),
    [sym_this] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [sym_null] = ACTIONS(2905),
    [sym_undefined] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2905),
    [anon_sym_set] = ACTIONS(2905),
    [anon_sym_declare] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_override] = ACTIONS(2905),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_any] = ACTIONS(2905),
    [anon_sym_number] = ACTIONS(2905),
    [anon_sym_boolean] = ACTIONS(2905),
    [anon_sym_string] = ACTIONS(2905),
    [anon_sym_symbol] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2905),
    [anon_sym_interface] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_component] = ACTIONS(2905),
  },
  [822] = {
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_as] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_in] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_QMARK_DOT] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_GT_GT_GT] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_BANG_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2911),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_QMARK_QMARK] = ACTIONS(2911),
    [anon_sym_instanceof] = ACTIONS(2909),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [sym_this] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [sym_false] = ACTIONS(2909),
    [sym_null] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_readonly] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_QMARK] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_satisfies] = ACTIONS(2909),
    [anon_sym_extends] = ACTIONS(2909),
    [anon_sym_infer] = ACTIONS(2909),
    [anon_sym_keyof] = ACTIONS(2909),
    [anon_sym_unknown] = ACTIONS(2909),
    [anon_sym_never] = ACTIONS(2909),
    [anon_sym_object] = ACTIONS(2909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2911),
    [anon_sym_constructor] = ACTIONS(2909),
    [anon_sym_prop] = ACTIONS(2909),
    [anon_sym_id] = ACTIONS(2909),
    [anon_sym_event] = ACTIONS(2909),
    [anon_sym_fn] = ACTIONS(2909),
    [anon_sym_on] = ACTIONS(2909),
    [sym__ternary_qmark] = ACTIONS(2911),
  },
  [823] = {
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_as] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_QMARK_DOT] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_GT_GT_GT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_instanceof] = ACTIONS(2913),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_number] = ACTIONS(2915),
    [sym_this] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_readonly] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_satisfies] = ACTIONS(2913),
    [anon_sym_extends] = ACTIONS(2913),
    [anon_sym_infer] = ACTIONS(2913),
    [anon_sym_keyof] = ACTIONS(2913),
    [anon_sym_unknown] = ACTIONS(2913),
    [anon_sym_never] = ACTIONS(2913),
    [anon_sym_object] = ACTIONS(2913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2915),
    [anon_sym_constructor] = ACTIONS(2913),
    [anon_sym_prop] = ACTIONS(2913),
    [anon_sym_id] = ACTIONS(2913),
    [anon_sym_event] = ACTIONS(2913),
    [anon_sym_fn] = ACTIONS(2913),
    [anon_sym_on] = ACTIONS(2913),
    [sym__ternary_qmark] = ACTIONS(2915),
  },
  [824] = {
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_typeof] = ACTIONS(2917),
    [anon_sym_import] = ACTIONS(2917),
    [anon_sym_var] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_switch] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_await] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2917),
    [anon_sym_try] = ACTIONS(2917),
    [anon_sym_with] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_debugger] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_throw] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2917),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_LTtemplate_GT] = ACTIONS(2919),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_class] = ACTIONS(2917),
    [anon_sym_async] = ACTIONS(2917),
    [anon_sym_function] = ACTIONS(2917),
    [anon_sym_new] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_void] = ACTIONS(2917),
    [anon_sym_delete] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [anon_sym_DQUOTE] = ACTIONS(2919),
    [anon_sym_SQUOTE] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2919),
    [sym_number] = ACTIONS(2919),
    [sym_this] = ACTIONS(2917),
    [sym_super] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_null] = ACTIONS(2917),
    [sym_undefined] = ACTIONS(2917),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2917),
    [anon_sym_readonly] = ACTIONS(2917),
    [anon_sym_get] = ACTIONS(2917),
    [anon_sym_set] = ACTIONS(2917),
    [anon_sym_declare] = ACTIONS(2917),
    [anon_sym_namespace] = ACTIONS(2917),
    [anon_sym_public] = ACTIONS(2917),
    [anon_sym_private] = ACTIONS(2917),
    [anon_sym_protected] = ACTIONS(2917),
    [anon_sym_override] = ACTIONS(2917),
    [anon_sym_module] = ACTIONS(2917),
    [anon_sym_any] = ACTIONS(2917),
    [anon_sym_number] = ACTIONS(2917),
    [anon_sym_boolean] = ACTIONS(2917),
    [anon_sym_string] = ACTIONS(2917),
    [anon_sym_symbol] = ACTIONS(2917),
    [anon_sym_abstract] = ACTIONS(2917),
    [anon_sym_interface] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [anon_sym_component] = ACTIONS(2917),
  },
  [825] = {
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_as] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_QMARK_DOT] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_GT_GT_GT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_instanceof] = ACTIONS(2913),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_number] = ACTIONS(2915),
    [sym_this] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_readonly] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_satisfies] = ACTIONS(2913),
    [anon_sym_extends] = ACTIONS(2913),
    [anon_sym_infer] = ACTIONS(2913),
    [anon_sym_keyof] = ACTIONS(2913),
    [anon_sym_unknown] = ACTIONS(2913),
    [anon_sym_never] = ACTIONS(2913),
    [anon_sym_object] = ACTIONS(2913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2915),
    [anon_sym_constructor] = ACTIONS(2913),
    [anon_sym_prop] = ACTIONS(2913),
    [anon_sym_id] = ACTIONS(2913),
    [anon_sym_event] = ACTIONS(2913),
    [anon_sym_fn] = ACTIONS(2913),
    [anon_sym_on] = ACTIONS(2913),
    [sym__ternary_qmark] = ACTIONS(2915),
  },
  [826] = {
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_as] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_QMARK_DOT] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_GT_GT_GT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_instanceof] = ACTIONS(2913),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_number] = ACTIONS(2915),
    [sym_this] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_readonly] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_satisfies] = ACTIONS(2913),
    [anon_sym_extends] = ACTIONS(2913),
    [anon_sym_infer] = ACTIONS(2913),
    [anon_sym_keyof] = ACTIONS(2913),
    [anon_sym_unknown] = ACTIONS(2913),
    [anon_sym_never] = ACTIONS(2913),
    [anon_sym_object] = ACTIONS(2913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2915),
    [anon_sym_constructor] = ACTIONS(2913),
    [anon_sym_prop] = ACTIONS(2913),
    [anon_sym_id] = ACTIONS(2913),
    [anon_sym_event] = ACTIONS(2913),
    [anon_sym_fn] = ACTIONS(2913),
    [anon_sym_on] = ACTIONS(2913),
    [sym__ternary_qmark] = ACTIONS(2915),
  },
  [827] = {
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_as] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2445),
    [anon_sym_typeof] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2443),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_SLASH] = ACTIONS(2443),
    [anon_sym_DOT] = ACTIONS(2443),
    [anon_sym_async] = ACTIONS(2443),
    [anon_sym_QMARK_DOT] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE] = ACTIONS(2445),
    [anon_sym_GT_GT] = ACTIONS(2443),
    [anon_sym_GT_GT_GT] = ACTIONS(2445),
    [anon_sym_LT_LT] = ACTIONS(2445),
    [anon_sym_AMP] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2445),
    [anon_sym_PIPE] = ACTIONS(2443),
    [anon_sym_PLUS] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2443),
    [anon_sym_PERCENT] = ACTIONS(2445),
    [anon_sym_STAR_STAR] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_EQ_EQ] = ACTIONS(2443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2445),
    [anon_sym_BANG_EQ] = ACTIONS(2443),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2445),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_QMARK_QMARK] = ACTIONS(2445),
    [anon_sym_instanceof] = ACTIONS(2443),
    [anon_sym_void] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2445),
    [sym_number] = ACTIONS(2445),
    [sym_this] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_null] = ACTIONS(2443),
    [sym_undefined] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_readonly] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_QMARK] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
    [anon_sym_abstract] = ACTIONS(2443),
    [anon_sym_satisfies] = ACTIONS(2443),
    [anon_sym_extends] = ACTIONS(2443),
    [anon_sym_infer] = ACTIONS(2443),
    [anon_sym_keyof] = ACTIONS(2443),
    [anon_sym_unknown] = ACTIONS(2443),
    [anon_sym_never] = ACTIONS(2443),
    [anon_sym_object] = ACTIONS(2443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2445),
    [anon_sym_constructor] = ACTIONS(2443),
    [anon_sym_prop] = ACTIONS(2443),
    [anon_sym_id] = ACTIONS(2443),
    [anon_sym_event] = ACTIONS(2443),
    [anon_sym_fn] = ACTIONS(2443),
    [anon_sym_on] = ACTIONS(2443),
    [sym__ternary_qmark] = ACTIONS(2445),
  },
  [828] = {
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_GT] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_QMARK_DOT] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_QMARK_QMARK] = ACTIONS(2923),
    [anon_sym_instanceof] = ACTIONS(2921),
    [anon_sym_void] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_DQUOTE] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2923),
    [sym_number] = ACTIONS(2923),
    [sym_this] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_null] = ACTIONS(2921),
    [sym_undefined] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_get] = ACTIONS(2921),
    [anon_sym_set] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_any] = ACTIONS(2921),
    [anon_sym_number] = ACTIONS(2921),
    [anon_sym_boolean] = ACTIONS(2921),
    [anon_sym_string] = ACTIONS(2921),
    [anon_sym_symbol] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_satisfies] = ACTIONS(2921),
    [anon_sym_extends] = ACTIONS(2921),
    [anon_sym_infer] = ACTIONS(2921),
    [anon_sym_keyof] = ACTIONS(2921),
    [anon_sym_unknown] = ACTIONS(2921),
    [anon_sym_never] = ACTIONS(2921),
    [anon_sym_object] = ACTIONS(2921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2923),
    [anon_sym_constructor] = ACTIONS(2921),
    [anon_sym_prop] = ACTIONS(2921),
    [anon_sym_id] = ACTIONS(2921),
    [anon_sym_event] = ACTIONS(2921),
    [anon_sym_fn] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [sym__ternary_qmark] = ACTIONS(2923),
  },
  [829] = {
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_as] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_DOT] = ACTIONS(2925),
    [anon_sym_async] = ACTIONS(2925),
    [anon_sym_QMARK_DOT] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2927),
    [anon_sym_LT_LT] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_CARET] = ACTIONS(2927),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2927),
    [anon_sym_STAR_STAR] = ACTIONS(2927),
    [anon_sym_LT_EQ] = ACTIONS(2927),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2927),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2927),
    [anon_sym_GT_EQ] = ACTIONS(2927),
    [anon_sym_QMARK_QMARK] = ACTIONS(2927),
    [anon_sym_instanceof] = ACTIONS(2925),
    [anon_sym_void] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym_this] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_null] = ACTIONS(2925),
    [sym_undefined] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_readonly] = ACTIONS(2925),
    [anon_sym_get] = ACTIONS(2925),
    [anon_sym_set] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_any] = ACTIONS(2925),
    [anon_sym_number] = ACTIONS(2925),
    [anon_sym_boolean] = ACTIONS(2925),
    [anon_sym_string] = ACTIONS(2925),
    [anon_sym_symbol] = ACTIONS(2925),
    [anon_sym_abstract] = ACTIONS(2925),
    [anon_sym_satisfies] = ACTIONS(2925),
    [anon_sym_extends] = ACTIONS(2925),
    [anon_sym_infer] = ACTIONS(2925),
    [anon_sym_keyof] = ACTIONS(2925),
    [anon_sym_unknown] = ACTIONS(2925),
    [anon_sym_never] = ACTIONS(2925),
    [anon_sym_object] = ACTIONS(2925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2927),
    [anon_sym_constructor] = ACTIONS(2925),
    [anon_sym_prop] = ACTIONS(2925),
    [anon_sym_id] = ACTIONS(2925),
    [anon_sym_event] = ACTIONS(2925),
    [anon_sym_fn] = ACTIONS(2925),
    [anon_sym_on] = ACTIONS(2925),
    [sym__ternary_qmark] = ACTIONS(2927),
  },
  [830] = {
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_as] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_in] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_GT] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_DOT] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_QMARK_DOT] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2929),
    [anon_sym_GT_GT_GT] = ACTIONS(2931),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2931),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_QMARK_QMARK] = ACTIONS(2931),
    [anon_sym_instanceof] = ACTIONS(2929),
    [anon_sym_void] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2931),
    [sym_number] = ACTIONS(2931),
    [sym_this] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_null] = ACTIONS(2929),
    [sym_undefined] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_satisfies] = ACTIONS(2929),
    [anon_sym_extends] = ACTIONS(2929),
    [anon_sym_infer] = ACTIONS(2929),
    [anon_sym_keyof] = ACTIONS(2929),
    [anon_sym_unknown] = ACTIONS(2929),
    [anon_sym_never] = ACTIONS(2929),
    [anon_sym_object] = ACTIONS(2929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2931),
    [anon_sym_constructor] = ACTIONS(2929),
    [anon_sym_prop] = ACTIONS(2929),
    [anon_sym_id] = ACTIONS(2929),
    [anon_sym_event] = ACTIONS(2929),
    [anon_sym_fn] = ACTIONS(2929),
    [anon_sym_on] = ACTIONS(2929),
    [sym__ternary_qmark] = ACTIONS(2931),
  },
  [831] = {
    [sym_identifier] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_as] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_typeof] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2815),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_async] = ACTIONS(2815),
    [anon_sym_QMARK_DOT] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2815),
    [anon_sym_GT_GT_GT] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_STAR_STAR] = ACTIONS(2817),
    [anon_sym_LT_EQ] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2817),
    [anon_sym_GT_EQ] = ACTIONS(2817),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_instanceof] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2817),
    [sym_number] = ACTIONS(2817),
    [sym_this] = ACTIONS(2815),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [sym_null] = ACTIONS(2815),
    [sym_undefined] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_readonly] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(2815),
    [anon_sym_set] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_any] = ACTIONS(2815),
    [anon_sym_number] = ACTIONS(2815),
    [anon_sym_boolean] = ACTIONS(2815),
    [anon_sym_string] = ACTIONS(2815),
    [anon_sym_symbol] = ACTIONS(2815),
    [anon_sym_abstract] = ACTIONS(2815),
    [anon_sym_satisfies] = ACTIONS(2815),
    [anon_sym_extends] = ACTIONS(2815),
    [anon_sym_infer] = ACTIONS(2815),
    [anon_sym_keyof] = ACTIONS(2815),
    [anon_sym_unknown] = ACTIONS(2815),
    [anon_sym_never] = ACTIONS(2815),
    [anon_sym_object] = ACTIONS(2815),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2817),
    [anon_sym_constructor] = ACTIONS(2815),
    [anon_sym_prop] = ACTIONS(2815),
    [anon_sym_id] = ACTIONS(2815),
    [anon_sym_event] = ACTIONS(2815),
    [anon_sym_fn] = ACTIONS(2815),
    [anon_sym_on] = ACTIONS(2815),
    [sym__ternary_qmark] = ACTIONS(2817),
  },
  [832] = {
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_as] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2933),
    [anon_sym_QMARK_DOT] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_GT_GT_GT] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_CARET] = ACTIONS(2935),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2935),
    [anon_sym_STAR_STAR] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2935),
    [anon_sym_instanceof] = ACTIONS(2933),
    [anon_sym_void] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2935),
    [sym_number] = ACTIONS(2935),
    [sym_this] = ACTIONS(2933),
    [sym_true] = ACTIONS(2933),
    [sym_false] = ACTIONS(2933),
    [sym_null] = ACTIONS(2933),
    [sym_undefined] = ACTIONS(2933),
    [anon_sym_static] = ACTIONS(2933),
    [anon_sym_readonly] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_abstract] = ACTIONS(2933),
    [anon_sym_satisfies] = ACTIONS(2933),
    [anon_sym_extends] = ACTIONS(2933),
    [anon_sym_infer] = ACTIONS(2933),
    [anon_sym_keyof] = ACTIONS(2933),
    [anon_sym_unknown] = ACTIONS(2933),
    [anon_sym_never] = ACTIONS(2933),
    [anon_sym_object] = ACTIONS(2933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2935),
    [anon_sym_constructor] = ACTIONS(2933),
    [anon_sym_prop] = ACTIONS(2933),
    [anon_sym_id] = ACTIONS(2933),
    [anon_sym_event] = ACTIONS(2933),
    [anon_sym_fn] = ACTIONS(2933),
    [anon_sym_on] = ACTIONS(2933),
    [sym__ternary_qmark] = ACTIONS(2935),
  },
  [833] = {
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_as] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_in] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_QMARK_DOT] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_GT_GT_GT] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_BANG_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2911),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_QMARK_QMARK] = ACTIONS(2911),
    [anon_sym_instanceof] = ACTIONS(2909),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [sym_this] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [sym_false] = ACTIONS(2909),
    [sym_null] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_readonly] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_QMARK] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_satisfies] = ACTIONS(2909),
    [anon_sym_extends] = ACTIONS(2909),
    [anon_sym_infer] = ACTIONS(2909),
    [anon_sym_keyof] = ACTIONS(2909),
    [anon_sym_unknown] = ACTIONS(2909),
    [anon_sym_never] = ACTIONS(2909),
    [anon_sym_object] = ACTIONS(2909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2911),
    [anon_sym_constructor] = ACTIONS(2909),
    [anon_sym_prop] = ACTIONS(2909),
    [anon_sym_id] = ACTIONS(2909),
    [anon_sym_event] = ACTIONS(2909),
    [anon_sym_fn] = ACTIONS(2909),
    [anon_sym_on] = ACTIONS(2909),
    [sym__ternary_qmark] = ACTIONS(2911),
  },
  [834] = {
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_QMARK_DOT] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_GT_GT_GT] = ACTIONS(2939),
    [anon_sym_LT_LT] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2939),
    [anon_sym_STAR_STAR] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_EQ_EQ] = ACTIONS(2937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2939),
    [anon_sym_instanceof] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2939),
    [sym_number] = ACTIONS(2939),
    [sym_this] = ACTIONS(2937),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [sym_null] = ACTIONS(2937),
    [sym_undefined] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_satisfies] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(2937),
    [anon_sym_infer] = ACTIONS(2937),
    [anon_sym_keyof] = ACTIONS(2937),
    [anon_sym_unknown] = ACTIONS(2937),
    [anon_sym_never] = ACTIONS(2937),
    [anon_sym_object] = ACTIONS(2937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2939),
    [anon_sym_constructor] = ACTIONS(2937),
    [anon_sym_prop] = ACTIONS(2937),
    [anon_sym_id] = ACTIONS(2937),
    [anon_sym_event] = ACTIONS(2937),
    [anon_sym_fn] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [sym__ternary_qmark] = ACTIONS(2939),
  },
  [835] = {
    [sym_identifier] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_as] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_GT] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_DOT] = ACTIONS(2941),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_QMARK_DOT] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_GT_GT_GT] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2943),
    [anon_sym_STAR_STAR] = ACTIONS(2943),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_EQ_EQ] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2941),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK] = ACTIONS(2943),
    [anon_sym_instanceof] = ACTIONS(2941),
    [anon_sym_void] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [sym_number] = ACTIONS(2943),
    [sym_this] = ACTIONS(2941),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [sym_null] = ACTIONS(2941),
    [sym_undefined] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_readonly] = ACTIONS(2941),
    [anon_sym_get] = ACTIONS(2941),
    [anon_sym_set] = ACTIONS(2941),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_any] = ACTIONS(2941),
    [anon_sym_number] = ACTIONS(2941),
    [anon_sym_boolean] = ACTIONS(2941),
    [anon_sym_string] = ACTIONS(2941),
    [anon_sym_symbol] = ACTIONS(2941),
    [anon_sym_abstract] = ACTIONS(2941),
    [anon_sym_satisfies] = ACTIONS(2941),
    [anon_sym_extends] = ACTIONS(2941),
    [anon_sym_infer] = ACTIONS(2941),
    [anon_sym_keyof] = ACTIONS(2941),
    [anon_sym_unknown] = ACTIONS(2941),
    [anon_sym_never] = ACTIONS(2941),
    [anon_sym_object] = ACTIONS(2941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2943),
    [anon_sym_constructor] = ACTIONS(2941),
    [anon_sym_prop] = ACTIONS(2941),
    [anon_sym_id] = ACTIONS(2941),
    [anon_sym_event] = ACTIONS(2941),
    [anon_sym_fn] = ACTIONS(2941),
    [anon_sym_on] = ACTIONS(2941),
    [sym__ternary_qmark] = ACTIONS(2943),
  },
  [836] = {
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_as] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_in] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_LBRACK] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_DOT] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_QMARK_DOT] = ACTIONS(2467),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2465),
    [anon_sym_GT_GT_GT] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_CARET] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PERCENT] = ACTIONS(2467),
    [anon_sym_STAR_STAR] = ACTIONS(2467),
    [anon_sym_LT_EQ] = ACTIONS(2467),
    [anon_sym_EQ_EQ] = ACTIONS(2465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2467),
    [anon_sym_BANG_EQ] = ACTIONS(2465),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2467),
    [anon_sym_GT_EQ] = ACTIONS(2467),
    [anon_sym_QMARK_QMARK] = ACTIONS(2467),
    [anon_sym_instanceof] = ACTIONS(2465),
    [anon_sym_void] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [sym_number] = ACTIONS(2467),
    [sym_this] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_null] = ACTIONS(2465),
    [sym_undefined] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_readonly] = ACTIONS(2465),
    [anon_sym_get] = ACTIONS(2465),
    [anon_sym_set] = ACTIONS(2465),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_any] = ACTIONS(2465),
    [anon_sym_number] = ACTIONS(2465),
    [anon_sym_boolean] = ACTIONS(2465),
    [anon_sym_string] = ACTIONS(2465),
    [anon_sym_symbol] = ACTIONS(2465),
    [anon_sym_abstract] = ACTIONS(2465),
    [anon_sym_satisfies] = ACTIONS(2465),
    [anon_sym_extends] = ACTIONS(2465),
    [anon_sym_infer] = ACTIONS(2465),
    [anon_sym_keyof] = ACTIONS(2465),
    [anon_sym_unknown] = ACTIONS(2465),
    [anon_sym_never] = ACTIONS(2465),
    [anon_sym_object] = ACTIONS(2465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2467),
    [anon_sym_constructor] = ACTIONS(2465),
    [anon_sym_prop] = ACTIONS(2465),
    [anon_sym_id] = ACTIONS(2465),
    [anon_sym_event] = ACTIONS(2465),
    [anon_sym_fn] = ACTIONS(2465),
    [anon_sym_on] = ACTIONS(2465),
    [sym__ternary_qmark] = ACTIONS(2467),
  },
  [837] = {
    [sym_identifier] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_as] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_GT] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_DOT] = ACTIONS(2941),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_QMARK_DOT] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_GT_GT_GT] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2943),
    [anon_sym_STAR_STAR] = ACTIONS(2943),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_EQ_EQ] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2941),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK] = ACTIONS(2943),
    [anon_sym_instanceof] = ACTIONS(2941),
    [anon_sym_void] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [sym_number] = ACTIONS(2943),
    [sym_this] = ACTIONS(2941),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [sym_null] = ACTIONS(2941),
    [sym_undefined] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_readonly] = ACTIONS(2941),
    [anon_sym_get] = ACTIONS(2941),
    [anon_sym_set] = ACTIONS(2941),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_any] = ACTIONS(2941),
    [anon_sym_number] = ACTIONS(2941),
    [anon_sym_boolean] = ACTIONS(2941),
    [anon_sym_string] = ACTIONS(2941),
    [anon_sym_symbol] = ACTIONS(2941),
    [anon_sym_abstract] = ACTIONS(2941),
    [anon_sym_satisfies] = ACTIONS(2941),
    [anon_sym_extends] = ACTIONS(2941),
    [anon_sym_infer] = ACTIONS(2941),
    [anon_sym_keyof] = ACTIONS(2941),
    [anon_sym_unknown] = ACTIONS(2941),
    [anon_sym_never] = ACTIONS(2941),
    [anon_sym_object] = ACTIONS(2941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2943),
    [anon_sym_constructor] = ACTIONS(2941),
    [anon_sym_prop] = ACTIONS(2941),
    [anon_sym_id] = ACTIONS(2941),
    [anon_sym_event] = ACTIONS(2941),
    [anon_sym_fn] = ACTIONS(2941),
    [anon_sym_on] = ACTIONS(2941),
    [sym__ternary_qmark] = ACTIONS(2943),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2686),
    [anon_sym_typeof] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_var] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2688),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_switch] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_await] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_do] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_with] = ACTIONS(2686),
    [anon_sym_break] = ACTIONS(2686),
    [anon_sym_continue] = ACTIONS(2686),
    [anon_sym_debugger] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_throw] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2686),
    [anon_sym_default] = ACTIONS(2686),
    [anon_sym_yield] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LTtemplate_GT] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_class] = ACTIONS(2686),
    [anon_sym_async] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_new] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2688),
    [anon_sym_void] = ACTIONS(2686),
    [anon_sym_delete] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2686),
    [sym_super] = ACTIONS(2686),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2686),
    [anon_sym_readonly] = ACTIONS(2686),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2686),
    [anon_sym_namespace] = ACTIONS(2686),
    [anon_sym_public] = ACTIONS(2686),
    [anon_sym_private] = ACTIONS(2686),
    [anon_sym_protected] = ACTIONS(2686),
    [anon_sym_override] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_any] = ACTIONS(2686),
    [anon_sym_number] = ACTIONS(2686),
    [anon_sym_boolean] = ACTIONS(2686),
    [anon_sym_string] = ACTIONS(2686),
    [anon_sym_symbol] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_interface] = ACTIONS(2686),
    [anon_sym_enum] = ACTIONS(2686),
    [anon_sym_component] = ACTIONS(2686),
  },
  [839] = {
    [sym_identifier] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_as] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_QMARK_DOT] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_GT_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK] = ACTIONS(2947),
    [anon_sym_instanceof] = ACTIONS(2945),
    [anon_sym_void] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [sym_number] = ACTIONS(2947),
    [sym_this] = ACTIONS(2945),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [sym_null] = ACTIONS(2945),
    [sym_undefined] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_get] = ACTIONS(2945),
    [anon_sym_set] = ACTIONS(2945),
    [anon_sym_QMARK] = ACTIONS(2945),
    [anon_sym_any] = ACTIONS(2945),
    [anon_sym_number] = ACTIONS(2945),
    [anon_sym_boolean] = ACTIONS(2945),
    [anon_sym_string] = ACTIONS(2945),
    [anon_sym_symbol] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_satisfies] = ACTIONS(2945),
    [anon_sym_extends] = ACTIONS(2945),
    [anon_sym_infer] = ACTIONS(2945),
    [anon_sym_keyof] = ACTIONS(2945),
    [anon_sym_unknown] = ACTIONS(2945),
    [anon_sym_never] = ACTIONS(2945),
    [anon_sym_object] = ACTIONS(2945),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2947),
    [anon_sym_constructor] = ACTIONS(2945),
    [anon_sym_prop] = ACTIONS(2945),
    [anon_sym_id] = ACTIONS(2945),
    [anon_sym_event] = ACTIONS(2945),
    [anon_sym_fn] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [sym__ternary_qmark] = ACTIONS(2947),
  },
  [840] = {
    [sym_identifier] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_as] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_STAR_STAR] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK] = ACTIONS(2951),
    [anon_sym_instanceof] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2951),
    [sym_number] = ACTIONS(2951),
    [sym_this] = ACTIONS(2949),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [sym_null] = ACTIONS(2949),
    [sym_undefined] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2949),
    [anon_sym_any] = ACTIONS(2949),
    [anon_sym_number] = ACTIONS(2949),
    [anon_sym_boolean] = ACTIONS(2949),
    [anon_sym_string] = ACTIONS(2949),
    [anon_sym_symbol] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_satisfies] = ACTIONS(2949),
    [anon_sym_extends] = ACTIONS(2949),
    [anon_sym_infer] = ACTIONS(2949),
    [anon_sym_keyof] = ACTIONS(2949),
    [anon_sym_unknown] = ACTIONS(2949),
    [anon_sym_never] = ACTIONS(2949),
    [anon_sym_object] = ACTIONS(2949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2951),
    [anon_sym_constructor] = ACTIONS(2949),
    [anon_sym_prop] = ACTIONS(2949),
    [anon_sym_id] = ACTIONS(2949),
    [anon_sym_event] = ACTIONS(2949),
    [anon_sym_fn] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [sym__ternary_qmark] = ACTIONS(2951),
  },
  [841] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1621),
    [anon_sym_PIPE_PIPE] = ACTIONS(1621),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1621),
    [anon_sym_LT_LT] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1621),
    [anon_sym_STAR_STAR] = ACTIONS(1621),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1621),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [842] = {
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_QMARK_DOT] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_GT_GT] = ACTIONS(2953),
    [anon_sym_GT_GT_GT] = ACTIONS(2955),
    [anon_sym_LT_LT] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_PIPE] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2955),
    [anon_sym_STAR_STAR] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK] = ACTIONS(2955),
    [anon_sym_instanceof] = ACTIONS(2953),
    [anon_sym_void] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2955),
    [sym_number] = ACTIONS(2955),
    [sym_this] = ACTIONS(2953),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [sym_null] = ACTIONS(2953),
    [sym_undefined] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_readonly] = ACTIONS(2953),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_any] = ACTIONS(2953),
    [anon_sym_number] = ACTIONS(2953),
    [anon_sym_boolean] = ACTIONS(2953),
    [anon_sym_string] = ACTIONS(2953),
    [anon_sym_symbol] = ACTIONS(2953),
    [anon_sym_abstract] = ACTIONS(2953),
    [anon_sym_satisfies] = ACTIONS(2953),
    [anon_sym_extends] = ACTIONS(2953),
    [anon_sym_infer] = ACTIONS(2953),
    [anon_sym_keyof] = ACTIONS(2953),
    [anon_sym_unknown] = ACTIONS(2953),
    [anon_sym_never] = ACTIONS(2953),
    [anon_sym_object] = ACTIONS(2953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2955),
    [anon_sym_constructor] = ACTIONS(2953),
    [anon_sym_prop] = ACTIONS(2953),
    [anon_sym_id] = ACTIONS(2953),
    [anon_sym_event] = ACTIONS(2953),
    [anon_sym_fn] = ACTIONS(2953),
    [anon_sym_on] = ACTIONS(2953),
    [sym__ternary_qmark] = ACTIONS(2955),
  },
  [843] = {
    [sym_identifier] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_as] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_QMARK_DOT] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_GT_GT_GT] = ACTIONS(2951),
    [anon_sym_LT_LT] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(2951),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2951),
    [anon_sym_STAR_STAR] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK] = ACTIONS(2951),
    [anon_sym_instanceof] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2951),
    [sym_number] = ACTIONS(2951),
    [sym_this] = ACTIONS(2949),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [sym_null] = ACTIONS(2949),
    [sym_undefined] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2949),
    [anon_sym_any] = ACTIONS(2949),
    [anon_sym_number] = ACTIONS(2949),
    [anon_sym_boolean] = ACTIONS(2949),
    [anon_sym_string] = ACTIONS(2949),
    [anon_sym_symbol] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_satisfies] = ACTIONS(2949),
    [anon_sym_extends] = ACTIONS(2949),
    [anon_sym_infer] = ACTIONS(2949),
    [anon_sym_keyof] = ACTIONS(2949),
    [anon_sym_unknown] = ACTIONS(2949),
    [anon_sym_never] = ACTIONS(2949),
    [anon_sym_object] = ACTIONS(2949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2951),
    [anon_sym_constructor] = ACTIONS(2949),
    [anon_sym_prop] = ACTIONS(2949),
    [anon_sym_id] = ACTIONS(2949),
    [anon_sym_event] = ACTIONS(2949),
    [anon_sym_fn] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [sym__ternary_qmark] = ACTIONS(2951),
  },
  [844] = {
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_QMARK_DOT] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_GT_GT] = ACTIONS(2953),
    [anon_sym_GT_GT_GT] = ACTIONS(2955),
    [anon_sym_LT_LT] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_PIPE] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2955),
    [anon_sym_STAR_STAR] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_EQ_EQ] = ACTIONS(2953),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2953),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK] = ACTIONS(2955),
    [anon_sym_instanceof] = ACTIONS(2953),
    [anon_sym_void] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2955),
    [sym_number] = ACTIONS(2955),
    [sym_this] = ACTIONS(2953),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [sym_null] = ACTIONS(2953),
    [sym_undefined] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_readonly] = ACTIONS(2953),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_any] = ACTIONS(2953),
    [anon_sym_number] = ACTIONS(2953),
    [anon_sym_boolean] = ACTIONS(2953),
    [anon_sym_string] = ACTIONS(2953),
    [anon_sym_symbol] = ACTIONS(2953),
    [anon_sym_abstract] = ACTIONS(2953),
    [anon_sym_satisfies] = ACTIONS(2953),
    [anon_sym_extends] = ACTIONS(2953),
    [anon_sym_infer] = ACTIONS(2953),
    [anon_sym_keyof] = ACTIONS(2953),
    [anon_sym_unknown] = ACTIONS(2953),
    [anon_sym_never] = ACTIONS(2953),
    [anon_sym_object] = ACTIONS(2953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2955),
    [anon_sym_constructor] = ACTIONS(2953),
    [anon_sym_prop] = ACTIONS(2953),
    [anon_sym_id] = ACTIONS(2953),
    [anon_sym_event] = ACTIONS(2953),
    [anon_sym_fn] = ACTIONS(2953),
    [anon_sym_on] = ACTIONS(2953),
    [sym__ternary_qmark] = ACTIONS(2955),
  },
  [845] = {
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_typeof] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_async] = ACTIONS(2957),
    [anon_sym_QMARK_DOT] = ACTIONS(2959),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_GT_GT_GT] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_BANG_EQ] = ACTIONS(2957),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2959),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_QMARK_QMARK] = ACTIONS(2959),
    [anon_sym_instanceof] = ACTIONS(2957),
    [anon_sym_void] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_number] = ACTIONS(2959),
    [sym_this] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_null] = ACTIONS(2957),
    [sym_undefined] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_readonly] = ACTIONS(2957),
    [anon_sym_get] = ACTIONS(2957),
    [anon_sym_set] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_any] = ACTIONS(2957),
    [anon_sym_number] = ACTIONS(2957),
    [anon_sym_boolean] = ACTIONS(2957),
    [anon_sym_string] = ACTIONS(2957),
    [anon_sym_symbol] = ACTIONS(2957),
    [anon_sym_abstract] = ACTIONS(2957),
    [anon_sym_satisfies] = ACTIONS(2957),
    [anon_sym_extends] = ACTIONS(2957),
    [anon_sym_infer] = ACTIONS(2957),
    [anon_sym_keyof] = ACTIONS(2957),
    [anon_sym_unknown] = ACTIONS(2957),
    [anon_sym_never] = ACTIONS(2957),
    [anon_sym_object] = ACTIONS(2957),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2959),
    [anon_sym_constructor] = ACTIONS(2957),
    [anon_sym_prop] = ACTIONS(2957),
    [anon_sym_id] = ACTIONS(2957),
    [anon_sym_event] = ACTIONS(2957),
    [anon_sym_fn] = ACTIONS(2957),
    [anon_sym_on] = ACTIONS(2957),
    [sym__ternary_qmark] = ACTIONS(2959),
  },
  [846] = {
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_typeof] = ACTIONS(2961),
    [anon_sym_import] = ACTIONS(2961),
    [anon_sym_var] = ACTIONS(2961),
    [anon_sym_let] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_switch] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2961),
    [anon_sym_while] = ACTIONS(2961),
    [anon_sym_do] = ACTIONS(2961),
    [anon_sym_try] = ACTIONS(2961),
    [anon_sym_with] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_debugger] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_throw] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_case] = ACTIONS(2961),
    [anon_sym_default] = ACTIONS(2961),
    [anon_sym_yield] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_LTtemplate_GT] = ACTIONS(2963),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_class] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(2961),
    [anon_sym_function] = ACTIONS(2961),
    [anon_sym_new] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2963),
    [anon_sym_void] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2963),
    [sym_number] = ACTIONS(2963),
    [sym_this] = ACTIONS(2961),
    [sym_super] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_null] = ACTIONS(2961),
    [sym_undefined] = ACTIONS(2961),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2961),
    [anon_sym_readonly] = ACTIONS(2961),
    [anon_sym_get] = ACTIONS(2961),
    [anon_sym_set] = ACTIONS(2961),
    [anon_sym_declare] = ACTIONS(2961),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_public] = ACTIONS(2961),
    [anon_sym_private] = ACTIONS(2961),
    [anon_sym_protected] = ACTIONS(2961),
    [anon_sym_override] = ACTIONS(2961),
    [anon_sym_module] = ACTIONS(2961),
    [anon_sym_any] = ACTIONS(2961),
    [anon_sym_number] = ACTIONS(2961),
    [anon_sym_boolean] = ACTIONS(2961),
    [anon_sym_string] = ACTIONS(2961),
    [anon_sym_symbol] = ACTIONS(2961),
    [anon_sym_abstract] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
    [anon_sym_component] = ACTIONS(2961),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2965),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_as] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_async] = ACTIONS(2965),
    [anon_sym_QMARK_DOT] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_GT_GT_GT] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK] = ACTIONS(2967),
    [anon_sym_instanceof] = ACTIONS(2965),
    [anon_sym_void] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2967),
    [sym_number] = ACTIONS(2967),
    [sym_this] = ACTIONS(2965),
    [sym_true] = ACTIONS(2965),
    [sym_false] = ACTIONS(2965),
    [sym_null] = ACTIONS(2965),
    [sym_undefined] = ACTIONS(2965),
    [anon_sym_static] = ACTIONS(2965),
    [anon_sym_readonly] = ACTIONS(2965),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2965),
    [anon_sym_any] = ACTIONS(2965),
    [anon_sym_number] = ACTIONS(2965),
    [anon_sym_boolean] = ACTIONS(2965),
    [anon_sym_string] = ACTIONS(2965),
    [anon_sym_symbol] = ACTIONS(2965),
    [anon_sym_abstract] = ACTIONS(2965),
    [anon_sym_satisfies] = ACTIONS(2965),
    [anon_sym_extends] = ACTIONS(2965),
    [anon_sym_infer] = ACTIONS(2965),
    [anon_sym_keyof] = ACTIONS(2965),
    [anon_sym_unknown] = ACTIONS(2965),
    [anon_sym_never] = ACTIONS(2965),
    [anon_sym_object] = ACTIONS(2965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2967),
    [anon_sym_constructor] = ACTIONS(2965),
    [anon_sym_prop] = ACTIONS(2965),
    [anon_sym_id] = ACTIONS(2965),
    [anon_sym_event] = ACTIONS(2965),
    [anon_sym_fn] = ACTIONS(2965),
    [anon_sym_on] = ACTIONS(2965),
    [sym__ternary_qmark] = ACTIONS(2967),
  },
  [848] = {
    [sym_identifier] = ACTIONS(2969),
    [anon_sym_export] = ACTIONS(2969),
    [anon_sym_LBRACE] = ACTIONS(2971),
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_type] = ACTIONS(2969),
    [anon_sym_typeof] = ACTIONS(2969),
    [anon_sym_import] = ACTIONS(2969),
    [anon_sym_var] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_break] = ACTIONS(2969),
    [anon_sym_continue] = ACTIONS(2969),
    [anon_sym_debugger] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_throw] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2969),
    [anon_sym_default] = ACTIONS(2969),
    [anon_sym_yield] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_LTtemplate_GT] = ACTIONS(2971),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_class] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(2969),
    [anon_sym_function] = ACTIONS(2969),
    [anon_sym_new] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2971),
    [anon_sym_void] = ACTIONS(2969),
    [anon_sym_delete] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2971),
    [sym_number] = ACTIONS(2971),
    [sym_this] = ACTIONS(2969),
    [sym_super] = ACTIONS(2969),
    [sym_true] = ACTIONS(2969),
    [sym_false] = ACTIONS(2969),
    [sym_null] = ACTIONS(2969),
    [sym_undefined] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2969),
    [anon_sym_readonly] = ACTIONS(2969),
    [anon_sym_get] = ACTIONS(2969),
    [anon_sym_set] = ACTIONS(2969),
    [anon_sym_declare] = ACTIONS(2969),
    [anon_sym_namespace] = ACTIONS(2969),
    [anon_sym_public] = ACTIONS(2969),
    [anon_sym_private] = ACTIONS(2969),
    [anon_sym_protected] = ACTIONS(2969),
    [anon_sym_override] = ACTIONS(2969),
    [anon_sym_module] = ACTIONS(2969),
    [anon_sym_any] = ACTIONS(2969),
    [anon_sym_number] = ACTIONS(2969),
    [anon_sym_boolean] = ACTIONS(2969),
    [anon_sym_string] = ACTIONS(2969),
    [anon_sym_symbol] = ACTIONS(2969),
    [anon_sym_abstract] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2969),
    [anon_sym_enum] = ACTIONS(2969),
    [anon_sym_component] = ACTIONS(2969),
  },
  [849] = {
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_export] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_typeof] = ACTIONS(2881),
    [anon_sym_import] = ACTIONS(2881),
    [anon_sym_var] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_else] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_switch] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_await] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_debugger] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_throw] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2881),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LTtemplate_GT] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_class] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_void] = ACTIONS(2881),
    [anon_sym_delete] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [sym_number] = ACTIONS(2883),
    [sym_this] = ACTIONS(2881),
    [sym_super] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_null] = ACTIONS(2881),
    [sym_undefined] = ACTIONS(2881),
    [anon_sym_AT] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_readonly] = ACTIONS(2881),
    [anon_sym_get] = ACTIONS(2881),
    [anon_sym_set] = ACTIONS(2881),
    [anon_sym_declare] = ACTIONS(2881),
    [anon_sym_namespace] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2881),
    [anon_sym_private] = ACTIONS(2881),
    [anon_sym_protected] = ACTIONS(2881),
    [anon_sym_override] = ACTIONS(2881),
    [anon_sym_module] = ACTIONS(2881),
    [anon_sym_any] = ACTIONS(2881),
    [anon_sym_number] = ACTIONS(2881),
    [anon_sym_boolean] = ACTIONS(2881),
    [anon_sym_string] = ACTIONS(2881),
    [anon_sym_symbol] = ACTIONS(2881),
    [anon_sym_abstract] = ACTIONS(2881),
    [anon_sym_interface] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_component] = ACTIONS(2881),
  },
  [850] = {
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_as] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2973),
    [anon_sym_QMARK_DOT] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_GT_GT_GT] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [anon_sym_STAR_STAR] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_QMARK_QMARK] = ACTIONS(2975),
    [anon_sym_instanceof] = ACTIONS(2973),
    [anon_sym_void] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2975),
    [sym_number] = ACTIONS(2975),
    [sym_this] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_null] = ACTIONS(2973),
    [sym_undefined] = ACTIONS(2973),
    [anon_sym_static] = ACTIONS(2973),
    [anon_sym_readonly] = ACTIONS(2973),
    [anon_sym_get] = ACTIONS(2973),
    [anon_sym_set] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_any] = ACTIONS(2973),
    [anon_sym_number] = ACTIONS(2973),
    [anon_sym_boolean] = ACTIONS(2973),
    [anon_sym_string] = ACTIONS(2973),
    [anon_sym_symbol] = ACTIONS(2973),
    [anon_sym_abstract] = ACTIONS(2973),
    [anon_sym_satisfies] = ACTIONS(2973),
    [anon_sym_extends] = ACTIONS(2973),
    [anon_sym_infer] = ACTIONS(2973),
    [anon_sym_keyof] = ACTIONS(2973),
    [anon_sym_unknown] = ACTIONS(2973),
    [anon_sym_never] = ACTIONS(2973),
    [anon_sym_object] = ACTIONS(2973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2975),
    [anon_sym_constructor] = ACTIONS(2973),
    [anon_sym_prop] = ACTIONS(2973),
    [anon_sym_id] = ACTIONS(2973),
    [anon_sym_event] = ACTIONS(2973),
    [anon_sym_fn] = ACTIONS(2973),
    [anon_sym_on] = ACTIONS(2973),
    [sym__ternary_qmark] = ACTIONS(2975),
  },
  [851] = {
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_export] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_type] = ACTIONS(2717),
    [anon_sym_typeof] = ACTIONS(2717),
    [anon_sym_import] = ACTIONS(2717),
    [anon_sym_var] = ACTIONS(2717),
    [anon_sym_let] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_LPAREN] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_with] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_debugger] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_yield] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LTtemplate_GT] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2717),
    [anon_sym_SLASH] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_async] = ACTIONS(2717),
    [anon_sym_function] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_void] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [sym_number] = ACTIONS(2719),
    [sym_this] = ACTIONS(2717),
    [sym_super] = ACTIONS(2717),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [sym_null] = ACTIONS(2717),
    [sym_undefined] = ACTIONS(2717),
    [anon_sym_AT] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_readonly] = ACTIONS(2717),
    [anon_sym_get] = ACTIONS(2717),
    [anon_sym_set] = ACTIONS(2717),
    [anon_sym_declare] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_public] = ACTIONS(2717),
    [anon_sym_private] = ACTIONS(2717),
    [anon_sym_protected] = ACTIONS(2717),
    [anon_sym_override] = ACTIONS(2717),
    [anon_sym_module] = ACTIONS(2717),
    [anon_sym_any] = ACTIONS(2717),
    [anon_sym_number] = ACTIONS(2717),
    [anon_sym_boolean] = ACTIONS(2717),
    [anon_sym_string] = ACTIONS(2717),
    [anon_sym_symbol] = ACTIONS(2717),
    [anon_sym_abstract] = ACTIONS(2717),
    [anon_sym_interface] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_component] = ACTIONS(2717),
  },
  [852] = {
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_export] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym_import] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_debugger] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LTtemplate_GT] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_void] = ACTIONS(2977),
    [anon_sym_delete] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [sym_number] = ACTIONS(2979),
    [sym_this] = ACTIONS(2977),
    [sym_super] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_null] = ACTIONS(2977),
    [sym_undefined] = ACTIONS(2977),
    [anon_sym_AT] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_declare] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_module] = ACTIONS(2977),
    [anon_sym_any] = ACTIONS(2977),
    [anon_sym_number] = ACTIONS(2977),
    [anon_sym_boolean] = ACTIONS(2977),
    [anon_sym_string] = ACTIONS(2977),
    [anon_sym_symbol] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [anon_sym_component] = ACTIONS(2977),
  },
  [853] = {
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_export] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_typeof] = ACTIONS(2981),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_var] = ACTIONS(2981),
    [anon_sym_let] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_await] = ACTIONS(2981),
    [anon_sym_while] = ACTIONS(2981),
    [anon_sym_do] = ACTIONS(2981),
    [anon_sym_try] = ACTIONS(2981),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_debugger] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_throw] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_case] = ACTIONS(2981),
    [anon_sym_default] = ACTIONS(2981),
    [anon_sym_yield] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LTtemplate_GT] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_class] = ACTIONS(2981),
    [anon_sym_async] = ACTIONS(2981),
    [anon_sym_function] = ACTIONS(2981),
    [anon_sym_new] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_void] = ACTIONS(2981),
    [anon_sym_delete] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym_number] = ACTIONS(2983),
    [sym_this] = ACTIONS(2981),
    [sym_super] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_undefined] = ACTIONS(2981),
    [anon_sym_AT] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2981),
    [anon_sym_get] = ACTIONS(2981),
    [anon_sym_set] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2981),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_override] = ACTIONS(2981),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_any] = ACTIONS(2981),
    [anon_sym_number] = ACTIONS(2981),
    [anon_sym_boolean] = ACTIONS(2981),
    [anon_sym_string] = ACTIONS(2981),
    [anon_sym_symbol] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [anon_sym_component] = ACTIONS(2981),
  },
  [854] = {
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_export] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym_import] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_debugger] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LTtemplate_GT] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_function] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_void] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_number] = ACTIONS(2987),
    [sym_this] = ACTIONS(2985),
    [sym_super] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_undefined] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_module] = ACTIONS(2985),
    [anon_sym_any] = ACTIONS(2985),
    [anon_sym_number] = ACTIONS(2985),
    [anon_sym_boolean] = ACTIONS(2985),
    [anon_sym_string] = ACTIONS(2985),
    [anon_sym_symbol] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_component] = ACTIONS(2985),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_export] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_typeof] = ACTIONS(2981),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_var] = ACTIONS(2981),
    [anon_sym_let] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_await] = ACTIONS(2981),
    [anon_sym_while] = ACTIONS(2981),
    [anon_sym_do] = ACTIONS(2981),
    [anon_sym_try] = ACTIONS(2981),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_debugger] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_throw] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_case] = ACTIONS(2981),
    [anon_sym_default] = ACTIONS(2981),
    [anon_sym_yield] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LTtemplate_GT] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_class] = ACTIONS(2981),
    [anon_sym_async] = ACTIONS(2981),
    [anon_sym_function] = ACTIONS(2981),
    [anon_sym_new] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_void] = ACTIONS(2981),
    [anon_sym_delete] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym_number] = ACTIONS(2983),
    [sym_this] = ACTIONS(2981),
    [sym_super] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_undefined] = ACTIONS(2981),
    [anon_sym_AT] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2981),
    [anon_sym_get] = ACTIONS(2981),
    [anon_sym_set] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2981),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_override] = ACTIONS(2981),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_any] = ACTIONS(2981),
    [anon_sym_number] = ACTIONS(2981),
    [anon_sym_boolean] = ACTIONS(2981),
    [anon_sym_string] = ACTIONS(2981),
    [anon_sym_symbol] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [anon_sym_component] = ACTIONS(2981),
  },
  [856] = {
    [sym_optional_chain] = STATE(3378),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_STAR_STAR] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_instanceof] = ACTIONS(2989),
    [anon_sym_void] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2991),
    [sym_number] = ACTIONS(2991),
    [sym_this] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_null] = ACTIONS(2989),
    [sym_undefined] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(2989),
    [anon_sym_infer] = ACTIONS(2989),
    [anon_sym_keyof] = ACTIONS(2989),
    [anon_sym_unknown] = ACTIONS(2989),
    [anon_sym_never] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2991),
    [anon_sym_constructor] = ACTIONS(2989),
    [anon_sym_prop] = ACTIONS(2989),
    [anon_sym_id] = ACTIONS(2989),
    [anon_sym_event] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [sym__ternary_qmark] = ACTIONS(2991),
  },
  [857] = {
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_export] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_typeof] = ACTIONS(2981),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_var] = ACTIONS(2981),
    [anon_sym_let] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_await] = ACTIONS(2981),
    [anon_sym_while] = ACTIONS(2981),
    [anon_sym_do] = ACTIONS(2981),
    [anon_sym_try] = ACTIONS(2981),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_debugger] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_throw] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_case] = ACTIONS(2981),
    [anon_sym_default] = ACTIONS(2981),
    [anon_sym_yield] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LTtemplate_GT] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_class] = ACTIONS(2981),
    [anon_sym_async] = ACTIONS(2981),
    [anon_sym_function] = ACTIONS(2981),
    [anon_sym_new] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_void] = ACTIONS(2981),
    [anon_sym_delete] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym_number] = ACTIONS(2983),
    [sym_this] = ACTIONS(2981),
    [sym_super] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_undefined] = ACTIONS(2981),
    [anon_sym_AT] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2981),
    [anon_sym_get] = ACTIONS(2981),
    [anon_sym_set] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2981),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_override] = ACTIONS(2981),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_any] = ACTIONS(2981),
    [anon_sym_number] = ACTIONS(2981),
    [anon_sym_boolean] = ACTIONS(2981),
    [anon_sym_string] = ACTIONS(2981),
    [anon_sym_symbol] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [anon_sym_component] = ACTIONS(2981),
  },
  [858] = {
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_typeof] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_QMARK_DOT] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_STAR_STAR] = ACTIONS(2879),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2879),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2879),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_QMARK_QMARK] = ACTIONS(2879),
    [anon_sym_instanceof] = ACTIONS(2877),
    [anon_sym_void] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2879),
    [sym_number] = ACTIONS(2879),
    [sym_this] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_null] = ACTIONS(2877),
    [sym_undefined] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_readonly] = ACTIONS(2877),
    [anon_sym_get] = ACTIONS(2877),
    [anon_sym_set] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_any] = ACTIONS(2877),
    [anon_sym_number] = ACTIONS(2877),
    [anon_sym_boolean] = ACTIONS(2877),
    [anon_sym_string] = ACTIONS(2877),
    [anon_sym_symbol] = ACTIONS(2877),
    [anon_sym_abstract] = ACTIONS(2877),
    [anon_sym_satisfies] = ACTIONS(2877),
    [anon_sym_extends] = ACTIONS(2877),
    [anon_sym_infer] = ACTIONS(2877),
    [anon_sym_keyof] = ACTIONS(2877),
    [anon_sym_unknown] = ACTIONS(2877),
    [anon_sym_never] = ACTIONS(2877),
    [anon_sym_object] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_constructor] = ACTIONS(2877),
    [anon_sym_prop] = ACTIONS(2877),
    [anon_sym_id] = ACTIONS(2877),
    [anon_sym_event] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_on] = ACTIONS(2877),
    [sym__ternary_qmark] = ACTIONS(2879),
  },
  [859] = {
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_QMARK_DOT] = ACTIONS(2995),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_PIPE_PIPE] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_GT_GT_GT] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_STAR_STAR] = ACTIONS(2995),
    [anon_sym_LT_EQ] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2995),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2995),
    [anon_sym_GT_EQ] = ACTIONS(2995),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_instanceof] = ACTIONS(2993),
    [anon_sym_void] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_number] = ACTIONS(2995),
    [sym_this] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_null] = ACTIONS(2993),
    [sym_undefined] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2993),
    [anon_sym_set] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_any] = ACTIONS(2993),
    [anon_sym_number] = ACTIONS(2993),
    [anon_sym_boolean] = ACTIONS(2993),
    [anon_sym_string] = ACTIONS(2993),
    [anon_sym_symbol] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_satisfies] = ACTIONS(2993),
    [anon_sym_extends] = ACTIONS(2993),
    [anon_sym_infer] = ACTIONS(2993),
    [anon_sym_keyof] = ACTIONS(2993),
    [anon_sym_unknown] = ACTIONS(2993),
    [anon_sym_never] = ACTIONS(2993),
    [anon_sym_object] = ACTIONS(2993),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2995),
    [anon_sym_constructor] = ACTIONS(2993),
    [anon_sym_prop] = ACTIONS(2993),
    [anon_sym_id] = ACTIONS(2993),
    [anon_sym_event] = ACTIONS(2993),
    [anon_sym_fn] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [sym__ternary_qmark] = ACTIONS(2995),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_async] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2999),
    [anon_sym_new] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_STAR_STAR] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_instanceof] = ACTIONS(2997),
    [anon_sym_void] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2999),
    [sym_number] = ACTIONS(2999),
    [sym_this] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_null] = ACTIONS(2997),
    [sym_undefined] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2997),
    [anon_sym_get] = ACTIONS(2997),
    [anon_sym_set] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_any] = ACTIONS(2997),
    [anon_sym_number] = ACTIONS(2997),
    [anon_sym_boolean] = ACTIONS(2997),
    [anon_sym_string] = ACTIONS(2997),
    [anon_sym_symbol] = ACTIONS(2997),
    [anon_sym_abstract] = ACTIONS(2997),
    [anon_sym_satisfies] = ACTIONS(2997),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(2997),
    [anon_sym_keyof] = ACTIONS(2997),
    [anon_sym_unknown] = ACTIONS(2997),
    [anon_sym_never] = ACTIONS(2997),
    [anon_sym_object] = ACTIONS(2997),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2999),
    [anon_sym_constructor] = ACTIONS(2997),
    [anon_sym_prop] = ACTIONS(2997),
    [anon_sym_id] = ACTIONS(2997),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [sym__ternary_qmark] = ACTIONS(2999),
  },
  [861] = {
    [sym_arguments] = STATE(975),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3001),
    [anon_sym_as] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3003),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_in] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_GT] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_DOT] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_QMARK_DOT] = ACTIONS(3003),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_GT_GT] = ACTIONS(3001),
    [anon_sym_GT_GT_GT] = ACTIONS(3003),
    [anon_sym_LT_LT] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3001),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_PIPE] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_STAR_STAR] = ACTIONS(3003),
    [anon_sym_LT_EQ] = ACTIONS(3003),
    [anon_sym_EQ_EQ] = ACTIONS(3001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3001),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3003),
    [anon_sym_GT_EQ] = ACTIONS(3003),
    [anon_sym_QMARK_QMARK] = ACTIONS(3003),
    [anon_sym_instanceof] = ACTIONS(3001),
    [anon_sym_void] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3003),
    [sym_number] = ACTIONS(3003),
    [sym_this] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_undefined] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_get] = ACTIONS(3001),
    [anon_sym_set] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_any] = ACTIONS(3001),
    [anon_sym_number] = ACTIONS(3001),
    [anon_sym_boolean] = ACTIONS(3001),
    [anon_sym_string] = ACTIONS(3001),
    [anon_sym_symbol] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_satisfies] = ACTIONS(3001),
    [anon_sym_infer] = ACTIONS(3001),
    [anon_sym_keyof] = ACTIONS(3001),
    [anon_sym_unknown] = ACTIONS(3001),
    [anon_sym_never] = ACTIONS(3001),
    [anon_sym_object] = ACTIONS(3001),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3003),
    [anon_sym_constructor] = ACTIONS(3001),
    [anon_sym_prop] = ACTIONS(3001),
    [anon_sym_id] = ACTIONS(3001),
    [anon_sym_event] = ACTIONS(3001),
    [anon_sym_fn] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [sym__ternary_qmark] = ACTIONS(3003),
  },
  [862] = {
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LTtemplate_GT] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_readonly] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_override] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_component] = ACTIONS(3008),
  },
  [863] = {
    [sym_identifier] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_as] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_QMARK_DOT] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_GT_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_QMARK_QMARK] = ACTIONS(3014),
    [anon_sym_instanceof] = ACTIONS(3012),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_this] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_readonly] = ACTIONS(3012),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_any] = ACTIONS(3012),
    [anon_sym_number] = ACTIONS(3012),
    [anon_sym_boolean] = ACTIONS(3012),
    [anon_sym_string] = ACTIONS(3012),
    [anon_sym_symbol] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_satisfies] = ACTIONS(3012),
    [anon_sym_extends] = ACTIONS(3012),
    [anon_sym_infer] = ACTIONS(3012),
    [anon_sym_keyof] = ACTIONS(3012),
    [anon_sym_unknown] = ACTIONS(3012),
    [anon_sym_never] = ACTIONS(3012),
    [anon_sym_object] = ACTIONS(3012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3014),
    [anon_sym_constructor] = ACTIONS(3012),
    [anon_sym_prop] = ACTIONS(3012),
    [anon_sym_id] = ACTIONS(3012),
    [anon_sym_event] = ACTIONS(3012),
    [anon_sym_fn] = ACTIONS(3012),
    [anon_sym_on] = ACTIONS(3012),
    [sym__ternary_qmark] = ACTIONS(3014),
  },
  [864] = {
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LTtemplate_GT] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [sym_number] = ACTIONS(3018),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_abstract] = ACTIONS(3016),
    [anon_sym_interface] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_component] = ACTIONS(3016),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3020),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_typeof] = ACTIONS(3020),
    [anon_sym_import] = ACTIONS(3020),
    [anon_sym_var] = ACTIONS(3020),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_with] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_debugger] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_yield] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_LTtemplate_GT] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_void] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [sym_number] = ACTIONS(3022),
    [sym_this] = ACTIONS(3020),
    [sym_super] = ACTIONS(3020),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_undefined] = ACTIONS(3020),
    [anon_sym_AT] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_readonly] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_override] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_abstract] = ACTIONS(3020),
    [anon_sym_interface] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_component] = ACTIONS(3020),
  },
  [866] = {
    [sym_identifier] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_QMARK_DOT] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_PIPE_PIPE] = ACTIONS(3026),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_GT_GT_GT] = ACTIONS(3026),
    [anon_sym_LT_LT] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3026),
    [anon_sym_PIPE] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3026),
    [anon_sym_STAR_STAR] = ACTIONS(3026),
    [anon_sym_LT_EQ] = ACTIONS(3026),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3026),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3026),
    [anon_sym_GT_EQ] = ACTIONS(3026),
    [anon_sym_QMARK_QMARK] = ACTIONS(3026),
    [anon_sym_instanceof] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3026),
    [sym_number] = ACTIONS(3026),
    [sym_this] = ACTIONS(3024),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [sym_null] = ACTIONS(3024),
    [sym_undefined] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_readonly] = ACTIONS(3024),
    [anon_sym_get] = ACTIONS(3024),
    [anon_sym_set] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_any] = ACTIONS(3024),
    [anon_sym_number] = ACTIONS(3024),
    [anon_sym_boolean] = ACTIONS(3024),
    [anon_sym_string] = ACTIONS(3024),
    [anon_sym_symbol] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_satisfies] = ACTIONS(3024),
    [anon_sym_extends] = ACTIONS(3024),
    [anon_sym_infer] = ACTIONS(3024),
    [anon_sym_keyof] = ACTIONS(3024),
    [anon_sym_unknown] = ACTIONS(3024),
    [anon_sym_never] = ACTIONS(3024),
    [anon_sym_object] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3026),
    [anon_sym_constructor] = ACTIONS(3024),
    [anon_sym_prop] = ACTIONS(3024),
    [anon_sym_id] = ACTIONS(3024),
    [anon_sym_event] = ACTIONS(3024),
    [anon_sym_fn] = ACTIONS(3024),
    [anon_sym_on] = ACTIONS(3024),
    [sym__ternary_qmark] = ACTIONS(3026),
  },
  [867] = {
    [sym_identifier] = ACTIONS(3028),
    [anon_sym_export] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_type] = ACTIONS(3028),
    [anon_sym_typeof] = ACTIONS(3028),
    [anon_sym_import] = ACTIONS(3028),
    [anon_sym_var] = ACTIONS(3028),
    [anon_sym_let] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_LPAREN] = ACTIONS(3030),
    [anon_sym_await] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_with] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_debugger] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_yield] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_LTtemplate_GT] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_SLASH] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_async] = ACTIONS(3028),
    [anon_sym_function] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_void] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3030),
    [sym_number] = ACTIONS(3030),
    [sym_this] = ACTIONS(3028),
    [sym_super] = ACTIONS(3028),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [sym_null] = ACTIONS(3028),
    [sym_undefined] = ACTIONS(3028),
    [anon_sym_AT] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_readonly] = ACTIONS(3028),
    [anon_sym_get] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3028),
    [anon_sym_declare] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_override] = ACTIONS(3028),
    [anon_sym_module] = ACTIONS(3028),
    [anon_sym_any] = ACTIONS(3028),
    [anon_sym_number] = ACTIONS(3028),
    [anon_sym_boolean] = ACTIONS(3028),
    [anon_sym_string] = ACTIONS(3028),
    [anon_sym_symbol] = ACTIONS(3028),
    [anon_sym_abstract] = ACTIONS(3028),
    [anon_sym_interface] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_component] = ACTIONS(3028),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_export] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_type] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3032),
    [anon_sym_import] = ACTIONS(3032),
    [anon_sym_var] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(3034),
    [anon_sym_await] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_with] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_debugger] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_LTtemplate_GT] = ACTIONS(3034),
    [anon_sym_LT] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_async] = ACTIONS(3032),
    [anon_sym_function] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_void] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3034),
    [sym_number] = ACTIONS(3034),
    [sym_this] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_true] = ACTIONS(3032),
    [sym_false] = ACTIONS(3032),
    [sym_null] = ACTIONS(3032),
    [sym_undefined] = ACTIONS(3032),
    [anon_sym_AT] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_readonly] = ACTIONS(3032),
    [anon_sym_get] = ACTIONS(3032),
    [anon_sym_set] = ACTIONS(3032),
    [anon_sym_declare] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_public] = ACTIONS(3032),
    [anon_sym_private] = ACTIONS(3032),
    [anon_sym_protected] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_module] = ACTIONS(3032),
    [anon_sym_any] = ACTIONS(3032),
    [anon_sym_number] = ACTIONS(3032),
    [anon_sym_boolean] = ACTIONS(3032),
    [anon_sym_string] = ACTIONS(3032),
    [anon_sym_symbol] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_component] = ACTIONS(3032),
  },
  [869] = {
    [sym_identifier] = ACTIONS(3036),
    [anon_sym_export] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_type] = ACTIONS(3036),
    [anon_sym_typeof] = ACTIONS(3036),
    [anon_sym_import] = ACTIONS(3036),
    [anon_sym_var] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_await] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_with] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_debugger] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_yield] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_LTtemplate_GT] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3036),
    [anon_sym_SLASH] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_function] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_void] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3038),
    [sym_number] = ACTIONS(3038),
    [sym_this] = ACTIONS(3036),
    [sym_super] = ACTIONS(3036),
    [sym_true] = ACTIONS(3036),
    [sym_false] = ACTIONS(3036),
    [sym_null] = ACTIONS(3036),
    [sym_undefined] = ACTIONS(3036),
    [anon_sym_AT] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_get] = ACTIONS(3036),
    [anon_sym_set] = ACTIONS(3036),
    [anon_sym_declare] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_module] = ACTIONS(3036),
    [anon_sym_any] = ACTIONS(3036),
    [anon_sym_number] = ACTIONS(3036),
    [anon_sym_boolean] = ACTIONS(3036),
    [anon_sym_string] = ACTIONS(3036),
    [anon_sym_symbol] = ACTIONS(3036),
    [anon_sym_abstract] = ACTIONS(3036),
    [anon_sym_interface] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_component] = ACTIONS(3036),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_export] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_type] = ACTIONS(3040),
    [anon_sym_typeof] = ACTIONS(3040),
    [anon_sym_import] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_await] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_with] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_debugger] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LTtemplate_GT] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_function] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_void] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3042),
    [sym_number] = ACTIONS(3042),
    [sym_this] = ACTIONS(3040),
    [sym_super] = ACTIONS(3040),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [sym_null] = ACTIONS(3040),
    [sym_undefined] = ACTIONS(3040),
    [anon_sym_AT] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_get] = ACTIONS(3040),
    [anon_sym_set] = ACTIONS(3040),
    [anon_sym_declare] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_module] = ACTIONS(3040),
    [anon_sym_any] = ACTIONS(3040),
    [anon_sym_number] = ACTIONS(3040),
    [anon_sym_boolean] = ACTIONS(3040),
    [anon_sym_string] = ACTIONS(3040),
    [anon_sym_symbol] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_interface] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_component] = ACTIONS(3040),
  },
  [871] = {
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_async] = ACTIONS(2997),
    [anon_sym_QMARK_DOT] = ACTIONS(2999),
    [anon_sym_new] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_STAR_STAR] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2997),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_instanceof] = ACTIONS(2997),
    [anon_sym_void] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2999),
    [sym_number] = ACTIONS(2999),
    [sym_this] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_null] = ACTIONS(2997),
    [sym_undefined] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2997),
    [anon_sym_get] = ACTIONS(2997),
    [anon_sym_set] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_any] = ACTIONS(2997),
    [anon_sym_number] = ACTIONS(2997),
    [anon_sym_boolean] = ACTIONS(2997),
    [anon_sym_string] = ACTIONS(2997),
    [anon_sym_symbol] = ACTIONS(2997),
    [anon_sym_abstract] = ACTIONS(2997),
    [anon_sym_satisfies] = ACTIONS(2997),
    [anon_sym_extends] = ACTIONS(2997),
    [anon_sym_infer] = ACTIONS(2997),
    [anon_sym_keyof] = ACTIONS(2997),
    [anon_sym_unknown] = ACTIONS(2997),
    [anon_sym_never] = ACTIONS(2997),
    [anon_sym_object] = ACTIONS(2997),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2999),
    [anon_sym_constructor] = ACTIONS(2997),
    [anon_sym_prop] = ACTIONS(2997),
    [anon_sym_id] = ACTIONS(2997),
    [anon_sym_event] = ACTIONS(2997),
    [anon_sym_fn] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [sym__ternary_qmark] = ACTIONS(2999),
  },
  [872] = {
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_typeof] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_var] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_switch] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_do] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_with] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_debugger] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_throw] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LTtemplate_GT] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_class] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_delete] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2835),
    [sym_number] = ACTIONS(2835),
    [sym_this] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_null] = ACTIONS(2833),
    [sym_undefined] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_override] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_interface] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_component] = ACTIONS(2833),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_as] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_typeof] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_LPAREN] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_QMARK_DOT] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_GT_GT_GT] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [anon_sym_STAR_STAR] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3046),
    [anon_sym_BANG_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3046),
    [anon_sym_GT_EQ] = ACTIONS(3046),
    [anon_sym_QMARK_QMARK] = ACTIONS(3046),
    [anon_sym_instanceof] = ACTIONS(3044),
    [anon_sym_void] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3046),
    [sym_number] = ACTIONS(3046),
    [sym_this] = ACTIONS(3044),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [sym_null] = ACTIONS(3044),
    [sym_undefined] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_readonly] = ACTIONS(3044),
    [anon_sym_get] = ACTIONS(3044),
    [anon_sym_set] = ACTIONS(3044),
    [anon_sym_QMARK] = ACTIONS(3044),
    [anon_sym_any] = ACTIONS(3044),
    [anon_sym_number] = ACTIONS(3044),
    [anon_sym_boolean] = ACTIONS(3044),
    [anon_sym_string] = ACTIONS(3044),
    [anon_sym_symbol] = ACTIONS(3044),
    [anon_sym_abstract] = ACTIONS(3044),
    [anon_sym_satisfies] = ACTIONS(3044),
    [anon_sym_extends] = ACTIONS(3044),
    [anon_sym_infer] = ACTIONS(3044),
    [anon_sym_keyof] = ACTIONS(3044),
    [anon_sym_unknown] = ACTIONS(3044),
    [anon_sym_never] = ACTIONS(3044),
    [anon_sym_object] = ACTIONS(3044),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3046),
    [anon_sym_constructor] = ACTIONS(3044),
    [anon_sym_prop] = ACTIONS(3044),
    [anon_sym_id] = ACTIONS(3044),
    [anon_sym_event] = ACTIONS(3044),
    [anon_sym_fn] = ACTIONS(3044),
    [anon_sym_on] = ACTIONS(3044),
    [sym__ternary_qmark] = ACTIONS(3046),
  },
  [874] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_as] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_typeof] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3048),
    [anon_sym_async] = ACTIONS(3048),
    [anon_sym_QMARK_DOT] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_GT_GT_GT] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_PIPE] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [anon_sym_STAR_STAR] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3050),
    [anon_sym_BANG_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3050),
    [anon_sym_GT_EQ] = ACTIONS(3050),
    [anon_sym_QMARK_QMARK] = ACTIONS(3050),
    [anon_sym_instanceof] = ACTIONS(3048),
    [anon_sym_void] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3050),
    [sym_number] = ACTIONS(3050),
    [sym_this] = ACTIONS(3048),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [sym_null] = ACTIONS(3048),
    [sym_undefined] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_readonly] = ACTIONS(3048),
    [anon_sym_get] = ACTIONS(3048),
    [anon_sym_set] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_any] = ACTIONS(3048),
    [anon_sym_number] = ACTIONS(3048),
    [anon_sym_boolean] = ACTIONS(3048),
    [anon_sym_string] = ACTIONS(3048),
    [anon_sym_symbol] = ACTIONS(3048),
    [anon_sym_abstract] = ACTIONS(3048),
    [anon_sym_satisfies] = ACTIONS(3048),
    [anon_sym_extends] = ACTIONS(3048),
    [anon_sym_infer] = ACTIONS(3048),
    [anon_sym_keyof] = ACTIONS(3048),
    [anon_sym_unknown] = ACTIONS(3048),
    [anon_sym_never] = ACTIONS(3048),
    [anon_sym_object] = ACTIONS(3048),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3050),
    [anon_sym_constructor] = ACTIONS(3048),
    [anon_sym_prop] = ACTIONS(3048),
    [anon_sym_id] = ACTIONS(3048),
    [anon_sym_event] = ACTIONS(3048),
    [anon_sym_fn] = ACTIONS(3048),
    [anon_sym_on] = ACTIONS(3048),
    [sym__ternary_qmark] = ACTIONS(3050),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3048),
    [anon_sym_export] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_type] = ACTIONS(3048),
    [anon_sym_typeof] = ACTIONS(3048),
    [anon_sym_import] = ACTIONS(3048),
    [anon_sym_var] = ACTIONS(3048),
    [anon_sym_let] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_else] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_LPAREN] = ACTIONS(3050),
    [anon_sym_await] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_with] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_debugger] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_yield] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_LTtemplate_GT] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_async] = ACTIONS(3048),
    [anon_sym_function] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_void] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3050),
    [sym_number] = ACTIONS(3050),
    [sym_this] = ACTIONS(3048),
    [sym_super] = ACTIONS(3048),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [sym_null] = ACTIONS(3048),
    [sym_undefined] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_readonly] = ACTIONS(3048),
    [anon_sym_get] = ACTIONS(3048),
    [anon_sym_set] = ACTIONS(3048),
    [anon_sym_declare] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_override] = ACTIONS(3048),
    [anon_sym_module] = ACTIONS(3048),
    [anon_sym_any] = ACTIONS(3048),
    [anon_sym_number] = ACTIONS(3048),
    [anon_sym_boolean] = ACTIONS(3048),
    [anon_sym_string] = ACTIONS(3048),
    [anon_sym_symbol] = ACTIONS(3048),
    [anon_sym_abstract] = ACTIONS(3048),
    [anon_sym_interface] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_component] = ACTIONS(3048),
  },
  [876] = {
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_LTtemplate_GT] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3054),
    [sym_number] = ACTIONS(3054),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_readonly] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_override] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_component] = ACTIONS(3052),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3056),
    [anon_sym_export] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3056),
    [anon_sym_typeof] = ACTIONS(3056),
    [anon_sym_import] = ACTIONS(3056),
    [anon_sym_var] = ACTIONS(3056),
    [anon_sym_let] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_LPAREN] = ACTIONS(3058),
    [anon_sym_await] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_debugger] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_yield] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_LTtemplate_GT] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_async] = ACTIONS(3056),
    [anon_sym_function] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_void] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3058),
    [sym_number] = ACTIONS(3058),
    [sym_this] = ACTIONS(3056),
    [sym_super] = ACTIONS(3056),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [sym_null] = ACTIONS(3056),
    [sym_undefined] = ACTIONS(3056),
    [anon_sym_AT] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_readonly] = ACTIONS(3056),
    [anon_sym_get] = ACTIONS(3056),
    [anon_sym_set] = ACTIONS(3056),
    [anon_sym_declare] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_override] = ACTIONS(3056),
    [anon_sym_module] = ACTIONS(3056),
    [anon_sym_any] = ACTIONS(3056),
    [anon_sym_number] = ACTIONS(3056),
    [anon_sym_boolean] = ACTIONS(3056),
    [anon_sym_string] = ACTIONS(3056),
    [anon_sym_symbol] = ACTIONS(3056),
    [anon_sym_abstract] = ACTIONS(3056),
    [anon_sym_interface] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_component] = ACTIONS(3056),
  },
  [878] = {
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_export] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym_import] = ACTIONS(2929),
    [anon_sym_var] = ACTIONS(2929),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_with] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_debugger] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_LTtemplate_GT] = ACTIONS(2931),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_void] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2931),
    [sym_number] = ACTIONS(2931),
    [sym_this] = ACTIONS(2929),
    [sym_super] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_null] = ACTIONS(2929),
    [sym_undefined] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_declare] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_module] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_component] = ACTIONS(2929),
  },
  [879] = {
    [sym_arguments] = STATE(934),
    [sym_identifier] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_as] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_typeof] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_async] = ACTIONS(3060),
    [anon_sym_QMARK_DOT] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE] = ACTIONS(3062),
    [anon_sym_GT_GT] = ACTIONS(3060),
    [anon_sym_GT_GT_GT] = ACTIONS(3062),
    [anon_sym_LT_LT] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_CARET] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3062),
    [anon_sym_STAR_STAR] = ACTIONS(3062),
    [anon_sym_LT_EQ] = ACTIONS(3062),
    [anon_sym_EQ_EQ] = ACTIONS(3060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3062),
    [anon_sym_BANG_EQ] = ACTIONS(3060),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3062),
    [anon_sym_GT_EQ] = ACTIONS(3062),
    [anon_sym_QMARK_QMARK] = ACTIONS(3062),
    [anon_sym_instanceof] = ACTIONS(3060),
    [anon_sym_void] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3062),
    [sym_number] = ACTIONS(3062),
    [sym_this] = ACTIONS(3060),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [sym_null] = ACTIONS(3060),
    [sym_undefined] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_readonly] = ACTIONS(3060),
    [anon_sym_get] = ACTIONS(3060),
    [anon_sym_set] = ACTIONS(3060),
    [anon_sym_QMARK] = ACTIONS(3060),
    [anon_sym_any] = ACTIONS(3060),
    [anon_sym_number] = ACTIONS(3060),
    [anon_sym_boolean] = ACTIONS(3060),
    [anon_sym_string] = ACTIONS(3060),
    [anon_sym_symbol] = ACTIONS(3060),
    [anon_sym_abstract] = ACTIONS(3060),
    [anon_sym_satisfies] = ACTIONS(3060),
    [anon_sym_infer] = ACTIONS(3060),
    [anon_sym_keyof] = ACTIONS(3060),
    [anon_sym_unknown] = ACTIONS(3060),
    [anon_sym_never] = ACTIONS(3060),
    [anon_sym_object] = ACTIONS(3060),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3062),
    [anon_sym_constructor] = ACTIONS(3060),
    [anon_sym_prop] = ACTIONS(3060),
    [anon_sym_id] = ACTIONS(3060),
    [anon_sym_event] = ACTIONS(3060),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_on] = ACTIONS(3060),
    [sym__ternary_qmark] = ACTIONS(3062),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3064),
    [anon_sym_as] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3064),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_typeof] = ACTIONS(3064),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_LPAREN] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3066),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_GT] = ACTIONS(3064),
    [anon_sym_SLASH] = ACTIONS(3064),
    [anon_sym_DOT] = ACTIONS(3064),
    [anon_sym_async] = ACTIONS(3064),
    [anon_sym_QMARK_DOT] = ACTIONS(3066),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3066),
    [anon_sym_GT_GT] = ACTIONS(3064),
    [anon_sym_GT_GT_GT] = ACTIONS(3066),
    [anon_sym_LT_LT] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_CARET] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PERCENT] = ACTIONS(3066),
    [anon_sym_STAR_STAR] = ACTIONS(3066),
    [anon_sym_LT_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ] = ACTIONS(3064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_BANG_EQ] = ACTIONS(3064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3066),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_QMARK_QMARK] = ACTIONS(3066),
    [anon_sym_instanceof] = ACTIONS(3064),
    [anon_sym_void] = ACTIONS(3064),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3066),
    [sym_number] = ACTIONS(3066),
    [sym_this] = ACTIONS(3064),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [sym_null] = ACTIONS(3064),
    [sym_undefined] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_readonly] = ACTIONS(3064),
    [anon_sym_get] = ACTIONS(3064),
    [anon_sym_set] = ACTIONS(3064),
    [anon_sym_QMARK] = ACTIONS(3064),
    [anon_sym_any] = ACTIONS(3064),
    [anon_sym_number] = ACTIONS(3064),
    [anon_sym_boolean] = ACTIONS(3064),
    [anon_sym_string] = ACTIONS(3064),
    [anon_sym_symbol] = ACTIONS(3064),
    [anon_sym_abstract] = ACTIONS(3064),
    [anon_sym_satisfies] = ACTIONS(3064),
    [anon_sym_extends] = ACTIONS(3064),
    [anon_sym_infer] = ACTIONS(3064),
    [anon_sym_keyof] = ACTIONS(3064),
    [anon_sym_unknown] = ACTIONS(3064),
    [anon_sym_never] = ACTIONS(3064),
    [anon_sym_object] = ACTIONS(3064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3066),
    [anon_sym_constructor] = ACTIONS(3064),
    [anon_sym_prop] = ACTIONS(3064),
    [anon_sym_id] = ACTIONS(3064),
    [anon_sym_event] = ACTIONS(3064),
    [anon_sym_fn] = ACTIONS(3064),
    [anon_sym_on] = ACTIONS(3064),
    [sym__ternary_qmark] = ACTIONS(3066),
  },
  [881] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1621),
    [anon_sym_PIPE_PIPE] = ACTIONS(1621),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1621),
    [anon_sym_LT_LT] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1621),
    [anon_sym_STAR_STAR] = ACTIONS(1621),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1621),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [882] = {
    [sym_identifier] = ACTIONS(3068),
    [anon_sym_export] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3068),
    [anon_sym_typeof] = ACTIONS(3068),
    [anon_sym_import] = ACTIONS(3068),
    [anon_sym_var] = ACTIONS(3068),
    [anon_sym_let] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_with] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_debugger] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_yield] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LTtemplate_GT] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_async] = ACTIONS(3068),
    [anon_sym_function] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_this] = ACTIONS(3068),
    [sym_super] = ACTIONS(3068),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [sym_null] = ACTIONS(3068),
    [sym_undefined] = ACTIONS(3068),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_readonly] = ACTIONS(3068),
    [anon_sym_get] = ACTIONS(3068),
    [anon_sym_set] = ACTIONS(3068),
    [anon_sym_declare] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_override] = ACTIONS(3068),
    [anon_sym_module] = ACTIONS(3068),
    [anon_sym_any] = ACTIONS(3068),
    [anon_sym_number] = ACTIONS(3068),
    [anon_sym_boolean] = ACTIONS(3068),
    [anon_sym_string] = ACTIONS(3068),
    [anon_sym_symbol] = ACTIONS(3068),
    [anon_sym_abstract] = ACTIONS(3068),
    [anon_sym_interface] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_component] = ACTIONS(3068),
  },
  [883] = {
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_QMARK_DOT] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_GT_GT_GT] = ACTIONS(2939),
    [anon_sym_LT_LT] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2939),
    [anon_sym_STAR_STAR] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_EQ_EQ] = ACTIONS(2937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2939),
    [anon_sym_instanceof] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2939),
    [sym_number] = ACTIONS(2939),
    [sym_this] = ACTIONS(2937),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [sym_null] = ACTIONS(2937),
    [sym_undefined] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_satisfies] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(2937),
    [anon_sym_infer] = ACTIONS(2937),
    [anon_sym_keyof] = ACTIONS(2937),
    [anon_sym_unknown] = ACTIONS(2937),
    [anon_sym_never] = ACTIONS(2937),
    [anon_sym_object] = ACTIONS(2937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2939),
    [anon_sym_constructor] = ACTIONS(2937),
    [anon_sym_prop] = ACTIONS(2937),
    [anon_sym_id] = ACTIONS(2937),
    [anon_sym_event] = ACTIONS(2937),
    [anon_sym_fn] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [sym__ternary_qmark] = ACTIONS(2939),
  },
  [884] = {
    [sym_identifier] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3072),
    [anon_sym_as] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3072),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_typeof] = ACTIONS(3072),
    [anon_sym_BANG] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_in] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3072),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_DOT] = ACTIONS(3072),
    [anon_sym_async] = ACTIONS(3072),
    [anon_sym_QMARK_DOT] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3074),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_GT_GT_GT] = ACTIONS(3074),
    [anon_sym_LT_LT] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(3074),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3074),
    [anon_sym_STAR_STAR] = ACTIONS(3074),
    [anon_sym_LT_EQ] = ACTIONS(3074),
    [anon_sym_EQ_EQ] = ACTIONS(3072),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3074),
    [anon_sym_BANG_EQ] = ACTIONS(3072),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3074),
    [anon_sym_GT_EQ] = ACTIONS(3074),
    [anon_sym_QMARK_QMARK] = ACTIONS(3074),
    [anon_sym_instanceof] = ACTIONS(3072),
    [anon_sym_void] = ACTIONS(3072),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_this] = ACTIONS(3072),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [sym_null] = ACTIONS(3072),
    [sym_undefined] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_readonly] = ACTIONS(3072),
    [anon_sym_get] = ACTIONS(3072),
    [anon_sym_set] = ACTIONS(3072),
    [anon_sym_QMARK] = ACTIONS(3072),
    [anon_sym_any] = ACTIONS(3072),
    [anon_sym_number] = ACTIONS(3072),
    [anon_sym_boolean] = ACTIONS(3072),
    [anon_sym_string] = ACTIONS(3072),
    [anon_sym_symbol] = ACTIONS(3072),
    [anon_sym_abstract] = ACTIONS(3072),
    [anon_sym_satisfies] = ACTIONS(3072),
    [anon_sym_extends] = ACTIONS(2620),
    [anon_sym_infer] = ACTIONS(3072),
    [anon_sym_keyof] = ACTIONS(3072),
    [anon_sym_unknown] = ACTIONS(3072),
    [anon_sym_never] = ACTIONS(3072),
    [anon_sym_object] = ACTIONS(3072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3074),
    [anon_sym_constructor] = ACTIONS(3072),
    [anon_sym_prop] = ACTIONS(3072),
    [anon_sym_id] = ACTIONS(3072),
    [anon_sym_event] = ACTIONS(3072),
    [anon_sym_fn] = ACTIONS(3072),
    [anon_sym_on] = ACTIONS(3072),
    [sym__ternary_qmark] = ACTIONS(3074),
  },
  [885] = {
    [sym_identifier] = ACTIONS(3076),
    [anon_sym_export] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_type] = ACTIONS(3076),
    [anon_sym_typeof] = ACTIONS(3076),
    [anon_sym_import] = ACTIONS(3076),
    [anon_sym_var] = ACTIONS(3076),
    [anon_sym_let] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_await] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_with] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_debugger] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_yield] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_LTtemplate_GT] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_SLASH] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_async] = ACTIONS(3076),
    [anon_sym_function] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_void] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3078),
    [sym_number] = ACTIONS(3078),
    [sym_this] = ACTIONS(3076),
    [sym_super] = ACTIONS(3076),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [sym_null] = ACTIONS(3076),
    [sym_undefined] = ACTIONS(3076),
    [anon_sym_AT] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_readonly] = ACTIONS(3076),
    [anon_sym_get] = ACTIONS(3076),
    [anon_sym_set] = ACTIONS(3076),
    [anon_sym_declare] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_public] = ACTIONS(3076),
    [anon_sym_private] = ACTIONS(3076),
    [anon_sym_protected] = ACTIONS(3076),
    [anon_sym_override] = ACTIONS(3076),
    [anon_sym_module] = ACTIONS(3076),
    [anon_sym_any] = ACTIONS(3076),
    [anon_sym_number] = ACTIONS(3076),
    [anon_sym_boolean] = ACTIONS(3076),
    [anon_sym_string] = ACTIONS(3076),
    [anon_sym_symbol] = ACTIONS(3076),
    [anon_sym_abstract] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_component] = ACTIONS(3076),
  },
  [886] = {
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_async] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3082),
    [anon_sym_PIPE_PIPE] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3082),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3082),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3082),
    [anon_sym_QMARK_QMARK] = ACTIONS(3082),
    [anon_sym_instanceof] = ACTIONS(3080),
    [anon_sym_void] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_this] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_null] = ACTIONS(3080),
    [sym_undefined] = ACTIONS(3080),
    [anon_sym_static] = ACTIONS(3080),
    [anon_sym_readonly] = ACTIONS(3080),
    [anon_sym_get] = ACTIONS(3080),
    [anon_sym_set] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_any] = ACTIONS(3080),
    [anon_sym_number] = ACTIONS(3080),
    [anon_sym_boolean] = ACTIONS(3080),
    [anon_sym_string] = ACTIONS(3080),
    [anon_sym_symbol] = ACTIONS(3080),
    [anon_sym_abstract] = ACTIONS(3080),
    [anon_sym_satisfies] = ACTIONS(3080),
    [anon_sym_extends] = ACTIONS(3080),
    [anon_sym_infer] = ACTIONS(3080),
    [anon_sym_keyof] = ACTIONS(3080),
    [anon_sym_unknown] = ACTIONS(3080),
    [anon_sym_never] = ACTIONS(3080),
    [anon_sym_object] = ACTIONS(3080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3082),
    [anon_sym_constructor] = ACTIONS(3080),
    [anon_sym_prop] = ACTIONS(3080),
    [anon_sym_id] = ACTIONS(3080),
    [anon_sym_event] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_on] = ACTIONS(3080),
    [sym__ternary_qmark] = ACTIONS(3082),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_export] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3086),
    [anon_sym_type] = ACTIONS(3084),
    [anon_sym_typeof] = ACTIONS(3084),
    [anon_sym_import] = ACTIONS(3084),
    [anon_sym_var] = ACTIONS(3084),
    [anon_sym_let] = ACTIONS(3084),
    [anon_sym_const] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3086),
    [anon_sym_await] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_do] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3084),
    [anon_sym_with] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_continue] = ACTIONS(3084),
    [anon_sym_debugger] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_throw] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_default] = ACTIONS(3084),
    [anon_sym_yield] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_LTtemplate_GT] = ACTIONS(3086),
    [anon_sym_LT] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_async] = ACTIONS(3084),
    [anon_sym_function] = ACTIONS(3084),
    [anon_sym_new] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_void] = ACTIONS(3084),
    [anon_sym_delete] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3086),
    [sym_number] = ACTIONS(3086),
    [sym_this] = ACTIONS(3084),
    [sym_super] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_null] = ACTIONS(3084),
    [sym_undefined] = ACTIONS(3084),
    [anon_sym_AT] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3084),
    [anon_sym_readonly] = ACTIONS(3084),
    [anon_sym_get] = ACTIONS(3084),
    [anon_sym_set] = ACTIONS(3084),
    [anon_sym_declare] = ACTIONS(3084),
    [anon_sym_namespace] = ACTIONS(3084),
    [anon_sym_public] = ACTIONS(3084),
    [anon_sym_private] = ACTIONS(3084),
    [anon_sym_protected] = ACTIONS(3084),
    [anon_sym_override] = ACTIONS(3084),
    [anon_sym_module] = ACTIONS(3084),
    [anon_sym_any] = ACTIONS(3084),
    [anon_sym_number] = ACTIONS(3084),
    [anon_sym_boolean] = ACTIONS(3084),
    [anon_sym_string] = ACTIONS(3084),
    [anon_sym_symbol] = ACTIONS(3084),
    [anon_sym_abstract] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3084),
    [anon_sym_enum] = ACTIONS(3084),
    [anon_sym_component] = ACTIONS(3084),
  },
  [888] = {
    [sym_identifier] = ACTIONS(3088),
    [anon_sym_export] = ACTIONS(3088),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(3090),
    [anon_sym_type] = ACTIONS(3088),
    [anon_sym_typeof] = ACTIONS(3088),
    [anon_sym_import] = ACTIONS(3088),
    [anon_sym_var] = ACTIONS(3088),
    [anon_sym_let] = ACTIONS(3088),
    [anon_sym_const] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_else] = ACTIONS(3088),
    [anon_sym_if] = ACTIONS(3088),
    [anon_sym_switch] = ACTIONS(3088),
    [anon_sym_for] = ACTIONS(3088),
    [anon_sym_LPAREN] = ACTIONS(3090),
    [anon_sym_await] = ACTIONS(3088),
    [anon_sym_while] = ACTIONS(3088),
    [anon_sym_do] = ACTIONS(3088),
    [anon_sym_try] = ACTIONS(3088),
    [anon_sym_with] = ACTIONS(3088),
    [anon_sym_break] = ACTIONS(3088),
    [anon_sym_continue] = ACTIONS(3088),
    [anon_sym_debugger] = ACTIONS(3088),
    [anon_sym_return] = ACTIONS(3088),
    [anon_sym_throw] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3088),
    [anon_sym_default] = ACTIONS(3088),
    [anon_sym_yield] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_LTtemplate_GT] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3088),
    [anon_sym_SLASH] = ACTIONS(3088),
    [anon_sym_class] = ACTIONS(3088),
    [anon_sym_async] = ACTIONS(3088),
    [anon_sym_function] = ACTIONS(3088),
    [anon_sym_new] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3090),
    [anon_sym_void] = ACTIONS(3088),
    [anon_sym_delete] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3090),
    [anon_sym_DQUOTE] = ACTIONS(3090),
    [anon_sym_SQUOTE] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3090),
    [sym_number] = ACTIONS(3090),
    [sym_this] = ACTIONS(3088),
    [sym_super] = ACTIONS(3088),
    [sym_true] = ACTIONS(3088),
    [sym_false] = ACTIONS(3088),
    [sym_null] = ACTIONS(3088),
    [sym_undefined] = ACTIONS(3088),
    [anon_sym_AT] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3088),
    [anon_sym_readonly] = ACTIONS(3088),
    [anon_sym_get] = ACTIONS(3088),
    [anon_sym_set] = ACTIONS(3088),
    [anon_sym_declare] = ACTIONS(3088),
    [anon_sym_namespace] = ACTIONS(3088),
    [anon_sym_public] = ACTIONS(3088),
    [anon_sym_private] = ACTIONS(3088),
    [anon_sym_protected] = ACTIONS(3088),
    [anon_sym_override] = ACTIONS(3088),
    [anon_sym_module] = ACTIONS(3088),
    [anon_sym_any] = ACTIONS(3088),
    [anon_sym_number] = ACTIONS(3088),
    [anon_sym_boolean] = ACTIONS(3088),
    [anon_sym_string] = ACTIONS(3088),
    [anon_sym_symbol] = ACTIONS(3088),
    [anon_sym_abstract] = ACTIONS(3088),
    [anon_sym_interface] = ACTIONS(3088),
    [anon_sym_enum] = ACTIONS(3088),
    [anon_sym_component] = ACTIONS(3088),
  },
  [889] = {
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_async] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3082),
    [anon_sym_PIPE_PIPE] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3082),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3082),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3082),
    [anon_sym_QMARK_QMARK] = ACTIONS(3082),
    [anon_sym_instanceof] = ACTIONS(3080),
    [anon_sym_void] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_this] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_null] = ACTIONS(3080),
    [sym_undefined] = ACTIONS(3080),
    [anon_sym_static] = ACTIONS(3080),
    [anon_sym_readonly] = ACTIONS(3080),
    [anon_sym_get] = ACTIONS(3080),
    [anon_sym_set] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_any] = ACTIONS(3080),
    [anon_sym_number] = ACTIONS(3080),
    [anon_sym_boolean] = ACTIONS(3080),
    [anon_sym_string] = ACTIONS(3080),
    [anon_sym_symbol] = ACTIONS(3080),
    [anon_sym_abstract] = ACTIONS(3080),
    [anon_sym_satisfies] = ACTIONS(3080),
    [anon_sym_extends] = ACTIONS(3080),
    [anon_sym_infer] = ACTIONS(3080),
    [anon_sym_keyof] = ACTIONS(3080),
    [anon_sym_unknown] = ACTIONS(3080),
    [anon_sym_never] = ACTIONS(3080),
    [anon_sym_object] = ACTIONS(3080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3082),
    [anon_sym_constructor] = ACTIONS(3080),
    [anon_sym_prop] = ACTIONS(3080),
    [anon_sym_id] = ACTIONS(3080),
    [anon_sym_event] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_on] = ACTIONS(3080),
    [sym__ternary_qmark] = ACTIONS(3082),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_export] = ACTIONS(3092),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_type] = ACTIONS(3092),
    [anon_sym_typeof] = ACTIONS(3092),
    [anon_sym_import] = ACTIONS(3092),
    [anon_sym_var] = ACTIONS(3092),
    [anon_sym_let] = ACTIONS(3092),
    [anon_sym_const] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_await] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_try] = ACTIONS(3092),
    [anon_sym_with] = ACTIONS(3092),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_debugger] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_throw] = ACTIONS(3092),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_yield] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_LTtemplate_GT] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3092),
    [anon_sym_SLASH] = ACTIONS(3092),
    [anon_sym_class] = ACTIONS(3092),
    [anon_sym_async] = ACTIONS(3092),
    [anon_sym_function] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3094),
    [sym_number] = ACTIONS(3094),
    [sym_this] = ACTIONS(3092),
    [sym_super] = ACTIONS(3092),
    [sym_true] = ACTIONS(3092),
    [sym_false] = ACTIONS(3092),
    [sym_null] = ACTIONS(3092),
    [sym_undefined] = ACTIONS(3092),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3092),
    [anon_sym_readonly] = ACTIONS(3092),
    [anon_sym_get] = ACTIONS(3092),
    [anon_sym_set] = ACTIONS(3092),
    [anon_sym_declare] = ACTIONS(3092),
    [anon_sym_namespace] = ACTIONS(3092),
    [anon_sym_public] = ACTIONS(3092),
    [anon_sym_private] = ACTIONS(3092),
    [anon_sym_protected] = ACTIONS(3092),
    [anon_sym_override] = ACTIONS(3092),
    [anon_sym_module] = ACTIONS(3092),
    [anon_sym_any] = ACTIONS(3092),
    [anon_sym_number] = ACTIONS(3092),
    [anon_sym_boolean] = ACTIONS(3092),
    [anon_sym_string] = ACTIONS(3092),
    [anon_sym_symbol] = ACTIONS(3092),
    [anon_sym_abstract] = ACTIONS(3092),
    [anon_sym_interface] = ACTIONS(3092),
    [anon_sym_enum] = ACTIONS(3092),
    [anon_sym_component] = ACTIONS(3092),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_in] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_async] = ACTIONS(3080),
    [anon_sym_QMARK_DOT] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3082),
    [anon_sym_PIPE_PIPE] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3080),
    [anon_sym_GT_GT_GT] = ACTIONS(3082),
    [anon_sym_LT_LT] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_CARET] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3082),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_LT_EQ] = ACTIONS(3082),
    [anon_sym_EQ_EQ] = ACTIONS(3080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3082),
    [anon_sym_BANG_EQ] = ACTIONS(3080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3082),
    [anon_sym_QMARK_QMARK] = ACTIONS(3082),
    [anon_sym_instanceof] = ACTIONS(3080),
    [anon_sym_void] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_this] = ACTIONS(3080),
    [sym_true] = ACTIONS(3080),
    [sym_false] = ACTIONS(3080),
    [sym_null] = ACTIONS(3080),
    [sym_undefined] = ACTIONS(3080),
    [anon_sym_static] = ACTIONS(3080),
    [anon_sym_readonly] = ACTIONS(3080),
    [anon_sym_get] = ACTIONS(3080),
    [anon_sym_set] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_any] = ACTIONS(3080),
    [anon_sym_number] = ACTIONS(3080),
    [anon_sym_boolean] = ACTIONS(3080),
    [anon_sym_string] = ACTIONS(3080),
    [anon_sym_symbol] = ACTIONS(3080),
    [anon_sym_abstract] = ACTIONS(3080),
    [anon_sym_satisfies] = ACTIONS(3080),
    [anon_sym_extends] = ACTIONS(3080),
    [anon_sym_infer] = ACTIONS(3080),
    [anon_sym_keyof] = ACTIONS(3080),
    [anon_sym_unknown] = ACTIONS(3080),
    [anon_sym_never] = ACTIONS(3080),
    [anon_sym_object] = ACTIONS(3080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3082),
    [anon_sym_constructor] = ACTIONS(3080),
    [anon_sym_prop] = ACTIONS(3080),
    [anon_sym_id] = ACTIONS(3080),
    [anon_sym_event] = ACTIONS(3080),
    [anon_sym_fn] = ACTIONS(3080),
    [anon_sym_on] = ACTIONS(3080),
    [sym__ternary_qmark] = ACTIONS(3082),
  },
  [892] = {
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_QMARK_DOT] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_GT_GT_GT] = ACTIONS(2939),
    [anon_sym_LT_LT] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2939),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2939),
    [anon_sym_STAR_STAR] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_EQ_EQ] = ACTIONS(2937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2939),
    [anon_sym_instanceof] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2939),
    [sym_number] = ACTIONS(2939),
    [sym_this] = ACTIONS(2937),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [sym_null] = ACTIONS(2937),
    [sym_undefined] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_satisfies] = ACTIONS(2937),
    [anon_sym_extends] = ACTIONS(2937),
    [anon_sym_infer] = ACTIONS(2937),
    [anon_sym_keyof] = ACTIONS(2937),
    [anon_sym_unknown] = ACTIONS(2937),
    [anon_sym_never] = ACTIONS(2937),
    [anon_sym_object] = ACTIONS(2937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2939),
    [anon_sym_constructor] = ACTIONS(2937),
    [anon_sym_prop] = ACTIONS(2937),
    [anon_sym_id] = ACTIONS(2937),
    [anon_sym_event] = ACTIONS(2937),
    [anon_sym_fn] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [sym__ternary_qmark] = ACTIONS(2939),
  },
  [893] = {
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_as] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_typeof] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_async] = ACTIONS(3096),
    [anon_sym_QMARK_DOT] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_PIPE_PIPE] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_GT_GT_GT] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_CARET] = ACTIONS(3098),
    [anon_sym_PIPE] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PERCENT] = ACTIONS(3098),
    [anon_sym_STAR_STAR] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3098),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3098),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3098),
    [anon_sym_GT_EQ] = ACTIONS(3098),
    [anon_sym_QMARK_QMARK] = ACTIONS(3098),
    [anon_sym_instanceof] = ACTIONS(3096),
    [anon_sym_void] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [sym_number] = ACTIONS(3098),
    [sym_this] = ACTIONS(3096),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [sym_null] = ACTIONS(3096),
    [sym_undefined] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_readonly] = ACTIONS(3096),
    [anon_sym_get] = ACTIONS(3096),
    [anon_sym_set] = ACTIONS(3096),
    [anon_sym_QMARK] = ACTIONS(3096),
    [anon_sym_any] = ACTIONS(3096),
    [anon_sym_number] = ACTIONS(3096),
    [anon_sym_boolean] = ACTIONS(3096),
    [anon_sym_string] = ACTIONS(3096),
    [anon_sym_symbol] = ACTIONS(3096),
    [anon_sym_abstract] = ACTIONS(3096),
    [anon_sym_satisfies] = ACTIONS(3096),
    [anon_sym_extends] = ACTIONS(3096),
    [anon_sym_infer] = ACTIONS(3096),
    [anon_sym_keyof] = ACTIONS(3096),
    [anon_sym_unknown] = ACTIONS(3096),
    [anon_sym_never] = ACTIONS(3096),
    [anon_sym_object] = ACTIONS(3096),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3098),
    [anon_sym_constructor] = ACTIONS(3096),
    [anon_sym_prop] = ACTIONS(3096),
    [anon_sym_id] = ACTIONS(3096),
    [anon_sym_event] = ACTIONS(3096),
    [anon_sym_fn] = ACTIONS(3096),
    [anon_sym_on] = ACTIONS(3096),
    [sym__ternary_qmark] = ACTIONS(3098),
  },
  [894] = {
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_as] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_typeof] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_async] = ACTIONS(3096),
    [anon_sym_QMARK_DOT] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_PIPE_PIPE] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_GT_GT_GT] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_CARET] = ACTIONS(3098),
    [anon_sym_PIPE] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PERCENT] = ACTIONS(3098),
    [anon_sym_STAR_STAR] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3098),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3098),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3098),
    [anon_sym_GT_EQ] = ACTIONS(3098),
    [anon_sym_QMARK_QMARK] = ACTIONS(3098),
    [anon_sym_instanceof] = ACTIONS(3096),
    [anon_sym_void] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [sym_number] = ACTIONS(3098),
    [sym_this] = ACTIONS(3096),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [sym_null] = ACTIONS(3096),
    [sym_undefined] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_readonly] = ACTIONS(3096),
    [anon_sym_get] = ACTIONS(3096),
    [anon_sym_set] = ACTIONS(3096),
    [anon_sym_QMARK] = ACTIONS(3096),
    [anon_sym_any] = ACTIONS(3096),
    [anon_sym_number] = ACTIONS(3096),
    [anon_sym_boolean] = ACTIONS(3096),
    [anon_sym_string] = ACTIONS(3096),
    [anon_sym_symbol] = ACTIONS(3096),
    [anon_sym_abstract] = ACTIONS(3096),
    [anon_sym_satisfies] = ACTIONS(3096),
    [anon_sym_extends] = ACTIONS(3096),
    [anon_sym_infer] = ACTIONS(3096),
    [anon_sym_keyof] = ACTIONS(3096),
    [anon_sym_unknown] = ACTIONS(3096),
    [anon_sym_never] = ACTIONS(3096),
    [anon_sym_object] = ACTIONS(3096),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3098),
    [anon_sym_constructor] = ACTIONS(3096),
    [anon_sym_prop] = ACTIONS(3096),
    [anon_sym_id] = ACTIONS(3096),
    [anon_sym_event] = ACTIONS(3096),
    [anon_sym_fn] = ACTIONS(3096),
    [anon_sym_on] = ACTIONS(3096),
    [sym__ternary_qmark] = ACTIONS(3098),
  },
  [895] = {
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_as] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3098),
    [anon_sym_typeof] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3098),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_async] = ACTIONS(3096),
    [anon_sym_QMARK_DOT] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3098),
    [anon_sym_PIPE_PIPE] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_GT_GT_GT] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_CARET] = ACTIONS(3098),
    [anon_sym_PIPE] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PERCENT] = ACTIONS(3098),
    [anon_sym_STAR_STAR] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3098),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3098),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3098),
    [anon_sym_GT_EQ] = ACTIONS(3098),
    [anon_sym_QMARK_QMARK] = ACTIONS(3098),
    [anon_sym_instanceof] = ACTIONS(3096),
    [anon_sym_void] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3098),
    [anon_sym_DQUOTE] = ACTIONS(3098),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [sym_number] = ACTIONS(3098),
    [sym_this] = ACTIONS(3096),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [sym_null] = ACTIONS(3096),
    [sym_undefined] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_readonly] = ACTIONS(3096),
    [anon_sym_get] = ACTIONS(3096),
    [anon_sym_set] = ACTIONS(3096),
    [anon_sym_QMARK] = ACTIONS(3096),
    [anon_sym_any] = ACTIONS(3096),
    [anon_sym_number] = ACTIONS(3096),
    [anon_sym_boolean] = ACTIONS(3096),
    [anon_sym_string] = ACTIONS(3096),
    [anon_sym_symbol] = ACTIONS(3096),
    [anon_sym_abstract] = ACTIONS(3096),
    [anon_sym_satisfies] = ACTIONS(3096),
    [anon_sym_extends] = ACTIONS(3096),
    [anon_sym_infer] = ACTIONS(3096),
    [anon_sym_keyof] = ACTIONS(3096),
    [anon_sym_unknown] = ACTIONS(3096),
    [anon_sym_never] = ACTIONS(3096),
    [anon_sym_object] = ACTIONS(3096),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3098),
    [anon_sym_constructor] = ACTIONS(3096),
    [anon_sym_prop] = ACTIONS(3096),
    [anon_sym_id] = ACTIONS(3096),
    [anon_sym_event] = ACTIONS(3096),
    [anon_sym_fn] = ACTIONS(3096),
    [anon_sym_on] = ACTIONS(3096),
    [sym__ternary_qmark] = ACTIONS(3098),
  },
  [896] = {
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_as] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_typeof] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3100),
    [anon_sym_GT] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_DOT] = ACTIONS(3100),
    [anon_sym_async] = ACTIONS(3100),
    [anon_sym_QMARK_DOT] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3100),
    [anon_sym_GT_GT_GT] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3100),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(3100),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_BANG_EQ] = ACTIONS(3100),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3102),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_QMARK_QMARK] = ACTIONS(3102),
    [anon_sym_instanceof] = ACTIONS(3100),
    [anon_sym_void] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [sym_this] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_undefined] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_readonly] = ACTIONS(3100),
    [anon_sym_get] = ACTIONS(3100),
    [anon_sym_set] = ACTIONS(3100),
    [anon_sym_QMARK] = ACTIONS(3100),
    [anon_sym_any] = ACTIONS(3100),
    [anon_sym_number] = ACTIONS(3100),
    [anon_sym_boolean] = ACTIONS(3100),
    [anon_sym_string] = ACTIONS(3100),
    [anon_sym_symbol] = ACTIONS(3100),
    [anon_sym_abstract] = ACTIONS(3100),
    [anon_sym_satisfies] = ACTIONS(3100),
    [anon_sym_infer] = ACTIONS(3100),
    [anon_sym_keyof] = ACTIONS(3100),
    [anon_sym_unknown] = ACTIONS(3100),
    [anon_sym_never] = ACTIONS(3100),
    [anon_sym_object] = ACTIONS(3100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3102),
    [anon_sym_constructor] = ACTIONS(3100),
    [anon_sym_prop] = ACTIONS(3100),
    [anon_sym_id] = ACTIONS(3100),
    [anon_sym_event] = ACTIONS(3100),
    [anon_sym_fn] = ACTIONS(3100),
    [anon_sym_on] = ACTIONS(3100),
    [sym__ternary_qmark] = ACTIONS(3102),
  },
  [897] = {
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_as] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_typeof] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3106),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym_LBRACK] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_SLASH] = ACTIONS(3104),
    [anon_sym_DOT] = ACTIONS(3104),
    [anon_sym_async] = ACTIONS(3104),
    [anon_sym_QMARK_DOT] = ACTIONS(3106),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_PIPE_PIPE] = ACTIONS(3106),
    [anon_sym_GT_GT] = ACTIONS(3104),
    [anon_sym_GT_GT_GT] = ACTIONS(3106),
    [anon_sym_LT_LT] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_CARET] = ACTIONS(3106),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PERCENT] = ACTIONS(3106),
    [anon_sym_STAR_STAR] = ACTIONS(3106),
    [anon_sym_LT_EQ] = ACTIONS(3106),
    [anon_sym_EQ_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3106),
    [anon_sym_GT_EQ] = ACTIONS(3106),
    [anon_sym_QMARK_QMARK] = ACTIONS(3106),
    [anon_sym_instanceof] = ACTIONS(3104),
    [anon_sym_void] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3106),
    [sym_number] = ACTIONS(3106),
    [sym_this] = ACTIONS(3104),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_null] = ACTIONS(3104),
    [sym_undefined] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_readonly] = ACTIONS(3104),
    [anon_sym_get] = ACTIONS(3104),
    [anon_sym_set] = ACTIONS(3104),
    [anon_sym_QMARK] = ACTIONS(3104),
    [anon_sym_any] = ACTIONS(3104),
    [anon_sym_number] = ACTIONS(3104),
    [anon_sym_boolean] = ACTIONS(3104),
    [anon_sym_string] = ACTIONS(3104),
    [anon_sym_symbol] = ACTIONS(3104),
    [anon_sym_abstract] = ACTIONS(3104),
    [anon_sym_satisfies] = ACTIONS(3104),
    [anon_sym_infer] = ACTIONS(3104),
    [anon_sym_keyof] = ACTIONS(3104),
    [anon_sym_unknown] = ACTIONS(3104),
    [anon_sym_never] = ACTIONS(3104),
    [anon_sym_object] = ACTIONS(3104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3106),
    [anon_sym_constructor] = ACTIONS(3104),
    [anon_sym_prop] = ACTIONS(3104),
    [anon_sym_id] = ACTIONS(3104),
    [anon_sym_event] = ACTIONS(3104),
    [anon_sym_fn] = ACTIONS(3104),
    [anon_sym_on] = ACTIONS(3104),
    [sym__ternary_qmark] = ACTIONS(3106),
  },
  [898] = {
    [sym_identifier] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3108),
    [anon_sym_as] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3108),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [anon_sym_typeof] = ACTIONS(3108),
    [anon_sym_BANG] = ACTIONS(3108),
    [anon_sym_LPAREN] = ACTIONS(3110),
    [anon_sym_in] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym_LBRACK] = ACTIONS(3110),
    [anon_sym_LT] = ACTIONS(3108),
    [anon_sym_GT] = ACTIONS(3108),
    [anon_sym_SLASH] = ACTIONS(3108),
    [anon_sym_DOT] = ACTIONS(3108),
    [anon_sym_async] = ACTIONS(3108),
    [anon_sym_QMARK_DOT] = ACTIONS(3110),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3110),
    [anon_sym_GT_GT] = ACTIONS(3108),
    [anon_sym_GT_GT_GT] = ACTIONS(3110),
    [anon_sym_LT_LT] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_CARET] = ACTIONS(3110),
    [anon_sym_PIPE] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PERCENT] = ACTIONS(3110),
    [anon_sym_STAR_STAR] = ACTIONS(3110),
    [anon_sym_LT_EQ] = ACTIONS(3110),
    [anon_sym_EQ_EQ] = ACTIONS(3108),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3110),
    [anon_sym_BANG_EQ] = ACTIONS(3108),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3110),
    [anon_sym_GT_EQ] = ACTIONS(3110),
    [anon_sym_QMARK_QMARK] = ACTIONS(3110),
    [anon_sym_instanceof] = ACTIONS(3108),
    [anon_sym_void] = ACTIONS(3108),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3110),
    [sym_number] = ACTIONS(3110),
    [sym_this] = ACTIONS(3108),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [sym_null] = ACTIONS(3108),
    [sym_undefined] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_readonly] = ACTIONS(3108),
    [anon_sym_get] = ACTIONS(3108),
    [anon_sym_set] = ACTIONS(3108),
    [anon_sym_QMARK] = ACTIONS(3108),
    [anon_sym_any] = ACTIONS(3108),
    [anon_sym_number] = ACTIONS(3108),
    [anon_sym_boolean] = ACTIONS(3108),
    [anon_sym_string] = ACTIONS(3108),
    [anon_sym_symbol] = ACTIONS(3108),
    [anon_sym_abstract] = ACTIONS(3108),
    [anon_sym_satisfies] = ACTIONS(3108),
    [anon_sym_infer] = ACTIONS(3108),
    [anon_sym_keyof] = ACTIONS(3108),
    [anon_sym_unknown] = ACTIONS(3108),
    [anon_sym_never] = ACTIONS(3108),
    [anon_sym_object] = ACTIONS(3108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3110),
    [anon_sym_constructor] = ACTIONS(3108),
    [anon_sym_prop] = ACTIONS(3108),
    [anon_sym_id] = ACTIONS(3108),
    [anon_sym_event] = ACTIONS(3108),
    [anon_sym_fn] = ACTIONS(3108),
    [anon_sym_on] = ACTIONS(3108),
    [sym__ternary_qmark] = ACTIONS(3110),
  },
  [899] = {
    [sym_identifier] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3112),
    [anon_sym_as] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3112),
    [anon_sym_RBRACE] = ACTIONS(3114),
    [anon_sym_typeof] = ACTIONS(3112),
    [anon_sym_BANG] = ACTIONS(3112),
    [anon_sym_LPAREN] = ACTIONS(3114),
    [anon_sym_in] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(3112),
    [anon_sym_GT] = ACTIONS(3112),
    [anon_sym_SLASH] = ACTIONS(3112),
    [anon_sym_DOT] = ACTIONS(3112),
    [anon_sym_async] = ACTIONS(3112),
    [anon_sym_QMARK_DOT] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [anon_sym_GT_GT] = ACTIONS(3112),
    [anon_sym_GT_GT_GT] = ACTIONS(3114),
    [anon_sym_LT_LT] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_CARET] = ACTIONS(3114),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PERCENT] = ACTIONS(3114),
    [anon_sym_STAR_STAR] = ACTIONS(3114),
    [anon_sym_LT_EQ] = ACTIONS(3114),
    [anon_sym_EQ_EQ] = ACTIONS(3112),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3114),
    [anon_sym_BANG_EQ] = ACTIONS(3112),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3114),
    [anon_sym_GT_EQ] = ACTIONS(3114),
    [anon_sym_QMARK_QMARK] = ACTIONS(3114),
    [anon_sym_instanceof] = ACTIONS(3112),
    [anon_sym_void] = ACTIONS(3112),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3114),
    [sym_number] = ACTIONS(3114),
    [sym_this] = ACTIONS(3112),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [sym_null] = ACTIONS(3112),
    [sym_undefined] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_readonly] = ACTIONS(3112),
    [anon_sym_get] = ACTIONS(3112),
    [anon_sym_set] = ACTIONS(3112),
    [anon_sym_QMARK] = ACTIONS(3112),
    [anon_sym_any] = ACTIONS(3112),
    [anon_sym_number] = ACTIONS(3112),
    [anon_sym_boolean] = ACTIONS(3112),
    [anon_sym_string] = ACTIONS(3112),
    [anon_sym_symbol] = ACTIONS(3112),
    [anon_sym_abstract] = ACTIONS(3112),
    [anon_sym_satisfies] = ACTIONS(3112),
    [anon_sym_infer] = ACTIONS(3112),
    [anon_sym_keyof] = ACTIONS(3112),
    [anon_sym_unknown] = ACTIONS(3112),
    [anon_sym_never] = ACTIONS(3112),
    [anon_sym_object] = ACTIONS(3112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3114),
    [anon_sym_constructor] = ACTIONS(3112),
    [anon_sym_prop] = ACTIONS(3112),
    [anon_sym_id] = ACTIONS(3112),
    [anon_sym_event] = ACTIONS(3112),
    [anon_sym_fn] = ACTIONS(3112),
    [anon_sym_on] = ACTIONS(3112),
    [sym__ternary_qmark] = ACTIONS(3114),
  },
  [900] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1621),
    [anon_sym_PIPE_PIPE] = ACTIONS(1621),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1621),
    [anon_sym_LT_LT] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1621),
    [anon_sym_STAR_STAR] = ACTIONS(1621),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1621),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_constructor] = ACTIONS(1617),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [901] = {
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_STAR] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3118),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3118),
    [anon_sym_in] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_LBRACK] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_QMARK_DOT] = ACTIONS(3118),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3116),
    [anon_sym_GT_GT_GT] = ACTIONS(3118),
    [anon_sym_LT_LT] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3116),
    [anon_sym_CARET] = ACTIONS(3118),
    [anon_sym_PIPE] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_PERCENT] = ACTIONS(3118),
    [anon_sym_STAR_STAR] = ACTIONS(3118),
    [anon_sym_LT_EQ] = ACTIONS(3118),
    [anon_sym_EQ_EQ] = ACTIONS(3116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3118),
    [anon_sym_BANG_EQ] = ACTIONS(3116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3118),
    [anon_sym_GT_EQ] = ACTIONS(3118),
    [anon_sym_QMARK_QMARK] = ACTIONS(3118),
    [anon_sym_instanceof] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3118),
    [anon_sym_DASH_DASH] = ACTIONS(3118),
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [anon_sym_SQUOTE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [sym_number] = ACTIONS(3118),
    [sym_this] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_QMARK] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_satisfies] = ACTIONS(3116),
    [anon_sym_infer] = ACTIONS(3116),
    [anon_sym_keyof] = ACTIONS(3116),
    [anon_sym_unknown] = ACTIONS(3116),
    [anon_sym_never] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3118),
    [anon_sym_constructor] = ACTIONS(3116),
    [anon_sym_prop] = ACTIONS(3116),
    [anon_sym_id] = ACTIONS(3116),
    [anon_sym_event] = ACTIONS(3116),
    [anon_sym_fn] = ACTIONS(3116),
    [anon_sym_on] = ACTIONS(3116),
    [sym__ternary_qmark] = ACTIONS(3118),
  },
  [902] = {
    [sym_identifier] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_as] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_typeof] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [anon_sym_in] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(1307),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_QMARK_DOT] = ACTIONS(1307),
    [anon_sym_new] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_GT_GT_GT] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1307),
    [anon_sym_STAR_STAR] = ACTIONS(1307),
    [anon_sym_LT_EQ] = ACTIONS(1307),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1307),
    [anon_sym_BANG_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1307),
    [anon_sym_GT_EQ] = ACTIONS(1307),
    [anon_sym_QMARK_QMARK] = ACTIONS(1307),
    [anon_sym_instanceof] = ACTIONS(1303),
    [anon_sym_void] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1307),
    [sym_this] = ACTIONS(1303),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_null] = ACTIONS(1303),
    [sym_undefined] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [anon_sym_abstract] = ACTIONS(1303),
    [anon_sym_satisfies] = ACTIONS(1303),
    [anon_sym_infer] = ACTIONS(1303),
    [anon_sym_keyof] = ACTIONS(1303),
    [anon_sym_unknown] = ACTIONS(1303),
    [anon_sym_never] = ACTIONS(1303),
    [anon_sym_object] = ACTIONS(1303),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1307),
    [anon_sym_constructor] = ACTIONS(1303),
    [anon_sym_prop] = ACTIONS(1303),
    [anon_sym_id] = ACTIONS(1303),
    [anon_sym_event] = ACTIONS(1303),
    [anon_sym_fn] = ACTIONS(1303),
    [anon_sym_on] = ACTIONS(1303),
    [sym__ternary_qmark] = ACTIONS(1307),
  },
  [903] = {
    [sym_identifier] = ACTIONS(3120),
    [anon_sym_STAR] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3122),
    [anon_sym_typeof] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3122),
    [anon_sym_in] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_LT] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3120),
    [anon_sym_SLASH] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(3120),
    [anon_sym_async] = ACTIONS(3120),
    [anon_sym_QMARK_DOT] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3122),
    [anon_sym_PIPE_PIPE] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3120),
    [anon_sym_GT_GT_GT] = ACTIONS(3122),
    [anon_sym_LT_LT] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3120),
    [anon_sym_CARET] = ACTIONS(3122),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3120),
    [anon_sym_PERCENT] = ACTIONS(3122),
    [anon_sym_STAR_STAR] = ACTIONS(3122),
    [anon_sym_LT_EQ] = ACTIONS(3122),
    [anon_sym_EQ_EQ] = ACTIONS(3120),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3122),
    [anon_sym_BANG_EQ] = ACTIONS(3120),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3122),
    [anon_sym_GT_EQ] = ACTIONS(3122),
    [anon_sym_QMARK_QMARK] = ACTIONS(3122),
    [anon_sym_instanceof] = ACTIONS(3120),
    [anon_sym_void] = ACTIONS(3120),
    [anon_sym_PLUS_PLUS] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3122),
    [anon_sym_DQUOTE] = ACTIONS(3122),
    [anon_sym_SQUOTE] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3122),
    [sym_number] = ACTIONS(3122),
    [sym_this] = ACTIONS(3120),
    [sym_true] = ACTIONS(3120),
    [sym_false] = ACTIONS(3120),
    [sym_null] = ACTIONS(3120),
    [sym_undefined] = ACTIONS(3120),
    [anon_sym_static] = ACTIONS(3120),
    [anon_sym_readonly] = ACTIONS(3120),
    [anon_sym_get] = ACTIONS(3120),
    [anon_sym_set] = ACTIONS(3120),
    [anon_sym_QMARK] = ACTIONS(3120),
    [anon_sym_any] = ACTIONS(3120),
    [anon_sym_number] = ACTIONS(3120),
    [anon_sym_boolean] = ACTIONS(3120),
    [anon_sym_string] = ACTIONS(3120),
    [anon_sym_symbol] = ACTIONS(3120),
    [anon_sym_abstract] = ACTIONS(3120),
    [anon_sym_satisfies] = ACTIONS(3120),
    [anon_sym_infer] = ACTIONS(3120),
    [anon_sym_keyof] = ACTIONS(3120),
    [anon_sym_unknown] = ACTIONS(3120),
    [anon_sym_never] = ACTIONS(3120),
    [anon_sym_object] = ACTIONS(3120),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3122),
    [anon_sym_constructor] = ACTIONS(3120),
    [anon_sym_prop] = ACTIONS(3120),
    [anon_sym_id] = ACTIONS(3120),
    [anon_sym_event] = ACTIONS(3120),
    [anon_sym_fn] = ACTIONS(3120),
    [anon_sym_on] = ACTIONS(3120),
    [sym__ternary_qmark] = ACTIONS(3122),
  },
  [904] = {
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_as] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_typeof] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_in] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_LT] = ACTIONS(3124),
    [anon_sym_GT] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3124),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_async] = ACTIONS(3124),
    [anon_sym_QMARK_DOT] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_PIPE_PIPE] = ACTIONS(3126),
    [anon_sym_GT_GT] = ACTIONS(3124),
    [anon_sym_GT_GT_GT] = ACTIONS(3126),
    [anon_sym_LT_LT] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_CARET] = ACTIONS(3126),
    [anon_sym_PIPE] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3124),
    [anon_sym_PERCENT] = ACTIONS(3126),
    [anon_sym_STAR_STAR] = ACTIONS(3126),
    [anon_sym_LT_EQ] = ACTIONS(3126),
    [anon_sym_EQ_EQ] = ACTIONS(3124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3126),
    [anon_sym_BANG_EQ] = ACTIONS(3124),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3126),
    [anon_sym_GT_EQ] = ACTIONS(3126),
    [anon_sym_QMARK_QMARK] = ACTIONS(3126),
    [anon_sym_instanceof] = ACTIONS(3124),
    [anon_sym_void] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3126),
    [sym_number] = ACTIONS(3126),
    [sym_this] = ACTIONS(3124),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [sym_null] = ACTIONS(3124),
    [sym_undefined] = ACTIONS(3124),
    [anon_sym_static] = ACTIONS(3124),
    [anon_sym_readonly] = ACTIONS(3124),
    [anon_sym_get] = ACTIONS(3124),
    [anon_sym_set] = ACTIONS(3124),
    [anon_sym_QMARK] = ACTIONS(3124),
    [anon_sym_any] = ACTIONS(3124),
    [anon_sym_number] = ACTIONS(3124),
    [anon_sym_boolean] = ACTIONS(3124),
    [anon_sym_string] = ACTIONS(3124),
    [anon_sym_symbol] = ACTIONS(3124),
    [anon_sym_abstract] = ACTIONS(3124),
    [anon_sym_satisfies] = ACTIONS(3124),
    [anon_sym_infer] = ACTIONS(3124),
    [anon_sym_keyof] = ACTIONS(3124),
    [anon_sym_unknown] = ACTIONS(3124),
    [anon_sym_never] = ACTIONS(3124),
    [anon_sym_object] = ACTIONS(3124),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3126),
    [anon_sym_constructor] = ACTIONS(3124),
    [anon_sym_prop] = ACTIONS(3124),
    [anon_sym_id] = ACTIONS(3124),
    [anon_sym_event] = ACTIONS(3124),
    [anon_sym_fn] = ACTIONS(3124),
    [anon_sym_on] = ACTIONS(3124),
    [sym__ternary_qmark] = ACTIONS(3126),
  },
  [905] = {
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_as] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_in] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_GT] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_DOT] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_QMARK_DOT] = ACTIONS(3130),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_PIPE_PIPE] = ACTIONS(3130),
    [anon_sym_GT_GT] = ACTIONS(3128),
    [anon_sym_GT_GT_GT] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_CARET] = ACTIONS(3130),
    [anon_sym_PIPE] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PERCENT] = ACTIONS(3130),
    [anon_sym_STAR_STAR] = ACTIONS(3130),
    [anon_sym_LT_EQ] = ACTIONS(3130),
    [anon_sym_EQ_EQ] = ACTIONS(3128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3130),
    [anon_sym_BANG_EQ] = ACTIONS(3128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3130),
    [anon_sym_GT_EQ] = ACTIONS(3130),
    [anon_sym_QMARK_QMARK] = ACTIONS(3130),
    [anon_sym_instanceof] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [sym_this] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_null] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_QMARK] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_satisfies] = ACTIONS(3128),
    [anon_sym_infer] = ACTIONS(3128),
    [anon_sym_keyof] = ACTIONS(3128),
    [anon_sym_unknown] = ACTIONS(3128),
    [anon_sym_never] = ACTIONS(3128),
    [anon_sym_object] = ACTIONS(3128),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3130),
    [anon_sym_constructor] = ACTIONS(3128),
    [anon_sym_prop] = ACTIONS(3128),
    [anon_sym_id] = ACTIONS(3128),
    [anon_sym_event] = ACTIONS(3128),
    [anon_sym_fn] = ACTIONS(3128),
    [anon_sym_on] = ACTIONS(3128),
    [sym__ternary_qmark] = ACTIONS(3130),
  },
  [906] = {
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_as] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_in] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [anon_sym_DOT] = ACTIONS(3132),
    [anon_sym_async] = ACTIONS(3132),
    [anon_sym_QMARK_DOT] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_PIPE_PIPE] = ACTIONS(3134),
    [anon_sym_GT_GT] = ACTIONS(3132),
    [anon_sym_GT_GT_GT] = ACTIONS(3134),
    [anon_sym_LT_LT] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_CARET] = ACTIONS(3134),
    [anon_sym_PIPE] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3134),
    [anon_sym_STAR_STAR] = ACTIONS(3134),
    [anon_sym_LT_EQ] = ACTIONS(3134),
    [anon_sym_EQ_EQ] = ACTIONS(3132),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3134),
    [anon_sym_BANG_EQ] = ACTIONS(3132),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3134),
    [anon_sym_QMARK_QMARK] = ACTIONS(3134),
    [anon_sym_instanceof] = ACTIONS(3132),
    [anon_sym_void] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3134),
    [sym_number] = ACTIONS(3134),
    [sym_this] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_null] = ACTIONS(3132),
    [sym_undefined] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_readonly] = ACTIONS(3132),
    [anon_sym_get] = ACTIONS(3132),
    [anon_sym_set] = ACTIONS(3132),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_any] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3132),
    [anon_sym_boolean] = ACTIONS(3132),
    [anon_sym_string] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(3132),
    [anon_sym_satisfies] = ACTIONS(3132),
    [anon_sym_infer] = ACTIONS(3132),
    [anon_sym_keyof] = ACTIONS(3132),
    [anon_sym_unknown] = ACTIONS(3132),
    [anon_sym_never] = ACTIONS(3132),
    [anon_sym_object] = ACTIONS(3132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3134),
    [anon_sym_constructor] = ACTIONS(3132),
    [anon_sym_prop] = ACTIONS(3132),
    [anon_sym_id] = ACTIONS(3132),
    [anon_sym_event] = ACTIONS(3132),
    [anon_sym_fn] = ACTIONS(3132),
    [anon_sym_on] = ACTIONS(3132),
    [sym__ternary_qmark] = ACTIONS(3134),
  },
  [907] = {
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(2383),
    [anon_sym_as] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2385),
    [anon_sym_typeof] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_in] = ACTIONS(2383),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2383),
    [anon_sym_DOT] = ACTIONS(2383),
    [anon_sym_async] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2385),
    [anon_sym_new] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2383),
    [anon_sym_GT_GT_GT] = ACTIONS(2385),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2383),
    [anon_sym_CARET] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2383),
    [anon_sym_PERCENT] = ACTIONS(2385),
    [anon_sym_STAR_STAR] = ACTIONS(2385),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2385),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2385),
    [anon_sym_GT_EQ] = ACTIONS(2385),
    [anon_sym_QMARK_QMARK] = ACTIONS(2385),
    [anon_sym_instanceof] = ACTIONS(2383),
    [anon_sym_void] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2385),
    [anon_sym_DASH_DASH] = ACTIONS(2385),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2385),
    [sym_number] = ACTIONS(2385),
    [sym_this] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_null] = ACTIONS(2383),
    [sym_undefined] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2383),
    [anon_sym_readonly] = ACTIONS(2383),
    [anon_sym_get] = ACTIONS(2383),
    [anon_sym_set] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_any] = ACTIONS(2383),
    [anon_sym_number] = ACTIONS(2383),
    [anon_sym_boolean] = ACTIONS(2383),
    [anon_sym_string] = ACTIONS(2383),
    [anon_sym_symbol] = ACTIONS(2383),
    [anon_sym_abstract] = ACTIONS(2383),
    [anon_sym_satisfies] = ACTIONS(2383),
    [anon_sym_infer] = ACTIONS(2383),
    [anon_sym_keyof] = ACTIONS(2383),
    [anon_sym_unknown] = ACTIONS(2383),
    [anon_sym_never] = ACTIONS(2383),
    [anon_sym_object] = ACTIONS(2383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2385),
    [anon_sym_constructor] = ACTIONS(2383),
    [anon_sym_prop] = ACTIONS(2383),
    [anon_sym_id] = ACTIONS(2383),
    [anon_sym_event] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_on] = ACTIONS(2383),
    [sym__ternary_qmark] = ACTIONS(2385),
  },
  [908] = {
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3136),
    [anon_sym_as] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_in] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_GT] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3136),
    [anon_sym_DOT] = ACTIONS(3136),
    [anon_sym_async] = ACTIONS(3136),
    [anon_sym_QMARK_DOT] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_AMP_AMP] = ACTIONS(3138),
    [anon_sym_PIPE_PIPE] = ACTIONS(3138),
    [anon_sym_GT_GT] = ACTIONS(3136),
    [anon_sym_GT_GT_GT] = ACTIONS(3138),
    [anon_sym_LT_LT] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym_CARET] = ACTIONS(3138),
    [anon_sym_PIPE] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_PERCENT] = ACTIONS(3138),
    [anon_sym_STAR_STAR] = ACTIONS(3138),
    [anon_sym_LT_EQ] = ACTIONS(3138),
    [anon_sym_EQ_EQ] = ACTIONS(3136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3138),
    [anon_sym_BANG_EQ] = ACTIONS(3136),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3138),
    [anon_sym_GT_EQ] = ACTIONS(3138),
    [anon_sym_QMARK_QMARK] = ACTIONS(3138),
    [anon_sym_instanceof] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_this] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_undefined] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_readonly] = ACTIONS(3136),
    [anon_sym_get] = ACTIONS(3136),
    [anon_sym_set] = ACTIONS(3136),
    [anon_sym_QMARK] = ACTIONS(3136),
    [anon_sym_any] = ACTIONS(3136),
    [anon_sym_number] = ACTIONS(3136),
    [anon_sym_boolean] = ACTIONS(3136),
    [anon_sym_string] = ACTIONS(3136),
    [anon_sym_symbol] = ACTIONS(3136),
    [anon_sym_abstract] = ACTIONS(3136),
    [anon_sym_satisfies] = ACTIONS(3136),
    [anon_sym_infer] = ACTIONS(3136),
    [anon_sym_keyof] = ACTIONS(3136),
    [anon_sym_unknown] = ACTIONS(3136),
    [anon_sym_never] = ACTIONS(3136),
    [anon_sym_object] = ACTIONS(3136),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3138),
    [anon_sym_constructor] = ACTIONS(3136),
    [anon_sym_prop] = ACTIONS(3136),
    [anon_sym_id] = ACTIONS(3136),
    [anon_sym_event] = ACTIONS(3136),
    [anon_sym_fn] = ACTIONS(3136),
    [anon_sym_on] = ACTIONS(3136),
    [sym__ternary_qmark] = ACTIONS(3138),
  },
  [909] = {
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_as] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_in] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_GT] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(3140),
    [anon_sym_DOT] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_QMARK_DOT] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3142),
    [anon_sym_PIPE_PIPE] = ACTIONS(3142),
    [anon_sym_GT_GT] = ACTIONS(3140),
    [anon_sym_GT_GT_GT] = ACTIONS(3142),
    [anon_sym_LT_LT] = ACTIONS(3142),
    [anon_sym_AMP] = ACTIONS(3140),
    [anon_sym_CARET] = ACTIONS(3142),
    [anon_sym_PIPE] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_PERCENT] = ACTIONS(3142),
    [anon_sym_STAR_STAR] = ACTIONS(3142),
    [anon_sym_LT_EQ] = ACTIONS(3142),
    [anon_sym_EQ_EQ] = ACTIONS(3140),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3142),
    [anon_sym_BANG_EQ] = ACTIONS(3140),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3142),
    [anon_sym_GT_EQ] = ACTIONS(3142),
    [anon_sym_QMARK_QMARK] = ACTIONS(3142),
    [anon_sym_instanceof] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [sym_this] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_null] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_readonly] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_QMARK] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_satisfies] = ACTIONS(3140),
    [anon_sym_infer] = ACTIONS(3140),
    [anon_sym_keyof] = ACTIONS(3140),
    [anon_sym_unknown] = ACTIONS(3140),
    [anon_sym_never] = ACTIONS(3140),
    [anon_sym_object] = ACTIONS(3140),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3142),
    [anon_sym_constructor] = ACTIONS(3140),
    [anon_sym_prop] = ACTIONS(3140),
    [anon_sym_id] = ACTIONS(3140),
    [anon_sym_event] = ACTIONS(3140),
    [anon_sym_fn] = ACTIONS(3140),
    [anon_sym_on] = ACTIONS(3140),
    [sym__ternary_qmark] = ACTIONS(3142),
  },
  [910] = {
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_as] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_in] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_GT] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3144),
    [anon_sym_DOT] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_QMARK_DOT] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_PIPE_PIPE] = ACTIONS(3146),
    [anon_sym_GT_GT] = ACTIONS(3144),
    [anon_sym_GT_GT_GT] = ACTIONS(3146),
    [anon_sym_LT_LT] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_CARET] = ACTIONS(3146),
    [anon_sym_PIPE] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PERCENT] = ACTIONS(3146),
    [anon_sym_STAR_STAR] = ACTIONS(3146),
    [anon_sym_LT_EQ] = ACTIONS(3146),
    [anon_sym_EQ_EQ] = ACTIONS(3144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3146),
    [anon_sym_BANG_EQ] = ACTIONS(3144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3146),
    [anon_sym_GT_EQ] = ACTIONS(3146),
    [anon_sym_QMARK_QMARK] = ACTIONS(3146),
    [anon_sym_instanceof] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [sym_this] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_null] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_readonly] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_QMARK] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_satisfies] = ACTIONS(3144),
    [anon_sym_infer] = ACTIONS(3144),
    [anon_sym_keyof] = ACTIONS(3144),
    [anon_sym_unknown] = ACTIONS(3144),
    [anon_sym_never] = ACTIONS(3144),
    [anon_sym_object] = ACTIONS(3144),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3146),
    [anon_sym_constructor] = ACTIONS(3144),
    [anon_sym_prop] = ACTIONS(3144),
    [anon_sym_id] = ACTIONS(3144),
    [anon_sym_event] = ACTIONS(3144),
    [anon_sym_fn] = ACTIONS(3144),
    [anon_sym_on] = ACTIONS(3144),
    [sym__ternary_qmark] = ACTIONS(3146),
  },
  [911] = {
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_as] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_typeof] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_QMARK_DOT] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1411),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_GT_GT_GT] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_QMARK_QMARK] = ACTIONS(1413),
    [anon_sym_instanceof] = ACTIONS(1411),
    [anon_sym_void] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1413),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [sym_number] = ACTIONS(1413),
    [sym_this] = ACTIONS(1411),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_readonly] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [anon_sym_abstract] = ACTIONS(1411),
    [anon_sym_satisfies] = ACTIONS(1411),
    [anon_sym_infer] = ACTIONS(1411),
    [anon_sym_keyof] = ACTIONS(1411),
    [anon_sym_unknown] = ACTIONS(1411),
    [anon_sym_never] = ACTIONS(1411),
    [anon_sym_object] = ACTIONS(1411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1413),
    [anon_sym_constructor] = ACTIONS(1411),
    [anon_sym_prop] = ACTIONS(1411),
    [anon_sym_id] = ACTIONS(1411),
    [anon_sym_event] = ACTIONS(1411),
    [anon_sym_fn] = ACTIONS(1411),
    [anon_sym_on] = ACTIONS(1411),
    [sym__ternary_qmark] = ACTIONS(1413),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_as] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_GT] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_QMARK_DOT] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_GT_GT] = ACTIONS(3148),
    [anon_sym_GT_GT_GT] = ACTIONS(3150),
    [anon_sym_LT_LT] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_CARET] = ACTIONS(3150),
    [anon_sym_PIPE] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PERCENT] = ACTIONS(3150),
    [anon_sym_STAR_STAR] = ACTIONS(3150),
    [anon_sym_LT_EQ] = ACTIONS(3150),
    [anon_sym_EQ_EQ] = ACTIONS(3148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3150),
    [anon_sym_BANG_EQ] = ACTIONS(3148),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3150),
    [anon_sym_GT_EQ] = ACTIONS(3150),
    [anon_sym_QMARK_QMARK] = ACTIONS(3150),
    [anon_sym_instanceof] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_this] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_satisfies] = ACTIONS(3148),
    [anon_sym_infer] = ACTIONS(3148),
    [anon_sym_keyof] = ACTIONS(3148),
    [anon_sym_unknown] = ACTIONS(3148),
    [anon_sym_never] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3150),
    [anon_sym_constructor] = ACTIONS(3148),
    [anon_sym_prop] = ACTIONS(3148),
    [anon_sym_id] = ACTIONS(3148),
    [anon_sym_event] = ACTIONS(3148),
    [anon_sym_fn] = ACTIONS(3148),
    [anon_sym_on] = ACTIONS(3148),
    [sym__ternary_qmark] = ACTIONS(3150),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_as] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_QMARK_DOT] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_GT_GT] = ACTIONS(3152),
    [anon_sym_GT_GT_GT] = ACTIONS(3154),
    [anon_sym_LT_LT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3154),
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3154),
    [anon_sym_LT_EQ] = ACTIONS(3154),
    [anon_sym_EQ_EQ] = ACTIONS(3152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3152),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3154),
    [anon_sym_GT_EQ] = ACTIONS(3154),
    [anon_sym_QMARK_QMARK] = ACTIONS(3154),
    [anon_sym_instanceof] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_this] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_satisfies] = ACTIONS(3152),
    [anon_sym_infer] = ACTIONS(3152),
    [anon_sym_keyof] = ACTIONS(3152),
    [anon_sym_unknown] = ACTIONS(3152),
    [anon_sym_never] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3154),
    [anon_sym_constructor] = ACTIONS(3152),
    [anon_sym_prop] = ACTIONS(3152),
    [anon_sym_id] = ACTIONS(3152),
    [anon_sym_event] = ACTIONS(3152),
    [anon_sym_fn] = ACTIONS(3152),
    [anon_sym_on] = ACTIONS(3152),
    [sym__ternary_qmark] = ACTIONS(3154),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_QMARK_DOT] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3156),
    [anon_sym_GT_GT_GT] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(3156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_BANG_EQ] = ACTIONS(3156),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_QMARK_QMARK] = ACTIONS(3158),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_this] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_satisfies] = ACTIONS(3156),
    [anon_sym_infer] = ACTIONS(3156),
    [anon_sym_keyof] = ACTIONS(3156),
    [anon_sym_unknown] = ACTIONS(3156),
    [anon_sym_never] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3158),
    [anon_sym_constructor] = ACTIONS(3156),
    [anon_sym_prop] = ACTIONS(3156),
    [anon_sym_id] = ACTIONS(3156),
    [anon_sym_event] = ACTIONS(3156),
    [anon_sym_fn] = ACTIONS(3156),
    [anon_sym_on] = ACTIONS(3156),
    [sym__ternary_qmark] = ACTIONS(3158),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_as] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_in] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_async] = ACTIONS(3160),
    [anon_sym_QMARK_DOT] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_PIPE_PIPE] = ACTIONS(3162),
    [anon_sym_GT_GT] = ACTIONS(3160),
    [anon_sym_GT_GT_GT] = ACTIONS(3162),
    [anon_sym_LT_LT] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_CARET] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_PERCENT] = ACTIONS(3162),
    [anon_sym_STAR_STAR] = ACTIONS(3162),
    [anon_sym_LT_EQ] = ACTIONS(3162),
    [anon_sym_EQ_EQ] = ACTIONS(3160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3162),
    [anon_sym_BANG_EQ] = ACTIONS(3160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3162),
    [anon_sym_GT_EQ] = ACTIONS(3162),
    [anon_sym_QMARK_QMARK] = ACTIONS(3162),
    [anon_sym_instanceof] = ACTIONS(3160),
    [anon_sym_void] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym_this] = ACTIONS(3160),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_undefined] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_readonly] = ACTIONS(3160),
    [anon_sym_get] = ACTIONS(3160),
    [anon_sym_set] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_any] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3160),
    [anon_sym_string] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3160),
    [anon_sym_abstract] = ACTIONS(3160),
    [anon_sym_satisfies] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3160),
    [anon_sym_keyof] = ACTIONS(3160),
    [anon_sym_unknown] = ACTIONS(3160),
    [anon_sym_never] = ACTIONS(3160),
    [anon_sym_object] = ACTIONS(3160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3162),
    [anon_sym_constructor] = ACTIONS(3160),
    [anon_sym_prop] = ACTIONS(3160),
    [anon_sym_id] = ACTIONS(3160),
    [anon_sym_event] = ACTIONS(3160),
    [anon_sym_fn] = ACTIONS(3160),
    [anon_sym_on] = ACTIONS(3160),
    [sym__ternary_qmark] = ACTIONS(3162),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_as] = ACTIONS(3164),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_typeof] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_in] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3164),
    [anon_sym_GT] = ACTIONS(3164),
    [anon_sym_SLASH] = ACTIONS(3164),
    [anon_sym_DOT] = ACTIONS(3164),
    [anon_sym_async] = ACTIONS(3164),
    [anon_sym_QMARK_DOT] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [anon_sym_GT_GT] = ACTIONS(3164),
    [anon_sym_GT_GT_GT] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_CARET] = ACTIONS(3166),
    [anon_sym_PIPE] = ACTIONS(3164),
    [anon_sym_PLUS] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3164),
    [anon_sym_PERCENT] = ACTIONS(3166),
    [anon_sym_STAR_STAR] = ACTIONS(3166),
    [anon_sym_LT_EQ] = ACTIONS(3166),
    [anon_sym_EQ_EQ] = ACTIONS(3164),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3166),
    [anon_sym_BANG_EQ] = ACTIONS(3164),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3166),
    [anon_sym_GT_EQ] = ACTIONS(3166),
    [anon_sym_QMARK_QMARK] = ACTIONS(3166),
    [anon_sym_instanceof] = ACTIONS(3164),
    [anon_sym_void] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_this] = ACTIONS(3164),
    [sym_true] = ACTIONS(3164),
    [sym_false] = ACTIONS(3164),
    [sym_null] = ACTIONS(3164),
    [sym_undefined] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_readonly] = ACTIONS(3164),
    [anon_sym_get] = ACTIONS(3164),
    [anon_sym_set] = ACTIONS(3164),
    [anon_sym_QMARK] = ACTIONS(3164),
    [anon_sym_any] = ACTIONS(3164),
    [anon_sym_number] = ACTIONS(3164),
    [anon_sym_boolean] = ACTIONS(3164),
    [anon_sym_string] = ACTIONS(3164),
    [anon_sym_symbol] = ACTIONS(3164),
    [anon_sym_abstract] = ACTIONS(3164),
    [anon_sym_satisfies] = ACTIONS(3164),
    [anon_sym_infer] = ACTIONS(3164),
    [anon_sym_keyof] = ACTIONS(3164),
    [anon_sym_unknown] = ACTIONS(3164),
    [anon_sym_never] = ACTIONS(3164),
    [anon_sym_object] = ACTIONS(3164),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3166),
    [anon_sym_constructor] = ACTIONS(3164),
    [anon_sym_prop] = ACTIONS(3164),
    [anon_sym_id] = ACTIONS(3164),
    [anon_sym_event] = ACTIONS(3164),
    [anon_sym_fn] = ACTIONS(3164),
    [anon_sym_on] = ACTIONS(3164),
    [sym__ternary_qmark] = ACTIONS(3166),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_as] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_in] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3168),
    [anon_sym_DOT] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_QMARK_DOT] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3170),
    [anon_sym_PIPE_PIPE] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3168),
    [anon_sym_GT_GT_GT] = ACTIONS(3170),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
    [anon_sym_CARET] = ACTIONS(3170),
    [anon_sym_PIPE] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_PERCENT] = ACTIONS(3170),
    [anon_sym_STAR_STAR] = ACTIONS(3170),
    [anon_sym_LT_EQ] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3170),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3170),
    [anon_sym_GT_EQ] = ACTIONS(3170),
    [anon_sym_QMARK_QMARK] = ACTIONS(3170),
    [anon_sym_instanceof] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [sym_number] = ACTIONS(3170),
    [sym_this] = ACTIONS(3168),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [sym_null] = ACTIONS(3168),
    [sym_undefined] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_readonly] = ACTIONS(3168),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_QMARK] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_abstract] = ACTIONS(3168),
    [anon_sym_satisfies] = ACTIONS(3168),
    [anon_sym_infer] = ACTIONS(3168),
    [anon_sym_keyof] = ACTIONS(3168),
    [anon_sym_unknown] = ACTIONS(3168),
    [anon_sym_never] = ACTIONS(3168),
    [anon_sym_object] = ACTIONS(3168),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3170),
    [anon_sym_constructor] = ACTIONS(3168),
    [anon_sym_prop] = ACTIONS(3168),
    [anon_sym_id] = ACTIONS(3168),
    [anon_sym_event] = ACTIONS(3168),
    [anon_sym_fn] = ACTIONS(3168),
    [anon_sym_on] = ACTIONS(3168),
    [sym__ternary_qmark] = ACTIONS(3170),
  },
  [918] = {
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_typeof] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1443),
    [anon_sym_in] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1443),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_async] = ACTIONS(1439),
    [anon_sym_QMARK_DOT] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_GT_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1443),
    [anon_sym_QMARK_QMARK] = ACTIONS(1443),
    [anon_sym_instanceof] = ACTIONS(1439),
    [anon_sym_void] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1443),
    [anon_sym_DASH_DASH] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1443),
    [sym_number] = ACTIONS(1443),
    [sym_this] = ACTIONS(1439),
    [sym_true] = ACTIONS(1439),
    [sym_false] = ACTIONS(1439),
    [sym_null] = ACTIONS(1439),
    [sym_undefined] = ACTIONS(1439),
    [anon_sym_static] = ACTIONS(1439),
    [anon_sym_readonly] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(1439),
    [anon_sym_set] = ACTIONS(1439),
    [anon_sym_QMARK] = ACTIONS(1439),
    [anon_sym_any] = ACTIONS(1439),
    [anon_sym_number] = ACTIONS(1439),
    [anon_sym_boolean] = ACTIONS(1439),
    [anon_sym_string] = ACTIONS(1439),
    [anon_sym_symbol] = ACTIONS(1439),
    [anon_sym_abstract] = ACTIONS(1439),
    [anon_sym_satisfies] = ACTIONS(1439),
    [anon_sym_infer] = ACTIONS(1439),
    [anon_sym_keyof] = ACTIONS(1439),
    [anon_sym_unknown] = ACTIONS(1439),
    [anon_sym_never] = ACTIONS(1439),
    [anon_sym_object] = ACTIONS(1439),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1443),
    [anon_sym_constructor] = ACTIONS(1439),
    [anon_sym_prop] = ACTIONS(1439),
    [anon_sym_id] = ACTIONS(1439),
    [anon_sym_event] = ACTIONS(1439),
    [anon_sym_fn] = ACTIONS(1439),
    [anon_sym_on] = ACTIONS(1439),
    [sym__ternary_qmark] = ACTIONS(1443),
  },
  [919] = {
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1261),
    [anon_sym_as] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_typeof] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1261),
    [anon_sym_DOT] = ACTIONS(1261),
    [anon_sym_async] = ACTIONS(1261),
    [anon_sym_QMARK_DOT] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_GT_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_QMARK_QMARK] = ACTIONS(1265),
    [anon_sym_instanceof] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1265),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [anon_sym_SQUOTE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [sym_number] = ACTIONS(1265),
    [sym_this] = ACTIONS(1261),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [sym_null] = ACTIONS(1261),
    [sym_undefined] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_get] = ACTIONS(1261),
    [anon_sym_set] = ACTIONS(1261),
    [anon_sym_QMARK] = ACTIONS(1261),
    [anon_sym_any] = ACTIONS(1261),
    [anon_sym_number] = ACTIONS(1261),
    [anon_sym_boolean] = ACTIONS(1261),
    [anon_sym_string] = ACTIONS(1261),
    [anon_sym_symbol] = ACTIONS(1261),
    [anon_sym_abstract] = ACTIONS(1261),
    [anon_sym_satisfies] = ACTIONS(1261),
    [anon_sym_infer] = ACTIONS(1261),
    [anon_sym_keyof] = ACTIONS(1261),
    [anon_sym_unknown] = ACTIONS(1261),
    [anon_sym_never] = ACTIONS(1261),
    [anon_sym_object] = ACTIONS(1261),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1265),
    [anon_sym_constructor] = ACTIONS(1261),
    [anon_sym_prop] = ACTIONS(1261),
    [anon_sym_id] = ACTIONS(1261),
    [anon_sym_event] = ACTIONS(1261),
    [anon_sym_fn] = ACTIONS(1261),
    [anon_sym_on] = ACTIONS(1261),
    [sym__ternary_qmark] = ACTIONS(1265),
  },
  [920] = {
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_as] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3174),
    [anon_sym_in] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_GT] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_DOT] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_QMARK_DOT] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3174),
    [anon_sym_PIPE_PIPE] = ACTIONS(3174),
    [anon_sym_GT_GT] = ACTIONS(3172),
    [anon_sym_GT_GT_GT] = ACTIONS(3174),
    [anon_sym_LT_LT] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3172),
    [anon_sym_CARET] = ACTIONS(3174),
    [anon_sym_PIPE] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_PERCENT] = ACTIONS(3174),
    [anon_sym_STAR_STAR] = ACTIONS(3174),
    [anon_sym_LT_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3174),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_QMARK_QMARK] = ACTIONS(3174),
    [anon_sym_instanceof] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [sym_number] = ACTIONS(3174),
    [sym_this] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_QMARK] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_satisfies] = ACTIONS(3172),
    [anon_sym_infer] = ACTIONS(3172),
    [anon_sym_keyof] = ACTIONS(3172),
    [anon_sym_unknown] = ACTIONS(3172),
    [anon_sym_never] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3174),
    [anon_sym_constructor] = ACTIONS(3172),
    [anon_sym_prop] = ACTIONS(3172),
    [anon_sym_id] = ACTIONS(3172),
    [anon_sym_event] = ACTIONS(3172),
    [anon_sym_fn] = ACTIONS(3172),
    [anon_sym_on] = ACTIONS(3172),
    [sym__ternary_qmark] = ACTIONS(3174),
  },
  [921] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_as] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_typeof] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_in] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_QMARK_DOT] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_GT_GT] = ACTIONS(3176),
    [anon_sym_GT_GT_GT] = ACTIONS(3178),
    [anon_sym_LT_LT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_CARET] = ACTIONS(3178),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_PERCENT] = ACTIONS(3178),
    [anon_sym_STAR_STAR] = ACTIONS(3178),
    [anon_sym_LT_EQ] = ACTIONS(3178),
    [anon_sym_EQ_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3178),
    [anon_sym_BANG_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3178),
    [anon_sym_GT_EQ] = ACTIONS(3178),
    [anon_sym_QMARK_QMARK] = ACTIONS(3178),
    [anon_sym_instanceof] = ACTIONS(3176),
    [anon_sym_void] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [sym_number] = ACTIONS(3178),
    [sym_this] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_undefined] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_readonly] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3176),
    [anon_sym_set] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3176),
    [anon_sym_any] = ACTIONS(3176),
    [anon_sym_number] = ACTIONS(3176),
    [anon_sym_boolean] = ACTIONS(3176),
    [anon_sym_string] = ACTIONS(3176),
    [anon_sym_symbol] = ACTIONS(3176),
    [anon_sym_abstract] = ACTIONS(3176),
    [anon_sym_satisfies] = ACTIONS(3176),
    [anon_sym_infer] = ACTIONS(3176),
    [anon_sym_keyof] = ACTIONS(3176),
    [anon_sym_unknown] = ACTIONS(3176),
    [anon_sym_never] = ACTIONS(3176),
    [anon_sym_object] = ACTIONS(3176),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3178),
    [anon_sym_constructor] = ACTIONS(3176),
    [anon_sym_prop] = ACTIONS(3176),
    [anon_sym_id] = ACTIONS(3176),
    [anon_sym_event] = ACTIONS(3176),
    [anon_sym_fn] = ACTIONS(3176),
    [anon_sym_on] = ACTIONS(3176),
    [sym__ternary_qmark] = ACTIONS(3178),
  },
  [922] = {
    [sym_identifier] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_as] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_RBRACE] = ACTIONS(1343),
    [anon_sym_typeof] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1343),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1341),
    [anon_sym_async] = ACTIONS(1341),
    [anon_sym_QMARK_DOT] = ACTIONS(1343),
    [anon_sym_new] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1343),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1343),
    [anon_sym_GT_EQ] = ACTIONS(1343),
    [anon_sym_QMARK_QMARK] = ACTIONS(1343),
    [anon_sym_instanceof] = ACTIONS(1341),
    [anon_sym_void] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [sym_number] = ACTIONS(1343),
    [sym_this] = ACTIONS(1341),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [sym_null] = ACTIONS(1341),
    [sym_undefined] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_get] = ACTIONS(1341),
    [anon_sym_set] = ACTIONS(1341),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_any] = ACTIONS(1341),
    [anon_sym_number] = ACTIONS(1341),
    [anon_sym_boolean] = ACTIONS(1341),
    [anon_sym_string] = ACTIONS(1341),
    [anon_sym_symbol] = ACTIONS(1341),
    [anon_sym_abstract] = ACTIONS(1341),
    [anon_sym_satisfies] = ACTIONS(1341),
    [anon_sym_infer] = ACTIONS(1341),
    [anon_sym_keyof] = ACTIONS(1341),
    [anon_sym_unknown] = ACTIONS(1341),
    [anon_sym_never] = ACTIONS(1341),
    [anon_sym_object] = ACTIONS(1341),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1343),
    [anon_sym_constructor] = ACTIONS(1341),
    [anon_sym_prop] = ACTIONS(1341),
    [anon_sym_id] = ACTIONS(1341),
    [anon_sym_event] = ACTIONS(1341),
    [anon_sym_fn] = ACTIONS(1341),
    [anon_sym_on] = ACTIONS(1341),
    [sym__ternary_qmark] = ACTIONS(1343),
  },
  [923] = {
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_as] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_typeof] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_in] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_SLASH] = ACTIONS(1323),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_async] = ACTIONS(1323),
    [anon_sym_QMARK_DOT] = ACTIONS(1327),
    [anon_sym_new] = ACTIONS(1323),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_GT_GT] = ACTIONS(1323),
    [anon_sym_GT_GT_GT] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1323),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_EQ_EQ] = ACTIONS(1323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1327),
    [anon_sym_BANG_EQ] = ACTIONS(1323),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1327),
    [anon_sym_QMARK_QMARK] = ACTIONS(1327),
    [anon_sym_instanceof] = ACTIONS(1323),
    [anon_sym_void] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1327),
    [sym_number] = ACTIONS(1327),
    [sym_this] = ACTIONS(1323),
    [sym_true] = ACTIONS(1323),
    [sym_false] = ACTIONS(1323),
    [sym_null] = ACTIONS(1323),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_static] = ACTIONS(1323),
    [anon_sym_readonly] = ACTIONS(1323),
    [anon_sym_get] = ACTIONS(1323),
    [anon_sym_set] = ACTIONS(1323),
    [anon_sym_QMARK] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1323),
    [anon_sym_number] = ACTIONS(1323),
    [anon_sym_boolean] = ACTIONS(1323),
    [anon_sym_string] = ACTIONS(1323),
    [anon_sym_symbol] = ACTIONS(1323),
    [anon_sym_abstract] = ACTIONS(1323),
    [anon_sym_satisfies] = ACTIONS(1323),
    [anon_sym_infer] = ACTIONS(1323),
    [anon_sym_keyof] = ACTIONS(1323),
    [anon_sym_unknown] = ACTIONS(1323),
    [anon_sym_never] = ACTIONS(1323),
    [anon_sym_object] = ACTIONS(1323),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1327),
    [anon_sym_constructor] = ACTIONS(1323),
    [anon_sym_prop] = ACTIONS(1323),
    [anon_sym_id] = ACTIONS(1323),
    [anon_sym_event] = ACTIONS(1323),
    [anon_sym_fn] = ACTIONS(1323),
    [anon_sym_on] = ACTIONS(1323),
    [sym__ternary_qmark] = ACTIONS(1327),
  },
  [924] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_as] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1365),
    [anon_sym_async] = ACTIONS(1365),
    [anon_sym_QMARK_DOT] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1365),
    [anon_sym_AMP_AMP] = ACTIONS(1369),
    [anon_sym_PIPE_PIPE] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_GT_GT_GT] = ACTIONS(1369),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(1369),
    [anon_sym_LT_EQ] = ACTIONS(1369),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1369),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_QMARK_QMARK] = ACTIONS(1369),
    [anon_sym_instanceof] = ACTIONS(1365),
    [anon_sym_void] = ACTIONS(1365),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1369),
    [sym_number] = ACTIONS(1369),
    [sym_this] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_undefined] = ACTIONS(1365),
    [anon_sym_static] = ACTIONS(1365),
    [anon_sym_readonly] = ACTIONS(1365),
    [anon_sym_get] = ACTIONS(1365),
    [anon_sym_set] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1365),
    [anon_sym_any] = ACTIONS(1365),
    [anon_sym_number] = ACTIONS(1365),
    [anon_sym_boolean] = ACTIONS(1365),
    [anon_sym_string] = ACTIONS(1365),
    [anon_sym_symbol] = ACTIONS(1365),
    [anon_sym_abstract] = ACTIONS(1365),
    [anon_sym_satisfies] = ACTIONS(1365),
    [anon_sym_infer] = ACTIONS(1365),
    [anon_sym_keyof] = ACTIONS(1365),
    [anon_sym_unknown] = ACTIONS(1365),
    [anon_sym_never] = ACTIONS(1365),
    [anon_sym_object] = ACTIONS(1365),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1369),
    [anon_sym_constructor] = ACTIONS(1365),
    [anon_sym_prop] = ACTIONS(1365),
    [anon_sym_id] = ACTIONS(1365),
    [anon_sym_event] = ACTIONS(1365),
    [anon_sym_fn] = ACTIONS(1365),
    [anon_sym_on] = ACTIONS(1365),
    [sym__ternary_qmark] = ACTIONS(1369),
  },
  [925] = {
    [sym_identifier] = ACTIONS(1389),
    [anon_sym_STAR] = ACTIONS(1389),
    [anon_sym_as] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1389),
    [anon_sym_GT] = ACTIONS(1389),
    [anon_sym_SLASH] = ACTIONS(1389),
    [anon_sym_DOT] = ACTIONS(1389),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_QMARK_DOT] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1389),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_GT_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1389),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1389),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_QMARK_QMARK] = ACTIONS(1393),
    [anon_sym_instanceof] = ACTIONS(1389),
    [anon_sym_void] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1389),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_null] = ACTIONS(1389),
    [sym_undefined] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_readonly] = ACTIONS(1389),
    [anon_sym_get] = ACTIONS(1389),
    [anon_sym_set] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1389),
    [anon_sym_any] = ACTIONS(1389),
    [anon_sym_number] = ACTIONS(1389),
    [anon_sym_boolean] = ACTIONS(1389),
    [anon_sym_string] = ACTIONS(1389),
    [anon_sym_symbol] = ACTIONS(1389),
    [anon_sym_abstract] = ACTIONS(1389),
    [anon_sym_satisfies] = ACTIONS(1389),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1389),
    [anon_sym_unknown] = ACTIONS(1389),
    [anon_sym_never] = ACTIONS(1389),
    [anon_sym_object] = ACTIONS(1389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1393),
    [anon_sym_constructor] = ACTIONS(1389),
    [anon_sym_prop] = ACTIONS(1389),
    [anon_sym_id] = ACTIONS(1389),
    [anon_sym_event] = ACTIONS(1389),
    [anon_sym_fn] = ACTIONS(1389),
    [anon_sym_on] = ACTIONS(1389),
    [sym__ternary_qmark] = ACTIONS(1393),
  },
  [926] = {
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_as] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2369),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_in] = ACTIONS(2369),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_DOT] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_QMARK_DOT] = ACTIONS(2371),
    [anon_sym_new] = ACTIONS(2369),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_GT_GT] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2369),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_STAR_STAR] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2369),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2371),
    [anon_sym_BANG_EQ] = ACTIONS(2369),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_QMARK_QMARK] = ACTIONS(2371),
    [anon_sym_instanceof] = ACTIONS(2369),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [sym_this] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [sym_false] = ACTIONS(2369),
    [sym_null] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_readonly] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_satisfies] = ACTIONS(2369),
    [anon_sym_infer] = ACTIONS(2369),
    [anon_sym_keyof] = ACTIONS(2369),
    [anon_sym_unknown] = ACTIONS(2369),
    [anon_sym_never] = ACTIONS(2369),
    [anon_sym_object] = ACTIONS(2369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2371),
    [anon_sym_constructor] = ACTIONS(2369),
    [anon_sym_prop] = ACTIONS(2369),
    [anon_sym_id] = ACTIONS(2369),
    [anon_sym_event] = ACTIONS(2369),
    [anon_sym_fn] = ACTIONS(2369),
    [anon_sym_on] = ACTIONS(2369),
    [sym__ternary_qmark] = ACTIONS(2371),
  },
  [927] = {
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_as] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_typeof] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_GT] = ACTIONS(3180),
    [anon_sym_SLASH] = ACTIONS(3180),
    [anon_sym_DOT] = ACTIONS(3180),
    [anon_sym_async] = ACTIONS(3180),
    [anon_sym_QMARK_DOT] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_PIPE_PIPE] = ACTIONS(3182),
    [anon_sym_GT_GT] = ACTIONS(3180),
    [anon_sym_GT_GT_GT] = ACTIONS(3182),
    [anon_sym_LT_LT] = ACTIONS(3182),
    [anon_sym_AMP] = ACTIONS(3180),
    [anon_sym_CARET] = ACTIONS(3182),
    [anon_sym_PIPE] = ACTIONS(3180),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_PERCENT] = ACTIONS(3182),
    [anon_sym_STAR_STAR] = ACTIONS(3182),
    [anon_sym_LT_EQ] = ACTIONS(3182),
    [anon_sym_EQ_EQ] = ACTIONS(3180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3182),
    [anon_sym_BANG_EQ] = ACTIONS(3180),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3182),
    [anon_sym_GT_EQ] = ACTIONS(3182),
    [anon_sym_QMARK_QMARK] = ACTIONS(3182),
    [anon_sym_instanceof] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [sym_this] = ACTIONS(3180),
    [sym_true] = ACTIONS(3180),
    [sym_false] = ACTIONS(3180),
    [sym_null] = ACTIONS(3180),
    [sym_undefined] = ACTIONS(3180),
    [anon_sym_static] = ACTIONS(3180),
    [anon_sym_readonly] = ACTIONS(3180),
    [anon_sym_get] = ACTIONS(3180),
    [anon_sym_set] = ACTIONS(3180),
    [anon_sym_QMARK] = ACTIONS(3180),
    [anon_sym_any] = ACTIONS(3180),
    [anon_sym_number] = ACTIONS(3180),
    [anon_sym_boolean] = ACTIONS(3180),
    [anon_sym_string] = ACTIONS(3180),
    [anon_sym_symbol] = ACTIONS(3180),
    [anon_sym_abstract] = ACTIONS(3180),
    [anon_sym_satisfies] = ACTIONS(3180),
    [anon_sym_infer] = ACTIONS(3180),
    [anon_sym_keyof] = ACTIONS(3180),
    [anon_sym_unknown] = ACTIONS(3180),
    [anon_sym_never] = ACTIONS(3180),
    [anon_sym_object] = ACTIONS(3180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3182),
    [anon_sym_constructor] = ACTIONS(3180),
    [anon_sym_prop] = ACTIONS(3180),
    [anon_sym_id] = ACTIONS(3180),
    [anon_sym_event] = ACTIONS(3180),
    [anon_sym_fn] = ACTIONS(3180),
    [anon_sym_on] = ACTIONS(3180),
    [sym__ternary_qmark] = ACTIONS(3182),
  },
  [928] = {
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_as] = ACTIONS(2357),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_SLASH] = ACTIONS(2357),
    [anon_sym_DOT] = ACTIONS(2357),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_QMARK_DOT] = ACTIONS(2359),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2359),
    [anon_sym_PIPE_PIPE] = ACTIONS(2359),
    [anon_sym_GT_GT] = ACTIONS(2357),
    [anon_sym_GT_GT_GT] = ACTIONS(2359),
    [anon_sym_LT_LT] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_CARET] = ACTIONS(2359),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2357),
    [anon_sym_PERCENT] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2359),
    [anon_sym_EQ_EQ] = ACTIONS(2357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2359),
    [anon_sym_BANG_EQ] = ACTIONS(2357),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2359),
    [anon_sym_GT_EQ] = ACTIONS(2359),
    [anon_sym_QMARK_QMARK] = ACTIONS(2359),
    [anon_sym_instanceof] = ACTIONS(2357),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2359),
    [anon_sym_DQUOTE] = ACTIONS(2359),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_number] = ACTIONS(2359),
    [sym_this] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_QMARK] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_satisfies] = ACTIONS(2357),
    [anon_sym_infer] = ACTIONS(2357),
    [anon_sym_keyof] = ACTIONS(2357),
    [anon_sym_unknown] = ACTIONS(2357),
    [anon_sym_never] = ACTIONS(2357),
    [anon_sym_object] = ACTIONS(2357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2359),
    [anon_sym_constructor] = ACTIONS(2357),
    [anon_sym_prop] = ACTIONS(2357),
    [anon_sym_id] = ACTIONS(2357),
    [anon_sym_event] = ACTIONS(2357),
    [anon_sym_fn] = ACTIONS(2357),
    [anon_sym_on] = ACTIONS(2357),
    [sym__ternary_qmark] = ACTIONS(2359),
  },
  [929] = {
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_as] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3186),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3186),
    [anon_sym_in] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_GT] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_QMARK_DOT] = ACTIONS(3186),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3186),
    [anon_sym_PIPE_PIPE] = ACTIONS(3186),
    [anon_sym_GT_GT] = ACTIONS(3184),
    [anon_sym_GT_GT_GT] = ACTIONS(3186),
    [anon_sym_LT_LT] = ACTIONS(3186),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_CARET] = ACTIONS(3186),
    [anon_sym_PIPE] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_PERCENT] = ACTIONS(3186),
    [anon_sym_STAR_STAR] = ACTIONS(3186),
    [anon_sym_LT_EQ] = ACTIONS(3186),
    [anon_sym_EQ_EQ] = ACTIONS(3184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3186),
    [anon_sym_BANG_EQ] = ACTIONS(3184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3186),
    [anon_sym_GT_EQ] = ACTIONS(3186),
    [anon_sym_QMARK_QMARK] = ACTIONS(3186),
    [anon_sym_instanceof] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3186),
    [anon_sym_DQUOTE] = ACTIONS(3186),
    [anon_sym_SQUOTE] = ACTIONS(3186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3186),
    [sym_number] = ACTIONS(3186),
    [sym_this] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_readonly] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_satisfies] = ACTIONS(3184),
    [anon_sym_infer] = ACTIONS(3184),
    [anon_sym_keyof] = ACTIONS(3184),
    [anon_sym_unknown] = ACTIONS(3184),
    [anon_sym_never] = ACTIONS(3184),
    [anon_sym_object] = ACTIONS(3184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3186),
    [anon_sym_constructor] = ACTIONS(3184),
    [anon_sym_prop] = ACTIONS(3184),
    [anon_sym_id] = ACTIONS(3184),
    [anon_sym_event] = ACTIONS(3184),
    [anon_sym_fn] = ACTIONS(3184),
    [anon_sym_on] = ACTIONS(3184),
    [sym__ternary_qmark] = ACTIONS(3186),
  },
  [930] = {
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_as] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_in] = ACTIONS(2365),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_DOT] = ACTIONS(2365),
    [anon_sym_async] = ACTIONS(2365),
    [anon_sym_QMARK_DOT] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2367),
    [anon_sym_GT_GT] = ACTIONS(2365),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2367),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_EQ_EQ] = ACTIONS(2365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2367),
    [anon_sym_BANG_EQ] = ACTIONS(2365),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2367),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_QMARK_QMARK] = ACTIONS(2367),
    [anon_sym_instanceof] = ACTIONS(2365),
    [anon_sym_void] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_number] = ACTIONS(2367),
    [sym_this] = ACTIONS(2365),
    [sym_true] = ACTIONS(2365),
    [sym_false] = ACTIONS(2365),
    [sym_null] = ACTIONS(2365),
    [sym_undefined] = ACTIONS(2365),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_get] = ACTIONS(2365),
    [anon_sym_set] = ACTIONS(2365),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_any] = ACTIONS(2365),
    [anon_sym_number] = ACTIONS(2365),
    [anon_sym_boolean] = ACTIONS(2365),
    [anon_sym_string] = ACTIONS(2365),
    [anon_sym_symbol] = ACTIONS(2365),
    [anon_sym_abstract] = ACTIONS(2365),
    [anon_sym_satisfies] = ACTIONS(2365),
    [anon_sym_infer] = ACTIONS(2365),
    [anon_sym_keyof] = ACTIONS(2365),
    [anon_sym_unknown] = ACTIONS(2365),
    [anon_sym_never] = ACTIONS(2365),
    [anon_sym_object] = ACTIONS(2365),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2367),
    [anon_sym_constructor] = ACTIONS(2365),
    [anon_sym_prop] = ACTIONS(2365),
    [anon_sym_id] = ACTIONS(2365),
    [anon_sym_event] = ACTIONS(2365),
    [anon_sym_fn] = ACTIONS(2365),
    [anon_sym_on] = ACTIONS(2365),
    [sym__ternary_qmark] = ACTIONS(2367),
  },
  [931] = {
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3190),
    [anon_sym_in] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_GT] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_DOT] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_QMARK_DOT] = ACTIONS(3190),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3190),
    [anon_sym_PIPE_PIPE] = ACTIONS(3190),
    [anon_sym_GT_GT] = ACTIONS(3188),
    [anon_sym_GT_GT_GT] = ACTIONS(3190),
    [anon_sym_LT_LT] = ACTIONS(3190),
    [anon_sym_AMP] = ACTIONS(3188),
    [anon_sym_CARET] = ACTIONS(3190),
    [anon_sym_PIPE] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PERCENT] = ACTIONS(3190),
    [anon_sym_STAR_STAR] = ACTIONS(3190),
    [anon_sym_LT_EQ] = ACTIONS(3190),
    [anon_sym_EQ_EQ] = ACTIONS(3188),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ] = ACTIONS(3188),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3190),
    [anon_sym_GT_EQ] = ACTIONS(3190),
    [anon_sym_QMARK_QMARK] = ACTIONS(3190),
    [anon_sym_instanceof] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3190),
    [anon_sym_DASH_DASH] = ACTIONS(3190),
    [anon_sym_DQUOTE] = ACTIONS(3190),
    [anon_sym_SQUOTE] = ACTIONS(3190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3190),
    [sym_number] = ACTIONS(3190),
    [sym_this] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_QMARK] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_satisfies] = ACTIONS(3188),
    [anon_sym_infer] = ACTIONS(3188),
    [anon_sym_keyof] = ACTIONS(3188),
    [anon_sym_unknown] = ACTIONS(3188),
    [anon_sym_never] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3190),
    [anon_sym_constructor] = ACTIONS(3188),
    [anon_sym_prop] = ACTIONS(3188),
    [anon_sym_id] = ACTIONS(3188),
    [anon_sym_event] = ACTIONS(3188),
    [anon_sym_fn] = ACTIONS(3188),
    [anon_sym_on] = ACTIONS(3188),
    [sym__ternary_qmark] = ACTIONS(3190),
  },
  [932] = {
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [anon_sym_in] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_async] = ACTIONS(3192),
    [anon_sym_QMARK_DOT] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_AMP_AMP] = ACTIONS(3194),
    [anon_sym_PIPE_PIPE] = ACTIONS(3194),
    [anon_sym_GT_GT] = ACTIONS(3192),
    [anon_sym_GT_GT_GT] = ACTIONS(3194),
    [anon_sym_LT_LT] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_CARET] = ACTIONS(3194),
    [anon_sym_PIPE] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3194),
    [anon_sym_STAR_STAR] = ACTIONS(3194),
    [anon_sym_LT_EQ] = ACTIONS(3194),
    [anon_sym_EQ_EQ] = ACTIONS(3192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3194),
    [anon_sym_BANG_EQ] = ACTIONS(3192),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3194),
    [anon_sym_GT_EQ] = ACTIONS(3194),
    [anon_sym_QMARK_QMARK] = ACTIONS(3194),
    [anon_sym_instanceof] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_number] = ACTIONS(3194),
    [sym_this] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_undefined] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_readonly] = ACTIONS(3192),
    [anon_sym_get] = ACTIONS(3192),
    [anon_sym_set] = ACTIONS(3192),
    [anon_sym_QMARK] = ACTIONS(3192),
    [anon_sym_any] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3192),
    [anon_sym_string] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3192),
    [anon_sym_abstract] = ACTIONS(3192),
    [anon_sym_satisfies] = ACTIONS(3192),
    [anon_sym_infer] = ACTIONS(3192),
    [anon_sym_keyof] = ACTIONS(3192),
    [anon_sym_unknown] = ACTIONS(3192),
    [anon_sym_never] = ACTIONS(3192),
    [anon_sym_object] = ACTIONS(3192),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3194),
    [anon_sym_constructor] = ACTIONS(3192),
    [anon_sym_prop] = ACTIONS(3192),
    [anon_sym_id] = ACTIONS(3192),
    [anon_sym_event] = ACTIONS(3192),
    [anon_sym_fn] = ACTIONS(3192),
    [anon_sym_on] = ACTIONS(3192),
    [sym__ternary_qmark] = ACTIONS(3194),
  },
  [933] = {
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_typeof] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_QMARK_DOT] = ACTIONS(1347),
    [anon_sym_new] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_GT_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1347),
    [anon_sym_QMARK_QMARK] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1345),
    [anon_sym_void] = ACTIONS(1345),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1345),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [sym_null] = ACTIONS(1345),
    [sym_undefined] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_QMARK] = ACTIONS(1345),
    [anon_sym_any] = ACTIONS(1345),
    [anon_sym_number] = ACTIONS(1345),
    [anon_sym_boolean] = ACTIONS(1345),
    [anon_sym_string] = ACTIONS(1345),
    [anon_sym_symbol] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(1345),
    [anon_sym_satisfies] = ACTIONS(1345),
    [anon_sym_infer] = ACTIONS(1345),
    [anon_sym_keyof] = ACTIONS(1345),
    [anon_sym_unknown] = ACTIONS(1345),
    [anon_sym_never] = ACTIONS(1345),
    [anon_sym_object] = ACTIONS(1345),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1347),
    [anon_sym_constructor] = ACTIONS(1345),
    [anon_sym_prop] = ACTIONS(1345),
    [anon_sym_id] = ACTIONS(1345),
    [anon_sym_event] = ACTIONS(1345),
    [anon_sym_fn] = ACTIONS(1345),
    [anon_sym_on] = ACTIONS(1345),
    [sym__ternary_qmark] = ACTIONS(1347),
  },
  [934] = {
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_as] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_in] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_GT] = ACTIONS(3196),
    [anon_sym_SLASH] = ACTIONS(3196),
    [anon_sym_DOT] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_QMARK_DOT] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(3198),
    [anon_sym_PIPE_PIPE] = ACTIONS(3198),
    [anon_sym_GT_GT] = ACTIONS(3196),
    [anon_sym_GT_GT_GT] = ACTIONS(3198),
    [anon_sym_LT_LT] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3196),
    [anon_sym_CARET] = ACTIONS(3198),
    [anon_sym_PIPE] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_PERCENT] = ACTIONS(3198),
    [anon_sym_STAR_STAR] = ACTIONS(3198),
    [anon_sym_LT_EQ] = ACTIONS(3198),
    [anon_sym_EQ_EQ] = ACTIONS(3196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3198),
    [anon_sym_BANG_EQ] = ACTIONS(3196),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3198),
    [anon_sym_GT_EQ] = ACTIONS(3198),
    [anon_sym_QMARK_QMARK] = ACTIONS(3198),
    [anon_sym_instanceof] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_this] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_readonly] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_QMARK] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_satisfies] = ACTIONS(3196),
    [anon_sym_infer] = ACTIONS(3196),
    [anon_sym_keyof] = ACTIONS(3196),
    [anon_sym_unknown] = ACTIONS(3196),
    [anon_sym_never] = ACTIONS(3196),
    [anon_sym_object] = ACTIONS(3196),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3198),
    [anon_sym_constructor] = ACTIONS(3196),
    [anon_sym_prop] = ACTIONS(3196),
    [anon_sym_id] = ACTIONS(3196),
    [anon_sym_event] = ACTIONS(3196),
    [anon_sym_fn] = ACTIONS(3196),
    [anon_sym_on] = ACTIONS(3196),
    [sym__ternary_qmark] = ACTIONS(3198),
  },
  [935] = {
    [sym_identifier] = ACTIONS(3200),
    [anon_sym_STAR] = ACTIONS(3200),
    [anon_sym_as] = ACTIONS(3200),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_typeof] = ACTIONS(3200),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3200),
    [anon_sym_GT] = ACTIONS(3200),
    [anon_sym_SLASH] = ACTIONS(3200),
    [anon_sym_DOT] = ACTIONS(3200),
    [anon_sym_async] = ACTIONS(3200),
    [anon_sym_QMARK_DOT] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3200),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_GT_GT] = ACTIONS(3200),
    [anon_sym_GT_GT_GT] = ACTIONS(3202),
    [anon_sym_LT_LT] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3200),
    [anon_sym_CARET] = ACTIONS(3202),
    [anon_sym_PIPE] = ACTIONS(3200),
    [anon_sym_PLUS] = ACTIONS(3200),
    [anon_sym_DASH] = ACTIONS(3200),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_STAR_STAR] = ACTIONS(3202),
    [anon_sym_LT_EQ] = ACTIONS(3202),
    [anon_sym_EQ_EQ] = ACTIONS(3200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3200),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3202),
    [anon_sym_GT_EQ] = ACTIONS(3202),
    [anon_sym_QMARK_QMARK] = ACTIONS(3202),
    [anon_sym_instanceof] = ACTIONS(3200),
    [anon_sym_void] = ACTIONS(3200),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [sym_this] = ACTIONS(3200),
    [sym_true] = ACTIONS(3200),
    [sym_false] = ACTIONS(3200),
    [sym_null] = ACTIONS(3200),
    [sym_undefined] = ACTIONS(3200),
    [anon_sym_static] = ACTIONS(3200),
    [anon_sym_readonly] = ACTIONS(3200),
    [anon_sym_get] = ACTIONS(3200),
    [anon_sym_set] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_any] = ACTIONS(3200),
    [anon_sym_number] = ACTIONS(3200),
    [anon_sym_boolean] = ACTIONS(3200),
    [anon_sym_string] = ACTIONS(3200),
    [anon_sym_symbol] = ACTIONS(3200),
    [anon_sym_abstract] = ACTIONS(3200),
    [anon_sym_satisfies] = ACTIONS(3200),
    [anon_sym_infer] = ACTIONS(3200),
    [anon_sym_keyof] = ACTIONS(3200),
    [anon_sym_unknown] = ACTIONS(3200),
    [anon_sym_never] = ACTIONS(3200),
    [anon_sym_object] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3202),
    [anon_sym_constructor] = ACTIONS(3200),
    [anon_sym_prop] = ACTIONS(3200),
    [anon_sym_id] = ACTIONS(3200),
    [anon_sym_event] = ACTIONS(3200),
    [anon_sym_fn] = ACTIONS(3200),
    [anon_sym_on] = ACTIONS(3200),
    [sym__ternary_qmark] = ACTIONS(3202),
  },
  [936] = {
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_typeof] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_QMARK_DOT] = ACTIONS(1255),
    [anon_sym_new] = ACTIONS(1251),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [anon_sym_GT_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_QMARK_QMARK] = ACTIONS(1255),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [sym_number] = ACTIONS(1255),
    [sym_this] = ACTIONS(1251),
    [sym_true] = ACTIONS(1251),
    [sym_false] = ACTIONS(1251),
    [sym_null] = ACTIONS(1251),
    [sym_undefined] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1251),
    [anon_sym_readonly] = ACTIONS(1251),
    [anon_sym_get] = ACTIONS(1251),
    [anon_sym_set] = ACTIONS(1251),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_any] = ACTIONS(1251),
    [anon_sym_number] = ACTIONS(1251),
    [anon_sym_boolean] = ACTIONS(1251),
    [anon_sym_string] = ACTIONS(1251),
    [anon_sym_symbol] = ACTIONS(1251),
    [anon_sym_abstract] = ACTIONS(1251),
    [anon_sym_satisfies] = ACTIONS(1251),
    [anon_sym_infer] = ACTIONS(1251),
    [anon_sym_keyof] = ACTIONS(1251),
    [anon_sym_unknown] = ACTIONS(1251),
    [anon_sym_never] = ACTIONS(1251),
    [anon_sym_object] = ACTIONS(1251),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1255),
    [anon_sym_constructor] = ACTIONS(1251),
    [anon_sym_prop] = ACTIONS(1251),
    [anon_sym_id] = ACTIONS(1251),
    [anon_sym_event] = ACTIONS(1251),
    [anon_sym_fn] = ACTIONS(1251),
    [anon_sym_on] = ACTIONS(1251),
    [sym__ternary_qmark] = ACTIONS(1255),
  },
  [937] = {
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_as] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3206),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3206),
    [anon_sym_LBRACK] = ACTIONS(3206),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_GT] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_QMARK_DOT] = ACTIONS(3206),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3206),
    [anon_sym_PIPE_PIPE] = ACTIONS(3206),
    [anon_sym_GT_GT] = ACTIONS(3204),
    [anon_sym_GT_GT_GT] = ACTIONS(3206),
    [anon_sym_LT_LT] = ACTIONS(3206),
    [anon_sym_AMP] = ACTIONS(3204),
    [anon_sym_CARET] = ACTIONS(3206),
    [anon_sym_PIPE] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3206),
    [anon_sym_STAR_STAR] = ACTIONS(3206),
    [anon_sym_LT_EQ] = ACTIONS(3206),
    [anon_sym_EQ_EQ] = ACTIONS(3204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3206),
    [anon_sym_BANG_EQ] = ACTIONS(3204),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3206),
    [anon_sym_GT_EQ] = ACTIONS(3206),
    [anon_sym_QMARK_QMARK] = ACTIONS(3206),
    [anon_sym_instanceof] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3206),
    [anon_sym_DASH_DASH] = ACTIONS(3206),
    [anon_sym_DQUOTE] = ACTIONS(3206),
    [anon_sym_SQUOTE] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3206),
    [sym_number] = ACTIONS(3206),
    [sym_this] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_readonly] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_satisfies] = ACTIONS(3204),
    [anon_sym_infer] = ACTIONS(3204),
    [anon_sym_keyof] = ACTIONS(3204),
    [anon_sym_unknown] = ACTIONS(3204),
    [anon_sym_never] = ACTIONS(3204),
    [anon_sym_object] = ACTIONS(3204),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3206),
    [anon_sym_constructor] = ACTIONS(3204),
    [anon_sym_prop] = ACTIONS(3204),
    [anon_sym_id] = ACTIONS(3204),
    [anon_sym_event] = ACTIONS(3204),
    [anon_sym_fn] = ACTIONS(3204),
    [anon_sym_on] = ACTIONS(3204),
    [sym__ternary_qmark] = ACTIONS(3206),
  },
  [938] = {
    [sym_identifier] = ACTIONS(3208),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_as] = ACTIONS(3208),
    [anon_sym_LBRACE] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3208),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3208),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3208),
    [anon_sym_GT] = ACTIONS(3208),
    [anon_sym_SLASH] = ACTIONS(3208),
    [anon_sym_DOT] = ACTIONS(3208),
    [anon_sym_async] = ACTIONS(3208),
    [anon_sym_QMARK_DOT] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3208),
    [anon_sym_AMP_AMP] = ACTIONS(3210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3210),
    [anon_sym_GT_GT] = ACTIONS(3208),
    [anon_sym_GT_GT_GT] = ACTIONS(3210),
    [anon_sym_LT_LT] = ACTIONS(3210),
    [anon_sym_AMP] = ACTIONS(3208),
    [anon_sym_CARET] = ACTIONS(3210),
    [anon_sym_PIPE] = ACTIONS(3208),
    [anon_sym_PLUS] = ACTIONS(3208),
    [anon_sym_DASH] = ACTIONS(3208),
    [anon_sym_PERCENT] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3210),
    [anon_sym_LT_EQ] = ACTIONS(3210),
    [anon_sym_EQ_EQ] = ACTIONS(3208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3210),
    [anon_sym_BANG_EQ] = ACTIONS(3208),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3210),
    [anon_sym_GT_EQ] = ACTIONS(3210),
    [anon_sym_QMARK_QMARK] = ACTIONS(3210),
    [anon_sym_instanceof] = ACTIONS(3208),
    [anon_sym_void] = ACTIONS(3208),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [sym_this] = ACTIONS(3208),
    [sym_true] = ACTIONS(3208),
    [sym_false] = ACTIONS(3208),
    [sym_null] = ACTIONS(3208),
    [sym_undefined] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(3208),
    [anon_sym_readonly] = ACTIONS(3208),
    [anon_sym_get] = ACTIONS(3208),
    [anon_sym_set] = ACTIONS(3208),
    [anon_sym_QMARK] = ACTIONS(3208),
    [anon_sym_any] = ACTIONS(3208),
    [anon_sym_number] = ACTIONS(3208),
    [anon_sym_boolean] = ACTIONS(3208),
    [anon_sym_string] = ACTIONS(3208),
    [anon_sym_symbol] = ACTIONS(3208),
    [anon_sym_abstract] = ACTIONS(3208),
    [anon_sym_satisfies] = ACTIONS(3208),
    [anon_sym_infer] = ACTIONS(3208),
    [anon_sym_keyof] = ACTIONS(3208),
    [anon_sym_unknown] = ACTIONS(3208),
    [anon_sym_never] = ACTIONS(3208),
    [anon_sym_object] = ACTIONS(3208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3210),
    [anon_sym_constructor] = ACTIONS(3208),
    [anon_sym_prop] = ACTIONS(3208),
    [anon_sym_id] = ACTIONS(3208),
    [anon_sym_event] = ACTIONS(3208),
    [anon_sym_fn] = ACTIONS(3208),
    [anon_sym_on] = ACTIONS(3208),
    [sym__ternary_qmark] = ACTIONS(3210),
  },
  [939] = {
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_as] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_in] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_QMARK_DOT] = ACTIONS(1361),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_GT_GT] = ACTIONS(1359),
    [anon_sym_GT_GT_GT] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1361),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1361),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1361),
    [anon_sym_QMARK_QMARK] = ACTIONS(1361),
    [anon_sym_instanceof] = ACTIONS(1359),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_number] = ACTIONS(1361),
    [sym_this] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_readonly] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_satisfies] = ACTIONS(1359),
    [anon_sym_infer] = ACTIONS(1359),
    [anon_sym_keyof] = ACTIONS(1359),
    [anon_sym_unknown] = ACTIONS(1359),
    [anon_sym_never] = ACTIONS(1359),
    [anon_sym_object] = ACTIONS(1359),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1361),
    [anon_sym_constructor] = ACTIONS(1359),
    [anon_sym_prop] = ACTIONS(1359),
    [anon_sym_id] = ACTIONS(1359),
    [anon_sym_event] = ACTIONS(1359),
    [anon_sym_fn] = ACTIONS(1359),
    [anon_sym_on] = ACTIONS(1359),
    [sym__ternary_qmark] = ACTIONS(1361),
  },
  [940] = {
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_as] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_GT] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_DOT] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_QMARK_DOT] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3214),
    [anon_sym_PIPE_PIPE] = ACTIONS(3214),
    [anon_sym_GT_GT] = ACTIONS(3212),
    [anon_sym_GT_GT_GT] = ACTIONS(3214),
    [anon_sym_LT_LT] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_CARET] = ACTIONS(3214),
    [anon_sym_PIPE] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3214),
    [anon_sym_STAR_STAR] = ACTIONS(3214),
    [anon_sym_LT_EQ] = ACTIONS(3214),
    [anon_sym_EQ_EQ] = ACTIONS(3212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3214),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3214),
    [anon_sym_GT_EQ] = ACTIONS(3214),
    [anon_sym_QMARK_QMARK] = ACTIONS(3214),
    [anon_sym_instanceof] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3214),
    [sym_number] = ACTIONS(3214),
    [sym_this] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_readonly] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_satisfies] = ACTIONS(3212),
    [anon_sym_infer] = ACTIONS(3212),
    [anon_sym_keyof] = ACTIONS(3212),
    [anon_sym_unknown] = ACTIONS(3212),
    [anon_sym_never] = ACTIONS(3212),
    [anon_sym_object] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3214),
    [anon_sym_constructor] = ACTIONS(3212),
    [anon_sym_prop] = ACTIONS(3212),
    [anon_sym_id] = ACTIONS(3212),
    [anon_sym_event] = ACTIONS(3212),
    [anon_sym_fn] = ACTIONS(3212),
    [anon_sym_on] = ACTIONS(3212),
    [sym__ternary_qmark] = ACTIONS(3214),
  },
  [941] = {
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3216),
    [anon_sym_as] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [anon_sym_in] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_DOT] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_QMARK_DOT] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3218),
    [anon_sym_PIPE_PIPE] = ACTIONS(3218),
    [anon_sym_GT_GT] = ACTIONS(3216),
    [anon_sym_GT_GT_GT] = ACTIONS(3218),
    [anon_sym_LT_LT] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3216),
    [anon_sym_CARET] = ACTIONS(3218),
    [anon_sym_PIPE] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_PERCENT] = ACTIONS(3218),
    [anon_sym_STAR_STAR] = ACTIONS(3218),
    [anon_sym_LT_EQ] = ACTIONS(3218),
    [anon_sym_EQ_EQ] = ACTIONS(3216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3218),
    [anon_sym_BANG_EQ] = ACTIONS(3216),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3218),
    [anon_sym_GT_EQ] = ACTIONS(3218),
    [anon_sym_QMARK_QMARK] = ACTIONS(3218),
    [anon_sym_instanceof] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [sym_this] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_readonly] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_satisfies] = ACTIONS(3216),
    [anon_sym_infer] = ACTIONS(3216),
    [anon_sym_keyof] = ACTIONS(3216),
    [anon_sym_unknown] = ACTIONS(3216),
    [anon_sym_never] = ACTIONS(3216),
    [anon_sym_object] = ACTIONS(3216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3218),
    [anon_sym_constructor] = ACTIONS(3216),
    [anon_sym_prop] = ACTIONS(3216),
    [anon_sym_id] = ACTIONS(3216),
    [anon_sym_event] = ACTIONS(3216),
    [anon_sym_fn] = ACTIONS(3216),
    [anon_sym_on] = ACTIONS(3216),
    [sym__ternary_qmark] = ACTIONS(3218),
  },
  [942] = {
    [sym_identifier] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1313),
    [anon_sym_as] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_typeof] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [anon_sym_LT] = ACTIONS(1313),
    [anon_sym_GT] = ACTIONS(1313),
    [anon_sym_SLASH] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1313),
    [anon_sym_QMARK_DOT] = ACTIONS(1317),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_GT_GT_GT] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_CARET] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_STAR] = ACTIONS(1317),
    [anon_sym_LT_EQ] = ACTIONS(1317),
    [anon_sym_EQ_EQ] = ACTIONS(1313),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ] = ACTIONS(1313),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1317),
    [anon_sym_GT_EQ] = ACTIONS(1317),
    [anon_sym_QMARK_QMARK] = ACTIONS(1317),
    [anon_sym_instanceof] = ACTIONS(1313),
    [anon_sym_void] = ACTIONS(1313),
    [anon_sym_PLUS_PLUS] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(1317),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1317),
    [sym_number] = ACTIONS(1317),
    [sym_this] = ACTIONS(1313),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1313),
    [anon_sym_get] = ACTIONS(1313),
    [anon_sym_set] = ACTIONS(1313),
    [anon_sym_QMARK] = ACTIONS(1313),
    [anon_sym_any] = ACTIONS(1313),
    [anon_sym_number] = ACTIONS(1313),
    [anon_sym_boolean] = ACTIONS(1313),
    [anon_sym_string] = ACTIONS(1313),
    [anon_sym_symbol] = ACTIONS(1313),
    [anon_sym_abstract] = ACTIONS(1313),
    [anon_sym_satisfies] = ACTIONS(1313),
    [anon_sym_infer] = ACTIONS(1313),
    [anon_sym_keyof] = ACTIONS(1313),
    [anon_sym_unknown] = ACTIONS(1313),
    [anon_sym_never] = ACTIONS(1313),
    [anon_sym_object] = ACTIONS(1313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1317),
    [anon_sym_constructor] = ACTIONS(1313),
    [anon_sym_prop] = ACTIONS(1313),
    [anon_sym_id] = ACTIONS(1313),
    [anon_sym_event] = ACTIONS(1313),
    [anon_sym_fn] = ACTIONS(1313),
    [anon_sym_on] = ACTIONS(1313),
    [sym__ternary_qmark] = ACTIONS(1317),
  },
  [943] = {
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_STAR] = ACTIONS(3220),
    [anon_sym_as] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_GT] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_DOT] = ACTIONS(3220),
    [anon_sym_async] = ACTIONS(3220),
    [anon_sym_QMARK_DOT] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3220),
    [anon_sym_AMP_AMP] = ACTIONS(3222),
    [anon_sym_PIPE_PIPE] = ACTIONS(3222),
    [anon_sym_GT_GT] = ACTIONS(3220),
    [anon_sym_GT_GT_GT] = ACTIONS(3222),
    [anon_sym_LT_LT] = ACTIONS(3222),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_CARET] = ACTIONS(3222),
    [anon_sym_PIPE] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_PERCENT] = ACTIONS(3222),
    [anon_sym_STAR_STAR] = ACTIONS(3222),
    [anon_sym_LT_EQ] = ACTIONS(3222),
    [anon_sym_EQ_EQ] = ACTIONS(3220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3222),
    [anon_sym_BANG_EQ] = ACTIONS(3220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3222),
    [anon_sym_GT_EQ] = ACTIONS(3222),
    [anon_sym_QMARK_QMARK] = ACTIONS(3222),
    [anon_sym_instanceof] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3222),
    [sym_number] = ACTIONS(3222),
    [sym_this] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3220),
    [anon_sym_readonly] = ACTIONS(3220),
    [anon_sym_get] = ACTIONS(3220),
    [anon_sym_set] = ACTIONS(3220),
    [anon_sym_QMARK] = ACTIONS(3220),
    [anon_sym_any] = ACTIONS(3220),
    [anon_sym_number] = ACTIONS(3220),
    [anon_sym_boolean] = ACTIONS(3220),
    [anon_sym_string] = ACTIONS(3220),
    [anon_sym_symbol] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(3220),
    [anon_sym_satisfies] = ACTIONS(3220),
    [anon_sym_infer] = ACTIONS(3220),
    [anon_sym_keyof] = ACTIONS(3220),
    [anon_sym_unknown] = ACTIONS(3220),
    [anon_sym_never] = ACTIONS(3220),
    [anon_sym_object] = ACTIONS(3220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3222),
    [anon_sym_constructor] = ACTIONS(3220),
    [anon_sym_prop] = ACTIONS(3220),
    [anon_sym_id] = ACTIONS(3220),
    [anon_sym_event] = ACTIONS(3220),
    [anon_sym_fn] = ACTIONS(3220),
    [anon_sym_on] = ACTIONS(3220),
    [sym__ternary_qmark] = ACTIONS(3222),
  },
  [944] = {
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_in] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_GT] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3224),
    [anon_sym_DOT] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_QMARK_DOT] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_GT_GT] = ACTIONS(3224),
    [anon_sym_GT_GT_GT] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_CARET] = ACTIONS(3226),
    [anon_sym_PIPE] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_PERCENT] = ACTIONS(3226),
    [anon_sym_STAR_STAR] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ] = ACTIONS(3224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_BANG_EQ] = ACTIONS(3224),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3226),
    [anon_sym_GT_EQ] = ACTIONS(3226),
    [anon_sym_QMARK_QMARK] = ACTIONS(3226),
    [anon_sym_instanceof] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [sym_this] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3224),
    [anon_sym_readonly] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_QMARK] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_satisfies] = ACTIONS(3224),
    [anon_sym_infer] = ACTIONS(3224),
    [anon_sym_keyof] = ACTIONS(3224),
    [anon_sym_unknown] = ACTIONS(3224),
    [anon_sym_never] = ACTIONS(3224),
    [anon_sym_object] = ACTIONS(3224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3226),
    [anon_sym_constructor] = ACTIONS(3224),
    [anon_sym_prop] = ACTIONS(3224),
    [anon_sym_id] = ACTIONS(3224),
    [anon_sym_event] = ACTIONS(3224),
    [anon_sym_fn] = ACTIONS(3224),
    [anon_sym_on] = ACTIONS(3224),
    [sym__ternary_qmark] = ACTIONS(3226),
  },
  [945] = {
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_in] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_GT] = ACTIONS(3228),
    [anon_sym_SLASH] = ACTIONS(3228),
    [anon_sym_DOT] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_QMARK_DOT] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3230),
    [anon_sym_PIPE_PIPE] = ACTIONS(3230),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_GT_GT_GT] = ACTIONS(3230),
    [anon_sym_LT_LT] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3228),
    [anon_sym_CARET] = ACTIONS(3230),
    [anon_sym_PIPE] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_PERCENT] = ACTIONS(3230),
    [anon_sym_STAR_STAR] = ACTIONS(3230),
    [anon_sym_LT_EQ] = ACTIONS(3230),
    [anon_sym_EQ_EQ] = ACTIONS(3228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3230),
    [anon_sym_GT_EQ] = ACTIONS(3230),
    [anon_sym_QMARK_QMARK] = ACTIONS(3230),
    [anon_sym_instanceof] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [sym_this] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_null] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_readonly] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_QMARK] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_satisfies] = ACTIONS(3228),
    [anon_sym_infer] = ACTIONS(3228),
    [anon_sym_keyof] = ACTIONS(3228),
    [anon_sym_unknown] = ACTIONS(3228),
    [anon_sym_never] = ACTIONS(3228),
    [anon_sym_object] = ACTIONS(3228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3230),
    [anon_sym_constructor] = ACTIONS(3228),
    [anon_sym_prop] = ACTIONS(3228),
    [anon_sym_id] = ACTIONS(3228),
    [anon_sym_event] = ACTIONS(3228),
    [anon_sym_fn] = ACTIONS(3228),
    [anon_sym_on] = ACTIONS(3228),
    [sym__ternary_qmark] = ACTIONS(3230),
  },
  [946] = {
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_as] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_GT] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_DOT] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_QMARK_DOT] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_GT_GT] = ACTIONS(3232),
    [anon_sym_GT_GT_GT] = ACTIONS(3234),
    [anon_sym_LT_LT] = ACTIONS(3234),
    [anon_sym_AMP] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PIPE] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3234),
    [anon_sym_STAR_STAR] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_EQ_EQ] = ACTIONS(3232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3232),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3234),
    [anon_sym_instanceof] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_this] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_QMARK] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_satisfies] = ACTIONS(3232),
    [anon_sym_infer] = ACTIONS(3232),
    [anon_sym_keyof] = ACTIONS(3232),
    [anon_sym_unknown] = ACTIONS(3232),
    [anon_sym_never] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3234),
    [anon_sym_constructor] = ACTIONS(3232),
    [anon_sym_prop] = ACTIONS(3232),
    [anon_sym_id] = ACTIONS(3232),
    [anon_sym_event] = ACTIONS(3232),
    [anon_sym_fn] = ACTIONS(3232),
    [anon_sym_on] = ACTIONS(3232),
    [sym__ternary_qmark] = ACTIONS(3234),
  },
  [947] = {
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_QMARK_DOT] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_GT_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3238),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_STAR_STAR] = ACTIONS(3238),
    [anon_sym_LT_EQ] = ACTIONS(3238),
    [anon_sym_EQ_EQ] = ACTIONS(3236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3238),
    [anon_sym_BANG_EQ] = ACTIONS(3236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3238),
    [anon_sym_GT_EQ] = ACTIONS(3238),
    [anon_sym_QMARK_QMARK] = ACTIONS(3238),
    [anon_sym_instanceof] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_this] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_satisfies] = ACTIONS(3236),
    [anon_sym_infer] = ACTIONS(3236),
    [anon_sym_keyof] = ACTIONS(3236),
    [anon_sym_unknown] = ACTIONS(3236),
    [anon_sym_never] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3238),
    [anon_sym_constructor] = ACTIONS(3236),
    [anon_sym_prop] = ACTIONS(3236),
    [anon_sym_id] = ACTIONS(3236),
    [anon_sym_event] = ACTIONS(3236),
    [anon_sym_fn] = ACTIONS(3236),
    [anon_sym_on] = ACTIONS(3236),
    [sym__ternary_qmark] = ACTIONS(3238),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3242),
    [anon_sym_typeof] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_async] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3242),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3242),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3242),
    [anon_sym_LT_EQ] = ACTIONS(3242),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3242),
    [anon_sym_GT_EQ] = ACTIONS(3242),
    [anon_sym_QMARK_QMARK] = ACTIONS(3242),
    [anon_sym_instanceof] = ACTIONS(3240),
    [anon_sym_void] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_SQUOTE] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3242),
    [sym_number] = ACTIONS(3242),
    [sym_this] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_null] = ACTIONS(3240),
    [sym_undefined] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_readonly] = ACTIONS(3240),
    [anon_sym_get] = ACTIONS(3240),
    [anon_sym_set] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_any] = ACTIONS(3240),
    [anon_sym_number] = ACTIONS(3240),
    [anon_sym_boolean] = ACTIONS(3240),
    [anon_sym_string] = ACTIONS(3240),
    [anon_sym_symbol] = ACTIONS(3240),
    [anon_sym_abstract] = ACTIONS(3240),
    [anon_sym_satisfies] = ACTIONS(3240),
    [anon_sym_infer] = ACTIONS(3240),
    [anon_sym_keyof] = ACTIONS(3240),
    [anon_sym_unknown] = ACTIONS(3240),
    [anon_sym_never] = ACTIONS(3240),
    [anon_sym_object] = ACTIONS(3240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3242),
    [anon_sym_constructor] = ACTIONS(3240),
    [anon_sym_prop] = ACTIONS(3240),
    [anon_sym_id] = ACTIONS(3240),
    [anon_sym_event] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_on] = ACTIONS(3240),
    [sym__ternary_qmark] = ACTIONS(3242),
  },
  [949] = {
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_typeof] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1407),
    [anon_sym_in] = ACTIONS(1403),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_LBRACK] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_SLASH] = ACTIONS(1403),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_QMARK_DOT] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(1403),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [anon_sym_GT_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_CARET] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1403),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_QMARK_QMARK] = ACTIONS(1407),
    [anon_sym_instanceof] = ACTIONS(1403),
    [anon_sym_void] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_number] = ACTIONS(1407),
    [sym_this] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_undefined] = ACTIONS(1403),
    [anon_sym_static] = ACTIONS(1403),
    [anon_sym_readonly] = ACTIONS(1403),
    [anon_sym_get] = ACTIONS(1403),
    [anon_sym_set] = ACTIONS(1403),
    [anon_sym_QMARK] = ACTIONS(1403),
    [anon_sym_any] = ACTIONS(1403),
    [anon_sym_number] = ACTIONS(1403),
    [anon_sym_boolean] = ACTIONS(1403),
    [anon_sym_string] = ACTIONS(1403),
    [anon_sym_symbol] = ACTIONS(1403),
    [anon_sym_abstract] = ACTIONS(1403),
    [anon_sym_satisfies] = ACTIONS(1403),
    [anon_sym_infer] = ACTIONS(1403),
    [anon_sym_keyof] = ACTIONS(1403),
    [anon_sym_unknown] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_object] = ACTIONS(1403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1407),
    [anon_sym_constructor] = ACTIONS(1403),
    [anon_sym_prop] = ACTIONS(1403),
    [anon_sym_id] = ACTIONS(1403),
    [anon_sym_event] = ACTIONS(1403),
    [anon_sym_fn] = ACTIONS(1403),
    [anon_sym_on] = ACTIONS(1403),
    [sym__ternary_qmark] = ACTIONS(1407),
  },
  [950] = {
    [sym_identifier] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_typeof] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3244),
    [anon_sym_DOT] = ACTIONS(3244),
    [anon_sym_async] = ACTIONS(3244),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3244),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_QMARK_QMARK] = ACTIONS(3246),
    [anon_sym_instanceof] = ACTIONS(3244),
    [anon_sym_void] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3246),
    [sym_number] = ACTIONS(3246),
    [sym_this] = ACTIONS(3244),
    [sym_true] = ACTIONS(3244),
    [sym_false] = ACTIONS(3244),
    [sym_null] = ACTIONS(3244),
    [sym_undefined] = ACTIONS(3244),
    [anon_sym_static] = ACTIONS(3244),
    [anon_sym_readonly] = ACTIONS(3244),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3244),
    [anon_sym_any] = ACTIONS(3244),
    [anon_sym_number] = ACTIONS(3244),
    [anon_sym_boolean] = ACTIONS(3244),
    [anon_sym_string] = ACTIONS(3244),
    [anon_sym_symbol] = ACTIONS(3244),
    [anon_sym_abstract] = ACTIONS(3244),
    [anon_sym_satisfies] = ACTIONS(3244),
    [anon_sym_infer] = ACTIONS(3244),
    [anon_sym_keyof] = ACTIONS(3244),
    [anon_sym_unknown] = ACTIONS(3244),
    [anon_sym_never] = ACTIONS(3244),
    [anon_sym_object] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3246),
    [anon_sym_constructor] = ACTIONS(3244),
    [anon_sym_prop] = ACTIONS(3244),
    [anon_sym_id] = ACTIONS(3244),
    [anon_sym_event] = ACTIONS(3244),
    [anon_sym_fn] = ACTIONS(3244),
    [anon_sym_on] = ACTIONS(3244),
    [sym__ternary_qmark] = ACTIONS(3246),
  },
  [951] = {
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_typeof] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1407),
    [anon_sym_in] = ACTIONS(1403),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_LBRACK] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_SLASH] = ACTIONS(1403),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_QMARK_DOT] = ACTIONS(1407),
    [anon_sym_new] = ACTIONS(1403),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [anon_sym_GT_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_CARET] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1403),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1407),
    [anon_sym_BANG_EQ] = ACTIONS(1403),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1407),
    [anon_sym_GT_EQ] = ACTIONS(1407),
    [anon_sym_QMARK_QMARK] = ACTIONS(1407),
    [anon_sym_instanceof] = ACTIONS(1403),
    [anon_sym_void] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [sym_number] = ACTIONS(1407),
    [sym_this] = ACTIONS(1403),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_undefined] = ACTIONS(1403),
    [anon_sym_static] = ACTIONS(1403),
    [anon_sym_readonly] = ACTIONS(1403),
    [anon_sym_get] = ACTIONS(1403),
    [anon_sym_set] = ACTIONS(1403),
    [anon_sym_QMARK] = ACTIONS(1403),
    [anon_sym_any] = ACTIONS(1403),
    [anon_sym_number] = ACTIONS(1403),
    [anon_sym_boolean] = ACTIONS(1403),
    [anon_sym_string] = ACTIONS(1403),
    [anon_sym_symbol] = ACTIONS(1403),
    [anon_sym_abstract] = ACTIONS(1403),
    [anon_sym_satisfies] = ACTIONS(1403),
    [anon_sym_infer] = ACTIONS(1403),
    [anon_sym_keyof] = ACTIONS(1403),
    [anon_sym_unknown] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_object] = ACTIONS(1403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1407),
    [anon_sym_constructor] = ACTIONS(1403),
    [anon_sym_prop] = ACTIONS(1403),
    [anon_sym_id] = ACTIONS(1403),
    [anon_sym_event] = ACTIONS(1403),
    [anon_sym_fn] = ACTIONS(1403),
    [anon_sym_on] = ACTIONS(1403),
    [sym__ternary_qmark] = ACTIONS(1407),
  },
  [952] = {
    [sym_identifier] = ACTIONS(3248),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_as] = ACTIONS(3248),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3248),
    [anon_sym_GT] = ACTIONS(3248),
    [anon_sym_SLASH] = ACTIONS(3248),
    [anon_sym_DOT] = ACTIONS(3248),
    [anon_sym_async] = ACTIONS(3248),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3248),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3248),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3248),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3248),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_STAR_STAR] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3248),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3248),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_QMARK_QMARK] = ACTIONS(3250),
    [anon_sym_instanceof] = ACTIONS(3248),
    [anon_sym_void] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_this] = ACTIONS(3248),
    [sym_true] = ACTIONS(3248),
    [sym_false] = ACTIONS(3248),
    [sym_null] = ACTIONS(3248),
    [sym_undefined] = ACTIONS(3248),
    [anon_sym_static] = ACTIONS(3248),
    [anon_sym_readonly] = ACTIONS(3248),
    [anon_sym_get] = ACTIONS(3248),
    [anon_sym_set] = ACTIONS(3248),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_any] = ACTIONS(3248),
    [anon_sym_number] = ACTIONS(3248),
    [anon_sym_boolean] = ACTIONS(3248),
    [anon_sym_string] = ACTIONS(3248),
    [anon_sym_symbol] = ACTIONS(3248),
    [anon_sym_abstract] = ACTIONS(3248),
    [anon_sym_satisfies] = ACTIONS(3248),
    [anon_sym_infer] = ACTIONS(3248),
    [anon_sym_keyof] = ACTIONS(3248),
    [anon_sym_unknown] = ACTIONS(3248),
    [anon_sym_never] = ACTIONS(3248),
    [anon_sym_object] = ACTIONS(3248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3250),
    [anon_sym_constructor] = ACTIONS(3248),
    [anon_sym_prop] = ACTIONS(3248),
    [anon_sym_id] = ACTIONS(3248),
    [anon_sym_event] = ACTIONS(3248),
    [anon_sym_fn] = ACTIONS(3248),
    [anon_sym_on] = ACTIONS(3248),
    [sym__ternary_qmark] = ACTIONS(3250),
  },
  [953] = {
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_as] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_in] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_GT] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_DOT] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_QMARK_DOT] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_GT_GT] = ACTIONS(3252),
    [anon_sym_GT_GT_GT] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_CARET] = ACTIONS(3254),
    [anon_sym_PIPE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_STAR_STAR] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ] = ACTIONS(3252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_BANG_EQ] = ACTIONS(3252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3254),
    [anon_sym_GT_EQ] = ACTIONS(3254),
    [anon_sym_QMARK_QMARK] = ACTIONS(3254),
    [anon_sym_instanceof] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_this] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_QMARK] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_satisfies] = ACTIONS(3252),
    [anon_sym_infer] = ACTIONS(3252),
    [anon_sym_keyof] = ACTIONS(3252),
    [anon_sym_unknown] = ACTIONS(3252),
    [anon_sym_never] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3254),
    [anon_sym_constructor] = ACTIONS(3252),
    [anon_sym_prop] = ACTIONS(3252),
    [anon_sym_id] = ACTIONS(3252),
    [anon_sym_event] = ACTIONS(3252),
    [anon_sym_fn] = ACTIONS(3252),
    [anon_sym_on] = ACTIONS(3252),
    [sym__ternary_qmark] = ACTIONS(3254),
  },
  [954] = {
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_as] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_typeof] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1429),
    [anon_sym_QMARK_DOT] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_QMARK_QMARK] = ACTIONS(1433),
    [anon_sym_instanceof] = ACTIONS(1429),
    [anon_sym_void] = ACTIONS(1429),
    [anon_sym_PLUS_PLUS] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1433),
    [anon_sym_DQUOTE] = ACTIONS(1433),
    [anon_sym_SQUOTE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1433),
    [sym_number] = ACTIONS(1433),
    [sym_this] = ACTIONS(1429),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [sym_null] = ACTIONS(1429),
    [sym_undefined] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_get] = ACTIONS(1429),
    [anon_sym_set] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_any] = ACTIONS(1429),
    [anon_sym_number] = ACTIONS(1429),
    [anon_sym_boolean] = ACTIONS(1429),
    [anon_sym_string] = ACTIONS(1429),
    [anon_sym_symbol] = ACTIONS(1429),
    [anon_sym_abstract] = ACTIONS(1429),
    [anon_sym_satisfies] = ACTIONS(1429),
    [anon_sym_infer] = ACTIONS(1429),
    [anon_sym_keyof] = ACTIONS(1429),
    [anon_sym_unknown] = ACTIONS(1429),
    [anon_sym_never] = ACTIONS(1429),
    [anon_sym_object] = ACTIONS(1429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1433),
    [anon_sym_constructor] = ACTIONS(1429),
    [anon_sym_prop] = ACTIONS(1429),
    [anon_sym_id] = ACTIONS(1429),
    [anon_sym_event] = ACTIONS(1429),
    [anon_sym_fn] = ACTIONS(1429),
    [anon_sym_on] = ACTIONS(1429),
    [sym__ternary_qmark] = ACTIONS(1433),
  },
  [955] = {
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_async] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3258),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3258),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_STAR_STAR] = ACTIONS(3258),
    [anon_sym_LT_EQ] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3258),
    [anon_sym_GT_EQ] = ACTIONS(3258),
    [anon_sym_QMARK_QMARK] = ACTIONS(3258),
    [anon_sym_instanceof] = ACTIONS(3256),
    [anon_sym_void] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_this] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_null] = ACTIONS(3256),
    [sym_undefined] = ACTIONS(3256),
    [anon_sym_static] = ACTIONS(3256),
    [anon_sym_readonly] = ACTIONS(3256),
    [anon_sym_get] = ACTIONS(3256),
    [anon_sym_set] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_any] = ACTIONS(3256),
    [anon_sym_number] = ACTIONS(3256),
    [anon_sym_boolean] = ACTIONS(3256),
    [anon_sym_string] = ACTIONS(3256),
    [anon_sym_symbol] = ACTIONS(3256),
    [anon_sym_abstract] = ACTIONS(3256),
    [anon_sym_satisfies] = ACTIONS(3256),
    [anon_sym_infer] = ACTIONS(3256),
    [anon_sym_keyof] = ACTIONS(3256),
    [anon_sym_unknown] = ACTIONS(3256),
    [anon_sym_never] = ACTIONS(3256),
    [anon_sym_object] = ACTIONS(3256),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3258),
    [anon_sym_constructor] = ACTIONS(3256),
    [anon_sym_prop] = ACTIONS(3256),
    [anon_sym_id] = ACTIONS(3256),
    [anon_sym_event] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_on] = ACTIONS(3256),
    [sym__ternary_qmark] = ACTIONS(3258),
  },
  [956] = {
    [sym_identifier] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1469),
    [anon_sym_as] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(1469),
    [anon_sym_BANG] = ACTIONS(1469),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_LT] = ACTIONS(1469),
    [anon_sym_GT] = ACTIONS(1469),
    [anon_sym_SLASH] = ACTIONS(1469),
    [anon_sym_DOT] = ACTIONS(1469),
    [anon_sym_async] = ACTIONS(1469),
    [anon_sym_QMARK_DOT] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1469),
    [anon_sym_AMP_AMP] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1469),
    [anon_sym_GT_GT_GT] = ACTIONS(1473),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_PERCENT] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1473),
    [anon_sym_LT_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1473),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_QMARK_QMARK] = ACTIONS(1473),
    [anon_sym_instanceof] = ACTIONS(1469),
    [anon_sym_void] = ACTIONS(1469),
    [anon_sym_PLUS_PLUS] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1473),
    [anon_sym_DQUOTE] = ACTIONS(1473),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1473),
    [sym_number] = ACTIONS(1473),
    [sym_this] = ACTIONS(1469),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_undefined] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1469),
    [anon_sym_set] = ACTIONS(1469),
    [anon_sym_QMARK] = ACTIONS(1469),
    [anon_sym_any] = ACTIONS(1469),
    [anon_sym_number] = ACTIONS(1469),
    [anon_sym_boolean] = ACTIONS(1469),
    [anon_sym_string] = ACTIONS(1469),
    [anon_sym_symbol] = ACTIONS(1469),
    [anon_sym_abstract] = ACTIONS(1469),
    [anon_sym_satisfies] = ACTIONS(1469),
    [anon_sym_infer] = ACTIONS(1469),
    [anon_sym_keyof] = ACTIONS(1469),
    [anon_sym_unknown] = ACTIONS(1469),
    [anon_sym_never] = ACTIONS(1469),
    [anon_sym_object] = ACTIONS(1469),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1473),
    [anon_sym_constructor] = ACTIONS(1469),
    [anon_sym_prop] = ACTIONS(1469),
    [anon_sym_id] = ACTIONS(1469),
    [anon_sym_event] = ACTIONS(1469),
    [anon_sym_fn] = ACTIONS(1469),
    [anon_sym_on] = ACTIONS(1469),
    [sym__ternary_qmark] = ACTIONS(1473),
  },
  [957] = {
    [sym_identifier] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_as] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1423),
    [anon_sym_typeof] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1419),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_SLASH] = ACTIONS(1419),
    [anon_sym_DOT] = ACTIONS(1419),
    [anon_sym_async] = ACTIONS(1419),
    [anon_sym_QMARK_DOT] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1419),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_PIPE_PIPE] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_GT_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1423),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_PLUS] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1419),
    [anon_sym_PERCENT] = ACTIONS(1423),
    [anon_sym_STAR_STAR] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1423),
    [anon_sym_EQ_EQ] = ACTIONS(1419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1423),
    [anon_sym_BANG_EQ] = ACTIONS(1419),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1423),
    [anon_sym_GT_EQ] = ACTIONS(1423),
    [anon_sym_QMARK_QMARK] = ACTIONS(1423),
    [anon_sym_instanceof] = ACTIONS(1419),
    [anon_sym_void] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1423),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [anon_sym_SQUOTE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1423),
    [sym_number] = ACTIONS(1423),
    [sym_this] = ACTIONS(1419),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(1419),
    [anon_sym_readonly] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(1419),
    [anon_sym_set] = ACTIONS(1419),
    [anon_sym_QMARK] = ACTIONS(1419),
    [anon_sym_any] = ACTIONS(1419),
    [anon_sym_number] = ACTIONS(1419),
    [anon_sym_boolean] = ACTIONS(1419),
    [anon_sym_string] = ACTIONS(1419),
    [anon_sym_symbol] = ACTIONS(1419),
    [anon_sym_abstract] = ACTIONS(1419),
    [anon_sym_satisfies] = ACTIONS(1419),
    [anon_sym_infer] = ACTIONS(1419),
    [anon_sym_keyof] = ACTIONS(1419),
    [anon_sym_unknown] = ACTIONS(1419),
    [anon_sym_never] = ACTIONS(1419),
    [anon_sym_object] = ACTIONS(1419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1423),
    [anon_sym_constructor] = ACTIONS(1419),
    [anon_sym_prop] = ACTIONS(1419),
    [anon_sym_id] = ACTIONS(1419),
    [anon_sym_event] = ACTIONS(1419),
    [anon_sym_fn] = ACTIONS(1419),
    [anon_sym_on] = ACTIONS(1419),
    [sym__ternary_qmark] = ACTIONS(1423),
  },
  [958] = {
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_QMARK_DOT] = ACTIONS(2991),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_STAR_STAR] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2989),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_instanceof] = ACTIONS(2989),
    [anon_sym_void] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2991),
    [sym_number] = ACTIONS(2991),
    [sym_this] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_null] = ACTIONS(2989),
    [sym_undefined] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(2989),
    [anon_sym_infer] = ACTIONS(2989),
    [anon_sym_keyof] = ACTIONS(2989),
    [anon_sym_unknown] = ACTIONS(2989),
    [anon_sym_never] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2991),
    [anon_sym_constructor] = ACTIONS(2989),
    [anon_sym_prop] = ACTIONS(2989),
    [anon_sym_id] = ACTIONS(2989),
    [anon_sym_event] = ACTIONS(2989),
    [anon_sym_fn] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [sym__ternary_qmark] = ACTIONS(2991),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_as] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_DOT] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3260),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_STAR_STAR] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK] = ACTIONS(3262),
    [anon_sym_instanceof] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_this] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_QMARK] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_satisfies] = ACTIONS(3260),
    [anon_sym_infer] = ACTIONS(3260),
    [anon_sym_keyof] = ACTIONS(3260),
    [anon_sym_unknown] = ACTIONS(3260),
    [anon_sym_never] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3262),
    [anon_sym_constructor] = ACTIONS(3260),
    [anon_sym_prop] = ACTIONS(3260),
    [anon_sym_id] = ACTIONS(3260),
    [anon_sym_event] = ACTIONS(3260),
    [anon_sym_fn] = ACTIONS(3260),
    [anon_sym_on] = ACTIONS(3260),
    [sym__ternary_qmark] = ACTIONS(3262),
  },
  [960] = {
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_as] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_typeof] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1271),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_QMARK_DOT] = ACTIONS(1275),
    [anon_sym_new] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_GT_GT_GT] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1275),
    [anon_sym_QMARK_QMARK] = ACTIONS(1275),
    [anon_sym_instanceof] = ACTIONS(1271),
    [anon_sym_void] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1275),
    [sym_number] = ACTIONS(1275),
    [sym_this] = ACTIONS(1271),
    [sym_true] = ACTIONS(1271),
    [sym_false] = ACTIONS(1271),
    [sym_null] = ACTIONS(1271),
    [sym_undefined] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1271),
    [anon_sym_readonly] = ACTIONS(1271),
    [anon_sym_get] = ACTIONS(1271),
    [anon_sym_set] = ACTIONS(1271),
    [anon_sym_QMARK] = ACTIONS(1271),
    [anon_sym_any] = ACTIONS(1271),
    [anon_sym_number] = ACTIONS(1271),
    [anon_sym_boolean] = ACTIONS(1271),
    [anon_sym_string] = ACTIONS(1271),
    [anon_sym_symbol] = ACTIONS(1271),
    [anon_sym_abstract] = ACTIONS(1271),
    [anon_sym_satisfies] = ACTIONS(1271),
    [anon_sym_infer] = ACTIONS(1271),
    [anon_sym_keyof] = ACTIONS(1271),
    [anon_sym_unknown] = ACTIONS(1271),
    [anon_sym_never] = ACTIONS(1271),
    [anon_sym_object] = ACTIONS(1271),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1275),
    [anon_sym_constructor] = ACTIONS(1271),
    [anon_sym_prop] = ACTIONS(1271),
    [anon_sym_id] = ACTIONS(1271),
    [anon_sym_event] = ACTIONS(1271),
    [anon_sym_fn] = ACTIONS(1271),
    [anon_sym_on] = ACTIONS(1271),
    [sym__ternary_qmark] = ACTIONS(1275),
  },
  [961] = {
    [sym_identifier] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_as] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_typeof] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1293),
    [anon_sym_QMARK_DOT] = ACTIONS(1297),
    [anon_sym_new] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_GT_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_STAR] = ACTIONS(1297),
    [anon_sym_LT_EQ] = ACTIONS(1297),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1297),
    [anon_sym_BANG_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1297),
    [anon_sym_GT_EQ] = ACTIONS(1297),
    [anon_sym_QMARK_QMARK] = ACTIONS(1297),
    [anon_sym_instanceof] = ACTIONS(1293),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1297),
    [anon_sym_DQUOTE] = ACTIONS(1297),
    [anon_sym_SQUOTE] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1297),
    [sym_number] = ACTIONS(1297),
    [sym_this] = ACTIONS(1293),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [sym_null] = ACTIONS(1293),
    [sym_undefined] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_QMARK] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_abstract] = ACTIONS(1293),
    [anon_sym_satisfies] = ACTIONS(1293),
    [anon_sym_infer] = ACTIONS(1293),
    [anon_sym_keyof] = ACTIONS(1293),
    [anon_sym_unknown] = ACTIONS(1293),
    [anon_sym_never] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1297),
    [anon_sym_constructor] = ACTIONS(1293),
    [anon_sym_prop] = ACTIONS(1293),
    [anon_sym_id] = ACTIONS(1293),
    [anon_sym_event] = ACTIONS(1293),
    [anon_sym_fn] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [sym__ternary_qmark] = ACTIONS(1297),
  },
  [962] = {
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1457),
    [anon_sym_as] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_typeof] = ACTIONS(1457),
    [anon_sym_BANG] = ACTIONS(1457),
    [anon_sym_LPAREN] = ACTIONS(1461),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_SLASH] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1457),
    [anon_sym_async] = ACTIONS(1457),
    [anon_sym_QMARK_DOT] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1457),
    [anon_sym_AMP_AMP] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1461),
    [anon_sym_GT_GT] = ACTIONS(1457),
    [anon_sym_GT_GT_GT] = ACTIONS(1461),
    [anon_sym_LT_LT] = ACTIONS(1461),
    [anon_sym_AMP] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PERCENT] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1461),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_QMARK_QMARK] = ACTIONS(1461),
    [anon_sym_instanceof] = ACTIONS(1457),
    [anon_sym_void] = ACTIONS(1457),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_number] = ACTIONS(1461),
    [sym_this] = ACTIONS(1457),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [sym_null] = ACTIONS(1457),
    [sym_undefined] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_get] = ACTIONS(1457),
    [anon_sym_set] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_any] = ACTIONS(1457),
    [anon_sym_number] = ACTIONS(1457),
    [anon_sym_boolean] = ACTIONS(1457),
    [anon_sym_string] = ACTIONS(1457),
    [anon_sym_symbol] = ACTIONS(1457),
    [anon_sym_abstract] = ACTIONS(1457),
    [anon_sym_satisfies] = ACTIONS(1457),
    [anon_sym_infer] = ACTIONS(1457),
    [anon_sym_keyof] = ACTIONS(1457),
    [anon_sym_unknown] = ACTIONS(1457),
    [anon_sym_never] = ACTIONS(1457),
    [anon_sym_object] = ACTIONS(1457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1461),
    [anon_sym_constructor] = ACTIONS(1457),
    [anon_sym_prop] = ACTIONS(1457),
    [anon_sym_id] = ACTIONS(1457),
    [anon_sym_event] = ACTIONS(1457),
    [anon_sym_fn] = ACTIONS(1457),
    [anon_sym_on] = ACTIONS(1457),
    [sym__ternary_qmark] = ACTIONS(1461),
  },
  [963] = {
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_DOT] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3264),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_STAR_STAR] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3264),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK] = ACTIONS(3266),
    [anon_sym_instanceof] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_this] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_QMARK] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_satisfies] = ACTIONS(3264),
    [anon_sym_infer] = ACTIONS(3264),
    [anon_sym_keyof] = ACTIONS(3264),
    [anon_sym_unknown] = ACTIONS(3264),
    [anon_sym_never] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3266),
    [anon_sym_constructor] = ACTIONS(3264),
    [anon_sym_prop] = ACTIONS(3264),
    [anon_sym_id] = ACTIONS(3264),
    [anon_sym_event] = ACTIONS(3264),
    [anon_sym_fn] = ACTIONS(3264),
    [anon_sym_on] = ACTIONS(3264),
    [sym__ternary_qmark] = ACTIONS(3266),
  },
  [964] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_as] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1355),
    [anon_sym_LBRACK] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_QMARK_DOT] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1351),
    [anon_sym_GT_GT_GT] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1355),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_QMARK_QMARK] = ACTIONS(1355),
    [anon_sym_instanceof] = ACTIONS(1351),
    [anon_sym_void] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1355),
    [sym_number] = ACTIONS(1355),
    [sym_this] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_undefined] = ACTIONS(1351),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_readonly] = ACTIONS(1351),
    [anon_sym_get] = ACTIONS(1351),
    [anon_sym_set] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_any] = ACTIONS(1351),
    [anon_sym_number] = ACTIONS(1351),
    [anon_sym_boolean] = ACTIONS(1351),
    [anon_sym_string] = ACTIONS(1351),
    [anon_sym_symbol] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_satisfies] = ACTIONS(1351),
    [anon_sym_infer] = ACTIONS(1351),
    [anon_sym_keyof] = ACTIONS(1351),
    [anon_sym_unknown] = ACTIONS(1351),
    [anon_sym_never] = ACTIONS(1351),
    [anon_sym_object] = ACTIONS(1351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1355),
    [anon_sym_constructor] = ACTIONS(1351),
    [anon_sym_prop] = ACTIONS(1351),
    [anon_sym_id] = ACTIONS(1351),
    [anon_sym_event] = ACTIONS(1351),
    [anon_sym_fn] = ACTIONS(1351),
    [anon_sym_on] = ACTIONS(1351),
    [sym__ternary_qmark] = ACTIONS(1355),
  },
  [965] = {
    [sym_identifier] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1397),
    [anon_sym_as] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_typeof] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1399),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [anon_sym_LT] = ACTIONS(1397),
    [anon_sym_GT] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1397),
    [anon_sym_QMARK_DOT] = ACTIONS(1399),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_PIPE_PIPE] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_GT_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1397),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PERCENT] = ACTIONS(1399),
    [anon_sym_STAR_STAR] = ACTIONS(1399),
    [anon_sym_LT_EQ] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1399),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1399),
    [anon_sym_GT_EQ] = ACTIONS(1399),
    [anon_sym_QMARK_QMARK] = ACTIONS(1399),
    [anon_sym_instanceof] = ACTIONS(1397),
    [anon_sym_void] = ACTIONS(1397),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1399),
    [sym_number] = ACTIONS(1399),
    [sym_this] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_get] = ACTIONS(1397),
    [anon_sym_set] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1397),
    [anon_sym_any] = ACTIONS(1397),
    [anon_sym_number] = ACTIONS(1397),
    [anon_sym_boolean] = ACTIONS(1397),
    [anon_sym_string] = ACTIONS(1397),
    [anon_sym_symbol] = ACTIONS(1397),
    [anon_sym_abstract] = ACTIONS(1397),
    [anon_sym_satisfies] = ACTIONS(1397),
    [anon_sym_infer] = ACTIONS(1397),
    [anon_sym_keyof] = ACTIONS(1397),
    [anon_sym_unknown] = ACTIONS(1397),
    [anon_sym_never] = ACTIONS(1397),
    [anon_sym_object] = ACTIONS(1397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1399),
    [anon_sym_constructor] = ACTIONS(1397),
    [anon_sym_prop] = ACTIONS(1397),
    [anon_sym_id] = ACTIONS(1397),
    [anon_sym_event] = ACTIONS(1397),
    [anon_sym_fn] = ACTIONS(1397),
    [anon_sym_on] = ACTIONS(1397),
    [sym__ternary_qmark] = ACTIONS(1399),
  },
  [966] = {
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_async] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3258),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3258),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_STAR_STAR] = ACTIONS(3258),
    [anon_sym_LT_EQ] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3258),
    [anon_sym_GT_EQ] = ACTIONS(3258),
    [anon_sym_QMARK_QMARK] = ACTIONS(3258),
    [anon_sym_instanceof] = ACTIONS(3256),
    [anon_sym_void] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_this] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_null] = ACTIONS(3256),
    [sym_undefined] = ACTIONS(3256),
    [anon_sym_static] = ACTIONS(3256),
    [anon_sym_readonly] = ACTIONS(3256),
    [anon_sym_get] = ACTIONS(3256),
    [anon_sym_set] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_any] = ACTIONS(3256),
    [anon_sym_number] = ACTIONS(3256),
    [anon_sym_boolean] = ACTIONS(3256),
    [anon_sym_string] = ACTIONS(3256),
    [anon_sym_symbol] = ACTIONS(3256),
    [anon_sym_abstract] = ACTIONS(3256),
    [anon_sym_satisfies] = ACTIONS(3256),
    [anon_sym_infer] = ACTIONS(3256),
    [anon_sym_keyof] = ACTIONS(3256),
    [anon_sym_unknown] = ACTIONS(3256),
    [anon_sym_never] = ACTIONS(3256),
    [anon_sym_object] = ACTIONS(3256),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3258),
    [anon_sym_constructor] = ACTIONS(3256),
    [anon_sym_prop] = ACTIONS(3256),
    [anon_sym_id] = ACTIONS(3256),
    [anon_sym_event] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_on] = ACTIONS(3256),
    [sym__ternary_qmark] = ACTIONS(3258),
  },
  [967] = {
    [sym_identifier] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_as] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1333),
    [anon_sym_QMARK_DOT] = ACTIONS(1337),
    [anon_sym_new] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_GT_GT_GT] = ACTIONS(1337),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_QMARK_QMARK] = ACTIONS(1337),
    [anon_sym_instanceof] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1337),
    [anon_sym_DQUOTE] = ACTIONS(1337),
    [anon_sym_SQUOTE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1337),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(1333),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [sym_null] = ACTIONS(1333),
    [sym_undefined] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_readonly] = ACTIONS(1333),
    [anon_sym_get] = ACTIONS(1333),
    [anon_sym_set] = ACTIONS(1333),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [anon_sym_abstract] = ACTIONS(1333),
    [anon_sym_satisfies] = ACTIONS(1333),
    [anon_sym_infer] = ACTIONS(1333),
    [anon_sym_keyof] = ACTIONS(1333),
    [anon_sym_unknown] = ACTIONS(1333),
    [anon_sym_never] = ACTIONS(1333),
    [anon_sym_object] = ACTIONS(1333),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1337),
    [anon_sym_constructor] = ACTIONS(1333),
    [anon_sym_prop] = ACTIONS(1333),
    [anon_sym_id] = ACTIONS(1333),
    [anon_sym_event] = ACTIONS(1333),
    [anon_sym_fn] = ACTIONS(1333),
    [anon_sym_on] = ACTIONS(1333),
    [sym__ternary_qmark] = ACTIONS(1337),
  },
  [968] = {
    [sym_identifier] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_as] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_in] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_QMARK_DOT] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1453),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_GT_GT_GT] = ACTIONS(1453),
    [anon_sym_LT_LT] = ACTIONS(1453),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_CARET] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_LT_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_BANG_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1453),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_QMARK_QMARK] = ACTIONS(1453),
    [anon_sym_instanceof] = ACTIONS(1451),
    [anon_sym_void] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1453),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1451),
    [sym_true] = ACTIONS(1451),
    [sym_false] = ACTIONS(1451),
    [sym_null] = ACTIONS(1451),
    [sym_undefined] = ACTIONS(1451),
    [anon_sym_static] = ACTIONS(1451),
    [anon_sym_readonly] = ACTIONS(1451),
    [anon_sym_get] = ACTIONS(1451),
    [anon_sym_set] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(1451),
    [anon_sym_any] = ACTIONS(1451),
    [anon_sym_number] = ACTIONS(1451),
    [anon_sym_boolean] = ACTIONS(1451),
    [anon_sym_string] = ACTIONS(1451),
    [anon_sym_symbol] = ACTIONS(1451),
    [anon_sym_abstract] = ACTIONS(1451),
    [anon_sym_satisfies] = ACTIONS(1451),
    [anon_sym_infer] = ACTIONS(1451),
    [anon_sym_keyof] = ACTIONS(1451),
    [anon_sym_unknown] = ACTIONS(1451),
    [anon_sym_never] = ACTIONS(1451),
    [anon_sym_object] = ACTIONS(1451),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1453),
    [anon_sym_constructor] = ACTIONS(1451),
    [anon_sym_prop] = ACTIONS(1451),
    [anon_sym_id] = ACTIONS(1451),
    [anon_sym_event] = ACTIONS(1451),
    [anon_sym_fn] = ACTIONS(1451),
    [anon_sym_on] = ACTIONS(1451),
    [sym__ternary_qmark] = ACTIONS(1453),
  },
  [969] = {
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_as] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1375),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_LPAREN] = ACTIONS(1379),
    [anon_sym_in] = ACTIONS(1375),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1375),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_QMARK_DOT] = ACTIONS(1379),
    [anon_sym_new] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1375),
    [anon_sym_GT_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_QMARK_QMARK] = ACTIONS(1379),
    [anon_sym_instanceof] = ACTIONS(1375),
    [anon_sym_void] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [sym_this] = ACTIONS(1375),
    [sym_true] = ACTIONS(1375),
    [sym_false] = ACTIONS(1375),
    [sym_null] = ACTIONS(1375),
    [sym_undefined] = ACTIONS(1375),
    [anon_sym_static] = ACTIONS(1375),
    [anon_sym_readonly] = ACTIONS(1375),
    [anon_sym_get] = ACTIONS(1375),
    [anon_sym_set] = ACTIONS(1375),
    [anon_sym_QMARK] = ACTIONS(1375),
    [anon_sym_any] = ACTIONS(1375),
    [anon_sym_number] = ACTIONS(1375),
    [anon_sym_boolean] = ACTIONS(1375),
    [anon_sym_string] = ACTIONS(1375),
    [anon_sym_symbol] = ACTIONS(1375),
    [anon_sym_abstract] = ACTIONS(1375),
    [anon_sym_satisfies] = ACTIONS(1375),
    [anon_sym_infer] = ACTIONS(1375),
    [anon_sym_keyof] = ACTIONS(1375),
    [anon_sym_unknown] = ACTIONS(1375),
    [anon_sym_never] = ACTIONS(1375),
    [anon_sym_object] = ACTIONS(1375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1379),
    [anon_sym_constructor] = ACTIONS(1375),
    [anon_sym_prop] = ACTIONS(1375),
    [anon_sym_id] = ACTIONS(1375),
    [anon_sym_event] = ACTIONS(1375),
    [anon_sym_fn] = ACTIONS(1375),
    [anon_sym_on] = ACTIONS(1375),
    [sym__ternary_qmark] = ACTIONS(1379),
  },
  [970] = {
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(2401),
    [anon_sym_as] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_GT] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_GT_GT] = ACTIONS(2401),
    [anon_sym_GT_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(2403),
    [anon_sym_AMP] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2403),
    [anon_sym_STAR_STAR] = ACTIONS(2403),
    [anon_sym_LT_EQ] = ACTIONS(2403),
    [anon_sym_EQ_EQ] = ACTIONS(2401),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2403),
    [anon_sym_BANG_EQ] = ACTIONS(2401),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2403),
    [anon_sym_GT_EQ] = ACTIONS(2403),
    [anon_sym_QMARK_QMARK] = ACTIONS(2403),
    [anon_sym_instanceof] = ACTIONS(2401),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_satisfies] = ACTIONS(2401),
    [anon_sym_infer] = ACTIONS(2401),
    [anon_sym_keyof] = ACTIONS(2401),
    [anon_sym_unknown] = ACTIONS(2401),
    [anon_sym_never] = ACTIONS(2401),
    [anon_sym_object] = ACTIONS(2401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2403),
    [anon_sym_constructor] = ACTIONS(2401),
    [anon_sym_prop] = ACTIONS(2401),
    [anon_sym_id] = ACTIONS(2401),
    [anon_sym_event] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_on] = ACTIONS(2401),
    [sym__ternary_qmark] = ACTIONS(2403),
  },
  [971] = {
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(2329),
    [anon_sym_as] = ACTIONS(2329),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2329),
    [anon_sym_LPAREN] = ACTIONS(2331),
    [anon_sym_in] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_LBRACK] = ACTIONS(2331),
    [anon_sym_LT] = ACTIONS(2329),
    [anon_sym_GT] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(2329),
    [anon_sym_DOT] = ACTIONS(2329),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_QMARK_DOT] = ACTIONS(2331),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2331),
    [anon_sym_PIPE_PIPE] = ACTIONS(2331),
    [anon_sym_GT_GT] = ACTIONS(2329),
    [anon_sym_GT_GT_GT] = ACTIONS(2331),
    [anon_sym_LT_LT] = ACTIONS(2331),
    [anon_sym_AMP] = ACTIONS(2329),
    [anon_sym_CARET] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(2329),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_PERCENT] = ACTIONS(2331),
    [anon_sym_STAR_STAR] = ACTIONS(2331),
    [anon_sym_LT_EQ] = ACTIONS(2331),
    [anon_sym_EQ_EQ] = ACTIONS(2329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2331),
    [anon_sym_BANG_EQ] = ACTIONS(2329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2331),
    [anon_sym_GT_EQ] = ACTIONS(2331),
    [anon_sym_QMARK_QMARK] = ACTIONS(2331),
    [anon_sym_instanceof] = ACTIONS(2329),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2331),
    [anon_sym_DASH_DASH] = ACTIONS(2331),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_get] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(2329),
    [anon_sym_QMARK] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_satisfies] = ACTIONS(2329),
    [anon_sym_infer] = ACTIONS(2329),
    [anon_sym_keyof] = ACTIONS(2329),
    [anon_sym_unknown] = ACTIONS(2329),
    [anon_sym_never] = ACTIONS(2329),
    [anon_sym_object] = ACTIONS(2329),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2331),
    [anon_sym_constructor] = ACTIONS(2329),
    [anon_sym_prop] = ACTIONS(2329),
    [anon_sym_id] = ACTIONS(2329),
    [anon_sym_event] = ACTIONS(2329),
    [anon_sym_fn] = ACTIONS(2329),
    [anon_sym_on] = ACTIONS(2329),
    [sym__ternary_qmark] = ACTIONS(2331),
  },
  [972] = {
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_as] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_DOT] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_STAR_STAR] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_QMARK_QMARK] = ACTIONS(3270),
    [anon_sym_instanceof] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3270),
    [sym_number] = ACTIONS(3270),
    [sym_this] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_QMARK] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_satisfies] = ACTIONS(3268),
    [anon_sym_infer] = ACTIONS(3268),
    [anon_sym_keyof] = ACTIONS(3268),
    [anon_sym_unknown] = ACTIONS(3268),
    [anon_sym_never] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3270),
    [anon_sym_constructor] = ACTIONS(3268),
    [anon_sym_prop] = ACTIONS(3268),
    [anon_sym_id] = ACTIONS(3268),
    [anon_sym_event] = ACTIONS(3268),
    [anon_sym_fn] = ACTIONS(3268),
    [anon_sym_on] = ACTIONS(3268),
    [sym__ternary_qmark] = ACTIONS(3270),
  },
  [973] = {
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_as] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_GT] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_DOT] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3272),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3272),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_STAR_STAR] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_QMARK_QMARK] = ACTIONS(3274),
    [anon_sym_instanceof] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_this] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_satisfies] = ACTIONS(3272),
    [anon_sym_infer] = ACTIONS(3272),
    [anon_sym_keyof] = ACTIONS(3272),
    [anon_sym_unknown] = ACTIONS(3272),
    [anon_sym_never] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3274),
    [anon_sym_constructor] = ACTIONS(3272),
    [anon_sym_prop] = ACTIONS(3272),
    [anon_sym_id] = ACTIONS(3272),
    [anon_sym_event] = ACTIONS(3272),
    [anon_sym_fn] = ACTIONS(3272),
    [anon_sym_on] = ACTIONS(3272),
    [sym__ternary_qmark] = ACTIONS(3274),
  },
  [974] = {
    [sym_identifier] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3276),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3276),
    [anon_sym_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_in] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3276),
    [anon_sym_DOT] = ACTIONS(3276),
    [anon_sym_async] = ACTIONS(3276),
    [anon_sym_QMARK_DOT] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_PIPE_PIPE] = ACTIONS(3278),
    [anon_sym_GT_GT] = ACTIONS(3276),
    [anon_sym_GT_GT_GT] = ACTIONS(3278),
    [anon_sym_LT_LT] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_CARET] = ACTIONS(3278),
    [anon_sym_PIPE] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3278),
    [anon_sym_STAR_STAR] = ACTIONS(3278),
    [anon_sym_LT_EQ] = ACTIONS(3278),
    [anon_sym_EQ_EQ] = ACTIONS(3276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3278),
    [anon_sym_BANG_EQ] = ACTIONS(3276),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3278),
    [anon_sym_GT_EQ] = ACTIONS(3278),
    [anon_sym_QMARK_QMARK] = ACTIONS(3278),
    [anon_sym_instanceof] = ACTIONS(3276),
    [anon_sym_void] = ACTIONS(3276),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_this] = ACTIONS(3276),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_undefined] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_readonly] = ACTIONS(3276),
    [anon_sym_get] = ACTIONS(3276),
    [anon_sym_set] = ACTIONS(3276),
    [anon_sym_QMARK] = ACTIONS(3276),
    [anon_sym_any] = ACTIONS(3276),
    [anon_sym_number] = ACTIONS(3276),
    [anon_sym_boolean] = ACTIONS(3276),
    [anon_sym_string] = ACTIONS(3276),
    [anon_sym_symbol] = ACTIONS(3276),
    [anon_sym_abstract] = ACTIONS(3276),
    [anon_sym_satisfies] = ACTIONS(3276),
    [anon_sym_infer] = ACTIONS(3276),
    [anon_sym_keyof] = ACTIONS(3276),
    [anon_sym_unknown] = ACTIONS(3276),
    [anon_sym_never] = ACTIONS(3276),
    [anon_sym_object] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3278),
    [anon_sym_constructor] = ACTIONS(3276),
    [anon_sym_prop] = ACTIONS(3276),
    [anon_sym_id] = ACTIONS(3276),
    [anon_sym_event] = ACTIONS(3276),
    [anon_sym_fn] = ACTIONS(3276),
    [anon_sym_on] = ACTIONS(3276),
    [sym__ternary_qmark] = ACTIONS(3278),
  },
  [975] = {
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(3280),
    [anon_sym_as] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_typeof] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3282),
    [anon_sym_in] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_DOT] = ACTIONS(3280),
    [anon_sym_async] = ACTIONS(3280),
    [anon_sym_QMARK_DOT] = ACTIONS(3282),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_AMP_AMP] = ACTIONS(3282),
    [anon_sym_PIPE_PIPE] = ACTIONS(3282),
    [anon_sym_GT_GT] = ACTIONS(3280),
    [anon_sym_GT_GT_GT] = ACTIONS(3282),
    [anon_sym_LT_LT] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3280),
    [anon_sym_CARET] = ACTIONS(3282),
    [anon_sym_PIPE] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3282),
    [anon_sym_STAR_STAR] = ACTIONS(3282),
    [anon_sym_LT_EQ] = ACTIONS(3282),
    [anon_sym_EQ_EQ] = ACTIONS(3280),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3282),
    [anon_sym_BANG_EQ] = ACTIONS(3280),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3282),
    [anon_sym_GT_EQ] = ACTIONS(3282),
    [anon_sym_QMARK_QMARK] = ACTIONS(3282),
    [anon_sym_instanceof] = ACTIONS(3280),
    [anon_sym_void] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3282),
    [anon_sym_DASH_DASH] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3282),
    [sym_number] = ACTIONS(3282),
    [sym_this] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_readonly] = ACTIONS(3280),
    [anon_sym_get] = ACTIONS(3280),
    [anon_sym_set] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(3280),
    [anon_sym_any] = ACTIONS(3280),
    [anon_sym_number] = ACTIONS(3280),
    [anon_sym_boolean] = ACTIONS(3280),
    [anon_sym_string] = ACTIONS(3280),
    [anon_sym_symbol] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(3280),
    [anon_sym_satisfies] = ACTIONS(3280),
    [anon_sym_infer] = ACTIONS(3280),
    [anon_sym_keyof] = ACTIONS(3280),
    [anon_sym_unknown] = ACTIONS(3280),
    [anon_sym_never] = ACTIONS(3280),
    [anon_sym_object] = ACTIONS(3280),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3282),
    [anon_sym_constructor] = ACTIONS(3280),
    [anon_sym_prop] = ACTIONS(3280),
    [anon_sym_id] = ACTIONS(3280),
    [anon_sym_event] = ACTIONS(3280),
    [anon_sym_fn] = ACTIONS(3280),
    [anon_sym_on] = ACTIONS(3280),
    [sym__ternary_qmark] = ACTIONS(3282),
  },
  [976] = {
    [sym_identifier] = ACTIONS(3284),
    [anon_sym_STAR] = ACTIONS(3284),
    [anon_sym_as] = ACTIONS(3284),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3286),
    [anon_sym_typeof] = ACTIONS(3284),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_in] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_LBRACK] = ACTIONS(3286),
    [anon_sym_LT] = ACTIONS(3284),
    [anon_sym_GT] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3284),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_async] = ACTIONS(3284),
    [anon_sym_QMARK_DOT] = ACTIONS(3286),
    [anon_sym_new] = ACTIONS(3284),
    [anon_sym_AMP_AMP] = ACTIONS(3286),
    [anon_sym_PIPE_PIPE] = ACTIONS(3286),
    [anon_sym_GT_GT] = ACTIONS(3284),
    [anon_sym_GT_GT_GT] = ACTIONS(3286),
    [anon_sym_LT_LT] = ACTIONS(3286),
    [anon_sym_AMP] = ACTIONS(3284),
    [anon_sym_CARET] = ACTIONS(3286),
    [anon_sym_PIPE] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3284),
    [anon_sym_PERCENT] = ACTIONS(3286),
    [anon_sym_STAR_STAR] = ACTIONS(3286),
    [anon_sym_LT_EQ] = ACTIONS(3286),
    [anon_sym_EQ_EQ] = ACTIONS(3284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ] = ACTIONS(3284),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3286),
    [anon_sym_GT_EQ] = ACTIONS(3286),
    [anon_sym_QMARK_QMARK] = ACTIONS(3286),
    [anon_sym_instanceof] = ACTIONS(3284),
    [anon_sym_void] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3286),
    [anon_sym_DASH_DASH] = ACTIONS(3286),
    [anon_sym_DQUOTE] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(3286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3286),
    [sym_number] = ACTIONS(3286),
    [sym_this] = ACTIONS(3284),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_static] = ACTIONS(3284),
    [anon_sym_readonly] = ACTIONS(3284),
    [anon_sym_get] = ACTIONS(3284),
    [anon_sym_set] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3284),
    [anon_sym_any] = ACTIONS(3284),
    [anon_sym_number] = ACTIONS(3284),
    [anon_sym_boolean] = ACTIONS(3284),
    [anon_sym_string] = ACTIONS(3284),
    [anon_sym_symbol] = ACTIONS(3284),
    [anon_sym_abstract] = ACTIONS(3284),
    [anon_sym_satisfies] = ACTIONS(3284),
    [anon_sym_infer] = ACTIONS(3284),
    [anon_sym_keyof] = ACTIONS(3284),
    [anon_sym_unknown] = ACTIONS(3284),
    [anon_sym_never] = ACTIONS(3284),
    [anon_sym_object] = ACTIONS(3284),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3286),
    [anon_sym_constructor] = ACTIONS(3284),
    [anon_sym_prop] = ACTIONS(3284),
    [anon_sym_id] = ACTIONS(3284),
    [anon_sym_event] = ACTIONS(3284),
    [anon_sym_fn] = ACTIONS(3284),
    [anon_sym_on] = ACTIONS(3284),
    [sym__ternary_qmark] = ACTIONS(3286),
  },
  [977] = {
    [sym_identifier] = ACTIONS(3288),
    [anon_sym_STAR] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(3288),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_typeof] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_in] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3288),
    [anon_sym_GT] = ACTIONS(3288),
    [anon_sym_SLASH] = ACTIONS(3288),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_QMARK_DOT] = ACTIONS(3290),
    [anon_sym_new] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3290),
    [anon_sym_PIPE_PIPE] = ACTIONS(3290),
    [anon_sym_GT_GT] = ACTIONS(3288),
    [anon_sym_GT_GT_GT] = ACTIONS(3290),
    [anon_sym_LT_LT] = ACTIONS(3290),
    [anon_sym_AMP] = ACTIONS(3288),
    [anon_sym_CARET] = ACTIONS(3290),
    [anon_sym_PIPE] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [anon_sym_PERCENT] = ACTIONS(3290),
    [anon_sym_STAR_STAR] = ACTIONS(3290),
    [anon_sym_LT_EQ] = ACTIONS(3290),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3290),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3290),
    [anon_sym_GT_EQ] = ACTIONS(3290),
    [anon_sym_QMARK_QMARK] = ACTIONS(3290),
    [anon_sym_instanceof] = ACTIONS(3288),
    [anon_sym_void] = ACTIONS(3288),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3290),
    [sym_number] = ACTIONS(3290),
    [sym_this] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_null] = ACTIONS(3288),
    [sym_undefined] = ACTIONS(3288),
    [anon_sym_static] = ACTIONS(3288),
    [anon_sym_readonly] = ACTIONS(3288),
    [anon_sym_get] = ACTIONS(3288),
    [anon_sym_set] = ACTIONS(3288),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_any] = ACTIONS(3288),
    [anon_sym_number] = ACTIONS(3288),
    [anon_sym_boolean] = ACTIONS(3288),
    [anon_sym_string] = ACTIONS(3288),
    [anon_sym_symbol] = ACTIONS(3288),
    [anon_sym_abstract] = ACTIONS(3288),
    [anon_sym_satisfies] = ACTIONS(3288),
    [anon_sym_infer] = ACTIONS(3288),
    [anon_sym_keyof] = ACTIONS(3288),
    [anon_sym_unknown] = ACTIONS(3288),
    [anon_sym_never] = ACTIONS(3288),
    [anon_sym_object] = ACTIONS(3288),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3290),
    [anon_sym_constructor] = ACTIONS(3288),
    [anon_sym_prop] = ACTIONS(3288),
    [anon_sym_id] = ACTIONS(3288),
    [anon_sym_event] = ACTIONS(3288),
    [anon_sym_fn] = ACTIONS(3288),
    [anon_sym_on] = ACTIONS(3288),
    [sym__ternary_qmark] = ACTIONS(3290),
  },
  [978] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_typeof] = ACTIONS(2387),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2387),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2389),
    [anon_sym_SQUOTE] = ACTIONS(2389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2389),
    [sym_number] = ACTIONS(2389),
    [sym_this] = ACTIONS(2387),
    [sym_true] = ACTIONS(2387),
    [sym_false] = ACTIONS(2387),
    [sym_null] = ACTIONS(2387),
    [sym_undefined] = ACTIONS(2387),
    [anon_sym_static] = ACTIONS(2387),
    [anon_sym_readonly] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_any] = ACTIONS(2387),
    [anon_sym_number] = ACTIONS(2387),
    [anon_sym_boolean] = ACTIONS(2387),
    [anon_sym_string] = ACTIONS(2387),
    [anon_sym_symbol] = ACTIONS(2387),
    [anon_sym_abstract] = ACTIONS(2387),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2387),
    [anon_sym_keyof] = ACTIONS(2387),
    [anon_sym_unknown] = ACTIONS(2387),
    [anon_sym_never] = ACTIONS(2387),
    [anon_sym_object] = ACTIONS(2387),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2389),
    [anon_sym_prop] = ACTIONS(2387),
    [anon_sym_id] = ACTIONS(2387),
    [anon_sym_event] = ACTIONS(2387),
    [anon_sym_fn] = ACTIONS(2387),
    [anon_sym_on] = ACTIONS(2387),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [979] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_typeof] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2273),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_number] = ACTIONS(2279),
    [sym_this] = ACTIONS(2273),
    [sym_true] = ACTIONS(2273),
    [sym_false] = ACTIONS(2273),
    [sym_null] = ACTIONS(2273),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_static] = ACTIONS(2273),
    [anon_sym_readonly] = ACTIONS(2273),
    [anon_sym_QMARK] = ACTIONS(2273),
    [anon_sym_any] = ACTIONS(2273),
    [anon_sym_number] = ACTIONS(2273),
    [anon_sym_boolean] = ACTIONS(2273),
    [anon_sym_string] = ACTIONS(2273),
    [anon_sym_symbol] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2273),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2273),
    [anon_sym_keyof] = ACTIONS(2273),
    [anon_sym_unknown] = ACTIONS(2273),
    [anon_sym_never] = ACTIONS(2273),
    [anon_sym_object] = ACTIONS(2273),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2279),
    [anon_sym_prop] = ACTIONS(2273),
    [anon_sym_id] = ACTIONS(2273),
    [anon_sym_event] = ACTIONS(2273),
    [anon_sym_fn] = ACTIONS(2273),
    [anon_sym_on] = ACTIONS(2273),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [980] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2383),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2385),
    [anon_sym_typeof] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2383),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2383),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2385),
    [sym_number] = ACTIONS(2385),
    [sym_this] = ACTIONS(2383),
    [sym_true] = ACTIONS(2383),
    [sym_false] = ACTIONS(2383),
    [sym_null] = ACTIONS(2383),
    [sym_undefined] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2383),
    [anon_sym_readonly] = ACTIONS(2383),
    [anon_sym_QMARK] = ACTIONS(2383),
    [anon_sym_any] = ACTIONS(2383),
    [anon_sym_number] = ACTIONS(2383),
    [anon_sym_boolean] = ACTIONS(2383),
    [anon_sym_string] = ACTIONS(2383),
    [anon_sym_symbol] = ACTIONS(2383),
    [anon_sym_abstract] = ACTIONS(2383),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2383),
    [anon_sym_keyof] = ACTIONS(2383),
    [anon_sym_unknown] = ACTIONS(2383),
    [anon_sym_never] = ACTIONS(2383),
    [anon_sym_object] = ACTIONS(2383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2385),
    [anon_sym_prop] = ACTIONS(2383),
    [anon_sym_id] = ACTIONS(2383),
    [anon_sym_event] = ACTIONS(2383),
    [anon_sym_fn] = ACTIONS(2383),
    [anon_sym_on] = ACTIONS(2383),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [981] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2453),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [sym_number] = ACTIONS(2455),
    [sym_this] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_undefined] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_readonly] = ACTIONS(2453),
    [anon_sym_QMARK] = ACTIONS(2453),
    [anon_sym_any] = ACTIONS(2453),
    [anon_sym_number] = ACTIONS(2453),
    [anon_sym_boolean] = ACTIONS(2453),
    [anon_sym_string] = ACTIONS(2453),
    [anon_sym_symbol] = ACTIONS(2453),
    [anon_sym_abstract] = ACTIONS(2453),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2453),
    [anon_sym_keyof] = ACTIONS(2453),
    [anon_sym_unknown] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_object] = ACTIONS(2453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2455),
    [anon_sym_prop] = ACTIONS(2453),
    [anon_sym_id] = ACTIONS(2453),
    [anon_sym_event] = ACTIONS(2453),
    [anon_sym_fn] = ACTIONS(2453),
    [anon_sym_on] = ACTIONS(2453),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [982] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [983] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [984] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [985] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_typeof] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [sym_number] = ACTIONS(2343),
    [sym_this] = ACTIONS(2341),
    [sym_true] = ACTIONS(2341),
    [sym_false] = ACTIONS(2341),
    [sym_null] = ACTIONS(2341),
    [sym_undefined] = ACTIONS(2341),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_abstract] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2341),
    [anon_sym_keyof] = ACTIONS(2341),
    [anon_sym_unknown] = ACTIONS(2341),
    [anon_sym_never] = ACTIONS(2341),
    [anon_sym_object] = ACTIONS(2341),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2343),
    [anon_sym_prop] = ACTIONS(2341),
    [anon_sym_id] = ACTIONS(2341),
    [anon_sym_event] = ACTIONS(2341),
    [anon_sym_fn] = ACTIONS(2341),
    [anon_sym_on] = ACTIONS(2341),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [986] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2397),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [sym_number] = ACTIONS(2399),
    [sym_this] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_null] = ACTIONS(2397),
    [sym_undefined] = ACTIONS(2397),
    [anon_sym_static] = ACTIONS(2397),
    [anon_sym_readonly] = ACTIONS(2397),
    [anon_sym_QMARK] = ACTIONS(2397),
    [anon_sym_any] = ACTIONS(2397),
    [anon_sym_number] = ACTIONS(2397),
    [anon_sym_boolean] = ACTIONS(2397),
    [anon_sym_string] = ACTIONS(2397),
    [anon_sym_symbol] = ACTIONS(2397),
    [anon_sym_abstract] = ACTIONS(2397),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2397),
    [anon_sym_keyof] = ACTIONS(2397),
    [anon_sym_unknown] = ACTIONS(2397),
    [anon_sym_never] = ACTIONS(2397),
    [anon_sym_object] = ACTIONS(2397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2399),
    [anon_sym_prop] = ACTIONS(2397),
    [anon_sym_id] = ACTIONS(2397),
    [anon_sym_event] = ACTIONS(2397),
    [anon_sym_fn] = ACTIONS(2397),
    [anon_sym_on] = ACTIONS(2397),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [987] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(2339),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [988] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2359),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_number] = ACTIONS(2359),
    [sym_this] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_QMARK] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2357),
    [anon_sym_keyof] = ACTIONS(2357),
    [anon_sym_unknown] = ACTIONS(2357),
    [anon_sym_never] = ACTIONS(2357),
    [anon_sym_object] = ACTIONS(2357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2359),
    [anon_sym_prop] = ACTIONS(2357),
    [anon_sym_id] = ACTIONS(2357),
    [anon_sym_event] = ACTIONS(2357),
    [anon_sym_fn] = ACTIONS(2357),
    [anon_sym_on] = ACTIONS(2357),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [989] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [990] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [991] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [992] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [993] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2369),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [sym_this] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [sym_false] = ACTIONS(2369),
    [sym_null] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_readonly] = ACTIONS(2369),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2369),
    [anon_sym_keyof] = ACTIONS(2369),
    [anon_sym_unknown] = ACTIONS(2369),
    [anon_sym_never] = ACTIONS(2369),
    [anon_sym_object] = ACTIONS(2369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2371),
    [anon_sym_prop] = ACTIONS(2369),
    [anon_sym_id] = ACTIONS(2369),
    [anon_sym_event] = ACTIONS(2369),
    [anon_sym_fn] = ACTIONS(2369),
    [anon_sym_on] = ACTIONS(2369),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [994] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_typeof] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2353),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2355),
    [anon_sym_SQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2353),
    [sym_true] = ACTIONS(2353),
    [sym_false] = ACTIONS(2353),
    [sym_null] = ACTIONS(2353),
    [sym_undefined] = ACTIONS(2353),
    [anon_sym_static] = ACTIONS(2353),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_QMARK] = ACTIONS(2353),
    [anon_sym_any] = ACTIONS(2353),
    [anon_sym_number] = ACTIONS(2353),
    [anon_sym_boolean] = ACTIONS(2353),
    [anon_sym_string] = ACTIONS(2353),
    [anon_sym_symbol] = ACTIONS(2353),
    [anon_sym_abstract] = ACTIONS(2353),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2353),
    [anon_sym_keyof] = ACTIONS(2353),
    [anon_sym_unknown] = ACTIONS(2353),
    [anon_sym_never] = ACTIONS(2353),
    [anon_sym_object] = ACTIONS(2353),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2355),
    [anon_sym_prop] = ACTIONS(2353),
    [anon_sym_id] = ACTIONS(2353),
    [anon_sym_event] = ACTIONS(2353),
    [anon_sym_fn] = ACTIONS(2353),
    [anon_sym_on] = ACTIONS(2353),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [995] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_typeof] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2429),
    [sym_number] = ACTIONS(2429),
    [sym_this] = ACTIONS(2427),
    [sym_true] = ACTIONS(2427),
    [sym_false] = ACTIONS(2427),
    [sym_null] = ACTIONS(2427),
    [sym_undefined] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2427),
    [anon_sym_readonly] = ACTIONS(2427),
    [anon_sym_QMARK] = ACTIONS(2427),
    [anon_sym_any] = ACTIONS(2427),
    [anon_sym_number] = ACTIONS(2427),
    [anon_sym_boolean] = ACTIONS(2427),
    [anon_sym_string] = ACTIONS(2427),
    [anon_sym_symbol] = ACTIONS(2427),
    [anon_sym_abstract] = ACTIONS(2427),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2427),
    [anon_sym_keyof] = ACTIONS(2427),
    [anon_sym_unknown] = ACTIONS(2427),
    [anon_sym_never] = ACTIONS(2427),
    [anon_sym_object] = ACTIONS(2427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2429),
    [anon_sym_prop] = ACTIONS(2427),
    [anon_sym_id] = ACTIONS(2427),
    [anon_sym_event] = ACTIONS(2427),
    [anon_sym_fn] = ACTIONS(2427),
    [anon_sym_on] = ACTIONS(2427),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [996] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_QMARK] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2329),
    [anon_sym_keyof] = ACTIONS(2329),
    [anon_sym_unknown] = ACTIONS(2329),
    [anon_sym_never] = ACTIONS(2329),
    [anon_sym_object] = ACTIONS(2329),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2331),
    [anon_sym_prop] = ACTIONS(2329),
    [anon_sym_id] = ACTIONS(2329),
    [anon_sym_event] = ACTIONS(2329),
    [anon_sym_fn] = ACTIONS(2329),
    [anon_sym_on] = ACTIONS(2329),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [997] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [998] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_QMARK] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2401),
    [anon_sym_keyof] = ACTIONS(2401),
    [anon_sym_unknown] = ACTIONS(2401),
    [anon_sym_never] = ACTIONS(2401),
    [anon_sym_object] = ACTIONS(2401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2403),
    [anon_sym_prop] = ACTIONS(2401),
    [anon_sym_id] = ACTIONS(2401),
    [anon_sym_event] = ACTIONS(2401),
    [anon_sym_fn] = ACTIONS(2401),
    [anon_sym_on] = ACTIONS(2401),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [999] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2365),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2365),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_number] = ACTIONS(2367),
    [sym_this] = ACTIONS(2365),
    [sym_true] = ACTIONS(2365),
    [sym_false] = ACTIONS(2365),
    [sym_null] = ACTIONS(2365),
    [sym_undefined] = ACTIONS(2365),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_QMARK] = ACTIONS(2365),
    [anon_sym_any] = ACTIONS(2365),
    [anon_sym_number] = ACTIONS(2365),
    [anon_sym_boolean] = ACTIONS(2365),
    [anon_sym_string] = ACTIONS(2365),
    [anon_sym_symbol] = ACTIONS(2365),
    [anon_sym_abstract] = ACTIONS(2365),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2365),
    [anon_sym_keyof] = ACTIONS(2365),
    [anon_sym_unknown] = ACTIONS(2365),
    [anon_sym_never] = ACTIONS(2365),
    [anon_sym_object] = ACTIONS(2365),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2367),
    [anon_sym_prop] = ACTIONS(2365),
    [anon_sym_id] = ACTIONS(2365),
    [anon_sym_event] = ACTIONS(2365),
    [anon_sym_fn] = ACTIONS(2365),
    [anon_sym_on] = ACTIONS(2365),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [1000] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_PERCENT] = ACTIONS(2339),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [1001] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_GT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(2337),
    [anon_sym_GT_GT_GT] = ACTIONS(2339),
    [anon_sym_LT_LT] = ACTIONS(2339),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(2339),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [1002] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3298),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_abstract] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(2315),
    [anon_sym_infer] = ACTIONS(2405),
    [anon_sym_keyof] = ACTIONS(2405),
    [anon_sym_unknown] = ACTIONS(2405),
    [anon_sym_never] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2407),
    [anon_sym_prop] = ACTIONS(2405),
    [anon_sym_id] = ACTIONS(2405),
    [anon_sym_event] = ACTIONS(2405),
    [anon_sym_fn] = ACTIONS(2405),
    [anon_sym_on] = ACTIONS(2405),
    [sym__ternary_qmark] = ACTIONS(3324),
  },
  [1003] = {
    [sym_optional_chain] = STATE(3840),
    [sym_arguments] = STATE(947),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_QMARK_DOT] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_AMP_AMP] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE] = ACTIONS(2339),
    [anon_sym_GT_GT] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_PIPE] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_STAR_STAR] = ACTIONS(3314),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(2337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2339),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(2339),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_satisfies] = ACTIONS(2337),
    [anon_sym_infer] = ACTIONS(2337),
    [anon_sym_keyof] = ACTIONS(2337),
    [anon_sym_unknown] = ACTIONS(2337),
    [anon_sym_never] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2339),
    [anon_sym_prop] = ACTIONS(2337),
    [anon_sym_id] = ACTIONS(2337),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_fn] = ACTIONS(2337),
    [anon_sym_on] = ACTIONS(2337),
    [sym__ternary_qmark] = ACTIONS(2339),
  },
  [1004] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_as] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_typeof] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_GT_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2564),
    [anon_sym_STAR_STAR] = ACTIONS(2564),
    [anon_sym_LT_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_BANG_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2564),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_QMARK_QMARK] = ACTIONS(2564),
    [anon_sym_instanceof] = ACTIONS(2562),
    [anon_sym_void] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_regex_flags] = ACTIONS(2566),
    [sym_number] = ACTIONS(2564),
    [sym_this] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_null] = ACTIONS(2562),
    [sym_undefined] = ACTIONS(2562),
    [anon_sym_static] = ACTIONS(2562),
    [anon_sym_readonly] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_any] = ACTIONS(2562),
    [anon_sym_number] = ACTIONS(2562),
    [anon_sym_boolean] = ACTIONS(2562),
    [anon_sym_string] = ACTIONS(2562),
    [anon_sym_symbol] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_satisfies] = ACTIONS(2562),
    [anon_sym_infer] = ACTIONS(2562),
    [anon_sym_keyof] = ACTIONS(2562),
    [anon_sym_unknown] = ACTIONS(2562),
    [anon_sym_never] = ACTIONS(2562),
    [anon_sym_object] = ACTIONS(2562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2564),
    [anon_sym_prop] = ACTIONS(2562),
    [anon_sym_id] = ACTIONS(2562),
    [anon_sym_event] = ACTIONS(2562),
    [anon_sym_fn] = ACTIONS(2562),
    [anon_sym_on] = ACTIONS(2562),
    [sym__ternary_qmark] = ACTIONS(2564),
  },
  [1005] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3704),
    [sym_optional_tuple_parameter] = STATE(3704),
    [sym_optional_type] = STATE(3704),
    [sym_rest_type] = STATE(3704),
    [sym__tuple_type_member] = STATE(3704),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1006] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3894),
    [sym_optional_tuple_parameter] = STATE(3894),
    [sym_optional_type] = STATE(3894),
    [sym_rest_type] = STATE(3894),
    [sym__tuple_type_member] = STATE(3894),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1007] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3931),
    [sym_optional_tuple_parameter] = STATE(3931),
    [sym_optional_type] = STATE(3931),
    [sym_rest_type] = STATE(3931),
    [sym__tuple_type_member] = STATE(3931),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1008] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3736),
    [sym_optional_tuple_parameter] = STATE(3736),
    [sym_optional_type] = STATE(3736),
    [sym_rest_type] = STATE(3736),
    [sym__tuple_type_member] = STATE(3736),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1009] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3796),
    [sym_optional_tuple_parameter] = STATE(3796),
    [sym_optional_type] = STATE(3796),
    [sym_rest_type] = STATE(3796),
    [sym__tuple_type_member] = STATE(3796),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1010] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(3852),
    [sym_optional_tuple_parameter] = STATE(3852),
    [sym_optional_type] = STATE(3852),
    [sym_rest_type] = STATE(3852),
    [sym__tuple_type_member] = STATE(3852),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1011] = {
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1621),
    [anon_sym_PIPE_PIPE] = ACTIONS(1621),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1621),
    [anon_sym_LT_LT] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1621),
    [anon_sym_STAR_STAR] = ACTIONS(1621),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1621),
    [anon_sym_instanceof] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_readonly] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_satisfies] = ACTIONS(1617),
    [anon_sym_infer] = ACTIONS(1617),
    [anon_sym_keyof] = ACTIONS(1617),
    [anon_sym_unknown] = ACTIONS(1617),
    [anon_sym_never] = ACTIONS(1617),
    [anon_sym_object] = ACTIONS(1617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1621),
    [anon_sym_prop] = ACTIONS(1617),
    [anon_sym_id] = ACTIONS(1617),
    [anon_sym_event] = ACTIONS(1617),
    [anon_sym_fn] = ACTIONS(1617),
    [anon_sym_on] = ACTIONS(1617),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1012] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_export] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1747),
    [anon_sym_typeof] = ACTIONS(1747),
    [anon_sym_import] = ACTIONS(1747),
    [anon_sym_var] = ACTIONS(1747),
    [anon_sym_let] = ACTIONS(1747),
    [anon_sym_const] = ACTIONS(1747),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_switch] = ACTIONS(1747),
    [anon_sym_for] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_while] = ACTIONS(1747),
    [anon_sym_do] = ACTIONS(1747),
    [anon_sym_try] = ACTIONS(1747),
    [anon_sym_with] = ACTIONS(1747),
    [anon_sym_break] = ACTIONS(1747),
    [anon_sym_continue] = ACTIONS(1747),
    [anon_sym_debugger] = ACTIONS(1747),
    [anon_sym_return] = ACTIONS(1747),
    [anon_sym_throw] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_yield] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_LTtemplate_GT] = ACTIONS(1749),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_class] = ACTIONS(1747),
    [anon_sym_async] = ACTIONS(1747),
    [anon_sym_function] = ACTIONS(1747),
    [anon_sym_new] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1749),
    [anon_sym_void] = ACTIONS(1747),
    [anon_sym_delete] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [anon_sym_DQUOTE] = ACTIONS(1749),
    [anon_sym_SQUOTE] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [sym_number] = ACTIONS(1749),
    [sym_this] = ACTIONS(1747),
    [sym_super] = ACTIONS(1747),
    [sym_true] = ACTIONS(1747),
    [sym_false] = ACTIONS(1747),
    [sym_null] = ACTIONS(1747),
    [sym_undefined] = ACTIONS(1747),
    [anon_sym_AT] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1747),
    [anon_sym_readonly] = ACTIONS(1747),
    [anon_sym_get] = ACTIONS(1747),
    [anon_sym_set] = ACTIONS(1747),
    [anon_sym_declare] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1747),
    [anon_sym_public] = ACTIONS(1747),
    [anon_sym_private] = ACTIONS(1747),
    [anon_sym_protected] = ACTIONS(1747),
    [anon_sym_override] = ACTIONS(1747),
    [anon_sym_module] = ACTIONS(1747),
    [anon_sym_any] = ACTIONS(1747),
    [anon_sym_number] = ACTIONS(1747),
    [anon_sym_boolean] = ACTIONS(1747),
    [anon_sym_string] = ACTIONS(1747),
    [anon_sym_symbol] = ACTIONS(1747),
    [anon_sym_abstract] = ACTIONS(1747),
    [anon_sym_interface] = ACTIONS(1747),
    [anon_sym_enum] = ACTIONS(1747),
    [anon_sym_component] = ACTIONS(1747),
  },
  [1015] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3360),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1016] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1017] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1018] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1019] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1020] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1021] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1022] = {
    [sym_identifier] = ACTIONS(1727),
    [anon_sym_export] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_type] = ACTIONS(1727),
    [anon_sym_typeof] = ACTIONS(1727),
    [anon_sym_import] = ACTIONS(1727),
    [anon_sym_var] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(1727),
    [anon_sym_const] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_switch] = ACTIONS(1727),
    [anon_sym_for] = ACTIONS(1727),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_await] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_try] = ACTIONS(1727),
    [anon_sym_with] = ACTIONS(1727),
    [anon_sym_break] = ACTIONS(1727),
    [anon_sym_continue] = ACTIONS(1727),
    [anon_sym_debugger] = ACTIONS(1727),
    [anon_sym_return] = ACTIONS(1727),
    [anon_sym_throw] = ACTIONS(1727),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LTtemplate_GT] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_class] = ACTIONS(1727),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_new] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_DASH] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_delete] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [sym_number] = ACTIONS(1729),
    [sym_this] = ACTIONS(1727),
    [sym_super] = ACTIONS(1727),
    [sym_true] = ACTIONS(1727),
    [sym_false] = ACTIONS(1727),
    [sym_null] = ACTIONS(1727),
    [sym_undefined] = ACTIONS(1727),
    [anon_sym_AT] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1727),
    [anon_sym_readonly] = ACTIONS(1727),
    [anon_sym_get] = ACTIONS(1727),
    [anon_sym_set] = ACTIONS(1727),
    [anon_sym_declare] = ACTIONS(1727),
    [anon_sym_namespace] = ACTIONS(1727),
    [anon_sym_public] = ACTIONS(1727),
    [anon_sym_private] = ACTIONS(1727),
    [anon_sym_protected] = ACTIONS(1727),
    [anon_sym_override] = ACTIONS(1727),
    [anon_sym_module] = ACTIONS(1727),
    [anon_sym_any] = ACTIONS(1727),
    [anon_sym_number] = ACTIONS(1727),
    [anon_sym_boolean] = ACTIONS(1727),
    [anon_sym_string] = ACTIONS(1727),
    [anon_sym_symbol] = ACTIONS(1727),
    [anon_sym_abstract] = ACTIONS(1727),
    [anon_sym_interface] = ACTIONS(1727),
    [anon_sym_enum] = ACTIONS(1727),
    [anon_sym_component] = ACTIONS(1727),
  },
  [1023] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1024] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1025] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1026] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1027] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1028] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1029] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1030] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3376),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1031] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3378),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1032] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3380),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_export] = ACTIONS(3382),
    [anon_sym_LBRACE] = ACTIONS(3384),
    [anon_sym_type] = ACTIONS(3382),
    [anon_sym_typeof] = ACTIONS(3382),
    [anon_sym_import] = ACTIONS(3382),
    [anon_sym_var] = ACTIONS(3382),
    [anon_sym_let] = ACTIONS(3382),
    [anon_sym_const] = ACTIONS(3382),
    [anon_sym_BANG] = ACTIONS(3384),
    [anon_sym_if] = ACTIONS(3382),
    [anon_sym_switch] = ACTIONS(3382),
    [anon_sym_for] = ACTIONS(3382),
    [anon_sym_LPAREN] = ACTIONS(3384),
    [anon_sym_await] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(3382),
    [anon_sym_do] = ACTIONS(3382),
    [anon_sym_try] = ACTIONS(3382),
    [anon_sym_with] = ACTIONS(3382),
    [anon_sym_break] = ACTIONS(3382),
    [anon_sym_continue] = ACTIONS(3382),
    [anon_sym_debugger] = ACTIONS(3382),
    [anon_sym_return] = ACTIONS(3382),
    [anon_sym_throw] = ACTIONS(3382),
    [anon_sym_SEMI] = ACTIONS(3384),
    [anon_sym_yield] = ACTIONS(3382),
    [anon_sym_LBRACK] = ACTIONS(3384),
    [anon_sym_LTtemplate_GT] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3382),
    [anon_sym_SLASH] = ACTIONS(3382),
    [anon_sym_class] = ACTIONS(3382),
    [anon_sym_async] = ACTIONS(3382),
    [anon_sym_function] = ACTIONS(3382),
    [anon_sym_new] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3382),
    [anon_sym_TILDE] = ACTIONS(3384),
    [anon_sym_void] = ACTIONS(3382),
    [anon_sym_delete] = ACTIONS(3382),
    [anon_sym_PLUS_PLUS] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3384),
    [anon_sym_DQUOTE] = ACTIONS(3384),
    [anon_sym_SQUOTE] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3384),
    [sym_number] = ACTIONS(3384),
    [sym_this] = ACTIONS(3382),
    [sym_super] = ACTIONS(3382),
    [sym_true] = ACTIONS(3382),
    [sym_false] = ACTIONS(3382),
    [sym_null] = ACTIONS(3382),
    [sym_undefined] = ACTIONS(3382),
    [anon_sym_AT] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3382),
    [anon_sym_readonly] = ACTIONS(3382),
    [anon_sym_get] = ACTIONS(3382),
    [anon_sym_set] = ACTIONS(3382),
    [anon_sym_declare] = ACTIONS(3382),
    [anon_sym_namespace] = ACTIONS(3382),
    [anon_sym_public] = ACTIONS(3382),
    [anon_sym_private] = ACTIONS(3382),
    [anon_sym_protected] = ACTIONS(3382),
    [anon_sym_override] = ACTIONS(3382),
    [anon_sym_module] = ACTIONS(3382),
    [anon_sym_any] = ACTIONS(3382),
    [anon_sym_number] = ACTIONS(3382),
    [anon_sym_boolean] = ACTIONS(3382),
    [anon_sym_string] = ACTIONS(3382),
    [anon_sym_symbol] = ACTIONS(3382),
    [anon_sym_abstract] = ACTIONS(3382),
    [anon_sym_interface] = ACTIONS(3382),
    [anon_sym_enum] = ACTIONS(3382),
    [anon_sym_component] = ACTIONS(3382),
  },
  [1034] = {
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [anon_sym_component] = ACTIONS(3356),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(3386),
    [anon_sym_export] = ACTIONS(3386),
    [anon_sym_LBRACE] = ACTIONS(3388),
    [anon_sym_type] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3386),
    [anon_sym_import] = ACTIONS(3386),
    [anon_sym_var] = ACTIONS(3386),
    [anon_sym_let] = ACTIONS(3386),
    [anon_sym_const] = ACTIONS(3386),
    [anon_sym_BANG] = ACTIONS(3388),
    [anon_sym_if] = ACTIONS(3386),
    [anon_sym_switch] = ACTIONS(3386),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_LPAREN] = ACTIONS(3388),
    [anon_sym_await] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3386),
    [anon_sym_do] = ACTIONS(3386),
    [anon_sym_try] = ACTIONS(3386),
    [anon_sym_with] = ACTIONS(3386),
    [anon_sym_break] = ACTIONS(3386),
    [anon_sym_continue] = ACTIONS(3386),
    [anon_sym_debugger] = ACTIONS(3386),
    [anon_sym_return] = ACTIONS(3386),
    [anon_sym_throw] = ACTIONS(3386),
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_yield] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [anon_sym_LTtemplate_GT] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3386),
    [anon_sym_SLASH] = ACTIONS(3386),
    [anon_sym_class] = ACTIONS(3386),
    [anon_sym_async] = ACTIONS(3386),
    [anon_sym_function] = ACTIONS(3386),
    [anon_sym_new] = ACTIONS(3386),
    [anon_sym_PLUS] = ACTIONS(3386),
    [anon_sym_DASH] = ACTIONS(3386),
    [anon_sym_TILDE] = ACTIONS(3388),
    [anon_sym_void] = ACTIONS(3386),
    [anon_sym_delete] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3388),
    [anon_sym_DQUOTE] = ACTIONS(3388),
    [anon_sym_SQUOTE] = ACTIONS(3388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3388),
    [sym_number] = ACTIONS(3388),
    [sym_this] = ACTIONS(3386),
    [sym_super] = ACTIONS(3386),
    [sym_true] = ACTIONS(3386),
    [sym_false] = ACTIONS(3386),
    [sym_null] = ACTIONS(3386),
    [sym_undefined] = ACTIONS(3386),
    [anon_sym_AT] = ACTIONS(3388),
    [anon_sym_static] = ACTIONS(3386),
    [anon_sym_readonly] = ACTIONS(3386),
    [anon_sym_get] = ACTIONS(3386),
    [anon_sym_set] = ACTIONS(3386),
    [anon_sym_declare] = ACTIONS(3386),
    [anon_sym_namespace] = ACTIONS(3386),
    [anon_sym_public] = ACTIONS(3386),
    [anon_sym_private] = ACTIONS(3386),
    [anon_sym_protected] = ACTIONS(3386),
    [anon_sym_override] = ACTIONS(3386),
    [anon_sym_module] = ACTIONS(3386),
    [anon_sym_any] = ACTIONS(3386),
    [anon_sym_number] = ACTIONS(3386),
    [anon_sym_boolean] = ACTIONS(3386),
    [anon_sym_string] = ACTIONS(3386),
    [anon_sym_symbol] = ACTIONS(3386),
    [anon_sym_abstract] = ACTIONS(3386),
    [anon_sym_interface] = ACTIONS(3386),
    [anon_sym_enum] = ACTIONS(3386),
    [anon_sym_component] = ACTIONS(3386),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3390),
    [anon_sym_export] = ACTIONS(3390),
    [anon_sym_LBRACE] = ACTIONS(3392),
    [anon_sym_type] = ACTIONS(3390),
    [anon_sym_typeof] = ACTIONS(3390),
    [anon_sym_import] = ACTIONS(3390),
    [anon_sym_var] = ACTIONS(3390),
    [anon_sym_let] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3392),
    [anon_sym_if] = ACTIONS(3390),
    [anon_sym_switch] = ACTIONS(3390),
    [anon_sym_for] = ACTIONS(3390),
    [anon_sym_LPAREN] = ACTIONS(3392),
    [anon_sym_await] = ACTIONS(3390),
    [anon_sym_while] = ACTIONS(3390),
    [anon_sym_do] = ACTIONS(3390),
    [anon_sym_try] = ACTIONS(3390),
    [anon_sym_with] = ACTIONS(3390),
    [anon_sym_break] = ACTIONS(3390),
    [anon_sym_continue] = ACTIONS(3390),
    [anon_sym_debugger] = ACTIONS(3390),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_throw] = ACTIONS(3390),
    [anon_sym_SEMI] = ACTIONS(3392),
    [anon_sym_yield] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LTtemplate_GT] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3390),
    [anon_sym_SLASH] = ACTIONS(3390),
    [anon_sym_class] = ACTIONS(3390),
    [anon_sym_async] = ACTIONS(3390),
    [anon_sym_function] = ACTIONS(3390),
    [anon_sym_new] = ACTIONS(3390),
    [anon_sym_PLUS] = ACTIONS(3390),
    [anon_sym_DASH] = ACTIONS(3390),
    [anon_sym_TILDE] = ACTIONS(3392),
    [anon_sym_void] = ACTIONS(3390),
    [anon_sym_delete] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3392),
    [anon_sym_DQUOTE] = ACTIONS(3392),
    [anon_sym_SQUOTE] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3392),
    [sym_number] = ACTIONS(3392),
    [sym_this] = ACTIONS(3390),
    [sym_super] = ACTIONS(3390),
    [sym_true] = ACTIONS(3390),
    [sym_false] = ACTIONS(3390),
    [sym_null] = ACTIONS(3390),
    [sym_undefined] = ACTIONS(3390),
    [anon_sym_AT] = ACTIONS(3392),
    [anon_sym_static] = ACTIONS(3390),
    [anon_sym_readonly] = ACTIONS(3390),
    [anon_sym_get] = ACTIONS(3390),
    [anon_sym_set] = ACTIONS(3390),
    [anon_sym_declare] = ACTIONS(3390),
    [anon_sym_namespace] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(3390),
    [anon_sym_private] = ACTIONS(3390),
    [anon_sym_protected] = ACTIONS(3390),
    [anon_sym_override] = ACTIONS(3390),
    [anon_sym_module] = ACTIONS(3390),
    [anon_sym_any] = ACTIONS(3390),
    [anon_sym_number] = ACTIONS(3390),
    [anon_sym_boolean] = ACTIONS(3390),
    [anon_sym_string] = ACTIONS(3390),
    [anon_sym_symbol] = ACTIONS(3390),
    [anon_sym_abstract] = ACTIONS(3390),
    [anon_sym_interface] = ACTIONS(3390),
    [anon_sym_enum] = ACTIONS(3390),
    [anon_sym_component] = ACTIONS(3390),
  },
  [1037] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_rest_pattern] = STATE(4043),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3182),
    [sym_tuple_parameter] = STATE(4184),
    [sym_optional_tuple_parameter] = STATE(4184),
    [sym_optional_type] = STATE(4184),
    [sym_rest_type] = STATE(4184),
    [sym__tuple_type_member] = STATE(4184),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1038] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1039] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_type_narrow] = STATE(4058),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
    [anon_sym_prop] = ACTIONS(3417),
    [anon_sym_fn] = ACTIONS(3419),
  },
  [1040] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1041] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1042] = {
    [sym_type_arguments] = STATE(2812),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__automatic_semicolon] = ACTIONS(2200),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1043] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_type_narrow] = STATE(4054),
    [sym_property_expression_initializer] = STATE(1467),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_EQ] = ACTIONS(3446),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1044] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_type_narrow] = STATE(4171),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_COLON] = ACTIONS(3448),
    [anon_sym_EQ] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1045] = {
    [sym_arguments] = STATE(2702),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3454),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(3456),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2347),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__automatic_semicolon] = ACTIONS(2347),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1046] = {
    [sym_type_annotation] = STATE(4200),
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_RBRACK] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3466),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1047] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(3118),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(3118),
    [sym_predefined_type] = STATE(3118),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3118),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_type_narrow] = STATE(4224),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_COLON] = ACTIONS(3469),
    [anon_sym_EQ] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1048] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(691),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1049] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_predicate] = STATE(3510),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(2884),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(3018),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3509),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_asserts] = ACTIONS(3519),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1050] = {
    [sym_arguments] = STATE(2579),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(3531),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1051] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(3533),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_RBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1052] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(691),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1053] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3033),
    [sym_constructor_type] = STATE(3033),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3033),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(4169),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2860),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3033),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3033),
    [sym_identifier] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3545),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_asserts] = ACTIONS(3553),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1054] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2992),
    [sym_constructor_type] = STATE(2992),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2992),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(3278),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2822),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2992),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2992),
    [sym_identifier] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3567),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_asserts] = ACTIONS(3575),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1055] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(691),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1056] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(695),
    [aux_sym_object_repeat1] = STATE(3887),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1057] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(3579),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3579),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_RBRACK] = ACTIONS(3581),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1058] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2696),
    [anon_sym_COMMA] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_type] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2694),
    [anon_sym_import] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2696),
    [anon_sym_await] = ACTIONS(2694),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_RBRACK] = ACTIONS(2696),
    [anon_sym_LTtemplate_GT] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2696),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2694),
    [anon_sym_async] = ACTIONS(2694),
    [anon_sym_function] = ACTIONS(2694),
    [anon_sym_EQ_GT] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2696),
    [anon_sym_PIPE] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2694),
    [anon_sym_delete] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(2696),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2694),
    [sym_super] = ACTIONS(2694),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2696),
    [anon_sym_static] = ACTIONS(2694),
    [anon_sym_readonly] = ACTIONS(2694),
    [anon_sym_get] = ACTIONS(2694),
    [anon_sym_set] = ACTIONS(2694),
    [anon_sym_QMARK] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2694),
    [anon_sym_namespace] = ACTIONS(2694),
    [anon_sym_public] = ACTIONS(2694),
    [anon_sym_private] = ACTIONS(2694),
    [anon_sym_protected] = ACTIONS(2694),
    [anon_sym_override] = ACTIONS(2694),
    [anon_sym_module] = ACTIONS(2694),
    [anon_sym_any] = ACTIONS(2694),
    [anon_sym_number] = ACTIONS(2694),
    [anon_sym_boolean] = ACTIONS(2694),
    [anon_sym_string] = ACTIONS(2694),
    [anon_sym_symbol] = ACTIONS(2694),
    [anon_sym_extends] = ACTIONS(2694),
    [anon_sym_implements] = ACTIONS(2694),
    [anon_sym_component] = ACTIONS(2694),
  },
  [1060] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2997),
    [sym_constructor_type] = STATE(2997),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2997),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(3278),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2815),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2997),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2997),
    [sym_identifier] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3588),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_asserts] = ACTIONS(3590),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_export] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2801),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_type] = ACTIONS(2799),
    [anon_sym_typeof] = ACTIONS(2799),
    [anon_sym_import] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2801),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_await] = ACTIONS(2799),
    [anon_sym_COLON] = ACTIONS(2801),
    [anon_sym_yield] = ACTIONS(2799),
    [anon_sym_EQ] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_RBRACK] = ACTIONS(2801),
    [anon_sym_LTtemplate_GT] = ACTIONS(2801),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2801),
    [anon_sym_SLASH] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_async] = ACTIONS(2799),
    [anon_sym_function] = ACTIONS(2799),
    [anon_sym_EQ_GT] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_PIPE] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_void] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2801),
    [sym_number] = ACTIONS(2801),
    [sym_this] = ACTIONS(2799),
    [sym_super] = ACTIONS(2799),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [sym_null] = ACTIONS(2799),
    [sym_undefined] = ACTIONS(2799),
    [anon_sym_AT] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_readonly] = ACTIONS(2799),
    [anon_sym_get] = ACTIONS(2799),
    [anon_sym_set] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_declare] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_override] = ACTIONS(2799),
    [anon_sym_module] = ACTIONS(2799),
    [anon_sym_any] = ACTIONS(2799),
    [anon_sym_number] = ACTIONS(2799),
    [anon_sym_boolean] = ACTIONS(2799),
    [anon_sym_string] = ACTIONS(2799),
    [anon_sym_symbol] = ACTIONS(2799),
    [anon_sym_extends] = ACTIONS(2799),
    [anon_sym_implements] = ACTIONS(2799),
    [anon_sym_component] = ACTIONS(2799),
  },
  [1062] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3093),
    [sym_constructor_type] = STATE(3093),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3093),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(4169),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2761),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3093),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3093),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3594),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_asserts] = ACTIONS(3596),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1063] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(695),
    [aux_sym_object_repeat1] = STATE(3808),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1064] = {
    [sym_nested_identifier] = STATE(570),
    [sym_string] = STATE(640),
    [sym__module] = STATE(695),
    [aux_sym_object_repeat1] = STATE(3834),
    [aux_sym_object_pattern_repeat1] = STATE(3836),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(23),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_in] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1681),
    [anon_sym_QMARK_DOT] = ACTIONS(62),
    [anon_sym_PLUS_EQ] = ACTIONS(66),
    [anon_sym_DASH_EQ] = ACTIONS(66),
    [anon_sym_STAR_EQ] = ACTIONS(66),
    [anon_sym_SLASH_EQ] = ACTIONS(66),
    [anon_sym_PERCENT_EQ] = ACTIONS(66),
    [anon_sym_CARET_EQ] = ACTIONS(66),
    [anon_sym_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_LT_EQ] = ACTIONS(66),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(66),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(66),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(66),
    [anon_sym_AMP_AMP] = ACTIONS(23),
    [anon_sym_PIPE_PIPE] = ACTIONS(23),
    [anon_sym_GT_GT] = ACTIONS(23),
    [anon_sym_GT_GT_GT] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_PIPE] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PERCENT] = ACTIONS(23),
    [anon_sym_STAR_STAR] = ACTIONS(23),
    [anon_sym_LT_EQ] = ACTIONS(62),
    [anon_sym_EQ_EQ] = ACTIONS(23),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(62),
    [anon_sym_BANG_EQ] = ACTIONS(23),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(62),
    [anon_sym_GT_EQ] = ACTIONS(62),
    [anon_sym_QMARK_QMARK] = ACTIONS(23),
    [anon_sym_instanceof] = ACTIONS(23),
    [anon_sym_PLUS_PLUS] = ACTIONS(62),
    [anon_sym_DASH_DASH] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_satisfies] = ACTIONS(23),
    [sym__automatic_semicolon] = ACTIONS(62),
    [sym__ternary_qmark] = ACTIONS(62),
  },
  [1065] = {
    [sym_identifier] = ACTIONS(3044),
    [anon_sym_export] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_type] = ACTIONS(3044),
    [anon_sym_typeof] = ACTIONS(3044),
    [anon_sym_import] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_LPAREN] = ACTIONS(3046),
    [anon_sym_RPAREN] = ACTIONS(3046),
    [anon_sym_await] = ACTIONS(3044),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_yield] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_RBRACK] = ACTIONS(3046),
    [anon_sym_LTtemplate_GT] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_function] = ACTIONS(3044),
    [anon_sym_EQ_GT] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_PIPE] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_void] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3046),
    [sym_number] = ACTIONS(3046),
    [sym_this] = ACTIONS(3044),
    [sym_super] = ACTIONS(3044),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [sym_null] = ACTIONS(3044),
    [sym_undefined] = ACTIONS(3044),
    [anon_sym_AT] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_readonly] = ACTIONS(3044),
    [anon_sym_get] = ACTIONS(3044),
    [anon_sym_set] = ACTIONS(3044),
    [anon_sym_QMARK] = ACTIONS(3046),
    [anon_sym_declare] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_public] = ACTIONS(3044),
    [anon_sym_private] = ACTIONS(3044),
    [anon_sym_protected] = ACTIONS(3044),
    [anon_sym_override] = ACTIONS(3044),
    [anon_sym_module] = ACTIONS(3044),
    [anon_sym_any] = ACTIONS(3044),
    [anon_sym_number] = ACTIONS(3044),
    [anon_sym_boolean] = ACTIONS(3044),
    [anon_sym_string] = ACTIONS(3044),
    [anon_sym_symbol] = ACTIONS(3044),
    [anon_sym_extends] = ACTIONS(3044),
    [anon_sym_implements] = ACTIONS(3044),
    [anon_sym_component] = ACTIONS(3044),
  },
  [1066] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(3598),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3579),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1067] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3581),
    [anon_sym_EQ] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_RBRACK] = ACTIONS(3581),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1068] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3157),
    [sym_constructor_type] = STATE(3157),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3157),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2602),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(3065),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3157),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3157),
    [sym_identifier] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3609),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1069] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1070] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1559),
    [sym_constructor_type] = STATE(1559),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1559),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_predicate] = STATE(1560),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1514),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1559),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1559),
    [sym_identifier] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3647),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1071] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3663),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1072] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3573),
    [sym_constructor_type] = STATE(3573),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3573),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3573),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3573),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1073] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3667),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1074] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(762),
    [sym_constructor_type] = STATE(762),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(762),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_predicate] = STATE(763),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(659),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(762),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(762),
    [sym_identifier] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3695),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1075] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1076] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(860),
    [sym_constructor_type] = STATE(860),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(860),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_predicate] = STATE(871),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(659),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(860),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(860),
    [sym_identifier] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3695),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1077] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3713),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1078] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1079] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3570),
    [sym_constructor_type] = STATE(3570),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3570),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3570),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3570),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1080] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3689),
    [sym_constructor_type] = STATE(3689),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3689),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3689),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3689),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1081] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3245),
    [sym_constructor_type] = STATE(3245),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3245),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2589),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(3065),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3245),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3245),
    [sym_identifier] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3609),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1082] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2877),
    [sym_constructor_type] = STATE(2877),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2877),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2602),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2860),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2877),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2877),
    [sym_identifier] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3545),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1083] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1084] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1085] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_RBRACK] = ACTIONS(2200),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1086] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1087] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2956),
    [sym_constructor_type] = STATE(2956),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2956),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_predicate] = STATE(2955),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(2884),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2956),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2956),
    [sym_identifier] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3509),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1088] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3249),
    [sym_constructor_type] = STATE(3249),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3249),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_type_parameter] = STATE(3730),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3249),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3249),
    [sym_identifier] = ACTIONS(3729),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1089] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2936),
    [sym_constructor_type] = STATE(2936),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2936),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_predicate] = STATE(2935),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(2884),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2936),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2936),
    [sym_identifier] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3509),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1090] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2903),
    [sym_constructor_type] = STATE(2903),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2903),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(2845),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2815),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2903),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2903),
    [sym_identifier] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3588),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1091] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1834),
    [sym_constructor_type] = STATE(1834),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1834),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_predicate] = STATE(1832),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1766),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1834),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1834),
    [sym_identifier] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3757),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1092] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3651),
    [sym_constructor_type] = STATE(3651),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3651),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3651),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3651),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3773),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1093] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3628),
    [sym_constructor_type] = STATE(3628),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3628),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3628),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3628),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3775),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1094] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3777),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1095] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3779),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1096] = {
    [sym_arguments] = STATE(2579),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(3531),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1097] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2834),
    [sym_constructor_type] = STATE(2834),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2834),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2589),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2761),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2834),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2834),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3594),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1098] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3781),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1099] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3783),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1100] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1101] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2905),
    [sym_constructor_type] = STATE(2905),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2905),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2589),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2860),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2905),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2905),
    [sym_identifier] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3545),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1102] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2809),
    [sym_constructor_type] = STATE(2809),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2809),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_predicate] = STATE(2602),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2761),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2809),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2809),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(3594),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1103] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1529),
    [sym_constructor_type] = STATE(1529),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1529),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_predicate] = STATE(1530),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1514),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1529),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1529),
    [sym_identifier] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3647),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1104] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3621),
    [sym_constructor_type] = STATE(3621),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3621),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3621),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3621),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(3787),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1105] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(3789),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1106] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_RBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1107] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1807),
    [sym_constructor_type] = STATE(1807),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1807),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_predicate] = STATE(1806),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1766),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1807),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1807),
    [sym_identifier] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3757),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1108] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2914),
    [sym_constructor_type] = STATE(2914),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2914),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(2831),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2822),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2914),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2914),
    [sym_identifier] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3567),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1109] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2907),
    [sym_constructor_type] = STATE(2907),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2907),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(2831),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2815),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2907),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2907),
    [sym_identifier] = ACTIONS(3586),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3588),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1110] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2896),
    [sym_constructor_type] = STATE(2896),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2896),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_predicate] = STATE(2845),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2822),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2896),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2896),
    [sym_identifier] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(3567),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1111] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3430),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3793),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_implements] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1112] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3554),
    [sym_constructor_type] = STATE(3554),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3554),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3554),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3554),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1113] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1831),
    [sym_constructor_type] = STATE(1831),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1831),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1831),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1831),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1114] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2592),
    [sym_constructor_type] = STATE(2592),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2592),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2592),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2592),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1115] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1810),
    [sym_constructor_type] = STATE(1810),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1810),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1810),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1810),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1116] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3271),
    [sym_constructor_type] = STATE(3271),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3271),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3271),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3271),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1117] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2596),
    [sym_constructor_type] = STATE(2596),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2596),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2596),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2596),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1118] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3530),
    [sym_constructor_type] = STATE(3530),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3530),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3530),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3530),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1119] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2599),
    [sym_constructor_type] = STATE(2599),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2599),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2599),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2599),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1120] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1621),
    [sym_constructor_type] = STATE(1621),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1621),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1621),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1621),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1121] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1861),
    [sym_constructor_type] = STATE(1861),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1861),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1861),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1861),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1122] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2878),
    [sym_constructor_type] = STATE(2878),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2878),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2878),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2878),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1123] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(717),
    [sym_constructor_type] = STATE(717),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(717),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(717),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(717),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1124] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1868),
    [sym_constructor_type] = STATE(1868),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1868),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1868),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1868),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1125] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(3872),
    [sym_constructor_type] = STATE(3872),
    [sym__primary_type] = STATE(1847),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(3872),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(3872),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(3872),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1126] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3555),
    [sym_constructor_type] = STATE(3555),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3555),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3555),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3555),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1127] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(3872),
    [sym_constructor_type] = STATE(3872),
    [sym__primary_type] = STATE(1849),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(3872),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(3872),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(3872),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1128] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1622),
    [sym_constructor_type] = STATE(1622),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1622),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1622),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1622),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1129] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1850),
    [sym_constructor_type] = STATE(1850),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1850),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1850),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1850),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1130] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1916),
    [sym_constructor_type] = STATE(1916),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1916),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1916),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1916),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1131] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3748),
    [sym_constructor_type] = STATE(3748),
    [sym__primary_type] = STATE(2803),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3748),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3748),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3748),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1132] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1917),
    [sym_constructor_type] = STATE(1917),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1917),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1917),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1917),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1133] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3674),
    [sym_constructor_type] = STATE(3674),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3674),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3674),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3674),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1134] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2601),
    [sym_constructor_type] = STATE(2601),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2601),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2601),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2601),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1135] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3033),
    [sym_constructor_type] = STATE(3033),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3033),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3033),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3033),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1136] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2596),
    [sym_constructor_type] = STATE(2596),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2596),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2596),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2596),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1137] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3748),
    [sym_constructor_type] = STATE(3748),
    [sym__primary_type] = STATE(2804),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3748),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3748),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3748),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1138] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2902),
    [sym_constructor_type] = STATE(2902),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2902),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2902),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2902),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1139] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(719),
    [sym_constructor_type] = STATE(719),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(719),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(719),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(719),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1140] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1141] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2988),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1142] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2987),
    [sym_constructor_type] = STATE(2987),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2987),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2987),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2987),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1143] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2983),
    [sym_constructor_type] = STATE(2983),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2983),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2983),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2983),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1144] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(3936),
    [sym_constructor_type] = STATE(3936),
    [sym__primary_type] = STATE(2982),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(3936),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(3936),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(3936),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1145] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(3936),
    [sym_constructor_type] = STATE(3936),
    [sym__primary_type] = STATE(2976),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(3936),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(3936),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(3936),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1146] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3597),
    [sym_constructor_type] = STATE(3597),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3597),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3597),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3597),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1147] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2953),
    [sym_constructor_type] = STATE(2953),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2953),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2953),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2953),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1148] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1937),
    [sym_constructor_type] = STATE(1937),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1937),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1937),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1937),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1149] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3593),
    [sym_constructor_type] = STATE(3593),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3593),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3593),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3593),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1150] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2951),
    [sym_constructor_type] = STATE(2951),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2951),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2951),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2951),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1151] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2900),
    [sym_constructor_type] = STATE(2900),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2900),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2900),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2900),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1152] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2819),
    [sym_constructor_type] = STATE(2819),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2819),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2819),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2819),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1153] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1854),
    [sym_constructor_type] = STATE(1854),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1854),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1854),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1854),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1154] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1556),
    [sym_constructor_type] = STATE(1556),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1556),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1556),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1556),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1155] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1943),
    [sym_constructor_type] = STATE(1943),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1943),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1943),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1943),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1156] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1855),
    [sym_constructor_type] = STATE(1855),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1855),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1855),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1855),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1157] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(3765),
    [sym_constructor_type] = STATE(3765),
    [sym__primary_type] = STATE(716),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(3765),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(3765),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(3765),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1158] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2938),
    [sym_constructor_type] = STATE(2938),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2938),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2938),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2938),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1159] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2601),
    [sym_constructor_type] = STATE(2601),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2601),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2601),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2601),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1160] = {
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_of] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3817),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1161] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2924),
    [sym_constructor_type] = STATE(2924),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2924),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2924),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2924),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1162] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2923),
    [sym_constructor_type] = STATE(2923),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2923),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2923),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2923),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1163] = {
    [sym_arguments] = STATE(2579),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(3793),
    [anon_sym_QMARK_DOT] = ACTIONS(3531),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2347),
    [anon_sym_implements] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1164] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3622),
    [sym_constructor_type] = STATE(3622),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3622),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3622),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3622),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1165] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(3765),
    [sym_constructor_type] = STATE(3765),
    [sym__primary_type] = STATE(711),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(3765),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(3765),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(3765),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1166] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3600),
    [sym_constructor_type] = STATE(3600),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3600),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3600),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3600),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1167] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3267),
    [sym_constructor_type] = STATE(3267),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3267),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3267),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3267),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1168] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2967),
    [sym_constructor_type] = STATE(2967),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2967),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2967),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2967),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1169] = {
    [sym_type_arguments] = STATE(2584),
    [sym_component_identifier] = STATE(3202),
    [sym_new_component_body] = STATE(1532),
    [sym_tagged_type_string] = STATE(1698),
    [sym_tripple_tagged_type_string] = STATE(1697),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3444),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1170] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3426),
    [sym_constructor_type] = STATE(3426),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3426),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3426),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3426),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1171] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3601),
    [sym_constructor_type] = STATE(3601),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3601),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3601),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3601),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1172] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2888),
    [sym_constructor_type] = STATE(2888),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2888),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2888),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2888),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1173] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2894),
    [sym_constructor_type] = STATE(2894),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2894),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2894),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2894),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1174] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(771),
    [sym_constructor_type] = STATE(771),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(771),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(771),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(771),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1175] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3611),
    [sym_constructor_type] = STATE(3611),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3611),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3611),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3611),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1176] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3618),
    [sym_constructor_type] = STATE(3618),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3618),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3618),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3618),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1177] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3619),
    [sym_constructor_type] = STATE(3619),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3619),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3619),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3619),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1178] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1932),
    [sym_constructor_type] = STATE(1932),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1932),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1932),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1932),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1179] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1598),
    [sym_constructor_type] = STATE(1598),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1598),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1598),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1598),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1180] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2807),
    [sym_constructor_type] = STATE(2807),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2807),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2807),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1181] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2990),
    [sym_constructor_type] = STATE(2990),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2990),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2990),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2990),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1182] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1599),
    [sym_constructor_type] = STATE(1599),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1599),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1599),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1599),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1183] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2603),
    [sym_constructor_type] = STATE(2603),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2603),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2603),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2603),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1184] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3272),
    [sym_constructor_type] = STATE(3272),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3272),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3272),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3272),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1185] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(710),
    [sym_constructor_type] = STATE(710),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(710),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(710),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(710),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1186] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2901),
    [sym_constructor_type] = STATE(2901),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2901),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2901),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2901),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1187] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(818),
    [sym_constructor_type] = STATE(818),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(818),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(818),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(818),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1188] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3596),
    [sym_constructor_type] = STATE(3596),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3596),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3596),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3596),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1189] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(688),
    [sym_constructor_type] = STATE(688),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(688),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(688),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(688),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1190] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3460),
    [sym_constructor_type] = STATE(3460),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3460),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3460),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3460),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1191] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(685),
    [sym_constructor_type] = STATE(685),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(685),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(685),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(685),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1192] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2872),
    [sym_constructor_type] = STATE(2872),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2872),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2872),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2872),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1193] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3387),
    [sym_constructor_type] = STATE(3387),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3387),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3387),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3387),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1194] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3623),
    [sym_constructor_type] = STATE(3623),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3623),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3623),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3623),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1195] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1928),
    [sym_constructor_type] = STATE(1928),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1928),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1928),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1928),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1196] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(777),
    [sym_constructor_type] = STATE(777),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(777),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(777),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(777),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1197] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2909),
    [sym_constructor_type] = STATE(2909),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2909),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2909),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2909),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1198] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2906),
    [sym_constructor_type] = STATE(2906),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2906),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2906),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2906),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1199] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2838),
    [sym_constructor_type] = STATE(2838),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2838),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2838),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2838),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1200] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2837),
    [sym_constructor_type] = STATE(2837),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2837),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2837),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2837),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1201] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2596),
    [sym_constructor_type] = STATE(2596),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2596),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2596),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2596),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1202] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(884),
    [sym_constructor_type] = STATE(884),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(884),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(884),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(884),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1203] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3266),
    [sym_constructor_type] = STATE(3266),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3266),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3266),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3266),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1204] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2867),
    [sym_constructor_type] = STATE(2867),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2867),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2867),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2867),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1205] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2601),
    [sym_constructor_type] = STATE(2601),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2601),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2601),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2601),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1206] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3695),
    [sym_constructor_type] = STATE(3695),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3695),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3695),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3695),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1207] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2863),
    [sym_constructor_type] = STATE(2863),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2863),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2863),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2863),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1208] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3665),
    [sym_constructor_type] = STATE(3665),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3665),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3665),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3665),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1209] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2859),
    [sym_constructor_type] = STATE(2859),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2859),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2859),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2859),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1210] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2856),
    [sym_constructor_type] = STATE(2856),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2856),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2856),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2856),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1211] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1624),
    [sym_constructor_type] = STATE(1624),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1624),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1624),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1624),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1212] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2603),
    [sym_constructor_type] = STATE(2603),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2603),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2603),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2603),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1213] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1781),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1214] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3199),
    [sym_constructor_type] = STATE(3199),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3199),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3199),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3199),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1215] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1216] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1625),
    [sym_constructor_type] = STATE(1625),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1625),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1625),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1625),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1217] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2843),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1218] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2600),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1219] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_of] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(3821),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3817),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1220] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3469),
    [sym_constructor_type] = STATE(3469),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3469),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3469),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3469),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1221] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(2612),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3792),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1222] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3174),
    [sym_constructor_type] = STATE(3174),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3174),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3174),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3174),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1223] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2899),
    [sym_constructor_type] = STATE(2899),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2899),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2899),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2899),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1224] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2858),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2858),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2858),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2858),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1225] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(2980),
    [sym_constructor_type] = STATE(2980),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(2980),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(2980),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(2980),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1226] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3438),
    [sym_constructor_type] = STATE(3438),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3438),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3438),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3438),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1227] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2603),
    [sym_constructor_type] = STATE(2603),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2603),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2603),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2603),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1228] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3017),
    [sym_constructor_type] = STATE(3017),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3017),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3017),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3017),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1229] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3025),
    [sym_constructor_type] = STATE(3025),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3025),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3025),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3025),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1230] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1616),
    [sym_constructor_type] = STATE(1616),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1616),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1616),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1616),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1231] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3253),
    [sym_constructor_type] = STATE(3253),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3253),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3253),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3253),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1232] = {
    [sym_nested_identifier] = STATE(4431),
    [sym_string] = STATE(3014),
    [sym_formal_parameters] = STATE(4643),
    [sym_nested_type_identifier] = STATE(2810),
    [sym__type] = STATE(3015),
    [sym_constructor_type] = STATE(3015),
    [sym__primary_type] = STATE(3010),
    [sym_template_literal_type] = STATE(3006),
    [sym_infer_type] = STATE(3015),
    [sym_conditional_type] = STATE(3006),
    [sym_generic_type] = STATE(3006),
    [sym_type_query] = STATE(3006),
    [sym_index_type_query] = STATE(3006),
    [sym_lookup_type] = STATE(3006),
    [sym_literal_type] = STATE(3006),
    [sym__number] = STATE(3005),
    [sym_existential_type] = STATE(3006),
    [sym_flow_maybe_type] = STATE(3006),
    [sym_parenthesized_type] = STATE(3006),
    [sym_predefined_type] = STATE(3006),
    [sym_object_type] = STATE(3006),
    [sym_type_parameters] = STATE(4102),
    [sym_array_type] = STATE(3006),
    [sym_tuple_type] = STATE(3006),
    [sym_readonly_type] = STATE(3015),
    [sym_union_type] = STATE(3006),
    [sym_intersection_type] = STATE(3006),
    [sym_function_type] = STATE(3015),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3815),
    [sym_true] = ACTIONS(3511),
    [sym_false] = ACTIONS(3511),
    [sym_null] = ACTIONS(3511),
    [sym_undefined] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_any] = ACTIONS(3499),
    [anon_sym_number] = ACTIONS(3499),
    [anon_sym_boolean] = ACTIONS(3499),
    [anon_sym_string] = ACTIONS(3499),
    [anon_sym_symbol] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3523),
    [anon_sym_unknown] = ACTIONS(3499),
    [anon_sym_never] = ACTIONS(3499),
    [anon_sym_object] = ACTIONS(3499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
  },
  [1233] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3158),
    [sym_constructor_type] = STATE(3158),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3158),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3158),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3158),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1234] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2599),
    [sym_constructor_type] = STATE(2599),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2599),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2599),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2599),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1235] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3291),
    [sym_constructor_type] = STATE(3291),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3291),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3291),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3291),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1236] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2861),
    [sym_constructor_type] = STATE(2861),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2861),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2861),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2861),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1237] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3614),
    [sym_constructor_type] = STATE(3614),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3614),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3614),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3614),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1238] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2911),
    [sym_constructor_type] = STATE(2911),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2911),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2911),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2911),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1239] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(764),
    [sym_constructor_type] = STATE(764),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(764),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(764),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(764),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1240] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2832),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2832),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1241] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2608),
    [sym_constructor_type] = STATE(2608),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2608),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2608),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2608),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1242] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1619),
    [sym_constructor_type] = STATE(1619),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1619),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1619),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1619),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1243] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(850),
    [sym_constructor_type] = STATE(850),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(850),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(850),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(850),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1244] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2592),
    [sym_constructor_type] = STATE(2592),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2592),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2592),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2592),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1245] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(863),
    [sym_constructor_type] = STATE(863),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(863),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(863),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(863),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1246] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3292),
    [sym_constructor_type] = STATE(3292),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3292),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3292),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3292),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1247] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3588),
    [sym_constructor_type] = STATE(3588),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3588),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3588),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3588),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1248] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3589),
    [sym_constructor_type] = STATE(3589),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3589),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3589),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3589),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1249] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym__primary_type] = STATE(3491),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3633),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3792),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3792),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1250] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(765),
    [sym_constructor_type] = STATE(765),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(765),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(765),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(765),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1251] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2889),
    [sym_constructor_type] = STATE(2889),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2889),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2889),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2889),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1252] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3249),
    [sym_constructor_type] = STATE(3249),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3249),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3249),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3249),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1253] = {
    [sym_nested_identifier] = STATE(4418),
    [sym_string] = STATE(1870),
    [sym_formal_parameters] = STATE(4491),
    [sym_nested_type_identifier] = STATE(1786),
    [sym__type] = STATE(1830),
    [sym_constructor_type] = STATE(1830),
    [sym__primary_type] = STATE(1867),
    [sym_template_literal_type] = STATE(1866),
    [sym_infer_type] = STATE(1830),
    [sym_conditional_type] = STATE(1866),
    [sym_generic_type] = STATE(1866),
    [sym_type_query] = STATE(1866),
    [sym_index_type_query] = STATE(1866),
    [sym_lookup_type] = STATE(1866),
    [sym_literal_type] = STATE(1866),
    [sym__number] = STATE(1865),
    [sym_existential_type] = STATE(1866),
    [sym_flow_maybe_type] = STATE(1866),
    [sym_parenthesized_type] = STATE(1866),
    [sym_predefined_type] = STATE(1866),
    [sym_object_type] = STATE(1866),
    [sym_type_parameters] = STATE(4123),
    [sym_array_type] = STATE(1866),
    [sym_tuple_type] = STATE(1866),
    [sym_readonly_type] = STATE(1830),
    [sym_union_type] = STATE(1866),
    [sym_intersection_type] = STATE(1866),
    [sym_function_type] = STATE(1830),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_LBRACE] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_PIPE] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_SQUOTE] = ACTIONS(198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [sym_number] = ACTIONS(3755),
    [sym_this] = ACTIONS(3799),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [sym_null] = ACTIONS(3759),
    [sym_undefined] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3765),
    [anon_sym_infer] = ACTIONS(3767),
    [anon_sym_keyof] = ACTIONS(3769),
    [anon_sym_unknown] = ACTIONS(3751),
    [anon_sym_never] = ACTIONS(3751),
    [anon_sym_object] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3771),
  },
  [1254] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2819),
    [sym_constructor_type] = STATE(2819),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2819),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2819),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2819),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1255] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2882),
    [sym_constructor_type] = STATE(2882),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2882),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2882),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2882),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1256] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3093),
    [sym_constructor_type] = STATE(3093),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3093),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3093),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3093),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1257] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3578),
    [sym_constructor_type] = STATE(3578),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3578),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3578),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3578),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1258] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3893),
    [sym_constructor_type] = STATE(3893),
    [sym__primary_type] = STATE(2804),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3893),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3893),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3893),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1259] = {
    [sym_nested_identifier] = STATE(4404),
    [sym_string] = STATE(828),
    [sym_formal_parameters] = STATE(4366),
    [sym_nested_type_identifier] = STATE(598),
    [sym__type] = STATE(847),
    [sym_constructor_type] = STATE(847),
    [sym__primary_type] = STATE(780),
    [sym_template_literal_type] = STATE(753),
    [sym_infer_type] = STATE(847),
    [sym_conditional_type] = STATE(753),
    [sym_generic_type] = STATE(753),
    [sym_type_query] = STATE(753),
    [sym_index_type_query] = STATE(753),
    [sym_lookup_type] = STATE(753),
    [sym_literal_type] = STATE(753),
    [sym__number] = STATE(751),
    [sym_existential_type] = STATE(753),
    [sym_flow_maybe_type] = STATE(753),
    [sym_parenthesized_type] = STATE(753),
    [sym_predefined_type] = STATE(753),
    [sym_object_type] = STATE(753),
    [sym_type_parameters] = STATE(4141),
    [sym_array_type] = STATE(753),
    [sym_tuple_type] = STATE(753),
    [sym_readonly_type] = STATE(847),
    [sym_union_type] = STATE(753),
    [sym_intersection_type] = STATE(753),
    [sym_function_type] = STATE(847),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3691),
    [sym_number] = ACTIONS(3693),
    [sym_this] = ACTIONS(3809),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_null] = ACTIONS(3697),
    [sym_undefined] = ACTIONS(3697),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_any] = ACTIONS(3689),
    [anon_sym_number] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3689),
    [anon_sym_string] = ACTIONS(3689),
    [anon_sym_symbol] = ACTIONS(3689),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_infer] = ACTIONS(3705),
    [anon_sym_keyof] = ACTIONS(3707),
    [anon_sym_unknown] = ACTIONS(3689),
    [anon_sym_never] = ACTIONS(3689),
    [anon_sym_object] = ACTIONS(3689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1260] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(3823),
    [anon_sym_of] = ACTIONS(3826),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1261] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2832),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2832),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1262] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2997),
    [sym_constructor_type] = STATE(2997),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2997),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2997),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2997),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1263] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3832),
    [sym_constructor_type] = STATE(3832),
    [sym__primary_type] = STATE(2600),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3832),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3832),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3832),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1264] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3893),
    [sym_constructor_type] = STATE(3893),
    [sym__primary_type] = STATE(2803),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3893),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3893),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3893),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1265] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2916),
    [sym_constructor_type] = STATE(2916),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2916),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2916),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2916),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1266] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3302),
    [sym_constructor_type] = STATE(3302),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3302),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3302),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3302),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1267] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2843),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1268] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3668),
    [sym_constructor_type] = STATE(3668),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3668),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3668),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3668),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1269] = {
    [sym_component_identifier] = STATE(3260),
    [sym_new_component_body] = STATE(1874),
    [sym_tagged_type_string] = STATE(2051),
    [sym_tripple_tagged_type_string] = STATE(2050),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_as] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_in] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1751),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_EQ_GT] = ACTIONS(3407),
    [anon_sym_QMARK_DOT] = ACTIONS(1621),
    [anon_sym_PLUS_EQ] = ACTIONS(1630),
    [anon_sym_DASH_EQ] = ACTIONS(1630),
    [anon_sym_STAR_EQ] = ACTIONS(1630),
    [anon_sym_SLASH_EQ] = ACTIONS(1630),
    [anon_sym_PERCENT_EQ] = ACTIONS(1630),
    [anon_sym_CARET_EQ] = ACTIONS(1630),
    [anon_sym_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1630),
    [anon_sym_LT_LT_EQ] = ACTIONS(1630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1630),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1630),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_GT_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_CARET] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PERCENT] = ACTIONS(1617),
    [anon_sym_STAR_STAR] = ACTIONS(1617),
    [anon_sym_LT_EQ] = ACTIONS(1621),
    [anon_sym_EQ_EQ] = ACTIONS(1617),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1621),
    [anon_sym_BANG_EQ] = ACTIONS(1617),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1621),
    [anon_sym_GT_EQ] = ACTIONS(1621),
    [anon_sym_QMARK_QMARK] = ACTIONS(1617),
    [anon_sym_instanceof] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(1621),
    [anon_sym_POUND] = ACTIONS(1635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3411),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1621),
  },
  [1270] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3832),
    [sym_constructor_type] = STATE(3832),
    [sym__primary_type] = STATE(2612),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3832),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3832),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3832),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1271] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3280),
    [sym_constructor_type] = STATE(3280),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3280),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3280),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3280),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1272] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2608),
    [sym_constructor_type] = STATE(2608),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2608),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2608),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2608),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1273] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2908),
    [sym_constructor_type] = STATE(2908),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2908),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2908),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2908),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1274] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3812),
    [sym_constructor_type] = STATE(3812),
    [sym__primary_type] = STATE(2600),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3812),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3812),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3812),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1275] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2856),
    [sym_constructor_type] = STATE(2856),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2856),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2856),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2856),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1276] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2859),
    [sym_constructor_type] = STATE(2859),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2859),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2859),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2859),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1277] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1569),
    [sym_constructor_type] = STATE(1569),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1569),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1569),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1569),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1278] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1572),
    [sym_constructor_type] = STATE(1572),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1572),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1572),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1572),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1279] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1592),
    [sym_constructor_type] = STATE(1592),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1592),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1592),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1592),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1280] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3812),
    [sym_constructor_type] = STATE(3812),
    [sym__primary_type] = STATE(2612),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3812),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3812),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3812),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1281] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(3727),
    [sym_constructor_type] = STATE(3727),
    [sym__primary_type] = STATE(1603),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(3727),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(3727),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(3727),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1282] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1533),
    [sym_constructor_type] = STATE(1533),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1533),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1533),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1533),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1283] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4528),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(1531),
    [sym_constructor_type] = STATE(1531),
    [sym__primary_type] = STATE(1602),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(1531),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4117),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(1531),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1531),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_infer] = ACTIONS(3657),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1284] = {
    [sym_nested_identifier] = STATE(4301),
    [sym_string] = STATE(1623),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(1506),
    [sym__type] = STATE(3727),
    [sym_constructor_type] = STATE(3727),
    [sym__primary_type] = STATE(1617),
    [sym_template_literal_type] = STATE(1600),
    [sym_infer_type] = STATE(3727),
    [sym_conditional_type] = STATE(1600),
    [sym_generic_type] = STATE(1600),
    [sym_type_query] = STATE(1600),
    [sym_index_type_query] = STATE(1600),
    [sym_lookup_type] = STATE(1600),
    [sym_literal_type] = STATE(1600),
    [sym__number] = STATE(1595),
    [sym_existential_type] = STATE(1600),
    [sym_flow_maybe_type] = STATE(1600),
    [sym_parenthesized_type] = STATE(1600),
    [sym_predefined_type] = STATE(1600),
    [sym_object_type] = STATE(1600),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(1600),
    [sym_tuple_type] = STATE(1600),
    [sym_readonly_type] = STATE(3727),
    [sym_union_type] = STATE(1600),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(3727),
    [sym_identifier] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_void] = ACTIONS(3641),
    [anon_sym_DQUOTE] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_number] = ACTIONS(3645),
    [sym_this] = ACTIONS(3805),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_any] = ACTIONS(3641),
    [anon_sym_number] = ACTIONS(3641),
    [anon_sym_boolean] = ACTIONS(3641),
    [anon_sym_string] = ACTIONS(3641),
    [anon_sym_symbol] = ACTIONS(3641),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3659),
    [anon_sym_unknown] = ACTIONS(3641),
    [anon_sym_never] = ACTIONS(3641),
    [anon_sym_object] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
  },
  [1285] = {
    [sym_nested_identifier] = STATE(4437),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4478),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(2863),
    [sym_constructor_type] = STATE(2863),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(2863),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4088),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(2863),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(2863),
    [sym_identifier] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_PIPE] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(3569),
    [anon_sym_QMARK] = ACTIONS(3571),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(3573),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(3577),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1286] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(3274),
    [sym_constructor_type] = STATE(3274),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3274),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3274),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3274),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1287] = {
    [sym_nested_identifier] = STATE(4388),
    [sym_string] = STATE(2850),
    [sym_formal_parameters] = STATE(4386),
    [sym_nested_type_identifier] = STATE(2699),
    [sym__type] = STATE(3369),
    [sym_constructor_type] = STATE(3369),
    [sym__primary_type] = STATE(2847),
    [sym_template_literal_type] = STATE(2846),
    [sym_infer_type] = STATE(3369),
    [sym_conditional_type] = STATE(2846),
    [sym_generic_type] = STATE(2846),
    [sym_type_query] = STATE(2846),
    [sym_index_type_query] = STATE(2846),
    [sym_lookup_type] = STATE(2846),
    [sym_literal_type] = STATE(2846),
    [sym__number] = STATE(2839),
    [sym_existential_type] = STATE(2846),
    [sym_flow_maybe_type] = STATE(2846),
    [sym_parenthesized_type] = STATE(2846),
    [sym_predefined_type] = STATE(2846),
    [sym_object_type] = STATE(2846),
    [sym_type_parameters] = STATE(4270),
    [sym_array_type] = STATE(2846),
    [sym_tuple_type] = STATE(2846),
    [sym_readonly_type] = STATE(3369),
    [sym_union_type] = STATE(2846),
    [sym_intersection_type] = STATE(2846),
    [sym_function_type] = STATE(3369),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_this] = ACTIONS(1094),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_readonly] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_any] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(813),
    [anon_sym_string] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_infer] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_unknown] = ACTIONS(813),
    [anon_sym_never] = ACTIONS(813),
    [anon_sym_object] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [1288] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3660),
    [sym_constructor_type] = STATE(3660),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3660),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3660),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3660),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1289] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3654),
    [sym_constructor_type] = STATE(3654),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3654),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3654),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3654),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1290] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3551),
    [sym_constructor_type] = STATE(3551),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3551),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3551),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3551),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1291] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2592),
    [sym_constructor_type] = STATE(2592),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2592),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2592),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2592),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1292] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3653),
    [sym_constructor_type] = STATE(3653),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3653),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3653),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3653),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1293] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2892),
    [sym_constructor_type] = STATE(2892),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2892),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2892),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2892),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1294] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3215),
    [sym_constructor_type] = STATE(3215),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3215),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3215),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3215),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1295] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4600),
    [sym_nested_type_identifier] = STATE(3022),
    [sym__type] = STATE(2608),
    [sym_constructor_type] = STATE(2608),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2608),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(3989),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2608),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2608),
    [sym_identifier] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_PIPE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3617),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1296] = {
    [sym_nested_identifier] = STATE(4403),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4462),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2869),
    [sym_constructor_type] = STATE(2869),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2869),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4065),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2869),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2869),
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(3555),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1297] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2599),
    [sym_constructor_type] = STATE(2599),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2599),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2599),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2599),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1298] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(2808),
    [sym_constructor_type] = STATE(2808),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(2808),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(2808),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2808),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
  [1299] = {
    [sym_nested_identifier] = STATE(4532),
    [sym_string] = STATE(2607),
    [sym_formal_parameters] = STATE(4561),
    [sym_nested_type_identifier] = STATE(2582),
    [sym__type] = STATE(3650),
    [sym_constructor_type] = STATE(3650),
    [sym__primary_type] = STATE(2620),
    [sym_template_literal_type] = STATE(2619),
    [sym_infer_type] = STATE(3650),
    [sym_conditional_type] = STATE(2619),
    [sym_generic_type] = STATE(2619),
    [sym_type_query] = STATE(2619),
    [sym_index_type_query] = STATE(2619),
    [sym_lookup_type] = STATE(2619),
    [sym_literal_type] = STATE(2619),
    [sym__number] = STATE(2618),
    [sym_existential_type] = STATE(2619),
    [sym_flow_maybe_type] = STATE(2619),
    [sym_parenthesized_type] = STATE(2619),
    [sym_predefined_type] = STATE(2619),
    [sym_object_type] = STATE(2619),
    [sym_type_parameters] = STATE(4017),
    [sym_array_type] = STATE(2619),
    [sym_tuple_type] = STATE(2619),
    [sym_readonly_type] = STATE(3650),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(3650),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_void] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_this] = ACTIONS(1040),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(113),
    [anon_sym_number] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(113),
    [anon_sym_string] = ACTIONS(113),
    [anon_sym_symbol] = ACTIONS(113),
    [anon_sym_abstract] = ACTIONS(107),
    [anon_sym_infer] = ACTIONS(109),
    [anon_sym_keyof] = ACTIONS(111),
    [anon_sym_unknown] = ACTIONS(113),
    [anon_sym_never] = ACTIONS(113),
    [anon_sym_object] = ACTIONS(113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(115),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3579), 1,
      anon_sym_COMMA,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    ACTIONS(3828), 1,
      anon_sym_in,
    ACTIONS(3830), 1,
      anon_sym_COLON,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [103] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(3832), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1621), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [200] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(1781), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(570), 1,
      sym_nested_identifier,
    STATE(640), 1,
      sym_string,
    STATE(695), 1,
      sym__module,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [290] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(3835), 1,
      sym_identifier,
    STATE(691), 1,
      sym__module,
    STATE(3524), 1,
      sym_nested_identifier,
    STATE(3681), 1,
      sym_string,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [380] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(3579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1621), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [476] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3839), 1,
      anon_sym_export,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3847), 1,
      anon_sym_RBRACE,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3855), 1,
      anon_sym_async,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3863), 1,
      anon_sym_static,
    ACTIONS(3865), 1,
      anon_sym_readonly,
    ACTIONS(3871), 1,
      anon_sym_override,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3867), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3869), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3837), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [614] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3839), 1,
      anon_sym_export,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3855), 1,
      anon_sym_async,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3863), 1,
      anon_sym_static,
    ACTIONS(3865), 1,
      anon_sym_readonly,
    ACTIONS(3871), 1,
      anon_sym_override,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3877), 1,
      anon_sym_RBRACE,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3867), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3869), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3837), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [752] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3881), 1,
      anon_sym_export,
    ACTIONS(3883), 1,
      anon_sym_RBRACE,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3887), 1,
      anon_sym_static,
    ACTIONS(3889), 1,
      anon_sym_readonly,
    ACTIONS(3895), 1,
      anon_sym_override,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3891), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3893), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3879), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [890] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3883), 1,
      anon_sym_RBRACE,
    ACTIONS(3899), 1,
      anon_sym_export,
    ACTIONS(3901), 1,
      anon_sym_async,
    ACTIONS(3903), 1,
      anon_sym_static,
    ACTIONS(3905), 1,
      anon_sym_readonly,
    ACTIONS(3911), 1,
      anon_sym_override,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3907), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3909), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3897), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1028] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3881), 1,
      anon_sym_export,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3887), 1,
      anon_sym_static,
    ACTIONS(3889), 1,
      anon_sym_readonly,
    ACTIONS(3895), 1,
      anon_sym_override,
    ACTIONS(3913), 1,
      anon_sym_RBRACE,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3891), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3893), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3879), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1166] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3828), 1,
      anon_sym_in,
    ACTIONS(3830), 1,
      anon_sym_COLON,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1264] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3828), 1,
      anon_sym_in,
    ACTIONS(3915), 1,
      anon_sym_COLON,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1362] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3919), 1,
      anon_sym_export,
    ACTIONS(3921), 1,
      anon_sym_RBRACE,
    ACTIONS(3923), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_static,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_override,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3929), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3931), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3917), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1500] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(1781), 1,
      anon_sym_COLON,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(570), 1,
      sym_nested_identifier,
    STATE(640), 1,
      sym_string,
    STATE(691), 1,
      sym__module,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1590] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3875), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3919), 1,
      anon_sym_export,
    ACTIONS(3923), 1,
      anon_sym_async,
    ACTIONS(3925), 1,
      anon_sym_static,
    ACTIONS(3927), 1,
      anon_sym_readonly,
    ACTIONS(3933), 1,
      anon_sym_override,
    ACTIONS(3935), 1,
      anon_sym_RBRACE,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3929), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3931), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3917), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1728] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3793), 1,
      anon_sym_EQ_GT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1822] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3881), 1,
      anon_sym_export,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3887), 1,
      anon_sym_static,
    ACTIONS(3889), 1,
      anon_sym_readonly,
    ACTIONS(3895), 1,
      anon_sym_override,
    ACTIONS(3937), 1,
      anon_sym_COMMA,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    ACTIONS(3941), 1,
      anon_sym_SEMI,
    ACTIONS(3943), 1,
      anon_sym_PIPE_RBRACE,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3891), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3893), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3879), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1960] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3791), 1,
      anon_sym_EQ,
    ACTIONS(3793), 1,
      anon_sym_EQ_GT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2054] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(3835), 1,
      sym_identifier,
    STATE(695), 1,
      sym__module,
    STATE(3524), 1,
      sym_nested_identifier,
    STATE(3681), 1,
      sym_string,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2144] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(3945), 1,
      sym_identifier,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2235] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(3945), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2326] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(3949), 1,
      anon_sym_EQ_GT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2419] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3949), 1,
      anon_sym_EQ_GT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2512] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3404), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(3823), 1,
      anon_sym_in,
    ACTIONS(3826), 1,
      anon_sym_of,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
    ACTIONS(1621), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2609] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(3951), 1,
      sym_identifier,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2700] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(3951), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2791] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(3945), 1,
      sym_identifier,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2882] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(3951), 1,
      sym_identifier,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(62), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1745), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1779), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3109] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3197] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3285] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 1,
      anon_sym_COLON,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_LT,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1683), 1,
      anon_sym_QMARK,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1737), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1771), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1775), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1741), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1733), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1729), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1749), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3918] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1142), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(119), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2084), 1,
      anon_sym_QMARK,
    ACTIONS(1020), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4148] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3961), 1,
      anon_sym_export,
    ACTIONS(3966), 1,
      anon_sym_async,
    ACTIONS(3968), 1,
      anon_sym_static,
    ACTIONS(3970), 1,
      anon_sym_readonly,
    ACTIONS(3976), 1,
      anon_sym_override,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3963), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3972), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3974), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4076), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4078), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3299), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3959), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4272] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(119), 1,
      anon_sym_RBRACK,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(27), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4350] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3841), 1,
      anon_sym_STAR,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3853), 1,
      anon_sym_LBRACK,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(3961), 1,
      anon_sym_export,
    ACTIONS(3966), 1,
      anon_sym_async,
    ACTIONS(3968), 1,
      anon_sym_static,
    ACTIONS(3970), 1,
      anon_sym_readonly,
    ACTIONS(3976), 1,
      anon_sym_override,
    STATE(2460), 1,
      sym_accessibility_modifier,
    STATE(2478), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3861), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3963), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3972), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3974), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2695), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4076), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4078), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3154), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3959), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(3945), 1,
      sym_identifier,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(3581), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4622] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(3579), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4697] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1142), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_QMARK,
    ACTIONS(3533), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(1781), 1,
      anon_sym_COLON,
    ACTIONS(3951), 1,
      sym_identifier,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      sym_identifier,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(1781), 1,
      anon_sym_COLON,
    ACTIONS(3945), 1,
      sym_identifier,
    ACTIONS(62), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5147] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(119), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1142), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5228] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_EQ,
    ACTIONS(1064), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_extends,
    ACTIONS(3953), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3956), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(62), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5304] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1020), 1,
      anon_sym_COLON,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(1013), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1749), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1733), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 1,
      anon_sym_AT,
    STATE(1361), 1,
      aux_sym_class_repeat1,
    STATE(1390), 1,
      sym_decorator,
    ACTIONS(3980), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3978), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [5576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2098), 1,
      anon_sym_EQ_GT,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5646] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1020), 1,
      anon_sym_COLON,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1142), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1741), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1745), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1771), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1737), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6050] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_EQ,
    ACTIONS(2098), 1,
      anon_sym_EQ_GT,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1729), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6184] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1144), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1142), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1775), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_LPAREN,
    ACTIONS(3991), 1,
      anon_sym_DOT,
    STATE(1384), 1,
      sym_arguments,
    ACTIONS(3987), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3985), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [6396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(1781), 1,
      anon_sym_COLON,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6468] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1020), 1,
      anon_sym_COLON,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(1142), 1,
      anon_sym_extends,
    ACTIONS(3953), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3993), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(62), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1621), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6616] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(2108), 1,
      anon_sym_in,
    ACTIONS(3997), 1,
      anon_sym_of,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6690] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6760] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1753), 1,
      anon_sym_EQ,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1779), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 1,
      anon_sym_AT,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4002), 1,
      anon_sym_component,
    STATE(1361), 1,
      aux_sym_class_repeat1,
    STATE(1390), 1,
      sym_decorator,
    ACTIONS(3980), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3978), 38,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6970] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(1142), 1,
      anon_sym_extends,
    ACTIONS(3953), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3956), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_EQ,
    ACTIONS(1064), 1,
      anon_sym_EQ_GT,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4005), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [7177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3533), 1,
      anon_sym_COLON,
    ACTIONS(3832), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4009), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [7311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_EQ,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1621), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7378] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(1064), 1,
      anon_sym_EQ_GT,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(62), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3985), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [7510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4013), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [7573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1621), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    ACTIONS(3823), 1,
      anon_sym_in,
    ACTIONS(3826), 1,
      anon_sym_of,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1621), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7711] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_COMMA,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(119), 1,
      anon_sym_RBRACK,
    ACTIONS(2137), 1,
      anon_sym_COLON,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1219), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [7850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_EQ,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1621), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      sym__automatic_semicolon,
    ACTIONS(1347), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1345), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [7980] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2172), 1,
      anon_sym_COLON,
    ACTIONS(62), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2851), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2849), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [8112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2945), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [8174] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2137), 1,
      anon_sym_COLON,
    ACTIONS(62), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(42), 1,
      anon_sym_EQ,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(27), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2853), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [8376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3288), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3280), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3148), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1345), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1359), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2377), 1,
      anon_sym_EQ_GT,
    ACTIONS(62), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(60), 1,
      anon_sym_EQ_GT,
    ACTIONS(1022), 1,
      anon_sym_EQ,
    ACTIONS(2108), 1,
      anon_sym_in,
    ACTIONS(3997), 1,
      anon_sym_of,
    ACTIONS(62), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_EQ_GT,
    ACTIONS(2441), 1,
      anon_sym_EQ,
    ACTIONS(62), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(66), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(23), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3164), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3823), 1,
      anon_sym_in,
    ACTIONS(3826), 1,
      anon_sym_of,
    ACTIONS(1621), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(1621), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1630), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1617), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 18,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4019), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_COLON,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(4025), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4023), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 1,
      anon_sym_EQ,
    STATE(1444), 1,
      sym_property_expression_initializer,
    ACTIONS(4033), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4031), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9328] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4041), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3294), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 1,
      anon_sym_COLON,
    ACTIONS(4063), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4061), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9494] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4067), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4069), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3224), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_LPAREN,
    STATE(1404), 1,
      sym_arguments,
    ACTIONS(3003), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3001), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4074), 1,
      anon_sym_LPAREN,
    STATE(1405), 1,
      sym_arguments,
    ACTIONS(2704), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2702), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9723] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3941), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3943), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3254), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_COLON,
    ACTIONS(4079), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4077), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9889] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4083), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4085), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9996] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4087), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4089), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3301), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10103] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4091), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4093), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3178), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10210] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(3851), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3875), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3156), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4097), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4095), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4099), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4103), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3100), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3204), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4107), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4111), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4115), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 1,
      anon_sym_SEMI,
    ACTIONS(4121), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4119), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4125), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3160), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4129), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4133), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3108), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4137), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4141), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4145), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4151), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4149), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4153), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4159), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4157), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3128), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4161), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3116), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2851), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2849), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4165), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3122), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3120), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3136), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2853), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4169), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4175), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4173), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4179), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4177), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4183), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4181), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4187), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4185), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4191), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4189), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2353), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4193), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4197), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4203), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4201), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4205), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12559] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [12662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4211), 1,
      anon_sym_COLON,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    ACTIONS(4025), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4023), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12721] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [12824] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [12927] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4219), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13030] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13133] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4225), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13291] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4229), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13394] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4231), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13497] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4233), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13600] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4235), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13703] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4237), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13806] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4239), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13909] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4241), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14012] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4243), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4245), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14218] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14321] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14424] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4251), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14527] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14630] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14733] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4257), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14836] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4261), 1,
      anon_sym_RBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4265), 1,
      anon_sym_async,
    ACTIONS(4267), 1,
      anon_sym_static,
    ACTIONS(4269), 1,
      anon_sym_readonly,
    ACTIONS(4275), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4271), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4273), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4259), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14934] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4279), 1,
      anon_sym_RBRACE,
    ACTIONS(4281), 1,
      anon_sym_async,
    ACTIONS(4283), 1,
      anon_sym_static,
    ACTIONS(4285), 1,
      anon_sym_readonly,
    ACTIONS(4291), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4287), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4289), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4277), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15032] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4295), 1,
      anon_sym_RBRACE,
    ACTIONS(4297), 1,
      anon_sym_async,
    ACTIONS(4299), 1,
      anon_sym_static,
    ACTIONS(4301), 1,
      anon_sym_readonly,
    ACTIONS(4307), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4303), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4305), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4293), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15130] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4311), 1,
      anon_sym_RBRACE,
    ACTIONS(4313), 1,
      anon_sym_async,
    ACTIONS(4315), 1,
      anon_sym_static,
    ACTIONS(4317), 1,
      anon_sym_readonly,
    ACTIONS(4323), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4321), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4309), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15228] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4327), 1,
      anon_sym_RBRACE,
    ACTIONS(4329), 1,
      anon_sym_async,
    ACTIONS(4331), 1,
      anon_sym_static,
    ACTIONS(4333), 1,
      anon_sym_readonly,
    ACTIONS(4339), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3881), 1,
      aux_sym_object_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4335), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4337), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3882), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4325), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4345), 1,
      anon_sym_LT,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    STATE(1618), 1,
      sym_type_arguments,
    STATE(1666), 1,
      sym_arguments,
    STATE(3453), 1,
      sym_optional_chain,
    ACTIONS(2228), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2230), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [15396] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4351), 1,
      anon_sym_RBRACE,
    ACTIONS(4353), 1,
      anon_sym_async,
    ACTIONS(4355), 1,
      anon_sym_static,
    ACTIONS(4357), 1,
      anon_sym_readonly,
    ACTIONS(4363), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3750), 1,
      aux_sym_object_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4359), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4361), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3747), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4349), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_DOT,
    ACTIONS(4367), 1,
      anon_sym_is,
    STATE(1590), 1,
      sym_type_arguments,
    ACTIONS(2198), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2200), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [15556] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4371), 1,
      anon_sym_RBRACE,
    ACTIONS(4373), 1,
      anon_sym_async,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_readonly,
    ACTIONS(4383), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3724), 1,
      aux_sym_object_repeat1,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4381), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3751), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4369), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15654] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4387), 1,
      anon_sym_RBRACE,
    ACTIONS(4389), 1,
      anon_sym_async,
    ACTIONS(4391), 1,
      anon_sym_static,
    ACTIONS(4393), 1,
      anon_sym_readonly,
    ACTIONS(4399), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3881), 1,
      aux_sym_object_repeat1,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4395), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4397), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3882), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4385), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_COLON,
    ACTIONS(4063), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4061), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [15808] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3327), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      sym__automatic_semicolon,
    ACTIONS(1219), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1223), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [15964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1142), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [16017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_LT,
    STATE(1566), 1,
      sym_type_arguments,
    ACTIONS(2325), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16074] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3318), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16173] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3171), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16272] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3299), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4405), 1,
      anon_sym_DOT,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2319), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2321), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4407), 1,
      anon_sym_DOT,
    STATE(1574), 1,
      sym_arguments,
    ACTIONS(2345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2347), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2879), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16542] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3250), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 1,
      anon_sym_is,
    ACTIONS(2325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4411), 1,
      anon_sym_DOT,
    STATE(1564), 1,
      sym_arguments,
    ACTIONS(2457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2459), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [16755] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3154), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2271), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [16913] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2379), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2381), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [16978] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2447), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2449), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [17051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2688), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17104] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3317), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_is,
    ACTIONS(2443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2425), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [17325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      anon_sym_SEMI,
    ACTIONS(4423), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4421), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [17380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_DOT,
    STATE(1590), 1,
      sym_type_arguments,
    ACTIONS(2198), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2200), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17439] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(3857), 1,
      anon_sym_new,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(3873), 1,
      anon_sym_abstract,
    ACTIONS(4037), 1,
      anon_sym_export,
    ACTIONS(4039), 1,
      anon_sym_STAR,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2472), 1,
      sym_accessibility_modifier,
    STATE(2486), 1,
      sym_override_modifier,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3458), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(4049), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2718), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2719), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2763), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [17700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2769), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LPAREN,
    STATE(1707), 1,
      sym_arguments,
    ACTIONS(3001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3003), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [17860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(2771), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2773), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2781), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_DOT,
    ACTIONS(2753), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2755), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym__automatic_semicolon,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [18074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2801), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2855), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3026), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2835), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2863), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2895), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2911), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2817), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2911), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2817), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2943), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2467), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2943), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2467), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2951), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2955), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2951), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2955), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2967), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2883), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2997), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2999), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2999), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3046), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2739), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2731), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    STATE(3453), 1,
      sym_optional_chain,
    ACTIONS(2989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2991), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2654), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2522), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3050), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2550), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3066), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2727), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(2552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2554), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2723), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2947), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2594), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20328] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_async,
    ACTIONS(4444), 1,
      anon_sym_static,
    ACTIONS(4446), 1,
      anon_sym_readonly,
    ACTIONS(4452), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    ACTIONS(204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3963), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4448), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4450), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4076), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4078), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4440), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2598), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 1,
      sym__automatic_semicolon,
    ACTIONS(1219), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1223), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4454), 1,
      anon_sym_LPAREN,
    STATE(1637), 1,
      sym_arguments,
    ACTIONS(2702), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2704), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2688), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [20844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2606), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2879), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [21000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2614), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2616), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2735), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4457), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [21266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3014), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2975), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2851), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(2628), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2827), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 1,
      anon_sym_extends,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(2628), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2622), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2624), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2632), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2931), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2927), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2821), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2646), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    STATE(1709), 1,
      sym_arguments,
    ACTIONS(3060), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3062), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(2795), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2797), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22534] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(3072), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3074), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2901), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2903), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2656), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2658), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_AMP,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(2648), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2650), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2747), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4463), 1,
      anon_sym_DOT,
    ACTIONS(2489), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2491), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2696), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3250), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23232] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      sym_identifier,
    ACTIONS(4468), 1,
      anon_sym_STAR,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_from,
    ACTIONS(4474), 1,
      anon_sym_DOT,
    STATE(2880), 1,
      sym_import_path_segment,
    STATE(3002), 1,
      sym_import_path,
    ACTIONS(3252), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3254), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [23297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3242), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1473), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3150), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    STATE(2579), 1,
      sym_arguments,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23505] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4478), 1,
      anon_sym_RBRACE,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1712), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [23600] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 1,
      sym_identifier,
    ACTIONS(4498), 1,
      anon_sym_STAR,
    ACTIONS(4500), 1,
      anon_sym_LBRACE,
    ACTIONS(4502), 1,
      anon_sym_from,
    ACTIONS(4504), 1,
      anon_sym_DOT,
    STATE(549), 1,
      sym_import_path_segment,
    STATE(588), 1,
      sym_import_path,
    ACTIONS(3252), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3254), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [23665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1399), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1423), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3166), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23869] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4510), 1,
      anon_sym_LT,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    STATE(1945), 1,
      sym_type_arguments,
    STATE(2113), 1,
      sym_arguments,
    STATE(3513), 1,
      sym_optional_chain,
    ACTIONS(2228), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2230), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [23936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3214), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3230), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1275), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3132), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3134), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1297), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2329), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2331), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3270), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3140), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3142), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3158), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1307), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3110), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3118), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3122), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24701] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4514), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1688), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3136), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3138), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2385), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3168), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3170), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3266), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3178), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3186), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3202), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3234), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1337), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25306] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4516), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25401] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4518), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1711), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1343), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3146), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3274), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4520), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1413), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25795] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
    ACTIONS(4530), 1,
      anon_sym_LBRACK,
    ACTIONS(4533), 1,
      anon_sym_async,
    ACTIONS(4536), 1,
      anon_sym_DASH,
    ACTIONS(4539), 1,
      anon_sym_DQUOTE,
    ACTIONS(4542), 1,
      anon_sym_SQUOTE,
    ACTIONS(4548), 1,
      anon_sym_AT,
    ACTIONS(4551), 1,
      anon_sym_static,
    ACTIONS(4554), 1,
      anon_sym_readonly,
    ACTIONS(4560), 1,
      anon_sym_declare,
    ACTIONS(4566), 1,
      anon_sym_override,
    ACTIONS(4569), 1,
      anon_sym_abstract,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4545), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4557), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4563), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4522), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3286), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3126), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1261), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1265), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2403), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3174), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1443), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3290), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26298] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4572), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3180), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3182), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3106), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3218), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3238), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3262), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3194), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2359), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3102), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3206), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1369), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1327), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2367), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27158] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4574), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1672), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3190), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1379), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3282), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_LT,
    ACTIONS(4576), 1,
      anon_sym_DOT,
    ACTIONS(4578), 1,
      anon_sym_is,
    STATE(1851), 1,
      sym_type_arguments,
    ACTIONS(2198), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2200), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [27465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3198), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3162), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27567] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4580), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27662] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4582), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3130), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1255), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1317), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27910] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4584), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1679), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3220), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3222), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3226), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28158] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4586), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1677), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2991), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1433), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3254), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1355), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28610] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(3859), 1,
      anon_sym_DASH,
    ACTIONS(4045), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4480), 1,
      anon_sym_async,
    ACTIONS(4484), 1,
      anon_sym_AT,
    ACTIONS(4486), 1,
      anon_sym_static,
    ACTIONS(4488), 1,
      anon_sym_readonly,
    ACTIONS(4492), 1,
      anon_sym_declare,
    ACTIONS(4494), 1,
      anon_sym_abstract,
    ACTIONS(4588), 1,
      anon_sym_RBRACE,
    STATE(2415), 1,
      sym_method_definition,
    STATE(2442), 1,
      sym_accessibility_modifier,
    STATE(2475), 1,
      sym_override_modifier,
    STATE(3586), 1,
      sym_method_signature,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1716), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2635), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3860), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4035), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28756] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_RBRACK,
    ACTIONS(2676), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4590), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [28812] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2429), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4592), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [28968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_QMARK,
    ACTIONS(3533), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29024] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    STATE(2473), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29106] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2343), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4651), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__automatic_semicolon,
    ACTIONS(1219), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1223), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29314] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    STATE(2473), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 1,
      sym__automatic_semicolon,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29448] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2371), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29550] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2367), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(3579), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29710] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2359), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [29862] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4663), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30016] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(4665), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2522), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30076] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    STATE(2473), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4682), 1,
      anon_sym_LBRACK,
    ACTIONS(4678), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2883), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4690), 1,
      anon_sym_RBRACK,
    ACTIONS(1227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4688), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2425), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [30338] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2447), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2449), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4651), 1,
      anon_sym_RBRACK,
    ACTIONS(2612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4701), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4690), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30518] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2379), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2381), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2271), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30686] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    STATE(2473), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1413), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30818] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2279), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30920] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2331), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31022] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31116] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2337), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31196] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1399), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      anon_sym_is,
    ACTIONS(2325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [31370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4578), 1,
      anon_sym_is,
    ACTIONS(2443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2445), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [31422] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2337), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [31492] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31580] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31666] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2337), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31750] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [31822] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31914] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32004] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [32080] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [32146] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2385), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32248] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2389), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32350] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4712), 1,
      anon_sym_COMMA,
    ACTIONS(4716), 1,
      anon_sym_LT,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3686), 1,
      aux_sym_extends_clause_repeat1,
    STATE(3687), 1,
      sym_type_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4710), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4714), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32460] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32518] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2399), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1343), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32670] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2403), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32772] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2407), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1142), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [32924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_LT,
    STATE(1846), 1,
      sym_type_arguments,
    ACTIONS(2325), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(3581), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [33034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4754), 1,
      anon_sym_DOT,
    STATE(1841), 1,
      sym_arguments,
    ACTIONS(2345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2347), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4756), 1,
      anon_sym_DOT,
    STATE(1840), 1,
      sym_arguments,
    ACTIONS(2319), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2321), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4758), 1,
      anon_sym_DOT,
    STATE(1839), 1,
      sym_arguments,
    ACTIONS(2457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2459), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_LT,
    ACTIONS(4576), 1,
      anon_sym_DOT,
    STATE(1851), 1,
      sym_type_arguments,
    ACTIONS(2198), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2200), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(2409), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [33362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3098), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3082), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3066), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3050), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33803] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(4760), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(4415), 1,
      sym_type_annotation,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33910] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2403), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3046), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2999), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34109] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2997), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2999), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [34164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34213] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2407), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2967), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2959), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2955), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2951), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2955), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2951), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2467), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2943), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2467), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2943), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2817), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2911), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34902] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(4802), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(4328), 1,
      sym_type_annotation,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2817), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2911), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2895), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2863), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2835), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2801), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2781), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(2771), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2773), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2769), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35501] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(4804), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(4407), 1,
      sym_type_annotation,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2763), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2765), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [35663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2761), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2747), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2739), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4806), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2445), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [35865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2731), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2727), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2723), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2719), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2696), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36110] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4812), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2654), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2646), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2632), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 1,
      anon_sym_extends,
    ACTIONS(4814), 1,
      anon_sym_LBRACK,
    ACTIONS(2628), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2622), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2624), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2614), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2616), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2606), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2598), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2594), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(2552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2554), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2550), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36768] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2429), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [36869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2522), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 1,
      anon_sym_DOT,
    ACTIONS(2753), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2755), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2939), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3026), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3014), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2883), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 1,
      anon_sym_LPAREN,
    STATE(2043), 1,
      sym_arguments,
    ACTIONS(2702), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2704), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2735), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2327), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 1,
      anon_sym_LBRACK,
    ACTIONS(2628), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2827), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2975), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2445), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2931), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_LPAREN,
    STATE(2052), 1,
      sym_arguments,
    ACTIONS(3001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3003), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37767] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4806), 1,
      anon_sym_LBRACK,
    ACTIONS(4826), 1,
      anon_sym_RPAREN,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4824), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4829), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37828] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(2923), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3579), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37889] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2343), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [37990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2927), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38088] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2367), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38189] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2359), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38290] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2371), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38391] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4865), 1,
      anon_sym_COMMA,
    ACTIONS(4868), 1,
      anon_sym_RBRACE,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2389), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4870), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2598), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3152), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [38551] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2279), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38652] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2331), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2851), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38802] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38895] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2337), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38974] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2337), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39114] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39286] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2337), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39369] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39440] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39531] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39620] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39760] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2385), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [39861] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2389), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [39962] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2399), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40063] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2403), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40164] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2407), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2915), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40412] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4748), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2923), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [40467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4878), 1,
      anon_sym_LBRACE,
    ACTIONS(4880), 1,
      anon_sym_async,
    ACTIONS(4884), 1,
      anon_sym_readonly,
    STATE(2470), 1,
      sym_statement_block,
    STATE(2484), 1,
      sym_override_modifier,
    ACTIONS(4882), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2655), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2855), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2899), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2859), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2821), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(2795), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2797), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40938] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2399), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [41039] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2389), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [41140] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2385), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [41241] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [41306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41357] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2359), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [41458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4463), 1,
      anon_sym_DOT,
    ACTIONS(2489), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2491), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [41509] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [41584] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [41673] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [41764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2648), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2650), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2947), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [41868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      sym_regex_flags,
    ACTIONS(2562), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(2564), 24,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [41919] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(4572), 1,
      sym_type_annotation,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2656), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2658), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42081] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    ACTIONS(4894), 1,
      anon_sym_in,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4764), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4892), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [42184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2594), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42237] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_QMARK,
    ACTIONS(2522), 1,
      anon_sym_extends,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 1,
      anon_sym_COLON,
    ACTIONS(4665), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42300] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(2881), 1,
      anon_sym_QMARK,
    ACTIONS(2883), 1,
      anon_sym_extends,
    ACTIONS(4682), 1,
      anon_sym_LBRACK,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4678), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(2901), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2903), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_extends,
    ACTIONS(4682), 1,
      anon_sym_LBRACK,
    ACTIONS(4897), 1,
      anon_sym_RPAREN,
    ACTIONS(1227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4688), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42479] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4904), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42552] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [42623] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_extends,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_RPAREN,
    ACTIONS(2612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4701), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_PIPE,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(3072), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3074), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42814] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4806), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_RPAREN,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4911), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym_arguments,
    ACTIONS(3060), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3062), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42928] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2337), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43011] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43096] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43183] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2337), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [43252] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43323] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2429), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [43424] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2337), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43503] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43596] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2331), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [43697] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4904), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    STATE(3513), 1,
      sym_optional_chain,
    ACTIONS(2989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2991), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [43827] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43902] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2279), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [44003] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2371), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [44104] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2343), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [44205] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_extends,
    ACTIONS(4665), 1,
      anon_sym_RPAREN,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(2612), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4651), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [44266] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44341] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4768), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4770), 1,
      anon_sym_GT_GT,
    ACTIONS(4774), 1,
      anon_sym_AMP,
    ACTIONS(4776), 1,
      anon_sym_CARET,
    ACTIONS(4778), 1,
      anon_sym_PIPE,
    ACTIONS(4782), 1,
      anon_sym_PERCENT,
    ACTIONS(4784), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4792), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4794), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4762), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4772), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4780), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4790), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4764), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4786), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2367), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [44442] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4904), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_extends,
    ACTIONS(4678), 1,
      anon_sym_RPAREN,
    ACTIONS(4682), 1,
      anon_sym_LBRACK,
    ACTIONS(1227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4690), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [44576] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(4918), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(4652), 1,
      sym_type_annotation,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44683] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4716), 1,
      anon_sym_LT,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3897), 1,
      sym_type_arguments,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4714), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4920), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [44788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4654), 1,
      sym__automatic_semicolon,
    ACTIONS(1219), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1223), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [44841] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44916] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4904), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44989] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4922), 1,
      anon_sym_COMMA,
    ACTIONS(4925), 1,
      anon_sym_RBRACE,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2407), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45094] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3584), 1,
      anon_sym_QMARK,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(2923), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3581), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4806), 1,
      anon_sym_LBRACK,
    ACTIONS(4930), 1,
      anon_sym_RPAREN,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4829), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4927), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45216] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4925), 1,
      anon_sym_RBRACE,
    ACTIONS(4934), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(2389), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      anon_sym_extends,
    ACTIONS(4873), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4870), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3152), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4937), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45427] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    STATE(2473), 1,
      sym_override_modifier,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45501] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [45571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45621] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45689] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4945), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3945), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45793] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2337), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [45861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4824), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45913] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2337), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [45991] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4947), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3716), 1,
      aux_sym_array_repeat1,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46095] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3942), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46199] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4951), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3845), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46303] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(4590), 1,
      anon_sym_of,
    ACTIONS(4953), 1,
      anon_sym_in,
    ACTIONS(2672), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46425] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [46509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4701), 1,
      anon_sym_of,
    ACTIONS(4956), 1,
      anon_sym_in,
    ACTIONS(2608), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4688), 1,
      anon_sym_of,
    ACTIONS(4959), 1,
      anon_sym_in,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46617] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2337), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [46699] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [46769] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2331), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_extends,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4672), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2608), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [46925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(2883), 1,
      anon_sym_extends,
    ACTIONS(4682), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4685), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [46981] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47071] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4962), 1,
      sym_regex_flags,
    ACTIONS(2562), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(2564), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47209] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [47283] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [47347] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4964), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [47447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4927), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47499] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2385), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47599] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2389), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4968), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4966), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47751] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2279), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47851] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3786), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_LT,
    ACTIONS(4980), 1,
      anon_sym_QMARK,
    ACTIONS(3272), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3274), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48011] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_extends,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4748), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48065] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2399), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48165] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4982), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3797), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_extends,
    ACTIONS(3791), 1,
      anon_sym_EQ,
    ACTIONS(4748), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4751), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [48325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    ACTIONS(3823), 1,
      anon_sym_in,
    ACTIONS(3826), 1,
      anon_sym_of,
    ACTIONS(1617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48379] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4984), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3928), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48483] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2371), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48583] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2359), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48683] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4986), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3848), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4962), 1,
      sym_regex_flags,
    ACTIONS(2562), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(2564), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [48837] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [48923] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2403), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49023] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4988), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3850), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49127] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2367), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49227] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2407), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49327] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2343), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49427] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4990), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4992), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_QMARK,
    ACTIONS(2923), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4748), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49585] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4746), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2429), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49685] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4892), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [49785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3130), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3162), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 1,
      sym__automatic_semicolon,
    ACTIONS(1335), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1333), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1337), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1309), 1,
      sym__automatic_semicolon,
    ACTIONS(1305), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1303), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1307), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 1,
      anon_sym_COLON,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2522), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4682), 1,
      anon_sym_LBRACK,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2883), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3110), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3118), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3122), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3136), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3138), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4911), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50345] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4994), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3886), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3150), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3166), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4996), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50597] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4990), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5000), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50699] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4990), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4663), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50801] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5004), 1,
      anon_sym_static,
    ACTIONS(5006), 1,
      anon_sym_readonly,
    ACTIONS(5008), 1,
      anon_sym_abstract,
    STATE(2457), 1,
      sym_accessibility_modifier,
    STATE(2510), 1,
      sym_override_modifier,
    ACTIONS(5002), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2958), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      sym__automatic_semicolon,
    ACTIONS(1441), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1443), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3102), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3206), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3282), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3290), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51117] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5010), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3797), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      sym__automatic_semicolon,
    ACTIONS(1263), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1261), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1265), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3254), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1369), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1327), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3242), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1381), 1,
      sym__automatic_semicolon,
    ACTIONS(1377), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1379), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3250), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1473), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1423), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1275), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1297), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3266), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1355), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1433), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52189] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5012), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3833), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3226), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3220), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3222), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      sym__automatic_semicolon,
    ACTIONS(1253), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1251), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1255), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1317), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1255), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3198), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1379), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3190), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2367), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2359), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52825] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5014), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    STATE(3829), 1,
      aux_sym_array_repeat1,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3180), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3182), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3174), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1261), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1265), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1443), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3146), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3140), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3142), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3132), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3134), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3126), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 1,
      sym__automatic_semicolon,
    ACTIONS(1315), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1313), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1317), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      sym__automatic_semicolon,
    ACTIONS(1431), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1433), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3214), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3230), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2329), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2331), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3270), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53705] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 1,
      sym__automatic_semicolon,
    ACTIONS(1353), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1351), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1355), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2594), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3158), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1307), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4873), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4870), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3152), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2385), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54077] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3533), 1,
      anon_sym_COLON,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3168), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3170), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3178), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3186), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3202), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3234), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1337), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3274), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3286), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 1,
      sym__automatic_semicolon,
    ACTIONS(1459), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2403), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_QMARK,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      sym__automatic_semicolon,
    ACTIONS(1295), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1297), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54777] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_LPAREN,
    ACTIONS(5019), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5024), 1,
      anon_sym_QMARK,
    ACTIONS(1617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3106), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54881] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3218), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3238), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3262), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5028), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5026), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 1,
      sym__automatic_semicolon,
    ACTIONS(1273), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1275), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4695), 1,
      anon_sym_as,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_satisfies,
    ACTIONS(4835), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4839), 1,
      anon_sym_GT_GT,
    ACTIONS(4843), 1,
      anon_sym_AMP,
    ACTIONS(4845), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    ACTIONS(4851), 1,
      anon_sym_PERCENT,
    ACTIONS(4853), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4863), 1,
      sym__ternary_qmark,
    ACTIONS(4990), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4693), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4831), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4841), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4857), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4859), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5030), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4833), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4855), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5028), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5026), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5028), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5026), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      sym__automatic_semicolon,
    ACTIONS(1421), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1423), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55455] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(2923), 1,
      anon_sym_extends,
    ACTIONS(3533), 1,
      anon_sym_COLON,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5032), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3194), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      sym__automatic_semicolon,
    ACTIONS(1471), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1473), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__automatic_semicolon,
    ACTIONS(1405), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5036), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55815] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4892), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [55915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4937), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2991), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5040), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56165] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4720), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4722), 1,
      anon_sym_GT_GT,
    ACTIONS(4726), 1,
      anon_sym_AMP,
    ACTIONS(4728), 1,
      anon_sym_CARET,
    ACTIONS(4730), 1,
      anon_sym_PIPE,
    ACTIONS(4734), 1,
      anon_sym_PERCENT,
    ACTIONS(4736), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4724), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4732), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4740), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4742), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4714), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4738), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [56257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4937), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56309] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5044), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [56409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1395), 1,
      sym__automatic_semicolon,
    ACTIONS(1391), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 1,
      sym__automatic_semicolon,
    ACTIONS(1367), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1369), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1329), 1,
      sym__automatic_semicolon,
    ACTIONS(1325), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1323), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1327), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      sym__automatic_semicolon,
    ACTIONS(1405), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1403), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1407), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56617] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56716] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4868), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56815] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4925), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2594), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1617), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [56965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_extends,
    ACTIONS(4748), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4751), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [57018] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5048), 1,
      anon_sym_RBRACE,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57119] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_QMARK,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4806), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      anon_sym_extends,
    ACTIONS(4870), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4873), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3152), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [57227] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 1,
      anon_sym_STAR,
    ACTIONS(5052), 1,
      anon_sym_async,
    ACTIONS(5056), 1,
      anon_sym_readonly,
    STATE(2487), 1,
      sym_override_modifier,
    ACTIONS(5054), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5058), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57296] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      sym_regex_flags,
    ACTIONS(2562), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2564), 21,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [57424] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57503] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5064), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57604] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5066), 1,
      anon_sym_RBRACE,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57705] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4880), 1,
      anon_sym_async,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    ACTIONS(5068), 1,
      anon_sym_abstract,
    ACTIONS(4882), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2655), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3832), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4806), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4809), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [57874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(2594), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [57974] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5072), 1,
      anon_sym_async,
    ACTIONS(5076), 1,
      anon_sym_readonly,
    STATE(2481), 1,
      sym_override_modifier,
    ACTIONS(5074), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2732), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58043] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58122] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_STAR,
    ACTIONS(5084), 1,
      anon_sym_async,
    ACTIONS(5088), 1,
      anon_sym_readonly,
    STATE(2482), 1,
      sym_override_modifier,
    ACTIONS(5086), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5090), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2631), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58191] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5092), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58292] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_STAR,
    ACTIONS(5084), 1,
      anon_sym_async,
    ACTIONS(5094), 1,
      anon_sym_abstract,
    ACTIONS(5086), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5090), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2631), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58357] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5096), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58458] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5098), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58559] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5100), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58660] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5102), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(2883), 1,
      anon_sym_extends,
    ACTIONS(4682), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4685), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_extends,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4669), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4672), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2608), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58871] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58950] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59029] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4904), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5108), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59195] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5110), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59296] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5112), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59397] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5114), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59498] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(4590), 1,
      anon_sym_COLON,
    ACTIONS(4592), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59551] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59630] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5116), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59731] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(68), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(5122), 1,
      anon_sym_RBRACE,
    STATE(3746), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5124), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3752), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4445), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5118), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59800] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5126), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59901] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5128), 1,
      anon_sym_RPAREN,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60081] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(68), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(5132), 1,
      anon_sym_RBRACE,
    STATE(3755), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5124), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3731), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4445), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5130), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      sym_override_modifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(2923), 1,
      anon_sym_extends,
    ACTIONS(4748), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60284] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5136), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60385] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5138), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60486] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60553] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4661), 1,
      anon_sym_COMMA,
    ACTIONS(5140), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60654] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5142), 1,
      anon_sym_STAR,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5148), 1,
      anon_sym_readonly,
    STATE(2476), 1,
      sym_override_modifier,
    ACTIONS(5146), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5150), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60723] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5152), 1,
      anon_sym_STAR,
    ACTIONS(5154), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5156), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60783] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60865] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5180), 1,
      anon_sym_STAR,
    ACTIONS(5182), 1,
      anon_sym_async,
    ACTIONS(5184), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5186), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2669), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60927] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2407), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61025] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [61133] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5180), 1,
      anon_sym_STAR,
    ACTIONS(5200), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5202), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61193] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 1,
      anon_sym_STAR,
    ACTIONS(5206), 1,
      anon_sym_async,
    ACTIONS(5208), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5210), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2727), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61255] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61327] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61397] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5142), 1,
      anon_sym_STAR,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5150), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61577] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5212), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61675] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2403), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61773] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4806), 1,
      anon_sym_LBRACK,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2445), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [61895] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2399), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61993] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5217), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62111] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5220), 1,
      anon_sym_STAR,
    ACTIONS(5222), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5224), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5217), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62219] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62291] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5226), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5231), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62437] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5234), 1,
      anon_sym_RBRACK,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3242), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5239), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62583] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2389), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62681] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2385), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62779] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5242), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5244), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3214), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62839] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62909] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_async,
    ACTIONS(5250), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5252), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2723), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62971] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63033] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63105] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63163] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [63271] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63343] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63413] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63499] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63557] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63615] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5254), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63713] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5220), 1,
      anon_sym_STAR,
    ACTIONS(5256), 1,
      anon_sym_async,
    ACTIONS(5258), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5260), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2638), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63863] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2337), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5262), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5265), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [63979] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5268), 1,
      anon_sym_STAR,
    ACTIONS(5270), 1,
      anon_sym_async,
    ACTIONS(5272), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5274), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64041] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5142), 1,
      anon_sym_STAR,
    ACTIONS(5276), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5278), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3236), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64101] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2337), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [64181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5280), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5283), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5289), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
    STATE(2702), 1,
      sym_arguments,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64327] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4892), 1,
      anon_sym_of,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    ACTIONS(5292), 1,
      anon_sym_in,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5160), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64427] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(68), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(5124), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5297), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4076), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4445), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4546), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5295), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64491] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5268), 1,
      anon_sym_STAR,
    ACTIONS(5299), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5301), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3153), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64551] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(2337), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [64635] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2343), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4688), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64783] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2337), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [64849] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5303), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4870), 1,
      anon_sym_LBRACK,
    ACTIONS(4873), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2598), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3152), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64999] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5305), 1,
      anon_sym_STAR,
    ACTIONS(5307), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65059] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5311), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65157] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5313), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65255] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2429), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5315), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5318), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65401] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5321), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 1,
      anon_sym_extends,
    ACTIONS(4806), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4809), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65573] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65645] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2337), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65713] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5327), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65811] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2367), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5329), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5332), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65957] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2337), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2339), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [66033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5335), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5338), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66081] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2337), 1,
      anon_sym_BANG,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2339), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [66171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5341), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5344), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_LBRACK,
    ACTIONS(4751), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1617), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66271] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5347), 1,
      anon_sym_STAR,
    ACTIONS(5349), 1,
      anon_sym_async,
    ACTIONS(5351), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5353), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2712), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66333] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5355), 1,
      anon_sym_STAR,
    ACTIONS(5357), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5359), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3179), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66393] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2359), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5361), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5364), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5367), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5370), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66587] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 1,
      anon_sym_STAR,
    ACTIONS(5373), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5375), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3217), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66775] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5377), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3203), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66835] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66893] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 1,
      anon_sym_STAR,
    ACTIONS(5052), 1,
      anon_sym_async,
    ACTIONS(5054), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5058), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66955] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2371), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67053] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 1,
      anon_sym_STAR,
    ACTIONS(5381), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5383), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3284), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67113] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5385), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5388), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [67233] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5347), 1,
      anon_sym_STAR,
    ACTIONS(5391), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5393), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67293] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2331), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(4590), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [67441] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67511] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2279), 1,
      anon_sym_of,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(5162), 1,
      anon_sym_GT_GT,
    ACTIONS(5166), 1,
      anon_sym_AMP,
    ACTIONS(5170), 1,
      anon_sym_PERCENT,
    ACTIONS(5172), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5190), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5192), 1,
      anon_sym_CARET,
    ACTIONS(5194), 1,
      anon_sym_PIPE,
    ACTIONS(5196), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5198), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5158), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5164), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5168), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5176), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5160), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5174), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67609] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67681] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67751] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5395), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5397), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67811] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5231), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [67931] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5399), 1,
      anon_sym_COLON,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68029] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_STAR,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5403), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68089] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_STAR,
    ACTIONS(5084), 1,
      anon_sym_async,
    ACTIONS(5086), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5090), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2631), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68151] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5072), 1,
      anon_sym_async,
    ACTIONS(5074), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2732), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [68261] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68326] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5381), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3284), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68436] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5395), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68491] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5373), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3217), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68666] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5276), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3236), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68721] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5307), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68776] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68841] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5407), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3191), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5299), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3153), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68951] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(3823), 1,
      anon_sym_in,
    ACTIONS(3826), 1,
      anon_sym_of,
    ACTIONS(1617), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69114] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(126), 1,
      anon_sym_STAR,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1189), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5413), 1,
      anon_sym_async,
    ACTIONS(5417), 1,
      anon_sym_static,
    ACTIONS(5419), 1,
      anon_sym_readonly,
    ACTIONS(5425), 1,
      anon_sym_override,
    STATE(2469), 1,
      sym_accessibility_modifier,
    STATE(2479), 1,
      sym_override_modifier,
    ACTIONS(5411), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5415), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5421), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5423), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3142), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4078), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(5409), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69191] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5427), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3283), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5377), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3203), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69301] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5357), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3179), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69356] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5242), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3214), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5200), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      anon_sym_EQ,
    ACTIONS(4688), 1,
      anon_sym_of,
    ACTIONS(4959), 1,
      anon_sym_in,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1225), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69582] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(4508), 1,
      anon_sym_LBRACK,
    ACTIONS(4512), 1,
      anon_sym_DOT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4697), 1,
      anon_sym_BANG,
    STATE(2129), 1,
      sym_arguments,
    STATE(3851), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69677] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(1617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69789] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(4701), 1,
      anon_sym_of,
    ACTIONS(4956), 1,
      anon_sym_in,
    ACTIONS(2608), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2610), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69950] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70015] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(2477), 1,
      sym_override_modifier,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      sym_regex_flags,
    ACTIONS(2562), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(2564), 19,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [70133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70188] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2234), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2281), 1,
      anon_sym_BANG,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(5434), 1,
      anon_sym_DOT,
    STATE(947), 1,
      sym_arguments,
    STATE(3840), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70338] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    ACTIONS(4347), 1,
      anon_sym_DOT,
    ACTIONS(4413), 1,
      anon_sym_as,
    ACTIONS(4415), 1,
      anon_sym_BANG,
    ACTIONS(4419), 1,
      anon_sym_satisfies,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(1693), 1,
      sym_arguments,
    STATE(3721), 1,
      sym_optional_chain,
    ACTIONS(4417), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4595), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4597), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ,
    ACTIONS(4590), 1,
      anon_sym_of,
    ACTIONS(4953), 1,
      anon_sym_in,
    ACTIONS(2672), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2674), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [70484] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70549] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    ACTIONS(5429), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70609] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70671] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5438), 1,
      anon_sym_abstract,
    ACTIONS(5429), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70891] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    STATE(2477), 1,
      sym_override_modifier,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70959] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5442), 1,
      anon_sym_readonly,
    STATE(2517), 1,
      sym_override_modifier,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71019] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5094), 1,
      anon_sym_abstract,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71240] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71295] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71468] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71578] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71633] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(13), 1,
      anon_sym_component,
    ACTIONS(1654), 1,
      anon_sym_type,
    ACTIONS(1656), 1,
      anon_sym_import,
    ACTIONS(1658), 1,
      anon_sym_var,
    ACTIONS(1660), 1,
      anon_sym_let,
    ACTIONS(1662), 1,
      anon_sym_const,
    ACTIONS(1675), 1,
      anon_sym_class,
    ACTIONS(1691), 1,
      anon_sym_abstract,
    ACTIONS(1697), 1,
      anon_sym_enum,
    ACTIONS(1755), 1,
      anon_sym_async,
    ACTIONS(1757), 1,
      anon_sym_function,
    ACTIONS(1759), 1,
      anon_sym_declare,
    ACTIONS(1761), 1,
      anon_sym_namespace,
    ACTIONS(1763), 1,
      anon_sym_module,
    ACTIONS(1765), 1,
      anon_sym_global,
    ACTIONS(1767), 1,
      anon_sym_interface,
    STATE(667), 1,
      sym_declaration,
    STATE(779), 1,
      sym_internal_module,
    STATE(1390), 1,
      sym_decorator,
    STATE(3201), 1,
      aux_sym_class_repeat1,
    STATE(775), 14,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
      sym_component_declaration,
  [71716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5444), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72048] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(13), 1,
      anon_sym_component,
    ACTIONS(1654), 1,
      anon_sym_type,
    ACTIONS(1656), 1,
      anon_sym_import,
    ACTIONS(1658), 1,
      anon_sym_var,
    ACTIONS(1660), 1,
      anon_sym_let,
    ACTIONS(1662), 1,
      anon_sym_const,
    ACTIONS(1675), 1,
      anon_sym_class,
    ACTIONS(1677), 1,
      anon_sym_async,
    ACTIONS(1679), 1,
      anon_sym_function,
    ACTIONS(1685), 1,
      anon_sym_declare,
    ACTIONS(1687), 1,
      anon_sym_namespace,
    ACTIONS(1689), 1,
      anon_sym_module,
    ACTIONS(1691), 1,
      anon_sym_abstract,
    ACTIONS(1693), 1,
      anon_sym_global,
    ACTIONS(1695), 1,
      anon_sym_interface,
    ACTIONS(1697), 1,
      anon_sym_enum,
    STATE(667), 1,
      sym_declaration,
    STATE(779), 1,
      sym_internal_module,
    STATE(1390), 1,
      sym_decorator,
    STATE(3201), 1,
      aux_sym_class_repeat1,
    STATE(775), 14,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
      sym_component_declaration,
  [72131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72186] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72241] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72296] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5446), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72349] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72404] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1359), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_else,
      anon_sym_while,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1345), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_else,
      anon_sym_while,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72542] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5448), 1,
      anon_sym_STAR,
    ACTIONS(5450), 1,
      anon_sym_async,
    ACTIONS(5454), 1,
      anon_sym_readonly,
    STATE(2474), 1,
      sym_override_modifier,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5456), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 1,
      anon_sym_LPAREN,
    ACTIONS(5460), 1,
      anon_sym_DOT,
    STATE(2464), 1,
      sym_arguments,
    ACTIONS(3987), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3985), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72699] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5462), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5466), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5448), 1,
      anon_sym_STAR,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5456), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5470), 1,
      anon_sym_STAR,
    ACTIONS(5472), 1,
      anon_sym_async,
    ACTIONS(5474), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5476), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5478), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [72976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5470), 1,
      anon_sym_STAR,
    ACTIONS(5474), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5476), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4009), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5482), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73110] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5486), 1,
      anon_sym_STAR,
    ACTIONS(5488), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73164] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5492), 1,
      anon_sym_STAR,
    ACTIONS(5494), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5496), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3168), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73218] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5486), 1,
      anon_sym_STAR,
    ACTIONS(5498), 1,
      anon_sym_async,
    ACTIONS(5488), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5490), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5500), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5504), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5466), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5508), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5512), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5508), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5516), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5520), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5526), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5524), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5530), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5534), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      sym__automatic_semicolon,
    ACTIONS(1347), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1345), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1219), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5542), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5546), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5504), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5482), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [73960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5520), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [74000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5500), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [74040] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5550), 1,
      anon_sym_EQ_GT,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74092] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5448), 1,
      anon_sym_STAR,
    ACTIONS(5450), 1,
      anon_sym_async,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5456), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5478), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [74188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5516), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [74228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1549), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1547), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5552), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1219), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [74455] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5556), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5373), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3217), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74553] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5558), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5560), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5377), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3203), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5307), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74798] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4880), 1,
      anon_sym_async,
    ACTIONS(5562), 1,
      anon_sym_static,
    ACTIONS(5564), 1,
      anon_sym_readonly,
    ACTIONS(5566), 1,
      anon_sym_abstract,
    STATE(2484), 1,
      sym_override_modifier,
    ACTIONS(4882), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2655), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5276), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3236), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74959] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5474), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75008] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5381), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3284), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75057] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5200), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75155] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5299), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3153), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75204] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5494), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3168), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5357), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3179), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75302] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5488), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym__automatic_semicolon,
    ACTIONS(1347), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1345), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1359), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5570), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5572), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3394), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75529] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5574), 1,
      anon_sym_static,
    ACTIONS(5576), 1,
      anon_sym_readonly,
    ACTIONS(5578), 1,
      anon_sym_abstract,
    STATE(2517), 1,
      sym_override_modifier,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1345), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_RBRACE,
    STATE(4285), 1,
      sym_enum_assignment,
    ACTIONS(5582), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3598), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75673] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    ACTIONS(5584), 1,
      anon_sym_static,
    STATE(2473), 1,
      sym_override_modifier,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75733] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5586), 1,
      anon_sym_RBRACE,
    STATE(4285), 1,
      sym_enum_assignment,
    ACTIONS(5582), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3598), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2851), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2849), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75821] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5588), 1,
      anon_sym_RBRACE,
    STATE(4285), 1,
      sym_enum_assignment,
    ACTIONS(5582), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3598), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4005), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3985), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2945), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [75985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2853), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [76023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5590), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [76061] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(1941), 1,
      anon_sym_override,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(5592), 1,
      anon_sym_static,
    STATE(2477), 1,
      sym_override_modifier,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5594), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [76159] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5598), 1,
      anon_sym_RBRACE,
    STATE(4285), 1,
      sym_enum_assignment,
    ACTIONS(5582), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3598), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76209] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4059), 1,
      anon_sym_override,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5072), 1,
      anon_sym_async,
    ACTIONS(5076), 1,
      anon_sym_readonly,
    ACTIONS(5600), 1,
      anon_sym_static,
    STATE(2481), 1,
      sym_override_modifier,
    ACTIONS(5074), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2732), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76269] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5142), 1,
      anon_sym_STAR,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5148), 1,
      anon_sym_readonly,
    ACTIONS(5146), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5150), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76322] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5486), 1,
      anon_sym_STAR,
    ACTIONS(5498), 1,
      anon_sym_async,
    ACTIONS(5602), 1,
      anon_sym_readonly,
    ACTIONS(5488), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5490), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4880), 1,
      anon_sym_async,
    ACTIONS(4884), 1,
      anon_sym_readonly,
    ACTIONS(4882), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2655), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 1,
      anon_sym_STAR,
    ACTIONS(5206), 1,
      anon_sym_async,
    ACTIONS(5604), 1,
      anon_sym_readonly,
    ACTIONS(5208), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5210), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2727), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5448), 1,
      anon_sym_STAR,
    ACTIONS(5450), 1,
      anon_sym_async,
    ACTIONS(5454), 1,
      anon_sym_readonly,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5456), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76534] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4629), 1,
      anon_sym_STAR,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(4643), 1,
      anon_sym_async,
    ACTIONS(4647), 1,
      anon_sym_readonly,
    ACTIONS(4645), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4649), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2734), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1935), 1,
      anon_sym_async,
    ACTIONS(1937), 1,
      anon_sym_readonly,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 1,
      anon_sym_STAR,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1553), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1551), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76679] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5050), 1,
      anon_sym_STAR,
    ACTIONS(5052), 1,
      anon_sym_async,
    ACTIONS(5056), 1,
      anon_sym_readonly,
    ACTIONS(5054), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5058), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2725), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76732] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5220), 1,
      anon_sym_STAR,
    ACTIONS(5256), 1,
      anon_sym_async,
    ACTIONS(5606), 1,
      anon_sym_readonly,
    ACTIONS(5258), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5260), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2638), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76785] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5608), 1,
      anon_sym_STAR,
    ACTIONS(5612), 1,
      anon_sym_readonly,
    ACTIONS(5610), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2659), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_STAR,
    ACTIONS(5084), 1,
      anon_sym_async,
    ACTIONS(5088), 1,
      anon_sym_readonly,
    ACTIONS(5086), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5090), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2631), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76889] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5442), 1,
      anon_sym_readonly,
    ACTIONS(5616), 1,
      anon_sym_STAR,
    ACTIONS(5618), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5620), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2632), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_STAR,
    ACTIONS(5072), 1,
      anon_sym_async,
    ACTIONS(5076), 1,
      anon_sym_readonly,
    ACTIONS(5074), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2732), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76993] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5268), 1,
      anon_sym_STAR,
    ACTIONS(5270), 1,
      anon_sym_async,
    ACTIONS(5622), 1,
      anon_sym_readonly,
    ACTIONS(5272), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5274), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2696), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77046] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    STATE(4285), 1,
      sym_enum_assignment,
    ACTIONS(5582), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3598), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5556), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5474), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(4902), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5452), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3187), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5242), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3214), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5276), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3236), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77357] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5299), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3153), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5624), 1,
      anon_sym_readonly,
    ACTIONS(5444), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(1723), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5200), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3175), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5488), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5427), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3283), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77623] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4638), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5558), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5373), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3217), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5494), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3168), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5560), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3220), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5407), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3191), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5442), 1,
      anon_sym_readonly,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5405), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2981), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5552), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78197] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5377), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3203), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5395), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3155), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78285] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78329] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      anon_sym_readonly,
    ACTIONS(5429), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5307), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5357), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3179), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5628), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_SQUOTE,
    ACTIONS(4641), 1,
      anon_sym_LBRACK,
    ACTIONS(5444), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4035), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(4900), 1,
      anon_sym_LBRACK,
    ACTIONS(5381), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3284), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1933), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_EQ,
    ACTIONS(2688), 23,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [78627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2855), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [78659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2947), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [78691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2851), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [78723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 1,
      anon_sym_EQ,
    ACTIONS(2879), 23,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [78755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      sym_identifier,
    STATE(4444), 1,
      sym_mapped_type_clause,
    ACTIONS(5632), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(2417), 5,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(2491), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [78816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    ACTIONS(3531), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5634), 1,
      anon_sym_DOT,
    STATE(2579), 1,
      sym_arguments,
    ACTIONS(2345), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2347), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    ACTIONS(5636), 1,
      anon_sym_DOT,
    ACTIONS(5638), 1,
      anon_sym_QMARK_DOT,
    STATE(2574), 1,
      sym_arguments,
    ACTIONS(2319), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2321), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    ACTIONS(5640), 1,
      anon_sym_DOT,
    ACTIONS(5642), 1,
      anon_sym_QMARK_DOT,
    STATE(2571), 1,
      sym_arguments,
    ACTIONS(2457), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2459), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2899), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2859), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2955), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [78999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2951), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2955), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2951), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3082), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2467), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2943), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2467), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3066), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2943), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2817), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2911), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2817), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2911), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2939), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2895), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2863), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2939), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2939), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3098), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2859), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3082), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3098), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3082), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2859), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3098), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2899), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79675] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(2198), 1,
      anon_sym_extends,
    ACTIONS(5644), 1,
      sym_identifier,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(5648), 1,
      anon_sym_COLON,
    ACTIONS(5650), 1,
      anon_sym_EQ,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_BQUOTE,
    ACTIONS(5658), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1421), 1,
      sym_new_component_body,
    STATE(1432), 1,
      sym_tripple_tagged_type_string,
    STATE(1433), 1,
      sym_tagged_type_string,
    STATE(2584), 1,
      sym_type_arguments,
    STATE(3288), 1,
      sym_component_identifier,
    ACTIONS(2200), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [79729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2899), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2915), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2915), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2915), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2927), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79859] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(2198), 1,
      anon_sym_extends,
    ACTIONS(5644), 1,
      sym_identifier,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_BQUOTE,
    ACTIONS(5658), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5660), 1,
      anon_sym_COLON,
    ACTIONS(5662), 1,
      anon_sym_EQ,
    STATE(1421), 1,
      sym_new_component_body,
    STATE(1432), 1,
      sym_tripple_tagged_type_string,
    STATE(1433), 1,
      sym_tagged_type_string,
    STATE(2584), 1,
      sym_type_arguments,
    STATE(3288), 1,
      sym_component_identifier,
    ACTIONS(2200), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [79913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_EQ,
    ACTIONS(2835), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [79938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_EQ,
    ACTIONS(2931), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [79963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2731), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [79988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 1,
      anon_sym_DOT,
    ACTIONS(5666), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2753), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2755), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [80017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_BQUOTE,
    ACTIONS(2861), 1,
      anon_sym_QMARK,
    ACTIONS(5668), 1,
      anon_sym_DOT,
    ACTIONS(2417), 3,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(2863), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [80048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2727), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [80073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 5,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
      anon_sym_is,
    ACTIONS(1142), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [80098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 1,
      anon_sym_EQ,
    ACTIONS(2883), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(3050), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_EQ,
    ACTIONS(2719), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2723), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [80198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_BQUOTE,
    ACTIONS(2861), 1,
      anon_sym_PIPE,
    ACTIONS(5668), 1,
      anon_sym_DOT,
    ACTIONS(2417), 3,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(2863), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(2781), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [80252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_EQ,
    ACTIONS(5652), 1,
      anon_sym_LT,
    STATE(2586), 1,
      sym_type_arguments,
    ACTIONS(2327), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 1,
      anon_sym_PIPE,
    ACTIONS(2879), 15,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(2606), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [80328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_PIPE,
    ACTIONS(2688), 15,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(2654), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [80376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_BQUOTE,
    ACTIONS(2489), 1,
      anon_sym_PIPE,
    ACTIONS(2417), 4,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(2491), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(2739), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [80428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(2999), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
    ACTIONS(3456), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5671), 1,
      anon_sym_DOT,
    STATE(2702), 1,
      sym_arguments,
    ACTIONS(2347), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [80503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_EQ,
    ACTIONS(2821), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [80547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      anon_sym_DOT,
    ACTIONS(5679), 1,
      anon_sym_QMARK_DOT,
    STATE(2697), 1,
      sym_arguments,
    ACTIONS(2321), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [80578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_EQ,
    ACTIONS(3026), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_EQ,
    ACTIONS(3014), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [80645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_EQ,
    ACTIONS(2995), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_EQ,
    ACTIONS(2769), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_EQ,
    ACTIONS(5683), 1,
      anon_sym_LBRACK,
    ACTIONS(2646), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_EQ,
    ACTIONS(2975), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_EQ,
    ACTIONS(2765), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ,
    ACTIONS(2967), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5685), 1,
      anon_sym_is,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_EQ,
    ACTIONS(2632), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 1,
      anon_sym_EQ,
    ACTIONS(2747), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_EQ,
    ACTIONS(2923), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_EQ,
    ACTIONS(2550), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_EQ,
    ACTIONS(2598), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_EQ,
    ACTIONS(2761), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [80952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5687), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [80973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_EQ,
    ACTIONS(5683), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2624), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [81000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5689), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [81021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_EQ,
    ACTIONS(2594), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_EQ,
    ACTIONS(2522), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [81088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    ACTIONS(2935), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_EQ,
    ACTIONS(2735), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_EQ,
    ACTIONS(2327), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_EQ,
    ACTIONS(5683), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_EQ,
    ACTIONS(2959), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5693), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [81226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_PIPE,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
    ACTIONS(5695), 1,
      anon_sym_DOT,
    ACTIONS(5697), 1,
      anon_sym_QMARK_DOT,
    STATE(2700), 1,
      sym_arguments,
    ACTIONS(2459), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    ACTIONS(2445), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [81280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_PIPE,
    ACTIONS(2915), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 1,
      anon_sym_PIPE,
    ACTIONS(2939), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5699), 1,
      anon_sym_DOT,
    ACTIONS(5701), 1,
      anon_sym_is,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [81352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5705), 1,
      sym_number,
    STATE(4452), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [81380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_PIPE,
    ACTIONS(5707), 1,
      anon_sym_LT,
    ACTIONS(5709), 1,
      anon_sym_DOT,
    ACTIONS(5711), 1,
      anon_sym_is,
    STATE(2812), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81410] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5713), 1,
      sym_number,
    STATE(4474), 1,
      sym_string,
    STATE(4475), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [81440] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5717), 1,
      anon_sym_BANG,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5725), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3309), 1,
      sym__call_signature,
    STATE(3349), 1,
      sym_type_annotation,
    STATE(3933), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5715), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [81482] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5717), 1,
      anon_sym_BANG,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5727), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3349), 1,
      sym_type_annotation,
    STATE(3899), 1,
      sym__initializer,
    STATE(3901), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5715), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [81524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5729), 1,
      sym_number,
    STATE(4515), 1,
      sym_predefined_type,
    STATE(4516), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [81554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5731), 1,
      sym_number,
    STATE(4518), 1,
      sym_predefined_type,
    STATE(4519), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [81584] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5735), 1,
      anon_sym_BANG,
    ACTIONS(5737), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3255), 1,
      sym__call_signature,
    STATE(3452), 1,
      sym_type_annotation,
    STATE(3711), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5733), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [81626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5739), 1,
      sym_number,
    STATE(4529), 1,
      sym_predefined_type,
    STATE(4531), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [81656] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(5741), 1,
      sym_identifier,
    ACTIONS(5743), 1,
      anon_sym_from,
    STATE(2701), 1,
      aux_sym_import_path_segment_repeat1,
    STATE(3878), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(2063), 2,
      ts_builtin_sym_end,
      anon_sym_AT,
    ACTIONS(5745), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2061), 5,
      anon_sym_as,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [81690] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5749), 1,
      anon_sym_BANG,
    ACTIONS(5751), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3223), 1,
      sym__call_signature,
    STATE(3427), 1,
      sym_type_annotation,
    STATE(3779), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [81732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_PIPE,
    ACTIONS(5707), 1,
      anon_sym_LT,
    ACTIONS(5753), 1,
      anon_sym_DOT,
    ACTIONS(5755), 1,
      anon_sym_is,
    STATE(2812), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_PIPE,
    ACTIONS(2863), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_PIPE,
    ACTIONS(2895), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(2911), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 1,
      anon_sym_PIPE,
    ACTIONS(2817), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(2911), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 1,
      anon_sym_PIPE,
    ACTIONS(2817), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 1,
      anon_sym_PIPE,
    ACTIONS(2943), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_PIPE,
    ACTIONS(2467), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 1,
      anon_sym_PIPE,
    ACTIONS(2943), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_PIPE,
    ACTIONS(2467), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [81982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2951), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_PIPE,
    ACTIONS(2955), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2951), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_PIPE,
    ACTIONS(2955), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5757), 1,
      sym_number,
    STATE(4350), 1,
      sym_string,
    STATE(4351), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82100] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5761), 1,
      anon_sym_BANG,
    ACTIONS(5763), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3270), 1,
      sym__call_signature,
    STATE(3395), 1,
      sym_type_annotation,
    STATE(3803), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5759), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82142] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5765), 1,
      sym_number,
    STATE(4547), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5767), 1,
      sym_number,
    STATE(4327), 1,
      sym_string,
    STATE(4333), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5769), 1,
      sym_number,
    STATE(4320), 1,
      sym_string,
    STATE(4323), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82230] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5761), 1,
      anon_sym_BANG,
    ACTIONS(5771), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3395), 1,
      sym_type_annotation,
    STATE(3813), 1,
      sym__call_signature,
    STATE(3815), 1,
      sym__initializer,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5759), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      sym_number,
    STATE(4318), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5775), 1,
      sym_number,
    STATE(4436), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5777), 1,
      sym_number,
    STATE(4653), 1,
      sym_predefined_type,
    STATE(4654), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5779), 1,
      sym_number,
    STATE(4441), 1,
      sym_string,
    STATE(4442), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5781), 1,
      sym_number,
    STATE(4447), 1,
      sym_string,
    STATE(4448), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5783), 1,
      sym_number,
    STATE(4511), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5785), 1,
      sym_number,
    STATE(4465), 1,
      sym_string,
    STATE(4472), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82476] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5787), 1,
      sym_number,
    STATE(4450), 1,
      sym_string,
    STATE(4464), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5789), 1,
      sym_number,
    STATE(4506), 1,
      sym_predefined_type,
    STATE(4509), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82536] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5793), 1,
      anon_sym_BANG,
    ACTIONS(5795), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3169), 1,
      sym__call_signature,
    STATE(3487), 1,
      sym_type_annotation,
    STATE(3810), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82578] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5797), 1,
      sym_number,
    STATE(4456), 1,
      sym_string,
    STATE(4461), 1,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_PIPE,
    ACTIONS(3066), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_PIPE,
    ACTIONS(3082), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_PIPE,
    ACTIONS(3082), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_PIPE,
    ACTIONS(3082), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_PIPE,
    ACTIONS(3098), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_PIPE,
    ACTIONS(3098), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_PIPE,
    ACTIONS(3098), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 1,
      anon_sym_PIPE,
    ACTIONS(2939), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 1,
      anon_sym_PIPE,
    ACTIONS(2939), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82806] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5799), 1,
      sym_number,
    STATE(4499), 1,
      sym_predefined_type,
    STATE(4503), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [82862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 1,
      anon_sym_PIPE,
    ACTIONS(2859), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [82884] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5801), 1,
      sym_number,
    STATE(4656), 1,
      sym_predefined_type,
    STATE(4658), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5803), 1,
      sym_number,
    STATE(4495), 1,
      sym_predefined_type,
    STATE(4496), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82944] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5805), 1,
      sym_number,
    STATE(4662), 1,
      sym_predefined_type,
    STATE(4663), 1,
      sym_string,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [82974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(5807), 1,
      sym_number,
    STATE(4669), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5703), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [83002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_PIPE,
    ACTIONS(2927), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_PIPE,
    ACTIONS(2915), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 1,
      anon_sym_PIPE,
    ACTIONS(2859), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_PIPE,
    ACTIONS(2915), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_PIPE,
    ACTIONS(2899), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_PIPE,
    ACTIONS(2899), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_PIPE,
    ACTIONS(2899), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 1,
      anon_sym_PIPE,
    ACTIONS(2859), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83178] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5811), 1,
      anon_sym_COLON,
    ACTIONS(5813), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3072), 1,
      sym__call_signature,
    STATE(3521), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5809), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3362), 1,
      sym__call_signature,
    STATE(3363), 1,
      sym_type_annotation,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5815), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 1,
      anon_sym_PIPE,
    ACTIONS(2727), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      sym_type_predicate,
    STATE(4485), 1,
      sym_predefined_type,
    ACTIONS(5819), 2,
      sym_identifier,
      sym_this,
    ACTIONS(113), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [83294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_PIPE,
    ACTIONS(5707), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(2327), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_PIPE,
    ACTIONS(2731), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 1,
      sym_identifier,
    STATE(2706), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(2124), 2,
      ts_builtin_sym_end,
      anon_sym_AT,
    ACTIONS(5823), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2122), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [83367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_PIPE,
    ACTIONS(2723), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_PIPE,
    ACTIONS(5825), 1,
      anon_sym_DOT,
    ACTIONS(5827), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2755), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5831), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3087), 1,
      sym__call_signature,
    STATE(3377), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5829), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_LPAREN,
    ACTIONS(5835), 1,
      anon_sym_DOT,
    ACTIONS(5837), 1,
      anon_sym_QMARK_DOT,
    STATE(2821), 1,
      sym_arguments,
    ACTIONS(2347), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [83475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      sym_identifier,
    STATE(2706), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(2152), 2,
      ts_builtin_sym_end,
      anon_sym_AT,
    ACTIONS(5842), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2150), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [83502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5699), 1,
      anon_sym_DOT,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [83527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_PIPE,
    ACTIONS(5707), 1,
      anon_sym_LT,
    ACTIONS(5709), 1,
      anon_sym_DOT,
    STATE(2812), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_LPAREN,
    ACTIONS(5845), 1,
      anon_sym_DOT,
    ACTIONS(5847), 1,
      anon_sym_QMARK_DOT,
    STATE(2825), 1,
      sym_arguments,
    ACTIONS(2459), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [83581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_LPAREN,
    ACTIONS(5849), 1,
      anon_sym_DOT,
    ACTIONS(5851), 1,
      anon_sym_QMARK_DOT,
    STATE(2824), 1,
      sym_arguments,
    ACTIONS(2321), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [83608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 1,
      anon_sym_PIPE,
    ACTIONS(2855), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83629] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5855), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3424), 1,
      sym__call_signature,
    STATE(3425), 1,
      sym_type_annotation,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5862), 1,
      anon_sym_COLON,
    ACTIONS(5864), 1,
      anon_sym_EQ,
    ACTIONS(5866), 1,
      anon_sym_extends,
    STATE(2584), 1,
      sym_type_arguments,
    STATE(3571), 1,
      sym_constraint,
    STATE(4126), 1,
      sym_default_type,
    ACTIONS(5859), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(2200), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [83732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      sym_type_predicate,
    STATE(4316), 1,
      sym_predefined_type,
    ACTIONS(5869), 2,
      sym_identifier,
      sym_this,
    ACTIONS(113), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [83819] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5871), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3521), 1,
      sym_type_annotation,
    STATE(3522), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5809), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(5875), 1,
      anon_sym_DOT,
    ACTIONS(5877), 1,
      anon_sym_is,
    STATE(2984), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [83881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 1,
      sym_identifier,
    STATE(2701), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(2063), 2,
      ts_builtin_sym_end,
      anon_sym_AT,
    ACTIONS(5745), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2061), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [83908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3332), 1,
      sym_type_predicate,
    STATE(4573), 1,
      sym_predefined_type,
    ACTIONS(5879), 2,
      sym_identifier,
      sym_this,
    ACTIONS(113), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [83933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_PIPE,
    ACTIONS(2947), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [83954] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5881), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3115), 1,
      sym__call_signature,
    STATE(3425), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 1,
      anon_sym_PIPE,
    ACTIONS(2851), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [84010] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5883), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3377), 1,
      sym_type_annotation,
    STATE(3381), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5829), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3507), 1,
      sym_type_predicate,
    STATE(4300), 1,
      sym_predefined_type,
    ACTIONS(5885), 2,
      sym_identifier,
      sym_this,
    ACTIONS(113), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [84070] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5887), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3105), 1,
      sym__call_signature,
    STATE(3363), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5815), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_PIPE,
    ACTIONS(5707), 1,
      anon_sym_LT,
    ACTIONS(5753), 1,
      anon_sym_DOT,
    STATE(2812), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [84132] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5889), 1,
      ts_builtin_sym_end,
    ACTIONS(5891), 1,
      anon_sym_import,
    ACTIONS(5894), 1,
      anon_sym_AT,
    ACTIONS(5897), 1,
      anon_sym_component,
    ACTIONS(5900), 1,
      anon_sym_instance,
    STATE(1390), 1,
      sym_decorator,
    STATE(3557), 1,
      aux_sym_class_repeat1,
    STATE(3941), 1,
      sym_component_instance,
    STATE(2729), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [84167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [84198] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(13), 1,
      anon_sym_component,
    ACTIONS(15), 1,
      anon_sym_instance,
    ACTIONS(5903), 1,
      ts_builtin_sym_end,
    STATE(1390), 1,
      sym_decorator,
    STATE(3557), 1,
      aux_sym_class_repeat1,
    STATE(3941), 1,
      sym_component_instance,
    STATE(2735), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [84233] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5907), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3441), 1,
      sym_type_annotation,
    STATE(3442), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3332), 1,
      sym_type_predicate,
    STATE(4553), 1,
      sym_predefined_type,
    ACTIONS(5909), 2,
      sym_identifier,
      sym_this,
    ACTIONS(113), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [84293] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5911), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3050), 1,
      sym__call_signature,
    STATE(3441), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84328] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(13), 1,
      anon_sym_component,
    ACTIONS(15), 1,
      anon_sym_instance,
    ACTIONS(5913), 1,
      ts_builtin_sym_end,
    STATE(1390), 1,
      sym_decorator,
    STATE(3557), 1,
      aux_sym_class_repeat1,
    STATE(3941), 1,
      sym_component_instance,
    STATE(2729), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [84363] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(13), 1,
      anon_sym_component,
    ACTIONS(15), 1,
      anon_sym_instance,
    ACTIONS(5903), 1,
      ts_builtin_sym_end,
    STATE(1390), 1,
      sym_decorator,
    STATE(3557), 1,
      aux_sym_class_repeat1,
    STATE(3941), 1,
      sym_component_instance,
    STATE(2729), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [84398] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4656), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [84426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3099), 1,
      sym__call_signature,
    STATE(3360), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 1,
      anon_sym_PIPE,
    ACTIONS(1142), 11,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [84514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84550] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3374), 1,
      sym_type_annotation,
    STATE(3375), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5917), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3422), 1,
      sym__call_signature,
    STATE(3423), 1,
      sym_type_annotation,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5919), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_DOT,
    ACTIONS(2491), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84724] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(2069), 1,
      anon_sym_EQ,
    ACTIONS(5741), 1,
      sym_identifier,
    ACTIONS(5743), 1,
      anon_sym_from,
    STATE(2701), 1,
      aux_sym_import_path_segment_repeat1,
    STATE(3878), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(5745), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2061), 4,
      anon_sym_as,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
  [84756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3216), 1,
      sym__call_signature,
    STATE(3350), 1,
      sym_type_annotation,
    STATE(3919), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3192), 1,
      sym__call_signature,
    STATE(3518), 1,
      sym_type_annotation,
    STATE(3702), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 1,
      anon_sym_is,
    ACTIONS(2327), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [84956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3409), 1,
      sym_type_annotation,
    STATE(3770), 1,
      sym__initializer,
    STATE(3771), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5927), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84992] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3350), 1,
      sym_type_annotation,
    STATE(3856), 1,
      sym__initializer,
    STATE(3906), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3114), 1,
      sym__call_signature,
    STATE(3423), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5919), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3435), 1,
      sym_type_annotation,
    STATE(3437), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5929), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85128] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3089), 1,
      sym__call_signature,
    STATE(3374), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5917), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 1,
      anon_sym_is,
    ACTIONS(2445), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3499), 1,
      sym__call_signature,
    STATE(3506), 1,
      sym_type_annotation,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5931), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85338] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5933), 1,
      anon_sym_QMARK,
    STATE(2584), 1,
      sym_type_arguments,
    STATE(4200), 1,
      sym_type_annotation,
    ACTIONS(2200), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85386] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3228), 1,
      sym__call_signature,
    STATE(3392), 1,
      sym_type_annotation,
    STATE(3818), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(5875), 1,
      anon_sym_DOT,
    STATE(2984), 1,
      sym_type_arguments,
    ACTIONS(2200), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3359), 1,
      sym__call_signature,
    STATE(3360), 1,
      sym_type_annotation,
    STATE(4034), 1,
      sym_type_parameters,
    ACTIONS(5915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3126), 1,
      sym__call_signature,
    STATE(3506), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5931), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_DOT,
    ACTIONS(2489), 1,
      anon_sym_PIPE,
    ACTIONS(2491), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3183), 1,
      sym__call_signature,
    STATE(3409), 1,
      sym_type_annotation,
    STATE(3785), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5927), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3235), 1,
      sym__call_signature,
    STATE(3539), 1,
      sym_type_annotation,
    STATE(3896), 1,
      sym__initializer,
    STATE(4133), 1,
      sym_type_parameters,
    ACTIONS(5938), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2895), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2863), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2859), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85778] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3051), 1,
      sym__call_signature,
    STATE(3435), 1,
      sym_type_annotation,
    STATE(4014), 1,
      sym_type_parameters,
    ACTIONS(5929), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2859), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2859), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_PIPE,
    ACTIONS(2632), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2851), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5857), 1,
      sym_identifier,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_PIPE,
    ACTIONS(5940), 1,
      anon_sym_LBRACK,
    ACTIONS(2646), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_PIPE,
    ACTIONS(5940), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(2624), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_RBRACE,
  [85985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_PIPE,
    ACTIONS(2654), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [86042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(2773), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(2765), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [86084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LT,
    STATE(2975), 1,
      sym_type_arguments,
    ACTIONS(2327), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2696), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      anon_sym_PIPE,
    ACTIONS(2606), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_PIPE,
    ACTIONS(2598), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_is,
    ACTIONS(2327), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_is,
    ACTIONS(2445), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 1,
      anon_sym_DOT,
    ACTIONS(5952), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2755), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_PIPE,
    ACTIONS(2550), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_PIPE,
    ACTIONS(2719), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_PIPE,
    ACTIONS(5954), 1,
      anon_sym_is,
    ACTIONS(2327), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_PIPE,
    ACTIONS(5755), 1,
      anon_sym_is,
    ACTIONS(2445), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2731), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 1,
      anon_sym_PIPE,
    ACTIONS(2883), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 1,
      anon_sym_PIPE,
    ACTIONS(2747), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_PIPE,
    ACTIONS(2761), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_PIPE,
    ACTIONS(2522), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_PIPE,
    ACTIONS(2765), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_PIPE,
    ACTIONS(2781), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(2999), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [86567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 1,
      anon_sym_PIPE,
    ACTIONS(2801), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86586] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_BQUOTE,
    ACTIONS(5658), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5660), 1,
      anon_sym_COLON,
    ACTIONS(5662), 1,
      anon_sym_EQ,
    STATE(1421), 1,
      sym_new_component_body,
    STATE(1432), 1,
      sym_tripple_tagged_type_string,
    STATE(1433), 1,
      sym_tagged_type_string,
    STATE(3288), 1,
      sym_component_identifier,
  [86623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(2650), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [86646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(2658), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [86669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [86705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_PIPE,
    ACTIONS(2835), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_PIPE,
    ACTIONS(2959), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_PIPE,
    ACTIONS(2967), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_PIPE,
    ACTIONS(2995), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_PIPE,
    ACTIONS(2999), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_PIPE,
    ACTIONS(2327), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_PIPE,
    ACTIONS(5940), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_PIPE,
    ACTIONS(3046), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_PIPE,
    ACTIONS(2445), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_PIPE,
    ACTIONS(2923), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_PIPE,
    ACTIONS(2935), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_PIPE,
    ACTIONS(3050), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_DOT,
    ACTIONS(2491), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [86954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_PIPE,
    ACTIONS(3026), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [86990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_PIPE,
    ACTIONS(3014), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5701), 1,
      anon_sym_is,
    ACTIONS(2445), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [87028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(2616), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [87051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_PIPE,
    ACTIONS(2975), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_is,
    ACTIONS(2327), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [87089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(2554), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [87108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_PIPE,
    ACTIONS(2821), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87146] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(5648), 1,
      anon_sym_COLON,
    ACTIONS(5650), 1,
      anon_sym_EQ,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_BQUOTE,
    ACTIONS(5658), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1421), 1,
      sym_new_component_body,
    STATE(1432), 1,
      sym_tripple_tagged_type_string,
    STATE(1433), 1,
      sym_tagged_type_string,
    STATE(3288), 1,
      sym_component_identifier,
  [87183] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5958), 1,
      sym_identifier,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    STATE(2141), 1,
      sym_class_body,
    STATE(3104), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4175), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_extends,
    ACTIONS(5644), 1,
      sym_identifier,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(5966), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2200), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [87245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87265] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(5972), 1,
      sym_identifier,
    STATE(2100), 1,
      sym_class_body,
    STATE(3047), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4252), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(2616), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [87321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_COLON,
    STATE(3279), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5980), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [87341] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(5984), 1,
      sym_identifier,
    STATE(2100), 1,
      sym_class_body,
    STATE(3047), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4252), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(2616), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87397] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5990), 1,
      anon_sym_BANG,
    ACTIONS(5994), 1,
      anon_sym_EQ,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3428), 1,
      sym__initializer,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [87445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      sym_identifier,
    STATE(2891), 1,
      sym_import_path_segment,
    ACTIONS(2263), 2,
      ts_builtin_sym_end,
      anon_sym_AT,
    ACTIONS(2261), 6,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_component,
      anon_sym_instance,
  [87467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5990), 1,
      anon_sym_BANG,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3898), 1,
      sym__initializer,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(2765), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [87517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(2773), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [87535] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(5998), 1,
      sym_identifier,
    STATE(2141), 1,
      sym_class_body,
    STATE(3104), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4175), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_DOT,
    STATE(2913), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2131), 8,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [87589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(6002), 1,
      anon_sym_LT,
    ACTIONS(6004), 1,
      anon_sym_is,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [87613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_PIPE,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(2554), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 1,
      anon_sym_is,
    ACTIONS(2445), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [87651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_is,
    ACTIONS(2327), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [87669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [87685] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6008), 1,
      sym_identifier,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(945), 1,
      sym_class_body,
    STATE(3036), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3968), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_COLON,
    STATE(3225), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6012), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [87739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(2650), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_extends,
  [87781] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6014), 1,
      sym_identifier,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(2283), 1,
      sym_class_body,
    STATE(3139), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4266), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2166), 8,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [87835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(2554), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [87853] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6018), 1,
      sym_identifier,
    STATE(899), 1,
      sym_class_body,
    STATE(3068), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4013), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(2658), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87909] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6020), 1,
      sym_identifier,
    STATE(2141), 1,
      sym_class_body,
    STATE(3104), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4175), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [87943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(2999), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [87965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      anon_sym_DOT,
    STATE(2897), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2159), 8,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [87985] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6031), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_class_body,
    STATE(3138), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4172), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(2650), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_PIPE,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(2554), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(2658), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(2616), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(2999), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6033), 1,
      sym_identifier,
    STATE(1702), 1,
      sym_class_body,
    STATE(3102), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4030), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(2999), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [88183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(2658), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [88205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(2765), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(2650), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [88269] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(5962), 1,
      anon_sym_extends,
    ACTIONS(5964), 1,
      anon_sym_implements,
    ACTIONS(6035), 1,
      sym_identifier,
    STATE(2100), 1,
      sym_class_body,
    STATE(3047), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4252), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(2773), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_DOT,
    STATE(2897), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2141), 8,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [88343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_DOT,
    STATE(2897), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2145), 8,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [88363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(2765), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [88385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      sym_identifier,
    ACTIONS(4637), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [88403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_PIPE,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(2773), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [88438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [88455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88470] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
  [88501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(613), 1,
      sym_class_body,
    STATE(3034), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4100), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88532] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2033), 1,
      sym_class_body,
    STATE(3094), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3952), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88593] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(737), 1,
      sym_class_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3951), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5134), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3427), 1,
      sym_type_annotation,
    STATE(3775), 1,
      sym__initializer,
    ACTIONS(5749), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88689] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5062), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    ACTIONS(6002), 1,
      anon_sym_LT,
    STATE(2584), 1,
      sym_type_arguments,
    ACTIONS(2200), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [88750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [88782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(2999), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [88833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88878] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1715), 1,
      sym_class_body,
    STATE(3070), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4219), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6055), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [88924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [88939] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2097), 1,
      sym_class_body,
    STATE(3100), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4066), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [88970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88985] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(967), 1,
      sym_class_body,
    STATE(3030), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4028), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [89016] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1701), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89041] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5080), 1,
      anon_sym_RBRACE,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89066] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(153), 1,
      sym_class_body,
    STATE(3046), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3992), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [89097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 1,
      anon_sym_LBRACE,
    ACTIONS(2801), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [89114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(2773), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [89146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3887), 1,
      aux_sym_object_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2769), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1646), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    ACTIONS(6063), 1,
      anon_sym_BQUOTE,
    STATE(861), 1,
      sym_new_component_body,
    STATE(896), 1,
      sym_tripple_tagged_type_string,
    STATE(937), 1,
      sym_tagged_type_string,
    STATE(3315), 1,
      sym_component_identifier,
  [89217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2765), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(2765), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [89253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_COLON,
    STATE(3509), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5980), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3395), 1,
      sym_type_annotation,
    STATE(3807), 1,
      sym__initializer,
    ACTIONS(5761), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5759), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_COLON,
    STATE(3511), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6012), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2747), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89376] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3409), 1,
      anon_sym_BQUOTE,
    ACTIONS(3411), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    STATE(1874), 1,
      sym_new_component_body,
    STATE(2050), 1,
      sym_tripple_tagged_type_string,
    STATE(2051), 1,
      sym_tagged_type_string,
    STATE(3260), 1,
      sym_component_identifier,
  [89407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(882), 1,
      sym_class_body,
    STATE(3037), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4113), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [89438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [89453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2821), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5994), 1,
      anon_sym_EQ,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3429), 1,
      sym__initializer,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(5654), 1,
      anon_sym_DOT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
  [89539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6069), 1,
      anon_sym_COLON,
    STATE(3279), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5980), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2285), 1,
      sym_class_body,
    STATE(3140), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4130), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [89589] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1671), 1,
      sym_class_body,
    STATE(3069), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4148), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [89620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6069), 1,
      anon_sym_COLON,
    STATE(3225), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6012), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_LBRACK,
    ACTIONS(2646), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6073), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [89701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(2650), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [89747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3349), 1,
      sym_type_annotation,
    STATE(3909), 1,
      sym__initializer,
    ACTIONS(5717), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5715), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2624), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(2616), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [89812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(2554), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [89874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [89923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6024), 1,
      anon_sym_PIPE,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(6075), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3487), 1,
      sym_type_annotation,
    STATE(3794), 1,
      sym__initializer,
    ACTIONS(5793), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3541), 1,
      sym_type_annotation,
    STATE(3892), 1,
      sym__initializer,
    ACTIONS(6079), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6077), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90024] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(151), 1,
      sym_class_body,
    STATE(3077), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4115), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6075), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_RBRACE,
  [90076] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2079), 1,
      sym_class_body,
    STATE(3049), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4250), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2696), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90122] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(651), 1,
      sym_class_body,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4265), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6081), 1,
      anon_sym_as,
    STATE(583), 1,
      sym_import_as,
    ACTIONS(2248), 7,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [90187] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(942), 1,
      sym_class_body,
    STATE(3073), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4023), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    STATE(3834), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90288] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2118), 1,
      sym_class_body,
    STATE(3116), 1,
      sym_type_parameters,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4203), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    STATE(3808), 1,
      aux_sym_object_repeat1,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [90344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_LBRACK,
    ACTIONS(2827), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    ACTIONS(5709), 1,
      anon_sym_DOT,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1697), 1,
      sym_tripple_tagged_type_string,
    STATE(1698), 1,
      sym_tagged_type_string,
    STATE(3202), 1,
      sym_component_identifier,
  [90392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3905), 1,
      sym__initializer,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(2658), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [90468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      sym_escape_sequence,
    ACTIONS(6085), 1,
      anon_sym_BQUOTE,
    ACTIONS(6087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6089), 1,
      sym__template_chars,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3490), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [90492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6091), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
    ACTIONS(6075), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90532] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6093), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6099), 1,
      anon_sym_enum,
    STATE(3647), 1,
      sym_variable_declarator,
    STATE(3076), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [90556] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      sym_escape_sequence,
    ACTIONS(6087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6089), 1,
      sym__template_chars,
    ACTIONS(6101), 1,
      anon_sym_BQUOTE,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3478), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [90580] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      sym_escape_sequence,
    ACTIONS(6087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6089), 1,
      sym__template_chars,
    ACTIONS(6103), 1,
      anon_sym_BQUOTE,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3478), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [90604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_LT,
    STATE(2586), 1,
      sym_type_arguments,
    ACTIONS(2327), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90622] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    ACTIONS(5990), 1,
      anon_sym_BANG,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3898), 1,
      sym__initializer,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      sym_escape_sequence,
    ACTIONS(6087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6089), 1,
      sym__template_chars,
    ACTIONS(6105), 1,
      anon_sym_BQUOTE,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3478), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [90670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5970), 1,
      anon_sym_PIPE,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6107), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90690] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      sym_escape_sequence,
    ACTIONS(6087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6089), 1,
      sym__template_chars,
    ACTIONS(6109), 1,
      anon_sym_BQUOTE,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3478), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [90714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4271), 1,
      sym_statement_block,
    ACTIONS(6113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6115), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [90744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_from,
    ACTIONS(4474), 1,
      anon_sym_DOT,
    ACTIONS(6117), 1,
      sym_identifier,
    ACTIONS(6119), 1,
      anon_sym_STAR,
    STATE(2880), 1,
      sym_import_path_segment,
    STATE(3002), 1,
      sym_import_path,
  [90769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(919), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3998), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [90807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [90820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6075), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [90839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(625), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4249), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6123), 1,
      sym_identifier,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    STATE(2138), 1,
      sym_component_body,
    STATE(3610), 1,
      sym_component_heritage,
    STATE(4190), 1,
      sym_component_identifier,
  [90889] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(944), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4024), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90914] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4268), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [90939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    ACTIONS(6129), 1,
      anon_sym_DOT,
    STATE(1384), 1,
      sym_arguments,
    ACTIONS(3987), 4,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_component,
  [90958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_LT,
    ACTIONS(6131), 1,
      anon_sym_LBRACE,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(6135), 1,
      anon_sym_DOT,
    ACTIONS(6137), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3684), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3703), 1,
      sym_type_arguments,
  [90983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(3373), 1,
      sym_type_annotation,
    ACTIONS(6139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [91013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_EQ,
    ACTIONS(3533), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [91028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4137), 1,
      sym_statement_block,
    ACTIONS(6145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6147), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_variable_declarator,
    STATE(3076), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [91066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [91079] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4037), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2076), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4247), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91129] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(715), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4163), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91154] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2065), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4164), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4094), 1,
      sym_statement_block,
    ACTIONS(6145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4134), 1,
      sym_statement_block,
    ACTIONS(6151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6153), 1,
      sym_identifier,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(940), 1,
      sym_component_body,
    STATE(3584), 1,
      sym_component_heritage,
    STATE(3969), 1,
      sym_component_identifier,
  [91238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(3382), 1,
      sym_type_annotation,
    ACTIONS(6157), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(620), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4185), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6147), 1,
      sym_identifier,
    STATE(3647), 1,
      sym_variable_declarator,
    STATE(3076), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [91301] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6161), 1,
      anon_sym_COLON,
    ACTIONS(6163), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym__call_signature,
  [91326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
  [91339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    ACTIONS(6171), 1,
      anon_sym_QMARK,
    STATE(3562), 1,
      sym_type_annotation,
    STATE(4105), 1,
      sym__initializer,
    ACTIONS(6165), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [91362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6173), 1,
      sym_identifier,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2287), 1,
      sym_component_body,
    STATE(3691), 1,
      sym_component_heritage,
    STATE(4260), 1,
      sym_component_identifier,
  [91387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym_EQ,
    ACTIONS(3579), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [91402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6073), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [91415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3350), 1,
      sym_type_annotation,
    STATE(3921), 1,
      sym__initializer,
    ACTIONS(5921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3539), 1,
      sym_type_annotation,
    STATE(3888), 1,
      sym__initializer,
    ACTIONS(5938), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [91470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6180), 1,
      anon_sym_is,
    ACTIONS(2327), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_is,
    ACTIONS(2445), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    STATE(1404), 1,
      sym_arguments,
    ACTIONS(3003), 5,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [91517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(946), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3953), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1682), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4238), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1636), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4092), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [91609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4275), 1,
      sym_statement_block,
    ACTIONS(6182), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91626] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(956), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4036), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6184), 1,
      sym_identifier,
    STATE(2099), 1,
      sym_component_body,
    STATE(3667), 1,
      sym_component_heritage,
    STATE(4283), 1,
      sym_component_identifier,
  [91676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6186), 1,
      sym_identifier,
    STATE(3647), 1,
      sym_variable_declarator,
    STATE(3013), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [91697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3905), 1,
      sym__initializer,
    ACTIONS(5988), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91718] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4212), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [91743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [91756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(3971), 1,
      sym_statement_block,
    ACTIONS(6188), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6190), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_variable_declarator,
    STATE(2968), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [91794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3540), 1,
      sym_type_annotation,
    STATE(3944), 1,
      sym__initializer,
    ACTIONS(6192), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(3966), 1,
      sym_statement_block,
    ACTIONS(6194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91832] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6196), 1,
      sym_identifier,
    ACTIONS(6198), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4031), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [91857] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6200), 1,
      sym_identifier,
    ACTIONS(6202), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4181), 1,
      sym__call_signature,
  [91882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    ACTIONS(6204), 1,
      sym_identifier,
    STATE(1695), 1,
      sym_component_body,
    STATE(3649), 1,
      sym_component_heritage,
    STATE(4032), 1,
      sym_component_identifier,
  [91907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(6206), 1,
      sym_identifier,
    ACTIONS(6208), 1,
      anon_sym_DOT,
    STATE(695), 1,
      sym__module,
    STATE(3524), 1,
      sym_nested_identifier,
    STATE(3681), 1,
      sym_string,
  [91932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4079), 1,
      sym_statement_block,
    ACTIONS(6194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91949] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1011), 1,
      anon_sym_LBRACE,
    ACTIONS(6210), 1,
      anon_sym_LT,
    ACTIONS(6212), 1,
      anon_sym_extends,
    STATE(865), 1,
      sym_object_type,
    STATE(3476), 1,
      sym_type_parameters,
    STATE(3713), 1,
      sym_extends_type_clause,
  [91974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4090), 1,
      sym_statement_block,
    ACTIONS(6188), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3392), 1,
      sym_type_annotation,
    STATE(3816), 1,
      sym__initializer,
    ACTIONS(5936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92012] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    ACTIONS(6214), 1,
      sym_identifier,
    STATE(932), 1,
      sym_component_body,
    STATE(3626), 1,
      sym_component_heritage,
    STATE(3988), 1,
      sym_component_identifier,
  [92037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6055), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [92050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6075), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [92069] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2055), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4055), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6216), 1,
      sym_identifier,
    ACTIONS(6218), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4181), 1,
      sym__call_signature,
  [92119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [92132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [92145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4136), 1,
      sym_statement_block,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4089), 1,
      sym_statement_block,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2139), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4072), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    ACTIONS(6097), 1,
      anon_sym_LBRACK,
    ACTIONS(6147), 1,
      sym_identifier,
    STATE(3861), 1,
      sym_variable_declarator,
    STATE(3076), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [92225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1669), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4150), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92250] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6224), 1,
      sym_identifier,
    ACTIONS(6226), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4151), 1,
      sym__call_signature,
  [92275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2116), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4209), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4087), 1,
      sym_statement_block,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92317] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6228), 1,
      sym_identifier,
    STATE(2138), 1,
      sym_component_body,
    STATE(3610), 1,
      sym_component_heritage,
    STATE(4190), 1,
      sym_component_identifier,
  [92342] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6230), 1,
      sym_identifier,
    ACTIONS(6232), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4217), 1,
      sym__call_signature,
  [92367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4122), 1,
      sym_statement_block,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92384] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    ACTIONS(6208), 1,
      anon_sym_DOT,
    ACTIONS(6234), 1,
      sym_identifier,
    STATE(570), 1,
      sym_nested_identifier,
    STATE(640), 1,
      sym_string,
    STATE(695), 1,
      sym__module,
  [92409] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6236), 1,
      sym_identifier,
    ACTIONS(6238), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4217), 1,
      sym__call_signature,
  [92434] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3518), 1,
      sym_type_annotation,
    STATE(3769), 1,
      sym__initializer,
    ACTIONS(5923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [92468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4241), 1,
      sym_statement_block,
    ACTIONS(6240), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4085), 1,
      sym_statement_block,
    ACTIONS(6113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4082), 1,
      sym_statement_block,
    ACTIONS(6240), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2091), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4258), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_LT,
    ACTIONS(6212), 1,
      anon_sym_extends,
    ACTIONS(6242), 1,
      anon_sym_LBRACE,
    ACTIONS(6244), 1,
      anon_sym_LBRACE_PIPE,
    STATE(865), 1,
      sym_object_type,
    STATE(3339), 1,
      sym_type_parameters,
    STATE(3934), 1,
      sym_extends_type_clause,
  [92569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_extends,
    ACTIONS(6246), 1,
      sym_identifier,
    ACTIONS(6248), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2327), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [92588] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6250), 1,
      sym_identifier,
    ACTIONS(6252), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4217), 1,
      sym__call_signature,
  [92613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6254), 1,
      sym_identifier,
    ACTIONS(6256), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4181), 1,
      sym__call_signature,
  [92638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5864), 1,
      anon_sym_EQ,
    STATE(3571), 1,
      sym_constraint,
    STATE(4126), 1,
      sym_default_type,
    ACTIONS(5862), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(6258), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [92659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
  [92672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4156), 1,
      sym_statement_block,
    ACTIONS(6260), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4145), 1,
      sym_statement_block,
    ACTIONS(6262), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6264), 1,
      sym_identifier,
    ACTIONS(6266), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3954), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [92731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4080), 1,
      sym_statement_block,
    ACTIONS(6260), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5755), 1,
      anon_sym_is,
    ACTIONS(6268), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6270), 1,
      sym_identifier,
    STATE(2138), 1,
      sym_component_body,
    STATE(3610), 1,
      sym_component_heritage,
    STATE(4190), 1,
      sym_component_identifier,
  [92788] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6272), 1,
      sym_identifier,
    STATE(2099), 1,
      sym_component_body,
    STATE(3667), 1,
      sym_component_heritage,
    STATE(4283), 1,
      sym_component_identifier,
  [92813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4106), 1,
      sym_statement_block,
    ACTIONS(6274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4103), 1,
      sym_statement_block,
    ACTIONS(6276), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4173), 1,
      sym_statement_block,
    ACTIONS(6278), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6280), 1,
      sym_identifier,
    STATE(2099), 1,
      sym_component_body,
    STATE(3667), 1,
      sym_component_heritage,
    STATE(4283), 1,
      sym_component_identifier,
  [92889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_BQUOTE,
    ACTIONS(2417), 6,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [92904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    STATE(1405), 1,
      sym_arguments,
    ACTIONS(2704), 5,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [92921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(3366), 1,
      sym_type_annotation,
    ACTIONS(6282), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [92951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(1718), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4218), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [92976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2303), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(4129), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [93001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    ACTIONS(6043), 1,
      anon_sym_extends,
    ACTIONS(6045), 1,
      anon_sym_implements,
    STATE(2277), 1,
      sym_class_body,
    STATE(3726), 1,
      sym_extends_clause,
    STATE(3964), 1,
      sym_class_heritage,
    STATE(4527), 1,
      sym_implements_clause,
  [93026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(3445), 1,
      sym_type_annotation,
    ACTIONS(6284), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6163), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym__call_signature,
  [93068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6288), 1,
      sym_identifier,
    ACTIONS(6290), 1,
      anon_sym_STAR,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3959), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [93093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    ACTIONS(6292), 1,
      sym_identifier,
    STATE(1646), 1,
      sym_component_body,
    STATE(3594), 1,
      sym_component_heritage,
    STATE(4176), 1,
      sym_component_identifier,
  [93118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3409), 1,
      sym_type_annotation,
    STATE(3789), 1,
      sym__initializer,
    ACTIONS(5927), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6294), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4159), 1,
      sym__call_signature,
  [93161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6296), 1,
      sym_identifier,
    ACTIONS(6298), 1,
      anon_sym_import,
    STATE(1510), 1,
      sym__type_query_member_expression,
    STATE(1515), 1,
      sym__type_query_subscript_expression,
    STATE(1535), 1,
      sym__type_query_call_expression,
    STATE(3984), 1,
      sym_import,
  [93183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2410), 1,
      sym_statement_block,
    ACTIONS(6222), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6115), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2417), 1,
      sym_statement_block,
    ACTIONS(6274), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 1,
      anon_sym_is,
    ACTIONS(6268), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6308), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6302), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6310), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3358), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [93281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3281), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6314), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3447), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [93319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3184), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6318), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6316), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(2765), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [93353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(2773), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [93367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4235), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6326), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_BQUOTE,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6328), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3335), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_component_body,
    STATE(3679), 1,
      sym_component_heritage,
    STATE(4216), 1,
      sym_component_identifier,
  [93435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3529), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [93453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2275), 1,
      sym_component_body,
    STATE(3545), 1,
      sym_component_heritage,
    STATE(4127), 1,
      sym_component_identifier,
  [93475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3364), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [93493] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6338), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3965), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [93515] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1657), 1,
      sym_component_body,
    STATE(3590), 1,
      sym_component_heritage,
    STATE(4166), 1,
      sym_component_identifier,
  [93537] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6340), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4236), 1,
      sym__call_signature,
  [93559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2397), 1,
      sym_statement_block,
    ACTIONS(6240), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2416), 1,
      sym_statement_block,
    ACTIONS(6276), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3239), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6342), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2407), 1,
      sym_statement_block,
    ACTIONS(6220), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6344), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_GT,
  [93653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6346), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3212), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [93675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4245), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93691] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6350), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3955), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [93713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3323), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6354), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6352), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6356), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3124), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [93751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4637), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6358), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93781] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6362), 1,
      anon_sym_QMARK,
    ACTIONS(6360), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [93801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2412), 1,
      sym_statement_block,
    ACTIONS(6222), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4237), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6364), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6366), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4257), 1,
      sym__call_signature,
  [93871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4135), 1,
      sym__call_signature,
  [93893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6370), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4220), 1,
      sym__call_signature,
  [93915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6376), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6372), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3264), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [93933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      sym_component_body,
    STATE(3556), 1,
      sym_component_heritage,
    STATE(3973), 1,
      sym_component_identifier,
  [93955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6380), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3907), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [93977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2422), 1,
      sym_statement_block,
    ACTIONS(6113), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93993] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_catch,
    ACTIONS(6384), 1,
      anon_sym_finally,
    STATE(670), 1,
      sym_finally_clause,
    STATE(3546), 1,
      sym_catch_clause,
    ACTIONS(2102), 2,
      anon_sym_else,
      anon_sym_while,
  [94013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6386), 1,
      anon_sym_class,
    ACTIONS(6388), 1,
      anon_sym_abstract,
    ACTIONS(6390), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [94035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6342), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6394), 1,
      anon_sym_BQUOTE,
    ACTIONS(6392), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3262), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6396), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3258), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [94091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6398), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4220), 1,
      sym__call_signature,
  [94113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6400), 1,
      anon_sym_COMMA,
    ACTIONS(6402), 1,
      anon_sym_GT,
    STATE(3926), 1,
      aux_sym_implements_clause_repeat1,
  [94135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6404), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3173), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [94157] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6388), 1,
      anon_sym_abstract,
    ACTIONS(6406), 1,
      anon_sym_class,
    ACTIONS(6408), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [94179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3444), 1,
      anon_sym_BQUOTE,
    STATE(1585), 1,
      sym_new_component_body,
    STATE(1658), 1,
      sym_tripple_tagged_type_string,
    STATE(1659), 1,
      sym_tagged_type_string,
  [94201] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6410), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3113), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [94223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_RBRACE,
    ACTIONS(6414), 1,
      anon_sym_case,
    ACTIONS(6416), 1,
      anon_sym_default,
    STATE(3307), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [94241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    ACTIONS(6234), 1,
      sym_identifier,
    STATE(570), 1,
      sym_nested_identifier,
    STATE(640), 1,
      sym_string,
    STATE(691), 1,
      sym__module,
  [94263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6420), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6418), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3231), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6388), 1,
      anon_sym_abstract,
    ACTIONS(6426), 1,
      anon_sym_class,
    ACTIONS(6428), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [94321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4229), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6430), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6432), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3276), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [94359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2409), 1,
      sym_statement_block,
    ACTIONS(6240), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4251), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6438), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3310), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [94431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6440), 1,
      anon_sym_COMMA,
    ACTIONS(6442), 1,
      anon_sym_GT,
    STATE(3904), 1,
      aux_sym_implements_clause_repeat1,
  [94453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2400), 1,
      sym_statement_block,
    ACTIONS(6188), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6444), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3098), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [94491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6446), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4002), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [94513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    STATE(2098), 1,
      sym_component_body,
    STATE(3630), 1,
      sym_component_heritage,
    STATE(4068), 1,
      sym_component_identifier,
  [94535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6448), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3421), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [94557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6450), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 1,
      anon_sym_case,
    ACTIONS(6416), 1,
      anon_sym_default,
    ACTIONS(6452), 1,
      anon_sym_RBRACE,
    STATE(3204), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [94591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_statement_block,
    ACTIONS(6220), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3195), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6456), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6454), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_import,
    ACTIONS(6460), 1,
      sym_identifier,
    STATE(2531), 1,
      sym__type_query_member_expression,
    STATE(2532), 1,
      sym__type_query_subscript_expression,
    STATE(2572), 1,
      sym__type_query_call_expression,
    STATE(4041), 1,
      sym_import,
  [94657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6464), 1,
      anon_sym_BQUOTE,
    ACTIONS(6462), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3233), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2421), 1,
      sym_statement_block,
    ACTIONS(6151), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6468), 1,
      anon_sym_BQUOTE,
    ACTIONS(6466), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3285), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6470), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3543), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [94731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6474), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6472), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 6,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_component,
  [94761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6476), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6478), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4220), 1,
      sym__call_signature,
  [94801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2403), 1,
      sym_statement_block,
    ACTIONS(6260), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6480), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3082), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [94839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6482), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6472), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    STATE(2034), 1,
      sym_component_body,
    STATE(3690), 1,
      sym_component_heritage,
    STATE(4047), 1,
      sym_component_identifier,
  [94879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6484), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6308), 1,
      anon_sym_BQUOTE,
    ACTIONS(6489), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6486), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [94913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3537), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [94931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    ACTIONS(6492), 1,
      anon_sym_QMARK,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3170), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [94953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_import,
    ACTIONS(6494), 1,
      sym_identifier,
    STATE(2594), 1,
      sym__type_query_member_expression,
    STATE(2623), 1,
      sym__type_query_subscript_expression,
    STATE(2703), 1,
      sym__type_query_call_expression,
    STATE(4197), 1,
      sym_import,
  [94975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(6206), 1,
      sym_identifier,
    STATE(691), 1,
      sym__module,
    STATE(3524), 1,
      sym_nested_identifier,
    STATE(3681), 1,
      sym_string,
  [94997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(2999), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [95015] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_import,
    ACTIONS(6496), 1,
      sym_identifier,
    STATE(2709), 1,
      sym__type_query_subscript_expression,
    STATE(2710), 1,
      sym__type_query_member_expression,
    STATE(2818), 1,
      sym__type_query_call_expression,
    STATE(3977), 1,
      sym_import,
  [95037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_component_body,
    STATE(3637), 1,
      sym_component_heritage,
    STATE(4120), 1,
      sym_component_identifier,
  [95059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6498), 1,
      anon_sym_BQUOTE,
    ACTIONS(6083), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3207), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6500), 1,
      anon_sym_COMMA,
    ACTIONS(6502), 1,
      anon_sym_GT,
    STATE(3918), 1,
      aux_sym_implements_clause_repeat1,
  [95099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3160), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6358), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6504), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4233), 1,
      sym__call_signature,
  [95137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6506), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4147), 1,
      sym__call_signature,
  [95159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6508), 1,
      anon_sym_COMMA,
    ACTIONS(6510), 1,
      anon_sym_GT,
    STATE(3806), 1,
      aux_sym_implements_clause_repeat1,
  [95181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3176), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6514), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6512), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2411), 1,
      sym_statement_block,
    ACTIONS(6182), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6516), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3131), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [95235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3416), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [95253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_statement_block,
    ACTIONS(6262), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4219), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6518), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95285] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3409), 1,
      anon_sym_BQUOTE,
    ACTIONS(3411), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1864), 1,
      sym_new_component_body,
    STATE(2037), 1,
      sym_tripple_tagged_type_string,
    STATE(2038), 1,
      sym_tagged_type_string,
  [95307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2423), 1,
      sym_statement_block,
    ACTIONS(6260), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6520), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2408), 1,
      sym_statement_block,
    ACTIONS(6113), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6522), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6472), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6524), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4284), 1,
      sym__call_signature,
  [95397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(2650), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [95415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(2658), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [95433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3413), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [95451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3412), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [95469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2414), 1,
      sym_statement_block,
    ACTIONS(6145), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6526), 1,
      anon_sym_LBRACE,
    ACTIONS(6528), 1,
      anon_sym_COMMA,
    STATE(3715), 1,
      aux_sym_implements_clause_repeat1,
  [95507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6530), 1,
      anon_sym_COMMA,
    ACTIONS(6532), 1,
      anon_sym_GT,
    STATE(3930), 1,
      aux_sym_implements_clause_repeat1,
  [95529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6534), 1,
      anon_sym_QMARK,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4144), 1,
      sym__call_signature,
  [95551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(2554), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [95565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_component_body,
    STATE(3657), 1,
      sym_component_heritage,
    STATE(4022), 1,
      sym_component_identifier,
  [95587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2429), 1,
      sym_statement_block,
    ACTIONS(6194), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6538), 1,
      anon_sym_QMARK,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3043), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [95625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(2616), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [95667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4243), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6544), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3386), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [95701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6546), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3772), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [95723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6548), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3384), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [95745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6550), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6554), 1,
      anon_sym_BQUOTE,
    ACTIONS(6552), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3330), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6558), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6556), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3328), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(5656), 1,
      anon_sym_BQUOTE,
    ACTIONS(5658), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1422), 1,
      sym_new_component_body,
    STATE(1443), 1,
      sym_tripple_tagged_type_string,
    STATE(1452), 1,
      sym_tagged_type_string,
  [95821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(902), 1,
      sym_component_body,
    STATE(3568), 1,
      sym_component_heritage,
    STATE(3961), 1,
      sym_component_identifier,
  [95843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2428), 1,
      sym_statement_block,
    ACTIONS(6188), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(2797), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [95875] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6560), 1,
      anon_sym_COMMA,
    ACTIONS(6562), 1,
      anon_sym_GT,
    STATE(3787), 1,
      aux_sym_implements_clause_repeat1,
  [95897] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6564), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4257), 1,
      sym__call_signature,
  [95919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3181), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6568), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6566), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(6570), 1,
      sym_identifier,
    ACTIONS(6572), 1,
      anon_sym_LBRACK,
    STATE(3827), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [95953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(3688), 1,
      sym_type_annotation,
    STATE(4269), 1,
      sym__initializer,
    ACTIONS(6574), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_import,
    ACTIONS(6576), 1,
      sym_identifier,
    STATE(597), 1,
      sym__type_query_member_expression,
    STATE(661), 1,
      sym__type_query_subscript_expression,
    STATE(758), 1,
      sym__type_query_call_expression,
    STATE(4149), 1,
      sym_import,
  [95995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_import,
    ACTIONS(6578), 1,
      sym_identifier,
    STATE(1789), 1,
      sym__type_query_member_expression,
    STATE(1790), 1,
      sym__type_query_subscript_expression,
    STATE(1858), 1,
      sym__type_query_call_expression,
    STATE(4040), 1,
      sym_import,
  [96017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3185), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4245), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3312), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6582), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3221), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6586), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6584), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    ACTIONS(6590), 1,
      anon_sym_GT,
    STATE(3849), 1,
      aux_sym_implements_clause_repeat1,
  [96087] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_LT,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(6592), 1,
      anon_sym_LBRACE,
    ACTIONS(6594), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3683), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3837), 1,
      sym_type_arguments,
  [96109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6596), 1,
      anon_sym_AT,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
    ACTIONS(3980), 3,
      anon_sym_class,
      anon_sym_abstract,
      anon_sym_component,
  [96127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    ACTIONS(6599), 1,
      sym_identifier,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4257), 1,
      sym__call_signature,
  [96149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    STATE(2074), 1,
      sym_component_body,
    STATE(3701), 1,
      sym_component_heritage,
    STATE(4246), 1,
      sym_component_identifier,
  [96171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym_RBRACE,
    ACTIONS(6603), 1,
      anon_sym_case,
    ACTIONS(6606), 1,
      anon_sym_default,
    STATE(3307), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [96189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    ACTIONS(6127), 1,
      anon_sym_LT,
    STATE(2108), 1,
      sym_component_body,
    STATE(3655), 1,
      sym_component_heritage,
    STATE(4229), 1,
      sym_component_identifier,
  [96211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2413), 1,
      sym_statement_block,
    ACTIONS(6194), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      sym_statement_block,
    ACTIONS(6145), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6612), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6609), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6614), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [96287] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(548), 1,
      sym_component_body,
    STATE(3615), 1,
      sym_component_heritage,
    STATE(3985), 1,
      sym_component_identifier,
  [96309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    ACTIONS(6063), 1,
      anon_sym_BQUOTE,
    STATE(742), 1,
      sym_new_component_body,
    STATE(898), 1,
      sym_tripple_tagged_type_string,
    STATE(901), 1,
      sym_tagged_type_string,
  [96331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3498), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [96349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3259), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6614), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3209), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6616), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6127), 1,
      anon_sym_LT,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(954), 1,
      sym_component_body,
    STATE(3663), 1,
      sym_component_heritage,
    STATE(4025), 1,
      sym_component_identifier,
  [96403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    ACTIONS(6334), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6336), 1,
      anon_sym_QMARK_COLON,
    STATE(3497), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [96421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6620), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6618), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3237), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    STATE(2396), 1,
      sym_statement_block,
    ACTIONS(6278), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3311), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6616), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96471] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    ACTIONS(6622), 1,
      anon_sym_QMARK,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3495), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [96493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(6572), 1,
      anon_sym_LBRACK,
    ACTIONS(6624), 1,
      sym_identifier,
    STATE(4227), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [96511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6628), 1,
      anon_sym_BQUOTE,
    ACTIONS(6626), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3211), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3213), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6450), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6630), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6472), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3152), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(6572), 1,
      anon_sym_LBRACK,
    ACTIONS(6632), 1,
      sym_identifier,
    STATE(3677), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [96581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6634), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_LBRACE,
    ACTIONS(6572), 1,
      anon_sym_LBRACK,
    ACTIONS(6636), 1,
      sym_identifier,
    STATE(3709), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [96617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5711), 1,
      anon_sym_is,
    ACTIONS(6268), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_LT,
    ACTIONS(6135), 1,
      anon_sym_DOT,
    ACTIONS(6638), 1,
      anon_sym_LBRACE,
    STATE(3703), 1,
      sym_type_arguments,
    ACTIONS(6640), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [96663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6642), 1,
      anon_sym_BQUOTE,
    ACTIONS(6422), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3240), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3290), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [96700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym_BQUOTE,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6648), 1,
      sym__template_chars,
    STATE(3490), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4966), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [96728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6212), 1,
      anon_sym_extends,
    ACTIONS(6242), 1,
      anon_sym_LBRACE,
    ACTIONS(6244), 1,
      anon_sym_LBRACE_PIPE,
    STATE(888), 1,
      sym_object_type,
    STATE(3811), 1,
      sym_extends_type_clause,
  [96747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6650), 1,
      anon_sym_BQUOTE,
    ACTIONS(6652), 1,
      sym__template_chars,
    STATE(3344), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3391), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [96783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4128), 1,
      sym__call_signature,
  [96802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3148), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [96821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6654), 1,
      anon_sym_BQUOTE,
    ACTIONS(6656), 1,
      sym__template_chars,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6658), 1,
      anon_sym_LBRACE,
    ACTIONS(6660), 1,
      anon_sym_SEMI,
    ACTIONS(6662), 1,
      sym__automatic_semicolon,
    ACTIONS(6664), 1,
      sym__function_signature_automatic_semicolon,
    STATE(159), 1,
      sym_statement_block,
  [96857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4084), 1,
      sym__call_signature,
  [96876] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3383), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [96895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    STATE(3067), 1,
      sym_new_component_body,
    STATE(3986), 1,
      sym_component_identifier,
  [96914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3784), 1,
      sym__initializer,
    ACTIONS(6666), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3783), 1,
      sym__initializer,
    ACTIONS(6668), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96944] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3774), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [96963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6670), 5,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [96974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3862), 1,
      sym__initializer,
    ACTIONS(6672), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6656), 1,
      sym__template_chars,
    ACTIONS(6674), 1,
      anon_sym_BQUOTE,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3417), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [97036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_COLON,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(6676), 1,
      anon_sym_RBRACE,
    STATE(3890), 1,
      aux_sym_object_pattern_repeat1,
  [97055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    STATE(1458), 1,
      sym_statement_block,
    STATE(4044), 1,
      sym_typed_function_return_type,
    STATE(4367), 1,
      sym_type_annotation,
  [97107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6682), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6686), 1,
      anon_sym_RPAREN,
    STATE(3838), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [97157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6690), 1,
      anon_sym_BQUOTE,
    ACTIONS(6692), 1,
      sym__template_chars,
    STATE(3354), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6694), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [97202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6698), 1,
      anon_sym_PIPE,
    ACTIONS(6696), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [97230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6656), 1,
      sym__template_chars,
    ACTIONS(6700), 1,
      anon_sym_BQUOTE,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4243), 1,
      sym__call_signature,
  [97266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6704), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6708), 1,
      anon_sym_EQ_GT,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [97314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(6713), 1,
      sym_identifier,
    ACTIONS(6715), 1,
      anon_sym_LBRACK,
    ACTIONS(6717), 1,
      sym_private_property_identifier,
    STATE(974), 1,
      sym_arguments,
  [97344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6719), 1,
      anon_sym_EQ_GT,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [97359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6722), 1,
      anon_sym_EQ_GT,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [97374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6658), 1,
      anon_sym_LBRACE,
    ACTIONS(6727), 1,
      anon_sym_SEMI,
    ACTIONS(6729), 1,
      sym__automatic_semicolon,
    ACTIONS(6731), 1,
      sym__function_signature_automatic_semicolon,
    STATE(176), 1,
      sym_statement_block,
  [97415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3355), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [97445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
    ACTIONS(6735), 1,
      anon_sym_as,
    ACTIONS(6737), 1,
      anon_sym_RBRACK,
  [97475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97486] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3472), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [97505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4261), 1,
      sym__call_signature,
  [97524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_SEMI,
    ACTIONS(6662), 1,
      sym__automatic_semicolon,
    ACTIONS(6664), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6739), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_statement_block,
  [97543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3903), 1,
      sym__initializer,
    ACTIONS(6741), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6743), 1,
      anon_sym_class,
    ACTIONS(6745), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [97577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    ACTIONS(6747), 1,
      anon_sym_COMMA,
    ACTIONS(6749), 1,
      anon_sym_RBRACE,
    STATE(3720), 1,
      aux_sym_enum_body_repeat1,
    STATE(4273), 1,
      sym__initializer,
  [97596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3914), 1,
      sym__initializer,
    ACTIONS(6751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [97622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [97633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [97644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3956), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [97663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      anon_sym_EQ_GT,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [97678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6656), 1,
      sym__template_chars,
    ACTIONS(6755), 1,
      anon_sym_BQUOTE,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6757), 1,
      anon_sym_class,
    ACTIONS(6759), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [97714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [97725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6761), 1,
      anon_sym_BQUOTE,
    ACTIONS(6763), 1,
      sym__template_chars,
    STATE(3478), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4242), 1,
      sym__call_signature,
  [97761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(3967), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [97780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3263), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [97799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_LBRACE,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [97814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3768), 1,
      sym__initializer,
    ACTIONS(6767), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3345), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [97848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3819), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [97867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6769), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6771), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4004), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [97908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6773), 1,
      anon_sym_BQUOTE,
    ACTIONS(6775), 1,
      sym__template_chars,
    STATE(3401), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [97925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6777), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [97966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3489), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [97985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [98002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6698), 1,
      anon_sym_PIPE,
    ACTIONS(6785), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3781), 1,
      sym__initializer,
    ACTIONS(6787), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_in,
    ACTIONS(6793), 1,
      anon_sym_of,
    ACTIONS(6789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_in,
    ACTIONS(6797), 1,
      anon_sym_of,
    ACTIONS(6789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [98130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    STATE(1466), 1,
      sym_statement_block,
    STATE(4053), 1,
      sym_typed_function_return_type,
    STATE(4367), 1,
      sym_type_annotation,
  [98149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    STATE(1461), 1,
      sym_statement_block,
    STATE(4056), 1,
      sym_typed_function_return_type,
    STATE(4367), 1,
      sym_type_annotation,
  [98168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4093), 1,
      sym__call_signature,
  [98187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6799), 1,
      anon_sym_EQ_GT,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [98202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6804), 1,
      anon_sym_EQ_GT,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [98228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6807), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [98256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6809), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [98273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4035), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [98325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4161), 1,
      sym__call_signature,
  [98344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6815), 1,
      anon_sym_BQUOTE,
    ACTIONS(6817), 1,
      sym__template_chars,
    STATE(3371), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [98372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3388), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [98402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3474), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [98421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3079), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [98440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [98451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3821), 1,
      sym__initializer,
    ACTIONS(6819), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    ACTIONS(6821), 1,
      sym_identifier,
    ACTIONS(6823), 1,
      anon_sym_LBRACK,
    ACTIONS(6825), 1,
      sym_private_property_identifier,
    STATE(1653), 1,
      sym_arguments,
  [98485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3486), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [98504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_EQ_GT,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [98519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4060), 1,
      sym__call_signature,
    STATE(4069), 1,
      sym_type_parameters,
  [98538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6827), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [98549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6831), 1,
      anon_sym_EQ_GT,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [98575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6807), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [98592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4188), 1,
      sym__call_signature,
  [98611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4263), 1,
      sym__call_signature,
  [98630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4071), 1,
      sym__call_signature,
  [98649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4259), 1,
      sym__call_signature,
  [98668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3473), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [98687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6834), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [98704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3468), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [98723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_SEMI,
    ACTIONS(6662), 1,
      sym__automatic_semicolon,
    ACTIONS(6664), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6836), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_statement_block,
  [98742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6838), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [98759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [98770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [98781] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      anon_sym_SEMI,
    ACTIONS(6729), 1,
      sym__automatic_semicolon,
    ACTIONS(6731), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6739), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_statement_block,
  [98800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      anon_sym_SEMI,
    ACTIONS(6729), 1,
      sym__automatic_semicolon,
    ACTIONS(6731), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6836), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_statement_block,
  [98819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_SEMI,
    ACTIONS(6662), 1,
      sym__automatic_semicolon,
    ACTIONS(6664), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2061), 1,
      sym_statement_block,
  [98838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [98849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1011), 1,
      anon_sym_LBRACE,
    ACTIONS(6212), 1,
      anon_sym_extends,
    STATE(888), 1,
      sym_object_type,
    STATE(3802), 1,
      sym_extends_type_clause,
  [98868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [98879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6656), 1,
      sym__template_chars,
    ACTIONS(6842), 1,
      anon_sym_BQUOTE,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [98896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4138), 1,
      sym__call_signature,
  [98915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6844), 1,
      anon_sym_class,
    ACTIONS(6846), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [98934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3108), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [98953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4146), 1,
      sym__call_signature,
  [98972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4225), 1,
      sym__call_signature,
  [98991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3261), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [99010] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    STATE(1448), 1,
      sym_statement_block,
    STATE(4168), 1,
      sym_typed_function_return_type,
    STATE(4367), 1,
      sym_type_annotation,
  [99029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      anon_sym_SEMI,
    ACTIONS(6729), 1,
      sym__automatic_semicolon,
    ACTIONS(6731), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2121), 1,
      sym_statement_block,
  [99048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3889), 1,
      sym__initializer,
    ACTIONS(6848), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6850), 1,
      anon_sym_BQUOTE,
    ACTIONS(6852), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6855), 1,
      sym__template_chars,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [99080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6656), 1,
      sym__template_chars,
    ACTIONS(6858), 1,
      anon_sym_BQUOTE,
    STATE(3488), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [99108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5683), 1,
      anon_sym_LBRACK,
    ACTIONS(6860), 1,
      anon_sym_RBRACE,
    ACTIONS(2827), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3526), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [99142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      anon_sym_LBRACE,
    ACTIONS(6765), 1,
      anon_sym_COLON,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [99157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3027), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [99176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_DOT,
    ACTIONS(2489), 1,
      anon_sym_LBRACE,
    ACTIONS(2491), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [99202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6862), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_COLON,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(6866), 1,
      anon_sym_RBRACE,
    STATE(3836), 1,
      aux_sym_object_pattern_repeat1,
  [99254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3123), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [99273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4256), 1,
      sym__call_signature,
  [99292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3130), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [99311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [99322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2887), 1,
      sym_formal_parameters,
    STATE(3132), 1,
      sym__call_signature,
    STATE(4014), 1,
      sym_type_parameters,
  [99341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6870), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [99380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99413] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4255), 1,
      sym__call_signature,
  [99432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    ACTIONS(6872), 1,
      sym_identifier,
    ACTIONS(6874), 1,
      anon_sym_LBRACK,
    ACTIONS(6876), 1,
      sym_private_property_identifier,
    STATE(2103), 1,
      sym_arguments,
  [99451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [99462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6878), 1,
      anon_sym_EQ_GT,
    STATE(4170), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [99477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 1,
      anon_sym_COLON,
    ACTIONS(6881), 1,
      anon_sym_EQ_GT,
    STATE(4039), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [99492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    STATE(4200), 1,
      sym_type_annotation,
    ACTIONS(3579), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [99507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3884), 1,
      sym__initializer,
    ACTIONS(6884), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4276), 1,
      sym__call_signature,
  [99541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      anon_sym_LT,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    STATE(3837), 1,
      sym_type_arguments,
    ACTIONS(6888), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [99558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6890), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6182), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      anon_sym_DOT,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(877), 1,
      sym_statement_block,
    ACTIONS(2182), 2,
      anon_sym_else,
      anon_sym_while,
  [99608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4213), 1,
      sym__call_signature,
  [99627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4228), 1,
      sym__call_signature,
  [99657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [99668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6892), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6698), 1,
      anon_sym_PIPE,
    ACTIONS(6894), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    ACTIONS(6896), 1,
      anon_sym_RPAREN,
    STATE(3777), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [99713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4230), 1,
      sym__call_signature,
  [99732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3150), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [99751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4911), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [99762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3493), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym_type_parameters,
    STATE(4104), 1,
      sym__call_signature,
  [99781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6278), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym_formal_parameters,
    STATE(3322), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_type_parameters,
  [99822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3943), 1,
      sym__initializer,
    ACTIONS(6900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3950), 1,
      sym__initializer,
    ACTIONS(6902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 1,
      anon_sym_EQ,
    STATE(3946), 1,
      sym__initializer,
    ACTIONS(6904), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6906), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [99878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6276), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_formal_parameters,
    STATE(3536), 1,
      sym__call_signature,
    STATE(4034), 1,
      sym_type_parameters,
  [99908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2233), 1,
      sym_component_body,
    STATE(4012), 1,
      sym_component_identifier,
  [99924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_finally,
    STATE(815), 1,
      sym_finally_clause,
    ACTIONS(2176), 2,
      anon_sym_else,
      anon_sym_while,
  [99938] = 4,
    ACTIONS(6908), 1,
      anon_sym_DQUOTE,
    ACTIONS(6912), 1,
      sym_comment,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [99952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4098), 1,
      sym_type_parameters,
    STATE(4576), 1,
      sym_formal_parameters,
  [99968] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6914), 1,
      sym__glimmer_template_content,
    ACTIONS(6916), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(972), 1,
      sym_glimmer_closing_tag,
    STATE(3876), 1,
      aux_sym_glimmer_template_repeat1,
  [99984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4099), 1,
      sym_type_parameters,
    STATE(4624), 1,
      sym_formal_parameters,
  [100000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6918), 1,
      anon_sym_QMARK,
  [100016] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_SQUOTE,
    STATE(3641), 1,
      aux_sym_string_repeat2,
    ACTIONS(6922), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100030] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6920), 1,
      anon_sym_DQUOTE,
    STATE(3547), 1,
      aux_sym_string_repeat1,
    ACTIONS(6924), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6926), 1,
      anon_sym_COLON,
  [100060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6928), 1,
      anon_sym_QMARK,
  [100076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(144), 1,
      sym_component_body,
    STATE(4114), 1,
      sym_component_identifier,
  [100092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AT,
    ACTIONS(6408), 1,
      anon_sym_component,
    STATE(1390), 1,
      sym_decorator,
    STATE(3304), 1,
      aux_sym_class_repeat1,
  [100108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      sym_identifier,
    STATE(3303), 1,
      sym_nested_type_identifier,
    STATE(3634), 1,
      sym_generic_type,
    STATE(4438), 1,
      sym_nested_identifier,
  [100124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6932), 1,
      anon_sym_RPAREN,
  [100140] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_DQUOTE,
    STATE(3566), 1,
      aux_sym_string_repeat1,
    ACTIONS(6936), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100154] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_SQUOTE,
    STATE(3567), 1,
      aux_sym_string_repeat2,
    ACTIONS(6938), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(4267), 1,
      sym__initializer,
    ACTIONS(6940), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4111), 1,
      sym_type_parameters,
    STATE(4584), 1,
      sym_formal_parameters,
  [100198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4118), 1,
      sym_type_parameters,
    STATE(4514), 1,
      sym_formal_parameters,
  [100214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3958), 1,
      sym_type_parameters,
    STATE(4614), 1,
      sym_formal_parameters,
  [100230] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100244] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(936), 1,
      sym_component_body,
    STATE(4019), 1,
      sym_component_identifier,
  [100274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3960), 1,
      sym_type_parameters,
    STATE(4607), 1,
      sym_formal_parameters,
  [100290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6946), 1,
      anon_sym_RBRACK,
  [100306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5864), 1,
      anon_sym_EQ,
    STATE(4254), 1,
      sym_default_type,
    ACTIONS(6948), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [100320] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6950), 1,
      sym__glimmer_template_content,
    ACTIONS(6952), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2126), 1,
      sym_glimmer_closing_tag,
    STATE(3620), 1,
      aux_sym_glimmer_template_repeat1,
  [100336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6954), 1,
      anon_sym_RBRACK,
  [100352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4132), 1,
      sym_type_parameters,
    STATE(4412), 1,
      sym_formal_parameters,
  [100368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6956), 1,
      anon_sym_COMMA,
    STATE(3602), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6958), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6956), 1,
      anon_sym_COMMA,
    STATE(3602), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6960), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100396] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6962), 1,
      anon_sym_DQUOTE,
    STATE(3697), 1,
      aux_sym_string_repeat1,
    ACTIONS(6964), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6966), 1,
      anon_sym_COLON,
  [100426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4139), 1,
      sym_type_parameters,
    STATE(4393), 1,
      sym_formal_parameters,
  [100442] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6968), 1,
      anon_sym_DQUOTE,
    STATE(3585), 1,
      aux_sym_string_repeat1,
    ACTIONS(6970), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6972), 1,
      anon_sym_RPAREN,
  [100472] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6962), 1,
      anon_sym_SQUOTE,
    STATE(3629), 1,
      aux_sym_string_repeat2,
    ACTIONS(6974), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100486] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6968), 1,
      anon_sym_SQUOTE,
    STATE(3592), 1,
      aux_sym_string_repeat2,
    ACTIONS(6976), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(955), 1,
      sym_component_body,
    STATE(4027), 1,
      sym_component_identifier,
  [100516] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6978), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3974), 1,
      sym_type_parameters,
    STATE(4637), 1,
      sym_formal_parameters,
  [100556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6980), 1,
      anon_sym_RBRACK,
  [100572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6982), 1,
      anon_sym_RBRACK,
  [100588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1714), 1,
      sym_component_body,
    STATE(4226), 1,
      sym_component_identifier,
  [100604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3975), 1,
      sym_type_parameters,
    STATE(4470), 1,
      sym_formal_parameters,
  [100620] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6978), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6984), 1,
      anon_sym_COLON,
  [100650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1723), 1,
      sym_component_body,
    STATE(4214), 1,
      sym_component_identifier,
  [100666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
    STATE(4049), 1,
      sym_formal_type_parameter,
    STATE(4210), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [100680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(6986), 1,
      anon_sym_COLON,
  [100696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6988), 1,
      anon_sym_QMARK,
  [100712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(4273), 1,
      sym__initializer,
    ACTIONS(6990), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(3040), 1,
      sym_formal_parameters,
    STATE(4206), 1,
      sym_type_parameters,
  [100742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6992), 1,
      anon_sym_QMARK,
  [100758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(6994), 1,
      anon_sym_QMARK,
  [100774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    STATE(3602), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100788] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_LBRACE,
    ACTIONS(7005), 1,
      anon_sym_COMMA,
    ACTIONS(7008), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3604), 1,
      aux_sym_extends_type_clause_repeat1,
  [100818] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7010), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [100842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(4045), 1,
      sym__initializer,
    ACTIONS(7012), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100856] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7014), 1,
      anon_sym_SQUOTE,
    STATE(3603), 1,
      aux_sym_string_repeat2,
    ACTIONS(7016), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [100870] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7014), 1,
      anon_sym_DQUOTE,
    STATE(3605), 1,
      aux_sym_string_repeat1,
    ACTIONS(7018), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [100884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2107), 1,
      sym_component_body,
    STATE(4232), 1,
      sym_component_identifier,
  [100900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7020), 1,
      anon_sym_QMARK,
  [100916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4086), 1,
      sym_type_parameters,
    STATE(4292), 1,
      sym_formal_parameters,
  [100932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      sym_escape_sequence,
    ACTIONS(7024), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [100944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(7027), 1,
      anon_sym_COLON,
  [100960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_component_body,
    STATE(4020), 1,
      sym_component_identifier,
  [100976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7029), 1,
      anon_sym_RPAREN,
  [100992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4083), 1,
      sym_type_parameters,
    STATE(4479), 1,
      sym_formal_parameters,
  [101008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(7031), 1,
      anon_sym_COLON,
  [101024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7033), 1,
      anon_sym_QMARK,
  [101040] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6914), 1,
      sym__glimmer_template_content,
    ACTIONS(6952), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2102), 1,
      sym_glimmer_closing_tag,
    STATE(3876), 1,
      aux_sym_glimmer_template_repeat1,
  [101056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7035), 1,
      anon_sym_RBRACK,
  [101072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7037), 1,
      anon_sym_RBRACK,
  [101088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7039), 1,
      anon_sym_RBRACK,
  [101104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_COMMA,
    STATE(3624), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7041), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [101118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_COMMA,
    STATE(3624), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7046), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [101132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(914), 1,
      sym_component_body,
    STATE(3962), 1,
      sym_component_identifier,
  [101148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7048), 1,
      anon_sym_RPAREN,
  [101164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7050), 1,
      anon_sym_RBRACK,
  [101180] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_component_body,
    STATE(4073), 1,
      sym_component_identifier,
  [101210] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7054), 1,
      anon_sym_DQUOTE,
    STATE(3693), 1,
      aux_sym_string_repeat1,
    ACTIONS(7056), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [101224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 1,
      anon_sym_DOT,
    STATE(3656), 1,
      aux_sym_component_heritage_repeat1,
    ACTIONS(7058), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [101238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 1,
      anon_sym_RBRACE,
    ACTIONS(2827), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(6592), 1,
      anon_sym_LBRACE,
    ACTIONS(6594), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3682), 1,
      aux_sym_extends_type_clause_repeat1,
  [101266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_COMMA,
    STATE(3635), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(7065), 2,
      anon_sym_RBRACE,
      anon_sym_from,
  [101280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4154), 1,
      sym_type_parameters,
    STATE(4627), 1,
      sym_formal_parameters,
  [101296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_component_body,
    STATE(4280), 1,
      sym_component_identifier,
  [101312] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7067), 1,
      sym__glimmer_template_content,
    ACTIONS(7069), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1691), 1,
      sym_glimmer_closing_tag,
    STATE(3692), 1,
      aux_sym_glimmer_template_repeat1,
  [101328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4178), 1,
      sym_type_parameters,
    STATE(4297), 1,
      sym_formal_parameters,
  [101344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4048), 1,
      sym_type_parameters,
    STATE(4490), 1,
      sym_formal_parameters,
  [101360] = 4,
    ACTIONS(6908), 1,
      anon_sym_SQUOTE,
    ACTIONS(6912), 1,
      sym_comment,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7071), 1,
      anon_sym_RPAREN,
  [101390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7073), 1,
      anon_sym_EQ,
    ACTIONS(7075), 1,
      anon_sym_RBRACK,
    STATE(3824), 1,
      aux_sym_array_pattern_repeat1,
  [101406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_EQ_GT,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [101418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 1,
      anon_sym_EQ_GT,
    ACTIONS(4637), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [101430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4195), 1,
      sym_type_parameters,
    STATE(4615), 1,
      sym_formal_parameters,
  [101446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6956), 1,
      anon_sym_COMMA,
    STATE(3575), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7079), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6956), 1,
      anon_sym_COMMA,
    STATE(3576), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7081), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1656), 1,
      sym_component_body,
    STATE(4167), 1,
      sym_component_identifier,
  [101490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
  [101506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7085), 1,
      anon_sym_RBRACK,
  [101522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 1,
      anon_sym_DOT,
    STATE(3632), 1,
      aux_sym_component_heritage_repeat1,
    ACTIONS(7087), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [101536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7089), 1,
      anon_sym_RBRACK,
  [101552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7091), 1,
      anon_sym_RBRACK,
  [101568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2081), 1,
      sym_component_body,
    STATE(4253), 1,
      sym_component_identifier,
  [101584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 1,
      anon_sym_DOT,
    STATE(3656), 1,
      aux_sym_component_heritage_repeat1,
    ACTIONS(7093), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [101598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_component_body,
    STATE(4070), 1,
      sym_component_identifier,
  [101614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4207), 1,
      sym_type_parameters,
    STATE(4322), 1,
      sym_formal_parameters,
  [101630] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7054), 1,
      anon_sym_SQUOTE,
    STATE(3696), 1,
      aux_sym_string_repeat2,
    ACTIONS(7098), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7100), 1,
      anon_sym_RBRACK,
  [101660] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7102), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(7104), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [101674] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(7109), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(951), 1,
      sym_component_body,
    STATE(4038), 1,
      sym_component_identifier,
  [101704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4204), 1,
      sym_type_parameters,
    STATE(4334), 1,
      sym_formal_parameters,
  [101720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7112), 1,
      anon_sym_QMARK,
  [101736] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2073), 1,
      sym_component_body,
    STATE(4245), 1,
      sym_component_identifier,
  [101766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(7116), 1,
      anon_sym_COLON,
  [101782] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [101796] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_SQUOTE,
    STATE(3666), 1,
      aux_sym_string_repeat2,
    ACTIONS(7120), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [101810] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_DQUOTE,
    STATE(3669), 1,
      aux_sym_string_repeat1,
    ACTIONS(7122), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [101824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_COLON,
    ACTIONS(4639), 1,
      anon_sym_EQ,
    ACTIONS(7124), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(4051), 1,
      sym__initializer,
    ACTIONS(7126), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(7128), 1,
      anon_sym_COLON,
  [101868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7073), 1,
      anon_sym_EQ,
    ACTIONS(7130), 1,
      anon_sym_RBRACK,
    STATE(3922), 1,
      aux_sym_array_pattern_repeat1,
  [101884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4663), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [101894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_EQ,
    STATE(4196), 1,
      sym__initializer,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
  [101908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [101918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1632), 1,
      sym_component_body,
    STATE(4091), 1,
      sym_component_identifier,
  [101934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7010), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [101944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(877), 1,
      sym_statement_block,
    ACTIONS(2182), 2,
      anon_sym_else,
      anon_sym_while,
  [101958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    ACTIONS(7138), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3604), 1,
      aux_sym_extends_type_clause_repeat1,
  [101974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(7136), 1,
      anon_sym_LBRACE,
    ACTIONS(7138), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3604), 1,
      aux_sym_extends_type_clause_repeat1,
  [101990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      anon_sym_COMMA,
    ACTIONS(7140), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3604), 1,
      aux_sym_extends_type_clause_repeat1,
  [102006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      sym_identifier,
    STATE(3520), 1,
      sym_nested_type_identifier,
    STATE(3859), 1,
      sym_generic_type,
    STATE(4438), 1,
      sym_nested_identifier,
  [102022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_COMMA,
    STATE(3624), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7146), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [102036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_COMMA,
    STATE(3625), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7148), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [102050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    STATE(4131), 1,
      sym__initializer,
    ACTIONS(7150), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [102064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7152), 1,
      anon_sym_RBRACK,
  [102080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2078), 1,
      sym_component_body,
    STATE(4061), 1,
      sym_component_identifier,
  [102096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2230), 1,
      sym_component_body,
    STATE(4125), 1,
      sym_component_identifier,
  [102112] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6914), 1,
      sym__glimmer_template_content,
    ACTIONS(7069), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1652), 1,
      sym_glimmer_closing_tag,
    STATE(3876), 1,
      aux_sym_glimmer_template_repeat1,
  [102128] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7154), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [102142] = 5,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(6916), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7156), 1,
      sym__glimmer_template_content,
    STATE(897), 1,
      sym_glimmer_closing_tag,
    STATE(3549), 1,
      aux_sym_glimmer_template_repeat1,
  [102158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
    ACTIONS(7158), 1,
      anon_sym_COLON,
  [102174] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    STATE(3662), 1,
      aux_sym_string_repeat2,
    ACTIONS(6944), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [102188] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_DQUOTE,
    STATE(3661), 1,
      aux_sym_string_repeat1,
    ACTIONS(6910), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [102202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
    ACTIONS(7160), 1,
      anon_sym_RPAREN,
  [102218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(4179), 1,
      sym_type_parameters,
  [102234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_COMMA,
    STATE(3700), 1,
      aux_sym_array_repeat1,
    ACTIONS(4964), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [102248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_POUND,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2063), 1,
      sym_component_body,
    STATE(4211), 1,
      sym_component_identifier,
  [102264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      anon_sym_LBRACE,
    ACTIONS(2606), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [102284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7167), 1,
      anon_sym_COMMA,
    ACTIONS(7169), 1,
      anon_sym_RBRACK,
    STATE(3825), 1,
      aux_sym_tuple_type_repeat1,
  [102297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_GT,
    ACTIONS(7171), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [102310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2433), 1,
      anon_sym_while,
    ACTIONS(7174), 1,
      anon_sym_else,
    STATE(731), 1,
      sym_else_clause,
  [102323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    ACTIONS(7176), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_statement_block,
  [102336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    ACTIONS(7180), 1,
      anon_sym_GT,
    STATE(4248), 1,
      sym_type_parameter,
  [102349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_RPAREN,
    STATE(4345), 1,
      sym_type_annotation,
  [102362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 1,
      anon_sym_COMMA,
    ACTIONS(7187), 1,
      anon_sym_GT,
    STATE(3710), 1,
      aux_sym_type_parameters_repeat1,
  [102375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      sym_identifier,
    ACTIONS(7193), 1,
      anon_sym_LBRACK,
    ACTIONS(7195), 1,
      sym_private_property_identifier,
  [102397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1011), 1,
      anon_sym_LBRACE,
    STATE(887), 1,
      sym_object_type,
  [102410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(590), 1,
      sym_string,
  [102423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 1,
      anon_sym_COMMA,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(3753), 1,
      aux_sym_implements_clause_repeat1,
  [102436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7199), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [102449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 1,
      anon_sym_RBRACK,
    ACTIONS(7201), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [102462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4951), 1,
      anon_sym_RPAREN,
    STATE(3845), 1,
      aux_sym_array_repeat1,
  [102475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_COMMA,
    ACTIONS(7206), 1,
      anon_sym_RPAREN,
    STATE(3719), 1,
      aux_sym_formal_parameters_repeat1,
  [102488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 1,
      anon_sym_COMMA,
    ACTIONS(7210), 1,
      anon_sym_RBRACE,
    STATE(3875), 1,
      aux_sym_enum_body_repeat1,
  [102501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6821), 1,
      sym_identifier,
    ACTIONS(6823), 1,
      anon_sym_LBRACK,
    ACTIONS(6825), 1,
      sym_private_property_identifier,
  [102514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4951), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [102527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 1,
      sym_identifier,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    ACTIONS(7216), 1,
      sym_private_property_identifier,
  [102540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7220), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [102553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [102562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 1,
      anon_sym_implements,
    ACTIONS(7222), 1,
      anon_sym_LBRACE,
    STATE(4380), 1,
      sym_implements_clause,
  [102575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_extends,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7226), 1,
      anon_sym_PIPE,
  [102588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(576), 1,
      sym_string,
  [102601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_RPAREN,
    ACTIONS(7228), 1,
      anon_sym_COMMA,
    STATE(3874), 1,
      aux_sym_formal_type_parameters_repeat1,
  [102614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 1,
      anon_sym_COMMA,
    ACTIONS(7232), 1,
      anon_sym_GT,
    STATE(3895), 1,
      aux_sym_type_parameters_repeat1,
  [102627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7234), 1,
      anon_sym_RBRACE,
    STATE(3891), 1,
      aux_sym_object_pattern_repeat1,
  [102640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7130), 1,
      anon_sym_RBRACK,
    STATE(3920), 1,
      aux_sym_array_pattern_repeat1,
  [102653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4984), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [102666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 1,
      anon_sym_COMMA,
    ACTIONS(7239), 1,
      anon_sym_RBRACK,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [102679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7241), 1,
      sym_identifier,
    ACTIONS(7243), 1,
      anon_sym_LBRACK,
    ACTIONS(7245), 1,
      sym_private_property_identifier,
  [102692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7247), 1,
      anon_sym_COMMA,
    ACTIONS(7249), 1,
      anon_sym_RBRACK,
    STATE(3717), 1,
      aux_sym_tuple_type_repeat1,
  [102705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7251), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [102714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4984), 1,
      anon_sym_RBRACK,
    STATE(3928), 1,
      aux_sym_array_repeat1,
  [102727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7130), 1,
      anon_sym_RBRACK,
    STATE(3922), 1,
      aux_sym_array_pattern_repeat1,
  [102740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7253), 1,
      anon_sym_COMMA,
    ACTIONS(7255), 1,
      anon_sym_RPAREN,
    STATE(3940), 1,
      aux_sym_formal_parameters_repeat1,
  [102753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 1,
      anon_sym_EQ,
    ACTIONS(7257), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6115), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [102773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7259), 1,
      sym_identifier,
    ACTIONS(7261), 1,
      anon_sym_LBRACK,
    ACTIONS(7263), 1,
      sym_private_property_identifier,
  [102786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_COMMA,
    ACTIONS(7267), 1,
      anon_sym_RBRACE,
    STATE(3875), 1,
      aux_sym_enum_body_repeat1,
  [102799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [102808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7269), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [102821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7271), 1,
      anon_sym_RBRACE,
    STATE(3900), 1,
      aux_sym_object_repeat1,
  [102834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_AMP,
    ACTIONS(6026), 1,
      anon_sym_extends,
    ACTIONS(7273), 1,
      anon_sym_PIPE,
  [102847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_COMMA,
    ACTIONS(7277), 1,
      anon_sym_GT,
    STATE(3710), 1,
      aux_sym_type_parameters_repeat1,
  [102860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7271), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [102873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7220), 1,
      anon_sym_RBRACE,
    STATE(3854), 1,
      aux_sym_object_repeat1,
  [102886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7269), 1,
      anon_sym_RBRACE,
    STATE(3853), 1,
      aux_sym_object_pattern_repeat1,
  [102899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_LBRACE,
    ACTIONS(7279), 1,
      anon_sym_COMMA,
    STATE(3753), 1,
      aux_sym_implements_clause_repeat1,
  [102912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7282), 1,
      sym_identifier,
    ACTIONS(7284), 1,
      anon_sym_LBRACK,
    ACTIONS(7286), 1,
      sym_private_property_identifier,
  [102925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7234), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [102938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(3786), 1,
      aux_sym_array_repeat1,
  [102951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [102964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 1,
      sym_identifier,
    ACTIONS(7290), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    STATE(576), 1,
      sym_string,
  [102988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(579), 1,
      sym_string,
  [103001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_RPAREN,
    ACTIONS(7292), 1,
      anon_sym_COMMA,
    STATE(3874), 1,
      aux_sym_formal_type_parameters_repeat1,
  [103014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 1,
      sym_identifier,
    ACTIONS(7296), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7298), 1,
      anon_sym_COMMA,
    ACTIONS(7300), 1,
      anon_sym_RPAREN,
    STATE(3927), 1,
      aux_sym_formal_parameters_repeat1,
  [103038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LT,
    ACTIONS(7302), 1,
      anon_sym_EQ,
    STATE(4500), 1,
      sym_type_parameters,
  [103051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      anon_sym_AMP,
    ACTIONS(7306), 1,
      anon_sym_PIPE,
    ACTIONS(7308), 1,
      anon_sym_extends,
  [103064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7310), 1,
      anon_sym_LPAREN,
    ACTIONS(7312), 1,
      anon_sym_await,
    STATE(48), 1,
      sym__for_header,
  [103077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7316), 1,
      anon_sym_BQUOTE,
    ACTIONS(7314), 2,
      anon_sym_LBRACE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [103088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7318), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7320), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7075), 1,
      anon_sym_RBRACK,
    STATE(3824), 1,
      aux_sym_array_pattern_repeat1,
  [103146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7093), 3,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
  [103173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7328), 1,
      anon_sym_COMMA,
    ACTIONS(7330), 1,
      anon_sym_RPAREN,
    STATE(3761), 1,
      aux_sym_formal_type_parameters_repeat1,
  [103186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7332), 1,
      anon_sym_LBRACE,
    ACTIONS(6906), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [103197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    ACTIONS(7334), 1,
      anon_sym_QMARK,
    STATE(3673), 1,
      sym_type_annotation,
  [103219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4945), 1,
      anon_sym_RBRACK,
    STATE(3945), 1,
      aux_sym_array_repeat1,
  [103241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7340), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7320), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7342), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_GT,
    ACTIONS(7344), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [103294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4945), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7320), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7075), 1,
      anon_sym_RBRACK,
    STATE(3920), 1,
      aux_sym_array_pattern_repeat1,
  [103329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym_COMMA,
    ACTIONS(7348), 1,
      anon_sym_GT,
    STATE(3749), 1,
      aux_sym_type_parameters_repeat1,
  [103342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_AMP,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_extends,
  [103355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [103364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      sym_identifier,
    STATE(1389), 1,
      sym_decorator_call_expression,
    STATE(3038), 1,
      sym_decorator_member_expression,
  [103386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 1,
      anon_sym_COMMA,
    ACTIONS(7356), 1,
      anon_sym_RBRACK,
    STATE(3820), 1,
      aux_sym_tuple_type_repeat1,
  [103399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7358), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 1,
      anon_sym_RPAREN,
    ACTIONS(7360), 1,
      anon_sym_COMMA,
    STATE(3719), 1,
      aux_sym_formal_parameters_repeat1,
  [103425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4947), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    ACTIONS(7362), 1,
      anon_sym_GT,
    STATE(4248), 1,
      sym_type_parameter,
  [103451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4947), 1,
      anon_sym_RPAREN,
    STATE(3716), 1,
      aux_sym_array_repeat1,
  [103464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1011), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_object_type,
  [103477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 1,
      sym_identifier,
    STATE(1373), 1,
      sym_decorator_member_expression,
    STATE(1389), 1,
      sym_decorator_call_expression,
  [103499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7368), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [103512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_GT,
    ACTIONS(7370), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [103525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7372), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [103547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 1,
      anon_sym_COMMA,
    ACTIONS(7376), 1,
      anon_sym_RBRACE,
    STATE(3744), 1,
      aux_sym_enum_body_repeat1,
  [103560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6242), 1,
      anon_sym_LBRACE,
    ACTIONS(6244), 1,
      anon_sym_LBRACE_PIPE,
    STATE(675), 1,
      sym_object_type,
  [103582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_AMP,
    ACTIONS(5976), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_extends,
  [103595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [103613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7364), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7380), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7382), 1,
      anon_sym_LPAREN,
    ACTIONS(7384), 1,
      anon_sym_await,
    STATE(42), 1,
      sym__for_header,
  [103644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7380), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 1,
      anon_sym_RBRACK,
    ACTIONS(7388), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [103675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7390), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7392), 1,
      anon_sym_from,
    STATE(3635), 1,
      aux_sym_js_import_statement_repeat1,
  [103697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7394), 1,
      anon_sym_LBRACE,
    ACTIONS(6827), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [103708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7396), 1,
      anon_sym_RBRACK,
    STATE(3920), 1,
      aux_sym_array_pattern_repeat1,
  [103721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 1,
      anon_sym_RBRACK,
    ACTIONS(7398), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [103734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(589), 1,
      sym_string,
  [103747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(7400), 1,
      anon_sym_RPAREN,
    STATE(4498), 1,
      sym_type_annotation,
  [103760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    STATE(574), 1,
      sym_string,
  [103773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7402), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(5014), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(5014), 1,
      anon_sym_RPAREN,
    STATE(3829), 1,
      aux_sym_array_repeat1,
  [103812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE,
    ACTIONS(6324), 1,
      anon_sym_extends,
  [103825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7404), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7406), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [103851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7408), 1,
      anon_sym_RBRACE,
    STATE(3635), 1,
      aux_sym_js_import_statement_repeat1,
  [103864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7410), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [103877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_LBRACE,
    ACTIONS(2654), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [103888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym_COMMA,
    ACTIONS(7414), 1,
      anon_sym_RPAREN,
    STATE(3729), 1,
      aux_sym_formal_type_parameters_repeat1,
  [103901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    STATE(590), 1,
      sym_string,
  [103914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      sym_identifier,
    ACTIONS(6715), 1,
      anon_sym_LBRACK,
    ACTIONS(6717), 1,
      sym_private_property_identifier,
  [103927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7416), 1,
      anon_sym_RBRACE,
    STATE(3635), 1,
      aux_sym_js_import_statement_repeat1,
  [103940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(5012), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(5012), 1,
      anon_sym_RPAREN,
    STATE(3833), 1,
      aux_sym_array_repeat1,
  [103966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      anon_sym_RBRACK,
    ACTIONS(7418), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [103979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7420), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [103992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7422), 1,
      anon_sym_RBRACE,
    STATE(3841), 1,
      aux_sym_js_import_statement_repeat1,
  [104005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_DOT,
  [104014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7424), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_GT,
    ACTIONS(7426), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [104040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7428), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6872), 1,
      sym_identifier,
    ACTIONS(6874), 1,
      anon_sym_LBRACK,
    ACTIONS(6876), 1,
      sym_private_property_identifier,
  [104066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 1,
      anon_sym_COMMA,
    ACTIONS(7432), 1,
      anon_sym_RBRACK,
    STATE(3844), 1,
      aux_sym_tuple_type_repeat1,
  [104079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7434), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [104092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7436), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [104105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 1,
      sym_identifier,
    ACTIONS(7440), 1,
      anon_sym_LBRACK,
    ACTIONS(7442), 1,
      sym_private_property_identifier,
  [104118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_COMMA,
    ACTIONS(7449), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [104140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 1,
      sym_identifier,
    ACTIONS(7453), 1,
      anon_sym_LBRACK,
    ACTIONS(7455), 1,
      sym_private_property_identifier,
  [104153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [104164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4994), 1,
      anon_sym_RPAREN,
    STATE(3886), 1,
      aux_sym_array_repeat1,
  [104204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4994), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7459), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7463), 1,
      anon_sym_DOT,
    ACTIONS(7461), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      sym_identifier,
    ACTIONS(7467), 1,
      anon_sym_LBRACK,
    ACTIONS(7469), 1,
      sym_private_property_identifier,
  [104250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_EQ,
    ACTIONS(3826), 2,
      anon_sym_in,
      anon_sym_of,
  [104261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_LBRACE,
    ACTIONS(6753), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [104272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4988), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4988), 1,
      anon_sym_RPAREN,
    STATE(3850), 1,
      aux_sym_array_repeat1,
  [104298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4800), 1,
      anon_sym_extends,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
  [104311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 1,
      anon_sym_COMMA,
    ACTIONS(7480), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [104324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 1,
      anon_sym_COMMA,
    ACTIONS(7485), 1,
      anon_sym_RPAREN,
    STATE(3874), 1,
      aux_sym_formal_type_parameters_repeat1,
  [104337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      anon_sym_COMMA,
    ACTIONS(7490), 1,
      anon_sym_RBRACE,
    STATE(3875), 1,
      aux_sym_enum_body_repeat1,
  [104350] = 4,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7492), 1,
      sym__glimmer_template_content,
    ACTIONS(7495), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3876), 1,
      aux_sym_glimmer_template_repeat1,
  [104363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4982), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7497), 1,
      anon_sym_from,
    STATE(3635), 1,
      aux_sym_js_import_statement_repeat1,
  [104389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4982), 1,
      anon_sym_RBRACK,
    STATE(3797), 1,
      aux_sym_array_repeat1,
  [104402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7499), 1,
      anon_sym_COMMA,
    ACTIONS(7501), 1,
      anon_sym_RPAREN,
    STATE(3798), 1,
      aux_sym_formal_parameters_repeat1,
  [104415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7503), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [104428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7503), 1,
      anon_sym_RBRACE,
    STATE(3805), 1,
      aux_sym_object_repeat1,
  [104441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    STATE(579), 1,
      sym_string,
  [104454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7505), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_DQUOTE,
    ACTIONS(3477), 1,
      anon_sym_SQUOTE,
    STATE(574), 1,
      sym_string,
  [104476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7507), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7509), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [104502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7513), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7515), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [104533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(7517), 1,
      anon_sym_RBRACE,
    STATE(3873), 1,
      aux_sym_object_pattern_repeat1,
  [104546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7519), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_extends,
    ACTIONS(6698), 1,
      anon_sym_PIPE,
  [104568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_COMMA,
    ACTIONS(7523), 1,
      anon_sym_RBRACK,
    STATE(3915), 1,
      aux_sym_tuple_type_repeat1,
  [104581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 1,
      anon_sym_COMMA,
    ACTIONS(7527), 1,
      anon_sym_GT,
    STATE(3710), 1,
      aux_sym_type_parameters_repeat1,
  [104594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [104612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_RBRACE,
    STATE(3857), 1,
      aux_sym_object_repeat1,
  [104643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4986), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_GT,
    ACTIONS(7539), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [104687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7541), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 1,
      anon_sym_COMMA,
    ACTIONS(7543), 1,
      anon_sym_RBRACE,
    STATE(3835), 1,
      aux_sym_js_import_statement_repeat1,
  [104727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    ACTIONS(7527), 1,
      anon_sym_GT,
    STATE(4248), 1,
      sym_type_parameter,
  [104749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4986), 1,
      anon_sym_RPAREN,
    STATE(3848), 1,
      aux_sym_array_repeat1,
  [104762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_RBRACK,
    ACTIONS(7545), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [104775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      sym_identifier,
    ACTIONS(7549), 1,
      anon_sym_LBRACK,
    ACTIONS(7551), 1,
      sym_private_property_identifier,
  [104788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7553), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 1,
      anon_sym_RBRACK,
    ACTIONS(7555), 1,
      anon_sym_COMMA,
    STATE(3734), 1,
      aux_sym_tuple_type_repeat1,
  [104810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      sym_identifier,
    ACTIONS(7559), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_private_property_identifier,
  [104823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7563), 1,
      sym_identifier,
    ACTIONS(7565), 1,
      anon_sym_LBRACK,
    ACTIONS(7567), 1,
      sym_private_property_identifier,
  [104836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 1,
      anon_sym_GT,
    ACTIONS(7569), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [104849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_COMMA,
    ACTIONS(7574), 1,
      anon_sym_RBRACK,
    STATE(3920), 1,
      aux_sym_array_pattern_repeat1,
  [104871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(7576), 1,
      anon_sym_RBRACK,
    STATE(3920), 1,
      aux_sym_array_pattern_repeat1,
  [104893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7578), 1,
      sym_identifier,
    ACTIONS(7580), 1,
      anon_sym_LBRACK,
    ACTIONS(7582), 1,
      sym_private_property_identifier,
  [104906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7584), 1,
      anon_sym_EQ,
    ACTIONS(3826), 2,
      anon_sym_in,
      anon_sym_of,
  [104917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_statement_block,
  [104930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_GT,
    ACTIONS(7588), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [104943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    ACTIONS(7590), 1,
      anon_sym_COMMA,
    STATE(3719), 1,
      aux_sym_formal_parameters_repeat1,
  [104956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7592), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [104969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    ACTIONS(7277), 1,
      anon_sym_GT,
    STATE(4248), 1,
      sym_type_parameter,
  [104982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 1,
      anon_sym_GT,
    ACTIONS(7594), 1,
      anon_sym_COMMA,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [104995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7596), 1,
      anon_sym_COMMA,
    ACTIONS(7598), 1,
      anon_sym_RBRACK,
    STATE(3912), 1,
      aux_sym_tuple_type_repeat1,
  [105008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 1,
      anon_sym_EQ,
    ACTIONS(7574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [105019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6242), 1,
      anon_sym_LBRACE,
    ACTIONS(6244), 1,
      anon_sym_LBRACE_PIPE,
    STATE(887), 1,
      sym_object_type,
  [105041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    STATE(589), 1,
      sym_string,
  [105054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_AMP,
    ACTIONS(6051), 1,
      anon_sym_PIPE,
    ACTIONS(6053), 1,
      anon_sym_extends,
  [105067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 1,
      sym_identifier,
    STATE(2393), 1,
      sym_decorator_member_expression,
    STATE(2465), 1,
      sym_decorator_call_expression,
  [105080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(3942), 1,
      aux_sym_array_repeat1,
  [105093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [105106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    ACTIONS(7602), 1,
      anon_sym_COMMA,
    STATE(3719), 1,
      aux_sym_formal_parameters_repeat1,
  [105119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 1,
      sym_identifier,
    STATE(3348), 1,
      sym_nested_identifier,
    STATE(3352), 1,
      sym_new_component_expression,
  [105132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7606), 1,
      anon_sym_RPAREN,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [105145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7608), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_COMMA,
    ACTIONS(7612), 1,
      anon_sym_RBRACK,
    STATE(3700), 1,
      aux_sym_array_repeat1,
  [105176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      sym__automatic_semicolon,
    ACTIONS(1347), 2,
      anon_sym_else,
      anon_sym_while,
  [105196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [105205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 2,
      anon_sym_else,
      anon_sym_while,
  [105216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7616), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(713), 1,
      sym_class_body,
  [105235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2049), 1,
      sym_class_body,
  [105245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_class_body,
  [105255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(927), 1,
      sym_statement_block,
  [105265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(931), 1,
      sym_statement_block,
  [105275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(969), 1,
      sym_statement_block,
  [105285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7620), 1,
      sym_identifier,
    ACTIONS(7622), 1,
      anon_sym_RBRACE,
  [105295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4616), 1,
      sym_formal_parameters,
  [105305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(935), 1,
      sym_statement_block,
  [105315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4613), 1,
      sym_formal_parameters,
  [105325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(936), 1,
      sym_component_body,
  [105335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(938), 1,
      sym_component_body,
  [105345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 1,
      sym_identifier,
    STATE(3866), 1,
      sym_nested_identifier,
  [105355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(2293), 1,
      sym_class_body,
  [105365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4136), 1,
      sym_statement_block,
  [105375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [105383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4122), 1,
      sym_statement_block,
  [105393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(943), 1,
      sym_class_body,
  [105403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(966), 1,
      sym_component_body,
  [105413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 1,
      sym_identifier,
    ACTIONS(7628), 1,
      anon_sym_STAR,
  [105423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [105431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7630), 1,
      sym_identifier,
    ACTIONS(7632), 1,
      anon_sym_STAR,
  [105441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(144), 1,
      sym_component_body,
  [105451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4486), 1,
      sym_formal_parameters,
  [105461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4286), 1,
      sym_formal_parameters,
  [105471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7634), 1,
      sym_identifier,
    ACTIONS(7636), 1,
      sym_private_property_identifier,
  [105481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_LPAREN,
    STATE(2821), 1,
      sym_arguments,
  [105491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_property_declaration_name,
  [105501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7640), 1,
      sym_identifier,
    ACTIONS(7642), 1,
      anon_sym_STAR,
  [105511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7644), 1,
      sym_identifier,
    ACTIONS(7646), 1,
      sym_private_property_identifier,
  [105521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7648), 1,
      sym_identifier,
    ACTIONS(7650), 1,
      sym_private_property_identifier,
  [105531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      sym_private_property_identifier,
  [105541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7656), 1,
      sym_identifier,
    STATE(2931), 1,
      sym_import_path_segment,
  [105551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN,
    STATE(1574), 1,
      sym_arguments,
  [105561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_component_body,
  [105571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_LBRACE,
    STATE(3135), 1,
      sym_new_component_body,
  [105581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7658), 1,
      sym_identifier,
    ACTIONS(7660), 1,
      sym_private_property_identifier,
  [105591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(914), 1,
      sym_component_body,
  [105601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4331), 1,
      sym_formal_parameters,
  [105611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
  [105621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [105631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
  [105641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    STATE(814), 1,
      sym_statement_block,
  [105651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [105661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7664), 1,
      anon_sym_LPAREN,
    STATE(4165), 1,
      sym_parenthesized_expression,
  [105671] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7666), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [105679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7578), 1,
      sym_identifier,
    ACTIONS(7582), 1,
      sym_private_property_identifier,
  [105689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(964), 1,
      sym_class_body,
  [105699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7668), 1,
      sym_identifier,
    ACTIONS(7670), 1,
      sym_private_property_identifier,
  [105709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3455), 1,
      sym_formal_parameters,
  [105719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7672), 1,
      sym_identifier,
    ACTIONS(7674), 1,
      sym_private_property_identifier,
  [105729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(963), 1,
      sym_statement_block,
  [105739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7676), 1,
      sym_identifier,
    ACTIONS(7678), 1,
      sym_private_property_identifier,
  [105749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(962), 1,
      sym_statement_block,
  [105759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_LBRACE,
    STATE(740), 1,
      sym_enum_body,
  [105769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      sym_identifier,
    ACTIONS(7684), 1,
      sym_private_property_identifier,
  [105779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    STATE(3730), 1,
      sym_type_parameter,
  [105789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_statement_block,
  [105799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7686), 1,
      sym_identifier,
    ACTIONS(7688), 1,
      sym_private_property_identifier,
  [105809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7690), 1,
      sym_identifier,
    ACTIONS(7692), 1,
      sym_private_property_identifier,
  [105819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7694), 1,
      sym_identifier,
    ACTIONS(7696), 1,
      sym_private_property_identifier,
  [105829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2292), 1,
      sym_component_body,
  [105839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(950), 1,
      sym_class_body,
  [105849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2870), 1,
      sym_formal_parameters,
  [105859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    STATE(4062), 1,
      sym_formal_type_parameters,
  [105869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1419), 1,
      sym_property_declaration_name,
  [105879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4458), 1,
      sym_formal_parameters,
  [105889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1416), 1,
      sym_property_declaration_name,
  [105899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(960), 1,
      sym_component_body,
  [105909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(564), 1,
      sym_component_body,
  [105919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7700), 1,
      anon_sym_async,
    ACTIONS(7702), 1,
      anon_sym_fn,
  [105929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(545), 1,
      sym_component_body,
  [105939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(957), 1,
      sym_class_body,
  [105949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(952), 1,
      sym_class_body,
  [105959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_component_body,
  [105969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_COLON,
    STATE(3865), 1,
      sym_type_annotation,
  [105979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(948), 1,
      sym_component_body,
  [105989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(918), 1,
      sym_class_body,
  [105999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym__for_header,
  [106009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1670), 1,
      sym_class_body,
  [106019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1668), 1,
      sym_statement_block,
  [106029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1656), 1,
      sym_component_body,
  [106039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7708), 1,
      sym_identifier,
    ACTIONS(7710), 1,
      sym_private_property_identifier,
  [106049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(2971), 1,
      sym_formal_parameters,
  [106059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LBRACE,
    STATE(923), 1,
      sym_statement_block,
  [106069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(924), 1,
      sym_class_body,
  [106079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_class_body,
  [106089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_LBRACE,
    STATE(925), 1,
      sym_component_body,
  [106099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [106107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_LPAREN,
    STATE(1841), 1,
      sym_arguments,
  [106117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LPAREN,
    STATE(2579), 1,
      sym_arguments,
  [106127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3515), 1,
      sym_formal_parameters,
  [106137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    STATE(4200), 1,
      sym_type_annotation,
  [106147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1463), 1,
      sym_statement_block,
  [106157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7712), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4187), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [106173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2078), 1,
      sym_component_body,
  [106183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4332), 1,
      sym_formal_parameters,
  [106193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4179), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [106209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7714), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1424), 1,
      sym_property_declaration_name,
  [106227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1459), 1,
      sym_statement_block,
  [106237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 1,
      anon_sym_EQ,
    STATE(1430), 1,
      sym_property_expression_initializer,
  [106247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2105), 1,
      sym_class_body,
  [106257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1434), 1,
      sym_statement_block,
  [106267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4314), 1,
      sym_formal_parameters,
  [106277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1417), 1,
      sym_property_declaration_name,
  [106287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    STATE(4205), 1,
      sym_formal_type_parameters,
  [106297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2124), 1,
      sym_statement_block,
  [106307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2132), 1,
      sym_component_body,
  [106317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1441), 1,
      sym_statement_block,
  [106327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 1,
      anon_sym_LPAREN,
    STATE(1436), 1,
      sym_formal_type_parameters,
  [106337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      sym_identifier,
    STATE(1470), 1,
      sym_property_declaration_name,
  [106347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4374), 1,
      sym_formal_parameters,
  [106357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2136), 1,
      sym_class_body,
  [106367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    STATE(3485), 1,
      sym_formal_type_parameters,
  [106377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2156), 1,
      sym_component_body,
  [106387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3408), 1,
      sym_formal_parameters,
  [106397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_component_body,
  [106407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2155), 1,
      sym_statement_block,
  [106417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2154), 1,
      sym_class_body,
  [106427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      sym_component_body,
  [106437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_in,
    ACTIONS(7720), 1,
      anon_sym_COLON,
  [106471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      sym_identifier,
    ACTIONS(7724), 1,
      anon_sym_RBRACE,
  [106505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4294), 1,
      sym_formal_parameters,
  [106523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6658), 1,
      anon_sym_LBRACE,
    STATE(149), 1,
      sym_statement_block,
  [106533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4290), 1,
      sym_formal_parameters,
  [106551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4291), 1,
      sym_formal_parameters,
  [106569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1690), 1,
      sym_component_body,
  [106595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1700), 1,
      sym_class_body,
  [106605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1701), 1,
      sym_statement_block,
  [106615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4275), 1,
      sym_statement_block,
  [106633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7263), 1,
      sym_private_property_identifier,
    ACTIONS(7726), 1,
      sym_identifier,
  [106643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4663), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4548), 1,
      sym_formal_parameters,
  [106661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4582), 1,
      sym_formal_parameters,
  [106671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_class_body,
  [106681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7728), 1,
      sym_identifier,
    STATE(585), 1,
      sym_import_path_segment,
  [106691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4603), 1,
      sym_formal_parameters,
  [106701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4173), 1,
      sym_statement_block,
  [106719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7732), 1,
      sym_identifier,
    ACTIONS(7734), 1,
      sym_private_property_identifier,
  [106745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7736), 1,
      sym_identifier,
    ACTIONS(7738), 1,
      sym_private_property_identifier,
  [106755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7740), 1,
      sym_identifier,
    ACTIONS(7742), 1,
      sym_private_property_identifier,
  [106765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 1,
      sym_identifier,
    ACTIONS(7746), 1,
      sym_private_property_identifier,
  [106775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4493), 1,
      sym_formal_parameters,
  [106785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    STATE(3791), 1,
      sym_type_parameter,
  [106795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(683), 1,
      sym_class_body,
  [106805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(146), 1,
      sym_component_body,
  [106815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_class_body,
  [106825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_statement_block,
  [106835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4639), 1,
      sym_formal_parameters,
  [106845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4583), 1,
      sym_formal_parameters,
  [106855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 1,
      sym_identifier,
    STATE(4248), 1,
      sym_type_parameter,
  [106865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(163), 1,
      sym_component_body,
  [106875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4549), 1,
      sym_formal_parameters,
  [106901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym__for_header,
  [106911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2235), 1,
      sym_component_body,
  [106921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7748), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [106929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_component_body,
  [106939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4271), 1,
      sym_statement_block,
  [106949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(2255), 1,
      sym_class_body,
  [106959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(2260), 1,
      sym_class_body,
  [106969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7750), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4435), 1,
      sym_formal_parameters,
  [106987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 1,
      anon_sym_LPAREN,
    STATE(2957), 1,
      sym_formal_parameters,
  [106997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(3966), 1,
      sym_statement_block,
  [107015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(3971), 1,
      sym_statement_block,
  [107041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4409), 1,
      sym_formal_parameters,
  [107051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_LBRACE,
    STATE(852), 1,
      sym_enum_body,
  [107061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4405), 1,
      sym_formal_parameters,
  [107071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_statement_block,
  [107081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7752), 1,
      sym_identifier,
    ACTIONS(7754), 1,
      anon_sym_STAR,
  [107091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4103), 1,
      sym_statement_block,
  [107101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4106), 1,
      sym_statement_block,
  [107119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4241), 1,
      sym_statement_block,
  [107129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1686), 1,
      sym_class_body,
  [107139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(747), 1,
      sym_arguments,
  [107149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_class_body,
  [107159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1689), 1,
      sym_statement_block,
  [107169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5000), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3380), 1,
      sym_formal_parameters,
  [107187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4617), 1,
      sym_formal_parameters,
  [107197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1705), 1,
      sym_statement_block,
  [107239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7760), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_statement_block,
  [107257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7762), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_switch_body,
  [107267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_class_body,
  [107277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2058), 1,
      sym_class_body,
  [107287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1714), 1,
      sym_component_body,
  [107305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1630), 1,
      sym_component_body,
  [107315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1447), 1,
      sym_statement_block,
  [107325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_COLON,
    ACTIONS(7768), 1,
      anon_sym_EQ,
  [107351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1717), 1,
      sym_class_body,
  [107361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [107377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2117), 1,
      sym_class_body,
  [107387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1725), 1,
      sym_component_body,
  [107397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      anon_sym_COLON,
    STATE(3607), 1,
      sym_type_annotation,
  [107407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4317), 1,
      sym_formal_parameters,
  [107417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(3053), 1,
      sym_formal_parameters,
  [107427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    STATE(3361), 1,
      sym_formal_type_parameters,
  [107437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2115), 1,
      sym_statement_block,
  [107447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      sym_identifier,
    ACTIONS(7469), 1,
      sym_private_property_identifier,
  [107457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      sym_identifier,
    ACTIONS(7772), 1,
      sym_private_property_identifier,
  [107467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    STATE(637), 1,
      sym_class_body,
  [107485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      sym_identifier,
    ACTIONS(7776), 1,
      sym_private_property_identifier,
  [107495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      sym_private_property_identifier,
    ACTIONS(7778), 1,
      sym_identifier,
  [107505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_statement_block,
  [107515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7780), 1,
      sym_identifier,
    ACTIONS(7782), 1,
      sym_private_property_identifier,
  [107525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2107), 1,
      sym_component_body,
  [107535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7784), 1,
      sym_identifier,
    ACTIONS(7786), 1,
      sym_private_property_identifier,
  [107545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3434), 1,
      sym_formal_parameters,
  [107555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(3436), 1,
      sym_formal_parameters,
  [107565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    STATE(639), 1,
      sym_statement_block,
  [107575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4533), 1,
      sym_formal_parameters,
  [107585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_in,
    ACTIONS(6793), 1,
      anon_sym_of,
  [107595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
    STATE(2702), 1,
      sym_arguments,
  [107605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    STATE(4160), 1,
      sym_type_annotation,
  [107615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(3193), 1,
      sym_statement_block,
  [107625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7788), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    STATE(3432), 1,
      sym_formal_type_parameters,
  [107651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_class_body,
  [107661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4296), 1,
      sym_formal_parameters,
  [107671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1449), 1,
      sym_statement_block,
  [107681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_LPAREN,
    STATE(3136), 1,
      sym_formal_parameters,
  [107691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4359), 1,
      sym_formal_parameters,
  [107701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [107709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2090), 1,
      sym_class_body,
  [107719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2057), 1,
      sym_component_body,
  [107737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_class_body,
  [107747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2059), 1,
      sym_statement_block,
  [107757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1635), 1,
      sym_component_body,
  [107767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5701), 1,
      anon_sym_is,
    ACTIONS(6268), 1,
      anon_sym_LBRACE,
  [107777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1633), 1,
      sym_component_body,
  [107787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2088), 1,
      sym_statement_block,
  [107797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1631), 1,
      sym_class_body,
  [107807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1643), 1,
      sym_class_body,
  [107817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2084), 1,
      sym_statement_block,
  [107827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 1,
      anon_sym_is,
    ACTIONS(6268), 1,
      anon_sym_EQ_GT,
  [107845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4370), 1,
      sym_formal_parameters,
  [107855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7794), 1,
      anon_sym_COLON,
    ACTIONS(7796), 1,
      anon_sym_EQ,
  [107865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2083), 1,
      sym_statement_block,
  [107875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(1648), 1,
      sym_component_body,
  [107885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 2,
      anon_sym_in,
      anon_sym_of,
  [107893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1650), 1,
      sym_statement_block,
  [107903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2081), 1,
      sym_component_body,
  [107913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1655), 1,
      sym_statement_block,
  [107923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_statement_block,
  [107933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2080), 1,
      sym_component_body,
  [107943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_LBRACE,
    STATE(1665), 1,
      sym_statement_block,
  [107953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [107963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(4162), 1,
      sym_parenthesized_expression,
  [107973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4145), 1,
      sym_statement_block,
  [107983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [107993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(1727), 1,
      sym_class_body,
  [108003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_statement_block,
  [108013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [108023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4156), 1,
      sym_statement_block,
  [108041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6658), 1,
      anon_sym_LBRACE,
    STATE(152), 1,
      sym_statement_block,
  [108051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(814), 1,
      sym_statement_block,
  [108061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2060), 1,
      sym_component_body,
  [108071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2062), 1,
      sym_component_body,
  [108081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2064), 1,
      sym_class_body,
  [108091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [108099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_class_body,
  [108109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2066), 1,
      sym_class_body,
  [108119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2077), 1,
      sym_class_body,
  [108137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2067), 1,
      sym_component_body,
  [108147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7800), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [108155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2068), 1,
      sym_statement_block,
  [108165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2069), 1,
      sym_statement_block,
  [108175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LBRACE,
    STATE(2070), 1,
      sym_statement_block,
  [108185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_LBRACE,
    STATE(2071), 1,
      sym_class_body,
  [108195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6836), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_statement_block,
  [108205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    STATE(2228), 1,
      sym_component_body,
  [108215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_statement_block,
  [108225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(639), 1,
      sym_statement_block,
  [108235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6836), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_statement_block,
  [108245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_statement_block,
  [108255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_LBRACE,
    STATE(619), 1,
      sym_class_body,
  [108265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACE,
    STATE(2259), 1,
      sym_class_body,
  [108275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7802), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_LBRACE,
    STATE(876), 1,
      sym_class_body,
  [108293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7804), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LPAREN,
    STATE(4329), 1,
      sym_formal_parameters,
  [108311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7806), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      sym_identifier,
    ACTIONS(7810), 1,
      sym_private_property_identifier,
  [108345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4134), 1,
      sym_statement_block,
  [108363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      sym_private_property_identifier,
  [108373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7257), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7816), 1,
      sym_identifier,
    ACTIONS(7818), 1,
      sym_private_property_identifier,
  [108391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_LBRACE,
    STATE(161), 1,
      sym_component_body,
  [108401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7259), 1,
      sym_identifier,
    ACTIONS(7263), 1,
      sym_private_property_identifier,
  [108411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACE,
    STATE(2072), 1,
      sym_component_body,
  [108429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(4137), 1,
      sym_statement_block,
  [108439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7820), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 1,
      anon_sym_EQ_GT,
  [108454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      sym_identifier,
  [108461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      sym_identifier,
  [108468] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7828), 1,
      sym_regex_pattern,
  [108475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7830), 1,
      anon_sym_EQ_GT,
  [108482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 1,
      anon_sym_EQ_GT,
  [108489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7834), 1,
      anon_sym_EQ_GT,
  [108496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7836), 1,
      anon_sym_EQ,
  [108503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_EQ_GT,
  [108510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      sym_identifier,
  [108517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_EQ_GT,
  [108524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      anon_sym_EQ_GT,
  [108531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5110), 1,
      anon_sym_RBRACK,
  [108538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7846), 1,
      anon_sym_class,
  [108545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_is,
  [108552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_DOT,
  [108559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7848), 1,
      anon_sym_RBRACK,
  [108566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_RBRACK,
  [108573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_RBRACK,
  [108580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_RBRACK,
  [108587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7854), 1,
      anon_sym_RBRACK,
  [108594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 1,
      anon_sym_RBRACK,
  [108601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7858), 1,
      anon_sym_RBRACK,
  [108608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 1,
      anon_sym_RBRACK,
  [108615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7862), 1,
      anon_sym_RBRACK,
  [108622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_RBRACK,
  [108629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 1,
      anon_sym_RBRACK,
  [108636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5108), 1,
      anon_sym_COLON,
  [108643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_EQ_GT,
  [108650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_RBRACK,
  [108657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 1,
      anon_sym_is,
  [108664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7870), 1,
      anon_sym_EQ_GT,
  [108671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      anon_sym_RBRACK,
  [108678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_RBRACK,
  [108685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_RBRACK,
  [108692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_RBRACK,
  [108699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7880), 1,
      anon_sym_EQ_GT,
  [108706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7882), 1,
      anon_sym_RBRACK,
  [108713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7884), 1,
      anon_sym_RPAREN,
  [108720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7886), 1,
      anon_sym_RBRACK,
  [108727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7888), 1,
      sym_identifier,
  [108734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7890), 1,
      anon_sym_RBRACK,
  [108741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7892), 1,
      anon_sym_RPAREN,
  [108748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7894), 1,
      anon_sym_EQ_GT,
  [108755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7896), 1,
      sym_identifier,
  [108762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7898), 1,
      anon_sym_EQ_GT,
  [108769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      anon_sym_EQ_GT,
  [108776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7902), 1,
      anon_sym_RBRACK,
  [108783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7904), 1,
      anon_sym_EQ_GT,
  [108790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      sym_identifier,
  [108797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7908), 1,
      anon_sym_RBRACK,
  [108804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7249), 1,
      anon_sym_RBRACK,
  [108811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7910), 1,
      anon_sym_RBRACK,
  [108818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7912), 1,
      anon_sym_RBRACK,
  [108825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5112), 1,
      anon_sym_RPAREN,
  [108832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7914), 1,
      anon_sym_RBRACK,
  [108839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7916), 1,
      anon_sym_RBRACK,
  [108846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7918), 1,
      anon_sym_RBRACK,
  [108853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7920), 1,
      anon_sym_RBRACK,
  [108860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7922), 1,
      anon_sym_RPAREN,
  [108867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7924), 1,
      anon_sym_RBRACK,
  [108874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7926), 1,
      anon_sym_RBRACK,
  [108881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7928), 1,
      anon_sym_RBRACK,
  [108888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7930), 1,
      anon_sym_RBRACK,
  [108895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7932), 1,
      anon_sym_RBRACK,
  [108902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7934), 1,
      anon_sym_RBRACK,
  [108909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7936), 1,
      anon_sym_target,
  [108916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 1,
      anon_sym_RPAREN,
  [108923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 1,
      anon_sym_RPAREN,
  [108930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7938), 1,
      anon_sym_EQ_GT,
  [108937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_EQ_GT,
  [108944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7942), 1,
      anon_sym_LBRACK,
  [108951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 1,
      anon_sym_RPAREN,
  [108958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7944), 1,
      anon_sym_EQ_GT,
  [108965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7946), 1,
      anon_sym_RBRACK,
  [108972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7948), 1,
      anon_sym_EQ_GT,
  [108979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7950), 1,
      anon_sym_EQ_GT,
  [108986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7584), 1,
      anon_sym_EQ,
  [108993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7952), 1,
      sym_number,
  [109000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7954), 1,
      sym_identifier,
  [109007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_EQ_GT,
  [109014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7958), 1,
      anon_sym_LBRACE,
  [109021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7960), 1,
      anon_sym_SLASH2,
  [109028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5064), 1,
      anon_sym_RBRACK,
  [109035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7962), 1,
      anon_sym_EQ_GT,
  [109042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4804), 1,
      anon_sym_RPAREN,
  [109049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7964), 1,
      sym_identifier,
  [109056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 1,
      anon_sym_RBRACE,
  [109063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7966), 1,
      anon_sym_EQ_GT,
  [109070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7968), 1,
      anon_sym_while,
  [109077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 1,
      anon_sym_EQ_GT,
  [109084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_EQ_GT,
  [109091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4802), 1,
      anon_sym_RPAREN,
  [109098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7970), 1,
      anon_sym_EQ_GT,
  [109105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7972), 1,
      anon_sym_LBRACE,
  [109112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7974), 1,
      sym_identifier,
  [109119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7976), 1,
      sym_identifier,
  [109126] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(7978), 1,
      sym_regex_pattern,
  [109133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7980), 1,
      sym_identifier,
  [109140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_function,
  [109147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7984), 1,
      anon_sym_EQ_GT,
  [109154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7986), 1,
      sym_identifier,
  [109161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5709), 1,
      anon_sym_DOT,
  [109168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7988), 1,
      sym_identifier,
  [109175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7990), 1,
      sym_number,
  [109182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7992), 1,
      anon_sym_class,
  [109189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7356), 1,
      anon_sym_RBRACK,
  [109196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_EQ_GT,
  [109203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7996), 1,
      anon_sym_EQ,
  [109210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7998), 1,
      anon_sym_EQ_GT,
  [109217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8000), 1,
      sym_identifier,
  [109224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8002), 1,
      anon_sym_RPAREN,
  [109231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_RPAREN,
  [109238] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(8006), 1,
      sym_regex_pattern,
  [109245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8008), 1,
      anon_sym_RPAREN,
  [109252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8010), 1,
      anon_sym_RPAREN,
  [109259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8012), 1,
      sym_identifier,
  [109266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 1,
      anon_sym_DOT,
  [109273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8014), 1,
      anon_sym_DOT,
  [109280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8016), 1,
      anon_sym_EQ_GT,
  [109287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_from,
  [109294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8020), 1,
      anon_sym_RPAREN,
  [109301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8022), 1,
      anon_sym_COLON,
  [109308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8024), 1,
      anon_sym_EQ_GT,
  [109315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8026), 1,
      sym_identifier,
  [109322] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(8028), 1,
      sym_regex_pattern,
  [109329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8030), 1,
      anon_sym_EQ_GT,
  [109336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      anon_sym_from,
  [109343] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(8034), 1,
      sym_regex_pattern,
  [109350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_RPAREN,
  [109357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8038), 1,
      anon_sym_EQ_GT,
  [109364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8040), 1,
      sym_identifier,
  [109371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4576), 1,
      anon_sym_DOT,
  [109378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7392), 1,
      anon_sym_from,
  [109385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8042), 1,
      anon_sym_RBRACK,
  [109392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3254), 1,
      anon_sym_LPAREN,
  [109399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8044), 1,
      anon_sym_RBRACK,
  [109406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8046), 1,
      sym_identifier,
  [109413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8048), 1,
      anon_sym_RBRACK,
  [109420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8050), 1,
      anon_sym_RBRACK,
  [109427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      anon_sym_RBRACK,
  [109434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8054), 1,
      anon_sym_RBRACK,
  [109441] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(8056), 1,
      sym_regex_pattern,
  [109448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8058), 1,
      sym_identifier,
  [109455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8060), 1,
      anon_sym_RBRACK,
  [109462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 1,
      anon_sym_DOT,
  [109469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_RBRACK,
  [109476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8064), 1,
      anon_sym_RBRACK,
  [109483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8066), 1,
      anon_sym_RBRACK,
  [109490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8068), 1,
      anon_sym_EQ_GT,
  [109497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8070), 1,
      anon_sym_RBRACK,
  [109504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 1,
      anon_sym_DOT,
  [109511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 1,
      anon_sym_DOT,
  [109518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym_RBRACK,
  [109525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7422), 1,
      sym_identifier,
  [109532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8074), 1,
      anon_sym_RBRACK,
  [109539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8076), 1,
      anon_sym_RBRACK,
  [109546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8078), 1,
      anon_sym_COLON,
  [109553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8080), 1,
      anon_sym_RBRACK,
  [109560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8082), 1,
      anon_sym_COLON,
  [109567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8084), 1,
      anon_sym_RBRACK,
  [109574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8086), 1,
      anon_sym_RBRACK,
  [109581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8088), 1,
      anon_sym_RBRACK,
  [109588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_RBRACK,
  [109595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8092), 1,
      anon_sym_RBRACK,
  [109602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8094), 1,
      anon_sym_EQ_GT,
  [109609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8096), 1,
      anon_sym_RBRACK,
  [109616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8098), 1,
      anon_sym_EQ,
  [109623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_RPAREN,
  [109630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8100), 1,
      anon_sym_RBRACK,
  [109637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8102), 1,
      anon_sym_RBRACK,
  [109644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8104), 1,
      sym_identifier,
  [109651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8106), 1,
      anon_sym_EQ_GT,
  [109658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym_COLON,
  [109665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8110), 1,
      anon_sym_new,
  [109672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8112), 1,
      anon_sym_RBRACK,
  [109679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8114), 1,
      anon_sym_EQ_GT,
  [109686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_RBRACK,
  [109693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_RBRACK,
  [109700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8120), 1,
      anon_sym_RBRACK,
  [109707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8122), 1,
      sym_identifier,
  [109714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8124), 1,
      anon_sym_EQ_GT,
  [109721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8126), 1,
      anon_sym_EQ_GT,
  [109728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8128), 1,
      anon_sym_EQ_GT,
  [109735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8130), 1,
      anon_sym_EQ_GT,
  [109742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8132), 1,
      sym_identifier,
  [109749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8134), 1,
      anon_sym_RBRACK,
  [109756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8136), 1,
      anon_sym_RBRACK,
  [109763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8138), 1,
      anon_sym_RBRACK,
  [109770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8140), 1,
      anon_sym_RBRACK,
  [109777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8142), 1,
      anon_sym_LPAREN,
  [109784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8144), 1,
      anon_sym_SLASH2,
  [109791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8146), 1,
      anon_sym_EQ_GT,
  [109798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8148), 1,
      anon_sym_EQ_GT,
  [109805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      sym_identifier,
  [109812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 1,
      anon_sym_COLON,
  [109819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8154), 1,
      sym_number,
  [109826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_fn,
  [109833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      sym_identifier,
  [109840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_is,
  [109847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_EQ_GT,
  [109854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8162), 1,
      anon_sym_SLASH2,
  [109861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8164), 1,
      sym_identifier,
  [109868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8166), 1,
      sym_identifier,
  [109875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8168), 1,
      anon_sym_EQ_GT,
  [109882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_EQ_GT,
  [109889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      sym_identifier,
  [109896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8174), 1,
      anon_sym_EQ_GT,
  [109903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8176), 1,
      anon_sym_RBRACK,
  [109910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8178), 1,
      anon_sym_RBRACK,
  [109917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8180), 1,
      anon_sym_RBRACK,
  [109924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8182), 1,
      anon_sym_RBRACK,
  [109931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8184), 1,
      anon_sym_RPAREN,
  [109938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8186), 1,
      anon_sym_RBRACK,
  [109945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8188), 1,
      anon_sym_EQ,
  [109952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 1,
      anon_sym_RBRACK,
  [109959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_RPAREN,
  [109966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8190), 1,
      anon_sym_RBRACK,
  [109973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8192), 1,
      anon_sym_RBRACK,
  [109980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8194), 1,
      anon_sym_SLASH2,
  [109987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8196), 1,
      anon_sym_RBRACK,
  [109994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8198), 1,
      anon_sym_new,
  [110001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8200), 1,
      anon_sym_readonly,
  [110008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_RBRACK,
  [110015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_RBRACK,
  [110022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_RBRACK,
  [110029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_RBRACK,
  [110036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8208), 1,
      anon_sym_EQ,
  [110043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8210), 1,
      anon_sym_EQ_GT,
  [110050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8212), 1,
      anon_sym_RBRACK,
  [110057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8214), 1,
      anon_sym_RBRACK,
  [110064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8216), 1,
      anon_sym_RBRACK,
  [110071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8218), 1,
      anon_sym_RBRACK,
  [110078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8220), 1,
      anon_sym_RBRACK,
  [110085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      sym_number,
  [110092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_target,
  [110099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_RBRACK,
  [110106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8228), 1,
      sym_identifier,
  [110113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8230), 1,
      anon_sym_EQ_GT,
  [110120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8232), 1,
      anon_sym_EQ_GT,
  [110127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8234), 1,
      anon_sym_EQ_GT,
  [110134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 1,
      anon_sym_LBRACE,
  [110141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8236), 1,
      anon_sym_EQ_GT,
  [110148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8238), 1,
      anon_sym_RBRACK,
  [110155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8240), 1,
      anon_sym_SLASH2,
  [110162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8242), 1,
      anon_sym_RBRACK,
  [110169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_DOT,
  [110176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8244), 1,
      anon_sym_EQ_GT,
  [110183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8246), 1,
      anon_sym_RBRACK,
  [110190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8248), 1,
      anon_sym_RBRACK,
  [110197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8250), 1,
      anon_sym_RBRACK,
  [110204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8252), 1,
      anon_sym_RBRACK,
  [110211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8254), 1,
      anon_sym_RBRACK,
  [110218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_RPAREN,
  [110225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8256), 1,
      anon_sym_RBRACK,
  [110232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8258), 1,
      anon_sym_RBRACK,
  [110239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8260), 1,
      anon_sym_RBRACK,
  [110246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8262), 1,
      anon_sym_RBRACK,
  [110253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8264), 1,
      sym_identifier,
  [110260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8266), 1,
      anon_sym_RBRACK,
  [110267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8268), 1,
      anon_sym_EQ,
  [110274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8270), 1,
      anon_sym_RBRACK,
  [110281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8272), 1,
      anon_sym_EQ_GT,
  [110288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8274), 1,
      anon_sym_EQ_GT,
  [110295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8276), 1,
      anon_sym_from,
  [110302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_RBRACK,
  [110309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8280), 1,
      anon_sym_RBRACK,
  [110316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_is,
  [110323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8282), 1,
      anon_sym_RBRACK,
  [110330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8284), 1,
      anon_sym_RBRACK,
  [110337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_RBRACK,
  [110344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8286), 1,
      anon_sym_RBRACK,
  [110351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8288), 1,
      anon_sym_RBRACK,
  [110358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      anon_sym_RBRACK,
  [110365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 1,
      anon_sym_RPAREN,
  [110372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8292), 1,
      anon_sym_EQ_GT,
  [110379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8294), 1,
      sym_identifier,
  [110386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8296), 1,
      sym_identifier,
  [110393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8298), 1,
      anon_sym_COLON,
  [110400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8300), 1,
      anon_sym_RBRACK,
  [110407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8302), 1,
      anon_sym_RBRACK,
  [110414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8304), 1,
      sym_identifier,
  [110421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8306), 1,
      anon_sym_new,
  [110428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_identifier,
  [110435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_SLASH2,
  [110442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_RBRACK,
  [110449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_RPAREN,
  [110456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 1,
      anon_sym_is,
  [110463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      sym_number,
  [110470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 1,
      anon_sym_EQ_GT,
  [110477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
  [110484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8322), 1,
      anon_sym_EQ,
  [110491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 1,
      anon_sym_EQ_GT,
  [110498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_EQ_GT,
  [110505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_EQ_GT,
  [110512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_fn,
  [110519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym_EQ_GT,
  [110526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
  [110533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8334), 1,
      anon_sym_EQ_GT,
  [110540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8336), 1,
      anon_sym_RBRACK,
  [110547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8338), 1,
      anon_sym_RBRACK,
  [110554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_EQ_GT,
  [110561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_EQ,
  [110568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8342), 1,
      anon_sym_EQ_GT,
  [110575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_EQ_GT,
  [110582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8346), 1,
      anon_sym_EQ_GT,
  [110589] = 2,
    ACTIONS(6912), 1,
      sym_comment,
    ACTIONS(8348), 1,
      sym_regex_pattern,
  [110596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 1,
      anon_sym_EQ,
  [110603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8352), 1,
      anon_sym_RBRACK,
  [110610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8354), 1,
      anon_sym_EQ_GT,
  [110617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8356), 1,
      anon_sym_RBRACK,
  [110624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8358), 1,
      anon_sym_RBRACK,
  [110631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8360), 1,
      anon_sym_new,
  [110638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8362), 1,
      anon_sym_RBRACK,
  [110645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8364), 1,
      anon_sym_EQ_GT,
  [110652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8366), 1,
      anon_sym_target,
  [110659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8368), 1,
      anon_sym_RBRACK,
  [110666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8370), 1,
      anon_sym_EQ_GT,
  [110673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_EQ_GT,
  [110680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8374), 1,
      anon_sym_EQ_GT,
  [110687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8376), 1,
      anon_sym_EQ_GT,
  [110694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8378), 1,
      anon_sym_EQ_GT,
  [110701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8380), 1,
      anon_sym_RBRACK,
  [110708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_from,
  [110715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8384), 1,
      sym_identifier,
  [110722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym_identifier,
  [110729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_EQ,
  [110736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8388), 1,
      anon_sym_EQ_GT,
  [110743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8390), 1,
      anon_sym_EQ_GT,
  [110750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_EQ_GT,
  [110757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8394), 1,
      anon_sym_EQ_GT,
  [110764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8396), 1,
      anon_sym_EQ_GT,
  [110771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_RBRACK,
  [110778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8400), 1,
      sym_identifier,
  [110785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8402), 1,
      sym_identifier,
  [110792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_new,
  [110799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7432), 1,
      anon_sym_RBRACK,
  [110806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      sym_identifier,
  [110813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_EQ_GT,
  [110820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      sym_identifier,
  [110827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_new,
  [110834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8414), 1,
      anon_sym_EQ_GT,
  [110841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8416), 1,
      anon_sym_new,
  [110848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8418), 1,
      anon_sym_RBRACK,
  [110855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8420), 1,
      anon_sym_new,
  [110862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 1,
      anon_sym_RBRACK,
  [110869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8422), 1,
      anon_sym_as,
  [110876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8424), 1,
      sym_identifier,
  [110883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8426), 1,
      sym_identifier,
  [110890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8428), 1,
      sym_identifier,
  [110897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8430), 1,
      anon_sym_SLASH2,
  [110904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8432), 1,
      anon_sym_EQ_GT,
  [110911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8434), 1,
      anon_sym_COLON,
  [110918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8436), 1,
      anon_sym_EQ_GT,
  [110925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      sym_identifier,
  [110932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      sym_identifier,
  [110939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      sym_identifier,
  [110946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8444), 1,
      anon_sym_EQ_GT,
  [110953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8446), 1,
      sym_identifier,
  [110960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8448), 1,
      sym_identifier,
  [110967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8450), 1,
      sym_identifier,
  [110974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8452), 1,
      sym_number,
  [110981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 1,
      anon_sym_RBRACK,
  [110988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7497), 1,
      anon_sym_from,
  [110995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      sym_identifier,
  [111002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8454), 1,
      sym_identifier,
  [111009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
  [111016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8458), 1,
      anon_sym_RBRACK,
  [111023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8460), 1,
      anon_sym_RBRACK,
  [111030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8462), 1,
      anon_sym_RBRACK,
  [111037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8464), 1,
      anon_sym_RBRACK,
  [111044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      sym_identifier,
  [111051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_RBRACK,
  [111058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5048), 1,
      anon_sym_RBRACE,
  [111065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_RBRACK,
  [111072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8472), 1,
      anon_sym_as,
  [111079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8474), 1,
      anon_sym_RBRACK,
  [111086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_RBRACK,
  [111093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8478), 1,
      anon_sym_new,
  [111100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8480), 1,
      ts_builtin_sym_end,
  [111107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8482), 1,
      anon_sym_RBRACK,
  [111114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym_function,
  [111121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8486), 1,
      anon_sym_new,
  [111128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8488), 1,
      anon_sym_RBRACK,
  [111135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8490), 1,
      sym_identifier,
  [111142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8492), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1300)] = 0,
  [SMALL_STATE(1301)] = 103,
  [SMALL_STATE(1302)] = 200,
  [SMALL_STATE(1303)] = 290,
  [SMALL_STATE(1304)] = 380,
  [SMALL_STATE(1305)] = 476,
  [SMALL_STATE(1306)] = 614,
  [SMALL_STATE(1307)] = 752,
  [SMALL_STATE(1308)] = 890,
  [SMALL_STATE(1309)] = 1028,
  [SMALL_STATE(1310)] = 1166,
  [SMALL_STATE(1311)] = 1264,
  [SMALL_STATE(1312)] = 1362,
  [SMALL_STATE(1313)] = 1500,
  [SMALL_STATE(1314)] = 1590,
  [SMALL_STATE(1315)] = 1728,
  [SMALL_STATE(1316)] = 1822,
  [SMALL_STATE(1317)] = 1960,
  [SMALL_STATE(1318)] = 2054,
  [SMALL_STATE(1319)] = 2144,
  [SMALL_STATE(1320)] = 2235,
  [SMALL_STATE(1321)] = 2326,
  [SMALL_STATE(1322)] = 2419,
  [SMALL_STATE(1323)] = 2512,
  [SMALL_STATE(1324)] = 2609,
  [SMALL_STATE(1325)] = 2700,
  [SMALL_STATE(1326)] = 2791,
  [SMALL_STATE(1327)] = 2882,
  [SMALL_STATE(1328)] = 2973,
  [SMALL_STATE(1329)] = 3041,
  [SMALL_STATE(1330)] = 3109,
  [SMALL_STATE(1331)] = 3197,
  [SMALL_STATE(1332)] = 3285,
  [SMALL_STATE(1333)] = 3373,
  [SMALL_STATE(1334)] = 3441,
  [SMALL_STATE(1335)] = 3509,
  [SMALL_STATE(1336)] = 3577,
  [SMALL_STATE(1337)] = 3645,
  [SMALL_STATE(1338)] = 3713,
  [SMALL_STATE(1339)] = 3784,
  [SMALL_STATE(1340)] = 3851,
  [SMALL_STATE(1341)] = 3918,
  [SMALL_STATE(1342)] = 3996,
  [SMALL_STATE(1343)] = 4072,
  [SMALL_STATE(1344)] = 4148,
  [SMALL_STATE(1345)] = 4272,
  [SMALL_STATE(1346)] = 4350,
  [SMALL_STATE(1347)] = 4474,
  [SMALL_STATE(1348)] = 4549,
  [SMALL_STATE(1349)] = 4622,
  [SMALL_STATE(1350)] = 4697,
  [SMALL_STATE(1351)] = 4778,
  [SMALL_STATE(1352)] = 4851,
  [SMALL_STATE(1353)] = 4926,
  [SMALL_STATE(1354)] = 4997,
  [SMALL_STATE(1355)] = 5072,
  [SMALL_STATE(1356)] = 5147,
  [SMALL_STATE(1357)] = 5228,
  [SMALL_STATE(1358)] = 5304,
  [SMALL_STATE(1359)] = 5378,
  [SMALL_STATE(1360)] = 5442,
  [SMALL_STATE(1361)] = 5506,
  [SMALL_STATE(1362)] = 5576,
  [SMALL_STATE(1363)] = 5646,
  [SMALL_STATE(1364)] = 5724,
  [SMALL_STATE(1365)] = 5794,
  [SMALL_STATE(1366)] = 5858,
  [SMALL_STATE(1367)] = 5922,
  [SMALL_STATE(1368)] = 5986,
  [SMALL_STATE(1369)] = 6050,
  [SMALL_STATE(1370)] = 6120,
  [SMALL_STATE(1371)] = 6184,
  [SMALL_STATE(1372)] = 6262,
  [SMALL_STATE(1373)] = 6326,
  [SMALL_STATE(1374)] = 6396,
  [SMALL_STATE(1375)] = 6468,
  [SMALL_STATE(1376)] = 6548,
  [SMALL_STATE(1377)] = 6616,
  [SMALL_STATE(1378)] = 6690,
  [SMALL_STATE(1379)] = 6760,
  [SMALL_STATE(1380)] = 6832,
  [SMALL_STATE(1381)] = 6896,
  [SMALL_STATE(1382)] = 6970,
  [SMALL_STATE(1383)] = 7045,
  [SMALL_STATE(1384)] = 7114,
  [SMALL_STATE(1385)] = 7177,
  [SMALL_STATE(1386)] = 7248,
  [SMALL_STATE(1387)] = 7311,
  [SMALL_STATE(1388)] = 7378,
  [SMALL_STATE(1389)] = 7447,
  [SMALL_STATE(1390)] = 7510,
  [SMALL_STATE(1391)] = 7573,
  [SMALL_STATE(1392)] = 7640,
  [SMALL_STATE(1393)] = 7711,
  [SMALL_STATE(1394)] = 7786,
  [SMALL_STATE(1395)] = 7850,
  [SMALL_STATE(1396)] = 7916,
  [SMALL_STATE(1397)] = 7980,
  [SMALL_STATE(1398)] = 8050,
  [SMALL_STATE(1399)] = 8112,
  [SMALL_STATE(1400)] = 8174,
  [SMALL_STATE(1401)] = 8244,
  [SMALL_STATE(1402)] = 8314,
  [SMALL_STATE(1403)] = 8376,
  [SMALL_STATE(1404)] = 8437,
  [SMALL_STATE(1405)] = 8498,
  [SMALL_STATE(1406)] = 8559,
  [SMALL_STATE(1407)] = 8620,
  [SMALL_STATE(1408)] = 8681,
  [SMALL_STATE(1409)] = 8748,
  [SMALL_STATE(1410)] = 8819,
  [SMALL_STATE(1411)] = 8886,
  [SMALL_STATE(1412)] = 8953,
  [SMALL_STATE(1413)] = 9014,
  [SMALL_STATE(1414)] = 9082,
  [SMALL_STATE(1415)] = 9146,
  [SMALL_STATE(1416)] = 9204,
  [SMALL_STATE(1417)] = 9266,
  [SMALL_STATE(1418)] = 9328,
  [SMALL_STATE(1419)] = 9435,
  [SMALL_STATE(1420)] = 9494,
  [SMALL_STATE(1421)] = 9601,
  [SMALL_STATE(1422)] = 9662,
  [SMALL_STATE(1423)] = 9723,
  [SMALL_STATE(1424)] = 9830,
  [SMALL_STATE(1425)] = 9889,
  [SMALL_STATE(1426)] = 9996,
  [SMALL_STATE(1427)] = 10103,
  [SMALL_STATE(1428)] = 10210,
  [SMALL_STATE(1429)] = 10317,
  [SMALL_STATE(1430)] = 10373,
  [SMALL_STATE(1431)] = 10429,
  [SMALL_STATE(1432)] = 10485,
  [SMALL_STATE(1433)] = 10541,
  [SMALL_STATE(1434)] = 10597,
  [SMALL_STATE(1435)] = 10653,
  [SMALL_STATE(1436)] = 10709,
  [SMALL_STATE(1437)] = 10765,
  [SMALL_STATE(1438)] = 10823,
  [SMALL_STATE(1439)] = 10879,
  [SMALL_STATE(1440)] = 10935,
  [SMALL_STATE(1441)] = 10991,
  [SMALL_STATE(1442)] = 11047,
  [SMALL_STATE(1443)] = 11103,
  [SMALL_STATE(1444)] = 11159,
  [SMALL_STATE(1445)] = 11215,
  [SMALL_STATE(1446)] = 11271,
  [SMALL_STATE(1447)] = 11327,
  [SMALL_STATE(1448)] = 11383,
  [SMALL_STATE(1449)] = 11439,
  [SMALL_STATE(1450)] = 11495,
  [SMALL_STATE(1451)] = 11551,
  [SMALL_STATE(1452)] = 11607,
  [SMALL_STATE(1453)] = 11663,
  [SMALL_STATE(1454)] = 11719,
  [SMALL_STATE(1455)] = 11775,
  [SMALL_STATE(1456)] = 11831,
  [SMALL_STATE(1457)] = 11887,
  [SMALL_STATE(1458)] = 11943,
  [SMALL_STATE(1459)] = 11999,
  [SMALL_STATE(1460)] = 12055,
  [SMALL_STATE(1461)] = 12111,
  [SMALL_STATE(1462)] = 12167,
  [SMALL_STATE(1463)] = 12223,
  [SMALL_STATE(1464)] = 12279,
  [SMALL_STATE(1465)] = 12335,
  [SMALL_STATE(1466)] = 12391,
  [SMALL_STATE(1467)] = 12447,
  [SMALL_STATE(1468)] = 12503,
  [SMALL_STATE(1469)] = 12559,
  [SMALL_STATE(1470)] = 12662,
  [SMALL_STATE(1471)] = 12721,
  [SMALL_STATE(1472)] = 12824,
  [SMALL_STATE(1473)] = 12927,
  [SMALL_STATE(1474)] = 13030,
  [SMALL_STATE(1475)] = 13133,
  [SMALL_STATE(1476)] = 13236,
  [SMALL_STATE(1477)] = 13291,
  [SMALL_STATE(1478)] = 13394,
  [SMALL_STATE(1479)] = 13497,
  [SMALL_STATE(1480)] = 13600,
  [SMALL_STATE(1481)] = 13703,
  [SMALL_STATE(1482)] = 13806,
  [SMALL_STATE(1483)] = 13909,
  [SMALL_STATE(1484)] = 14012,
  [SMALL_STATE(1485)] = 14115,
  [SMALL_STATE(1486)] = 14218,
  [SMALL_STATE(1487)] = 14321,
  [SMALL_STATE(1488)] = 14424,
  [SMALL_STATE(1489)] = 14527,
  [SMALL_STATE(1490)] = 14630,
  [SMALL_STATE(1491)] = 14733,
  [SMALL_STATE(1492)] = 14836,
  [SMALL_STATE(1493)] = 14934,
  [SMALL_STATE(1494)] = 15032,
  [SMALL_STATE(1495)] = 15130,
  [SMALL_STATE(1496)] = 15228,
  [SMALL_STATE(1497)] = 15326,
  [SMALL_STATE(1498)] = 15396,
  [SMALL_STATE(1499)] = 15494,
  [SMALL_STATE(1500)] = 15556,
  [SMALL_STATE(1501)] = 15654,
  [SMALL_STATE(1502)] = 15752,
  [SMALL_STATE(1503)] = 15808,
  [SMALL_STATE(1504)] = 15907,
  [SMALL_STATE(1505)] = 15964,
  [SMALL_STATE(1506)] = 16017,
  [SMALL_STATE(1507)] = 16074,
  [SMALL_STATE(1508)] = 16173,
  [SMALL_STATE(1509)] = 16272,
  [SMALL_STATE(1510)] = 16371,
  [SMALL_STATE(1511)] = 16430,
  [SMALL_STATE(1512)] = 16489,
  [SMALL_STATE(1513)] = 16542,
  [SMALL_STATE(1514)] = 16641,
  [SMALL_STATE(1515)] = 16696,
  [SMALL_STATE(1516)] = 16755,
  [SMALL_STATE(1517)] = 16854,
  [SMALL_STATE(1518)] = 16913,
  [SMALL_STATE(1519)] = 16978,
  [SMALL_STATE(1520)] = 17051,
  [SMALL_STATE(1521)] = 17104,
  [SMALL_STATE(1522)] = 17203,
  [SMALL_STATE(1523)] = 17258,
  [SMALL_STATE(1524)] = 17325,
  [SMALL_STATE(1525)] = 17380,
  [SMALL_STATE(1526)] = 17439,
  [SMALL_STATE(1527)] = 17538,
  [SMALL_STATE(1528)] = 17590,
  [SMALL_STATE(1529)] = 17642,
  [SMALL_STATE(1530)] = 17700,
  [SMALL_STATE(1531)] = 17752,
  [SMALL_STATE(1532)] = 17804,
  [SMALL_STATE(1533)] = 17860,
  [SMALL_STATE(1534)] = 17914,
  [SMALL_STATE(1535)] = 17966,
  [SMALL_STATE(1536)] = 18020,
  [SMALL_STATE(1537)] = 18074,
  [SMALL_STATE(1538)] = 18126,
  [SMALL_STATE(1539)] = 18178,
  [SMALL_STATE(1540)] = 18230,
  [SMALL_STATE(1541)] = 18282,
  [SMALL_STATE(1542)] = 18334,
  [SMALL_STATE(1543)] = 18386,
  [SMALL_STATE(1544)] = 18438,
  [SMALL_STATE(1545)] = 18490,
  [SMALL_STATE(1546)] = 18542,
  [SMALL_STATE(1547)] = 18594,
  [SMALL_STATE(1548)] = 18646,
  [SMALL_STATE(1549)] = 18698,
  [SMALL_STATE(1550)] = 18750,
  [SMALL_STATE(1551)] = 18802,
  [SMALL_STATE(1552)] = 18854,
  [SMALL_STATE(1553)] = 18906,
  [SMALL_STATE(1554)] = 18958,
  [SMALL_STATE(1555)] = 19010,
  [SMALL_STATE(1556)] = 19062,
  [SMALL_STATE(1557)] = 19114,
  [SMALL_STATE(1558)] = 19166,
  [SMALL_STATE(1559)] = 19218,
  [SMALL_STATE(1560)] = 19276,
  [SMALL_STATE(1561)] = 19328,
  [SMALL_STATE(1562)] = 19380,
  [SMALL_STATE(1563)] = 19432,
  [SMALL_STATE(1564)] = 19486,
  [SMALL_STATE(1565)] = 19538,
  [SMALL_STATE(1566)] = 19598,
  [SMALL_STATE(1567)] = 19650,
  [SMALL_STATE(1568)] = 19702,
  [SMALL_STATE(1569)] = 19754,
  [SMALL_STATE(1570)] = 19806,
  [SMALL_STATE(1571)] = 19858,
  [SMALL_STATE(1572)] = 19910,
  [SMALL_STATE(1573)] = 19964,
  [SMALL_STATE(1574)] = 20016,
  [SMALL_STATE(1575)] = 20068,
  [SMALL_STATE(1576)] = 20120,
  [SMALL_STATE(1577)] = 20172,
  [SMALL_STATE(1578)] = 20224,
  [SMALL_STATE(1579)] = 20276,
  [SMALL_STATE(1580)] = 20328,
  [SMALL_STATE(1581)] = 20418,
  [SMALL_STATE(1582)] = 20472,
  [SMALL_STATE(1583)] = 20524,
  [SMALL_STATE(1584)] = 20578,
  [SMALL_STATE(1585)] = 20632,
  [SMALL_STATE(1586)] = 20688,
  [SMALL_STATE(1587)] = 20740,
  [SMALL_STATE(1588)] = 20792,
  [SMALL_STATE(1589)] = 20844,
  [SMALL_STATE(1590)] = 20896,
  [SMALL_STATE(1591)] = 20948,
  [SMALL_STATE(1592)] = 21000,
  [SMALL_STATE(1593)] = 21058,
  [SMALL_STATE(1594)] = 21110,
  [SMALL_STATE(1595)] = 21162,
  [SMALL_STATE(1596)] = 21214,
  [SMALL_STATE(1597)] = 21266,
  [SMALL_STATE(1598)] = 21320,
  [SMALL_STATE(1599)] = 21372,
  [SMALL_STATE(1600)] = 21424,
  [SMALL_STATE(1601)] = 21476,
  [SMALL_STATE(1602)] = 21528,
  [SMALL_STATE(1603)] = 21582,
  [SMALL_STATE(1604)] = 21640,
  [SMALL_STATE(1605)] = 21692,
  [SMALL_STATE(1606)] = 21744,
  [SMALL_STATE(1607)] = 21796,
  [SMALL_STATE(1608)] = 21848,
  [SMALL_STATE(1609)] = 21900,
  [SMALL_STATE(1610)] = 21952,
  [SMALL_STATE(1611)] = 22004,
  [SMALL_STATE(1612)] = 22056,
  [SMALL_STATE(1613)] = 22108,
  [SMALL_STATE(1614)] = 22160,
  [SMALL_STATE(1615)] = 22212,
  [SMALL_STATE(1616)] = 22264,
  [SMALL_STATE(1617)] = 22316,
  [SMALL_STATE(1618)] = 22370,
  [SMALL_STATE(1619)] = 22426,
  [SMALL_STATE(1620)] = 22482,
  [SMALL_STATE(1621)] = 22534,
  [SMALL_STATE(1622)] = 22592,
  [SMALL_STATE(1623)] = 22650,
  [SMALL_STATE(1624)] = 22702,
  [SMALL_STATE(1625)] = 22760,
  [SMALL_STATE(1626)] = 22818,
  [SMALL_STATE(1627)] = 22870,
  [SMALL_STATE(1628)] = 22924,
  [SMALL_STATE(1629)] = 22976,
  [SMALL_STATE(1630)] = 23028,
  [SMALL_STATE(1631)] = 23079,
  [SMALL_STATE(1632)] = 23130,
  [SMALL_STATE(1633)] = 23181,
  [SMALL_STATE(1634)] = 23232,
  [SMALL_STATE(1635)] = 23297,
  [SMALL_STATE(1636)] = 23348,
  [SMALL_STATE(1637)] = 23399,
  [SMALL_STATE(1638)] = 23450,
  [SMALL_STATE(1639)] = 23505,
  [SMALL_STATE(1640)] = 23600,
  [SMALL_STATE(1641)] = 23665,
  [SMALL_STATE(1642)] = 23716,
  [SMALL_STATE(1643)] = 23767,
  [SMALL_STATE(1644)] = 23818,
  [SMALL_STATE(1645)] = 23869,
  [SMALL_STATE(1646)] = 23936,
  [SMALL_STATE(1647)] = 23987,
  [SMALL_STATE(1648)] = 24038,
  [SMALL_STATE(1649)] = 24089,
  [SMALL_STATE(1650)] = 24140,
  [SMALL_STATE(1651)] = 24191,
  [SMALL_STATE(1652)] = 24242,
  [SMALL_STATE(1653)] = 24293,
  [SMALL_STATE(1654)] = 24344,
  [SMALL_STATE(1655)] = 24395,
  [SMALL_STATE(1656)] = 24446,
  [SMALL_STATE(1657)] = 24497,
  [SMALL_STATE(1658)] = 24548,
  [SMALL_STATE(1659)] = 24599,
  [SMALL_STATE(1660)] = 24650,
  [SMALL_STATE(1661)] = 24701,
  [SMALL_STATE(1662)] = 24796,
  [SMALL_STATE(1663)] = 24847,
  [SMALL_STATE(1664)] = 24898,
  [SMALL_STATE(1665)] = 24949,
  [SMALL_STATE(1666)] = 25000,
  [SMALL_STATE(1667)] = 25051,
  [SMALL_STATE(1668)] = 25102,
  [SMALL_STATE(1669)] = 25153,
  [SMALL_STATE(1670)] = 25204,
  [SMALL_STATE(1671)] = 25255,
  [SMALL_STATE(1672)] = 25306,
  [SMALL_STATE(1673)] = 25401,
  [SMALL_STATE(1674)] = 25496,
  [SMALL_STATE(1675)] = 25547,
  [SMALL_STATE(1676)] = 25598,
  [SMALL_STATE(1677)] = 25649,
  [SMALL_STATE(1678)] = 25744,
  [SMALL_STATE(1679)] = 25795,
  [SMALL_STATE(1680)] = 25890,
  [SMALL_STATE(1681)] = 25941,
  [SMALL_STATE(1682)] = 25992,
  [SMALL_STATE(1683)] = 26043,
  [SMALL_STATE(1684)] = 26094,
  [SMALL_STATE(1685)] = 26145,
  [SMALL_STATE(1686)] = 26196,
  [SMALL_STATE(1687)] = 26247,
  [SMALL_STATE(1688)] = 26298,
  [SMALL_STATE(1689)] = 26393,
  [SMALL_STATE(1690)] = 26444,
  [SMALL_STATE(1691)] = 26495,
  [SMALL_STATE(1692)] = 26546,
  [SMALL_STATE(1693)] = 26597,
  [SMALL_STATE(1694)] = 26648,
  [SMALL_STATE(1695)] = 26699,
  [SMALL_STATE(1696)] = 26750,
  [SMALL_STATE(1697)] = 26801,
  [SMALL_STATE(1698)] = 26852,
  [SMALL_STATE(1699)] = 26903,
  [SMALL_STATE(1700)] = 26954,
  [SMALL_STATE(1701)] = 27005,
  [SMALL_STATE(1702)] = 27056,
  [SMALL_STATE(1703)] = 27107,
  [SMALL_STATE(1704)] = 27158,
  [SMALL_STATE(1705)] = 27253,
  [SMALL_STATE(1706)] = 27304,
  [SMALL_STATE(1707)] = 27355,
  [SMALL_STATE(1708)] = 27406,
  [SMALL_STATE(1709)] = 27465,
  [SMALL_STATE(1710)] = 27516,
  [SMALL_STATE(1711)] = 27567,
  [SMALL_STATE(1712)] = 27662,
  [SMALL_STATE(1713)] = 27757,
  [SMALL_STATE(1714)] = 27808,
  [SMALL_STATE(1715)] = 27859,
  [SMALL_STATE(1716)] = 27910,
  [SMALL_STATE(1717)] = 28005,
  [SMALL_STATE(1718)] = 28056,
  [SMALL_STATE(1719)] = 28107,
  [SMALL_STATE(1720)] = 28158,
  [SMALL_STATE(1721)] = 28253,
  [SMALL_STATE(1722)] = 28304,
  [SMALL_STATE(1723)] = 28355,
  [SMALL_STATE(1724)] = 28406,
  [SMALL_STATE(1725)] = 28457,
  [SMALL_STATE(1726)] = 28508,
  [SMALL_STATE(1727)] = 28559,
  [SMALL_STATE(1728)] = 28610,
  [SMALL_STATE(1729)] = 28705,
  [SMALL_STATE(1730)] = 28756,
  [SMALL_STATE(1731)] = 28812,
  [SMALL_STATE(1732)] = 28914,
  [SMALL_STATE(1733)] = 28968,
  [SMALL_STATE(1734)] = 29024,
  [SMALL_STATE(1735)] = 29106,
  [SMALL_STATE(1736)] = 29208,
  [SMALL_STATE(1737)] = 29262,
  [SMALL_STATE(1738)] = 29314,
  [SMALL_STATE(1739)] = 29396,
  [SMALL_STATE(1740)] = 29448,
  [SMALL_STATE(1741)] = 29550,
  [SMALL_STATE(1742)] = 29652,
  [SMALL_STATE(1743)] = 29710,
  [SMALL_STATE(1744)] = 29812,
  [SMALL_STATE(1745)] = 29862,
  [SMALL_STATE(1746)] = 29966,
  [SMALL_STATE(1747)] = 30016,
  [SMALL_STATE(1748)] = 30076,
  [SMALL_STATE(1749)] = 30158,
  [SMALL_STATE(1750)] = 30218,
  [SMALL_STATE(1751)] = 30274,
  [SMALL_STATE(1752)] = 30338,
  [SMALL_STATE(1753)] = 30408,
  [SMALL_STATE(1754)] = 30464,
  [SMALL_STATE(1755)] = 30518,
  [SMALL_STATE(1756)] = 30580,
  [SMALL_STATE(1757)] = 30636,
  [SMALL_STATE(1758)] = 30686,
  [SMALL_STATE(1759)] = 30768,
  [SMALL_STATE(1760)] = 30818,
  [SMALL_STATE(1761)] = 30920,
  [SMALL_STATE(1762)] = 31022,
  [SMALL_STATE(1763)] = 31116,
  [SMALL_STATE(1764)] = 31196,
  [SMALL_STATE(1765)] = 31268,
  [SMALL_STATE(1766)] = 31318,
  [SMALL_STATE(1767)] = 31370,
  [SMALL_STATE(1768)] = 31422,
  [SMALL_STATE(1769)] = 31492,
  [SMALL_STATE(1770)] = 31580,
  [SMALL_STATE(1771)] = 31666,
  [SMALL_STATE(1772)] = 31750,
  [SMALL_STATE(1773)] = 31822,
  [SMALL_STATE(1774)] = 31914,
  [SMALL_STATE(1775)] = 32004,
  [SMALL_STATE(1776)] = 32080,
  [SMALL_STATE(1777)] = 32146,
  [SMALL_STATE(1778)] = 32248,
  [SMALL_STATE(1779)] = 32350,
  [SMALL_STATE(1780)] = 32460,
  [SMALL_STATE(1781)] = 32518,
  [SMALL_STATE(1782)] = 32620,
  [SMALL_STATE(1783)] = 32670,
  [SMALL_STATE(1784)] = 32772,
  [SMALL_STATE(1785)] = 32874,
  [SMALL_STATE(1786)] = 32924,
  [SMALL_STATE(1787)] = 32978,
  [SMALL_STATE(1788)] = 33034,
  [SMALL_STATE(1789)] = 33090,
  [SMALL_STATE(1790)] = 33146,
  [SMALL_STATE(1791)] = 33202,
  [SMALL_STATE(1792)] = 33258,
  [SMALL_STATE(1793)] = 33307,
  [SMALL_STATE(1794)] = 33362,
  [SMALL_STATE(1795)] = 33411,
  [SMALL_STATE(1796)] = 33460,
  [SMALL_STATE(1797)] = 33509,
  [SMALL_STATE(1798)] = 33558,
  [SMALL_STATE(1799)] = 33607,
  [SMALL_STATE(1800)] = 33656,
  [SMALL_STATE(1801)] = 33705,
  [SMALL_STATE(1802)] = 33754,
  [SMALL_STATE(1803)] = 33803,
  [SMALL_STATE(1804)] = 33910,
  [SMALL_STATE(1805)] = 34011,
  [SMALL_STATE(1806)] = 34060,
  [SMALL_STATE(1807)] = 34109,
  [SMALL_STATE(1808)] = 34164,
  [SMALL_STATE(1809)] = 34213,
  [SMALL_STATE(1810)] = 34314,
  [SMALL_STATE(1811)] = 34363,
  [SMALL_STATE(1812)] = 34412,
  [SMALL_STATE(1813)] = 34461,
  [SMALL_STATE(1814)] = 34510,
  [SMALL_STATE(1815)] = 34559,
  [SMALL_STATE(1816)] = 34608,
  [SMALL_STATE(1817)] = 34657,
  [SMALL_STATE(1818)] = 34706,
  [SMALL_STATE(1819)] = 34755,
  [SMALL_STATE(1820)] = 34804,
  [SMALL_STATE(1821)] = 34853,
  [SMALL_STATE(1822)] = 34902,
  [SMALL_STATE(1823)] = 35009,
  [SMALL_STATE(1824)] = 35058,
  [SMALL_STATE(1825)] = 35107,
  [SMALL_STATE(1826)] = 35156,
  [SMALL_STATE(1827)] = 35205,
  [SMALL_STATE(1828)] = 35254,
  [SMALL_STATE(1829)] = 35303,
  [SMALL_STATE(1830)] = 35352,
  [SMALL_STATE(1831)] = 35403,
  [SMALL_STATE(1832)] = 35452,
  [SMALL_STATE(1833)] = 35501,
  [SMALL_STATE(1834)] = 35608,
  [SMALL_STATE(1835)] = 35663,
  [SMALL_STATE(1836)] = 35712,
  [SMALL_STATE(1837)] = 35761,
  [SMALL_STATE(1838)] = 35810,
  [SMALL_STATE(1839)] = 35865,
  [SMALL_STATE(1840)] = 35914,
  [SMALL_STATE(1841)] = 35963,
  [SMALL_STATE(1842)] = 36012,
  [SMALL_STATE(1843)] = 36061,
  [SMALL_STATE(1844)] = 36110,
  [SMALL_STATE(1845)] = 36211,
  [SMALL_STATE(1846)] = 36262,
  [SMALL_STATE(1847)] = 36311,
  [SMALL_STATE(1848)] = 36362,
  [SMALL_STATE(1849)] = 36411,
  [SMALL_STATE(1850)] = 36466,
  [SMALL_STATE(1851)] = 36521,
  [SMALL_STATE(1852)] = 36570,
  [SMALL_STATE(1853)] = 36619,
  [SMALL_STATE(1854)] = 36668,
  [SMALL_STATE(1855)] = 36719,
  [SMALL_STATE(1856)] = 36768,
  [SMALL_STATE(1857)] = 36869,
  [SMALL_STATE(1858)] = 36918,
  [SMALL_STATE(1859)] = 36969,
  [SMALL_STATE(1860)] = 37018,
  [SMALL_STATE(1861)] = 37067,
  [SMALL_STATE(1862)] = 37116,
  [SMALL_STATE(1863)] = 37165,
  [SMALL_STATE(1864)] = 37216,
  [SMALL_STATE(1865)] = 37269,
  [SMALL_STATE(1866)] = 37318,
  [SMALL_STATE(1867)] = 37367,
  [SMALL_STATE(1868)] = 37418,
  [SMALL_STATE(1869)] = 37467,
  [SMALL_STATE(1870)] = 37516,
  [SMALL_STATE(1871)] = 37565,
  [SMALL_STATE(1872)] = 37614,
  [SMALL_STATE(1873)] = 37663,
  [SMALL_STATE(1874)] = 37714,
  [SMALL_STATE(1875)] = 37767,
  [SMALL_STATE(1876)] = 37828,
  [SMALL_STATE(1877)] = 37889,
  [SMALL_STATE(1878)] = 37990,
  [SMALL_STATE(1879)] = 38039,
  [SMALL_STATE(1880)] = 38088,
  [SMALL_STATE(1881)] = 38189,
  [SMALL_STATE(1882)] = 38290,
  [SMALL_STATE(1883)] = 38391,
  [SMALL_STATE(1884)] = 38496,
  [SMALL_STATE(1885)] = 38551,
  [SMALL_STATE(1886)] = 38652,
  [SMALL_STATE(1887)] = 38753,
  [SMALL_STATE(1888)] = 38802,
  [SMALL_STATE(1889)] = 38895,
  [SMALL_STATE(1890)] = 38974,
  [SMALL_STATE(1891)] = 39045,
  [SMALL_STATE(1892)] = 39114,
  [SMALL_STATE(1893)] = 39201,
  [SMALL_STATE(1894)] = 39286,
  [SMALL_STATE(1895)] = 39369,
  [SMALL_STATE(1896)] = 39440,
  [SMALL_STATE(1897)] = 39531,
  [SMALL_STATE(1898)] = 39620,
  [SMALL_STATE(1899)] = 39695,
  [SMALL_STATE(1900)] = 39760,
  [SMALL_STATE(1901)] = 39861,
  [SMALL_STATE(1902)] = 39962,
  [SMALL_STATE(1903)] = 40063,
  [SMALL_STATE(1904)] = 40164,
  [SMALL_STATE(1905)] = 40265,
  [SMALL_STATE(1906)] = 40314,
  [SMALL_STATE(1907)] = 40363,
  [SMALL_STATE(1908)] = 40412,
  [SMALL_STATE(1909)] = 40467,
  [SMALL_STATE(1910)] = 40542,
  [SMALL_STATE(1911)] = 40591,
  [SMALL_STATE(1912)] = 40640,
  [SMALL_STATE(1913)] = 40689,
  [SMALL_STATE(1914)] = 40738,
  [SMALL_STATE(1915)] = 40787,
  [SMALL_STATE(1916)] = 40836,
  [SMALL_STATE(1917)] = 40885,
  [SMALL_STATE(1918)] = 40938,
  [SMALL_STATE(1919)] = 41039,
  [SMALL_STATE(1920)] = 41140,
  [SMALL_STATE(1921)] = 41241,
  [SMALL_STATE(1922)] = 41306,
  [SMALL_STATE(1923)] = 41357,
  [SMALL_STATE(1924)] = 41458,
  [SMALL_STATE(1925)] = 41509,
  [SMALL_STATE(1926)] = 41584,
  [SMALL_STATE(1927)] = 41673,
  [SMALL_STATE(1928)] = 41764,
  [SMALL_STATE(1929)] = 41819,
  [SMALL_STATE(1930)] = 41868,
  [SMALL_STATE(1931)] = 41919,
  [SMALL_STATE(1932)] = 42026,
  [SMALL_STATE(1933)] = 42081,
  [SMALL_STATE(1934)] = 42184,
  [SMALL_STATE(1935)] = 42237,
  [SMALL_STATE(1936)] = 42300,
  [SMALL_STATE(1937)] = 42363,
  [SMALL_STATE(1938)] = 42418,
  [SMALL_STATE(1939)] = 42479,
  [SMALL_STATE(1940)] = 42552,
  [SMALL_STATE(1941)] = 42623,
  [SMALL_STATE(1942)] = 42698,
  [SMALL_STATE(1943)] = 42759,
  [SMALL_STATE(1944)] = 42814,
  [SMALL_STATE(1945)] = 42875,
  [SMALL_STATE(1946)] = 42928,
  [SMALL_STATE(1947)] = 43011,
  [SMALL_STATE(1948)] = 43096,
  [SMALL_STATE(1949)] = 43183,
  [SMALL_STATE(1950)] = 43252,
  [SMALL_STATE(1951)] = 43323,
  [SMALL_STATE(1952)] = 43424,
  [SMALL_STATE(1953)] = 43503,
  [SMALL_STATE(1954)] = 43596,
  [SMALL_STATE(1955)] = 43697,
  [SMALL_STATE(1956)] = 43770,
  [SMALL_STATE(1957)] = 43827,
  [SMALL_STATE(1958)] = 43902,
  [SMALL_STATE(1959)] = 44003,
  [SMALL_STATE(1960)] = 44104,
  [SMALL_STATE(1961)] = 44205,
  [SMALL_STATE(1962)] = 44266,
  [SMALL_STATE(1963)] = 44341,
  [SMALL_STATE(1964)] = 44442,
  [SMALL_STATE(1965)] = 44515,
  [SMALL_STATE(1966)] = 44576,
  [SMALL_STATE(1967)] = 44683,
  [SMALL_STATE(1968)] = 44788,
  [SMALL_STATE(1969)] = 44841,
  [SMALL_STATE(1970)] = 44916,
  [SMALL_STATE(1971)] = 44989,
  [SMALL_STATE(1972)] = 45094,
  [SMALL_STATE(1973)] = 45155,
  [SMALL_STATE(1974)] = 45216,
  [SMALL_STATE(1975)] = 45321,
  [SMALL_STATE(1976)] = 45375,
  [SMALL_STATE(1977)] = 45427,
  [SMALL_STATE(1978)] = 45501,
  [SMALL_STATE(1979)] = 45571,
  [SMALL_STATE(1980)] = 45621,
  [SMALL_STATE(1981)] = 45689,
  [SMALL_STATE(1982)] = 45793,
  [SMALL_STATE(1983)] = 45861,
  [SMALL_STATE(1984)] = 45913,
  [SMALL_STATE(1985)] = 45991,
  [SMALL_STATE(1986)] = 46095,
  [SMALL_STATE(1987)] = 46199,
  [SMALL_STATE(1988)] = 46303,
  [SMALL_STATE(1989)] = 46371,
  [SMALL_STATE(1990)] = 46425,
  [SMALL_STATE(1991)] = 46509,
  [SMALL_STATE(1992)] = 46563,
  [SMALL_STATE(1993)] = 46617,
  [SMALL_STATE(1994)] = 46699,
  [SMALL_STATE(1995)] = 46769,
  [SMALL_STATE(1996)] = 46869,
  [SMALL_STATE(1997)] = 46925,
  [SMALL_STATE(1998)] = 46981,
  [SMALL_STATE(1999)] = 47071,
  [SMALL_STATE(2000)] = 47159,
  [SMALL_STATE(2001)] = 47209,
  [SMALL_STATE(2002)] = 47283,
  [SMALL_STATE(2003)] = 47347,
  [SMALL_STATE(2004)] = 47447,
  [SMALL_STATE(2005)] = 47499,
  [SMALL_STATE(2006)] = 47599,
  [SMALL_STATE(2007)] = 47699,
  [SMALL_STATE(2008)] = 47751,
  [SMALL_STATE(2009)] = 47851,
  [SMALL_STATE(2010)] = 47955,
  [SMALL_STATE(2011)] = 48011,
  [SMALL_STATE(2012)] = 48065,
  [SMALL_STATE(2013)] = 48165,
  [SMALL_STATE(2014)] = 48269,
  [SMALL_STATE(2015)] = 48325,
  [SMALL_STATE(2016)] = 48379,
  [SMALL_STATE(2017)] = 48483,
  [SMALL_STATE(2018)] = 48583,
  [SMALL_STATE(2019)] = 48683,
  [SMALL_STATE(2020)] = 48787,
  [SMALL_STATE(2021)] = 48837,
  [SMALL_STATE(2022)] = 48923,
  [SMALL_STATE(2023)] = 49023,
  [SMALL_STATE(2024)] = 49127,
  [SMALL_STATE(2025)] = 49227,
  [SMALL_STATE(2026)] = 49327,
  [SMALL_STATE(2027)] = 49427,
  [SMALL_STATE(2028)] = 49529,
  [SMALL_STATE(2029)] = 49585,
  [SMALL_STATE(2030)] = 49685,
  [SMALL_STATE(2031)] = 49785,
  [SMALL_STATE(2032)] = 49833,
  [SMALL_STATE(2033)] = 49881,
  [SMALL_STATE(2034)] = 49933,
  [SMALL_STATE(2035)] = 49985,
  [SMALL_STATE(2036)] = 50043,
  [SMALL_STATE(2037)] = 50101,
  [SMALL_STATE(2038)] = 50149,
  [SMALL_STATE(2039)] = 50197,
  [SMALL_STATE(2040)] = 50245,
  [SMALL_STATE(2041)] = 50293,
  [SMALL_STATE(2042)] = 50345,
  [SMALL_STATE(2043)] = 50449,
  [SMALL_STATE(2044)] = 50497,
  [SMALL_STATE(2045)] = 50545,
  [SMALL_STATE(2046)] = 50597,
  [SMALL_STATE(2047)] = 50699,
  [SMALL_STATE(2048)] = 50801,
  [SMALL_STATE(2049)] = 50873,
  [SMALL_STATE(2050)] = 50925,
  [SMALL_STATE(2051)] = 50973,
  [SMALL_STATE(2052)] = 51021,
  [SMALL_STATE(2053)] = 51069,
  [SMALL_STATE(2054)] = 51117,
  [SMALL_STATE(2055)] = 51221,
  [SMALL_STATE(2056)] = 51273,
  [SMALL_STATE(2057)] = 51321,
  [SMALL_STATE(2058)] = 51369,
  [SMALL_STATE(2059)] = 51417,
  [SMALL_STATE(2060)] = 51465,
  [SMALL_STATE(2061)] = 51513,
  [SMALL_STATE(2062)] = 51565,
  [SMALL_STATE(2063)] = 51613,
  [SMALL_STATE(2064)] = 51661,
  [SMALL_STATE(2065)] = 51709,
  [SMALL_STATE(2066)] = 51757,
  [SMALL_STATE(2067)] = 51805,
  [SMALL_STATE(2068)] = 51853,
  [SMALL_STATE(2069)] = 51901,
  [SMALL_STATE(2070)] = 51949,
  [SMALL_STATE(2071)] = 51997,
  [SMALL_STATE(2072)] = 52045,
  [SMALL_STATE(2073)] = 52093,
  [SMALL_STATE(2074)] = 52141,
  [SMALL_STATE(2075)] = 52189,
  [SMALL_STATE(2076)] = 52293,
  [SMALL_STATE(2077)] = 52341,
  [SMALL_STATE(2078)] = 52389,
  [SMALL_STATE(2079)] = 52441,
  [SMALL_STATE(2080)] = 52489,
  [SMALL_STATE(2081)] = 52537,
  [SMALL_STATE(2082)] = 52585,
  [SMALL_STATE(2083)] = 52633,
  [SMALL_STATE(2084)] = 52681,
  [SMALL_STATE(2085)] = 52729,
  [SMALL_STATE(2086)] = 52777,
  [SMALL_STATE(2087)] = 52825,
  [SMALL_STATE(2088)] = 52929,
  [SMALL_STATE(2089)] = 52977,
  [SMALL_STATE(2090)] = 53025,
  [SMALL_STATE(2091)] = 53073,
  [SMALL_STATE(2092)] = 53121,
  [SMALL_STATE(2093)] = 53169,
  [SMALL_STATE(2094)] = 53217,
  [SMALL_STATE(2095)] = 53265,
  [SMALL_STATE(2096)] = 53313,
  [SMALL_STATE(2097)] = 53361,
  [SMALL_STATE(2098)] = 53413,
  [SMALL_STATE(2099)] = 53465,
  [SMALL_STATE(2100)] = 53513,
  [SMALL_STATE(2101)] = 53561,
  [SMALL_STATE(2102)] = 53609,
  [SMALL_STATE(2103)] = 53657,
  [SMALL_STATE(2104)] = 53705,
  [SMALL_STATE(2105)] = 53773,
  [SMALL_STATE(2106)] = 53825,
  [SMALL_STATE(2107)] = 53877,
  [SMALL_STATE(2108)] = 53925,
  [SMALL_STATE(2109)] = 53973,
  [SMALL_STATE(2110)] = 54029,
  [SMALL_STATE(2111)] = 54077,
  [SMALL_STATE(2112)] = 54135,
  [SMALL_STATE(2113)] = 54183,
  [SMALL_STATE(2114)] = 54231,
  [SMALL_STATE(2115)] = 54279,
  [SMALL_STATE(2116)] = 54327,
  [SMALL_STATE(2117)] = 54375,
  [SMALL_STATE(2118)] = 54423,
  [SMALL_STATE(2119)] = 54471,
  [SMALL_STATE(2120)] = 54519,
  [SMALL_STATE(2121)] = 54567,
  [SMALL_STATE(2122)] = 54619,
  [SMALL_STATE(2123)] = 54667,
  [SMALL_STATE(2124)] = 54725,
  [SMALL_STATE(2125)] = 54777,
  [SMALL_STATE(2126)] = 54833,
  [SMALL_STATE(2127)] = 54881,
  [SMALL_STATE(2128)] = 54949,
  [SMALL_STATE(2129)] = 54997,
  [SMALL_STATE(2130)] = 55045,
  [SMALL_STATE(2131)] = 55093,
  [SMALL_STATE(2132)] = 55145,
  [SMALL_STATE(2133)] = 55197,
  [SMALL_STATE(2134)] = 55299,
  [SMALL_STATE(2135)] = 55351,
  [SMALL_STATE(2136)] = 55403,
  [SMALL_STATE(2137)] = 55455,
  [SMALL_STATE(2138)] = 55515,
  [SMALL_STATE(2139)] = 55563,
  [SMALL_STATE(2140)] = 55615,
  [SMALL_STATE(2141)] = 55663,
  [SMALL_STATE(2142)] = 55711,
  [SMALL_STATE(2143)] = 55763,
  [SMALL_STATE(2144)] = 55815,
  [SMALL_STATE(2145)] = 55915,
  [SMALL_STATE(2146)] = 55967,
  [SMALL_STATE(2147)] = 56015,
  [SMALL_STATE(2148)] = 56067,
  [SMALL_STATE(2149)] = 56117,
  [SMALL_STATE(2150)] = 56165,
  [SMALL_STATE(2151)] = 56257,
  [SMALL_STATE(2152)] = 56309,
  [SMALL_STATE(2153)] = 56409,
  [SMALL_STATE(2154)] = 56461,
  [SMALL_STATE(2155)] = 56513,
  [SMALL_STATE(2156)] = 56565,
  [SMALL_STATE(2157)] = 56617,
  [SMALL_STATE(2158)] = 56716,
  [SMALL_STATE(2159)] = 56815,
  [SMALL_STATE(2160)] = 56914,
  [SMALL_STATE(2161)] = 56965,
  [SMALL_STATE(2162)] = 57018,
  [SMALL_STATE(2163)] = 57119,
  [SMALL_STATE(2164)] = 57174,
  [SMALL_STATE(2165)] = 57227,
  [SMALL_STATE(2166)] = 57296,
  [SMALL_STATE(2167)] = 57375,
  [SMALL_STATE(2168)] = 57424,
  [SMALL_STATE(2169)] = 57503,
  [SMALL_STATE(2170)] = 57604,
  [SMALL_STATE(2171)] = 57705,
  [SMALL_STATE(2172)] = 57770,
  [SMALL_STATE(2173)] = 57821,
  [SMALL_STATE(2174)] = 57874,
  [SMALL_STATE(2175)] = 57925,
  [SMALL_STATE(2176)] = 57974,
  [SMALL_STATE(2177)] = 58043,
  [SMALL_STATE(2178)] = 58122,
  [SMALL_STATE(2179)] = 58191,
  [SMALL_STATE(2180)] = 58292,
  [SMALL_STATE(2181)] = 58357,
  [SMALL_STATE(2182)] = 58458,
  [SMALL_STATE(2183)] = 58559,
  [SMALL_STATE(2184)] = 58660,
  [SMALL_STATE(2185)] = 58761,
  [SMALL_STATE(2186)] = 58816,
  [SMALL_STATE(2187)] = 58871,
  [SMALL_STATE(2188)] = 58950,
  [SMALL_STATE(2189)] = 59029,
  [SMALL_STATE(2190)] = 59094,
  [SMALL_STATE(2191)] = 59195,
  [SMALL_STATE(2192)] = 59296,
  [SMALL_STATE(2193)] = 59397,
  [SMALL_STATE(2194)] = 59498,
  [SMALL_STATE(2195)] = 59551,
  [SMALL_STATE(2196)] = 59630,
  [SMALL_STATE(2197)] = 59731,
  [SMALL_STATE(2198)] = 59800,
  [SMALL_STATE(2199)] = 59901,
  [SMALL_STATE(2200)] = 59980,
  [SMALL_STATE(2201)] = 60081,
  [SMALL_STATE(2202)] = 60150,
  [SMALL_STATE(2203)] = 60229,
  [SMALL_STATE(2204)] = 60284,
  [SMALL_STATE(2205)] = 60385,
  [SMALL_STATE(2206)] = 60486,
  [SMALL_STATE(2207)] = 60553,
  [SMALL_STATE(2208)] = 60654,
  [SMALL_STATE(2209)] = 60723,
  [SMALL_STATE(2210)] = 60783,
  [SMALL_STATE(2211)] = 60865,
  [SMALL_STATE(2212)] = 60927,
  [SMALL_STATE(2213)] = 61025,
  [SMALL_STATE(2214)] = 61083,
  [SMALL_STATE(2215)] = 61133,
  [SMALL_STATE(2216)] = 61193,
  [SMALL_STATE(2217)] = 61255,
  [SMALL_STATE(2218)] = 61327,
  [SMALL_STATE(2219)] = 61397,
  [SMALL_STATE(2220)] = 61459,
  [SMALL_STATE(2221)] = 61519,
  [SMALL_STATE(2222)] = 61577,
  [SMALL_STATE(2223)] = 61675,
  [SMALL_STATE(2224)] = 61773,
  [SMALL_STATE(2225)] = 61843,
  [SMALL_STATE(2226)] = 61895,
  [SMALL_STATE(2227)] = 61993,
  [SMALL_STATE(2228)] = 62063,
  [SMALL_STATE(2229)] = 62111,
  [SMALL_STATE(2230)] = 62171,
  [SMALL_STATE(2231)] = 62219,
  [SMALL_STATE(2232)] = 62291,
  [SMALL_STATE(2233)] = 62389,
  [SMALL_STATE(2234)] = 62437,
  [SMALL_STATE(2235)] = 62535,
  [SMALL_STATE(2236)] = 62583,
  [SMALL_STATE(2237)] = 62681,
  [SMALL_STATE(2238)] = 62779,
  [SMALL_STATE(2239)] = 62839,
  [SMALL_STATE(2240)] = 62909,
  [SMALL_STATE(2241)] = 62971,
  [SMALL_STATE(2242)] = 63033,
  [SMALL_STATE(2243)] = 63105,
  [SMALL_STATE(2244)] = 63163,
  [SMALL_STATE(2245)] = 63221,
  [SMALL_STATE(2246)] = 63271,
  [SMALL_STATE(2247)] = 63343,
  [SMALL_STATE(2248)] = 63413,
  [SMALL_STATE(2249)] = 63499,
  [SMALL_STATE(2250)] = 63557,
  [SMALL_STATE(2251)] = 63615,
  [SMALL_STATE(2252)] = 63713,
  [SMALL_STATE(2253)] = 63801,
  [SMALL_STATE(2254)] = 63863,
  [SMALL_STATE(2255)] = 63931,
  [SMALL_STATE(2256)] = 63979,
  [SMALL_STATE(2257)] = 64041,
  [SMALL_STATE(2258)] = 64101,
  [SMALL_STATE(2259)] = 64181,
  [SMALL_STATE(2260)] = 64229,
  [SMALL_STATE(2261)] = 64277,
  [SMALL_STATE(2262)] = 64327,
  [SMALL_STATE(2263)] = 64427,
  [SMALL_STATE(2264)] = 64491,
  [SMALL_STATE(2265)] = 64551,
  [SMALL_STATE(2266)] = 64635,
  [SMALL_STATE(2267)] = 64733,
  [SMALL_STATE(2268)] = 64783,
  [SMALL_STATE(2269)] = 64849,
  [SMALL_STATE(2270)] = 64947,
  [SMALL_STATE(2271)] = 64999,
  [SMALL_STATE(2272)] = 65059,
  [SMALL_STATE(2273)] = 65157,
  [SMALL_STATE(2274)] = 65255,
  [SMALL_STATE(2275)] = 65353,
  [SMALL_STATE(2276)] = 65401,
  [SMALL_STATE(2277)] = 65473,
  [SMALL_STATE(2278)] = 65521,
  [SMALL_STATE(2279)] = 65573,
  [SMALL_STATE(2280)] = 65645,
  [SMALL_STATE(2281)] = 65713,
  [SMALL_STATE(2282)] = 65811,
  [SMALL_STATE(2283)] = 65909,
  [SMALL_STATE(2284)] = 65957,
  [SMALL_STATE(2285)] = 66033,
  [SMALL_STATE(2286)] = 66081,
  [SMALL_STATE(2287)] = 66171,
  [SMALL_STATE(2288)] = 66219,
  [SMALL_STATE(2289)] = 66271,
  [SMALL_STATE(2290)] = 66333,
  [SMALL_STATE(2291)] = 66393,
  [SMALL_STATE(2292)] = 66491,
  [SMALL_STATE(2293)] = 66539,
  [SMALL_STATE(2294)] = 66587,
  [SMALL_STATE(2295)] = 66657,
  [SMALL_STATE(2296)] = 66717,
  [SMALL_STATE(2297)] = 66775,
  [SMALL_STATE(2298)] = 66835,
  [SMALL_STATE(2299)] = 66893,
  [SMALL_STATE(2300)] = 66955,
  [SMALL_STATE(2301)] = 67053,
  [SMALL_STATE(2302)] = 67113,
  [SMALL_STATE(2303)] = 67185,
  [SMALL_STATE(2304)] = 67233,
  [SMALL_STATE(2305)] = 67293,
  [SMALL_STATE(2306)] = 67391,
  [SMALL_STATE(2307)] = 67441,
  [SMALL_STATE(2308)] = 67511,
  [SMALL_STATE(2309)] = 67609,
  [SMALL_STATE(2310)] = 67681,
  [SMALL_STATE(2311)] = 67751,
  [SMALL_STATE(2312)] = 67811,
  [SMALL_STATE(2313)] = 67883,
  [SMALL_STATE(2314)] = 67931,
  [SMALL_STATE(2315)] = 68029,
  [SMALL_STATE(2316)] = 68089,
  [SMALL_STATE(2317)] = 68151,
  [SMALL_STATE(2318)] = 68213,
  [SMALL_STATE(2319)] = 68261,
  [SMALL_STATE(2320)] = 68326,
  [SMALL_STATE(2321)] = 68381,
  [SMALL_STATE(2322)] = 68436,
  [SMALL_STATE(2323)] = 68491,
  [SMALL_STATE(2324)] = 68546,
  [SMALL_STATE(2325)] = 68611,
  [SMALL_STATE(2326)] = 68666,
  [SMALL_STATE(2327)] = 68721,
  [SMALL_STATE(2328)] = 68776,
  [SMALL_STATE(2329)] = 68841,
  [SMALL_STATE(2330)] = 68896,
  [SMALL_STATE(2331)] = 68951,
  [SMALL_STATE(2332)] = 69016,
  [SMALL_STATE(2333)] = 69067,
  [SMALL_STATE(2334)] = 69114,
  [SMALL_STATE(2335)] = 69191,
  [SMALL_STATE(2336)] = 69246,
  [SMALL_STATE(2337)] = 69301,
  [SMALL_STATE(2338)] = 69356,
  [SMALL_STATE(2339)] = 69421,
  [SMALL_STATE(2340)] = 69476,
  [SMALL_STATE(2341)] = 69531,
  [SMALL_STATE(2342)] = 69582,
  [SMALL_STATE(2343)] = 69677,
  [SMALL_STATE(2344)] = 69742,
  [SMALL_STATE(2345)] = 69789,
  [SMALL_STATE(2346)] = 69844,
  [SMALL_STATE(2347)] = 69895,
  [SMALL_STATE(2348)] = 69950,
  [SMALL_STATE(2349)] = 70015,
  [SMALL_STATE(2350)] = 70086,
  [SMALL_STATE(2351)] = 70133,
  [SMALL_STATE(2352)] = 70188,
  [SMALL_STATE(2353)] = 70283,
  [SMALL_STATE(2354)] = 70338,
  [SMALL_STATE(2355)] = 70433,
  [SMALL_STATE(2356)] = 70484,
  [SMALL_STATE(2357)] = 70549,
  [SMALL_STATE(2358)] = 70609,
  [SMALL_STATE(2359)] = 70671,
  [SMALL_STATE(2360)] = 70735,
  [SMALL_STATE(2361)] = 70785,
  [SMALL_STATE(2362)] = 70841,
  [SMALL_STATE(2363)] = 70891,
  [SMALL_STATE(2364)] = 70959,
  [SMALL_STATE(2365)] = 71019,
  [SMALL_STATE(2366)] = 71075,
  [SMALL_STATE(2367)] = 71130,
  [SMALL_STATE(2368)] = 71185,
  [SMALL_STATE(2369)] = 71240,
  [SMALL_STATE(2370)] = 71295,
  [SMALL_STATE(2371)] = 71356,
  [SMALL_STATE(2372)] = 71413,
  [SMALL_STATE(2373)] = 71468,
  [SMALL_STATE(2374)] = 71523,
  [SMALL_STATE(2375)] = 71578,
  [SMALL_STATE(2376)] = 71633,
  [SMALL_STATE(2377)] = 71716,
  [SMALL_STATE(2378)] = 71775,
  [SMALL_STATE(2379)] = 71830,
  [SMALL_STATE(2380)] = 71885,
  [SMALL_STATE(2381)] = 71940,
  [SMALL_STATE(2382)] = 71993,
  [SMALL_STATE(2383)] = 72048,
  [SMALL_STATE(2384)] = 72131,
  [SMALL_STATE(2385)] = 72186,
  [SMALL_STATE(2386)] = 72241,
  [SMALL_STATE(2387)] = 72296,
  [SMALL_STATE(2388)] = 72349,
  [SMALL_STATE(2389)] = 72404,
  [SMALL_STATE(2390)] = 72458,
  [SMALL_STATE(2391)] = 72500,
  [SMALL_STATE(2392)] = 72542,
  [SMALL_STATE(2393)] = 72605,
  [SMALL_STATE(2394)] = 72652,
  [SMALL_STATE(2395)] = 72699,
  [SMALL_STATE(2396)] = 72746,
  [SMALL_STATE(2397)] = 72786,
  [SMALL_STATE(2398)] = 72826,
  [SMALL_STATE(2399)] = 72880,
  [SMALL_STATE(2400)] = 72936,
  [SMALL_STATE(2401)] = 72976,
  [SMALL_STATE(2402)] = 73030,
  [SMALL_STATE(2403)] = 73070,
  [SMALL_STATE(2404)] = 73110,
  [SMALL_STATE(2405)] = 73164,
  [SMALL_STATE(2406)] = 73218,
  [SMALL_STATE(2407)] = 73274,
  [SMALL_STATE(2408)] = 73314,
  [SMALL_STATE(2409)] = 73354,
  [SMALL_STATE(2410)] = 73394,
  [SMALL_STATE(2411)] = 73434,
  [SMALL_STATE(2412)] = 73474,
  [SMALL_STATE(2413)] = 73514,
  [SMALL_STATE(2414)] = 73554,
  [SMALL_STATE(2415)] = 73594,
  [SMALL_STATE(2416)] = 73636,
  [SMALL_STATE(2417)] = 73676,
  [SMALL_STATE(2418)] = 73716,
  [SMALL_STATE(2419)] = 73758,
  [SMALL_STATE(2420)] = 73800,
  [SMALL_STATE(2421)] = 73840,
  [SMALL_STATE(2422)] = 73880,
  [SMALL_STATE(2423)] = 73920,
  [SMALL_STATE(2424)] = 73960,
  [SMALL_STATE(2425)] = 74000,
  [SMALL_STATE(2426)] = 74040,
  [SMALL_STATE(2427)] = 74092,
  [SMALL_STATE(2428)] = 74148,
  [SMALL_STATE(2429)] = 74188,
  [SMALL_STATE(2430)] = 74228,
  [SMALL_STATE(2431)] = 74272,
  [SMALL_STATE(2432)] = 74316,
  [SMALL_STATE(2433)] = 74365,
  [SMALL_STATE(2434)] = 74414,
  [SMALL_STATE(2435)] = 74455,
  [SMALL_STATE(2436)] = 74504,
  [SMALL_STATE(2437)] = 74553,
  [SMALL_STATE(2438)] = 74602,
  [SMALL_STATE(2439)] = 74651,
  [SMALL_STATE(2440)] = 74700,
  [SMALL_STATE(2441)] = 74749,
  [SMALL_STATE(2442)] = 74798,
  [SMALL_STATE(2443)] = 74861,
  [SMALL_STATE(2444)] = 74910,
  [SMALL_STATE(2445)] = 74959,
  [SMALL_STATE(2446)] = 75008,
  [SMALL_STATE(2447)] = 75057,
  [SMALL_STATE(2448)] = 75106,
  [SMALL_STATE(2449)] = 75155,
  [SMALL_STATE(2450)] = 75204,
  [SMALL_STATE(2451)] = 75253,
  [SMALL_STATE(2452)] = 75302,
  [SMALL_STATE(2453)] = 75351,
  [SMALL_STATE(2454)] = 75392,
  [SMALL_STATE(2455)] = 75441,
  [SMALL_STATE(2456)] = 75479,
  [SMALL_STATE(2457)] = 75529,
  [SMALL_STATE(2458)] = 75585,
  [SMALL_STATE(2459)] = 75623,
  [SMALL_STATE(2460)] = 75673,
  [SMALL_STATE(2461)] = 75733,
  [SMALL_STATE(2462)] = 75783,
  [SMALL_STATE(2463)] = 75821,
  [SMALL_STATE(2464)] = 75871,
  [SMALL_STATE(2465)] = 75909,
  [SMALL_STATE(2466)] = 75947,
  [SMALL_STATE(2467)] = 75985,
  [SMALL_STATE(2468)] = 76023,
  [SMALL_STATE(2469)] = 76061,
  [SMALL_STATE(2470)] = 76121,
  [SMALL_STATE(2471)] = 76159,
  [SMALL_STATE(2472)] = 76209,
  [SMALL_STATE(2473)] = 76269,
  [SMALL_STATE(2474)] = 76322,
  [SMALL_STATE(2475)] = 76375,
  [SMALL_STATE(2476)] = 76428,
  [SMALL_STATE(2477)] = 76481,
  [SMALL_STATE(2478)] = 76534,
  [SMALL_STATE(2479)] = 76587,
  [SMALL_STATE(2480)] = 76640,
  [SMALL_STATE(2481)] = 76679,
  [SMALL_STATE(2482)] = 76732,
  [SMALL_STATE(2483)] = 76785,
  [SMALL_STATE(2484)] = 76836,
  [SMALL_STATE(2485)] = 76889,
  [SMALL_STATE(2486)] = 76940,
  [SMALL_STATE(2487)] = 76993,
  [SMALL_STATE(2488)] = 77046,
  [SMALL_STATE(2489)] = 77093,
  [SMALL_STATE(2490)] = 77137,
  [SMALL_STATE(2491)] = 77181,
  [SMALL_STATE(2492)] = 77225,
  [SMALL_STATE(2493)] = 77269,
  [SMALL_STATE(2494)] = 77313,
  [SMALL_STATE(2495)] = 77357,
  [SMALL_STATE(2496)] = 77401,
  [SMALL_STATE(2497)] = 77447,
  [SMALL_STATE(2498)] = 77491,
  [SMALL_STATE(2499)] = 77535,
  [SMALL_STATE(2500)] = 77579,
  [SMALL_STATE(2501)] = 77623,
  [SMALL_STATE(2502)] = 77667,
  [SMALL_STATE(2503)] = 77711,
  [SMALL_STATE(2504)] = 77755,
  [SMALL_STATE(2505)] = 77799,
  [SMALL_STATE(2506)] = 77843,
  [SMALL_STATE(2507)] = 77887,
  [SMALL_STATE(2508)] = 77931,
  [SMALL_STATE(2509)] = 77975,
  [SMALL_STATE(2510)] = 78019,
  [SMALL_STATE(2511)] = 78065,
  [SMALL_STATE(2512)] = 78109,
  [SMALL_STATE(2513)] = 78153,
  [SMALL_STATE(2514)] = 78197,
  [SMALL_STATE(2515)] = 78241,
  [SMALL_STATE(2516)] = 78285,
  [SMALL_STATE(2517)] = 78329,
  [SMALL_STATE(2518)] = 78375,
  [SMALL_STATE(2519)] = 78419,
  [SMALL_STATE(2520)] = 78463,
  [SMALL_STATE(2521)] = 78507,
  [SMALL_STATE(2522)] = 78551,
  [SMALL_STATE(2523)] = 78595,
  [SMALL_STATE(2524)] = 78627,
  [SMALL_STATE(2525)] = 78659,
  [SMALL_STATE(2526)] = 78691,
  [SMALL_STATE(2527)] = 78723,
  [SMALL_STATE(2528)] = 78755,
  [SMALL_STATE(2529)] = 78786,
  [SMALL_STATE(2530)] = 78816,
  [SMALL_STATE(2531)] = 78851,
  [SMALL_STATE(2532)] = 78886,
  [SMALL_STATE(2533)] = 78921,
  [SMALL_STATE(2534)] = 78947,
  [SMALL_STATE(2535)] = 78973,
  [SMALL_STATE(2536)] = 78999,
  [SMALL_STATE(2537)] = 79025,
  [SMALL_STATE(2538)] = 79051,
  [SMALL_STATE(2539)] = 79077,
  [SMALL_STATE(2540)] = 79103,
  [SMALL_STATE(2541)] = 79129,
  [SMALL_STATE(2542)] = 79155,
  [SMALL_STATE(2543)] = 79181,
  [SMALL_STATE(2544)] = 79207,
  [SMALL_STATE(2545)] = 79233,
  [SMALL_STATE(2546)] = 79259,
  [SMALL_STATE(2547)] = 79285,
  [SMALL_STATE(2548)] = 79311,
  [SMALL_STATE(2549)] = 79337,
  [SMALL_STATE(2550)] = 79363,
  [SMALL_STATE(2551)] = 79389,
  [SMALL_STATE(2552)] = 79415,
  [SMALL_STATE(2553)] = 79441,
  [SMALL_STATE(2554)] = 79467,
  [SMALL_STATE(2555)] = 79493,
  [SMALL_STATE(2556)] = 79519,
  [SMALL_STATE(2557)] = 79545,
  [SMALL_STATE(2558)] = 79571,
  [SMALL_STATE(2559)] = 79597,
  [SMALL_STATE(2560)] = 79623,
  [SMALL_STATE(2561)] = 79649,
  [SMALL_STATE(2562)] = 79675,
  [SMALL_STATE(2563)] = 79729,
  [SMALL_STATE(2564)] = 79755,
  [SMALL_STATE(2565)] = 79781,
  [SMALL_STATE(2566)] = 79807,
  [SMALL_STATE(2567)] = 79833,
  [SMALL_STATE(2568)] = 79859,
  [SMALL_STATE(2569)] = 79913,
  [SMALL_STATE(2570)] = 79938,
  [SMALL_STATE(2571)] = 79963,
  [SMALL_STATE(2572)] = 79988,
  [SMALL_STATE(2573)] = 80017,
  [SMALL_STATE(2574)] = 80048,
  [SMALL_STATE(2575)] = 80073,
  [SMALL_STATE(2576)] = 80098,
  [SMALL_STATE(2577)] = 80123,
  [SMALL_STATE(2578)] = 80148,
  [SMALL_STATE(2579)] = 80173,
  [SMALL_STATE(2580)] = 80198,
  [SMALL_STATE(2581)] = 80228,
  [SMALL_STATE(2582)] = 80252,
  [SMALL_STATE(2583)] = 80280,
  [SMALL_STATE(2584)] = 80304,
  [SMALL_STATE(2585)] = 80328,
  [SMALL_STATE(2586)] = 80352,
  [SMALL_STATE(2587)] = 80376,
  [SMALL_STATE(2588)] = 80404,
  [SMALL_STATE(2589)] = 80428,
  [SMALL_STATE(2590)] = 80451,
  [SMALL_STATE(2591)] = 80482,
  [SMALL_STATE(2592)] = 80503,
  [SMALL_STATE(2593)] = 80526,
  [SMALL_STATE(2594)] = 80547,
  [SMALL_STATE(2595)] = 80578,
  [SMALL_STATE(2596)] = 80601,
  [SMALL_STATE(2597)] = 80624,
  [SMALL_STATE(2598)] = 80645,
  [SMALL_STATE(2599)] = 80668,
  [SMALL_STATE(2600)] = 80691,
  [SMALL_STATE(2601)] = 80716,
  [SMALL_STATE(2602)] = 80739,
  [SMALL_STATE(2603)] = 80762,
  [SMALL_STATE(2604)] = 80785,
  [SMALL_STATE(2605)] = 80814,
  [SMALL_STATE(2606)] = 80837,
  [SMALL_STATE(2607)] = 80860,
  [SMALL_STATE(2608)] = 80883,
  [SMALL_STATE(2609)] = 80906,
  [SMALL_STATE(2610)] = 80929,
  [SMALL_STATE(2611)] = 80952,
  [SMALL_STATE(2612)] = 80973,
  [SMALL_STATE(2613)] = 81000,
  [SMALL_STATE(2614)] = 81021,
  [SMALL_STATE(2615)] = 81044,
  [SMALL_STATE(2616)] = 81067,
  [SMALL_STATE(2617)] = 81088,
  [SMALL_STATE(2618)] = 81111,
  [SMALL_STATE(2619)] = 81134,
  [SMALL_STATE(2620)] = 81157,
  [SMALL_STATE(2621)] = 81182,
  [SMALL_STATE(2622)] = 81205,
  [SMALL_STATE(2623)] = 81226,
  [SMALL_STATE(2624)] = 81257,
  [SMALL_STATE(2625)] = 81280,
  [SMALL_STATE(2626)] = 81302,
  [SMALL_STATE(2627)] = 81324,
  [SMALL_STATE(2628)] = 81352,
  [SMALL_STATE(2629)] = 81380,
  [SMALL_STATE(2630)] = 81410,
  [SMALL_STATE(2631)] = 81440,
  [SMALL_STATE(2632)] = 81482,
  [SMALL_STATE(2633)] = 81524,
  [SMALL_STATE(2634)] = 81554,
  [SMALL_STATE(2635)] = 81584,
  [SMALL_STATE(2636)] = 81626,
  [SMALL_STATE(2637)] = 81656,
  [SMALL_STATE(2638)] = 81690,
  [SMALL_STATE(2639)] = 81732,
  [SMALL_STATE(2640)] = 81762,
  [SMALL_STATE(2641)] = 81784,
  [SMALL_STATE(2642)] = 81806,
  [SMALL_STATE(2643)] = 81828,
  [SMALL_STATE(2644)] = 81850,
  [SMALL_STATE(2645)] = 81872,
  [SMALL_STATE(2646)] = 81894,
  [SMALL_STATE(2647)] = 81916,
  [SMALL_STATE(2648)] = 81938,
  [SMALL_STATE(2649)] = 81960,
  [SMALL_STATE(2650)] = 81982,
  [SMALL_STATE(2651)] = 82004,
  [SMALL_STATE(2652)] = 82026,
  [SMALL_STATE(2653)] = 82048,
  [SMALL_STATE(2654)] = 82070,
  [SMALL_STATE(2655)] = 82100,
  [SMALL_STATE(2656)] = 82142,
  [SMALL_STATE(2657)] = 82170,
  [SMALL_STATE(2658)] = 82200,
  [SMALL_STATE(2659)] = 82230,
  [SMALL_STATE(2660)] = 82272,
  [SMALL_STATE(2661)] = 82300,
  [SMALL_STATE(2662)] = 82328,
  [SMALL_STATE(2663)] = 82358,
  [SMALL_STATE(2664)] = 82388,
  [SMALL_STATE(2665)] = 82418,
  [SMALL_STATE(2666)] = 82446,
  [SMALL_STATE(2667)] = 82476,
  [SMALL_STATE(2668)] = 82506,
  [SMALL_STATE(2669)] = 82536,
  [SMALL_STATE(2670)] = 82578,
  [SMALL_STATE(2671)] = 82608,
  [SMALL_STATE(2672)] = 82630,
  [SMALL_STATE(2673)] = 82652,
  [SMALL_STATE(2674)] = 82674,
  [SMALL_STATE(2675)] = 82696,
  [SMALL_STATE(2676)] = 82718,
  [SMALL_STATE(2677)] = 82740,
  [SMALL_STATE(2678)] = 82762,
  [SMALL_STATE(2679)] = 82784,
  [SMALL_STATE(2680)] = 82806,
  [SMALL_STATE(2681)] = 82836,
  [SMALL_STATE(2682)] = 82862,
  [SMALL_STATE(2683)] = 82884,
  [SMALL_STATE(2684)] = 82914,
  [SMALL_STATE(2685)] = 82944,
  [SMALL_STATE(2686)] = 82974,
  [SMALL_STATE(2687)] = 83002,
  [SMALL_STATE(2688)] = 83024,
  [SMALL_STATE(2689)] = 83046,
  [SMALL_STATE(2690)] = 83068,
  [SMALL_STATE(2691)] = 83090,
  [SMALL_STATE(2692)] = 83112,
  [SMALL_STATE(2693)] = 83134,
  [SMALL_STATE(2694)] = 83156,
  [SMALL_STATE(2695)] = 83178,
  [SMALL_STATE(2696)] = 83213,
  [SMALL_STATE(2697)] = 83248,
  [SMALL_STATE(2698)] = 83269,
  [SMALL_STATE(2699)] = 83294,
  [SMALL_STATE(2700)] = 83319,
  [SMALL_STATE(2701)] = 83340,
  [SMALL_STATE(2702)] = 83367,
  [SMALL_STATE(2703)] = 83388,
  [SMALL_STATE(2704)] = 83413,
  [SMALL_STATE(2705)] = 83448,
  [SMALL_STATE(2706)] = 83475,
  [SMALL_STATE(2707)] = 83502,
  [SMALL_STATE(2708)] = 83527,
  [SMALL_STATE(2709)] = 83554,
  [SMALL_STATE(2710)] = 83581,
  [SMALL_STATE(2711)] = 83608,
  [SMALL_STATE(2712)] = 83629,
  [SMALL_STATE(2713)] = 83664,
  [SMALL_STATE(2714)] = 83695,
  [SMALL_STATE(2715)] = 83732,
  [SMALL_STATE(2716)] = 83763,
  [SMALL_STATE(2717)] = 83794,
  [SMALL_STATE(2718)] = 83819,
  [SMALL_STATE(2719)] = 83854,
  [SMALL_STATE(2720)] = 83881,
  [SMALL_STATE(2721)] = 83908,
  [SMALL_STATE(2722)] = 83933,
  [SMALL_STATE(2723)] = 83954,
  [SMALL_STATE(2724)] = 83989,
  [SMALL_STATE(2725)] = 84010,
  [SMALL_STATE(2726)] = 84045,
  [SMALL_STATE(2727)] = 84070,
  [SMALL_STATE(2728)] = 84105,
  [SMALL_STATE(2729)] = 84132,
  [SMALL_STATE(2730)] = 84167,
  [SMALL_STATE(2731)] = 84198,
  [SMALL_STATE(2732)] = 84233,
  [SMALL_STATE(2733)] = 84268,
  [SMALL_STATE(2734)] = 84293,
  [SMALL_STATE(2735)] = 84328,
  [SMALL_STATE(2736)] = 84363,
  [SMALL_STATE(2737)] = 84398,
  [SMALL_STATE(2738)] = 84426,
  [SMALL_STATE(2739)] = 84444,
  [SMALL_STATE(2740)] = 84476,
  [SMALL_STATE(2741)] = 84494,
  [SMALL_STATE(2742)] = 84514,
  [SMALL_STATE(2743)] = 84532,
  [SMALL_STATE(2744)] = 84550,
  [SMALL_STATE(2745)] = 84582,
  [SMALL_STATE(2746)] = 84614,
  [SMALL_STATE(2747)] = 84632,
  [SMALL_STATE(2748)] = 84650,
  [SMALL_STATE(2749)] = 84668,
  [SMALL_STATE(2750)] = 84686,
  [SMALL_STATE(2751)] = 84704,
  [SMALL_STATE(2752)] = 84724,
  [SMALL_STATE(2753)] = 84756,
  [SMALL_STATE(2754)] = 84774,
  [SMALL_STATE(2755)] = 84810,
  [SMALL_STATE(2756)] = 84846,
  [SMALL_STATE(2757)] = 84864,
  [SMALL_STATE(2758)] = 84882,
  [SMALL_STATE(2759)] = 84900,
  [SMALL_STATE(2760)] = 84918,
  [SMALL_STATE(2761)] = 84936,
  [SMALL_STATE(2762)] = 84956,
  [SMALL_STATE(2763)] = 84992,
  [SMALL_STATE(2764)] = 85028,
  [SMALL_STATE(2765)] = 85046,
  [SMALL_STATE(2766)] = 85064,
  [SMALL_STATE(2767)] = 85096,
  [SMALL_STATE(2768)] = 85128,
  [SMALL_STATE(2769)] = 85160,
  [SMALL_STATE(2770)] = 85180,
  [SMALL_STATE(2771)] = 85198,
  [SMALL_STATE(2772)] = 85216,
  [SMALL_STATE(2773)] = 85234,
  [SMALL_STATE(2774)] = 85252,
  [SMALL_STATE(2775)] = 85270,
  [SMALL_STATE(2776)] = 85288,
  [SMALL_STATE(2777)] = 85306,
  [SMALL_STATE(2778)] = 85338,
  [SMALL_STATE(2779)] = 85368,
  [SMALL_STATE(2780)] = 85386,
  [SMALL_STATE(2781)] = 85422,
  [SMALL_STATE(2782)] = 85446,
  [SMALL_STATE(2783)] = 85464,
  [SMALL_STATE(2784)] = 85496,
  [SMALL_STATE(2785)] = 85528,
  [SMALL_STATE(2786)] = 85546,
  [SMALL_STATE(2787)] = 85574,
  [SMALL_STATE(2788)] = 85596,
  [SMALL_STATE(2789)] = 85624,
  [SMALL_STATE(2790)] = 85660,
  [SMALL_STATE(2791)] = 85688,
  [SMALL_STATE(2792)] = 85724,
  [SMALL_STATE(2793)] = 85742,
  [SMALL_STATE(2794)] = 85760,
  [SMALL_STATE(2795)] = 85778,
  [SMALL_STATE(2796)] = 85810,
  [SMALL_STATE(2797)] = 85828,
  [SMALL_STATE(2798)] = 85846,
  [SMALL_STATE(2799)] = 85864,
  [SMALL_STATE(2800)] = 85882,
  [SMALL_STATE(2801)] = 85901,
  [SMALL_STATE(2802)] = 85918,
  [SMALL_STATE(2803)] = 85941,
  [SMALL_STATE(2804)] = 85962,
  [SMALL_STATE(2805)] = 85985,
  [SMALL_STATE(2806)] = 86004,
  [SMALL_STATE(2807)] = 86021,
  [SMALL_STATE(2808)] = 86042,
  [SMALL_STATE(2809)] = 86061,
  [SMALL_STATE(2810)] = 86084,
  [SMALL_STATE(2811)] = 86105,
  [SMALL_STATE(2812)] = 86124,
  [SMALL_STATE(2813)] = 86143,
  [SMALL_STATE(2814)] = 86160,
  [SMALL_STATE(2815)] = 86179,
  [SMALL_STATE(2816)] = 86200,
  [SMALL_STATE(2817)] = 86219,
  [SMALL_STATE(2818)] = 86240,
  [SMALL_STATE(2819)] = 86261,
  [SMALL_STATE(2820)] = 86280,
  [SMALL_STATE(2821)] = 86299,
  [SMALL_STATE(2822)] = 86316,
  [SMALL_STATE(2823)] = 86337,
  [SMALL_STATE(2824)] = 86358,
  [SMALL_STATE(2825)] = 86375,
  [SMALL_STATE(2826)] = 86392,
  [SMALL_STATE(2827)] = 86411,
  [SMALL_STATE(2828)] = 86430,
  [SMALL_STATE(2829)] = 86449,
  [SMALL_STATE(2830)] = 86468,
  [SMALL_STATE(2831)] = 86487,
  [SMALL_STATE(2832)] = 86506,
  [SMALL_STATE(2833)] = 86525,
  [SMALL_STATE(2834)] = 86544,
  [SMALL_STATE(2835)] = 86567,
  [SMALL_STATE(2836)] = 86586,
  [SMALL_STATE(2837)] = 86623,
  [SMALL_STATE(2838)] = 86646,
  [SMALL_STATE(2839)] = 86669,
  [SMALL_STATE(2840)] = 86688,
  [SMALL_STATE(2841)] = 86705,
  [SMALL_STATE(2842)] = 86724,
  [SMALL_STATE(2843)] = 86743,
  [SMALL_STATE(2844)] = 86762,
  [SMALL_STATE(2845)] = 86781,
  [SMALL_STATE(2846)] = 86800,
  [SMALL_STATE(2847)] = 86819,
  [SMALL_STATE(2848)] = 86840,
  [SMALL_STATE(2849)] = 86859,
  [SMALL_STATE(2850)] = 86878,
  [SMALL_STATE(2851)] = 86897,
  [SMALL_STATE(2852)] = 86916,
  [SMALL_STATE(2853)] = 86935,
  [SMALL_STATE(2854)] = 86954,
  [SMALL_STATE(2855)] = 86973,
  [SMALL_STATE(2856)] = 86990,
  [SMALL_STATE(2857)] = 87009,
  [SMALL_STATE(2858)] = 87028,
  [SMALL_STATE(2859)] = 87051,
  [SMALL_STATE(2860)] = 87070,
  [SMALL_STATE(2861)] = 87089,
  [SMALL_STATE(2862)] = 87108,
  [SMALL_STATE(2863)] = 87127,
  [SMALL_STATE(2864)] = 87146,
  [SMALL_STATE(2865)] = 87183,
  [SMALL_STATE(2866)] = 87217,
  [SMALL_STATE(2867)] = 87245,
  [SMALL_STATE(2868)] = 87265,
  [SMALL_STATE(2869)] = 87299,
  [SMALL_STATE(2870)] = 87321,
  [SMALL_STATE(2871)] = 87341,
  [SMALL_STATE(2872)] = 87375,
  [SMALL_STATE(2873)] = 87397,
  [SMALL_STATE(2874)] = 87425,
  [SMALL_STATE(2875)] = 87445,
  [SMALL_STATE(2876)] = 87467,
  [SMALL_STATE(2877)] = 87495,
  [SMALL_STATE(2878)] = 87517,
  [SMALL_STATE(2879)] = 87535,
  [SMALL_STATE(2880)] = 87569,
  [SMALL_STATE(2881)] = 87589,
  [SMALL_STATE(2882)] = 87613,
  [SMALL_STATE(2883)] = 87633,
  [SMALL_STATE(2884)] = 87651,
  [SMALL_STATE(2885)] = 87669,
  [SMALL_STATE(2886)] = 87685,
  [SMALL_STATE(2887)] = 87719,
  [SMALL_STATE(2888)] = 87739,
  [SMALL_STATE(2889)] = 87761,
  [SMALL_STATE(2890)] = 87781,
  [SMALL_STATE(2891)] = 87815,
  [SMALL_STATE(2892)] = 87835,
  [SMALL_STATE(2893)] = 87853,
  [SMALL_STATE(2894)] = 87887,
  [SMALL_STATE(2895)] = 87909,
  [SMALL_STATE(2896)] = 87943,
  [SMALL_STATE(2897)] = 87965,
  [SMALL_STATE(2898)] = 87985,
  [SMALL_STATE(2899)] = 88019,
  [SMALL_STATE(2900)] = 88041,
  [SMALL_STATE(2901)] = 88061,
  [SMALL_STATE(2902)] = 88083,
  [SMALL_STATE(2903)] = 88105,
  [SMALL_STATE(2904)] = 88127,
  [SMALL_STATE(2905)] = 88161,
  [SMALL_STATE(2906)] = 88183,
  [SMALL_STATE(2907)] = 88205,
  [SMALL_STATE(2908)] = 88227,
  [SMALL_STATE(2909)] = 88247,
  [SMALL_STATE(2910)] = 88269,
  [SMALL_STATE(2911)] = 88303,
  [SMALL_STATE(2912)] = 88323,
  [SMALL_STATE(2913)] = 88343,
  [SMALL_STATE(2914)] = 88363,
  [SMALL_STATE(2915)] = 88385,
  [SMALL_STATE(2916)] = 88403,
  [SMALL_STATE(2917)] = 88423,
  [SMALL_STATE(2918)] = 88438,
  [SMALL_STATE(2919)] = 88455,
  [SMALL_STATE(2920)] = 88470,
  [SMALL_STATE(2921)] = 88501,
  [SMALL_STATE(2922)] = 88532,
  [SMALL_STATE(2923)] = 88563,
  [SMALL_STATE(2924)] = 88578,
  [SMALL_STATE(2925)] = 88593,
  [SMALL_STATE(2926)] = 88624,
  [SMALL_STATE(2927)] = 88649,
  [SMALL_STATE(2928)] = 88664,
  [SMALL_STATE(2929)] = 88689,
  [SMALL_STATE(2930)] = 88714,
  [SMALL_STATE(2931)] = 88735,
  [SMALL_STATE(2932)] = 88750,
  [SMALL_STATE(2933)] = 88765,
  [SMALL_STATE(2934)] = 88782,
  [SMALL_STATE(2935)] = 88797,
  [SMALL_STATE(2936)] = 88812,
  [SMALL_STATE(2937)] = 88833,
  [SMALL_STATE(2938)] = 88848,
  [SMALL_STATE(2939)] = 88863,
  [SMALL_STATE(2940)] = 88878,
  [SMALL_STATE(2941)] = 88909,
  [SMALL_STATE(2942)] = 88924,
  [SMALL_STATE(2943)] = 88939,
  [SMALL_STATE(2944)] = 88970,
  [SMALL_STATE(2945)] = 88985,
  [SMALL_STATE(2946)] = 89016,
  [SMALL_STATE(2947)] = 89041,
  [SMALL_STATE(2948)] = 89066,
  [SMALL_STATE(2949)] = 89097,
  [SMALL_STATE(2950)] = 89114,
  [SMALL_STATE(2951)] = 89129,
  [SMALL_STATE(2952)] = 89146,
  [SMALL_STATE(2953)] = 89171,
  [SMALL_STATE(2954)] = 89186,
  [SMALL_STATE(2955)] = 89217,
  [SMALL_STATE(2956)] = 89232,
  [SMALL_STATE(2957)] = 89253,
  [SMALL_STATE(2958)] = 89272,
  [SMALL_STATE(2959)] = 89297,
  [SMALL_STATE(2960)] = 89312,
  [SMALL_STATE(2961)] = 89327,
  [SMALL_STATE(2962)] = 89346,
  [SMALL_STATE(2963)] = 89361,
  [SMALL_STATE(2964)] = 89376,
  [SMALL_STATE(2965)] = 89407,
  [SMALL_STATE(2966)] = 89438,
  [SMALL_STATE(2967)] = 89453,
  [SMALL_STATE(2968)] = 89468,
  [SMALL_STATE(2969)] = 89493,
  [SMALL_STATE(2970)] = 89508,
  [SMALL_STATE(2971)] = 89539,
  [SMALL_STATE(2972)] = 89558,
  [SMALL_STATE(2973)] = 89589,
  [SMALL_STATE(2974)] = 89620,
  [SMALL_STATE(2975)] = 89639,
  [SMALL_STATE(2976)] = 89654,
  [SMALL_STATE(2977)] = 89671,
  [SMALL_STATE(2978)] = 89686,
  [SMALL_STATE(2979)] = 89701,
  [SMALL_STATE(2980)] = 89726,
  [SMALL_STATE(2981)] = 89747,
  [SMALL_STATE(2982)] = 89772,
  [SMALL_STATE(2983)] = 89791,
  [SMALL_STATE(2984)] = 89812,
  [SMALL_STATE(2985)] = 89827,
  [SMALL_STATE(2986)] = 89842,
  [SMALL_STATE(2987)] = 89857,
  [SMALL_STATE(2988)] = 89874,
  [SMALL_STATE(2989)] = 89889,
  [SMALL_STATE(2990)] = 89904,
  [SMALL_STATE(2991)] = 89923,
  [SMALL_STATE(2992)] = 89938,
  [SMALL_STATE(2993)] = 89959,
  [SMALL_STATE(2994)] = 89984,
  [SMALL_STATE(2995)] = 89999,
  [SMALL_STATE(2996)] = 90024,
  [SMALL_STATE(2997)] = 90055,
  [SMALL_STATE(2998)] = 90076,
  [SMALL_STATE(2999)] = 90107,
  [SMALL_STATE(3000)] = 90122,
  [SMALL_STATE(3001)] = 90153,
  [SMALL_STATE(3002)] = 90168,
  [SMALL_STATE(3003)] = 90187,
  [SMALL_STATE(3004)] = 90218,
  [SMALL_STATE(3005)] = 90233,
  [SMALL_STATE(3006)] = 90248,
  [SMALL_STATE(3007)] = 90263,
  [SMALL_STATE(3008)] = 90288,
  [SMALL_STATE(3009)] = 90319,
  [SMALL_STATE(3010)] = 90344,
  [SMALL_STATE(3011)] = 90361,
  [SMALL_STATE(3012)] = 90392,
  [SMALL_STATE(3013)] = 90407,
  [SMALL_STATE(3014)] = 90432,
  [SMALL_STATE(3015)] = 90447,
  [SMALL_STATE(3016)] = 90468,
  [SMALL_STATE(3017)] = 90492,
  [SMALL_STATE(3018)] = 90512,
  [SMALL_STATE(3019)] = 90532,
  [SMALL_STATE(3020)] = 90556,
  [SMALL_STATE(3021)] = 90580,
  [SMALL_STATE(3022)] = 90604,
  [SMALL_STATE(3023)] = 90622,
  [SMALL_STATE(3024)] = 90646,
  [SMALL_STATE(3025)] = 90670,
  [SMALL_STATE(3026)] = 90690,
  [SMALL_STATE(3027)] = 90714,
  [SMALL_STATE(3028)] = 90731,
  [SMALL_STATE(3029)] = 90744,
  [SMALL_STATE(3030)] = 90769,
  [SMALL_STATE(3031)] = 90794,
  [SMALL_STATE(3032)] = 90807,
  [SMALL_STATE(3033)] = 90820,
  [SMALL_STATE(3034)] = 90839,
  [SMALL_STATE(3035)] = 90864,
  [SMALL_STATE(3036)] = 90889,
  [SMALL_STATE(3037)] = 90914,
  [SMALL_STATE(3038)] = 90939,
  [SMALL_STATE(3039)] = 90958,
  [SMALL_STATE(3040)] = 90983,
  [SMALL_STATE(3041)] = 91000,
  [SMALL_STATE(3042)] = 91013,
  [SMALL_STATE(3043)] = 91028,
  [SMALL_STATE(3044)] = 91045,
  [SMALL_STATE(3045)] = 91066,
  [SMALL_STATE(3046)] = 91079,
  [SMALL_STATE(3047)] = 91104,
  [SMALL_STATE(3048)] = 91129,
  [SMALL_STATE(3049)] = 91154,
  [SMALL_STATE(3050)] = 91179,
  [SMALL_STATE(3051)] = 91196,
  [SMALL_STATE(3052)] = 91213,
  [SMALL_STATE(3053)] = 91238,
  [SMALL_STATE(3054)] = 91255,
  [SMALL_STATE(3055)] = 91280,
  [SMALL_STATE(3056)] = 91301,
  [SMALL_STATE(3057)] = 91326,
  [SMALL_STATE(3058)] = 91339,
  [SMALL_STATE(3059)] = 91362,
  [SMALL_STATE(3060)] = 91387,
  [SMALL_STATE(3061)] = 91402,
  [SMALL_STATE(3062)] = 91415,
  [SMALL_STATE(3063)] = 91436,
  [SMALL_STATE(3064)] = 91457,
  [SMALL_STATE(3065)] = 91470,
  [SMALL_STATE(3066)] = 91485,
  [SMALL_STATE(3067)] = 91500,
  [SMALL_STATE(3068)] = 91517,
  [SMALL_STATE(3069)] = 91542,
  [SMALL_STATE(3070)] = 91567,
  [SMALL_STATE(3071)] = 91592,
  [SMALL_STATE(3072)] = 91609,
  [SMALL_STATE(3073)] = 91626,
  [SMALL_STATE(3074)] = 91651,
  [SMALL_STATE(3075)] = 91676,
  [SMALL_STATE(3076)] = 91697,
  [SMALL_STATE(3077)] = 91718,
  [SMALL_STATE(3078)] = 91743,
  [SMALL_STATE(3079)] = 91756,
  [SMALL_STATE(3080)] = 91773,
  [SMALL_STATE(3081)] = 91794,
  [SMALL_STATE(3082)] = 91815,
  [SMALL_STATE(3083)] = 91832,
  [SMALL_STATE(3084)] = 91857,
  [SMALL_STATE(3085)] = 91882,
  [SMALL_STATE(3086)] = 91907,
  [SMALL_STATE(3087)] = 91932,
  [SMALL_STATE(3088)] = 91949,
  [SMALL_STATE(3089)] = 91974,
  [SMALL_STATE(3090)] = 91991,
  [SMALL_STATE(3091)] = 92012,
  [SMALL_STATE(3092)] = 92037,
  [SMALL_STATE(3093)] = 92050,
  [SMALL_STATE(3094)] = 92069,
  [SMALL_STATE(3095)] = 92094,
  [SMALL_STATE(3096)] = 92119,
  [SMALL_STATE(3097)] = 92132,
  [SMALL_STATE(3098)] = 92145,
  [SMALL_STATE(3099)] = 92162,
  [SMALL_STATE(3100)] = 92179,
  [SMALL_STATE(3101)] = 92204,
  [SMALL_STATE(3102)] = 92225,
  [SMALL_STATE(3103)] = 92250,
  [SMALL_STATE(3104)] = 92275,
  [SMALL_STATE(3105)] = 92300,
  [SMALL_STATE(3106)] = 92317,
  [SMALL_STATE(3107)] = 92342,
  [SMALL_STATE(3108)] = 92367,
  [SMALL_STATE(3109)] = 92384,
  [SMALL_STATE(3110)] = 92409,
  [SMALL_STATE(3111)] = 92434,
  [SMALL_STATE(3112)] = 92455,
  [SMALL_STATE(3113)] = 92468,
  [SMALL_STATE(3114)] = 92485,
  [SMALL_STATE(3115)] = 92502,
  [SMALL_STATE(3116)] = 92519,
  [SMALL_STATE(3117)] = 92544,
  [SMALL_STATE(3118)] = 92569,
  [SMALL_STATE(3119)] = 92588,
  [SMALL_STATE(3120)] = 92613,
  [SMALL_STATE(3121)] = 92638,
  [SMALL_STATE(3122)] = 92659,
  [SMALL_STATE(3123)] = 92672,
  [SMALL_STATE(3124)] = 92689,
  [SMALL_STATE(3125)] = 92706,
  [SMALL_STATE(3126)] = 92731,
  [SMALL_STATE(3127)] = 92748,
  [SMALL_STATE(3128)] = 92763,
  [SMALL_STATE(3129)] = 92788,
  [SMALL_STATE(3130)] = 92813,
  [SMALL_STATE(3131)] = 92830,
  [SMALL_STATE(3132)] = 92847,
  [SMALL_STATE(3133)] = 92864,
  [SMALL_STATE(3134)] = 92889,
  [SMALL_STATE(3135)] = 92904,
  [SMALL_STATE(3136)] = 92921,
  [SMALL_STATE(3137)] = 92938,
  [SMALL_STATE(3138)] = 92951,
  [SMALL_STATE(3139)] = 92976,
  [SMALL_STATE(3140)] = 93001,
  [SMALL_STATE(3141)] = 93026,
  [SMALL_STATE(3142)] = 93043,
  [SMALL_STATE(3143)] = 93068,
  [SMALL_STATE(3144)] = 93093,
  [SMALL_STATE(3145)] = 93118,
  [SMALL_STATE(3146)] = 93139,
  [SMALL_STATE(3147)] = 93161,
  [SMALL_STATE(3148)] = 93183,
  [SMALL_STATE(3149)] = 93199,
  [SMALL_STATE(3150)] = 93211,
  [SMALL_STATE(3151)] = 93227,
  [SMALL_STATE(3152)] = 93241,
  [SMALL_STATE(3153)] = 93259,
  [SMALL_STATE(3154)] = 93281,
  [SMALL_STATE(3155)] = 93297,
  [SMALL_STATE(3156)] = 93319,
  [SMALL_STATE(3157)] = 93335,
  [SMALL_STATE(3158)] = 93353,
  [SMALL_STATE(3159)] = 93367,
  [SMALL_STATE(3160)] = 93379,
  [SMALL_STATE(3161)] = 93395,
  [SMALL_STATE(3162)] = 93413,
  [SMALL_STATE(3163)] = 93435,
  [SMALL_STATE(3164)] = 93453,
  [SMALL_STATE(3165)] = 93475,
  [SMALL_STATE(3166)] = 93493,
  [SMALL_STATE(3167)] = 93515,
  [SMALL_STATE(3168)] = 93537,
  [SMALL_STATE(3169)] = 93559,
  [SMALL_STATE(3170)] = 93575,
  [SMALL_STATE(3171)] = 93591,
  [SMALL_STATE(3172)] = 93607,
  [SMALL_STATE(3173)] = 93619,
  [SMALL_STATE(3174)] = 93635,
  [SMALL_STATE(3175)] = 93653,
  [SMALL_STATE(3176)] = 93675,
  [SMALL_STATE(3177)] = 93691,
  [SMALL_STATE(3178)] = 93713,
  [SMALL_STATE(3179)] = 93729,
  [SMALL_STATE(3180)] = 93751,
  [SMALL_STATE(3181)] = 93765,
  [SMALL_STATE(3182)] = 93781,
  [SMALL_STATE(3183)] = 93801,
  [SMALL_STATE(3184)] = 93817,
  [SMALL_STATE(3185)] = 93833,
  [SMALL_STATE(3186)] = 93849,
  [SMALL_STATE(3187)] = 93871,
  [SMALL_STATE(3188)] = 93893,
  [SMALL_STATE(3189)] = 93915,
  [SMALL_STATE(3190)] = 93933,
  [SMALL_STATE(3191)] = 93955,
  [SMALL_STATE(3192)] = 93977,
  [SMALL_STATE(3193)] = 93993,
  [SMALL_STATE(3194)] = 94013,
  [SMALL_STATE(3195)] = 94035,
  [SMALL_STATE(3196)] = 94051,
  [SMALL_STATE(3197)] = 94069,
  [SMALL_STATE(3198)] = 94091,
  [SMALL_STATE(3199)] = 94113,
  [SMALL_STATE(3200)] = 94135,
  [SMALL_STATE(3201)] = 94157,
  [SMALL_STATE(3202)] = 94179,
  [SMALL_STATE(3203)] = 94201,
  [SMALL_STATE(3204)] = 94223,
  [SMALL_STATE(3205)] = 94241,
  [SMALL_STATE(3206)] = 94263,
  [SMALL_STATE(3207)] = 94281,
  [SMALL_STATE(3208)] = 94299,
  [SMALL_STATE(3209)] = 94321,
  [SMALL_STATE(3210)] = 94337,
  [SMALL_STATE(3211)] = 94359,
  [SMALL_STATE(3212)] = 94377,
  [SMALL_STATE(3213)] = 94393,
  [SMALL_STATE(3214)] = 94409,
  [SMALL_STATE(3215)] = 94431,
  [SMALL_STATE(3216)] = 94453,
  [SMALL_STATE(3217)] = 94469,
  [SMALL_STATE(3218)] = 94491,
  [SMALL_STATE(3219)] = 94513,
  [SMALL_STATE(3220)] = 94535,
  [SMALL_STATE(3221)] = 94557,
  [SMALL_STATE(3222)] = 94573,
  [SMALL_STATE(3223)] = 94591,
  [SMALL_STATE(3224)] = 94607,
  [SMALL_STATE(3225)] = 94623,
  [SMALL_STATE(3226)] = 94635,
  [SMALL_STATE(3227)] = 94657,
  [SMALL_STATE(3228)] = 94675,
  [SMALL_STATE(3229)] = 94691,
  [SMALL_STATE(3230)] = 94709,
  [SMALL_STATE(3231)] = 94731,
  [SMALL_STATE(3232)] = 94749,
  [SMALL_STATE(3233)] = 94761,
  [SMALL_STATE(3234)] = 94779,
  [SMALL_STATE(3235)] = 94801,
  [SMALL_STATE(3236)] = 94817,
  [SMALL_STATE(3237)] = 94839,
  [SMALL_STATE(3238)] = 94857,
  [SMALL_STATE(3239)] = 94879,
  [SMALL_STATE(3240)] = 94895,
  [SMALL_STATE(3241)] = 94913,
  [SMALL_STATE(3242)] = 94931,
  [SMALL_STATE(3243)] = 94953,
  [SMALL_STATE(3244)] = 94975,
  [SMALL_STATE(3245)] = 94997,
  [SMALL_STATE(3246)] = 95015,
  [SMALL_STATE(3247)] = 95037,
  [SMALL_STATE(3248)] = 95059,
  [SMALL_STATE(3249)] = 95077,
  [SMALL_STATE(3250)] = 95099,
  [SMALL_STATE(3251)] = 95115,
  [SMALL_STATE(3252)] = 95137,
  [SMALL_STATE(3253)] = 95159,
  [SMALL_STATE(3254)] = 95181,
  [SMALL_STATE(3255)] = 95197,
  [SMALL_STATE(3256)] = 95213,
  [SMALL_STATE(3257)] = 95235,
  [SMALL_STATE(3258)] = 95253,
  [SMALL_STATE(3259)] = 95269,
  [SMALL_STATE(3260)] = 95285,
  [SMALL_STATE(3261)] = 95307,
  [SMALL_STATE(3262)] = 95323,
  [SMALL_STATE(3263)] = 95341,
  [SMALL_STATE(3264)] = 95357,
  [SMALL_STATE(3265)] = 95375,
  [SMALL_STATE(3266)] = 95397,
  [SMALL_STATE(3267)] = 95415,
  [SMALL_STATE(3268)] = 95433,
  [SMALL_STATE(3269)] = 95451,
  [SMALL_STATE(3270)] = 95469,
  [SMALL_STATE(3271)] = 95485,
  [SMALL_STATE(3272)] = 95507,
  [SMALL_STATE(3273)] = 95529,
  [SMALL_STATE(3274)] = 95551,
  [SMALL_STATE(3275)] = 95565,
  [SMALL_STATE(3276)] = 95587,
  [SMALL_STATE(3277)] = 95603,
  [SMALL_STATE(3278)] = 95625,
  [SMALL_STATE(3279)] = 95637,
  [SMALL_STATE(3280)] = 95649,
  [SMALL_STATE(3281)] = 95667,
  [SMALL_STATE(3282)] = 95683,
  [SMALL_STATE(3283)] = 95701,
  [SMALL_STATE(3284)] = 95723,
  [SMALL_STATE(3285)] = 95745,
  [SMALL_STATE(3286)] = 95763,
  [SMALL_STATE(3287)] = 95781,
  [SMALL_STATE(3288)] = 95799,
  [SMALL_STATE(3289)] = 95821,
  [SMALL_STATE(3290)] = 95843,
  [SMALL_STATE(3291)] = 95859,
  [SMALL_STATE(3292)] = 95875,
  [SMALL_STATE(3293)] = 95897,
  [SMALL_STATE(3294)] = 95919,
  [SMALL_STATE(3295)] = 95935,
  [SMALL_STATE(3296)] = 95953,
  [SMALL_STATE(3297)] = 95973,
  [SMALL_STATE(3298)] = 95995,
  [SMALL_STATE(3299)] = 96017,
  [SMALL_STATE(3300)] = 96033,
  [SMALL_STATE(3301)] = 96049,
  [SMALL_STATE(3302)] = 96065,
  [SMALL_STATE(3303)] = 96087,
  [SMALL_STATE(3304)] = 96109,
  [SMALL_STATE(3305)] = 96127,
  [SMALL_STATE(3306)] = 96149,
  [SMALL_STATE(3307)] = 96171,
  [SMALL_STATE(3308)] = 96189,
  [SMALL_STATE(3309)] = 96211,
  [SMALL_STATE(3310)] = 96227,
  [SMALL_STATE(3311)] = 96243,
  [SMALL_STATE(3312)] = 96259,
  [SMALL_STATE(3313)] = 96275,
  [SMALL_STATE(3314)] = 96287,
  [SMALL_STATE(3315)] = 96309,
  [SMALL_STATE(3316)] = 96331,
  [SMALL_STATE(3317)] = 96349,
  [SMALL_STATE(3318)] = 96365,
  [SMALL_STATE(3319)] = 96381,
  [SMALL_STATE(3320)] = 96403,
  [SMALL_STATE(3321)] = 96421,
  [SMALL_STATE(3322)] = 96439,
  [SMALL_STATE(3323)] = 96455,
  [SMALL_STATE(3324)] = 96471,
  [SMALL_STATE(3325)] = 96493,
  [SMALL_STATE(3326)] = 96511,
  [SMALL_STATE(3327)] = 96529,
  [SMALL_STATE(3328)] = 96545,
  [SMALL_STATE(3329)] = 96563,
  [SMALL_STATE(3330)] = 96581,
  [SMALL_STATE(3331)] = 96599,
  [SMALL_STATE(3332)] = 96617,
  [SMALL_STATE(3333)] = 96629,
  [SMALL_STATE(3334)] = 96643,
  [SMALL_STATE(3335)] = 96663,
  [SMALL_STATE(3336)] = 96681,
  [SMALL_STATE(3337)] = 96700,
  [SMALL_STATE(3338)] = 96717,
  [SMALL_STATE(3339)] = 96728,
  [SMALL_STATE(3340)] = 96747,
  [SMALL_STATE(3341)] = 96764,
  [SMALL_STATE(3342)] = 96783,
  [SMALL_STATE(3343)] = 96802,
  [SMALL_STATE(3344)] = 96821,
  [SMALL_STATE(3345)] = 96838,
  [SMALL_STATE(3346)] = 96857,
  [SMALL_STATE(3347)] = 96876,
  [SMALL_STATE(3348)] = 96895,
  [SMALL_STATE(3349)] = 96914,
  [SMALL_STATE(3350)] = 96929,
  [SMALL_STATE(3351)] = 96944,
  [SMALL_STATE(3352)] = 96963,
  [SMALL_STATE(3353)] = 96974,
  [SMALL_STATE(3354)] = 96989,
  [SMALL_STATE(3355)] = 97006,
  [SMALL_STATE(3356)] = 97017,
  [SMALL_STATE(3357)] = 97036,
  [SMALL_STATE(3358)] = 97055,
  [SMALL_STATE(3359)] = 97066,
  [SMALL_STATE(3360)] = 97077,
  [SMALL_STATE(3361)] = 97088,
  [SMALL_STATE(3362)] = 97107,
  [SMALL_STATE(3363)] = 97118,
  [SMALL_STATE(3364)] = 97129,
  [SMALL_STATE(3365)] = 97140,
  [SMALL_STATE(3366)] = 97157,
  [SMALL_STATE(3367)] = 97168,
  [SMALL_STATE(3368)] = 97185,
  [SMALL_STATE(3369)] = 97202,
  [SMALL_STATE(3370)] = 97219,
  [SMALL_STATE(3371)] = 97230,
  [SMALL_STATE(3372)] = 97247,
  [SMALL_STATE(3373)] = 97266,
  [SMALL_STATE(3374)] = 97277,
  [SMALL_STATE(3375)] = 97288,
  [SMALL_STATE(3376)] = 97299,
  [SMALL_STATE(3377)] = 97314,
  [SMALL_STATE(3378)] = 97325,
  [SMALL_STATE(3379)] = 97344,
  [SMALL_STATE(3380)] = 97359,
  [SMALL_STATE(3381)] = 97374,
  [SMALL_STATE(3382)] = 97385,
  [SMALL_STATE(3383)] = 97396,
  [SMALL_STATE(3384)] = 97415,
  [SMALL_STATE(3385)] = 97426,
  [SMALL_STATE(3386)] = 97445,
  [SMALL_STATE(3387)] = 97456,
  [SMALL_STATE(3388)] = 97475,
  [SMALL_STATE(3389)] = 97486,
  [SMALL_STATE(3390)] = 97505,
  [SMALL_STATE(3391)] = 97524,
  [SMALL_STATE(3392)] = 97543,
  [SMALL_STATE(3393)] = 97558,
  [SMALL_STATE(3394)] = 97577,
  [SMALL_STATE(3395)] = 97596,
  [SMALL_STATE(3396)] = 97611,
  [SMALL_STATE(3397)] = 97622,
  [SMALL_STATE(3398)] = 97633,
  [SMALL_STATE(3399)] = 97644,
  [SMALL_STATE(3400)] = 97663,
  [SMALL_STATE(3401)] = 97678,
  [SMALL_STATE(3402)] = 97695,
  [SMALL_STATE(3403)] = 97714,
  [SMALL_STATE(3404)] = 97725,
  [SMALL_STATE(3405)] = 97742,
  [SMALL_STATE(3406)] = 97761,
  [SMALL_STATE(3407)] = 97780,
  [SMALL_STATE(3408)] = 97799,
  [SMALL_STATE(3409)] = 97814,
  [SMALL_STATE(3410)] = 97829,
  [SMALL_STATE(3411)] = 97848,
  [SMALL_STATE(3412)] = 97867,
  [SMALL_STATE(3413)] = 97878,
  [SMALL_STATE(3414)] = 97889,
  [SMALL_STATE(3415)] = 97908,
  [SMALL_STATE(3416)] = 97925,
  [SMALL_STATE(3417)] = 97936,
  [SMALL_STATE(3418)] = 97947,
  [SMALL_STATE(3419)] = 97966,
  [SMALL_STATE(3420)] = 97985,
  [SMALL_STATE(3421)] = 98002,
  [SMALL_STATE(3422)] = 98013,
  [SMALL_STATE(3423)] = 98024,
  [SMALL_STATE(3424)] = 98035,
  [SMALL_STATE(3425)] = 98046,
  [SMALL_STATE(3426)] = 98057,
  [SMALL_STATE(3427)] = 98074,
  [SMALL_STATE(3428)] = 98089,
  [SMALL_STATE(3429)] = 98104,
  [SMALL_STATE(3430)] = 98119,
  [SMALL_STATE(3431)] = 98130,
  [SMALL_STATE(3432)] = 98149,
  [SMALL_STATE(3433)] = 98168,
  [SMALL_STATE(3434)] = 98187,
  [SMALL_STATE(3435)] = 98202,
  [SMALL_STATE(3436)] = 98213,
  [SMALL_STATE(3437)] = 98228,
  [SMALL_STATE(3438)] = 98239,
  [SMALL_STATE(3439)] = 98256,
  [SMALL_STATE(3440)] = 98273,
  [SMALL_STATE(3441)] = 98284,
  [SMALL_STATE(3442)] = 98295,
  [SMALL_STATE(3443)] = 98306,
  [SMALL_STATE(3444)] = 98325,
  [SMALL_STATE(3445)] = 98344,
  [SMALL_STATE(3446)] = 98355,
  [SMALL_STATE(3447)] = 98372,
  [SMALL_STATE(3448)] = 98383,
  [SMALL_STATE(3449)] = 98402,
  [SMALL_STATE(3450)] = 98421,
  [SMALL_STATE(3451)] = 98440,
  [SMALL_STATE(3452)] = 98451,
  [SMALL_STATE(3453)] = 98466,
  [SMALL_STATE(3454)] = 98485,
  [SMALL_STATE(3455)] = 98504,
  [SMALL_STATE(3456)] = 98519,
  [SMALL_STATE(3457)] = 98538,
  [SMALL_STATE(3458)] = 98549,
  [SMALL_STATE(3459)] = 98560,
  [SMALL_STATE(3460)] = 98575,
  [SMALL_STATE(3461)] = 98592,
  [SMALL_STATE(3462)] = 98611,
  [SMALL_STATE(3463)] = 98630,
  [SMALL_STATE(3464)] = 98649,
  [SMALL_STATE(3465)] = 98668,
  [SMALL_STATE(3466)] = 98687,
  [SMALL_STATE(3467)] = 98704,
  [SMALL_STATE(3468)] = 98723,
  [SMALL_STATE(3469)] = 98742,
  [SMALL_STATE(3470)] = 98759,
  [SMALL_STATE(3471)] = 98770,
  [SMALL_STATE(3472)] = 98781,
  [SMALL_STATE(3473)] = 98800,
  [SMALL_STATE(3474)] = 98819,
  [SMALL_STATE(3475)] = 98838,
  [SMALL_STATE(3476)] = 98849,
  [SMALL_STATE(3477)] = 98868,
  [SMALL_STATE(3478)] = 98879,
  [SMALL_STATE(3479)] = 98896,
  [SMALL_STATE(3480)] = 98915,
  [SMALL_STATE(3481)] = 98934,
  [SMALL_STATE(3482)] = 98953,
  [SMALL_STATE(3483)] = 98972,
  [SMALL_STATE(3484)] = 98991,
  [SMALL_STATE(3485)] = 99010,
  [SMALL_STATE(3486)] = 99029,
  [SMALL_STATE(3487)] = 99048,
  [SMALL_STATE(3488)] = 99063,
  [SMALL_STATE(3489)] = 99080,
  [SMALL_STATE(3490)] = 99091,
  [SMALL_STATE(3491)] = 99108,
  [SMALL_STATE(3492)] = 99123,
  [SMALL_STATE(3493)] = 99142,
  [SMALL_STATE(3494)] = 99157,
  [SMALL_STATE(3495)] = 99176,
  [SMALL_STATE(3496)] = 99187,
  [SMALL_STATE(3497)] = 99202,
  [SMALL_STATE(3498)] = 99213,
  [SMALL_STATE(3499)] = 99224,
  [SMALL_STATE(3500)] = 99235,
  [SMALL_STATE(3501)] = 99254,
  [SMALL_STATE(3502)] = 99273,
  [SMALL_STATE(3503)] = 99292,
  [SMALL_STATE(3504)] = 99311,
  [SMALL_STATE(3505)] = 99322,
  [SMALL_STATE(3506)] = 99341,
  [SMALL_STATE(3507)] = 99352,
  [SMALL_STATE(3508)] = 99363,
  [SMALL_STATE(3509)] = 99380,
  [SMALL_STATE(3510)] = 99391,
  [SMALL_STATE(3511)] = 99402,
  [SMALL_STATE(3512)] = 99413,
  [SMALL_STATE(3513)] = 99432,
  [SMALL_STATE(3514)] = 99451,
  [SMALL_STATE(3515)] = 99462,
  [SMALL_STATE(3516)] = 99477,
  [SMALL_STATE(3517)] = 99492,
  [SMALL_STATE(3518)] = 99507,
  [SMALL_STATE(3519)] = 99522,
  [SMALL_STATE(3520)] = 99541,
  [SMALL_STATE(3521)] = 99558,
  [SMALL_STATE(3522)] = 99569,
  [SMALL_STATE(3523)] = 99580,
  [SMALL_STATE(3524)] = 99591,
  [SMALL_STATE(3525)] = 99608,
  [SMALL_STATE(3526)] = 99627,
  [SMALL_STATE(3527)] = 99638,
  [SMALL_STATE(3528)] = 99657,
  [SMALL_STATE(3529)] = 99668,
  [SMALL_STATE(3530)] = 99679,
  [SMALL_STATE(3531)] = 99696,
  [SMALL_STATE(3532)] = 99713,
  [SMALL_STATE(3533)] = 99732,
  [SMALL_STATE(3534)] = 99751,
  [SMALL_STATE(3535)] = 99762,
  [SMALL_STATE(3536)] = 99781,
  [SMALL_STATE(3537)] = 99792,
  [SMALL_STATE(3538)] = 99803,
  [SMALL_STATE(3539)] = 99822,
  [SMALL_STATE(3540)] = 99837,
  [SMALL_STATE(3541)] = 99852,
  [SMALL_STATE(3542)] = 99867,
  [SMALL_STATE(3543)] = 99878,
  [SMALL_STATE(3544)] = 99889,
  [SMALL_STATE(3545)] = 99908,
  [SMALL_STATE(3546)] = 99924,
  [SMALL_STATE(3547)] = 99938,
  [SMALL_STATE(3548)] = 99952,
  [SMALL_STATE(3549)] = 99968,
  [SMALL_STATE(3550)] = 99984,
  [SMALL_STATE(3551)] = 100000,
  [SMALL_STATE(3552)] = 100016,
  [SMALL_STATE(3553)] = 100030,
  [SMALL_STATE(3554)] = 100044,
  [SMALL_STATE(3555)] = 100060,
  [SMALL_STATE(3556)] = 100076,
  [SMALL_STATE(3557)] = 100092,
  [SMALL_STATE(3558)] = 100108,
  [SMALL_STATE(3559)] = 100124,
  [SMALL_STATE(3560)] = 100140,
  [SMALL_STATE(3561)] = 100154,
  [SMALL_STATE(3562)] = 100168,
  [SMALL_STATE(3563)] = 100182,
  [SMALL_STATE(3564)] = 100198,
  [SMALL_STATE(3565)] = 100214,
  [SMALL_STATE(3566)] = 100230,
  [SMALL_STATE(3567)] = 100244,
  [SMALL_STATE(3568)] = 100258,
  [SMALL_STATE(3569)] = 100274,
  [SMALL_STATE(3570)] = 100290,
  [SMALL_STATE(3571)] = 100306,
  [SMALL_STATE(3572)] = 100320,
  [SMALL_STATE(3573)] = 100336,
  [SMALL_STATE(3574)] = 100352,
  [SMALL_STATE(3575)] = 100368,
  [SMALL_STATE(3576)] = 100382,
  [SMALL_STATE(3577)] = 100396,
  [SMALL_STATE(3578)] = 100410,
  [SMALL_STATE(3579)] = 100426,
  [SMALL_STATE(3580)] = 100442,
  [SMALL_STATE(3581)] = 100456,
  [SMALL_STATE(3582)] = 100472,
  [SMALL_STATE(3583)] = 100486,
  [SMALL_STATE(3584)] = 100500,
  [SMALL_STATE(3585)] = 100516,
  [SMALL_STATE(3586)] = 100530,
  [SMALL_STATE(3587)] = 100540,
  [SMALL_STATE(3588)] = 100556,
  [SMALL_STATE(3589)] = 100572,
  [SMALL_STATE(3590)] = 100588,
  [SMALL_STATE(3591)] = 100604,
  [SMALL_STATE(3592)] = 100620,
  [SMALL_STATE(3593)] = 100634,
  [SMALL_STATE(3594)] = 100650,
  [SMALL_STATE(3595)] = 100666,
  [SMALL_STATE(3596)] = 100680,
  [SMALL_STATE(3597)] = 100696,
  [SMALL_STATE(3598)] = 100712,
  [SMALL_STATE(3599)] = 100726,
  [SMALL_STATE(3600)] = 100742,
  [SMALL_STATE(3601)] = 100758,
  [SMALL_STATE(3602)] = 100774,
  [SMALL_STATE(3603)] = 100788,
  [SMALL_STATE(3604)] = 100802,
  [SMALL_STATE(3605)] = 100818,
  [SMALL_STATE(3606)] = 100832,
  [SMALL_STATE(3607)] = 100842,
  [SMALL_STATE(3608)] = 100856,
  [SMALL_STATE(3609)] = 100870,
  [SMALL_STATE(3610)] = 100884,
  [SMALL_STATE(3611)] = 100900,
  [SMALL_STATE(3612)] = 100916,
  [SMALL_STATE(3613)] = 100932,
  [SMALL_STATE(3614)] = 100944,
  [SMALL_STATE(3615)] = 100960,
  [SMALL_STATE(3616)] = 100976,
  [SMALL_STATE(3617)] = 100992,
  [SMALL_STATE(3618)] = 101008,
  [SMALL_STATE(3619)] = 101024,
  [SMALL_STATE(3620)] = 101040,
  [SMALL_STATE(3621)] = 101056,
  [SMALL_STATE(3622)] = 101072,
  [SMALL_STATE(3623)] = 101088,
  [SMALL_STATE(3624)] = 101104,
  [SMALL_STATE(3625)] = 101118,
  [SMALL_STATE(3626)] = 101132,
  [SMALL_STATE(3627)] = 101148,
  [SMALL_STATE(3628)] = 101164,
  [SMALL_STATE(3629)] = 101180,
  [SMALL_STATE(3630)] = 101194,
  [SMALL_STATE(3631)] = 101210,
  [SMALL_STATE(3632)] = 101224,
  [SMALL_STATE(3633)] = 101238,
  [SMALL_STATE(3634)] = 101250,
  [SMALL_STATE(3635)] = 101266,
  [SMALL_STATE(3636)] = 101280,
  [SMALL_STATE(3637)] = 101296,
  [SMALL_STATE(3638)] = 101312,
  [SMALL_STATE(3639)] = 101328,
  [SMALL_STATE(3640)] = 101344,
  [SMALL_STATE(3641)] = 101360,
  [SMALL_STATE(3642)] = 101374,
  [SMALL_STATE(3643)] = 101390,
  [SMALL_STATE(3644)] = 101406,
  [SMALL_STATE(3645)] = 101418,
  [SMALL_STATE(3646)] = 101430,
  [SMALL_STATE(3647)] = 101446,
  [SMALL_STATE(3648)] = 101460,
  [SMALL_STATE(3649)] = 101474,
  [SMALL_STATE(3650)] = 101490,
  [SMALL_STATE(3651)] = 101506,
  [SMALL_STATE(3652)] = 101522,
  [SMALL_STATE(3653)] = 101536,
  [SMALL_STATE(3654)] = 101552,
  [SMALL_STATE(3655)] = 101568,
  [SMALL_STATE(3656)] = 101584,
  [SMALL_STATE(3657)] = 101598,
  [SMALL_STATE(3658)] = 101614,
  [SMALL_STATE(3659)] = 101630,
  [SMALL_STATE(3660)] = 101644,
  [SMALL_STATE(3661)] = 101660,
  [SMALL_STATE(3662)] = 101674,
  [SMALL_STATE(3663)] = 101688,
  [SMALL_STATE(3664)] = 101704,
  [SMALL_STATE(3665)] = 101720,
  [SMALL_STATE(3666)] = 101736,
  [SMALL_STATE(3667)] = 101750,
  [SMALL_STATE(3668)] = 101766,
  [SMALL_STATE(3669)] = 101782,
  [SMALL_STATE(3670)] = 101796,
  [SMALL_STATE(3671)] = 101810,
  [SMALL_STATE(3672)] = 101824,
  [SMALL_STATE(3673)] = 101838,
  [SMALL_STATE(3674)] = 101852,
  [SMALL_STATE(3675)] = 101868,
  [SMALL_STATE(3676)] = 101884,
  [SMALL_STATE(3677)] = 101894,
  [SMALL_STATE(3678)] = 101908,
  [SMALL_STATE(3679)] = 101918,
  [SMALL_STATE(3680)] = 101934,
  [SMALL_STATE(3681)] = 101944,
  [SMALL_STATE(3682)] = 101958,
  [SMALL_STATE(3683)] = 101974,
  [SMALL_STATE(3684)] = 101990,
  [SMALL_STATE(3685)] = 102006,
  [SMALL_STATE(3686)] = 102022,
  [SMALL_STATE(3687)] = 102036,
  [SMALL_STATE(3688)] = 102050,
  [SMALL_STATE(3689)] = 102064,
  [SMALL_STATE(3690)] = 102080,
  [SMALL_STATE(3691)] = 102096,
  [SMALL_STATE(3692)] = 102112,
  [SMALL_STATE(3693)] = 102128,
  [SMALL_STATE(3694)] = 102142,
  [SMALL_STATE(3695)] = 102158,
  [SMALL_STATE(3696)] = 102174,
  [SMALL_STATE(3697)] = 102188,
  [SMALL_STATE(3698)] = 102202,
  [SMALL_STATE(3699)] = 102218,
  [SMALL_STATE(3700)] = 102234,
  [SMALL_STATE(3701)] = 102248,
  [SMALL_STATE(3702)] = 102264,
  [SMALL_STATE(3703)] = 102273,
  [SMALL_STATE(3704)] = 102284,
  [SMALL_STATE(3705)] = 102297,
  [SMALL_STATE(3706)] = 102310,
  [SMALL_STATE(3707)] = 102323,
  [SMALL_STATE(3708)] = 102336,
  [SMALL_STATE(3709)] = 102349,
  [SMALL_STATE(3710)] = 102362,
  [SMALL_STATE(3711)] = 102375,
  [SMALL_STATE(3712)] = 102384,
  [SMALL_STATE(3713)] = 102397,
  [SMALL_STATE(3714)] = 102410,
  [SMALL_STATE(3715)] = 102423,
  [SMALL_STATE(3716)] = 102436,
  [SMALL_STATE(3717)] = 102449,
  [SMALL_STATE(3718)] = 102462,
  [SMALL_STATE(3719)] = 102475,
  [SMALL_STATE(3720)] = 102488,
  [SMALL_STATE(3721)] = 102501,
  [SMALL_STATE(3722)] = 102514,
  [SMALL_STATE(3723)] = 102527,
  [SMALL_STATE(3724)] = 102540,
  [SMALL_STATE(3725)] = 102553,
  [SMALL_STATE(3726)] = 102562,
  [SMALL_STATE(3727)] = 102575,
  [SMALL_STATE(3728)] = 102588,
  [SMALL_STATE(3729)] = 102601,
  [SMALL_STATE(3730)] = 102614,
  [SMALL_STATE(3731)] = 102627,
  [SMALL_STATE(3732)] = 102640,
  [SMALL_STATE(3733)] = 102653,
  [SMALL_STATE(3734)] = 102666,
  [SMALL_STATE(3735)] = 102679,
  [SMALL_STATE(3736)] = 102692,
  [SMALL_STATE(3737)] = 102705,
  [SMALL_STATE(3738)] = 102714,
  [SMALL_STATE(3739)] = 102727,
  [SMALL_STATE(3740)] = 102740,
  [SMALL_STATE(3741)] = 102753,
  [SMALL_STATE(3742)] = 102764,
  [SMALL_STATE(3743)] = 102773,
  [SMALL_STATE(3744)] = 102786,
  [SMALL_STATE(3745)] = 102799,
  [SMALL_STATE(3746)] = 102808,
  [SMALL_STATE(3747)] = 102821,
  [SMALL_STATE(3748)] = 102834,
  [SMALL_STATE(3749)] = 102847,
  [SMALL_STATE(3750)] = 102860,
  [SMALL_STATE(3751)] = 102873,
  [SMALL_STATE(3752)] = 102886,
  [SMALL_STATE(3753)] = 102899,
  [SMALL_STATE(3754)] = 102912,
  [SMALL_STATE(3755)] = 102925,
  [SMALL_STATE(3756)] = 102938,
  [SMALL_STATE(3757)] = 102951,
  [SMALL_STATE(3758)] = 102964,
  [SMALL_STATE(3759)] = 102975,
  [SMALL_STATE(3760)] = 102988,
  [SMALL_STATE(3761)] = 103001,
  [SMALL_STATE(3762)] = 103014,
  [SMALL_STATE(3763)] = 103025,
  [SMALL_STATE(3764)] = 103038,
  [SMALL_STATE(3765)] = 103051,
  [SMALL_STATE(3766)] = 103064,
  [SMALL_STATE(3767)] = 103077,
  [SMALL_STATE(3768)] = 103088,
  [SMALL_STATE(3769)] = 103097,
  [SMALL_STATE(3770)] = 103106,
  [SMALL_STATE(3771)] = 103115,
  [SMALL_STATE(3772)] = 103124,
  [SMALL_STATE(3773)] = 103133,
  [SMALL_STATE(3774)] = 103146,
  [SMALL_STATE(3775)] = 103155,
  [SMALL_STATE(3776)] = 103164,
  [SMALL_STATE(3777)] = 103173,
  [SMALL_STATE(3778)] = 103186,
  [SMALL_STATE(3779)] = 103197,
  [SMALL_STATE(3780)] = 103206,
  [SMALL_STATE(3781)] = 103219,
  [SMALL_STATE(3782)] = 103228,
  [SMALL_STATE(3783)] = 103241,
  [SMALL_STATE(3784)] = 103250,
  [SMALL_STATE(3785)] = 103259,
  [SMALL_STATE(3786)] = 103268,
  [SMALL_STATE(3787)] = 103281,
  [SMALL_STATE(3788)] = 103294,
  [SMALL_STATE(3789)] = 103307,
  [SMALL_STATE(3790)] = 103316,
  [SMALL_STATE(3791)] = 103329,
  [SMALL_STATE(3792)] = 103342,
  [SMALL_STATE(3793)] = 103355,
  [SMALL_STATE(3794)] = 103364,
  [SMALL_STATE(3795)] = 103373,
  [SMALL_STATE(3796)] = 103386,
  [SMALL_STATE(3797)] = 103399,
  [SMALL_STATE(3798)] = 103412,
  [SMALL_STATE(3799)] = 103425,
  [SMALL_STATE(3800)] = 103438,
  [SMALL_STATE(3801)] = 103451,
  [SMALL_STATE(3802)] = 103464,
  [SMALL_STATE(3803)] = 103477,
  [SMALL_STATE(3804)] = 103486,
  [SMALL_STATE(3805)] = 103499,
  [SMALL_STATE(3806)] = 103512,
  [SMALL_STATE(3807)] = 103525,
  [SMALL_STATE(3808)] = 103534,
  [SMALL_STATE(3809)] = 103547,
  [SMALL_STATE(3810)] = 103560,
  [SMALL_STATE(3811)] = 103569,
  [SMALL_STATE(3812)] = 103582,
  [SMALL_STATE(3813)] = 103595,
  [SMALL_STATE(3814)] = 103604,
  [SMALL_STATE(3815)] = 103613,
  [SMALL_STATE(3816)] = 103622,
  [SMALL_STATE(3817)] = 103631,
  [SMALL_STATE(3818)] = 103644,
  [SMALL_STATE(3819)] = 103653,
  [SMALL_STATE(3820)] = 103662,
  [SMALL_STATE(3821)] = 103675,
  [SMALL_STATE(3822)] = 103684,
  [SMALL_STATE(3823)] = 103697,
  [SMALL_STATE(3824)] = 103708,
  [SMALL_STATE(3825)] = 103721,
  [SMALL_STATE(3826)] = 103734,
  [SMALL_STATE(3827)] = 103747,
  [SMALL_STATE(3828)] = 103760,
  [SMALL_STATE(3829)] = 103773,
  [SMALL_STATE(3830)] = 103786,
  [SMALL_STATE(3831)] = 103799,
  [SMALL_STATE(3832)] = 103812,
  [SMALL_STATE(3833)] = 103825,
  [SMALL_STATE(3834)] = 103838,
  [SMALL_STATE(3835)] = 103851,
  [SMALL_STATE(3836)] = 103864,
  [SMALL_STATE(3837)] = 103877,
  [SMALL_STATE(3838)] = 103888,
  [SMALL_STATE(3839)] = 103901,
  [SMALL_STATE(3840)] = 103914,
  [SMALL_STATE(3841)] = 103927,
  [SMALL_STATE(3842)] = 103940,
  [SMALL_STATE(3843)] = 103953,
  [SMALL_STATE(3844)] = 103966,
  [SMALL_STATE(3845)] = 103979,
  [SMALL_STATE(3846)] = 103992,
  [SMALL_STATE(3847)] = 104005,
  [SMALL_STATE(3848)] = 104014,
  [SMALL_STATE(3849)] = 104027,
  [SMALL_STATE(3850)] = 104040,
  [SMALL_STATE(3851)] = 104053,
  [SMALL_STATE(3852)] = 104066,
  [SMALL_STATE(3853)] = 104079,
  [SMALL_STATE(3854)] = 104092,
  [SMALL_STATE(3855)] = 104105,
  [SMALL_STATE(3856)] = 104118,
  [SMALL_STATE(3857)] = 104127,
  [SMALL_STATE(3858)] = 104140,
  [SMALL_STATE(3859)] = 104153,
  [SMALL_STATE(3860)] = 104164,
  [SMALL_STATE(3861)] = 104173,
  [SMALL_STATE(3862)] = 104182,
  [SMALL_STATE(3863)] = 104191,
  [SMALL_STATE(3864)] = 104204,
  [SMALL_STATE(3865)] = 104217,
  [SMALL_STATE(3866)] = 104226,
  [SMALL_STATE(3867)] = 104237,
  [SMALL_STATE(3868)] = 104250,
  [SMALL_STATE(3869)] = 104261,
  [SMALL_STATE(3870)] = 104272,
  [SMALL_STATE(3871)] = 104285,
  [SMALL_STATE(3872)] = 104298,
  [SMALL_STATE(3873)] = 104311,
  [SMALL_STATE(3874)] = 104324,
  [SMALL_STATE(3875)] = 104337,
  [SMALL_STATE(3876)] = 104350,
  [SMALL_STATE(3877)] = 104363,
  [SMALL_STATE(3878)] = 104376,
  [SMALL_STATE(3879)] = 104389,
  [SMALL_STATE(3880)] = 104402,
  [SMALL_STATE(3881)] = 104415,
  [SMALL_STATE(3882)] = 104428,
  [SMALL_STATE(3883)] = 104441,
  [SMALL_STATE(3884)] = 104454,
  [SMALL_STATE(3885)] = 104463,
  [SMALL_STATE(3886)] = 104476,
  [SMALL_STATE(3887)] = 104489,
  [SMALL_STATE(3888)] = 104502,
  [SMALL_STATE(3889)] = 104511,
  [SMALL_STATE(3890)] = 104520,
  [SMALL_STATE(3891)] = 104533,
  [SMALL_STATE(3892)] = 104546,
  [SMALL_STATE(3893)] = 104555,
  [SMALL_STATE(3894)] = 104568,
  [SMALL_STATE(3895)] = 104581,
  [SMALL_STATE(3896)] = 104594,
  [SMALL_STATE(3897)] = 104603,
  [SMALL_STATE(3898)] = 104612,
  [SMALL_STATE(3899)] = 104621,
  [SMALL_STATE(3900)] = 104630,
  [SMALL_STATE(3901)] = 104643,
  [SMALL_STATE(3902)] = 104652,
  [SMALL_STATE(3903)] = 104665,
  [SMALL_STATE(3904)] = 104674,
  [SMALL_STATE(3905)] = 104687,
  [SMALL_STATE(3906)] = 104696,
  [SMALL_STATE(3907)] = 104705,
  [SMALL_STATE(3908)] = 104714,
  [SMALL_STATE(3909)] = 104727,
  [SMALL_STATE(3910)] = 104736,
  [SMALL_STATE(3911)] = 104749,
  [SMALL_STATE(3912)] = 104762,
  [SMALL_STATE(3913)] = 104775,
  [SMALL_STATE(3914)] = 104788,
  [SMALL_STATE(3915)] = 104797,
  [SMALL_STATE(3916)] = 104810,
  [SMALL_STATE(3917)] = 104823,
  [SMALL_STATE(3918)] = 104836,
  [SMALL_STATE(3919)] = 104849,
  [SMALL_STATE(3920)] = 104858,
  [SMALL_STATE(3921)] = 104871,
  [SMALL_STATE(3922)] = 104880,
  [SMALL_STATE(3923)] = 104893,
  [SMALL_STATE(3924)] = 104906,
  [SMALL_STATE(3925)] = 104917,
  [SMALL_STATE(3926)] = 104930,
  [SMALL_STATE(3927)] = 104943,
  [SMALL_STATE(3928)] = 104956,
  [SMALL_STATE(3929)] = 104969,
  [SMALL_STATE(3930)] = 104982,
  [SMALL_STATE(3931)] = 104995,
  [SMALL_STATE(3932)] = 105008,
  [SMALL_STATE(3933)] = 105019,
  [SMALL_STATE(3934)] = 105028,
  [SMALL_STATE(3935)] = 105041,
  [SMALL_STATE(3936)] = 105054,
  [SMALL_STATE(3937)] = 105067,
  [SMALL_STATE(3938)] = 105080,
  [SMALL_STATE(3939)] = 105093,
  [SMALL_STATE(3940)] = 105106,
  [SMALL_STATE(3941)] = 105119,
  [SMALL_STATE(3942)] = 105132,
  [SMALL_STATE(3943)] = 105145,
  [SMALL_STATE(3944)] = 105154,
  [SMALL_STATE(3945)] = 105163,
  [SMALL_STATE(3946)] = 105176,
  [SMALL_STATE(3947)] = 105185,
  [SMALL_STATE(3948)] = 105196,
  [SMALL_STATE(3949)] = 105205,
  [SMALL_STATE(3950)] = 105216,
  [SMALL_STATE(3951)] = 105225,
  [SMALL_STATE(3952)] = 105235,
  [SMALL_STATE(3953)] = 105245,
  [SMALL_STATE(3954)] = 105255,
  [SMALL_STATE(3955)] = 105265,
  [SMALL_STATE(3956)] = 105275,
  [SMALL_STATE(3957)] = 105285,
  [SMALL_STATE(3958)] = 105295,
  [SMALL_STATE(3959)] = 105305,
  [SMALL_STATE(3960)] = 105315,
  [SMALL_STATE(3961)] = 105325,
  [SMALL_STATE(3962)] = 105335,
  [SMALL_STATE(3963)] = 105345,
  [SMALL_STATE(3964)] = 105355,
  [SMALL_STATE(3965)] = 105365,
  [SMALL_STATE(3966)] = 105375,
  [SMALL_STATE(3967)] = 105383,
  [SMALL_STATE(3968)] = 105393,
  [SMALL_STATE(3969)] = 105403,
  [SMALL_STATE(3970)] = 105413,
  [SMALL_STATE(3971)] = 105423,
  [SMALL_STATE(3972)] = 105431,
  [SMALL_STATE(3973)] = 105441,
  [SMALL_STATE(3974)] = 105451,
  [SMALL_STATE(3975)] = 105461,
  [SMALL_STATE(3976)] = 105471,
  [SMALL_STATE(3977)] = 105481,
  [SMALL_STATE(3978)] = 105491,
  [SMALL_STATE(3979)] = 105501,
  [SMALL_STATE(3980)] = 105511,
  [SMALL_STATE(3981)] = 105521,
  [SMALL_STATE(3982)] = 105531,
  [SMALL_STATE(3983)] = 105541,
  [SMALL_STATE(3984)] = 105551,
  [SMALL_STATE(3985)] = 105561,
  [SMALL_STATE(3986)] = 105571,
  [SMALL_STATE(3987)] = 105581,
  [SMALL_STATE(3988)] = 105591,
  [SMALL_STATE(3989)] = 105601,
  [SMALL_STATE(3990)] = 105611,
  [SMALL_STATE(3991)] = 105621,
  [SMALL_STATE(3992)] = 105631,
  [SMALL_STATE(3993)] = 105641,
  [SMALL_STATE(3994)] = 105651,
  [SMALL_STATE(3995)] = 105661,
  [SMALL_STATE(3996)] = 105671,
  [SMALL_STATE(3997)] = 105679,
  [SMALL_STATE(3998)] = 105689,
  [SMALL_STATE(3999)] = 105699,
  [SMALL_STATE(4000)] = 105709,
  [SMALL_STATE(4001)] = 105719,
  [SMALL_STATE(4002)] = 105729,
  [SMALL_STATE(4003)] = 105739,
  [SMALL_STATE(4004)] = 105749,
  [SMALL_STATE(4005)] = 105759,
  [SMALL_STATE(4006)] = 105769,
  [SMALL_STATE(4007)] = 105779,
  [SMALL_STATE(4008)] = 105789,
  [SMALL_STATE(4009)] = 105799,
  [SMALL_STATE(4010)] = 105809,
  [SMALL_STATE(4011)] = 105819,
  [SMALL_STATE(4012)] = 105829,
  [SMALL_STATE(4013)] = 105839,
  [SMALL_STATE(4014)] = 105849,
  [SMALL_STATE(4015)] = 105859,
  [SMALL_STATE(4016)] = 105869,
  [SMALL_STATE(4017)] = 105879,
  [SMALL_STATE(4018)] = 105889,
  [SMALL_STATE(4019)] = 105899,
  [SMALL_STATE(4020)] = 105909,
  [SMALL_STATE(4021)] = 105919,
  [SMALL_STATE(4022)] = 105929,
  [SMALL_STATE(4023)] = 105939,
  [SMALL_STATE(4024)] = 105949,
  [SMALL_STATE(4025)] = 105959,
  [SMALL_STATE(4026)] = 105969,
  [SMALL_STATE(4027)] = 105979,
  [SMALL_STATE(4028)] = 105989,
  [SMALL_STATE(4029)] = 105999,
  [SMALL_STATE(4030)] = 106009,
  [SMALL_STATE(4031)] = 106019,
  [SMALL_STATE(4032)] = 106029,
  [SMALL_STATE(4033)] = 106039,
  [SMALL_STATE(4034)] = 106049,
  [SMALL_STATE(4035)] = 106059,
  [SMALL_STATE(4036)] = 106069,
  [SMALL_STATE(4037)] = 106079,
  [SMALL_STATE(4038)] = 106089,
  [SMALL_STATE(4039)] = 106099,
  [SMALL_STATE(4040)] = 106107,
  [SMALL_STATE(4041)] = 106117,
  [SMALL_STATE(4042)] = 106127,
  [SMALL_STATE(4043)] = 106137,
  [SMALL_STATE(4044)] = 106147,
  [SMALL_STATE(4045)] = 106157,
  [SMALL_STATE(4046)] = 106165,
  [SMALL_STATE(4047)] = 106173,
  [SMALL_STATE(4048)] = 106183,
  [SMALL_STATE(4049)] = 106193,
  [SMALL_STATE(4050)] = 106201,
  [SMALL_STATE(4051)] = 106209,
  [SMALL_STATE(4052)] = 106217,
  [SMALL_STATE(4053)] = 106227,
  [SMALL_STATE(4054)] = 106237,
  [SMALL_STATE(4055)] = 106247,
  [SMALL_STATE(4056)] = 106257,
  [SMALL_STATE(4057)] = 106267,
  [SMALL_STATE(4058)] = 106277,
  [SMALL_STATE(4059)] = 106287,
  [SMALL_STATE(4060)] = 106297,
  [SMALL_STATE(4061)] = 106307,
  [SMALL_STATE(4062)] = 106317,
  [SMALL_STATE(4063)] = 106327,
  [SMALL_STATE(4064)] = 106337,
  [SMALL_STATE(4065)] = 106347,
  [SMALL_STATE(4066)] = 106357,
  [SMALL_STATE(4067)] = 106367,
  [SMALL_STATE(4068)] = 106377,
  [SMALL_STATE(4069)] = 106387,
  [SMALL_STATE(4070)] = 106397,
  [SMALL_STATE(4071)] = 106407,
  [SMALL_STATE(4072)] = 106417,
  [SMALL_STATE(4073)] = 106427,
  [SMALL_STATE(4074)] = 106437,
  [SMALL_STATE(4075)] = 106445,
  [SMALL_STATE(4076)] = 106453,
  [SMALL_STATE(4077)] = 106461,
  [SMALL_STATE(4078)] = 106471,
  [SMALL_STATE(4079)] = 106479,
  [SMALL_STATE(4080)] = 106487,
  [SMALL_STATE(4081)] = 106495,
  [SMALL_STATE(4082)] = 106505,
  [SMALL_STATE(4083)] = 106513,
  [SMALL_STATE(4084)] = 106523,
  [SMALL_STATE(4085)] = 106533,
  [SMALL_STATE(4086)] = 106541,
  [SMALL_STATE(4087)] = 106551,
  [SMALL_STATE(4088)] = 106559,
  [SMALL_STATE(4089)] = 106569,
  [SMALL_STATE(4090)] = 106577,
  [SMALL_STATE(4091)] = 106585,
  [SMALL_STATE(4092)] = 106595,
  [SMALL_STATE(4093)] = 106605,
  [SMALL_STATE(4094)] = 106615,
  [SMALL_STATE(4095)] = 106623,
  [SMALL_STATE(4096)] = 106633,
  [SMALL_STATE(4097)] = 106643,
  [SMALL_STATE(4098)] = 106651,
  [SMALL_STATE(4099)] = 106661,
  [SMALL_STATE(4100)] = 106671,
  [SMALL_STATE(4101)] = 106681,
  [SMALL_STATE(4102)] = 106691,
  [SMALL_STATE(4103)] = 106701,
  [SMALL_STATE(4104)] = 106709,
  [SMALL_STATE(4105)] = 106719,
  [SMALL_STATE(4106)] = 106727,
  [SMALL_STATE(4107)] = 106735,
  [SMALL_STATE(4108)] = 106745,
  [SMALL_STATE(4109)] = 106755,
  [SMALL_STATE(4110)] = 106765,
  [SMALL_STATE(4111)] = 106775,
  [SMALL_STATE(4112)] = 106785,
  [SMALL_STATE(4113)] = 106795,
  [SMALL_STATE(4114)] = 106805,
  [SMALL_STATE(4115)] = 106815,
  [SMALL_STATE(4116)] = 106825,
  [SMALL_STATE(4117)] = 106835,
  [SMALL_STATE(4118)] = 106845,
  [SMALL_STATE(4119)] = 106855,
  [SMALL_STATE(4120)] = 106865,
  [SMALL_STATE(4121)] = 106875,
  [SMALL_STATE(4122)] = 106883,
  [SMALL_STATE(4123)] = 106891,
  [SMALL_STATE(4124)] = 106901,
  [SMALL_STATE(4125)] = 106911,
  [SMALL_STATE(4126)] = 106921,
  [SMALL_STATE(4127)] = 106929,
  [SMALL_STATE(4128)] = 106939,
  [SMALL_STATE(4129)] = 106949,
  [SMALL_STATE(4130)] = 106959,
  [SMALL_STATE(4131)] = 106969,
  [SMALL_STATE(4132)] = 106977,
  [SMALL_STATE(4133)] = 106987,
  [SMALL_STATE(4134)] = 106997,
  [SMALL_STATE(4135)] = 107005,
  [SMALL_STATE(4136)] = 107015,
  [SMALL_STATE(4137)] = 107023,
  [SMALL_STATE(4138)] = 107031,
  [SMALL_STATE(4139)] = 107041,
  [SMALL_STATE(4140)] = 107051,
  [SMALL_STATE(4141)] = 107061,
  [SMALL_STATE(4142)] = 107071,
  [SMALL_STATE(4143)] = 107081,
  [SMALL_STATE(4144)] = 107091,
  [SMALL_STATE(4145)] = 107101,
  [SMALL_STATE(4146)] = 107109,
  [SMALL_STATE(4147)] = 107119,
  [SMALL_STATE(4148)] = 107129,
  [SMALL_STATE(4149)] = 107139,
  [SMALL_STATE(4150)] = 107149,
  [SMALL_STATE(4151)] = 107159,
  [SMALL_STATE(4152)] = 107169,
  [SMALL_STATE(4153)] = 107177,
  [SMALL_STATE(4154)] = 107187,
  [SMALL_STATE(4155)] = 107197,
  [SMALL_STATE(4156)] = 107205,
  [SMALL_STATE(4157)] = 107213,
  [SMALL_STATE(4158)] = 107221,
  [SMALL_STATE(4159)] = 107229,
  [SMALL_STATE(4160)] = 107239,
  [SMALL_STATE(4161)] = 107247,
  [SMALL_STATE(4162)] = 107257,
  [SMALL_STATE(4163)] = 107267,
  [SMALL_STATE(4164)] = 107277,
  [SMALL_STATE(4165)] = 107287,
  [SMALL_STATE(4166)] = 107295,
  [SMALL_STATE(4167)] = 107305,
  [SMALL_STATE(4168)] = 107315,
  [SMALL_STATE(4169)] = 107325,
  [SMALL_STATE(4170)] = 107333,
  [SMALL_STATE(4171)] = 107341,
  [SMALL_STATE(4172)] = 107351,
  [SMALL_STATE(4173)] = 107361,
  [SMALL_STATE(4174)] = 107369,
  [SMALL_STATE(4175)] = 107377,
  [SMALL_STATE(4176)] = 107387,
  [SMALL_STATE(4177)] = 107397,
  [SMALL_STATE(4178)] = 107407,
  [SMALL_STATE(4179)] = 107417,
  [SMALL_STATE(4180)] = 107427,
  [SMALL_STATE(4181)] = 107437,
  [SMALL_STATE(4182)] = 107447,
  [SMALL_STATE(4183)] = 107457,
  [SMALL_STATE(4184)] = 107467,
  [SMALL_STATE(4185)] = 107475,
  [SMALL_STATE(4186)] = 107485,
  [SMALL_STATE(4187)] = 107495,
  [SMALL_STATE(4188)] = 107505,
  [SMALL_STATE(4189)] = 107515,
  [SMALL_STATE(4190)] = 107525,
  [SMALL_STATE(4191)] = 107535,
  [SMALL_STATE(4192)] = 107545,
  [SMALL_STATE(4193)] = 107555,
  [SMALL_STATE(4194)] = 107565,
  [SMALL_STATE(4195)] = 107575,
  [SMALL_STATE(4196)] = 107585,
  [SMALL_STATE(4197)] = 107595,
  [SMALL_STATE(4198)] = 107605,
  [SMALL_STATE(4199)] = 107615,
  [SMALL_STATE(4200)] = 107625,
  [SMALL_STATE(4201)] = 107633,
  [SMALL_STATE(4202)] = 107641,
  [SMALL_STATE(4203)] = 107651,
  [SMALL_STATE(4204)] = 107661,
  [SMALL_STATE(4205)] = 107671,
  [SMALL_STATE(4206)] = 107681,
  [SMALL_STATE(4207)] = 107691,
  [SMALL_STATE(4208)] = 107701,
  [SMALL_STATE(4209)] = 107709,
  [SMALL_STATE(4210)] = 107719,
  [SMALL_STATE(4211)] = 107727,
  [SMALL_STATE(4212)] = 107737,
  [SMALL_STATE(4213)] = 107747,
  [SMALL_STATE(4214)] = 107757,
  [SMALL_STATE(4215)] = 107767,
  [SMALL_STATE(4216)] = 107777,
  [SMALL_STATE(4217)] = 107787,
  [SMALL_STATE(4218)] = 107797,
  [SMALL_STATE(4219)] = 107807,
  [SMALL_STATE(4220)] = 107817,
  [SMALL_STATE(4221)] = 107827,
  [SMALL_STATE(4222)] = 107835,
  [SMALL_STATE(4223)] = 107845,
  [SMALL_STATE(4224)] = 107855,
  [SMALL_STATE(4225)] = 107865,
  [SMALL_STATE(4226)] = 107875,
  [SMALL_STATE(4227)] = 107885,
  [SMALL_STATE(4228)] = 107893,
  [SMALL_STATE(4229)] = 107903,
  [SMALL_STATE(4230)] = 107913,
  [SMALL_STATE(4231)] = 107923,
  [SMALL_STATE(4232)] = 107933,
  [SMALL_STATE(4233)] = 107943,
  [SMALL_STATE(4234)] = 107953,
  [SMALL_STATE(4235)] = 107963,
  [SMALL_STATE(4236)] = 107973,
  [SMALL_STATE(4237)] = 107983,
  [SMALL_STATE(4238)] = 107993,
  [SMALL_STATE(4239)] = 108003,
  [SMALL_STATE(4240)] = 108013,
  [SMALL_STATE(4241)] = 108023,
  [SMALL_STATE(4242)] = 108031,
  [SMALL_STATE(4243)] = 108041,
  [SMALL_STATE(4244)] = 108051,
  [SMALL_STATE(4245)] = 108061,
  [SMALL_STATE(4246)] = 108071,
  [SMALL_STATE(4247)] = 108081,
  [SMALL_STATE(4248)] = 108091,
  [SMALL_STATE(4249)] = 108099,
  [SMALL_STATE(4250)] = 108109,
  [SMALL_STATE(4251)] = 108119,
  [SMALL_STATE(4252)] = 108127,
  [SMALL_STATE(4253)] = 108137,
  [SMALL_STATE(4254)] = 108147,
  [SMALL_STATE(4255)] = 108155,
  [SMALL_STATE(4256)] = 108165,
  [SMALL_STATE(4257)] = 108175,
  [SMALL_STATE(4258)] = 108185,
  [SMALL_STATE(4259)] = 108195,
  [SMALL_STATE(4260)] = 108205,
  [SMALL_STATE(4261)] = 108215,
  [SMALL_STATE(4262)] = 108225,
  [SMALL_STATE(4263)] = 108235,
  [SMALL_STATE(4264)] = 108245,
  [SMALL_STATE(4265)] = 108255,
  [SMALL_STATE(4266)] = 108265,
  [SMALL_STATE(4267)] = 108275,
  [SMALL_STATE(4268)] = 108283,
  [SMALL_STATE(4269)] = 108293,
  [SMALL_STATE(4270)] = 108301,
  [SMALL_STATE(4271)] = 108311,
  [SMALL_STATE(4272)] = 108319,
  [SMALL_STATE(4273)] = 108327,
  [SMALL_STATE(4274)] = 108335,
  [SMALL_STATE(4275)] = 108345,
  [SMALL_STATE(4276)] = 108353,
  [SMALL_STATE(4277)] = 108363,
  [SMALL_STATE(4278)] = 108373,
  [SMALL_STATE(4279)] = 108381,
  [SMALL_STATE(4280)] = 108391,
  [SMALL_STATE(4281)] = 108401,
  [SMALL_STATE(4282)] = 108411,
  [SMALL_STATE(4283)] = 108419,
  [SMALL_STATE(4284)] = 108429,
  [SMALL_STATE(4285)] = 108439,
  [SMALL_STATE(4286)] = 108447,
  [SMALL_STATE(4287)] = 108454,
  [SMALL_STATE(4288)] = 108461,
  [SMALL_STATE(4289)] = 108468,
  [SMALL_STATE(4290)] = 108475,
  [SMALL_STATE(4291)] = 108482,
  [SMALL_STATE(4292)] = 108489,
  [SMALL_STATE(4293)] = 108496,
  [SMALL_STATE(4294)] = 108503,
  [SMALL_STATE(4295)] = 108510,
  [SMALL_STATE(4296)] = 108517,
  [SMALL_STATE(4297)] = 108524,
  [SMALL_STATE(4298)] = 108531,
  [SMALL_STATE(4299)] = 108538,
  [SMALL_STATE(4300)] = 108545,
  [SMALL_STATE(4301)] = 108552,
  [SMALL_STATE(4302)] = 108559,
  [SMALL_STATE(4303)] = 108566,
  [SMALL_STATE(4304)] = 108573,
  [SMALL_STATE(4305)] = 108580,
  [SMALL_STATE(4306)] = 108587,
  [SMALL_STATE(4307)] = 108594,
  [SMALL_STATE(4308)] = 108601,
  [SMALL_STATE(4309)] = 108608,
  [SMALL_STATE(4310)] = 108615,
  [SMALL_STATE(4311)] = 108622,
  [SMALL_STATE(4312)] = 108629,
  [SMALL_STATE(4313)] = 108636,
  [SMALL_STATE(4314)] = 108643,
  [SMALL_STATE(4315)] = 108650,
  [SMALL_STATE(4316)] = 108657,
  [SMALL_STATE(4317)] = 108664,
  [SMALL_STATE(4318)] = 108671,
  [SMALL_STATE(4319)] = 108678,
  [SMALL_STATE(4320)] = 108685,
  [SMALL_STATE(4321)] = 108692,
  [SMALL_STATE(4322)] = 108699,
  [SMALL_STATE(4323)] = 108706,
  [SMALL_STATE(4324)] = 108713,
  [SMALL_STATE(4325)] = 108720,
  [SMALL_STATE(4326)] = 108727,
  [SMALL_STATE(4327)] = 108734,
  [SMALL_STATE(4328)] = 108741,
  [SMALL_STATE(4329)] = 108748,
  [SMALL_STATE(4330)] = 108755,
  [SMALL_STATE(4331)] = 108762,
  [SMALL_STATE(4332)] = 108769,
  [SMALL_STATE(4333)] = 108776,
  [SMALL_STATE(4334)] = 108783,
  [SMALL_STATE(4335)] = 108790,
  [SMALL_STATE(4336)] = 108797,
  [SMALL_STATE(4337)] = 108804,
  [SMALL_STATE(4338)] = 108811,
  [SMALL_STATE(4339)] = 108818,
  [SMALL_STATE(4340)] = 108825,
  [SMALL_STATE(4341)] = 108832,
  [SMALL_STATE(4342)] = 108839,
  [SMALL_STATE(4343)] = 108846,
  [SMALL_STATE(4344)] = 108853,
  [SMALL_STATE(4345)] = 108860,
  [SMALL_STATE(4346)] = 108867,
  [SMALL_STATE(4347)] = 108874,
  [SMALL_STATE(4348)] = 108881,
  [SMALL_STATE(4349)] = 108888,
  [SMALL_STATE(4350)] = 108895,
  [SMALL_STATE(4351)] = 108902,
  [SMALL_STATE(4352)] = 108909,
  [SMALL_STATE(4353)] = 108916,
  [SMALL_STATE(4354)] = 108923,
  [SMALL_STATE(4355)] = 108930,
  [SMALL_STATE(4356)] = 108937,
  [SMALL_STATE(4357)] = 108944,
  [SMALL_STATE(4358)] = 108951,
  [SMALL_STATE(4359)] = 108958,
  [SMALL_STATE(4360)] = 108965,
  [SMALL_STATE(4361)] = 108972,
  [SMALL_STATE(4362)] = 108979,
  [SMALL_STATE(4363)] = 108986,
  [SMALL_STATE(4364)] = 108993,
  [SMALL_STATE(4365)] = 109000,
  [SMALL_STATE(4366)] = 109007,
  [SMALL_STATE(4367)] = 109014,
  [SMALL_STATE(4368)] = 109021,
  [SMALL_STATE(4369)] = 109028,
  [SMALL_STATE(4370)] = 109035,
  [SMALL_STATE(4371)] = 109042,
  [SMALL_STATE(4372)] = 109049,
  [SMALL_STATE(4373)] = 109056,
  [SMALL_STATE(4374)] = 109063,
  [SMALL_STATE(4375)] = 109070,
  [SMALL_STATE(4376)] = 109077,
  [SMALL_STATE(4377)] = 109084,
  [SMALL_STATE(4378)] = 109091,
  [SMALL_STATE(4379)] = 109098,
  [SMALL_STATE(4380)] = 109105,
  [SMALL_STATE(4381)] = 109112,
  [SMALL_STATE(4382)] = 109119,
  [SMALL_STATE(4383)] = 109126,
  [SMALL_STATE(4384)] = 109133,
  [SMALL_STATE(4385)] = 109140,
  [SMALL_STATE(4386)] = 109147,
  [SMALL_STATE(4387)] = 109154,
  [SMALL_STATE(4388)] = 109161,
  [SMALL_STATE(4389)] = 109168,
  [SMALL_STATE(4390)] = 109175,
  [SMALL_STATE(4391)] = 109182,
  [SMALL_STATE(4392)] = 109189,
  [SMALL_STATE(4393)] = 109196,
  [SMALL_STATE(4394)] = 109203,
  [SMALL_STATE(4395)] = 109210,
  [SMALL_STATE(4396)] = 109217,
  [SMALL_STATE(4397)] = 109224,
  [SMALL_STATE(4398)] = 109231,
  [SMALL_STATE(4399)] = 109238,
  [SMALL_STATE(4400)] = 109245,
  [SMALL_STATE(4401)] = 109252,
  [SMALL_STATE(4402)] = 109259,
  [SMALL_STATE(4403)] = 109266,
  [SMALL_STATE(4404)] = 109273,
  [SMALL_STATE(4405)] = 109280,
  [SMALL_STATE(4406)] = 109287,
  [SMALL_STATE(4407)] = 109294,
  [SMALL_STATE(4408)] = 109301,
  [SMALL_STATE(4409)] = 109308,
  [SMALL_STATE(4410)] = 109315,
  [SMALL_STATE(4411)] = 109322,
  [SMALL_STATE(4412)] = 109329,
  [SMALL_STATE(4413)] = 109336,
  [SMALL_STATE(4414)] = 109343,
  [SMALL_STATE(4415)] = 109350,
  [SMALL_STATE(4416)] = 109357,
  [SMALL_STATE(4417)] = 109364,
  [SMALL_STATE(4418)] = 109371,
  [SMALL_STATE(4419)] = 109378,
  [SMALL_STATE(4420)] = 109385,
  [SMALL_STATE(4421)] = 109392,
  [SMALL_STATE(4422)] = 109399,
  [SMALL_STATE(4423)] = 109406,
  [SMALL_STATE(4424)] = 109413,
  [SMALL_STATE(4425)] = 109420,
  [SMALL_STATE(4426)] = 109427,
  [SMALL_STATE(4427)] = 109434,
  [SMALL_STATE(4428)] = 109441,
  [SMALL_STATE(4429)] = 109448,
  [SMALL_STATE(4430)] = 109455,
  [SMALL_STATE(4431)] = 109462,
  [SMALL_STATE(4432)] = 109469,
  [SMALL_STATE(4433)] = 109476,
  [SMALL_STATE(4434)] = 109483,
  [SMALL_STATE(4435)] = 109490,
  [SMALL_STATE(4436)] = 109497,
  [SMALL_STATE(4437)] = 109504,
  [SMALL_STATE(4438)] = 109511,
  [SMALL_STATE(4439)] = 109518,
  [SMALL_STATE(4440)] = 109525,
  [SMALL_STATE(4441)] = 109532,
  [SMALL_STATE(4442)] = 109539,
  [SMALL_STATE(4443)] = 109546,
  [SMALL_STATE(4444)] = 109553,
  [SMALL_STATE(4445)] = 109560,
  [SMALL_STATE(4446)] = 109567,
  [SMALL_STATE(4447)] = 109574,
  [SMALL_STATE(4448)] = 109581,
  [SMALL_STATE(4449)] = 109588,
  [SMALL_STATE(4450)] = 109595,
  [SMALL_STATE(4451)] = 109602,
  [SMALL_STATE(4452)] = 109609,
  [SMALL_STATE(4453)] = 109616,
  [SMALL_STATE(4454)] = 109623,
  [SMALL_STATE(4455)] = 109630,
  [SMALL_STATE(4456)] = 109637,
  [SMALL_STATE(4457)] = 109644,
  [SMALL_STATE(4458)] = 109651,
  [SMALL_STATE(4459)] = 109658,
  [SMALL_STATE(4460)] = 109665,
  [SMALL_STATE(4461)] = 109672,
  [SMALL_STATE(4462)] = 109679,
  [SMALL_STATE(4463)] = 109686,
  [SMALL_STATE(4464)] = 109693,
  [SMALL_STATE(4465)] = 109700,
  [SMALL_STATE(4466)] = 109707,
  [SMALL_STATE(4467)] = 109714,
  [SMALL_STATE(4468)] = 109721,
  [SMALL_STATE(4469)] = 109728,
  [SMALL_STATE(4470)] = 109735,
  [SMALL_STATE(4471)] = 109742,
  [SMALL_STATE(4472)] = 109749,
  [SMALL_STATE(4473)] = 109756,
  [SMALL_STATE(4474)] = 109763,
  [SMALL_STATE(4475)] = 109770,
  [SMALL_STATE(4476)] = 109777,
  [SMALL_STATE(4477)] = 109784,
  [SMALL_STATE(4478)] = 109791,
  [SMALL_STATE(4479)] = 109798,
  [SMALL_STATE(4480)] = 109805,
  [SMALL_STATE(4481)] = 109812,
  [SMALL_STATE(4482)] = 109819,
  [SMALL_STATE(4483)] = 109826,
  [SMALL_STATE(4484)] = 109833,
  [SMALL_STATE(4485)] = 109840,
  [SMALL_STATE(4486)] = 109847,
  [SMALL_STATE(4487)] = 109854,
  [SMALL_STATE(4488)] = 109861,
  [SMALL_STATE(4489)] = 109868,
  [SMALL_STATE(4490)] = 109875,
  [SMALL_STATE(4491)] = 109882,
  [SMALL_STATE(4492)] = 109889,
  [SMALL_STATE(4493)] = 109896,
  [SMALL_STATE(4494)] = 109903,
  [SMALL_STATE(4495)] = 109910,
  [SMALL_STATE(4496)] = 109917,
  [SMALL_STATE(4497)] = 109924,
  [SMALL_STATE(4498)] = 109931,
  [SMALL_STATE(4499)] = 109938,
  [SMALL_STATE(4500)] = 109945,
  [SMALL_STATE(4501)] = 109952,
  [SMALL_STATE(4502)] = 109959,
  [SMALL_STATE(4503)] = 109966,
  [SMALL_STATE(4504)] = 109973,
  [SMALL_STATE(4505)] = 109980,
  [SMALL_STATE(4506)] = 109987,
  [SMALL_STATE(4507)] = 109994,
  [SMALL_STATE(4508)] = 110001,
  [SMALL_STATE(4509)] = 110008,
  [SMALL_STATE(4510)] = 110015,
  [SMALL_STATE(4511)] = 110022,
  [SMALL_STATE(4512)] = 110029,
  [SMALL_STATE(4513)] = 110036,
  [SMALL_STATE(4514)] = 110043,
  [SMALL_STATE(4515)] = 110050,
  [SMALL_STATE(4516)] = 110057,
  [SMALL_STATE(4517)] = 110064,
  [SMALL_STATE(4518)] = 110071,
  [SMALL_STATE(4519)] = 110078,
  [SMALL_STATE(4520)] = 110085,
  [SMALL_STATE(4521)] = 110092,
  [SMALL_STATE(4522)] = 110099,
  [SMALL_STATE(4523)] = 110106,
  [SMALL_STATE(4524)] = 110113,
  [SMALL_STATE(4525)] = 110120,
  [SMALL_STATE(4526)] = 110127,
  [SMALL_STATE(4527)] = 110134,
  [SMALL_STATE(4528)] = 110141,
  [SMALL_STATE(4529)] = 110148,
  [SMALL_STATE(4530)] = 110155,
  [SMALL_STATE(4531)] = 110162,
  [SMALL_STATE(4532)] = 110169,
  [SMALL_STATE(4533)] = 110176,
  [SMALL_STATE(4534)] = 110183,
  [SMALL_STATE(4535)] = 110190,
  [SMALL_STATE(4536)] = 110197,
  [SMALL_STATE(4537)] = 110204,
  [SMALL_STATE(4538)] = 110211,
  [SMALL_STATE(4539)] = 110218,
  [SMALL_STATE(4540)] = 110225,
  [SMALL_STATE(4541)] = 110232,
  [SMALL_STATE(4542)] = 110239,
  [SMALL_STATE(4543)] = 110246,
  [SMALL_STATE(4544)] = 110253,
  [SMALL_STATE(4545)] = 110260,
  [SMALL_STATE(4546)] = 110267,
  [SMALL_STATE(4547)] = 110274,
  [SMALL_STATE(4548)] = 110281,
  [SMALL_STATE(4549)] = 110288,
  [SMALL_STATE(4550)] = 110295,
  [SMALL_STATE(4551)] = 110302,
  [SMALL_STATE(4552)] = 110309,
  [SMALL_STATE(4553)] = 110316,
  [SMALL_STATE(4554)] = 110323,
  [SMALL_STATE(4555)] = 110330,
  [SMALL_STATE(4556)] = 110337,
  [SMALL_STATE(4557)] = 110344,
  [SMALL_STATE(4558)] = 110351,
  [SMALL_STATE(4559)] = 110358,
  [SMALL_STATE(4560)] = 110365,
  [SMALL_STATE(4561)] = 110372,
  [SMALL_STATE(4562)] = 110379,
  [SMALL_STATE(4563)] = 110386,
  [SMALL_STATE(4564)] = 110393,
  [SMALL_STATE(4565)] = 110400,
  [SMALL_STATE(4566)] = 110407,
  [SMALL_STATE(4567)] = 110414,
  [SMALL_STATE(4568)] = 110421,
  [SMALL_STATE(4569)] = 110428,
  [SMALL_STATE(4570)] = 110435,
  [SMALL_STATE(4571)] = 110442,
  [SMALL_STATE(4572)] = 110449,
  [SMALL_STATE(4573)] = 110456,
  [SMALL_STATE(4574)] = 110463,
  [SMALL_STATE(4575)] = 110470,
  [SMALL_STATE(4576)] = 110477,
  [SMALL_STATE(4577)] = 110484,
  [SMALL_STATE(4578)] = 110491,
  [SMALL_STATE(4579)] = 110498,
  [SMALL_STATE(4580)] = 110505,
  [SMALL_STATE(4581)] = 110512,
  [SMALL_STATE(4582)] = 110519,
  [SMALL_STATE(4583)] = 110526,
  [SMALL_STATE(4584)] = 110533,
  [SMALL_STATE(4585)] = 110540,
  [SMALL_STATE(4586)] = 110547,
  [SMALL_STATE(4587)] = 110554,
  [SMALL_STATE(4588)] = 110561,
  [SMALL_STATE(4589)] = 110568,
  [SMALL_STATE(4590)] = 110575,
  [SMALL_STATE(4591)] = 110582,
  [SMALL_STATE(4592)] = 110589,
  [SMALL_STATE(4593)] = 110596,
  [SMALL_STATE(4594)] = 110603,
  [SMALL_STATE(4595)] = 110610,
  [SMALL_STATE(4596)] = 110617,
  [SMALL_STATE(4597)] = 110624,
  [SMALL_STATE(4598)] = 110631,
  [SMALL_STATE(4599)] = 110638,
  [SMALL_STATE(4600)] = 110645,
  [SMALL_STATE(4601)] = 110652,
  [SMALL_STATE(4602)] = 110659,
  [SMALL_STATE(4603)] = 110666,
  [SMALL_STATE(4604)] = 110673,
  [SMALL_STATE(4605)] = 110680,
  [SMALL_STATE(4606)] = 110687,
  [SMALL_STATE(4607)] = 110694,
  [SMALL_STATE(4608)] = 110701,
  [SMALL_STATE(4609)] = 110708,
  [SMALL_STATE(4610)] = 110715,
  [SMALL_STATE(4611)] = 110722,
  [SMALL_STATE(4612)] = 110729,
  [SMALL_STATE(4613)] = 110736,
  [SMALL_STATE(4614)] = 110743,
  [SMALL_STATE(4615)] = 110750,
  [SMALL_STATE(4616)] = 110757,
  [SMALL_STATE(4617)] = 110764,
  [SMALL_STATE(4618)] = 110771,
  [SMALL_STATE(4619)] = 110778,
  [SMALL_STATE(4620)] = 110785,
  [SMALL_STATE(4621)] = 110792,
  [SMALL_STATE(4622)] = 110799,
  [SMALL_STATE(4623)] = 110806,
  [SMALL_STATE(4624)] = 110813,
  [SMALL_STATE(4625)] = 110820,
  [SMALL_STATE(4626)] = 110827,
  [SMALL_STATE(4627)] = 110834,
  [SMALL_STATE(4628)] = 110841,
  [SMALL_STATE(4629)] = 110848,
  [SMALL_STATE(4630)] = 110855,
  [SMALL_STATE(4631)] = 110862,
  [SMALL_STATE(4632)] = 110869,
  [SMALL_STATE(4633)] = 110876,
  [SMALL_STATE(4634)] = 110883,
  [SMALL_STATE(4635)] = 110890,
  [SMALL_STATE(4636)] = 110897,
  [SMALL_STATE(4637)] = 110904,
  [SMALL_STATE(4638)] = 110911,
  [SMALL_STATE(4639)] = 110918,
  [SMALL_STATE(4640)] = 110925,
  [SMALL_STATE(4641)] = 110932,
  [SMALL_STATE(4642)] = 110939,
  [SMALL_STATE(4643)] = 110946,
  [SMALL_STATE(4644)] = 110953,
  [SMALL_STATE(4645)] = 110960,
  [SMALL_STATE(4646)] = 110967,
  [SMALL_STATE(4647)] = 110974,
  [SMALL_STATE(4648)] = 110981,
  [SMALL_STATE(4649)] = 110988,
  [SMALL_STATE(4650)] = 110995,
  [SMALL_STATE(4651)] = 111002,
  [SMALL_STATE(4652)] = 111009,
  [SMALL_STATE(4653)] = 111016,
  [SMALL_STATE(4654)] = 111023,
  [SMALL_STATE(4655)] = 111030,
  [SMALL_STATE(4656)] = 111037,
  [SMALL_STATE(4657)] = 111044,
  [SMALL_STATE(4658)] = 111051,
  [SMALL_STATE(4659)] = 111058,
  [SMALL_STATE(4660)] = 111065,
  [SMALL_STATE(4661)] = 111072,
  [SMALL_STATE(4662)] = 111079,
  [SMALL_STATE(4663)] = 111086,
  [SMALL_STATE(4664)] = 111093,
  [SMALL_STATE(4665)] = 111100,
  [SMALL_STATE(4666)] = 111107,
  [SMALL_STATE(4667)] = 111114,
  [SMALL_STATE(4668)] = 111121,
  [SMALL_STATE(4669)] = 111128,
  [SMALL_STATE(4670)] = 111135,
  [SMALL_STATE(4671)] = 111142,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [23] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [27] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 9),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [33] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(420),
  [36] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [38] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [40] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [42] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 9), SHIFT(406),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [51] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4592),
  [54] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [56] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [58] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [60] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [62] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9),
  [64] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [66] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 9),
  [68] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [70] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [72] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [74] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [76] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [78] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [80] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [82] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(430),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4567),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 9),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4299),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1213),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1355),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(7),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1352),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(379),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1640),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3044),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3055),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3019),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(379),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4234),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4235),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3766),
  [339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(89),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(383),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4237),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(49),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4239),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4240),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3762),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3758),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4251),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(188),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(216),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(654),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(85),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(108),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3996),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1088),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4399),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2895),
  [395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(541),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3084),
  [401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(251),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(333),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3609),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3608),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3161),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2149),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2149),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2148),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3795),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1374),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(492),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1313),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1302),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4299),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4288),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4295),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3128),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 275),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 275),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 59),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 59),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 58),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 58),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(92),
  [573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(115),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(1088),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 9),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4592),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4598),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym_rest_pattern, 2, .production_id = 50),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 50),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [1154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1161] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2828),
  [1165] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2606),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4590),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [1198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(94),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4007),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4587),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 16),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 16),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 16),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 16),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 103),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 103),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 103),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 103),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 42),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 42),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 42),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 42),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4356),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [1284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(4361),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 148),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 148),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 6),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 6),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 6),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 6),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 115),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 115),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 115),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 115),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 192),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 192),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 192),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 192),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 57),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 57),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_body, 3, .production_id = 40),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_body, 3, .production_id = 40),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 144),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 144),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 144),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 144),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 193),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 193),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 111),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 111),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 111),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 111),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 88),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 6, .production_id = 88),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 88),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 6, .production_id = 88),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_body, 2),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_body, 2),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 44),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 44),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 44),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 44),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 152),
  [1419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 152),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 152),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 152),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 18),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 18),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 18),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 18),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 102),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 102),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 102),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 102),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 148),
  [1457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 148),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 148),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 148),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 153),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 153),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 153),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 153),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4521),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [1617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(4611),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(3227),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(3326),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [1664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym__property_name, 1, .production_id = 20),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(51),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym__property_name, 1, .production_id = 20),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 20),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(2492),
  [1710] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(94),
  [1714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(397),
  [1717] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(4007),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 93),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 93),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 69),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 69),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 11),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 11),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [1747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [1769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 68),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 68),
  [1773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 114),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 114),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 150),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 150),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4569),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2562),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2617),
  [1833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1428),
  [1836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41),
  [1838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3226),
  [1841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(72),
  [1844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1005),
  [1847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4007),
  [1850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4581),
  [1853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3640),
  [1856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1241),
  [1859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1236),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4574),
  [1865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2575),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3577),
  [1871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3582),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3404),
  [1877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2607),
  [1880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2624),
  [1883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2607),
  [1886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1039),
  [1889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1224),
  [1892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4544),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4569),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1221),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4568),
  [1904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4567),
  [1907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1218),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1428),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4015),
  [1916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4016),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4564),
  [1922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4563),
  [1925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4562),
  [1928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2520),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2568),
  [1962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2617),
  [1965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1428),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41),
  [1970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3226),
  [1973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(72),
  [1976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1005),
  [1979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4007),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4581),
  [1985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3640),
  [1988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1241),
  [1991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1236),
  [1994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4574),
  [1997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2575),
  [2000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3577),
  [2003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3582),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3404),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2607),
  [2012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2624),
  [2015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2607),
  [2018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4021),
  [2021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1224),
  [2024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1221),
  [2027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4568),
  [2030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4567),
  [2033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1218),
  [2036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1428),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(3978),
  [2042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4564),
  [2045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4563),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(4562),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 41), SHIFT_REPEAT(2501),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path_segment, 1), SHIFT(547),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path_segment, 1),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path_segment, 1),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [2071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_import_path_segment, 1), SHIFT(547),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4526),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 50),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4377),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 25),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 25),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3993),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), SHIFT(275),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [2119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path_segment, 2), SHIFT(558),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path_segment, 2),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path_segment, 2),
  [2126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_import_path_segment, 2), SHIFT(558),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 1),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 3, .production_id = 2),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 3, .production_id = 2),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(558),
  [2150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2),
  [2154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(558),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2),
  [2161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2), SHIFT_REPEAT(4101),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, .production_id = 2),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2, .production_id = 2),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 7, .production_id = 88),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 7, .production_id = 88),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 181),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 181),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 7),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 7),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4488),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 42),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 42),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 44),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 44),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 7, .production_id = 89),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 7, .production_id = 89),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4633),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 6, .production_id = 45),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 6, .production_id = 45),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 18),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 18),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 16),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 16),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 4, .production_id = 8),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 4, .production_id = 8),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_as, 2),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_as, 2),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 26),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 26),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 3, .production_id = 4),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 3, .production_id = 4),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 5, .production_id = 19),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 5, .production_id = 19),
  [2258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path, 1, .production_id = 2), SHIFT(560),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1, .production_id = 2),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 1, .production_id = 2),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 6),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 6),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 66),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 66),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 32),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 32),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 72),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 72),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 25),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 25),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 66),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 66),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 149),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 149),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_listener_declaration, 6, .production_id = 211),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_listener_declaration, 6, .production_id = 211),
  [2357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [2361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 289),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 289),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [2369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 107),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 107),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 21),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 21),
  [2383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 65),
  [2385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 65),
  [2387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 278),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 278),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 47),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 47),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_expression_initializer, 2, .production_id = 58),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_expression_initializer, 2, .production_id = 58),
  [2415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 21),
  [2425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 21),
  [2427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 177),
  [2433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 177),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 13),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13),
  [2447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [2449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment_expression, 1),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment_expression, 1),
  [2457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 33),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 33),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 128),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 128),
  [2469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 214),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 214),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 256),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 256),
  [2477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 159),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 159),
  [2489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 82),
  [2491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 82),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 82),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 182),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 182),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 180),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 180),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 37),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 37),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 144),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 144),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 236),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 236),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 179),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 179),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [2558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 51),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 51),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 136),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 136),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 136),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 136),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 261),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 261),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 234),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 234),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 21),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 21),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 35),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 35),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [2614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [2616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 36),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 36),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 262),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 262),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 263),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 263),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 124),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 124),
  [2652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 38),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 38),
  [2656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 151),
  [2658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 151),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [2664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 144),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 144),
  [2672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 48),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 48),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 49),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 213),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 213),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 235),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 235),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 240),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 240),
  [2694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 212),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 212),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 3, .production_id = 7),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 7),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 7), SHIFT(134),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 176),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 176),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 102),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 102),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 5),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 5),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 78),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 78),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 79),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 79),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 14),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 14),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 237),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 237),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 178),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 178),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 34),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 34),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 87),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 87),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [2769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [2771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [2775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 148),
  [2777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 148),
  [2779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 111),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 111),
  [2791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 176),
  [2793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 176),
  [2795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 233),
  [2797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 233),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 103),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 103),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 126),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 126),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, .production_id = 208),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, .production_id = 208),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 183),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 183),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 184),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 184),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 184),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 184),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 175),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 175),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 204),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 204),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 11),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 11),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 259),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 259),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 148),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 148),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 37),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 37),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 25),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 25),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 215),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 215),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 203),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 203),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 253),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 253),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 125),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 125),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 202),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 202),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 201),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 201),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 168),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 168),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 127),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 127),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 129),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 129),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 130),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 130),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 277),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 277),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 131),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 131),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 171),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 171),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 6),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 6),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 118),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 118),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 133),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 133),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 2, .production_id = 7),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 7),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 7), SHIFT(134),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 192),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 192),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 170),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 170),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 279),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 279),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 57),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 57),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 259),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 259),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 261),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 261),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 280),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 280),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 257),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 257),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 185),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 185),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 63),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 63),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 114),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 114),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 216),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 216),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [3080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 166),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 166),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 102),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 102),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 103),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 103),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [3096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 167),
  [3098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 167),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tripple_tagged_component_expression, 2, .production_id = 7),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tripple_tagged_component_expression, 2, .production_id = 7),
  [3104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, .production_id = 28),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, .production_id = 28),
  [3108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tripple_tagged_component_expression, 3, .production_id = 7),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tripple_tagged_component_expression, 3, .production_id = 7),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 25),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 25),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tagged_component_expression, 3, .production_id = 7),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tagged_component_expression, 3, .production_id = 7),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tripple_tagged_type_string, 2),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tripple_tagged_type_string, 2),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 48),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 48),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tripple_tagged_type_string, 3),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tripple_tagged_type_string, 3),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tagged_type_string, 2),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tagged_type_string, 2),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 100),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 100),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 4, .production_id = 43),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 4, .production_id = 43),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 59),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 59),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tagged_type_string, 3),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tagged_type_string, 3),
  [3164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_body, 3, .production_id = 40),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_body, 3, .production_id = 40),
  [3168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 106),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 106),
  [3176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 62),
  [3178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 62),
  [3180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 108),
  [3182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 108),
  [3184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 108),
  [3190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 108),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 25),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 25),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 112),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 112),
  [3200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 61),
  [3202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 61),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tagged_component_expression, 2, .production_id = 7),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tagged_component_expression, 2, .production_id = 7),
  [3208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 113),
  [3210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 113),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 74),
  [3214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 74),
  [3216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 116),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 116),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 117),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 117),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 74),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 74),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 60),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 60),
  [3236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 5),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 5),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 155),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 155),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 59),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 59),
  [3248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 154),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 154),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 116),
  [3258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 116),
  [3260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 27),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 27),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 147),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 147),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, .production_id = 71),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, .production_id = 71),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 70),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 70),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 3, .production_id = 17),
  [3282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 17),
  [3284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_body, 2),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_body, 2),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [3356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 288),
  [3358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 288),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 254),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 254),
  [3386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 255),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 255),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 276),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 276),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 20),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [3401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 20),
  [3404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4611),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [3417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3423] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(323),
  [3430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1246),
  [3436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4396),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [3460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1252),
  [3463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4480),
  [3466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(4198),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4628),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [3521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [3545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4664),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [3573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [3598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3569),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4668),
  [3617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [3621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [3627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3636),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [3675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [3697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4621),
  [3705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3725] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_rest_pattern, 2),
  [3729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [3823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(284),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2788),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [3953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym_predefined_type, 1),
  [3956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym_predefined_type, 1),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [3963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [3978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3),
  [3982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3), SHIFT_REPEAT(3804),
  [3985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [3993] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 9), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 50),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3), SHIFT(2898),
  [4002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3), SHIFT(3144),
  [4005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 5),
  [4007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 5),
  [4009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 11),
  [4011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 11),
  [4013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 1, .production_id = 1),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 1, .production_id = 1),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [4019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration_name, 1),
  [4021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration_name, 1),
  [4023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 2, .production_id = 39),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 2, .production_id = 39),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [4031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 3, .production_id = 84),
  [4033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 3, .production_id = 84),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [4061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 2, .production_id = 37),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 2, .production_id = 37),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 7), SHIFT(130),
  [4074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 7), SHIFT(130),
  [4077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 3, .production_id = 83),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 3, .production_id = 83),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 173),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 173),
  [4099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 6, .production_id = 196),
  [4101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 6, .production_id = 196),
  [4103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 134),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 134),
  [4107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 205),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 205),
  [4111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 135),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 135),
  [4115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 3, .production_id = 86),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 3, .production_id = 86),
  [4119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 1, .production_id = 15),
  [4121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 1, .production_id = 15),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_property_assignment, 3, .production_id = 7),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_property_assignment, 3, .production_id = 7),
  [4129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment, 3, .production_id = 80),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment, 3, .production_id = 80),
  [4133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 3, .production_id = 85),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 3, .production_id = 85),
  [4137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 4, .production_id = 84),
  [4139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 4, .production_id = 84),
  [4141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment, 3, .production_id = 81),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment, 3, .production_id = 81),
  [4145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 2),
  [4147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 2),
  [4149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 174),
  [4151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 174),
  [4153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 4, .production_id = 132),
  [4155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 4, .production_id = 132),
  [4157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 4, .production_id = 132),
  [4159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 4, .production_id = 132),
  [4161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 172),
  [4163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 172),
  [4165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 3),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 3),
  [4169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 206),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 206),
  [4173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 6, .production_id = 207),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 6, .production_id = 207),
  [4177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 4),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 4),
  [4181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 169),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 169),
  [4185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 5),
  [4187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 5),
  [4189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 7, .production_id = 232),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 7, .production_id = 232),
  [4193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 210),
  [4195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 210),
  [4197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 5, .production_id = 42),
  [4199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 5, .production_id = 42),
  [4201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 5, .production_id = 83),
  [4203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 5, .production_id = 83),
  [4205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 209),
  [4207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 209),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 15),
  [4227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 15),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [4323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [4339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [4349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [4353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 1, .production_id = 15),
  [4423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 1, .production_id = 15),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [4433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 7), SHIFT(137),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [4454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 7), SHIFT(137),
  [4457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 15),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 15),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 82),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4661),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [4522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2840),
  [4525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2493),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(265),
  [4533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2238),
  [4536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4508),
  [4539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3560),
  [4542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3561),
  [4545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2635),
  [4548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3937),
  [4551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1909),
  [4554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2171),
  [4557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2339),
  [4560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2048),
  [4563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2318),
  [4566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2333),
  [4569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2483),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [4590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 49),
  [4592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 48), REDUCE(sym_object_pattern, 3, .production_id = 49),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(1580),
  [4634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(1732),
  [4637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [4651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [4656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(1597),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 64),
  [4665] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(2194),
  [4678] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), SHIFT(1730),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [4710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 58),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [4806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [4809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 13),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [4818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 7), SHIFT(136),
  [4821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 7), SHIFT(136),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 22),
  [4826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 22), REDUCE(sym__primary_type, 1, .production_id = 13),
  [4829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 22),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [4833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 64),
  [4870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [4886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [4888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 58),
  [4894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 58), SHIFT(334),
  [4897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 51),
  [4913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 13), REDUCE(sym__parameter_name, 2, .production_id = 51),
  [4916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 51),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 58),
  [4922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 90), REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [4925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 90),
  [4927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 22),
  [4930] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 22), REDUCE(sym__primary_type, 1, .production_id = 13),
  [4934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 90), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 98),
  [4939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 98),
  [4941] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 20), REDUCE(aux_sym_object_repeat1, 2, .production_id = 48), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 49),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [4953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 48), REDUCE(sym_object_pattern, 3, .production_id = 49),
  [4956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 187),
  [4968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 187),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 54),
  [4998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 54),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [5016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [5021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [5026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 140),
  [5028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 140),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [5032] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [5038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [5040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 138),
  [5042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 138),
  [5044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [5046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 91),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [5210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 59), REDUCE(sym_component, 4, .production_id = 116),
  [5217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 59), REDUCE(sym_component, 4, .production_id = 116),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [5228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 16), REDUCE(sym_component, 5, .production_id = 44),
  [5231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 16), REDUCE(sym_component, 5, .production_id = 44),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [5236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 113), REDUCE(sym_component, 5, .production_id = 155),
  [5239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 113), REDUCE(sym_component, 5, .production_id = 155),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [5262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 106), REDUCE(sym_class, 5, .production_id = 154),
  [5265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 106), REDUCE(sym_class, 5, .production_id = 154),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [5280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 59), REDUCE(sym_class, 4, .production_id = 116),
  [5283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 59), REDUCE(sym_class, 4, .production_id = 116),
  [5286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 102), REDUCE(sym_class, 5, .production_id = 152),
  [5289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 102), REDUCE(sym_class, 5, .production_id = 152),
  [5292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 58), SHIFT(464),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [5297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 6), REDUCE(sym_component, 4, .production_id = 18),
  [5318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 6), REDUCE(sym_component, 4, .production_id = 18),
  [5321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 103), REDUCE(sym_class, 5, .production_id = 153),
  [5324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 103), REDUCE(sym_class, 5, .production_id = 153),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 25), REDUCE(sym_class, 3, .production_id = 74),
  [5332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 25), REDUCE(sym_class, 3, .production_id = 74),
  [5335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 115),
  [5338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 115),
  [5341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 25), REDUCE(sym_component, 3, .production_id = 74),
  [5344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 25), REDUCE(sym_component, 3, .production_id = 74),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [5361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 42), REDUCE(sym_component, 6, .production_id = 88),
  [5364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 42), REDUCE(sym_component, 6, .production_id = 88),
  [5367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 144), REDUCE(sym_class, 6, .production_id = 193),
  [5370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 144), REDUCE(sym_class, 6, .production_id = 193),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [5383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [5385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 60), REDUCE(sym_class, 4, .production_id = 117),
  [5388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 60), REDUCE(sym_class, 4, .production_id = 117),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [5393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [5403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [5409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [5413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [5417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [5419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [5421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [5431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 48), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 49),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 48),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [5462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 290),
  [5464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 290),
  [5466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 242),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 242),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 186),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 186),
  [5482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 264),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 264),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [5500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 192),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 192),
  [5504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 241),
  [5506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 241),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 219),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 219),
  [5512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 92),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 92),
  [5516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 148),
  [5518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 148),
  [5520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 111),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 111),
  [5524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [5530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 282),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 282),
  [5534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 281),
  [5536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 281),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [5542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 265),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 265),
  [5546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 137),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 137),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [5594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, .production_id = 25),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 2, .production_id = 25),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [5614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4077),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [5644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_narrow, 1, .production_id = 12),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [5668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym__type_query_member_expression, 3, .production_id = 11),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 83),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [5733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 7),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [5747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 163),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 37),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 200),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [5809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 7),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [5815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 163),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4215),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 83),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [5839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(2706),
  [5842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(2706),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [5853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 200),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [5859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_type_parameter, 1, .production_id = 24),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [5866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(1222),
  [5869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [5879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [5885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [5889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [5891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3029),
  [5894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3795),
  [5897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4671),
  [5900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4670),
  [5903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [5905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 37),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [5909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [5913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [5915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 83),
  [5917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 37),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 163),
  [5921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 37),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 163),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 83),
  [5929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 7),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 200),
  [5933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(4198),
  [5936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 7),
  [5938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 200),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [5966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_narrow, 1, .production_id = 12),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 30),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 7),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [6012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 10),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2), SHIFT_REPEAT(3983),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [6037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [6057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 49),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [6063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [6073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [6077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 247),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [6091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [6099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [6107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [6113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 228),
  [6115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [6121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [6131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 217),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 217),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 122),
  [6141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [6145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 118),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [6149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [6151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 123),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 120),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [6165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 23),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [6177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(323),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [6182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 76),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [6188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 156),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [6192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 247),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 159),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 195),
  [6222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 194),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [6240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 229),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [6246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_narrow, 1),
  [6248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_narrow, 1),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [6258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 24),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 248),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 249),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [6274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 273),
  [6276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 274),
  [6278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 287),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 165),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 75),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4421),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [6302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3152),
  [6305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(256),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [6344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 29),
  [6460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [6486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3240),
  [6489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(263),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [6494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [6496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [6540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [6542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 73),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [6574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 23),
  [6576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [6578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [6592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 218),
  [6594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 218),
  [6596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 3), SHIFT_REPEAT(3795),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [6601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(210),
  [6606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4481),
  [6609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1526),
  [6612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [6638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 217),
  [6640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 217),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 161),
  [6668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 162),
  [6670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_instance_statement, 2),
  [6672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 77),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 196),
  [6680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 197),
  [6682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 198),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [6688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, .production_id = 199),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 164),
  [6704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 162),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [6708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 10), SHIFT(1109),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 161),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [6719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 10), SHIFT(1217),
  [6722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 30), SHIFT(1090),
  [6725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 160),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 158),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [6737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 157),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [6741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [6751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [6753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [6767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 196),
  [6769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 224),
  [6771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 226),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 227),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [6781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 230),
  [6783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 231),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [6787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 197),
  [6789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 101),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [6799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 30), SHIFT(1117),
  [6802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [6804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 30), SHIFT(1210),
  [6807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [6811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 121),
  [6813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 119),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [6819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 77),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 31),
  [6831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 10), SHIFT(1102),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [6838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 231),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(1249),
  [6855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3488),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [6862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 250),
  [6864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 251),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [6868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 252),
  [6870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [6878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 30), SHIFT(1097),
  [6881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 10), SHIFT(1227),
  [6884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 230),
  [6886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 218),
  [6888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 218),
  [6890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 77),
  [6892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 272),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [6898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 271),
  [6900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 252),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 285),
  [6904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 270),
  [6906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [6912] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [6916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [6934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [6940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 53),
  [6942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [6948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 56),
  [6950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2994),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 37),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(3101),
  [6999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [7001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [7003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 258),
  [7005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 258), SHIFT_REPEAT(3685),
  [7008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 258),
  [7010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [7012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 124),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [7024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [7041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 146),
  [7043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 146), SHIFT_REPEAT(360),
  [7046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 145),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [7052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [7058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_heritage, 3),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [7062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_js_import_statement_repeat1, 2), SHIFT_REPEAT(4641),
  [7065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_js_import_statement_repeat1, 2),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [7069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [7087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_heritage, 2),
  [7089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 225),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [7093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_heritage_repeat1, 2),
  [7095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_heritage_repeat1, 2), SHIFT_REPEAT(4457),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [7102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [7104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3661),
  [7107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [7109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3662),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [7124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 49),
  [7126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_type_parameter, 2, .production_id = 77),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1),
  [7136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 239),
  [7138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 239),
  [7140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 238),
  [7142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 238),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [7146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 105),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 104),
  [7150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 96),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [7156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [7162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(138),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 244),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [7171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1190),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [7184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(4119),
  [7187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 101),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [7197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [7203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(117),
  [7206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [7222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [7236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(1037),
  [7239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [7251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [7257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 91),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [7279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1226),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [7314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_identifier, 2),
  [7316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_identifier, 2),
  [7318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 243),
  [7320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 220),
  [7322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 194),
  [7324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 195),
  [7326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 223),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [7332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [7336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 245),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 222),
  [7340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 221),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [7350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 246),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [7364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 141),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [7378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 118),
  [7380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 142),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [7386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 228),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [7390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 143),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [7394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [7444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 189),
  [7446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2334),
  [7449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [7457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 143),
  [7459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 124),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [7471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [7477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2263),
  [7480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [7482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_type_parameters_repeat1, 2), SHIFT_REPEAT(3595),
  [7485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_type_parameters_repeat1, 2),
  [7487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 260), SHIFT_REPEAT(2488),
  [7490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 260),
  [7492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2), SHIFT_REPEAT(3876),
  [7495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [7505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 266),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [7511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 267),
  [7513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 268),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [7519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 269),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [7529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 104),
  [7531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 188),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [7535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 159),
  [7537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 191),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 156),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [7553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 190),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [7571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(128),
  [7574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 283),
  [7610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 284),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [7614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 286),
  [7616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 291),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [7666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [7712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 4, .production_id = 191),
  [7714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_type_parameter, 3, .production_id = 143),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [7730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 52),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [7748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 55),
  [7750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 139),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [7760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 124),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [7788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 77),
  [7790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameter, 1),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [7800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 99),
  [7802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 97),
  [7804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 95),
  [7806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 101),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [7820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [7828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [7958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_function_return_type, 1),
  [7960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [7972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [7978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4477),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [8006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4505),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [8028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [8034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [8056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [8144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [8162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [8194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [8240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [8310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [8348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [8430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [8466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_instance, 2),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [8480] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_elements_external_scanner_create(void);
void tree_sitter_elements_external_scanner_destroy(void *);
bool tree_sitter_elements_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_elements_external_scanner_serialize(void *, char *);
void tree_sitter_elements_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_elements(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_elements_external_scanner_create,
      tree_sitter_elements_external_scanner_destroy,
      tree_sitter_elements_external_scanner_scan,
      tree_sitter_elements_external_scanner_serialize,
      tree_sitter_elements_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
